var COMPILED = false;
var goog = goog || {};
goog.global = this;
goog.DEBUG = true;
goog.LOCALE = "en";
goog.evalWorksForGlobals_ = null;
goog.provide = function(name) {
  if(!COMPILED) {
    if(goog.getObjectByName(name) && !goog.implicitNamespaces_[name]) {
      throw Error('Namespace "' + name + '" already declared.');
    }
    var namespace = name;
    while(namespace = namespace.substring(0, namespace.lastIndexOf("."))) {
      goog.implicitNamespaces_[namespace] = true
    }
  }
  goog.exportPath_(name)
};
goog.setTestOnly = function(opt_message) {
  if(COMPILED && !goog.DEBUG) {
    opt_message = opt_message || "";
    throw Error("Importing test-only code into non-debug environment" + opt_message ? ": " + opt_message : ".");
  }
};
if(!COMPILED) {
  goog.implicitNamespaces_ = {}
}
goog.exportPath_ = function(name, opt_object, opt_objectToExportTo) {
  var parts = name.split(".");
  var cur = opt_objectToExportTo || goog.global;
  if(!(parts[0] in cur) && cur.execScript) {
    cur.execScript("var " + parts[0])
  }
  for(var part;parts.length && (part = parts.shift());) {
    if(!parts.length && goog.isDef(opt_object)) {
      cur[part] = opt_object
    }else {
      if(cur[part]) {
        cur = cur[part]
      }else {
        cur = cur[part] = {}
      }
    }
  }
};
goog.getObjectByName = function(name, opt_obj) {
  var parts = name.split(".");
  var cur = opt_obj || goog.global;
  for(var part;part = parts.shift();) {
    if(goog.isDefAndNotNull(cur[part])) {
      cur = cur[part]
    }else {
      return null
    }
  }
  return cur
};
goog.globalize = function(obj, opt_global) {
  var global = opt_global || goog.global;
  for(var x in obj) {
    global[x] = obj[x]
  }
};
goog.addDependency = function(relPath, provides, requires) {
  if(!COMPILED) {
    var provide, require;
    var path = relPath.replace(/\\/g, "/");
    var deps = goog.dependencies_;
    for(var i = 0;provide = provides[i];i++) {
      deps.nameToPath[provide] = path;
      if(!(path in deps.pathToNames)) {
        deps.pathToNames[path] = {}
      }
      deps.pathToNames[path][provide] = true
    }
    for(var j = 0;require = requires[j];j++) {
      if(!(path in deps.requires)) {
        deps.requires[path] = {}
      }
      deps.requires[path][require] = true
    }
  }
};
goog.require = function(rule) {
  if(!COMPILED) {
    if(goog.getObjectByName(rule)) {
      return
    }
    var path = goog.getPathFromDeps_(rule);
    if(path) {
      goog.included_[path] = true;
      goog.writeScripts_()
    }else {
      var errorMessage = "goog.require could not find: " + rule;
      if(goog.global.console) {
        goog.global.console["error"](errorMessage)
      }
      throw Error(errorMessage);
    }
  }
};
goog.basePath = "";
goog.global.CLOSURE_BASE_PATH;
goog.global.CLOSURE_NO_DEPS;
goog.global.CLOSURE_IMPORT_SCRIPT;
goog.nullFunction = function() {
};
goog.identityFunction = function(var_args) {
  return arguments[0]
};
goog.abstractMethod = function() {
  throw Error("unimplemented abstract method");
};
goog.addSingletonGetter = function(ctor) {
  ctor.getInstance = function() {
    return ctor.instance_ || (ctor.instance_ = new ctor)
  }
};
if(!COMPILED) {
  goog.included_ = {};
  goog.dependencies_ = {pathToNames:{}, nameToPath:{}, requires:{}, visited:{}, written:{}};
  goog.inHtmlDocument_ = function() {
    var doc = goog.global.document;
    return typeof doc != "undefined" && "write" in doc
  };
  goog.findBasePath_ = function() {
    if(goog.global.CLOSURE_BASE_PATH) {
      goog.basePath = goog.global.CLOSURE_BASE_PATH;
      return
    }else {
      if(!goog.inHtmlDocument_()) {
        return
      }
    }
    var doc = goog.global.document;
    var scripts = doc.getElementsByTagName("script");
    for(var i = scripts.length - 1;i >= 0;--i) {
      var src = scripts[i].src;
      var qmark = src.lastIndexOf("?");
      var l = qmark == -1 ? src.length : qmark;
      if(src.substr(l - 7, 7) == "base.js") {
        goog.basePath = src.substr(0, l - 7);
        return
      }
    }
  };
  goog.importScript_ = function(src) {
    var importScript = goog.global.CLOSURE_IMPORT_SCRIPT || goog.writeScriptTag_;
    if(!goog.dependencies_.written[src] && importScript(src)) {
      goog.dependencies_.written[src] = true
    }
  };
  goog.writeScriptTag_ = function(src) {
    if(goog.inHtmlDocument_()) {
      var doc = goog.global.document;
      doc.write('<script type="text/javascript" src="' + src + '"></' + "script>");
      return true
    }else {
      return false
    }
  };
  goog.writeScripts_ = function() {
    var scripts = [];
    var seenScript = {};
    var deps = goog.dependencies_;
    function visitNode(path) {
      if(path in deps.written) {
        return
      }
      if(path in deps.visited) {
        if(!(path in seenScript)) {
          seenScript[path] = true;
          scripts.push(path)
        }
        return
      }
      deps.visited[path] = true;
      if(path in deps.requires) {
        for(var requireName in deps.requires[path]) {
          if(requireName in deps.nameToPath) {
            visitNode(deps.nameToPath[requireName])
          }else {
            if(!goog.getObjectByName(requireName)) {
              throw Error("Undefined nameToPath for " + requireName);
            }
          }
        }
      }
      if(!(path in seenScript)) {
        seenScript[path] = true;
        scripts.push(path)
      }
    }
    for(var path in goog.included_) {
      if(!deps.written[path]) {
        visitNode(path)
      }
    }
    for(var i = 0;i < scripts.length;i++) {
      if(scripts[i]) {
        goog.importScript_(goog.basePath + scripts[i])
      }else {
        throw Error("Undefined script input");
      }
    }
  };
  goog.getPathFromDeps_ = function(rule) {
    if(rule in goog.dependencies_.nameToPath) {
      return goog.dependencies_.nameToPath[rule]
    }else {
      return null
    }
  };
  goog.findBasePath_();
  if(!goog.global.CLOSURE_NO_DEPS) {
    goog.importScript_(goog.basePath + "deps.js")
  }
}
goog.typeOf = function(value) {
  var s = typeof value;
  if(s == "object") {
    if(value) {
      if(value instanceof Array) {
        return"array"
      }else {
        if(value instanceof Object) {
          return s
        }
      }
      var className = Object.prototype.toString.call(value);
      if(className == "[object Window]") {
        return"object"
      }
      if(className == "[object Array]" || typeof value.length == "number" && typeof value.splice != "undefined" && typeof value.propertyIsEnumerable != "undefined" && !value.propertyIsEnumerable("splice")) {
        return"array"
      }
      if(className == "[object Function]" || typeof value.call != "undefined" && typeof value.propertyIsEnumerable != "undefined" && !value.propertyIsEnumerable("call")) {
        return"function"
      }
    }else {
      return"null"
    }
  }else {
    if(s == "function" && typeof value.call == "undefined") {
      return"object"
    }
  }
  return s
};
goog.propertyIsEnumerableCustom_ = function(object, propName) {
  if(propName in object) {
    for(var key in object) {
      if(key == propName && Object.prototype.hasOwnProperty.call(object, propName)) {
        return true
      }
    }
  }
  return false
};
goog.propertyIsEnumerable_ = function(object, propName) {
  if(object instanceof Object) {
    return Object.prototype.propertyIsEnumerable.call(object, propName)
  }else {
    return goog.propertyIsEnumerableCustom_(object, propName)
  }
};
goog.isDef = function(val) {
  return val !== undefined
};
goog.isNull = function(val) {
  return val === null
};
goog.isDefAndNotNull = function(val) {
  return val != null
};
goog.isArray = function(val) {
  return goog.typeOf(val) == "array"
};
goog.isArrayLike = function(val) {
  var type = goog.typeOf(val);
  return type == "array" || type == "object" && typeof val.length == "number"
};
goog.isDateLike = function(val) {
  return goog.isObject(val) && typeof val.getFullYear == "function"
};
goog.isString = function(val) {
  return typeof val == "string"
};
goog.isBoolean = function(val) {
  return typeof val == "boolean"
};
goog.isNumber = function(val) {
  return typeof val == "number"
};
goog.isFunction = function(val) {
  return goog.typeOf(val) == "function"
};
goog.isObject = function(val) {
  var type = goog.typeOf(val);
  return type == "object" || type == "array" || type == "function"
};
goog.getUid = function(obj) {
  return obj[goog.UID_PROPERTY_] || (obj[goog.UID_PROPERTY_] = ++goog.uidCounter_)
};
goog.removeUid = function(obj) {
  if("removeAttribute" in obj) {
    obj.removeAttribute(goog.UID_PROPERTY_)
  }
  try {
    delete obj[goog.UID_PROPERTY_]
  }catch(ex) {
  }
};
goog.UID_PROPERTY_ = "closure_uid_" + Math.floor(Math.random() * 2147483648).toString(36);
goog.uidCounter_ = 0;
goog.getHashCode = goog.getUid;
goog.removeHashCode = goog.removeUid;
goog.cloneObject = function(obj) {
  var type = goog.typeOf(obj);
  if(type == "object" || type == "array") {
    if(obj.clone) {
      return obj.clone()
    }
    var clone = type == "array" ? [] : {};
    for(var key in obj) {
      clone[key] = goog.cloneObject(obj[key])
    }
    return clone
  }
  return obj
};
Object.prototype.clone;
goog.bindNative_ = function(fn, selfObj, var_args) {
  return fn.call.apply(fn.bind, arguments)
};
goog.bindJs_ = function(fn, selfObj, var_args) {
  var context = selfObj || goog.global;
  if(arguments.length > 2) {
    var boundArgs = Array.prototype.slice.call(arguments, 2);
    return function() {
      var newArgs = Array.prototype.slice.call(arguments);
      Array.prototype.unshift.apply(newArgs, boundArgs);
      return fn.apply(context, newArgs)
    }
  }else {
    return function() {
      return fn.apply(context, arguments)
    }
  }
};
goog.bind = function(fn, selfObj, var_args) {
  if(Function.prototype.bind && Function.prototype.bind.toString().indexOf("native code") != -1) {
    goog.bind = goog.bindNative_
  }else {
    goog.bind = goog.bindJs_
  }
  return goog.bind.apply(null, arguments)
};
goog.partial = function(fn, var_args) {
  var args = Array.prototype.slice.call(arguments, 1);
  return function() {
    var newArgs = Array.prototype.slice.call(arguments);
    newArgs.unshift.apply(newArgs, args);
    return fn.apply(this, newArgs)
  }
};
goog.mixin = function(target, source) {
  for(var x in source) {
    target[x] = source[x]
  }
};
goog.now = Date.now || function() {
  return+new Date
};
goog.globalEval = function(script) {
  if(goog.global.execScript) {
    goog.global.execScript(script, "JavaScript")
  }else {
    if(goog.global.eval) {
      if(goog.evalWorksForGlobals_ == null) {
        goog.global.eval("var _et_ = 1;");
        if(typeof goog.global["_et_"] != "undefined") {
          delete goog.global["_et_"];
          goog.evalWorksForGlobals_ = true
        }else {
          goog.evalWorksForGlobals_ = false
        }
      }
      if(goog.evalWorksForGlobals_) {
        goog.global.eval(script)
      }else {
        var doc = goog.global.document;
        var scriptElt = doc.createElement("script");
        scriptElt.type = "text/javascript";
        scriptElt.defer = false;
        scriptElt.appendChild(doc.createTextNode(script));
        doc.body.appendChild(scriptElt);
        doc.body.removeChild(scriptElt)
      }
    }else {
      throw Error("goog.globalEval not available");
    }
  }
};
goog.cssNameMapping_;
goog.cssNameMappingStyle_;
goog.getCssName = function(className, opt_modifier) {
  var getMapping = function(cssName) {
    return goog.cssNameMapping_[cssName] || cssName
  };
  var renameByParts = function(cssName) {
    var parts = cssName.split("-");
    var mapped = [];
    for(var i = 0;i < parts.length;i++) {
      mapped.push(getMapping(parts[i]))
    }
    return mapped.join("-")
  };
  var rename;
  if(goog.cssNameMapping_) {
    rename = goog.cssNameMappingStyle_ == "BY_WHOLE" ? getMapping : renameByParts
  }else {
    rename = function(a) {
      return a
    }
  }
  if(opt_modifier) {
    return className + "-" + rename(opt_modifier)
  }else {
    return rename(className)
  }
};
goog.setCssNameMapping = function(mapping, style) {
  goog.cssNameMapping_ = mapping;
  goog.cssNameMappingStyle_ = style
};
goog.getMsg = function(str, opt_values) {
  var values = opt_values || {};
  for(var key in values) {
    var value = ("" + values[key]).replace(/\$/g, "$$$$");
    str = str.replace(new RegExp("\\{\\$" + key + "\\}", "gi"), value)
  }
  return str
};
goog.exportSymbol = function(publicPath, object, opt_objectToExportTo) {
  goog.exportPath_(publicPath, object, opt_objectToExportTo)
};
goog.exportProperty = function(object, publicName, symbol) {
  object[publicName] = symbol
};
goog.inherits = function(childCtor, parentCtor) {
  function tempCtor() {
  }
  tempCtor.prototype = parentCtor.prototype;
  childCtor.superClass_ = parentCtor.prototype;
  childCtor.prototype = new tempCtor;
  childCtor.prototype.constructor = childCtor
};
goog.base = function(me, opt_methodName, var_args) {
  var caller = arguments.callee.caller;
  if(caller.superClass_) {
    return caller.superClass_.constructor.apply(me, Array.prototype.slice.call(arguments, 1))
  }
  var args = Array.prototype.slice.call(arguments, 2);
  var foundCaller = false;
  for(var ctor = me.constructor;ctor;ctor = ctor.superClass_ && ctor.superClass_.constructor) {
    if(ctor.prototype[opt_methodName] === caller) {
      foundCaller = true
    }else {
      if(foundCaller) {
        return ctor.prototype[opt_methodName].apply(me, args)
      }
    }
  }
  if(me[opt_methodName] === caller) {
    return me.constructor.prototype[opt_methodName].apply(me, args)
  }else {
    throw Error("goog.base called from a method of one name " + "to a method of a different name");
  }
};
goog.scope = function(fn) {
  fn.call(goog.global)
};
goog.provide("goog.string");
goog.provide("goog.string.Unicode");
goog.string.Unicode = {NBSP:"\u00a0"};
goog.string.startsWith = function(str, prefix) {
  return str.lastIndexOf(prefix, 0) == 0
};
goog.string.endsWith = function(str, suffix) {
  var l = str.length - suffix.length;
  return l >= 0 && str.indexOf(suffix, l) == l
};
goog.string.caseInsensitiveStartsWith = function(str, prefix) {
  return goog.string.caseInsensitiveCompare(prefix, str.substr(0, prefix.length)) == 0
};
goog.string.caseInsensitiveEndsWith = function(str, suffix) {
  return goog.string.caseInsensitiveCompare(suffix, str.substr(str.length - suffix.length, suffix.length)) == 0
};
goog.string.subs = function(str, var_args) {
  for(var i = 1;i < arguments.length;i++) {
    var replacement = String(arguments[i]).replace(/\$/g, "$$$$");
    str = str.replace(/\%s/, replacement)
  }
  return str
};
goog.string.collapseWhitespace = function(str) {
  return str.replace(/[\s\xa0]+/g, " ").replace(/^\s+|\s+$/g, "")
};
goog.string.isEmpty = function(str) {
  return/^[\s\xa0]*$/.test(str)
};
goog.string.isEmptySafe = function(str) {
  return goog.string.isEmpty(goog.string.makeSafe(str))
};
goog.string.isBreakingWhitespace = function(str) {
  return!/[^\t\n\r ]/.test(str)
};
goog.string.isAlpha = function(str) {
  return!/[^a-zA-Z]/.test(str)
};
goog.string.isNumeric = function(str) {
  return!/[^0-9]/.test(str)
};
goog.string.isAlphaNumeric = function(str) {
  return!/[^a-zA-Z0-9]/.test(str)
};
goog.string.isSpace = function(ch) {
  return ch == " "
};
goog.string.isUnicodeChar = function(ch) {
  return ch.length == 1 && ch >= " " && ch <= "~" || ch >= "\u0080" && ch <= "\ufffd"
};
goog.string.stripNewlines = function(str) {
  return str.replace(/(\r\n|\r|\n)+/g, " ")
};
goog.string.canonicalizeNewlines = function(str) {
  return str.replace(/(\r\n|\r|\n)/g, "\n")
};
goog.string.normalizeWhitespace = function(str) {
  return str.replace(/\xa0|\s/g, " ")
};
goog.string.normalizeSpaces = function(str) {
  return str.replace(/\xa0|[ \t]+/g, " ")
};
goog.string.trim = function(str) {
  return str.replace(/^[\s\xa0]+|[\s\xa0]+$/g, "")
};
goog.string.trimLeft = function(str) {
  return str.replace(/^[\s\xa0]+/, "")
};
goog.string.trimRight = function(str) {
  return str.replace(/[\s\xa0]+$/, "")
};
goog.string.caseInsensitiveCompare = function(str1, str2) {
  var test1 = String(str1).toLowerCase();
  var test2 = String(str2).toLowerCase();
  if(test1 < test2) {
    return-1
  }else {
    if(test1 == test2) {
      return 0
    }else {
      return 1
    }
  }
};
goog.string.numerateCompareRegExp_ = /(\.\d+)|(\d+)|(\D+)/g;
goog.string.numerateCompare = function(str1, str2) {
  if(str1 == str2) {
    return 0
  }
  if(!str1) {
    return-1
  }
  if(!str2) {
    return 1
  }
  var tokens1 = str1.toLowerCase().match(goog.string.numerateCompareRegExp_);
  var tokens2 = str2.toLowerCase().match(goog.string.numerateCompareRegExp_);
  var count = Math.min(tokens1.length, tokens2.length);
  for(var i = 0;i < count;i++) {
    var a = tokens1[i];
    var b = tokens2[i];
    if(a != b) {
      var num1 = parseInt(a, 10);
      if(!isNaN(num1)) {
        var num2 = parseInt(b, 10);
        if(!isNaN(num2) && num1 - num2) {
          return num1 - num2
        }
      }
      return a < b ? -1 : 1
    }
  }
  if(tokens1.length != tokens2.length) {
    return tokens1.length - tokens2.length
  }
  return str1 < str2 ? -1 : 1
};
goog.string.encodeUriRegExp_ = /^[a-zA-Z0-9\-_.!~*'()]*$/;
goog.string.urlEncode = function(str) {
  str = String(str);
  if(!goog.string.encodeUriRegExp_.test(str)) {
    return encodeURIComponent(str)
  }
  return str
};
goog.string.urlDecode = function(str) {
  return decodeURIComponent(str.replace(/\+/g, " "))
};
goog.string.newLineToBr = function(str, opt_xml) {
  return str.replace(/(\r\n|\r|\n)/g, opt_xml ? "<br />" : "<br>")
};
goog.string.htmlEscape = function(str, opt_isLikelyToContainHtmlChars) {
  if(opt_isLikelyToContainHtmlChars) {
    return str.replace(goog.string.amperRe_, "&amp;").replace(goog.string.ltRe_, "&lt;").replace(goog.string.gtRe_, "&gt;").replace(goog.string.quotRe_, "&quot;")
  }else {
    if(!goog.string.allRe_.test(str)) {
      return str
    }
    if(str.indexOf("&") != -1) {
      str = str.replace(goog.string.amperRe_, "&amp;")
    }
    if(str.indexOf("<") != -1) {
      str = str.replace(goog.string.ltRe_, "&lt;")
    }
    if(str.indexOf(">") != -1) {
      str = str.replace(goog.string.gtRe_, "&gt;")
    }
    if(str.indexOf('"') != -1) {
      str = str.replace(goog.string.quotRe_, "&quot;")
    }
    return str
  }
};
goog.string.amperRe_ = /&/g;
goog.string.ltRe_ = /</g;
goog.string.gtRe_ = />/g;
goog.string.quotRe_ = /\"/g;
goog.string.allRe_ = /[&<>\"]/;
goog.string.unescapeEntities = function(str) {
  if(goog.string.contains(str, "&")) {
    if("document" in goog.global && !goog.string.contains(str, "<")) {
      return goog.string.unescapeEntitiesUsingDom_(str)
    }else {
      return goog.string.unescapePureXmlEntities_(str)
    }
  }
  return str
};
goog.string.unescapeEntitiesUsingDom_ = function(str) {
  var el = goog.global["document"]["createElement"]("div");
  el["innerHTML"] = "<pre>x" + str + "</pre>";
  if(el["firstChild"][goog.string.NORMALIZE_FN_]) {
    el["firstChild"][goog.string.NORMALIZE_FN_]()
  }
  str = el["firstChild"]["firstChild"]["nodeValue"].slice(1);
  el["innerHTML"] = "";
  return goog.string.canonicalizeNewlines(str)
};
goog.string.unescapePureXmlEntities_ = function(str) {
  return str.replace(/&([^;]+);/g, function(s, entity) {
    switch(entity) {
      case "amp":
        return"&";
      case "lt":
        return"<";
      case "gt":
        return">";
      case "quot":
        return'"';
      default:
        if(entity.charAt(0) == "#") {
          var n = Number("0" + entity.substr(1));
          if(!isNaN(n)) {
            return String.fromCharCode(n)
          }
        }
        return s
    }
  })
};
goog.string.NORMALIZE_FN_ = "normalize";
goog.string.whitespaceEscape = function(str, opt_xml) {
  return goog.string.newLineToBr(str.replace(/  /g, " &#160;"), opt_xml)
};
goog.string.stripQuotes = function(str, quoteChars) {
  var length = quoteChars.length;
  for(var i = 0;i < length;i++) {
    var quoteChar = length == 1 ? quoteChars : quoteChars.charAt(i);
    if(str.charAt(0) == quoteChar && str.charAt(str.length - 1) == quoteChar) {
      return str.substring(1, str.length - 1)
    }
  }
  return str
};
goog.string.truncate = function(str, chars, opt_protectEscapedCharacters) {
  if(opt_protectEscapedCharacters) {
    str = goog.string.unescapeEntities(str)
  }
  if(str.length > chars) {
    str = str.substring(0, chars - 3) + "..."
  }
  if(opt_protectEscapedCharacters) {
    str = goog.string.htmlEscape(str)
  }
  return str
};
goog.string.truncateMiddle = function(str, chars, opt_protectEscapedCharacters, opt_trailingChars) {
  if(opt_protectEscapedCharacters) {
    str = goog.string.unescapeEntities(str)
  }
  if(opt_trailingChars) {
    if(opt_trailingChars > chars) {
      opt_trailingChars = chars
    }
    var endPoint = str.length - opt_trailingChars;
    var startPoint = chars - opt_trailingChars;
    str = str.substring(0, startPoint) + "..." + str.substring(endPoint)
  }else {
    if(str.length > chars) {
      var half = Math.floor(chars / 2);
      var endPos = str.length - half;
      half += chars % 2;
      str = str.substring(0, half) + "..." + str.substring(endPos)
    }
  }
  if(opt_protectEscapedCharacters) {
    str = goog.string.htmlEscape(str)
  }
  return str
};
goog.string.specialEscapeChars_ = {"\x00":"\\0", "\u0008":"\\b", "\u000c":"\\f", "\n":"\\n", "\r":"\\r", "\t":"\\t", "\u000b":"\\x0B", '"':'\\"', "\\":"\\\\"};
goog.string.jsEscapeCache_ = {"'":"\\'"};
goog.string.quote = function(s) {
  s = String(s);
  if(s.quote) {
    return s.quote()
  }else {
    var sb = ['"'];
    for(var i = 0;i < s.length;i++) {
      var ch = s.charAt(i);
      var cc = ch.charCodeAt(0);
      sb[i + 1] = goog.string.specialEscapeChars_[ch] || (cc > 31 && cc < 127 ? ch : goog.string.escapeChar(ch))
    }
    sb.push('"');
    return sb.join("")
  }
};
goog.string.escapeString = function(str) {
  var sb = [];
  for(var i = 0;i < str.length;i++) {
    sb[i] = goog.string.escapeChar(str.charAt(i))
  }
  return sb.join("")
};
goog.string.escapeChar = function(c) {
  if(c in goog.string.jsEscapeCache_) {
    return goog.string.jsEscapeCache_[c]
  }
  if(c in goog.string.specialEscapeChars_) {
    return goog.string.jsEscapeCache_[c] = goog.string.specialEscapeChars_[c]
  }
  var rv = c;
  var cc = c.charCodeAt(0);
  if(cc > 31 && cc < 127) {
    rv = c
  }else {
    if(cc < 256) {
      rv = "\\x";
      if(cc < 16 || cc > 256) {
        rv += "0"
      }
    }else {
      rv = "\\u";
      if(cc < 4096) {
        rv += "0"
      }
    }
    rv += cc.toString(16).toUpperCase()
  }
  return goog.string.jsEscapeCache_[c] = rv
};
goog.string.toMap = function(s) {
  var rv = {};
  for(var i = 0;i < s.length;i++) {
    rv[s.charAt(i)] = true
  }
  return rv
};
goog.string.contains = function(s, ss) {
  return s.indexOf(ss) != -1
};
goog.string.removeAt = function(s, index, stringLength) {
  var resultStr = s;
  if(index >= 0 && index < s.length && stringLength > 0) {
    resultStr = s.substr(0, index) + s.substr(index + stringLength, s.length - index - stringLength)
  }
  return resultStr
};
goog.string.remove = function(s, ss) {
  var re = new RegExp(goog.string.regExpEscape(ss), "");
  return s.replace(re, "")
};
goog.string.removeAll = function(s, ss) {
  var re = new RegExp(goog.string.regExpEscape(ss), "g");
  return s.replace(re, "")
};
goog.string.regExpEscape = function(s) {
  return String(s).replace(/([-()\[\]{}+?*.$\^|,:#<!\\])/g, "\\$1").replace(/\x08/g, "\\x08")
};
goog.string.repeat = function(string, length) {
  return(new Array(length + 1)).join(string)
};
goog.string.padNumber = function(num, length, opt_precision) {
  var s = goog.isDef(opt_precision) ? num.toFixed(opt_precision) : String(num);
  var index = s.indexOf(".");
  if(index == -1) {
    index = s.length
  }
  return goog.string.repeat("0", Math.max(0, length - index)) + s
};
goog.string.makeSafe = function(obj) {
  return obj == null ? "" : String(obj)
};
goog.string.buildString = function(var_args) {
  return Array.prototype.join.call(arguments, "")
};
goog.string.getRandomString = function() {
  var x = 2147483648;
  return Math.floor(Math.random() * x).toString(36) + Math.abs(Math.floor(Math.random() * x) ^ goog.now()).toString(36)
};
goog.string.compareVersions = function(version1, version2) {
  var order = 0;
  var v1Subs = goog.string.trim(String(version1)).split(".");
  var v2Subs = goog.string.trim(String(version2)).split(".");
  var subCount = Math.max(v1Subs.length, v2Subs.length);
  for(var subIdx = 0;order == 0 && subIdx < subCount;subIdx++) {
    var v1Sub = v1Subs[subIdx] || "";
    var v2Sub = v2Subs[subIdx] || "";
    var v1CompParser = new RegExp("(\\d*)(\\D*)", "g");
    var v2CompParser = new RegExp("(\\d*)(\\D*)", "g");
    do {
      var v1Comp = v1CompParser.exec(v1Sub) || ["", "", ""];
      var v2Comp = v2CompParser.exec(v2Sub) || ["", "", ""];
      if(v1Comp[0].length == 0 && v2Comp[0].length == 0) {
        break
      }
      var v1CompNum = v1Comp[1].length == 0 ? 0 : parseInt(v1Comp[1], 10);
      var v2CompNum = v2Comp[1].length == 0 ? 0 : parseInt(v2Comp[1], 10);
      order = goog.string.compareElements_(v1CompNum, v2CompNum) || goog.string.compareElements_(v1Comp[2].length == 0, v2Comp[2].length == 0) || goog.string.compareElements_(v1Comp[2], v2Comp[2])
    }while(order == 0)
  }
  return order
};
goog.string.compareElements_ = function(left, right) {
  if(left < right) {
    return-1
  }else {
    if(left > right) {
      return 1
    }
  }
  return 0
};
goog.string.HASHCODE_MAX_ = 4294967296;
goog.string.hashCode = function(str) {
  var result = 0;
  for(var i = 0;i < str.length;++i) {
    result = 31 * result + str.charCodeAt(i);
    result %= goog.string.HASHCODE_MAX_
  }
  return result
};
goog.string.uniqueStringCounter_ = Math.random() * 2147483648 | 0;
goog.string.createUniqueString = function() {
  return"goog_" + goog.string.uniqueStringCounter_++
};
goog.string.toNumber = function(str) {
  var num = Number(str);
  if(num == 0 && goog.string.isEmpty(str)) {
    return NaN
  }
  return num
};
goog.string.toCamelCaseCache_ = {};
goog.string.toCamelCase = function(str) {
  return goog.string.toCamelCaseCache_[str] || (goog.string.toCamelCaseCache_[str] = String(str).replace(/\-([a-z])/g, function(all, match) {
    return match.toUpperCase()
  }))
};
goog.string.toSelectorCaseCache_ = {};
goog.string.toSelectorCase = function(str) {
  return goog.string.toSelectorCaseCache_[str] || (goog.string.toSelectorCaseCache_[str] = String(str).replace(/([A-Z])/g, "-$1").toLowerCase())
};
goog.provide("goog.debug.Error");
goog.debug.Error = function(opt_msg) {
  this.stack = (new Error).stack || "";
  if(opt_msg) {
    this.message = String(opt_msg)
  }
};
goog.inherits(goog.debug.Error, Error);
goog.debug.Error.prototype.name = "CustomError";
goog.provide("goog.asserts");
goog.provide("goog.asserts.AssertionError");
goog.require("goog.debug.Error");
goog.require("goog.string");
goog.asserts.ENABLE_ASSERTS = goog.DEBUG;
goog.asserts.AssertionError = function(messagePattern, messageArgs) {
  messageArgs.unshift(messagePattern);
  goog.debug.Error.call(this, goog.string.subs.apply(null, messageArgs));
  messageArgs.shift();
  this.messagePattern = messagePattern
};
goog.inherits(goog.asserts.AssertionError, goog.debug.Error);
goog.asserts.AssertionError.prototype.name = "AssertionError";
goog.asserts.doAssertFailure_ = function(defaultMessage, defaultArgs, givenMessage, givenArgs) {
  var message = "Assertion failed";
  if(givenMessage) {
    message += ": " + givenMessage;
    var args = givenArgs
  }else {
    if(defaultMessage) {
      message += ": " + defaultMessage;
      args = defaultArgs
    }
  }
  throw new goog.asserts.AssertionError("" + message, args || []);
};
goog.asserts.assert = function(condition, opt_message, var_args) {
  if(goog.asserts.ENABLE_ASSERTS && !condition) {
    goog.asserts.doAssertFailure_("", null, opt_message, Array.prototype.slice.call(arguments, 2))
  }
  return condition
};
goog.asserts.fail = function(opt_message, var_args) {
  if(goog.asserts.ENABLE_ASSERTS) {
    throw new goog.asserts.AssertionError("Failure" + (opt_message ? ": " + opt_message : ""), Array.prototype.slice.call(arguments, 1));
  }
};
goog.asserts.assertNumber = function(value, opt_message, var_args) {
  if(goog.asserts.ENABLE_ASSERTS && !goog.isNumber(value)) {
    goog.asserts.doAssertFailure_("Expected number but got %s: %s.", [goog.typeOf(value), value], opt_message, Array.prototype.slice.call(arguments, 2))
  }
  return value
};
goog.asserts.assertString = function(value, opt_message, var_args) {
  if(goog.asserts.ENABLE_ASSERTS && !goog.isString(value)) {
    goog.asserts.doAssertFailure_("Expected string but got %s: %s.", [goog.typeOf(value), value], opt_message, Array.prototype.slice.call(arguments, 2))
  }
  return value
};
goog.asserts.assertFunction = function(value, opt_message, var_args) {
  if(goog.asserts.ENABLE_ASSERTS && !goog.isFunction(value)) {
    goog.asserts.doAssertFailure_("Expected function but got %s: %s.", [goog.typeOf(value), value], opt_message, Array.prototype.slice.call(arguments, 2))
  }
  return value
};
goog.asserts.assertObject = function(value, opt_message, var_args) {
  if(goog.asserts.ENABLE_ASSERTS && !goog.isObject(value)) {
    goog.asserts.doAssertFailure_("Expected object but got %s: %s.", [goog.typeOf(value), value], opt_message, Array.prototype.slice.call(arguments, 2))
  }
  return value
};
goog.asserts.assertArray = function(value, opt_message, var_args) {
  if(goog.asserts.ENABLE_ASSERTS && !goog.isArray(value)) {
    goog.asserts.doAssertFailure_("Expected array but got %s: %s.", [goog.typeOf(value), value], opt_message, Array.prototype.slice.call(arguments, 2))
  }
  return value
};
goog.asserts.assertBoolean = function(value, opt_message, var_args) {
  if(goog.asserts.ENABLE_ASSERTS && !goog.isBoolean(value)) {
    goog.asserts.doAssertFailure_("Expected boolean but got %s: %s.", [goog.typeOf(value), value], opt_message, Array.prototype.slice.call(arguments, 2))
  }
  return value
};
goog.asserts.assertInstanceof = function(value, type, opt_message, var_args) {
  if(goog.asserts.ENABLE_ASSERTS && !(value instanceof type)) {
    goog.asserts.doAssertFailure_("instanceof check failed.", null, opt_message, Array.prototype.slice.call(arguments, 3))
  }
};
goog.provide("goog.array");
goog.provide("goog.array.ArrayLike");
goog.require("goog.asserts");
goog.NATIVE_ARRAY_PROTOTYPES = true;
goog.array.ArrayLike;
goog.array.peek = function(array) {
  return array[array.length - 1]
};
goog.array.ARRAY_PROTOTYPE_ = Array.prototype;
goog.array.indexOf = goog.NATIVE_ARRAY_PROTOTYPES && goog.array.ARRAY_PROTOTYPE_.indexOf ? function(arr, obj, opt_fromIndex) {
  goog.asserts.assert(arr.length != null);
  return goog.array.ARRAY_PROTOTYPE_.indexOf.call(arr, obj, opt_fromIndex)
} : function(arr, obj, opt_fromIndex) {
  var fromIndex = opt_fromIndex == null ? 0 : opt_fromIndex < 0 ? Math.max(0, arr.length + opt_fromIndex) : opt_fromIndex;
  if(goog.isString(arr)) {
    if(!goog.isString(obj) || obj.length != 1) {
      return-1
    }
    return arr.indexOf(obj, fromIndex)
  }
  for(var i = fromIndex;i < arr.length;i++) {
    if(i in arr && arr[i] === obj) {
      return i
    }
  }
  return-1
};
goog.array.lastIndexOf = goog.NATIVE_ARRAY_PROTOTYPES && goog.array.ARRAY_PROTOTYPE_.lastIndexOf ? function(arr, obj, opt_fromIndex) {
  goog.asserts.assert(arr.length != null);
  var fromIndex = opt_fromIndex == null ? arr.length - 1 : opt_fromIndex;
  return goog.array.ARRAY_PROTOTYPE_.lastIndexOf.call(arr, obj, fromIndex)
} : function(arr, obj, opt_fromIndex) {
  var fromIndex = opt_fromIndex == null ? arr.length - 1 : opt_fromIndex;
  if(fromIndex < 0) {
    fromIndex = Math.max(0, arr.length + fromIndex)
  }
  if(goog.isString(arr)) {
    if(!goog.isString(obj) || obj.length != 1) {
      return-1
    }
    return arr.lastIndexOf(obj, fromIndex)
  }
  for(var i = fromIndex;i >= 0;i--) {
    if(i in arr && arr[i] === obj) {
      return i
    }
  }
  return-1
};
goog.array.forEach = goog.NATIVE_ARRAY_PROTOTYPES && goog.array.ARRAY_PROTOTYPE_.forEach ? function(arr, f, opt_obj) {
  goog.asserts.assert(arr.length != null);
  goog.array.ARRAY_PROTOTYPE_.forEach.call(arr, f, opt_obj)
} : function(arr, f, opt_obj) {
  var l = arr.length;
  var arr2 = goog.isString(arr) ? arr.split("") : arr;
  for(var i = 0;i < l;i++) {
    if(i in arr2) {
      f.call(opt_obj, arr2[i], i, arr)
    }
  }
};
goog.array.forEachRight = function(arr, f, opt_obj) {
  var l = arr.length;
  var arr2 = goog.isString(arr) ? arr.split("") : arr;
  for(var i = l - 1;i >= 0;--i) {
    if(i in arr2) {
      f.call(opt_obj, arr2[i], i, arr)
    }
  }
};
goog.array.filter = goog.NATIVE_ARRAY_PROTOTYPES && goog.array.ARRAY_PROTOTYPE_.filter ? function(arr, f, opt_obj) {
  goog.asserts.assert(arr.length != null);
  return goog.array.ARRAY_PROTOTYPE_.filter.call(arr, f, opt_obj)
} : function(arr, f, opt_obj) {
  var l = arr.length;
  var res = [];
  var resLength = 0;
  var arr2 = goog.isString(arr) ? arr.split("") : arr;
  for(var i = 0;i < l;i++) {
    if(i in arr2) {
      var val = arr2[i];
      if(f.call(opt_obj, val, i, arr)) {
        res[resLength++] = val
      }
    }
  }
  return res
};
goog.array.map = goog.NATIVE_ARRAY_PROTOTYPES && goog.array.ARRAY_PROTOTYPE_.map ? function(arr, f, opt_obj) {
  goog.asserts.assert(arr.length != null);
  return goog.array.ARRAY_PROTOTYPE_.map.call(arr, f, opt_obj)
} : function(arr, f, opt_obj) {
  var l = arr.length;
  var res = new Array(l);
  var arr2 = goog.isString(arr) ? arr.split("") : arr;
  for(var i = 0;i < l;i++) {
    if(i in arr2) {
      res[i] = f.call(opt_obj, arr2[i], i, arr)
    }
  }
  return res
};
goog.array.reduce = function(arr, f, val, opt_obj) {
  if(arr.reduce) {
    if(opt_obj) {
      return arr.reduce(goog.bind(f, opt_obj), val)
    }else {
      return arr.reduce(f, val)
    }
  }
  var rval = val;
  goog.array.forEach(arr, function(val, index) {
    rval = f.call(opt_obj, rval, val, index, arr)
  });
  return rval
};
goog.array.reduceRight = function(arr, f, val, opt_obj) {
  if(arr.reduceRight) {
    if(opt_obj) {
      return arr.reduceRight(goog.bind(f, opt_obj), val)
    }else {
      return arr.reduceRight(f, val)
    }
  }
  var rval = val;
  goog.array.forEachRight(arr, function(val, index) {
    rval = f.call(opt_obj, rval, val, index, arr)
  });
  return rval
};
goog.array.some = goog.NATIVE_ARRAY_PROTOTYPES && goog.array.ARRAY_PROTOTYPE_.some ? function(arr, f, opt_obj) {
  goog.asserts.assert(arr.length != null);
  return goog.array.ARRAY_PROTOTYPE_.some.call(arr, f, opt_obj)
} : function(arr, f, opt_obj) {
  var l = arr.length;
  var arr2 = goog.isString(arr) ? arr.split("") : arr;
  for(var i = 0;i < l;i++) {
    if(i in arr2 && f.call(opt_obj, arr2[i], i, arr)) {
      return true
    }
  }
  return false
};
goog.array.every = goog.NATIVE_ARRAY_PROTOTYPES && goog.array.ARRAY_PROTOTYPE_.every ? function(arr, f, opt_obj) {
  goog.asserts.assert(arr.length != null);
  return goog.array.ARRAY_PROTOTYPE_.every.call(arr, f, opt_obj)
} : function(arr, f, opt_obj) {
  var l = arr.length;
  var arr2 = goog.isString(arr) ? arr.split("") : arr;
  for(var i = 0;i < l;i++) {
    if(i in arr2 && !f.call(opt_obj, arr2[i], i, arr)) {
      return false
    }
  }
  return true
};
goog.array.find = function(arr, f, opt_obj) {
  var i = goog.array.findIndex(arr, f, opt_obj);
  return i < 0 ? null : goog.isString(arr) ? arr.charAt(i) : arr[i]
};
goog.array.findIndex = function(arr, f, opt_obj) {
  var l = arr.length;
  var arr2 = goog.isString(arr) ? arr.split("") : arr;
  for(var i = 0;i < l;i++) {
    if(i in arr2 && f.call(opt_obj, arr2[i], i, arr)) {
      return i
    }
  }
  return-1
};
goog.array.findRight = function(arr, f, opt_obj) {
  var i = goog.array.findIndexRight(arr, f, opt_obj);
  return i < 0 ? null : goog.isString(arr) ? arr.charAt(i) : arr[i]
};
goog.array.findIndexRight = function(arr, f, opt_obj) {
  var l = arr.length;
  var arr2 = goog.isString(arr) ? arr.split("") : arr;
  for(var i = l - 1;i >= 0;i--) {
    if(i in arr2 && f.call(opt_obj, arr2[i], i, arr)) {
      return i
    }
  }
  return-1
};
goog.array.contains = function(arr, obj) {
  return goog.array.indexOf(arr, obj) >= 0
};
goog.array.isEmpty = function(arr) {
  return arr.length == 0
};
goog.array.clear = function(arr) {
  if(!goog.isArray(arr)) {
    for(var i = arr.length - 1;i >= 0;i--) {
      delete arr[i]
    }
  }
  arr.length = 0
};
goog.array.insert = function(arr, obj) {
  if(!goog.array.contains(arr, obj)) {
    arr.push(obj)
  }
};
goog.array.insertAt = function(arr, obj, opt_i) {
  goog.array.splice(arr, opt_i, 0, obj)
};
goog.array.insertArrayAt = function(arr, elementsToAdd, opt_i) {
  goog.partial(goog.array.splice, arr, opt_i, 0).apply(null, elementsToAdd)
};
goog.array.insertBefore = function(arr, obj, opt_obj2) {
  var i;
  if(arguments.length == 2 || (i = goog.array.indexOf(arr, opt_obj2)) < 0) {
    arr.push(obj)
  }else {
    goog.array.insertAt(arr, obj, i)
  }
};
goog.array.remove = function(arr, obj) {
  var i = goog.array.indexOf(arr, obj);
  var rv;
  if(rv = i >= 0) {
    goog.array.removeAt(arr, i)
  }
  return rv
};
goog.array.removeAt = function(arr, i) {
  goog.asserts.assert(arr.length != null);
  return goog.array.ARRAY_PROTOTYPE_.splice.call(arr, i, 1).length == 1
};
goog.array.removeIf = function(arr, f, opt_obj) {
  var i = goog.array.findIndex(arr, f, opt_obj);
  if(i >= 0) {
    goog.array.removeAt(arr, i);
    return true
  }
  return false
};
goog.array.concat = function(var_args) {
  return goog.array.ARRAY_PROTOTYPE_.concat.apply(goog.array.ARRAY_PROTOTYPE_, arguments)
};
goog.array.clone = function(arr) {
  if(goog.isArray(arr)) {
    return goog.array.concat(arr)
  }else {
    var rv = [];
    for(var i = 0, len = arr.length;i < len;i++) {
      rv[i] = arr[i]
    }
    return rv
  }
};
goog.array.toArray = function(object) {
  if(goog.isArray(object)) {
    return goog.array.concat(object)
  }
  return goog.array.clone(object)
};
goog.array.extend = function(arr1, var_args) {
  for(var i = 1;i < arguments.length;i++) {
    var arr2 = arguments[i];
    var isArrayLike;
    if(goog.isArray(arr2) || (isArrayLike = goog.isArrayLike(arr2)) && arr2.hasOwnProperty("callee")) {
      arr1.push.apply(arr1, arr2)
    }else {
      if(isArrayLike) {
        var len1 = arr1.length;
        var len2 = arr2.length;
        for(var j = 0;j < len2;j++) {
          arr1[len1 + j] = arr2[j]
        }
      }else {
        arr1.push(arr2)
      }
    }
  }
};
goog.array.splice = function(arr, index, howMany, var_args) {
  goog.asserts.assert(arr.length != null);
  return goog.array.ARRAY_PROTOTYPE_.splice.apply(arr, goog.array.slice(arguments, 1))
};
goog.array.slice = function(arr, start, opt_end) {
  goog.asserts.assert(arr.length != null);
  if(arguments.length <= 2) {
    return goog.array.ARRAY_PROTOTYPE_.slice.call(arr, start)
  }else {
    return goog.array.ARRAY_PROTOTYPE_.slice.call(arr, start, opt_end)
  }
};
goog.array.removeDuplicates = function(arr, opt_rv) {
  var returnArray = opt_rv || arr;
  var seen = {}, cursorInsert = 0, cursorRead = 0;
  while(cursorRead < arr.length) {
    var current = arr[cursorRead++];
    var key = goog.isObject(current) ? "o" + goog.getUid(current) : (typeof current).charAt(0) + current;
    if(!Object.prototype.hasOwnProperty.call(seen, key)) {
      seen[key] = true;
      returnArray[cursorInsert++] = current
    }
  }
  returnArray.length = cursorInsert
};
goog.array.binarySearch = function(arr, target, opt_compareFn) {
  return goog.array.binarySearch_(arr, opt_compareFn || goog.array.defaultCompare, false, target)
};
goog.array.binarySelect = function(arr, evaluator, opt_obj) {
  return goog.array.binarySearch_(arr, evaluator, true, undefined, opt_obj)
};
goog.array.binarySearch_ = function(arr, compareFn, isEvaluator, opt_target, opt_selfObj) {
  var left = 0;
  var right = arr.length;
  var found;
  while(left < right) {
    var middle = left + right >> 1;
    var compareResult;
    if(isEvaluator) {
      compareResult = compareFn.call(opt_selfObj, arr[middle], middle, arr)
    }else {
      compareResult = compareFn(opt_target, arr[middle])
    }
    if(compareResult > 0) {
      left = middle + 1
    }else {
      right = middle;
      found = !compareResult
    }
  }
  return found ? left : ~left
};
goog.array.sort = function(arr, opt_compareFn) {
  goog.asserts.assert(arr.length != null);
  goog.array.ARRAY_PROTOTYPE_.sort.call(arr, opt_compareFn || goog.array.defaultCompare)
};
goog.array.stableSort = function(arr, opt_compareFn) {
  for(var i = 0;i < arr.length;i++) {
    arr[i] = {index:i, value:arr[i]}
  }
  var valueCompareFn = opt_compareFn || goog.array.defaultCompare;
  function stableCompareFn(obj1, obj2) {
    return valueCompareFn(obj1.value, obj2.value) || obj1.index - obj2.index
  }
  goog.array.sort(arr, stableCompareFn);
  for(var i = 0;i < arr.length;i++) {
    arr[i] = arr[i].value
  }
};
goog.array.sortObjectsByKey = function(arr, key, opt_compareFn) {
  var compare = opt_compareFn || goog.array.defaultCompare;
  goog.array.sort(arr, function(a, b) {
    return compare(a[key], b[key])
  })
};
goog.array.isSorted = function(arr, opt_compareFn, opt_strict) {
  var compare = opt_compareFn || goog.array.defaultCompare;
  for(var i = 1;i < arr.length;i++) {
    var compareResult = compare(arr[i - 1], arr[i]);
    if(compareResult > 0 || compareResult == 0 && opt_strict) {
      return false
    }
  }
  return true
};
goog.array.equals = function(arr1, arr2, opt_equalsFn) {
  if(!goog.isArrayLike(arr1) || !goog.isArrayLike(arr2) || arr1.length != arr2.length) {
    return false
  }
  var l = arr1.length;
  var equalsFn = opt_equalsFn || goog.array.defaultCompareEquality;
  for(var i = 0;i < l;i++) {
    if(!equalsFn(arr1[i], arr2[i])) {
      return false
    }
  }
  return true
};
goog.array.compare = function(arr1, arr2, opt_equalsFn) {
  return goog.array.equals(arr1, arr2, opt_equalsFn)
};
goog.array.defaultCompare = function(a, b) {
  return a > b ? 1 : a < b ? -1 : 0
};
goog.array.defaultCompareEquality = function(a, b) {
  return a === b
};
goog.array.binaryInsert = function(array, value, opt_compareFn) {
  var index = goog.array.binarySearch(array, value, opt_compareFn);
  if(index < 0) {
    goog.array.insertAt(array, value, -(index + 1));
    return true
  }
  return false
};
goog.array.binaryRemove = function(array, value, opt_compareFn) {
  var index = goog.array.binarySearch(array, value, opt_compareFn);
  return index >= 0 ? goog.array.removeAt(array, index) : false
};
goog.array.bucket = function(array, sorter) {
  var buckets = {};
  for(var i = 0;i < array.length;i++) {
    var value = array[i];
    var key = sorter(value, i, array);
    if(goog.isDef(key)) {
      var bucket = buckets[key] || (buckets[key] = []);
      bucket.push(value)
    }
  }
  return buckets
};
goog.array.repeat = function(value, n) {
  var array = [];
  for(var i = 0;i < n;i++) {
    array[i] = value
  }
  return array
};
goog.array.flatten = function(var_args) {
  var result = [];
  for(var i = 0;i < arguments.length;i++) {
    var element = arguments[i];
    if(goog.isArray(element)) {
      result.push.apply(result, goog.array.flatten.apply(null, element))
    }else {
      result.push(element)
    }
  }
  return result
};
goog.array.rotate = function(array, n) {
  goog.asserts.assert(array.length != null);
  if(array.length) {
    n %= array.length;
    if(n > 0) {
      goog.array.ARRAY_PROTOTYPE_.unshift.apply(array, array.splice(-n, n))
    }else {
      if(n < 0) {
        goog.array.ARRAY_PROTOTYPE_.push.apply(array, array.splice(0, -n))
      }
    }
  }
  return array
};
goog.array.zip = function(var_args) {
  if(!arguments.length) {
    return[]
  }
  var result = [];
  for(var i = 0;true;i++) {
    var value = [];
    for(var j = 0;j < arguments.length;j++) {
      var arr = arguments[j];
      if(i >= arr.length) {
        return result
      }
      value.push(arr[i])
    }
    result.push(value)
  }
};
goog.array.shuffle = function(arr, opt_randFn) {
  var randFn = opt_randFn || Math.random;
  for(var i = arr.length - 1;i > 0;i--) {
    var j = Math.floor(randFn() * (i + 1));
    var tmp = arr[i];
    arr[i] = arr[j];
    arr[j] = tmp
  }
};
goog.provide("goog.object");
goog.object.forEach = function(obj, f, opt_obj) {
  for(var key in obj) {
    f.call(opt_obj, obj[key], key, obj)
  }
};
goog.object.filter = function(obj, f, opt_obj) {
  var res = {};
  for(var key in obj) {
    if(f.call(opt_obj, obj[key], key, obj)) {
      res[key] = obj[key]
    }
  }
  return res
};
goog.object.map = function(obj, f, opt_obj) {
  var res = {};
  for(var key in obj) {
    res[key] = f.call(opt_obj, obj[key], key, obj)
  }
  return res
};
goog.object.some = function(obj, f, opt_obj) {
  for(var key in obj) {
    if(f.call(opt_obj, obj[key], key, obj)) {
      return true
    }
  }
  return false
};
goog.object.every = function(obj, f, opt_obj) {
  for(var key in obj) {
    if(!f.call(opt_obj, obj[key], key, obj)) {
      return false
    }
  }
  return true
};
goog.object.getCount = function(obj) {
  var rv = 0;
  for(var key in obj) {
    rv++
  }
  return rv
};
goog.object.getAnyKey = function(obj) {
  for(var key in obj) {
    return key
  }
};
goog.object.getAnyValue = function(obj) {
  for(var key in obj) {
    return obj[key]
  }
};
goog.object.contains = function(obj, val) {
  return goog.object.containsValue(obj, val)
};
goog.object.getValues = function(obj) {
  var res = [];
  var i = 0;
  for(var key in obj) {
    res[i++] = obj[key]
  }
  return res
};
goog.object.getKeys = function(obj) {
  var res = [];
  var i = 0;
  for(var key in obj) {
    res[i++] = key
  }
  return res
};
goog.object.getValueByKeys = function(obj, var_args) {
  var isArrayLike = goog.isArrayLike(var_args);
  var keys = isArrayLike ? var_args : arguments;
  for(var i = isArrayLike ? 0 : 1;i < keys.length;i++) {
    obj = obj[keys[i]];
    if(!goog.isDef(obj)) {
      break
    }
  }
  return obj
};
goog.object.containsKey = function(obj, key) {
  return key in obj
};
goog.object.containsValue = function(obj, val) {
  for(var key in obj) {
    if(obj[key] == val) {
      return true
    }
  }
  return false
};
goog.object.findKey = function(obj, f, opt_this) {
  for(var key in obj) {
    if(f.call(opt_this, obj[key], key, obj)) {
      return key
    }
  }
  return undefined
};
goog.object.findValue = function(obj, f, opt_this) {
  var key = goog.object.findKey(obj, f, opt_this);
  return key && obj[key]
};
goog.object.isEmpty = function(obj) {
  for(var key in obj) {
    return false
  }
  return true
};
goog.object.clear = function(obj) {
  for(var i in obj) {
    delete obj[i]
  }
};
goog.object.remove = function(obj, key) {
  var rv;
  if(rv = key in obj) {
    delete obj[key]
  }
  return rv
};
goog.object.add = function(obj, key, val) {
  if(key in obj) {
    throw Error('The object already contains the key "' + key + '"');
  }
  goog.object.set(obj, key, val)
};
goog.object.get = function(obj, key, opt_val) {
  if(key in obj) {
    return obj[key]
  }
  return opt_val
};
goog.object.set = function(obj, key, value) {
  obj[key] = value
};
goog.object.setIfUndefined = function(obj, key, value) {
  return key in obj ? obj[key] : obj[key] = value
};
goog.object.clone = function(obj) {
  var res = {};
  for(var key in obj) {
    res[key] = obj[key]
  }
  return res
};
goog.object.unsafeClone = function(obj) {
  var type = goog.typeOf(obj);
  if(type == "object" || type == "array") {
    if(obj.clone) {
      return obj.clone()
    }
    var clone = type == "array" ? [] : {};
    for(var key in obj) {
      clone[key] = goog.object.unsafeClone(obj[key])
    }
    return clone
  }
  return obj
};
goog.object.transpose = function(obj) {
  var transposed = {};
  for(var key in obj) {
    transposed[obj[key]] = key
  }
  return transposed
};
goog.object.PROTOTYPE_FIELDS_ = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
goog.object.extend = function(target, var_args) {
  var key, source;
  for(var i = 1;i < arguments.length;i++) {
    source = arguments[i];
    for(key in source) {
      target[key] = source[key]
    }
    for(var j = 0;j < goog.object.PROTOTYPE_FIELDS_.length;j++) {
      key = goog.object.PROTOTYPE_FIELDS_[j];
      if(Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key]
      }
    }
  }
};
goog.object.create = function(var_args) {
  var argLength = arguments.length;
  if(argLength == 1 && goog.isArray(arguments[0])) {
    return goog.object.create.apply(null, arguments[0])
  }
  if(argLength % 2) {
    throw Error("Uneven number of arguments");
  }
  var rv = {};
  for(var i = 0;i < argLength;i += 2) {
    rv[arguments[i]] = arguments[i + 1]
  }
  return rv
};
goog.object.createSet = function(var_args) {
  var argLength = arguments.length;
  if(argLength == 1 && goog.isArray(arguments[0])) {
    return goog.object.createSet.apply(null, arguments[0])
  }
  var rv = {};
  for(var i = 0;i < argLength;i++) {
    rv[arguments[i]] = true
  }
  return rv
};
goog.provide("goog.userAgent.jscript");
goog.require("goog.string");
goog.userAgent.jscript.ASSUME_NO_JSCRIPT = false;
goog.userAgent.jscript.init_ = function() {
  var hasScriptEngine = "ScriptEngine" in goog.global;
  goog.userAgent.jscript.DETECTED_HAS_JSCRIPT_ = hasScriptEngine && goog.global["ScriptEngine"]() == "JScript";
  goog.userAgent.jscript.DETECTED_VERSION_ = goog.userAgent.jscript.DETECTED_HAS_JSCRIPT_ ? goog.global["ScriptEngineMajorVersion"]() + "." + goog.global["ScriptEngineMinorVersion"]() + "." + goog.global["ScriptEngineBuildVersion"]() : "0"
};
if(!goog.userAgent.jscript.ASSUME_NO_JSCRIPT) {
  goog.userAgent.jscript.init_()
}
goog.userAgent.jscript.HAS_JSCRIPT = goog.userAgent.jscript.ASSUME_NO_JSCRIPT ? false : goog.userAgent.jscript.DETECTED_HAS_JSCRIPT_;
goog.userAgent.jscript.VERSION = goog.userAgent.jscript.ASSUME_NO_JSCRIPT ? "0" : goog.userAgent.jscript.DETECTED_VERSION_;
goog.userAgent.jscript.isVersion = function(version) {
  return goog.string.compareVersions(goog.userAgent.jscript.VERSION, version) >= 0
};
goog.provide("goog.string.StringBuffer");
goog.require("goog.userAgent.jscript");
goog.string.StringBuffer = function(opt_a1, var_args) {
  this.buffer_ = goog.userAgent.jscript.HAS_JSCRIPT ? [] : "";
  if(opt_a1 != null) {
    this.append.apply(this, arguments)
  }
};
goog.string.StringBuffer.prototype.set = function(s) {
  this.clear();
  this.append(s)
};
if(goog.userAgent.jscript.HAS_JSCRIPT) {
  goog.string.StringBuffer.prototype.bufferLength_ = 0;
  goog.string.StringBuffer.prototype.append = function(a1, opt_a2, var_args) {
    if(opt_a2 == null) {
      this.buffer_[this.bufferLength_++] = a1
    }else {
      this.buffer_.push.apply(this.buffer_, arguments);
      this.bufferLength_ = this.buffer_.length
    }
    return this
  }
}else {
  goog.string.StringBuffer.prototype.append = function(a1, opt_a2, var_args) {
    this.buffer_ += a1;
    if(opt_a2 != null) {
      for(var i = 1;i < arguments.length;i++) {
        this.buffer_ += arguments[i]
      }
    }
    return this
  }
}
goog.string.StringBuffer.prototype.clear = function() {
  if(goog.userAgent.jscript.HAS_JSCRIPT) {
    this.buffer_.length = 0;
    this.bufferLength_ = 0
  }else {
    this.buffer_ = ""
  }
};
goog.string.StringBuffer.prototype.getLength = function() {
  return this.toString().length
};
goog.string.StringBuffer.prototype.toString = function() {
  if(goog.userAgent.jscript.HAS_JSCRIPT) {
    var str = this.buffer_.join("");
    this.clear();
    if(str) {
      this.append(str)
    }
    return str
  }else {
    return this.buffer_
  }
};
goog.provide("cljs.core");
goog.require("goog.string");
goog.require("goog.string.StringBuffer");
goog.require("goog.object");
goog.require("goog.array");
cljs.core._STAR_print_fn_STAR_ = function _STAR_print_fn_STAR_(_) {
  throw new Error("No *print-fn* fn set for evaluation environment");
};
cljs.core.truth_ = function truth_(x) {
  return x != null && x !== false
};
cljs.core.type_satisfies_ = function type_satisfies_(p, x) {
  var or__3548__auto____1606272 = p[goog.typeOf.call(null, x)];
  if(cljs.core.truth_(or__3548__auto____1606272)) {
    return or__3548__auto____1606272
  }else {
    var or__3548__auto____1606273 = p["_"];
    if(cljs.core.truth_(or__3548__auto____1606273)) {
      return or__3548__auto____1606273
    }else {
      return false
    }
  }
};
cljs.core.is_proto_ = function is_proto_(x) {
  return x.constructor.prototype === x
};
cljs.core._STAR_main_cli_fn_STAR_ = null;
cljs.core.missing_protocol = function missing_protocol(proto, obj) {
  return Error.call(null, "No protocol method " + proto + " defined for type " + goog.typeOf.call(null, obj) + ": " + obj)
};
cljs.core.aclone = function aclone(array_like) {
  return Array.prototype.slice.call(array_like)
};
cljs.core.array = function array(var_args) {
  return Array.prototype.slice.call(arguments)
};
cljs.core.aget = function aget(array, i) {
  return array[i]
};
cljs.core.aset = function aset(array, i, val) {
  return array[i] = val
};
cljs.core.alength = function alength(array) {
  return array.length
};
cljs.core.IFn = {};
cljs.core._invoke = function() {
  var _invoke = null;
  var _invoke__1606337 = function(this$) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606274 = this$;
      if(cljs.core.truth_(and__3546__auto____1606274)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606274
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$)
    }else {
      return function() {
        var or__3548__auto____1606275 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606275)) {
          return or__3548__auto____1606275
        }else {
          var or__3548__auto____1606276 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606276)) {
            return or__3548__auto____1606276
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$)
    }
  };
  var _invoke__1606338 = function(this$, a) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606277 = this$;
      if(cljs.core.truth_(and__3546__auto____1606277)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606277
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a)
    }else {
      return function() {
        var or__3548__auto____1606278 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606278)) {
          return or__3548__auto____1606278
        }else {
          var or__3548__auto____1606279 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606279)) {
            return or__3548__auto____1606279
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a)
    }
  };
  var _invoke__1606339 = function(this$, a, b) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606280 = this$;
      if(cljs.core.truth_(and__3546__auto____1606280)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606280
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b)
    }else {
      return function() {
        var or__3548__auto____1606281 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606281)) {
          return or__3548__auto____1606281
        }else {
          var or__3548__auto____1606282 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606282)) {
            return or__3548__auto____1606282
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b)
    }
  };
  var _invoke__1606340 = function(this$, a, b, c) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606283 = this$;
      if(cljs.core.truth_(and__3546__auto____1606283)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606283
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c)
    }else {
      return function() {
        var or__3548__auto____1606284 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606284)) {
          return or__3548__auto____1606284
        }else {
          var or__3548__auto____1606285 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606285)) {
            return or__3548__auto____1606285
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c)
    }
  };
  var _invoke__1606341 = function(this$, a, b, c, d) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606286 = this$;
      if(cljs.core.truth_(and__3546__auto____1606286)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606286
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d)
    }else {
      return function() {
        var or__3548__auto____1606287 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606287)) {
          return or__3548__auto____1606287
        }else {
          var or__3548__auto____1606288 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606288)) {
            return or__3548__auto____1606288
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d)
    }
  };
  var _invoke__1606342 = function(this$, a, b, c, d, e) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606289 = this$;
      if(cljs.core.truth_(and__3546__auto____1606289)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606289
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e)
    }else {
      return function() {
        var or__3548__auto____1606290 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606290)) {
          return or__3548__auto____1606290
        }else {
          var or__3548__auto____1606291 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606291)) {
            return or__3548__auto____1606291
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e)
    }
  };
  var _invoke__1606343 = function(this$, a, b, c, d, e, f) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606292 = this$;
      if(cljs.core.truth_(and__3546__auto____1606292)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606292
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f)
    }else {
      return function() {
        var or__3548__auto____1606293 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606293)) {
          return or__3548__auto____1606293
        }else {
          var or__3548__auto____1606294 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606294)) {
            return or__3548__auto____1606294
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f)
    }
  };
  var _invoke__1606344 = function(this$, a, b, c, d, e, f, g) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606295 = this$;
      if(cljs.core.truth_(and__3546__auto____1606295)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606295
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g)
    }else {
      return function() {
        var or__3548__auto____1606296 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606296)) {
          return or__3548__auto____1606296
        }else {
          var or__3548__auto____1606297 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606297)) {
            return or__3548__auto____1606297
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g)
    }
  };
  var _invoke__1606345 = function(this$, a, b, c, d, e, f, g, h) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606298 = this$;
      if(cljs.core.truth_(and__3546__auto____1606298)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606298
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h)
    }else {
      return function() {
        var or__3548__auto____1606299 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606299)) {
          return or__3548__auto____1606299
        }else {
          var or__3548__auto____1606300 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606300)) {
            return or__3548__auto____1606300
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h)
    }
  };
  var _invoke__1606346 = function(this$, a, b, c, d, e, f, g, h, i) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606301 = this$;
      if(cljs.core.truth_(and__3546__auto____1606301)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606301
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i)
    }else {
      return function() {
        var or__3548__auto____1606302 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606302)) {
          return or__3548__auto____1606302
        }else {
          var or__3548__auto____1606303 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606303)) {
            return or__3548__auto____1606303
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i)
    }
  };
  var _invoke__1606347 = function(this$, a, b, c, d, e, f, g, h, i, j) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606304 = this$;
      if(cljs.core.truth_(and__3546__auto____1606304)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606304
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j)
    }else {
      return function() {
        var or__3548__auto____1606305 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606305)) {
          return or__3548__auto____1606305
        }else {
          var or__3548__auto____1606306 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606306)) {
            return or__3548__auto____1606306
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j)
    }
  };
  var _invoke__1606348 = function(this$, a, b, c, d, e, f, g, h, i, j, k) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606307 = this$;
      if(cljs.core.truth_(and__3546__auto____1606307)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606307
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j, k)
    }else {
      return function() {
        var or__3548__auto____1606308 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606308)) {
          return or__3548__auto____1606308
        }else {
          var or__3548__auto____1606309 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606309)) {
            return or__3548__auto____1606309
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j, k)
    }
  };
  var _invoke__1606349 = function(this$, a, b, c, d, e, f, g, h, i, j, k, l) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606310 = this$;
      if(cljs.core.truth_(and__3546__auto____1606310)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606310
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j, k, l)
    }else {
      return function() {
        var or__3548__auto____1606311 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606311)) {
          return or__3548__auto____1606311
        }else {
          var or__3548__auto____1606312 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606312)) {
            return or__3548__auto____1606312
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j, k, l)
    }
  };
  var _invoke__1606350 = function(this$, a, b, c, d, e, f, g, h, i, j, k, l, m) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606313 = this$;
      if(cljs.core.truth_(and__3546__auto____1606313)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606313
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j, k, l, m)
    }else {
      return function() {
        var or__3548__auto____1606314 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606314)) {
          return or__3548__auto____1606314
        }else {
          var or__3548__auto____1606315 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606315)) {
            return or__3548__auto____1606315
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j, k, l, m)
    }
  };
  var _invoke__1606351 = function(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606316 = this$;
      if(cljs.core.truth_(and__3546__auto____1606316)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606316
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n)
    }else {
      return function() {
        var or__3548__auto____1606317 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606317)) {
          return or__3548__auto____1606317
        }else {
          var or__3548__auto____1606318 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606318)) {
            return or__3548__auto____1606318
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n)
    }
  };
  var _invoke__1606352 = function(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606319 = this$;
      if(cljs.core.truth_(and__3546__auto____1606319)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606319
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o)
    }else {
      return function() {
        var or__3548__auto____1606320 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606320)) {
          return or__3548__auto____1606320
        }else {
          var or__3548__auto____1606321 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606321)) {
            return or__3548__auto____1606321
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o)
    }
  };
  var _invoke__1606353 = function(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606322 = this$;
      if(cljs.core.truth_(and__3546__auto____1606322)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606322
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p)
    }else {
      return function() {
        var or__3548__auto____1606323 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606323)) {
          return or__3548__auto____1606323
        }else {
          var or__3548__auto____1606324 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606324)) {
            return or__3548__auto____1606324
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p)
    }
  };
  var _invoke__1606354 = function(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606325 = this$;
      if(cljs.core.truth_(and__3546__auto____1606325)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606325
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q)
    }else {
      return function() {
        var or__3548__auto____1606326 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606326)) {
          return or__3548__auto____1606326
        }else {
          var or__3548__auto____1606327 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606327)) {
            return or__3548__auto____1606327
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q)
    }
  };
  var _invoke__1606355 = function(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606328 = this$;
      if(cljs.core.truth_(and__3546__auto____1606328)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606328
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s)
    }else {
      return function() {
        var or__3548__auto____1606329 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606329)) {
          return or__3548__auto____1606329
        }else {
          var or__3548__auto____1606330 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606330)) {
            return or__3548__auto____1606330
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s)
    }
  };
  var _invoke__1606356 = function(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s, t) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606331 = this$;
      if(cljs.core.truth_(and__3546__auto____1606331)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606331
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s, t)
    }else {
      return function() {
        var or__3548__auto____1606332 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606332)) {
          return or__3548__auto____1606332
        }else {
          var or__3548__auto____1606333 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606333)) {
            return or__3548__auto____1606333
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s, t)
    }
  };
  var _invoke__1606357 = function(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s, t, rest) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606334 = this$;
      if(cljs.core.truth_(and__3546__auto____1606334)) {
        return this$.cljs$core$IFn$_invoke
      }else {
        return and__3546__auto____1606334
      }
    }())) {
      return this$.cljs$core$IFn$_invoke(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s, t, rest)
    }else {
      return function() {
        var or__3548__auto____1606335 = cljs.core._invoke[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1606335)) {
          return or__3548__auto____1606335
        }else {
          var or__3548__auto____1606336 = cljs.core._invoke["_"];
          if(cljs.core.truth_(or__3548__auto____1606336)) {
            return or__3548__auto____1606336
          }else {
            throw cljs.core.missing_protocol.call(null, "IFn.-invoke", this$);
          }
        }
      }().call(null, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s, t, rest)
    }
  };
  _invoke = function(this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s, t, rest) {
    switch(arguments.length) {
      case 1:
        return _invoke__1606337.call(this, this$);
      case 2:
        return _invoke__1606338.call(this, this$, a);
      case 3:
        return _invoke__1606339.call(this, this$, a, b);
      case 4:
        return _invoke__1606340.call(this, this$, a, b, c);
      case 5:
        return _invoke__1606341.call(this, this$, a, b, c, d);
      case 6:
        return _invoke__1606342.call(this, this$, a, b, c, d, e);
      case 7:
        return _invoke__1606343.call(this, this$, a, b, c, d, e, f);
      case 8:
        return _invoke__1606344.call(this, this$, a, b, c, d, e, f, g);
      case 9:
        return _invoke__1606345.call(this, this$, a, b, c, d, e, f, g, h);
      case 10:
        return _invoke__1606346.call(this, this$, a, b, c, d, e, f, g, h, i);
      case 11:
        return _invoke__1606347.call(this, this$, a, b, c, d, e, f, g, h, i, j);
      case 12:
        return _invoke__1606348.call(this, this$, a, b, c, d, e, f, g, h, i, j, k);
      case 13:
        return _invoke__1606349.call(this, this$, a, b, c, d, e, f, g, h, i, j, k, l);
      case 14:
        return _invoke__1606350.call(this, this$, a, b, c, d, e, f, g, h, i, j, k, l, m);
      case 15:
        return _invoke__1606351.call(this, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n);
      case 16:
        return _invoke__1606352.call(this, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o);
      case 17:
        return _invoke__1606353.call(this, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p);
      case 18:
        return _invoke__1606354.call(this, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q);
      case 19:
        return _invoke__1606355.call(this, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s);
      case 20:
        return _invoke__1606356.call(this, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s, t);
      case 21:
        return _invoke__1606357.call(this, this$, a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, s, t, rest)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return _invoke
}();
cljs.core.ICounted = {};
cljs.core._count = function _count(coll) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606359 = coll;
    if(cljs.core.truth_(and__3546__auto____1606359)) {
      return coll.cljs$core$ICounted$_count
    }else {
      return and__3546__auto____1606359
    }
  }())) {
    return coll.cljs$core$ICounted$_count(coll)
  }else {
    return function() {
      var or__3548__auto____1606360 = cljs.core._count[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606360)) {
        return or__3548__auto____1606360
      }else {
        var or__3548__auto____1606361 = cljs.core._count["_"];
        if(cljs.core.truth_(or__3548__auto____1606361)) {
          return or__3548__auto____1606361
        }else {
          throw cljs.core.missing_protocol.call(null, "ICounted.-count", coll);
        }
      }
    }().call(null, coll)
  }
};
cljs.core.IEmptyableCollection = {};
cljs.core._empty = function _empty(coll) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606362 = coll;
    if(cljs.core.truth_(and__3546__auto____1606362)) {
      return coll.cljs$core$IEmptyableCollection$_empty
    }else {
      return and__3546__auto____1606362
    }
  }())) {
    return coll.cljs$core$IEmptyableCollection$_empty(coll)
  }else {
    return function() {
      var or__3548__auto____1606363 = cljs.core._empty[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606363)) {
        return or__3548__auto____1606363
      }else {
        var or__3548__auto____1606364 = cljs.core._empty["_"];
        if(cljs.core.truth_(or__3548__auto____1606364)) {
          return or__3548__auto____1606364
        }else {
          throw cljs.core.missing_protocol.call(null, "IEmptyableCollection.-empty", coll);
        }
      }
    }().call(null, coll)
  }
};
cljs.core.ICollection = {};
cljs.core._conj = function _conj(coll, o) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606365 = coll;
    if(cljs.core.truth_(and__3546__auto____1606365)) {
      return coll.cljs$core$ICollection$_conj
    }else {
      return and__3546__auto____1606365
    }
  }())) {
    return coll.cljs$core$ICollection$_conj(coll, o)
  }else {
    return function() {
      var or__3548__auto____1606366 = cljs.core._conj[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606366)) {
        return or__3548__auto____1606366
      }else {
        var or__3548__auto____1606367 = cljs.core._conj["_"];
        if(cljs.core.truth_(or__3548__auto____1606367)) {
          return or__3548__auto____1606367
        }else {
          throw cljs.core.missing_protocol.call(null, "ICollection.-conj", coll);
        }
      }
    }().call(null, coll, o)
  }
};
cljs.core.IIndexed = {};
cljs.core._nth = function() {
  var _nth = null;
  var _nth__1606374 = function(coll, n) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606368 = coll;
      if(cljs.core.truth_(and__3546__auto____1606368)) {
        return coll.cljs$core$IIndexed$_nth
      }else {
        return and__3546__auto____1606368
      }
    }())) {
      return coll.cljs$core$IIndexed$_nth(coll, n)
    }else {
      return function() {
        var or__3548__auto____1606369 = cljs.core._nth[goog.typeOf.call(null, coll)];
        if(cljs.core.truth_(or__3548__auto____1606369)) {
          return or__3548__auto____1606369
        }else {
          var or__3548__auto____1606370 = cljs.core._nth["_"];
          if(cljs.core.truth_(or__3548__auto____1606370)) {
            return or__3548__auto____1606370
          }else {
            throw cljs.core.missing_protocol.call(null, "IIndexed.-nth", coll);
          }
        }
      }().call(null, coll, n)
    }
  };
  var _nth__1606375 = function(coll, n, not_found) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606371 = coll;
      if(cljs.core.truth_(and__3546__auto____1606371)) {
        return coll.cljs$core$IIndexed$_nth
      }else {
        return and__3546__auto____1606371
      }
    }())) {
      return coll.cljs$core$IIndexed$_nth(coll, n, not_found)
    }else {
      return function() {
        var or__3548__auto____1606372 = cljs.core._nth[goog.typeOf.call(null, coll)];
        if(cljs.core.truth_(or__3548__auto____1606372)) {
          return or__3548__auto____1606372
        }else {
          var or__3548__auto____1606373 = cljs.core._nth["_"];
          if(cljs.core.truth_(or__3548__auto____1606373)) {
            return or__3548__auto____1606373
          }else {
            throw cljs.core.missing_protocol.call(null, "IIndexed.-nth", coll);
          }
        }
      }().call(null, coll, n, not_found)
    }
  };
  _nth = function(coll, n, not_found) {
    switch(arguments.length) {
      case 2:
        return _nth__1606374.call(this, coll, n);
      case 3:
        return _nth__1606375.call(this, coll, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return _nth
}();
cljs.core.ISeq = {};
cljs.core._first = function _first(coll) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606377 = coll;
    if(cljs.core.truth_(and__3546__auto____1606377)) {
      return coll.cljs$core$ISeq$_first
    }else {
      return and__3546__auto____1606377
    }
  }())) {
    return coll.cljs$core$ISeq$_first(coll)
  }else {
    return function() {
      var or__3548__auto____1606378 = cljs.core._first[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606378)) {
        return or__3548__auto____1606378
      }else {
        var or__3548__auto____1606379 = cljs.core._first["_"];
        if(cljs.core.truth_(or__3548__auto____1606379)) {
          return or__3548__auto____1606379
        }else {
          throw cljs.core.missing_protocol.call(null, "ISeq.-first", coll);
        }
      }
    }().call(null, coll)
  }
};
cljs.core._rest = function _rest(coll) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606380 = coll;
    if(cljs.core.truth_(and__3546__auto____1606380)) {
      return coll.cljs$core$ISeq$_rest
    }else {
      return and__3546__auto____1606380
    }
  }())) {
    return coll.cljs$core$ISeq$_rest(coll)
  }else {
    return function() {
      var or__3548__auto____1606381 = cljs.core._rest[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606381)) {
        return or__3548__auto____1606381
      }else {
        var or__3548__auto____1606382 = cljs.core._rest["_"];
        if(cljs.core.truth_(or__3548__auto____1606382)) {
          return or__3548__auto____1606382
        }else {
          throw cljs.core.missing_protocol.call(null, "ISeq.-rest", coll);
        }
      }
    }().call(null, coll)
  }
};
cljs.core.ILookup = {};
cljs.core._lookup = function() {
  var _lookup = null;
  var _lookup__1606389 = function(o, k) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606383 = o;
      if(cljs.core.truth_(and__3546__auto____1606383)) {
        return o.cljs$core$ILookup$_lookup
      }else {
        return and__3546__auto____1606383
      }
    }())) {
      return o.cljs$core$ILookup$_lookup(o, k)
    }else {
      return function() {
        var or__3548__auto____1606384 = cljs.core._lookup[goog.typeOf.call(null, o)];
        if(cljs.core.truth_(or__3548__auto____1606384)) {
          return or__3548__auto____1606384
        }else {
          var or__3548__auto____1606385 = cljs.core._lookup["_"];
          if(cljs.core.truth_(or__3548__auto____1606385)) {
            return or__3548__auto____1606385
          }else {
            throw cljs.core.missing_protocol.call(null, "ILookup.-lookup", o);
          }
        }
      }().call(null, o, k)
    }
  };
  var _lookup__1606390 = function(o, k, not_found) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606386 = o;
      if(cljs.core.truth_(and__3546__auto____1606386)) {
        return o.cljs$core$ILookup$_lookup
      }else {
        return and__3546__auto____1606386
      }
    }())) {
      return o.cljs$core$ILookup$_lookup(o, k, not_found)
    }else {
      return function() {
        var or__3548__auto____1606387 = cljs.core._lookup[goog.typeOf.call(null, o)];
        if(cljs.core.truth_(or__3548__auto____1606387)) {
          return or__3548__auto____1606387
        }else {
          var or__3548__auto____1606388 = cljs.core._lookup["_"];
          if(cljs.core.truth_(or__3548__auto____1606388)) {
            return or__3548__auto____1606388
          }else {
            throw cljs.core.missing_protocol.call(null, "ILookup.-lookup", o);
          }
        }
      }().call(null, o, k, not_found)
    }
  };
  _lookup = function(o, k, not_found) {
    switch(arguments.length) {
      case 2:
        return _lookup__1606389.call(this, o, k);
      case 3:
        return _lookup__1606390.call(this, o, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return _lookup
}();
cljs.core.IAssociative = {};
cljs.core._contains_key_QMARK_ = function _contains_key_QMARK_(coll, k) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606392 = coll;
    if(cljs.core.truth_(and__3546__auto____1606392)) {
      return coll.cljs$core$IAssociative$_contains_key_QMARK_
    }else {
      return and__3546__auto____1606392
    }
  }())) {
    return coll.cljs$core$IAssociative$_contains_key_QMARK_(coll, k)
  }else {
    return function() {
      var or__3548__auto____1606393 = cljs.core._contains_key_QMARK_[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606393)) {
        return or__3548__auto____1606393
      }else {
        var or__3548__auto____1606394 = cljs.core._contains_key_QMARK_["_"];
        if(cljs.core.truth_(or__3548__auto____1606394)) {
          return or__3548__auto____1606394
        }else {
          throw cljs.core.missing_protocol.call(null, "IAssociative.-contains-key?", coll);
        }
      }
    }().call(null, coll, k)
  }
};
cljs.core._assoc = function _assoc(coll, k, v) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606395 = coll;
    if(cljs.core.truth_(and__3546__auto____1606395)) {
      return coll.cljs$core$IAssociative$_assoc
    }else {
      return and__3546__auto____1606395
    }
  }())) {
    return coll.cljs$core$IAssociative$_assoc(coll, k, v)
  }else {
    return function() {
      var or__3548__auto____1606396 = cljs.core._assoc[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606396)) {
        return or__3548__auto____1606396
      }else {
        var or__3548__auto____1606397 = cljs.core._assoc["_"];
        if(cljs.core.truth_(or__3548__auto____1606397)) {
          return or__3548__auto____1606397
        }else {
          throw cljs.core.missing_protocol.call(null, "IAssociative.-assoc", coll);
        }
      }
    }().call(null, coll, k, v)
  }
};
cljs.core.IMap = {};
cljs.core._dissoc = function _dissoc(coll, k) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606398 = coll;
    if(cljs.core.truth_(and__3546__auto____1606398)) {
      return coll.cljs$core$IMap$_dissoc
    }else {
      return and__3546__auto____1606398
    }
  }())) {
    return coll.cljs$core$IMap$_dissoc(coll, k)
  }else {
    return function() {
      var or__3548__auto____1606399 = cljs.core._dissoc[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606399)) {
        return or__3548__auto____1606399
      }else {
        var or__3548__auto____1606400 = cljs.core._dissoc["_"];
        if(cljs.core.truth_(or__3548__auto____1606400)) {
          return or__3548__auto____1606400
        }else {
          throw cljs.core.missing_protocol.call(null, "IMap.-dissoc", coll);
        }
      }
    }().call(null, coll, k)
  }
};
cljs.core.ISet = {};
cljs.core._disjoin = function _disjoin(coll, v) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606401 = coll;
    if(cljs.core.truth_(and__3546__auto____1606401)) {
      return coll.cljs$core$ISet$_disjoin
    }else {
      return and__3546__auto____1606401
    }
  }())) {
    return coll.cljs$core$ISet$_disjoin(coll, v)
  }else {
    return function() {
      var or__3548__auto____1606402 = cljs.core._disjoin[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606402)) {
        return or__3548__auto____1606402
      }else {
        var or__3548__auto____1606403 = cljs.core._disjoin["_"];
        if(cljs.core.truth_(or__3548__auto____1606403)) {
          return or__3548__auto____1606403
        }else {
          throw cljs.core.missing_protocol.call(null, "ISet.-disjoin", coll);
        }
      }
    }().call(null, coll, v)
  }
};
cljs.core.IStack = {};
cljs.core._peek = function _peek(coll) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606404 = coll;
    if(cljs.core.truth_(and__3546__auto____1606404)) {
      return coll.cljs$core$IStack$_peek
    }else {
      return and__3546__auto____1606404
    }
  }())) {
    return coll.cljs$core$IStack$_peek(coll)
  }else {
    return function() {
      var or__3548__auto____1606405 = cljs.core._peek[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606405)) {
        return or__3548__auto____1606405
      }else {
        var or__3548__auto____1606406 = cljs.core._peek["_"];
        if(cljs.core.truth_(or__3548__auto____1606406)) {
          return or__3548__auto____1606406
        }else {
          throw cljs.core.missing_protocol.call(null, "IStack.-peek", coll);
        }
      }
    }().call(null, coll)
  }
};
cljs.core._pop = function _pop(coll) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606407 = coll;
    if(cljs.core.truth_(and__3546__auto____1606407)) {
      return coll.cljs$core$IStack$_pop
    }else {
      return and__3546__auto____1606407
    }
  }())) {
    return coll.cljs$core$IStack$_pop(coll)
  }else {
    return function() {
      var or__3548__auto____1606408 = cljs.core._pop[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606408)) {
        return or__3548__auto____1606408
      }else {
        var or__3548__auto____1606409 = cljs.core._pop["_"];
        if(cljs.core.truth_(or__3548__auto____1606409)) {
          return or__3548__auto____1606409
        }else {
          throw cljs.core.missing_protocol.call(null, "IStack.-pop", coll);
        }
      }
    }().call(null, coll)
  }
};
cljs.core.IVector = {};
cljs.core._assoc_n = function _assoc_n(coll, n, val) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606410 = coll;
    if(cljs.core.truth_(and__3546__auto____1606410)) {
      return coll.cljs$core$IVector$_assoc_n
    }else {
      return and__3546__auto____1606410
    }
  }())) {
    return coll.cljs$core$IVector$_assoc_n(coll, n, val)
  }else {
    return function() {
      var or__3548__auto____1606411 = cljs.core._assoc_n[goog.typeOf.call(null, coll)];
      if(cljs.core.truth_(or__3548__auto____1606411)) {
        return or__3548__auto____1606411
      }else {
        var or__3548__auto____1606412 = cljs.core._assoc_n["_"];
        if(cljs.core.truth_(or__3548__auto____1606412)) {
          return or__3548__auto____1606412
        }else {
          throw cljs.core.missing_protocol.call(null, "IVector.-assoc-n", coll);
        }
      }
    }().call(null, coll, n, val)
  }
};
cljs.core.IDeref = {};
cljs.core._deref = function _deref(o) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606413 = o;
    if(cljs.core.truth_(and__3546__auto____1606413)) {
      return o.cljs$core$IDeref$_deref
    }else {
      return and__3546__auto____1606413
    }
  }())) {
    return o.cljs$core$IDeref$_deref(o)
  }else {
    return function() {
      var or__3548__auto____1606414 = cljs.core._deref[goog.typeOf.call(null, o)];
      if(cljs.core.truth_(or__3548__auto____1606414)) {
        return or__3548__auto____1606414
      }else {
        var or__3548__auto____1606415 = cljs.core._deref["_"];
        if(cljs.core.truth_(or__3548__auto____1606415)) {
          return or__3548__auto____1606415
        }else {
          throw cljs.core.missing_protocol.call(null, "IDeref.-deref", o);
        }
      }
    }().call(null, o)
  }
};
cljs.core.IDerefWithTimeout = {};
cljs.core._deref_with_timeout = function _deref_with_timeout(o, msec, timeout_val) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606416 = o;
    if(cljs.core.truth_(and__3546__auto____1606416)) {
      return o.cljs$core$IDerefWithTimeout$_deref_with_timeout
    }else {
      return and__3546__auto____1606416
    }
  }())) {
    return o.cljs$core$IDerefWithTimeout$_deref_with_timeout(o, msec, timeout_val)
  }else {
    return function() {
      var or__3548__auto____1606417 = cljs.core._deref_with_timeout[goog.typeOf.call(null, o)];
      if(cljs.core.truth_(or__3548__auto____1606417)) {
        return or__3548__auto____1606417
      }else {
        var or__3548__auto____1606418 = cljs.core._deref_with_timeout["_"];
        if(cljs.core.truth_(or__3548__auto____1606418)) {
          return or__3548__auto____1606418
        }else {
          throw cljs.core.missing_protocol.call(null, "IDerefWithTimeout.-deref-with-timeout", o);
        }
      }
    }().call(null, o, msec, timeout_val)
  }
};
cljs.core.IMeta = {};
cljs.core._meta = function _meta(o) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606419 = o;
    if(cljs.core.truth_(and__3546__auto____1606419)) {
      return o.cljs$core$IMeta$_meta
    }else {
      return and__3546__auto____1606419
    }
  }())) {
    return o.cljs$core$IMeta$_meta(o)
  }else {
    return function() {
      var or__3548__auto____1606420 = cljs.core._meta[goog.typeOf.call(null, o)];
      if(cljs.core.truth_(or__3548__auto____1606420)) {
        return or__3548__auto____1606420
      }else {
        var or__3548__auto____1606421 = cljs.core._meta["_"];
        if(cljs.core.truth_(or__3548__auto____1606421)) {
          return or__3548__auto____1606421
        }else {
          throw cljs.core.missing_protocol.call(null, "IMeta.-meta", o);
        }
      }
    }().call(null, o)
  }
};
cljs.core.IWithMeta = {};
cljs.core._with_meta = function _with_meta(o, meta) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606422 = o;
    if(cljs.core.truth_(and__3546__auto____1606422)) {
      return o.cljs$core$IWithMeta$_with_meta
    }else {
      return and__3546__auto____1606422
    }
  }())) {
    return o.cljs$core$IWithMeta$_with_meta(o, meta)
  }else {
    return function() {
      var or__3548__auto____1606423 = cljs.core._with_meta[goog.typeOf.call(null, o)];
      if(cljs.core.truth_(or__3548__auto____1606423)) {
        return or__3548__auto____1606423
      }else {
        var or__3548__auto____1606424 = cljs.core._with_meta["_"];
        if(cljs.core.truth_(or__3548__auto____1606424)) {
          return or__3548__auto____1606424
        }else {
          throw cljs.core.missing_protocol.call(null, "IWithMeta.-with-meta", o);
        }
      }
    }().call(null, o, meta)
  }
};
cljs.core.IReduce = {};
cljs.core._reduce = function() {
  var _reduce = null;
  var _reduce__1606431 = function(coll, f) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606425 = coll;
      if(cljs.core.truth_(and__3546__auto____1606425)) {
        return coll.cljs$core$IReduce$_reduce
      }else {
        return and__3546__auto____1606425
      }
    }())) {
      return coll.cljs$core$IReduce$_reduce(coll, f)
    }else {
      return function() {
        var or__3548__auto____1606426 = cljs.core._reduce[goog.typeOf.call(null, coll)];
        if(cljs.core.truth_(or__3548__auto____1606426)) {
          return or__3548__auto____1606426
        }else {
          var or__3548__auto____1606427 = cljs.core._reduce["_"];
          if(cljs.core.truth_(or__3548__auto____1606427)) {
            return or__3548__auto____1606427
          }else {
            throw cljs.core.missing_protocol.call(null, "IReduce.-reduce", coll);
          }
        }
      }().call(null, coll, f)
    }
  };
  var _reduce__1606432 = function(coll, f, start) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606428 = coll;
      if(cljs.core.truth_(and__3546__auto____1606428)) {
        return coll.cljs$core$IReduce$_reduce
      }else {
        return and__3546__auto____1606428
      }
    }())) {
      return coll.cljs$core$IReduce$_reduce(coll, f, start)
    }else {
      return function() {
        var or__3548__auto____1606429 = cljs.core._reduce[goog.typeOf.call(null, coll)];
        if(cljs.core.truth_(or__3548__auto____1606429)) {
          return or__3548__auto____1606429
        }else {
          var or__3548__auto____1606430 = cljs.core._reduce["_"];
          if(cljs.core.truth_(or__3548__auto____1606430)) {
            return or__3548__auto____1606430
          }else {
            throw cljs.core.missing_protocol.call(null, "IReduce.-reduce", coll);
          }
        }
      }().call(null, coll, f, start)
    }
  };
  _reduce = function(coll, f, start) {
    switch(arguments.length) {
      case 2:
        return _reduce__1606431.call(this, coll, f);
      case 3:
        return _reduce__1606432.call(this, coll, f, start)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return _reduce
}();
cljs.core.IEquiv = {};
cljs.core._equiv = function _equiv(o, other) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606434 = o;
    if(cljs.core.truth_(and__3546__auto____1606434)) {
      return o.cljs$core$IEquiv$_equiv
    }else {
      return and__3546__auto____1606434
    }
  }())) {
    return o.cljs$core$IEquiv$_equiv(o, other)
  }else {
    return function() {
      var or__3548__auto____1606435 = cljs.core._equiv[goog.typeOf.call(null, o)];
      if(cljs.core.truth_(or__3548__auto____1606435)) {
        return or__3548__auto____1606435
      }else {
        var or__3548__auto____1606436 = cljs.core._equiv["_"];
        if(cljs.core.truth_(or__3548__auto____1606436)) {
          return or__3548__auto____1606436
        }else {
          throw cljs.core.missing_protocol.call(null, "IEquiv.-equiv", o);
        }
      }
    }().call(null, o, other)
  }
};
cljs.core.IHash = {};
cljs.core._hash = function _hash(o) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606437 = o;
    if(cljs.core.truth_(and__3546__auto____1606437)) {
      return o.cljs$core$IHash$_hash
    }else {
      return and__3546__auto____1606437
    }
  }())) {
    return o.cljs$core$IHash$_hash(o)
  }else {
    return function() {
      var or__3548__auto____1606438 = cljs.core._hash[goog.typeOf.call(null, o)];
      if(cljs.core.truth_(or__3548__auto____1606438)) {
        return or__3548__auto____1606438
      }else {
        var or__3548__auto____1606439 = cljs.core._hash["_"];
        if(cljs.core.truth_(or__3548__auto____1606439)) {
          return or__3548__auto____1606439
        }else {
          throw cljs.core.missing_protocol.call(null, "IHash.-hash", o);
        }
      }
    }().call(null, o)
  }
};
cljs.core.ISeqable = {};
cljs.core._seq = function _seq(o) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606440 = o;
    if(cljs.core.truth_(and__3546__auto____1606440)) {
      return o.cljs$core$ISeqable$_seq
    }else {
      return and__3546__auto____1606440
    }
  }())) {
    return o.cljs$core$ISeqable$_seq(o)
  }else {
    return function() {
      var or__3548__auto____1606441 = cljs.core._seq[goog.typeOf.call(null, o)];
      if(cljs.core.truth_(or__3548__auto____1606441)) {
        return or__3548__auto____1606441
      }else {
        var or__3548__auto____1606442 = cljs.core._seq["_"];
        if(cljs.core.truth_(or__3548__auto____1606442)) {
          return or__3548__auto____1606442
        }else {
          throw cljs.core.missing_protocol.call(null, "ISeqable.-seq", o);
        }
      }
    }().call(null, o)
  }
};
cljs.core.ISequential = {};
cljs.core.IRecord = {};
cljs.core.IPrintable = {};
cljs.core._pr_seq = function _pr_seq(o, opts) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606443 = o;
    if(cljs.core.truth_(and__3546__auto____1606443)) {
      return o.cljs$core$IPrintable$_pr_seq
    }else {
      return and__3546__auto____1606443
    }
  }())) {
    return o.cljs$core$IPrintable$_pr_seq(o, opts)
  }else {
    return function() {
      var or__3548__auto____1606444 = cljs.core._pr_seq[goog.typeOf.call(null, o)];
      if(cljs.core.truth_(or__3548__auto____1606444)) {
        return or__3548__auto____1606444
      }else {
        var or__3548__auto____1606445 = cljs.core._pr_seq["_"];
        if(cljs.core.truth_(or__3548__auto____1606445)) {
          return or__3548__auto____1606445
        }else {
          throw cljs.core.missing_protocol.call(null, "IPrintable.-pr-seq", o);
        }
      }
    }().call(null, o, opts)
  }
};
cljs.core.IPending = {};
cljs.core._realized_QMARK_ = function _realized_QMARK_(d) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606446 = d;
    if(cljs.core.truth_(and__3546__auto____1606446)) {
      return d.cljs$core$IPending$_realized_QMARK_
    }else {
      return and__3546__auto____1606446
    }
  }())) {
    return d.cljs$core$IPending$_realized_QMARK_(d)
  }else {
    return function() {
      var or__3548__auto____1606447 = cljs.core._realized_QMARK_[goog.typeOf.call(null, d)];
      if(cljs.core.truth_(or__3548__auto____1606447)) {
        return or__3548__auto____1606447
      }else {
        var or__3548__auto____1606448 = cljs.core._realized_QMARK_["_"];
        if(cljs.core.truth_(or__3548__auto____1606448)) {
          return or__3548__auto____1606448
        }else {
          throw cljs.core.missing_protocol.call(null, "IPending.-realized?", d);
        }
      }
    }().call(null, d)
  }
};
cljs.core.IWatchable = {};
cljs.core._notify_watches = function _notify_watches(this$, oldval, newval) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606449 = this$;
    if(cljs.core.truth_(and__3546__auto____1606449)) {
      return this$.cljs$core$IWatchable$_notify_watches
    }else {
      return and__3546__auto____1606449
    }
  }())) {
    return this$.cljs$core$IWatchable$_notify_watches(this$, oldval, newval)
  }else {
    return function() {
      var or__3548__auto____1606450 = cljs.core._notify_watches[goog.typeOf.call(null, this$)];
      if(cljs.core.truth_(or__3548__auto____1606450)) {
        return or__3548__auto____1606450
      }else {
        var or__3548__auto____1606451 = cljs.core._notify_watches["_"];
        if(cljs.core.truth_(or__3548__auto____1606451)) {
          return or__3548__auto____1606451
        }else {
          throw cljs.core.missing_protocol.call(null, "IWatchable.-notify-watches", this$);
        }
      }
    }().call(null, this$, oldval, newval)
  }
};
cljs.core._add_watch = function _add_watch(this$, key, f) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606452 = this$;
    if(cljs.core.truth_(and__3546__auto____1606452)) {
      return this$.cljs$core$IWatchable$_add_watch
    }else {
      return and__3546__auto____1606452
    }
  }())) {
    return this$.cljs$core$IWatchable$_add_watch(this$, key, f)
  }else {
    return function() {
      var or__3548__auto____1606453 = cljs.core._add_watch[goog.typeOf.call(null, this$)];
      if(cljs.core.truth_(or__3548__auto____1606453)) {
        return or__3548__auto____1606453
      }else {
        var or__3548__auto____1606454 = cljs.core._add_watch["_"];
        if(cljs.core.truth_(or__3548__auto____1606454)) {
          return or__3548__auto____1606454
        }else {
          throw cljs.core.missing_protocol.call(null, "IWatchable.-add-watch", this$);
        }
      }
    }().call(null, this$, key, f)
  }
};
cljs.core._remove_watch = function _remove_watch(this$, key) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606455 = this$;
    if(cljs.core.truth_(and__3546__auto____1606455)) {
      return this$.cljs$core$IWatchable$_remove_watch
    }else {
      return and__3546__auto____1606455
    }
  }())) {
    return this$.cljs$core$IWatchable$_remove_watch(this$, key)
  }else {
    return function() {
      var or__3548__auto____1606456 = cljs.core._remove_watch[goog.typeOf.call(null, this$)];
      if(cljs.core.truth_(or__3548__auto____1606456)) {
        return or__3548__auto____1606456
      }else {
        var or__3548__auto____1606457 = cljs.core._remove_watch["_"];
        if(cljs.core.truth_(or__3548__auto____1606457)) {
          return or__3548__auto____1606457
        }else {
          throw cljs.core.missing_protocol.call(null, "IWatchable.-remove-watch", this$);
        }
      }
    }().call(null, this$, key)
  }
};
cljs.core.identical_QMARK_ = function identical_QMARK_(x, y) {
  return x === y
};
cljs.core._EQ_ = function _EQ_(x, y) {
  return cljs.core._equiv.call(null, x, y)
};
cljs.core.nil_QMARK_ = function nil_QMARK_(x) {
  return x === null
};
cljs.core.type = function type(x) {
  return x.constructor
};
cljs.core.IHash["null"] = true;
cljs.core._hash["null"] = function(o) {
  return 0
};
cljs.core.ILookup["null"] = true;
cljs.core._lookup["null"] = function() {
  var G__1606458 = null;
  var G__1606458__1606459 = function(o, k) {
    return null
  };
  var G__1606458__1606460 = function(o, k, not_found) {
    return not_found
  };
  G__1606458 = function(o, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1606458__1606459.call(this, o, k);
      case 3:
        return G__1606458__1606460.call(this, o, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606458
}();
cljs.core.IAssociative["null"] = true;
cljs.core._assoc["null"] = function(_, k, v) {
  return cljs.core.hash_map.call(null, k, v)
};
cljs.core.ICollection["null"] = true;
cljs.core._conj["null"] = function(_, o) {
  return cljs.core.list.call(null, o)
};
cljs.core.IReduce["null"] = true;
cljs.core._reduce["null"] = function() {
  var G__1606462 = null;
  var G__1606462__1606463 = function(_, f) {
    return f.call(null)
  };
  var G__1606462__1606464 = function(_, f, start) {
    return start
  };
  G__1606462 = function(_, f, start) {
    switch(arguments.length) {
      case 2:
        return G__1606462__1606463.call(this, _, f);
      case 3:
        return G__1606462__1606464.call(this, _, f, start)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606462
}();
cljs.core.IPrintable["null"] = true;
cljs.core._pr_seq["null"] = function(o) {
  return cljs.core.list.call(null, "nil")
};
cljs.core.ISet["null"] = true;
cljs.core._disjoin["null"] = function(_, v) {
  return null
};
cljs.core.ICounted["null"] = true;
cljs.core._count["null"] = function(_) {
  return 0
};
cljs.core.IStack["null"] = true;
cljs.core._peek["null"] = function(_) {
  return null
};
cljs.core._pop["null"] = function(_) {
  return null
};
cljs.core.ISeq["null"] = true;
cljs.core._first["null"] = function(_) {
  return null
};
cljs.core._rest["null"] = function(_) {
  return cljs.core.list.call(null)
};
cljs.core.IEquiv["null"] = true;
cljs.core._equiv["null"] = function(_, o) {
  return o === null
};
cljs.core.IWithMeta["null"] = true;
cljs.core._with_meta["null"] = function(_, meta) {
  return null
};
cljs.core.IMeta["null"] = true;
cljs.core._meta["null"] = function(_) {
  return null
};
cljs.core.IIndexed["null"] = true;
cljs.core._nth["null"] = function() {
  var G__1606466 = null;
  var G__1606466__1606467 = function(_, n) {
    return null
  };
  var G__1606466__1606468 = function(_, n, not_found) {
    return not_found
  };
  G__1606466 = function(_, n, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1606466__1606467.call(this, _, n);
      case 3:
        return G__1606466__1606468.call(this, _, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606466
}();
cljs.core.IEmptyableCollection["null"] = true;
cljs.core._empty["null"] = function(_) {
  return null
};
cljs.core.IMap["null"] = true;
cljs.core._dissoc["null"] = function(_, k) {
  return null
};
Date.prototype.cljs$core$IEquiv$ = true;
Date.prototype.cljs$core$IEquiv$_equiv = function(o, other) {
  return o.toString() === other.toString()
};
cljs.core.IHash["number"] = true;
cljs.core._hash["number"] = function(o) {
  return o
};
cljs.core.IEquiv["number"] = true;
cljs.core._equiv["number"] = function(x, o) {
  return x === o
};
cljs.core.IHash["boolean"] = true;
cljs.core._hash["boolean"] = function(o) {
  return o === true ? 1 : 0
};
cljs.core.IHash["function"] = true;
cljs.core._hash["function"] = function(o) {
  return goog.getUid.call(null, o)
};
cljs.core.inc = function inc(x) {
  return x + 1
};
cljs.core.ci_reduce = function() {
  var ci_reduce = null;
  var ci_reduce__1606476 = function(cicoll, f) {
    if(cljs.core.truth_(cljs.core._EQ_.call(null, 0, cljs.core._count.call(null, cicoll)))) {
      return f.call(null)
    }else {
      var val__1606470 = cljs.core._nth.call(null, cicoll, 0);
      var n__1606471 = 1;
      while(true) {
        if(cljs.core.truth_(n__1606471 < cljs.core._count.call(null, cicoll))) {
          var G__1606480 = f.call(null, val__1606470, cljs.core._nth.call(null, cicoll, n__1606471));
          var G__1606481 = n__1606471 + 1;
          val__1606470 = G__1606480;
          n__1606471 = G__1606481;
          continue
        }else {
          return val__1606470
        }
        break
      }
    }
  };
  var ci_reduce__1606477 = function(cicoll, f, val) {
    var val__1606472 = val;
    var n__1606473 = 0;
    while(true) {
      if(cljs.core.truth_(n__1606473 < cljs.core._count.call(null, cicoll))) {
        var G__1606482 = f.call(null, val__1606472, cljs.core._nth.call(null, cicoll, n__1606473));
        var G__1606483 = n__1606473 + 1;
        val__1606472 = G__1606482;
        n__1606473 = G__1606483;
        continue
      }else {
        return val__1606472
      }
      break
    }
  };
  var ci_reduce__1606478 = function(cicoll, f, val, idx) {
    var val__1606474 = val;
    var n__1606475 = idx;
    while(true) {
      if(cljs.core.truth_(n__1606475 < cljs.core._count.call(null, cicoll))) {
        var G__1606484 = f.call(null, val__1606474, cljs.core._nth.call(null, cicoll, n__1606475));
        var G__1606485 = n__1606475 + 1;
        val__1606474 = G__1606484;
        n__1606475 = G__1606485;
        continue
      }else {
        return val__1606474
      }
      break
    }
  };
  ci_reduce = function(cicoll, f, val, idx) {
    switch(arguments.length) {
      case 2:
        return ci_reduce__1606476.call(this, cicoll, f);
      case 3:
        return ci_reduce__1606477.call(this, cicoll, f, val);
      case 4:
        return ci_reduce__1606478.call(this, cicoll, f, val, idx)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return ci_reduce
}();
cljs.core.IndexedSeq = function(a, i) {
  this.a = a;
  this.i = i
};
cljs.core.IndexedSeq.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.IndexedSeq")
};
cljs.core.IndexedSeq.prototype.cljs$core$IHash$ = true;
cljs.core.IndexedSeq.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1606486 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.IndexedSeq.prototype.cljs$core$IReduce$ = true;
cljs.core.IndexedSeq.prototype.cljs$core$IReduce$_reduce = function() {
  var G__1606499 = null;
  var G__1606499__1606500 = function(_, f) {
    var this__1606487 = this;
    return cljs.core.ci_reduce.call(null, this__1606487.a, f, this__1606487.a[this__1606487.i], this__1606487.i + 1)
  };
  var G__1606499__1606501 = function(_, f, start) {
    var this__1606488 = this;
    return cljs.core.ci_reduce.call(null, this__1606488.a, f, start, this__1606488.i)
  };
  G__1606499 = function(_, f, start) {
    switch(arguments.length) {
      case 2:
        return G__1606499__1606500.call(this, _, f);
      case 3:
        return G__1606499__1606501.call(this, _, f, start)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606499
}();
cljs.core.IndexedSeq.prototype.cljs$core$ICollection$ = true;
cljs.core.IndexedSeq.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1606489 = this;
  return cljs.core.cons.call(null, o, coll)
};
cljs.core.IndexedSeq.prototype.cljs$core$IEquiv$ = true;
cljs.core.IndexedSeq.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1606490 = this;
  return cljs.core.equiv_sequential.call(null, coll, other)
};
cljs.core.IndexedSeq.prototype.cljs$core$ISequential$ = true;
cljs.core.IndexedSeq.prototype.cljs$core$IIndexed$ = true;
cljs.core.IndexedSeq.prototype.cljs$core$IIndexed$_nth = function() {
  var G__1606503 = null;
  var G__1606503__1606504 = function(coll, n) {
    var this__1606491 = this;
    var i__1606492 = n + this__1606491.i;
    if(cljs.core.truth_(i__1606492 < this__1606491.a.length)) {
      return this__1606491.a[i__1606492]
    }else {
      return null
    }
  };
  var G__1606503__1606505 = function(coll, n, not_found) {
    var this__1606493 = this;
    var i__1606494 = n + this__1606493.i;
    if(cljs.core.truth_(i__1606494 < this__1606493.a.length)) {
      return this__1606493.a[i__1606494]
    }else {
      return not_found
    }
  };
  G__1606503 = function(coll, n, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1606503__1606504.call(this, coll, n);
      case 3:
        return G__1606503__1606505.call(this, coll, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606503
}();
cljs.core.IndexedSeq.prototype.cljs$core$ICounted$ = true;
cljs.core.IndexedSeq.prototype.cljs$core$ICounted$_count = function(_) {
  var this__1606495 = this;
  return this__1606495.a.length - this__1606495.i
};
cljs.core.IndexedSeq.prototype.cljs$core$ISeq$ = true;
cljs.core.IndexedSeq.prototype.cljs$core$ISeq$_first = function(_) {
  var this__1606496 = this;
  return this__1606496.a[this__1606496.i]
};
cljs.core.IndexedSeq.prototype.cljs$core$ISeq$_rest = function(_) {
  var this__1606497 = this;
  if(cljs.core.truth_(this__1606497.i + 1 < this__1606497.a.length)) {
    return new cljs.core.IndexedSeq(this__1606497.a, this__1606497.i + 1)
  }else {
    return cljs.core.list.call(null)
  }
};
cljs.core.IndexedSeq.prototype.cljs$core$ISeqable$ = true;
cljs.core.IndexedSeq.prototype.cljs$core$ISeqable$_seq = function(this$) {
  var this__1606498 = this;
  return this$
};
cljs.core.IndexedSeq;
cljs.core.prim_seq = function prim_seq(prim, i) {
  if(cljs.core.truth_(cljs.core._EQ_.call(null, 0, prim.length))) {
    return null
  }else {
    return new cljs.core.IndexedSeq(prim, i)
  }
};
cljs.core.array_seq = function array_seq(array, i) {
  return cljs.core.prim_seq.call(null, array, i)
};
cljs.core.IReduce["array"] = true;
cljs.core._reduce["array"] = function() {
  var G__1606507 = null;
  var G__1606507__1606508 = function(array, f) {
    return cljs.core.ci_reduce.call(null, array, f)
  };
  var G__1606507__1606509 = function(array, f, start) {
    return cljs.core.ci_reduce.call(null, array, f, start)
  };
  G__1606507 = function(array, f, start) {
    switch(arguments.length) {
      case 2:
        return G__1606507__1606508.call(this, array, f);
      case 3:
        return G__1606507__1606509.call(this, array, f, start)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606507
}();
cljs.core.ILookup["array"] = true;
cljs.core._lookup["array"] = function() {
  var G__1606511 = null;
  var G__1606511__1606512 = function(array, k) {
    return array[k]
  };
  var G__1606511__1606513 = function(array, k, not_found) {
    return cljs.core._nth.call(null, array, k, not_found)
  };
  G__1606511 = function(array, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1606511__1606512.call(this, array, k);
      case 3:
        return G__1606511__1606513.call(this, array, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606511
}();
cljs.core.IIndexed["array"] = true;
cljs.core._nth["array"] = function() {
  var G__1606515 = null;
  var G__1606515__1606516 = function(array, n) {
    if(cljs.core.truth_(n < array.length)) {
      return array[n]
    }else {
      return null
    }
  };
  var G__1606515__1606517 = function(array, n, not_found) {
    if(cljs.core.truth_(n < array.length)) {
      return array[n]
    }else {
      return not_found
    }
  };
  G__1606515 = function(array, n, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1606515__1606516.call(this, array, n);
      case 3:
        return G__1606515__1606517.call(this, array, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606515
}();
cljs.core.ICounted["array"] = true;
cljs.core._count["array"] = function(a) {
  return a.length
};
cljs.core.ISeqable["array"] = true;
cljs.core._seq["array"] = function(array) {
  return cljs.core.array_seq.call(null, array, 0)
};
cljs.core.seq = function seq(coll) {
  if(cljs.core.truth_(coll)) {
    return cljs.core._seq.call(null, coll)
  }else {
    return null
  }
};
cljs.core.first = function first(coll) {
  var temp__3698__auto____1606519 = cljs.core.seq.call(null, coll);
  if(cljs.core.truth_(temp__3698__auto____1606519)) {
    var s__1606520 = temp__3698__auto____1606519;
    return cljs.core._first.call(null, s__1606520)
  }else {
    return null
  }
};
cljs.core.rest = function rest(coll) {
  return cljs.core._rest.call(null, cljs.core.seq.call(null, coll))
};
cljs.core.next = function next(coll) {
  if(cljs.core.truth_(coll)) {
    return cljs.core.seq.call(null, cljs.core.rest.call(null, coll))
  }else {
    return null
  }
};
cljs.core.second = function second(coll) {
  return cljs.core.first.call(null, cljs.core.next.call(null, coll))
};
cljs.core.ffirst = function ffirst(coll) {
  return cljs.core.first.call(null, cljs.core.first.call(null, coll))
};
cljs.core.nfirst = function nfirst(coll) {
  return cljs.core.next.call(null, cljs.core.first.call(null, coll))
};
cljs.core.fnext = function fnext(coll) {
  return cljs.core.first.call(null, cljs.core.next.call(null, coll))
};
cljs.core.nnext = function nnext(coll) {
  return cljs.core.next.call(null, cljs.core.next.call(null, coll))
};
cljs.core.last = function last(s) {
  while(true) {
    if(cljs.core.truth_(cljs.core.next.call(null, s))) {
      var G__1606521 = cljs.core.next.call(null, s);
      s = G__1606521;
      continue
    }else {
      return cljs.core.first.call(null, s)
    }
    break
  }
};
cljs.core.ICounted["_"] = true;
cljs.core._count["_"] = function(x) {
  var s__1606522 = cljs.core.seq.call(null, x);
  var n__1606523 = 0;
  while(true) {
    if(cljs.core.truth_(s__1606522)) {
      var G__1606524 = cljs.core.next.call(null, s__1606522);
      var G__1606525 = n__1606523 + 1;
      s__1606522 = G__1606524;
      n__1606523 = G__1606525;
      continue
    }else {
      return n__1606523
    }
    break
  }
};
cljs.core.IEquiv["_"] = true;
cljs.core._equiv["_"] = function(x, o) {
  return x === o
};
cljs.core.not = function not(x) {
  if(cljs.core.truth_(x)) {
    return false
  }else {
    return true
  }
};
cljs.core.conj = function() {
  var conj = null;
  var conj__1606526 = function(coll, x) {
    return cljs.core._conj.call(null, coll, x)
  };
  var conj__1606527 = function() {
    var G__1606529__delegate = function(coll, x, xs) {
      while(true) {
        if(cljs.core.truth_(xs)) {
          var G__1606530 = conj.call(null, coll, x);
          var G__1606531 = cljs.core.first.call(null, xs);
          var G__1606532 = cljs.core.next.call(null, xs);
          coll = G__1606530;
          x = G__1606531;
          xs = G__1606532;
          continue
        }else {
          return conj.call(null, coll, x)
        }
        break
      }
    };
    var G__1606529 = function(coll, x, var_args) {
      var xs = null;
      if(goog.isDef(var_args)) {
        xs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606529__delegate.call(this, coll, x, xs)
    };
    G__1606529.cljs$lang$maxFixedArity = 2;
    G__1606529.cljs$lang$applyTo = function(arglist__1606533) {
      var coll = cljs.core.first(arglist__1606533);
      var x = cljs.core.first(cljs.core.next(arglist__1606533));
      var xs = cljs.core.rest(cljs.core.next(arglist__1606533));
      return G__1606529__delegate.call(this, coll, x, xs)
    };
    return G__1606529
  }();
  conj = function(coll, x, var_args) {
    var xs = var_args;
    switch(arguments.length) {
      case 2:
        return conj__1606526.call(this, coll, x);
      default:
        return conj__1606527.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  conj.cljs$lang$maxFixedArity = 2;
  conj.cljs$lang$applyTo = conj__1606527.cljs$lang$applyTo;
  return conj
}();
cljs.core.empty = function empty(coll) {
  return cljs.core._empty.call(null, coll)
};
cljs.core.count = function count(coll) {
  return cljs.core._count.call(null, coll)
};
cljs.core.nth = function() {
  var nth = null;
  var nth__1606534 = function(coll, n) {
    return cljs.core._nth.call(null, coll, Math.floor(n))
  };
  var nth__1606535 = function(coll, n, not_found) {
    return cljs.core._nth.call(null, coll, Math.floor(n), not_found)
  };
  nth = function(coll, n, not_found) {
    switch(arguments.length) {
      case 2:
        return nth__1606534.call(this, coll, n);
      case 3:
        return nth__1606535.call(this, coll, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return nth
}();
cljs.core.get = function() {
  var get = null;
  var get__1606537 = function(o, k) {
    return cljs.core._lookup.call(null, o, k)
  };
  var get__1606538 = function(o, k, not_found) {
    return cljs.core._lookup.call(null, o, k, not_found)
  };
  get = function(o, k, not_found) {
    switch(arguments.length) {
      case 2:
        return get__1606537.call(this, o, k);
      case 3:
        return get__1606538.call(this, o, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return get
}();
cljs.core.assoc = function() {
  var assoc = null;
  var assoc__1606541 = function(coll, k, v) {
    return cljs.core._assoc.call(null, coll, k, v)
  };
  var assoc__1606542 = function() {
    var G__1606544__delegate = function(coll, k, v, kvs) {
      while(true) {
        var ret__1606540 = assoc.call(null, coll, k, v);
        if(cljs.core.truth_(kvs)) {
          var G__1606545 = ret__1606540;
          var G__1606546 = cljs.core.first.call(null, kvs);
          var G__1606547 = cljs.core.second.call(null, kvs);
          var G__1606548 = cljs.core.nnext.call(null, kvs);
          coll = G__1606545;
          k = G__1606546;
          v = G__1606547;
          kvs = G__1606548;
          continue
        }else {
          return ret__1606540
        }
        break
      }
    };
    var G__1606544 = function(coll, k, v, var_args) {
      var kvs = null;
      if(goog.isDef(var_args)) {
        kvs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
      }
      return G__1606544__delegate.call(this, coll, k, v, kvs)
    };
    G__1606544.cljs$lang$maxFixedArity = 3;
    G__1606544.cljs$lang$applyTo = function(arglist__1606549) {
      var coll = cljs.core.first(arglist__1606549);
      var k = cljs.core.first(cljs.core.next(arglist__1606549));
      var v = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1606549)));
      var kvs = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1606549)));
      return G__1606544__delegate.call(this, coll, k, v, kvs)
    };
    return G__1606544
  }();
  assoc = function(coll, k, v, var_args) {
    var kvs = var_args;
    switch(arguments.length) {
      case 3:
        return assoc__1606541.call(this, coll, k, v);
      default:
        return assoc__1606542.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  assoc.cljs$lang$maxFixedArity = 3;
  assoc.cljs$lang$applyTo = assoc__1606542.cljs$lang$applyTo;
  return assoc
}();
cljs.core.dissoc = function() {
  var dissoc = null;
  var dissoc__1606551 = function(coll) {
    return coll
  };
  var dissoc__1606552 = function(coll, k) {
    return cljs.core._dissoc.call(null, coll, k)
  };
  var dissoc__1606553 = function() {
    var G__1606555__delegate = function(coll, k, ks) {
      while(true) {
        var ret__1606550 = dissoc.call(null, coll, k);
        if(cljs.core.truth_(ks)) {
          var G__1606556 = ret__1606550;
          var G__1606557 = cljs.core.first.call(null, ks);
          var G__1606558 = cljs.core.next.call(null, ks);
          coll = G__1606556;
          k = G__1606557;
          ks = G__1606558;
          continue
        }else {
          return ret__1606550
        }
        break
      }
    };
    var G__1606555 = function(coll, k, var_args) {
      var ks = null;
      if(goog.isDef(var_args)) {
        ks = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606555__delegate.call(this, coll, k, ks)
    };
    G__1606555.cljs$lang$maxFixedArity = 2;
    G__1606555.cljs$lang$applyTo = function(arglist__1606559) {
      var coll = cljs.core.first(arglist__1606559);
      var k = cljs.core.first(cljs.core.next(arglist__1606559));
      var ks = cljs.core.rest(cljs.core.next(arglist__1606559));
      return G__1606555__delegate.call(this, coll, k, ks)
    };
    return G__1606555
  }();
  dissoc = function(coll, k, var_args) {
    var ks = var_args;
    switch(arguments.length) {
      case 1:
        return dissoc__1606551.call(this, coll);
      case 2:
        return dissoc__1606552.call(this, coll, k);
      default:
        return dissoc__1606553.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  dissoc.cljs$lang$maxFixedArity = 2;
  dissoc.cljs$lang$applyTo = dissoc__1606553.cljs$lang$applyTo;
  return dissoc
}();
cljs.core.with_meta = function with_meta(o, meta) {
  return cljs.core._with_meta.call(null, o, meta)
};
cljs.core.meta = function meta(o) {
  if(cljs.core.truth_(function() {
    var x__451__auto____1606560 = o;
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606561 = x__451__auto____1606560;
      if(cljs.core.truth_(and__3546__auto____1606561)) {
        var and__3546__auto____1606562 = x__451__auto____1606560.cljs$core$IMeta$;
        if(cljs.core.truth_(and__3546__auto____1606562)) {
          return cljs.core.not.call(null, x__451__auto____1606560.hasOwnProperty("cljs$core$IMeta$"))
        }else {
          return and__3546__auto____1606562
        }
      }else {
        return and__3546__auto____1606561
      }
    }())) {
      return true
    }else {
      return cljs.core.type_satisfies_.call(null, cljs.core.IMeta, x__451__auto____1606560)
    }
  }())) {
    return cljs.core._meta.call(null, o)
  }else {
    return null
  }
};
cljs.core.peek = function peek(coll) {
  return cljs.core._peek.call(null, coll)
};
cljs.core.pop = function pop(coll) {
  return cljs.core._pop.call(null, coll)
};
cljs.core.disj = function() {
  var disj = null;
  var disj__1606564 = function(coll) {
    return coll
  };
  var disj__1606565 = function(coll, k) {
    return cljs.core._disjoin.call(null, coll, k)
  };
  var disj__1606566 = function() {
    var G__1606568__delegate = function(coll, k, ks) {
      while(true) {
        var ret__1606563 = disj.call(null, coll, k);
        if(cljs.core.truth_(ks)) {
          var G__1606569 = ret__1606563;
          var G__1606570 = cljs.core.first.call(null, ks);
          var G__1606571 = cljs.core.next.call(null, ks);
          coll = G__1606569;
          k = G__1606570;
          ks = G__1606571;
          continue
        }else {
          return ret__1606563
        }
        break
      }
    };
    var G__1606568 = function(coll, k, var_args) {
      var ks = null;
      if(goog.isDef(var_args)) {
        ks = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606568__delegate.call(this, coll, k, ks)
    };
    G__1606568.cljs$lang$maxFixedArity = 2;
    G__1606568.cljs$lang$applyTo = function(arglist__1606572) {
      var coll = cljs.core.first(arglist__1606572);
      var k = cljs.core.first(cljs.core.next(arglist__1606572));
      var ks = cljs.core.rest(cljs.core.next(arglist__1606572));
      return G__1606568__delegate.call(this, coll, k, ks)
    };
    return G__1606568
  }();
  disj = function(coll, k, var_args) {
    var ks = var_args;
    switch(arguments.length) {
      case 1:
        return disj__1606564.call(this, coll);
      case 2:
        return disj__1606565.call(this, coll, k);
      default:
        return disj__1606566.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  disj.cljs$lang$maxFixedArity = 2;
  disj.cljs$lang$applyTo = disj__1606566.cljs$lang$applyTo;
  return disj
}();
cljs.core.hash = function hash(o) {
  return cljs.core._hash.call(null, o)
};
cljs.core.empty_QMARK_ = function empty_QMARK_(coll) {
  return cljs.core.not.call(null, cljs.core.seq.call(null, coll))
};
cljs.core.coll_QMARK_ = function coll_QMARK_(x) {
  if(cljs.core.truth_(x === null)) {
    return false
  }else {
    var x__451__auto____1606573 = x;
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606574 = x__451__auto____1606573;
      if(cljs.core.truth_(and__3546__auto____1606574)) {
        var and__3546__auto____1606575 = x__451__auto____1606573.cljs$core$ICollection$;
        if(cljs.core.truth_(and__3546__auto____1606575)) {
          return cljs.core.not.call(null, x__451__auto____1606573.hasOwnProperty("cljs$core$ICollection$"))
        }else {
          return and__3546__auto____1606575
        }
      }else {
        return and__3546__auto____1606574
      }
    }())) {
      return true
    }else {
      return cljs.core.type_satisfies_.call(null, cljs.core.ICollection, x__451__auto____1606573)
    }
  }
};
cljs.core.set_QMARK_ = function set_QMARK_(x) {
  if(cljs.core.truth_(x === null)) {
    return false
  }else {
    var x__451__auto____1606576 = x;
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606577 = x__451__auto____1606576;
      if(cljs.core.truth_(and__3546__auto____1606577)) {
        var and__3546__auto____1606578 = x__451__auto____1606576.cljs$core$ISet$;
        if(cljs.core.truth_(and__3546__auto____1606578)) {
          return cljs.core.not.call(null, x__451__auto____1606576.hasOwnProperty("cljs$core$ISet$"))
        }else {
          return and__3546__auto____1606578
        }
      }else {
        return and__3546__auto____1606577
      }
    }())) {
      return true
    }else {
      return cljs.core.type_satisfies_.call(null, cljs.core.ISet, x__451__auto____1606576)
    }
  }
};
cljs.core.associative_QMARK_ = function associative_QMARK_(x) {
  var x__451__auto____1606579 = x;
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606580 = x__451__auto____1606579;
    if(cljs.core.truth_(and__3546__auto____1606580)) {
      var and__3546__auto____1606581 = x__451__auto____1606579.cljs$core$IAssociative$;
      if(cljs.core.truth_(and__3546__auto____1606581)) {
        return cljs.core.not.call(null, x__451__auto____1606579.hasOwnProperty("cljs$core$IAssociative$"))
      }else {
        return and__3546__auto____1606581
      }
    }else {
      return and__3546__auto____1606580
    }
  }())) {
    return true
  }else {
    return cljs.core.type_satisfies_.call(null, cljs.core.IAssociative, x__451__auto____1606579)
  }
};
cljs.core.sequential_QMARK_ = function sequential_QMARK_(x) {
  var x__451__auto____1606582 = x;
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606583 = x__451__auto____1606582;
    if(cljs.core.truth_(and__3546__auto____1606583)) {
      var and__3546__auto____1606584 = x__451__auto____1606582.cljs$core$ISequential$;
      if(cljs.core.truth_(and__3546__auto____1606584)) {
        return cljs.core.not.call(null, x__451__auto____1606582.hasOwnProperty("cljs$core$ISequential$"))
      }else {
        return and__3546__auto____1606584
      }
    }else {
      return and__3546__auto____1606583
    }
  }())) {
    return true
  }else {
    return cljs.core.type_satisfies_.call(null, cljs.core.ISequential, x__451__auto____1606582)
  }
};
cljs.core.counted_QMARK_ = function counted_QMARK_(x) {
  var x__451__auto____1606585 = x;
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606586 = x__451__auto____1606585;
    if(cljs.core.truth_(and__3546__auto____1606586)) {
      var and__3546__auto____1606587 = x__451__auto____1606585.cljs$core$ICounted$;
      if(cljs.core.truth_(and__3546__auto____1606587)) {
        return cljs.core.not.call(null, x__451__auto____1606585.hasOwnProperty("cljs$core$ICounted$"))
      }else {
        return and__3546__auto____1606587
      }
    }else {
      return and__3546__auto____1606586
    }
  }())) {
    return true
  }else {
    return cljs.core.type_satisfies_.call(null, cljs.core.ICounted, x__451__auto____1606585)
  }
};
cljs.core.map_QMARK_ = function map_QMARK_(x) {
  if(cljs.core.truth_(x === null)) {
    return false
  }else {
    var x__451__auto____1606588 = x;
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606589 = x__451__auto____1606588;
      if(cljs.core.truth_(and__3546__auto____1606589)) {
        var and__3546__auto____1606590 = x__451__auto____1606588.cljs$core$IMap$;
        if(cljs.core.truth_(and__3546__auto____1606590)) {
          return cljs.core.not.call(null, x__451__auto____1606588.hasOwnProperty("cljs$core$IMap$"))
        }else {
          return and__3546__auto____1606590
        }
      }else {
        return and__3546__auto____1606589
      }
    }())) {
      return true
    }else {
      return cljs.core.type_satisfies_.call(null, cljs.core.IMap, x__451__auto____1606588)
    }
  }
};
cljs.core.vector_QMARK_ = function vector_QMARK_(x) {
  var x__451__auto____1606591 = x;
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606592 = x__451__auto____1606591;
    if(cljs.core.truth_(and__3546__auto____1606592)) {
      var and__3546__auto____1606593 = x__451__auto____1606591.cljs$core$IVector$;
      if(cljs.core.truth_(and__3546__auto____1606593)) {
        return cljs.core.not.call(null, x__451__auto____1606591.hasOwnProperty("cljs$core$IVector$"))
      }else {
        return and__3546__auto____1606593
      }
    }else {
      return and__3546__auto____1606592
    }
  }())) {
    return true
  }else {
    return cljs.core.type_satisfies_.call(null, cljs.core.IVector, x__451__auto____1606591)
  }
};
cljs.core.js_obj = function js_obj() {
  return{}
};
cljs.core.js_keys = function js_keys(obj) {
  var keys__1606594 = [];
  goog.object.forEach.call(null, obj, function(val, key, obj) {
    return keys__1606594.push(key)
  });
  return keys__1606594
};
cljs.core.js_delete = function js_delete(obj, key) {
  return delete obj[key]
};
cljs.core.lookup_sentinel = cljs.core.js_obj.call(null);
cljs.core.false_QMARK_ = function false_QMARK_(x) {
  return x === false
};
cljs.core.true_QMARK_ = function true_QMARK_(x) {
  return x === true
};
cljs.core.undefined_QMARK_ = function undefined_QMARK_(x) {
  return void 0 === x
};
cljs.core.instance_QMARK_ = function instance_QMARK_(t, o) {
  return o != null && (o instanceof t || o.constructor === t || t === Object)
};
cljs.core.seq_QMARK_ = function seq_QMARK_(s) {
  if(cljs.core.truth_(s === null)) {
    return false
  }else {
    var x__451__auto____1606595 = s;
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606596 = x__451__auto____1606595;
      if(cljs.core.truth_(and__3546__auto____1606596)) {
        var and__3546__auto____1606597 = x__451__auto____1606595.cljs$core$ISeq$;
        if(cljs.core.truth_(and__3546__auto____1606597)) {
          return cljs.core.not.call(null, x__451__auto____1606595.hasOwnProperty("cljs$core$ISeq$"))
        }else {
          return and__3546__auto____1606597
        }
      }else {
        return and__3546__auto____1606596
      }
    }())) {
      return true
    }else {
      return cljs.core.type_satisfies_.call(null, cljs.core.ISeq, x__451__auto____1606595)
    }
  }
};
cljs.core.boolean$ = function boolean$(x) {
  if(cljs.core.truth_(x)) {
    return true
  }else {
    return false
  }
};
cljs.core.string_QMARK_ = function string_QMARK_(x) {
  var and__3546__auto____1606598 = goog.isString.call(null, x);
  if(cljs.core.truth_(and__3546__auto____1606598)) {
    return cljs.core.not.call(null, function() {
      var or__3548__auto____1606599 = cljs.core._EQ_.call(null, x.charAt(0), "\ufdd0");
      if(cljs.core.truth_(or__3548__auto____1606599)) {
        return or__3548__auto____1606599
      }else {
        return cljs.core._EQ_.call(null, x.charAt(0), "\ufdd1")
      }
    }())
  }else {
    return and__3546__auto____1606598
  }
};
cljs.core.keyword_QMARK_ = function keyword_QMARK_(x) {
  var and__3546__auto____1606600 = goog.isString.call(null, x);
  if(cljs.core.truth_(and__3546__auto____1606600)) {
    return cljs.core._EQ_.call(null, x.charAt(0), "\ufdd0")
  }else {
    return and__3546__auto____1606600
  }
};
cljs.core.symbol_QMARK_ = function symbol_QMARK_(x) {
  var and__3546__auto____1606601 = goog.isString.call(null, x);
  if(cljs.core.truth_(and__3546__auto____1606601)) {
    return cljs.core._EQ_.call(null, x.charAt(0), "\ufdd1")
  }else {
    return and__3546__auto____1606601
  }
};
cljs.core.number_QMARK_ = function number_QMARK_(n) {
  return goog.isNumber.call(null, n)
};
cljs.core.fn_QMARK_ = function fn_QMARK_(f) {
  return goog.isFunction.call(null, f)
};
cljs.core.integer_QMARK_ = function integer_QMARK_(n) {
  var and__3546__auto____1606602 = cljs.core.number_QMARK_.call(null, n);
  if(cljs.core.truth_(and__3546__auto____1606602)) {
    return n == n.toFixed()
  }else {
    return and__3546__auto____1606602
  }
};
cljs.core.contains_QMARK_ = function contains_QMARK_(coll, v) {
  if(cljs.core.truth_(cljs.core._lookup.call(null, coll, v, cljs.core.lookup_sentinel) === cljs.core.lookup_sentinel)) {
    return false
  }else {
    return true
  }
};
cljs.core.find = function find(coll, k) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606603 = coll;
    if(cljs.core.truth_(and__3546__auto____1606603)) {
      var and__3546__auto____1606604 = cljs.core.associative_QMARK_.call(null, coll);
      if(cljs.core.truth_(and__3546__auto____1606604)) {
        return cljs.core.contains_QMARK_.call(null, coll, k)
      }else {
        return and__3546__auto____1606604
      }
    }else {
      return and__3546__auto____1606603
    }
  }())) {
    return cljs.core.PersistentVector.fromArray([k, cljs.core._lookup.call(null, coll, k)])
  }else {
    return null
  }
};
cljs.core.distinct_QMARK_ = function() {
  var distinct_QMARK_ = null;
  var distinct_QMARK___1606609 = function(x) {
    return true
  };
  var distinct_QMARK___1606610 = function(x, y) {
    return cljs.core.not.call(null, cljs.core._EQ_.call(null, x, y))
  };
  var distinct_QMARK___1606611 = function() {
    var G__1606613__delegate = function(x, y, more) {
      if(cljs.core.truth_(cljs.core.not.call(null, cljs.core._EQ_.call(null, x, y)))) {
        var s__1606605 = cljs.core.set([y, x]);
        var xs__1606606 = more;
        while(true) {
          var x__1606607 = cljs.core.first.call(null, xs__1606606);
          var etc__1606608 = cljs.core.next.call(null, xs__1606606);
          if(cljs.core.truth_(xs__1606606)) {
            if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, s__1606605, x__1606607))) {
              return false
            }else {
              var G__1606614 = cljs.core.conj.call(null, s__1606605, x__1606607);
              var G__1606615 = etc__1606608;
              s__1606605 = G__1606614;
              xs__1606606 = G__1606615;
              continue
            }
          }else {
            return true
          }
          break
        }
      }else {
        return false
      }
    };
    var G__1606613 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606613__delegate.call(this, x, y, more)
    };
    G__1606613.cljs$lang$maxFixedArity = 2;
    G__1606613.cljs$lang$applyTo = function(arglist__1606616) {
      var x = cljs.core.first(arglist__1606616);
      var y = cljs.core.first(cljs.core.next(arglist__1606616));
      var more = cljs.core.rest(cljs.core.next(arglist__1606616));
      return G__1606613__delegate.call(this, x, y, more)
    };
    return G__1606613
  }();
  distinct_QMARK_ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return distinct_QMARK___1606609.call(this, x);
      case 2:
        return distinct_QMARK___1606610.call(this, x, y);
      default:
        return distinct_QMARK___1606611.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  distinct_QMARK_.cljs$lang$maxFixedArity = 2;
  distinct_QMARK_.cljs$lang$applyTo = distinct_QMARK___1606611.cljs$lang$applyTo;
  return distinct_QMARK_
}();
cljs.core.compare = function compare(x, y) {
  return goog.array.defaultCompare.call(null, x, y)
};
cljs.core.fn__GT_comparator = function fn__GT_comparator(f) {
  if(cljs.core.truth_(cljs.core._EQ_.call(null, f, cljs.core.compare))) {
    return cljs.core.compare
  }else {
    return function(x, y) {
      var r__1606617 = f.call(null, x, y);
      if(cljs.core.truth_(cljs.core.number_QMARK_.call(null, r__1606617))) {
        return r__1606617
      }else {
        if(cljs.core.truth_(r__1606617)) {
          return-1
        }else {
          if(cljs.core.truth_(f.call(null, y, x))) {
            return 1
          }else {
            return 0
          }
        }
      }
    }
  }
};
cljs.core.sort = function() {
  var sort = null;
  var sort__1606619 = function(coll) {
    return sort.call(null, cljs.core.compare, coll)
  };
  var sort__1606620 = function(comp, coll) {
    if(cljs.core.truth_(cljs.core.seq.call(null, coll))) {
      var a__1606618 = cljs.core.to_array.call(null, coll);
      goog.array.stableSort.call(null, a__1606618, cljs.core.fn__GT_comparator.call(null, comp));
      return cljs.core.seq.call(null, a__1606618)
    }else {
      return cljs.core.List.EMPTY
    }
  };
  sort = function(comp, coll) {
    switch(arguments.length) {
      case 1:
        return sort__1606619.call(this, comp);
      case 2:
        return sort__1606620.call(this, comp, coll)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return sort
}();
cljs.core.sort_by = function() {
  var sort_by = null;
  var sort_by__1606622 = function(keyfn, coll) {
    return sort_by.call(null, keyfn, cljs.core.compare, coll)
  };
  var sort_by__1606623 = function(keyfn, comp, coll) {
    return cljs.core.sort.call(null, function(x, y) {
      return cljs.core.fn__GT_comparator.call(null, comp).call(null, keyfn.call(null, x), keyfn.call(null, y))
    }, coll)
  };
  sort_by = function(keyfn, comp, coll) {
    switch(arguments.length) {
      case 2:
        return sort_by__1606622.call(this, keyfn, comp);
      case 3:
        return sort_by__1606623.call(this, keyfn, comp, coll)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return sort_by
}();
cljs.core.reduce = function() {
  var reduce = null;
  var reduce__1606625 = function(f, coll) {
    return cljs.core._reduce.call(null, coll, f)
  };
  var reduce__1606626 = function(f, val, coll) {
    return cljs.core._reduce.call(null, coll, f, val)
  };
  reduce = function(f, val, coll) {
    switch(arguments.length) {
      case 2:
        return reduce__1606625.call(this, f, val);
      case 3:
        return reduce__1606626.call(this, f, val, coll)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return reduce
}();
cljs.core.seq_reduce = function() {
  var seq_reduce = null;
  var seq_reduce__1606632 = function(f, coll) {
    var temp__3695__auto____1606628 = cljs.core.seq.call(null, coll);
    if(cljs.core.truth_(temp__3695__auto____1606628)) {
      var s__1606629 = temp__3695__auto____1606628;
      return cljs.core.reduce.call(null, f, cljs.core.first.call(null, s__1606629), cljs.core.next.call(null, s__1606629))
    }else {
      return f.call(null)
    }
  };
  var seq_reduce__1606633 = function(f, val, coll) {
    var val__1606630 = val;
    var coll__1606631 = cljs.core.seq.call(null, coll);
    while(true) {
      if(cljs.core.truth_(coll__1606631)) {
        var G__1606635 = f.call(null, val__1606630, cljs.core.first.call(null, coll__1606631));
        var G__1606636 = cljs.core.next.call(null, coll__1606631);
        val__1606630 = G__1606635;
        coll__1606631 = G__1606636;
        continue
      }else {
        return val__1606630
      }
      break
    }
  };
  seq_reduce = function(f, val, coll) {
    switch(arguments.length) {
      case 2:
        return seq_reduce__1606632.call(this, f, val);
      case 3:
        return seq_reduce__1606633.call(this, f, val, coll)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return seq_reduce
}();
cljs.core.IReduce["_"] = true;
cljs.core._reduce["_"] = function() {
  var G__1606637 = null;
  var G__1606637__1606638 = function(coll, f) {
    return cljs.core.seq_reduce.call(null, f, coll)
  };
  var G__1606637__1606639 = function(coll, f, start) {
    return cljs.core.seq_reduce.call(null, f, start, coll)
  };
  G__1606637 = function(coll, f, start) {
    switch(arguments.length) {
      case 2:
        return G__1606637__1606638.call(this, coll, f);
      case 3:
        return G__1606637__1606639.call(this, coll, f, start)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606637
}();
cljs.core._PLUS_ = function() {
  var _PLUS_ = null;
  var _PLUS___1606641 = function() {
    return 0
  };
  var _PLUS___1606642 = function(x) {
    return x
  };
  var _PLUS___1606643 = function(x, y) {
    return x + y
  };
  var _PLUS___1606644 = function() {
    var G__1606646__delegate = function(x, y, more) {
      return cljs.core.reduce.call(null, _PLUS_, x + y, more)
    };
    var G__1606646 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606646__delegate.call(this, x, y, more)
    };
    G__1606646.cljs$lang$maxFixedArity = 2;
    G__1606646.cljs$lang$applyTo = function(arglist__1606647) {
      var x = cljs.core.first(arglist__1606647);
      var y = cljs.core.first(cljs.core.next(arglist__1606647));
      var more = cljs.core.rest(cljs.core.next(arglist__1606647));
      return G__1606646__delegate.call(this, x, y, more)
    };
    return G__1606646
  }();
  _PLUS_ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 0:
        return _PLUS___1606641.call(this);
      case 1:
        return _PLUS___1606642.call(this, x);
      case 2:
        return _PLUS___1606643.call(this, x, y);
      default:
        return _PLUS___1606644.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  _PLUS_.cljs$lang$maxFixedArity = 2;
  _PLUS_.cljs$lang$applyTo = _PLUS___1606644.cljs$lang$applyTo;
  return _PLUS_
}();
cljs.core._ = function() {
  var _ = null;
  var ___1606648 = function(x) {
    return-x
  };
  var ___1606649 = function(x, y) {
    return x - y
  };
  var ___1606650 = function() {
    var G__1606652__delegate = function(x, y, more) {
      return cljs.core.reduce.call(null, _, x - y, more)
    };
    var G__1606652 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606652__delegate.call(this, x, y, more)
    };
    G__1606652.cljs$lang$maxFixedArity = 2;
    G__1606652.cljs$lang$applyTo = function(arglist__1606653) {
      var x = cljs.core.first(arglist__1606653);
      var y = cljs.core.first(cljs.core.next(arglist__1606653));
      var more = cljs.core.rest(cljs.core.next(arglist__1606653));
      return G__1606652__delegate.call(this, x, y, more)
    };
    return G__1606652
  }();
  _ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return ___1606648.call(this, x);
      case 2:
        return ___1606649.call(this, x, y);
      default:
        return ___1606650.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  _.cljs$lang$maxFixedArity = 2;
  _.cljs$lang$applyTo = ___1606650.cljs$lang$applyTo;
  return _
}();
cljs.core._STAR_ = function() {
  var _STAR_ = null;
  var _STAR___1606654 = function() {
    return 1
  };
  var _STAR___1606655 = function(x) {
    return x
  };
  var _STAR___1606656 = function(x, y) {
    return x * y
  };
  var _STAR___1606657 = function() {
    var G__1606659__delegate = function(x, y, more) {
      return cljs.core.reduce.call(null, _STAR_, x * y, more)
    };
    var G__1606659 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606659__delegate.call(this, x, y, more)
    };
    G__1606659.cljs$lang$maxFixedArity = 2;
    G__1606659.cljs$lang$applyTo = function(arglist__1606660) {
      var x = cljs.core.first(arglist__1606660);
      var y = cljs.core.first(cljs.core.next(arglist__1606660));
      var more = cljs.core.rest(cljs.core.next(arglist__1606660));
      return G__1606659__delegate.call(this, x, y, more)
    };
    return G__1606659
  }();
  _STAR_ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 0:
        return _STAR___1606654.call(this);
      case 1:
        return _STAR___1606655.call(this, x);
      case 2:
        return _STAR___1606656.call(this, x, y);
      default:
        return _STAR___1606657.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  _STAR_.cljs$lang$maxFixedArity = 2;
  _STAR_.cljs$lang$applyTo = _STAR___1606657.cljs$lang$applyTo;
  return _STAR_
}();
cljs.core._SLASH_ = function() {
  var _SLASH_ = null;
  var _SLASH___1606661 = function(x) {
    return _SLASH_.call(null, 1, x)
  };
  var _SLASH___1606662 = function(x, y) {
    return x / y
  };
  var _SLASH___1606663 = function() {
    var G__1606665__delegate = function(x, y, more) {
      return cljs.core.reduce.call(null, _SLASH_, _SLASH_.call(null, x, y), more)
    };
    var G__1606665 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606665__delegate.call(this, x, y, more)
    };
    G__1606665.cljs$lang$maxFixedArity = 2;
    G__1606665.cljs$lang$applyTo = function(arglist__1606666) {
      var x = cljs.core.first(arglist__1606666);
      var y = cljs.core.first(cljs.core.next(arglist__1606666));
      var more = cljs.core.rest(cljs.core.next(arglist__1606666));
      return G__1606665__delegate.call(this, x, y, more)
    };
    return G__1606665
  }();
  _SLASH_ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return _SLASH___1606661.call(this, x);
      case 2:
        return _SLASH___1606662.call(this, x, y);
      default:
        return _SLASH___1606663.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  _SLASH_.cljs$lang$maxFixedArity = 2;
  _SLASH_.cljs$lang$applyTo = _SLASH___1606663.cljs$lang$applyTo;
  return _SLASH_
}();
cljs.core._LT_ = function() {
  var _LT_ = null;
  var _LT___1606667 = function(x) {
    return true
  };
  var _LT___1606668 = function(x, y) {
    return x < y
  };
  var _LT___1606669 = function() {
    var G__1606671__delegate = function(x, y, more) {
      while(true) {
        if(cljs.core.truth_(x < y)) {
          if(cljs.core.truth_(cljs.core.next.call(null, more))) {
            var G__1606672 = y;
            var G__1606673 = cljs.core.first.call(null, more);
            var G__1606674 = cljs.core.next.call(null, more);
            x = G__1606672;
            y = G__1606673;
            more = G__1606674;
            continue
          }else {
            return y < cljs.core.first.call(null, more)
          }
        }else {
          return false
        }
        break
      }
    };
    var G__1606671 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606671__delegate.call(this, x, y, more)
    };
    G__1606671.cljs$lang$maxFixedArity = 2;
    G__1606671.cljs$lang$applyTo = function(arglist__1606675) {
      var x = cljs.core.first(arglist__1606675);
      var y = cljs.core.first(cljs.core.next(arglist__1606675));
      var more = cljs.core.rest(cljs.core.next(arglist__1606675));
      return G__1606671__delegate.call(this, x, y, more)
    };
    return G__1606671
  }();
  _LT_ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return _LT___1606667.call(this, x);
      case 2:
        return _LT___1606668.call(this, x, y);
      default:
        return _LT___1606669.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  _LT_.cljs$lang$maxFixedArity = 2;
  _LT_.cljs$lang$applyTo = _LT___1606669.cljs$lang$applyTo;
  return _LT_
}();
cljs.core._LT__EQ_ = function() {
  var _LT__EQ_ = null;
  var _LT__EQ___1606676 = function(x) {
    return true
  };
  var _LT__EQ___1606677 = function(x, y) {
    return x <= y
  };
  var _LT__EQ___1606678 = function() {
    var G__1606680__delegate = function(x, y, more) {
      while(true) {
        if(cljs.core.truth_(x <= y)) {
          if(cljs.core.truth_(cljs.core.next.call(null, more))) {
            var G__1606681 = y;
            var G__1606682 = cljs.core.first.call(null, more);
            var G__1606683 = cljs.core.next.call(null, more);
            x = G__1606681;
            y = G__1606682;
            more = G__1606683;
            continue
          }else {
            return y <= cljs.core.first.call(null, more)
          }
        }else {
          return false
        }
        break
      }
    };
    var G__1606680 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606680__delegate.call(this, x, y, more)
    };
    G__1606680.cljs$lang$maxFixedArity = 2;
    G__1606680.cljs$lang$applyTo = function(arglist__1606684) {
      var x = cljs.core.first(arglist__1606684);
      var y = cljs.core.first(cljs.core.next(arglist__1606684));
      var more = cljs.core.rest(cljs.core.next(arglist__1606684));
      return G__1606680__delegate.call(this, x, y, more)
    };
    return G__1606680
  }();
  _LT__EQ_ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return _LT__EQ___1606676.call(this, x);
      case 2:
        return _LT__EQ___1606677.call(this, x, y);
      default:
        return _LT__EQ___1606678.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  _LT__EQ_.cljs$lang$maxFixedArity = 2;
  _LT__EQ_.cljs$lang$applyTo = _LT__EQ___1606678.cljs$lang$applyTo;
  return _LT__EQ_
}();
cljs.core._GT_ = function() {
  var _GT_ = null;
  var _GT___1606685 = function(x) {
    return true
  };
  var _GT___1606686 = function(x, y) {
    return x > y
  };
  var _GT___1606687 = function() {
    var G__1606689__delegate = function(x, y, more) {
      while(true) {
        if(cljs.core.truth_(x > y)) {
          if(cljs.core.truth_(cljs.core.next.call(null, more))) {
            var G__1606690 = y;
            var G__1606691 = cljs.core.first.call(null, more);
            var G__1606692 = cljs.core.next.call(null, more);
            x = G__1606690;
            y = G__1606691;
            more = G__1606692;
            continue
          }else {
            return y > cljs.core.first.call(null, more)
          }
        }else {
          return false
        }
        break
      }
    };
    var G__1606689 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606689__delegate.call(this, x, y, more)
    };
    G__1606689.cljs$lang$maxFixedArity = 2;
    G__1606689.cljs$lang$applyTo = function(arglist__1606693) {
      var x = cljs.core.first(arglist__1606693);
      var y = cljs.core.first(cljs.core.next(arglist__1606693));
      var more = cljs.core.rest(cljs.core.next(arglist__1606693));
      return G__1606689__delegate.call(this, x, y, more)
    };
    return G__1606689
  }();
  _GT_ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return _GT___1606685.call(this, x);
      case 2:
        return _GT___1606686.call(this, x, y);
      default:
        return _GT___1606687.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  _GT_.cljs$lang$maxFixedArity = 2;
  _GT_.cljs$lang$applyTo = _GT___1606687.cljs$lang$applyTo;
  return _GT_
}();
cljs.core._GT__EQ_ = function() {
  var _GT__EQ_ = null;
  var _GT__EQ___1606694 = function(x) {
    return true
  };
  var _GT__EQ___1606695 = function(x, y) {
    return x >= y
  };
  var _GT__EQ___1606696 = function() {
    var G__1606698__delegate = function(x, y, more) {
      while(true) {
        if(cljs.core.truth_(x >= y)) {
          if(cljs.core.truth_(cljs.core.next.call(null, more))) {
            var G__1606699 = y;
            var G__1606700 = cljs.core.first.call(null, more);
            var G__1606701 = cljs.core.next.call(null, more);
            x = G__1606699;
            y = G__1606700;
            more = G__1606701;
            continue
          }else {
            return y >= cljs.core.first.call(null, more)
          }
        }else {
          return false
        }
        break
      }
    };
    var G__1606698 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606698__delegate.call(this, x, y, more)
    };
    G__1606698.cljs$lang$maxFixedArity = 2;
    G__1606698.cljs$lang$applyTo = function(arglist__1606702) {
      var x = cljs.core.first(arglist__1606702);
      var y = cljs.core.first(cljs.core.next(arglist__1606702));
      var more = cljs.core.rest(cljs.core.next(arglist__1606702));
      return G__1606698__delegate.call(this, x, y, more)
    };
    return G__1606698
  }();
  _GT__EQ_ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return _GT__EQ___1606694.call(this, x);
      case 2:
        return _GT__EQ___1606695.call(this, x, y);
      default:
        return _GT__EQ___1606696.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  _GT__EQ_.cljs$lang$maxFixedArity = 2;
  _GT__EQ_.cljs$lang$applyTo = _GT__EQ___1606696.cljs$lang$applyTo;
  return _GT__EQ_
}();
cljs.core.dec = function dec(x) {
  return x - 1
};
cljs.core.max = function() {
  var max = null;
  var max__1606703 = function(x) {
    return x
  };
  var max__1606704 = function(x, y) {
    return x > y ? x : y
  };
  var max__1606705 = function() {
    var G__1606707__delegate = function(x, y, more) {
      return cljs.core.reduce.call(null, max, x > y ? x : y, more)
    };
    var G__1606707 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606707__delegate.call(this, x, y, more)
    };
    G__1606707.cljs$lang$maxFixedArity = 2;
    G__1606707.cljs$lang$applyTo = function(arglist__1606708) {
      var x = cljs.core.first(arglist__1606708);
      var y = cljs.core.first(cljs.core.next(arglist__1606708));
      var more = cljs.core.rest(cljs.core.next(arglist__1606708));
      return G__1606707__delegate.call(this, x, y, more)
    };
    return G__1606707
  }();
  max = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return max__1606703.call(this, x);
      case 2:
        return max__1606704.call(this, x, y);
      default:
        return max__1606705.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  max.cljs$lang$maxFixedArity = 2;
  max.cljs$lang$applyTo = max__1606705.cljs$lang$applyTo;
  return max
}();
cljs.core.min = function() {
  var min = null;
  var min__1606709 = function(x) {
    return x
  };
  var min__1606710 = function(x, y) {
    return x < y ? x : y
  };
  var min__1606711 = function() {
    var G__1606713__delegate = function(x, y, more) {
      return cljs.core.reduce.call(null, min, x < y ? x : y, more)
    };
    var G__1606713 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606713__delegate.call(this, x, y, more)
    };
    G__1606713.cljs$lang$maxFixedArity = 2;
    G__1606713.cljs$lang$applyTo = function(arglist__1606714) {
      var x = cljs.core.first(arglist__1606714);
      var y = cljs.core.first(cljs.core.next(arglist__1606714));
      var more = cljs.core.rest(cljs.core.next(arglist__1606714));
      return G__1606713__delegate.call(this, x, y, more)
    };
    return G__1606713
  }();
  min = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return min__1606709.call(this, x);
      case 2:
        return min__1606710.call(this, x, y);
      default:
        return min__1606711.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  min.cljs$lang$maxFixedArity = 2;
  min.cljs$lang$applyTo = min__1606711.cljs$lang$applyTo;
  return min
}();
cljs.core.fix = function fix(q) {
  if(cljs.core.truth_(q >= 0)) {
    return Math.floor.call(null, q)
  }else {
    return Math.ceil.call(null, q)
  }
};
cljs.core.mod = function mod(n, d) {
  return n % d
};
cljs.core.quot = function quot(n, d) {
  var rem__1606715 = n % d;
  return cljs.core.fix.call(null, (n - rem__1606715) / d)
};
cljs.core.rem = function rem(n, d) {
  var q__1606716 = cljs.core.quot.call(null, n, d);
  return n - d * q__1606716
};
cljs.core.rand = function() {
  var rand = null;
  var rand__1606717 = function() {
    return Math.random.call(null)
  };
  var rand__1606718 = function(n) {
    return n * rand.call(null)
  };
  rand = function(n) {
    switch(arguments.length) {
      case 0:
        return rand__1606717.call(this);
      case 1:
        return rand__1606718.call(this, n)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return rand
}();
cljs.core.rand_int = function rand_int(n) {
  return cljs.core.fix.call(null, cljs.core.rand.call(null, n))
};
cljs.core.bit_xor = function bit_xor(x, y) {
  return x ^ y
};
cljs.core.bit_and = function bit_and(x, y) {
  return x & y
};
cljs.core.bit_or = function bit_or(x, y) {
  return x | y
};
cljs.core.bit_and_not = function bit_and_not(x, y) {
  return x & ~y
};
cljs.core.bit_clear = function bit_clear(x, n) {
  return x & ~(1 << n)
};
cljs.core.bit_flip = function bit_flip(x, n) {
  return x ^ 1 << n
};
cljs.core.bit_not = function bit_not(x) {
  return~x
};
cljs.core.bit_set = function bit_set(x, n) {
  return x | 1 << n
};
cljs.core.bit_test = function bit_test(x, n) {
  return(x & 1 << n) != 0
};
cljs.core.bit_shift_left = function bit_shift_left(x, n) {
  return x << n
};
cljs.core.bit_shift_right = function bit_shift_right(x, n) {
  return x >> n
};
cljs.core._EQ__EQ_ = function() {
  var _EQ__EQ_ = null;
  var _EQ__EQ___1606720 = function(x) {
    return true
  };
  var _EQ__EQ___1606721 = function(x, y) {
    return cljs.core._equiv.call(null, x, y)
  };
  var _EQ__EQ___1606722 = function() {
    var G__1606724__delegate = function(x, y, more) {
      while(true) {
        if(cljs.core.truth_(_EQ__EQ_.call(null, x, y))) {
          if(cljs.core.truth_(cljs.core.next.call(null, more))) {
            var G__1606725 = y;
            var G__1606726 = cljs.core.first.call(null, more);
            var G__1606727 = cljs.core.next.call(null, more);
            x = G__1606725;
            y = G__1606726;
            more = G__1606727;
            continue
          }else {
            return _EQ__EQ_.call(null, y, cljs.core.first.call(null, more))
          }
        }else {
          return false
        }
        break
      }
    };
    var G__1606724 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606724__delegate.call(this, x, y, more)
    };
    G__1606724.cljs$lang$maxFixedArity = 2;
    G__1606724.cljs$lang$applyTo = function(arglist__1606728) {
      var x = cljs.core.first(arglist__1606728);
      var y = cljs.core.first(cljs.core.next(arglist__1606728));
      var more = cljs.core.rest(cljs.core.next(arglist__1606728));
      return G__1606724__delegate.call(this, x, y, more)
    };
    return G__1606724
  }();
  _EQ__EQ_ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return _EQ__EQ___1606720.call(this, x);
      case 2:
        return _EQ__EQ___1606721.call(this, x, y);
      default:
        return _EQ__EQ___1606722.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  _EQ__EQ_.cljs$lang$maxFixedArity = 2;
  _EQ__EQ_.cljs$lang$applyTo = _EQ__EQ___1606722.cljs$lang$applyTo;
  return _EQ__EQ_
}();
cljs.core.pos_QMARK_ = function pos_QMARK_(n) {
  return n > 0
};
cljs.core.zero_QMARK_ = function zero_QMARK_(n) {
  return n === 0
};
cljs.core.neg_QMARK_ = function neg_QMARK_(x) {
  return x < 0
};
cljs.core.nthnext = function nthnext(coll, n) {
  var n__1606729 = n;
  var xs__1606730 = cljs.core.seq.call(null, coll);
  while(true) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606731 = xs__1606730;
      if(cljs.core.truth_(and__3546__auto____1606731)) {
        return n__1606729 > 0
      }else {
        return and__3546__auto____1606731
      }
    }())) {
      var G__1606732 = n__1606729 - 1;
      var G__1606733 = cljs.core.next.call(null, xs__1606730);
      n__1606729 = G__1606732;
      xs__1606730 = G__1606733;
      continue
    }else {
      return xs__1606730
    }
    break
  }
};
cljs.core.IIndexed["_"] = true;
cljs.core._nth["_"] = function() {
  var G__1606738 = null;
  var G__1606738__1606739 = function(coll, n) {
    var temp__3695__auto____1606734 = cljs.core.nthnext.call(null, coll, n);
    if(cljs.core.truth_(temp__3695__auto____1606734)) {
      var xs__1606735 = temp__3695__auto____1606734;
      return cljs.core.first.call(null, xs__1606735)
    }else {
      throw new Error("Index out of bounds");
    }
  };
  var G__1606738__1606740 = function(coll, n, not_found) {
    var temp__3695__auto____1606736 = cljs.core.nthnext.call(null, coll, n);
    if(cljs.core.truth_(temp__3695__auto____1606736)) {
      var xs__1606737 = temp__3695__auto____1606736;
      return cljs.core.first.call(null, xs__1606737)
    }else {
      return not_found
    }
  };
  G__1606738 = function(coll, n, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1606738__1606739.call(this, coll, n);
      case 3:
        return G__1606738__1606740.call(this, coll, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606738
}();
cljs.core.str_STAR_ = function() {
  var str_STAR_ = null;
  var str_STAR___1606742 = function() {
    return""
  };
  var str_STAR___1606743 = function(x) {
    if(cljs.core.truth_(x === null)) {
      return""
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        return x.toString()
      }else {
        return null
      }
    }
  };
  var str_STAR___1606744 = function() {
    var G__1606746__delegate = function(x, ys) {
      return function(sb, more) {
        while(true) {
          if(cljs.core.truth_(more)) {
            var G__1606747 = sb.append(str_STAR_.call(null, cljs.core.first.call(null, more)));
            var G__1606748 = cljs.core.next.call(null, more);
            sb = G__1606747;
            more = G__1606748;
            continue
          }else {
            return str_STAR_.call(null, sb)
          }
          break
        }
      }.call(null, new goog.string.StringBuffer(str_STAR_.call(null, x)), ys)
    };
    var G__1606746 = function(x, var_args) {
      var ys = null;
      if(goog.isDef(var_args)) {
        ys = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1), 0)
      }
      return G__1606746__delegate.call(this, x, ys)
    };
    G__1606746.cljs$lang$maxFixedArity = 1;
    G__1606746.cljs$lang$applyTo = function(arglist__1606749) {
      var x = cljs.core.first(arglist__1606749);
      var ys = cljs.core.rest(arglist__1606749);
      return G__1606746__delegate.call(this, x, ys)
    };
    return G__1606746
  }();
  str_STAR_ = function(x, var_args) {
    var ys = var_args;
    switch(arguments.length) {
      case 0:
        return str_STAR___1606742.call(this);
      case 1:
        return str_STAR___1606743.call(this, x);
      default:
        return str_STAR___1606744.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  str_STAR_.cljs$lang$maxFixedArity = 1;
  str_STAR_.cljs$lang$applyTo = str_STAR___1606744.cljs$lang$applyTo;
  return str_STAR_
}();
cljs.core.str = function() {
  var str = null;
  var str__1606750 = function() {
    return""
  };
  var str__1606751 = function(x) {
    if(cljs.core.truth_(cljs.core.symbol_QMARK_.call(null, x))) {
      return x.substring(2, x.length)
    }else {
      if(cljs.core.truth_(cljs.core.keyword_QMARK_.call(null, x))) {
        return cljs.core.str_STAR_.call(null, ":", x.substring(2, x.length))
      }else {
        if(cljs.core.truth_(x === null)) {
          return""
        }else {
          if(cljs.core.truth_("\ufdd0'else")) {
            return x.toString()
          }else {
            return null
          }
        }
      }
    }
  };
  var str__1606752 = function() {
    var G__1606754__delegate = function(x, ys) {
      return function(sb, more) {
        while(true) {
          if(cljs.core.truth_(more)) {
            var G__1606755 = sb.append(str.call(null, cljs.core.first.call(null, more)));
            var G__1606756 = cljs.core.next.call(null, more);
            sb = G__1606755;
            more = G__1606756;
            continue
          }else {
            return cljs.core.str_STAR_.call(null, sb)
          }
          break
        }
      }.call(null, new goog.string.StringBuffer(str.call(null, x)), ys)
    };
    var G__1606754 = function(x, var_args) {
      var ys = null;
      if(goog.isDef(var_args)) {
        ys = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1), 0)
      }
      return G__1606754__delegate.call(this, x, ys)
    };
    G__1606754.cljs$lang$maxFixedArity = 1;
    G__1606754.cljs$lang$applyTo = function(arglist__1606757) {
      var x = cljs.core.first(arglist__1606757);
      var ys = cljs.core.rest(arglist__1606757);
      return G__1606754__delegate.call(this, x, ys)
    };
    return G__1606754
  }();
  str = function(x, var_args) {
    var ys = var_args;
    switch(arguments.length) {
      case 0:
        return str__1606750.call(this);
      case 1:
        return str__1606751.call(this, x);
      default:
        return str__1606752.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  str.cljs$lang$maxFixedArity = 1;
  str.cljs$lang$applyTo = str__1606752.cljs$lang$applyTo;
  return str
}();
cljs.core.subs = function() {
  var subs = null;
  var subs__1606758 = function(s, start) {
    return s.substring(start)
  };
  var subs__1606759 = function(s, start, end) {
    return s.substring(start, end)
  };
  subs = function(s, start, end) {
    switch(arguments.length) {
      case 2:
        return subs__1606758.call(this, s, start);
      case 3:
        return subs__1606759.call(this, s, start, end)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return subs
}();
cljs.core.symbol = function() {
  var symbol = null;
  var symbol__1606761 = function(name) {
    if(cljs.core.truth_(cljs.core.symbol_QMARK_.call(null, name))) {
      name
    }else {
      if(cljs.core.truth_(cljs.core.keyword_QMARK_.call(null, name))) {
        cljs.core.str_STAR_.call(null, "\ufdd1", "'", cljs.core.subs.call(null, name, 2))
      }else {
      }
    }
    return cljs.core.str_STAR_.call(null, "\ufdd1", "'", name)
  };
  var symbol__1606762 = function(ns, name) {
    return symbol.call(null, cljs.core.str_STAR_.call(null, ns, "/", name))
  };
  symbol = function(ns, name) {
    switch(arguments.length) {
      case 1:
        return symbol__1606761.call(this, ns);
      case 2:
        return symbol__1606762.call(this, ns, name)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return symbol
}();
cljs.core.keyword = function() {
  var keyword = null;
  var keyword__1606764 = function(name) {
    if(cljs.core.truth_(cljs.core.keyword_QMARK_.call(null, name))) {
      return name
    }else {
      if(cljs.core.truth_(cljs.core.symbol_QMARK_.call(null, name))) {
        return cljs.core.str_STAR_.call(null, "\ufdd0", "'", cljs.core.subs.call(null, name, 2))
      }else {
        if(cljs.core.truth_("\ufdd0'else")) {
          return cljs.core.str_STAR_.call(null, "\ufdd0", "'", name)
        }else {
          return null
        }
      }
    }
  };
  var keyword__1606765 = function(ns, name) {
    return keyword.call(null, cljs.core.str_STAR_.call(null, ns, "/", name))
  };
  keyword = function(ns, name) {
    switch(arguments.length) {
      case 1:
        return keyword__1606764.call(this, ns);
      case 2:
        return keyword__1606765.call(this, ns, name)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return keyword
}();
cljs.core.equiv_sequential = function equiv_sequential(x, y) {
  return cljs.core.boolean$.call(null, cljs.core.truth_(cljs.core.sequential_QMARK_.call(null, y)) ? function() {
    var xs__1606767 = cljs.core.seq.call(null, x);
    var ys__1606768 = cljs.core.seq.call(null, y);
    while(true) {
      if(cljs.core.truth_(xs__1606767 === null)) {
        return ys__1606768 === null
      }else {
        if(cljs.core.truth_(ys__1606768 === null)) {
          return false
        }else {
          if(cljs.core.truth_(cljs.core._EQ_.call(null, cljs.core.first.call(null, xs__1606767), cljs.core.first.call(null, ys__1606768)))) {
            var G__1606769 = cljs.core.next.call(null, xs__1606767);
            var G__1606770 = cljs.core.next.call(null, ys__1606768);
            xs__1606767 = G__1606769;
            ys__1606768 = G__1606770;
            continue
          }else {
            if(cljs.core.truth_("\ufdd0'else")) {
              return false
            }else {
              return null
            }
          }
        }
      }
      break
    }
  }() : null)
};
cljs.core.hash_combine = function hash_combine(seed, hash) {
  return seed ^ hash + 2654435769 + (seed << 6) + (seed >> 2)
};
cljs.core.hash_coll = function hash_coll(coll) {
  return cljs.core.reduce.call(null, function(p1__1606771_SHARP_, p2__1606772_SHARP_) {
    return cljs.core.hash_combine.call(null, p1__1606771_SHARP_, cljs.core.hash.call(null, p2__1606772_SHARP_))
  }, cljs.core.hash.call(null, cljs.core.first.call(null, coll)), cljs.core.next.call(null, coll))
};
cljs.core.extend_object_BANG_ = function extend_object_BANG_(obj, fn_map) {
  var G__1606773__1606774 = cljs.core.seq.call(null, fn_map);
  if(cljs.core.truth_(G__1606773__1606774)) {
    var G__1606776__1606778 = cljs.core.first.call(null, G__1606773__1606774);
    var vec__1606777__1606779 = G__1606776__1606778;
    var key_name__1606780 = cljs.core.nth.call(null, vec__1606777__1606779, 0, null);
    var f__1606781 = cljs.core.nth.call(null, vec__1606777__1606779, 1, null);
    var G__1606773__1606782 = G__1606773__1606774;
    var G__1606776__1606783 = G__1606776__1606778;
    var G__1606773__1606784 = G__1606773__1606782;
    while(true) {
      var vec__1606785__1606786 = G__1606776__1606783;
      var key_name__1606787 = cljs.core.nth.call(null, vec__1606785__1606786, 0, null);
      var f__1606788 = cljs.core.nth.call(null, vec__1606785__1606786, 1, null);
      var G__1606773__1606789 = G__1606773__1606784;
      var str_name__1606790 = cljs.core.name.call(null, key_name__1606787);
      obj[str_name__1606790] = f__1606788;
      var temp__3698__auto____1606791 = cljs.core.next.call(null, G__1606773__1606789);
      if(cljs.core.truth_(temp__3698__auto____1606791)) {
        var G__1606773__1606792 = temp__3698__auto____1606791;
        var G__1606793 = cljs.core.first.call(null, G__1606773__1606792);
        var G__1606794 = G__1606773__1606792;
        G__1606776__1606783 = G__1606793;
        G__1606773__1606784 = G__1606794;
        continue
      }else {
      }
      break
    }
  }else {
  }
  return obj
};
cljs.core.List = function(meta, first, rest, count) {
  this.meta = meta;
  this.first = first;
  this.rest = rest;
  this.count = count
};
cljs.core.List.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.List")
};
cljs.core.List.prototype.cljs$core$IHash$ = true;
cljs.core.List.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1606795 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.List.prototype.cljs$core$ISequential$ = true;
cljs.core.List.prototype.cljs$core$ICollection$ = true;
cljs.core.List.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1606796 = this;
  return new cljs.core.List(this__1606796.meta, o, coll, this__1606796.count + 1)
};
cljs.core.List.prototype.cljs$core$ISeqable$ = true;
cljs.core.List.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1606797 = this;
  return coll
};
cljs.core.List.prototype.cljs$core$ICounted$ = true;
cljs.core.List.prototype.cljs$core$ICounted$_count = function(coll) {
  var this__1606798 = this;
  return this__1606798.count
};
cljs.core.List.prototype.cljs$core$IStack$ = true;
cljs.core.List.prototype.cljs$core$IStack$_peek = function(coll) {
  var this__1606799 = this;
  return this__1606799.first
};
cljs.core.List.prototype.cljs$core$IStack$_pop = function(coll) {
  var this__1606800 = this;
  return cljs.core._rest.call(null, coll)
};
cljs.core.List.prototype.cljs$core$ISeq$ = true;
cljs.core.List.prototype.cljs$core$ISeq$_first = function(coll) {
  var this__1606801 = this;
  return this__1606801.first
};
cljs.core.List.prototype.cljs$core$ISeq$_rest = function(coll) {
  var this__1606802 = this;
  return this__1606802.rest
};
cljs.core.List.prototype.cljs$core$IEquiv$ = true;
cljs.core.List.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1606803 = this;
  return cljs.core.equiv_sequential.call(null, coll, other)
};
cljs.core.List.prototype.cljs$core$IWithMeta$ = true;
cljs.core.List.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1606804 = this;
  return new cljs.core.List(meta, this__1606804.first, this__1606804.rest, this__1606804.count)
};
cljs.core.List.prototype.cljs$core$IMeta$ = true;
cljs.core.List.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1606805 = this;
  return this__1606805.meta
};
cljs.core.List.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.List.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1606806 = this;
  return cljs.core.List.EMPTY
};
cljs.core.List;
cljs.core.EmptyList = function(meta) {
  this.meta = meta
};
cljs.core.EmptyList.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.EmptyList")
};
cljs.core.EmptyList.prototype.cljs$core$IHash$ = true;
cljs.core.EmptyList.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1606807 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.EmptyList.prototype.cljs$core$ISequential$ = true;
cljs.core.EmptyList.prototype.cljs$core$ICollection$ = true;
cljs.core.EmptyList.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1606808 = this;
  return new cljs.core.List(this__1606808.meta, o, null, 1)
};
cljs.core.EmptyList.prototype.cljs$core$ISeqable$ = true;
cljs.core.EmptyList.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1606809 = this;
  return null
};
cljs.core.EmptyList.prototype.cljs$core$ICounted$ = true;
cljs.core.EmptyList.prototype.cljs$core$ICounted$_count = function(coll) {
  var this__1606810 = this;
  return 0
};
cljs.core.EmptyList.prototype.cljs$core$IStack$ = true;
cljs.core.EmptyList.prototype.cljs$core$IStack$_peek = function(coll) {
  var this__1606811 = this;
  return null
};
cljs.core.EmptyList.prototype.cljs$core$IStack$_pop = function(coll) {
  var this__1606812 = this;
  return null
};
cljs.core.EmptyList.prototype.cljs$core$ISeq$ = true;
cljs.core.EmptyList.prototype.cljs$core$ISeq$_first = function(coll) {
  var this__1606813 = this;
  return null
};
cljs.core.EmptyList.prototype.cljs$core$ISeq$_rest = function(coll) {
  var this__1606814 = this;
  return null
};
cljs.core.EmptyList.prototype.cljs$core$IEquiv$ = true;
cljs.core.EmptyList.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1606815 = this;
  return cljs.core.equiv_sequential.call(null, coll, other)
};
cljs.core.EmptyList.prototype.cljs$core$IWithMeta$ = true;
cljs.core.EmptyList.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1606816 = this;
  return new cljs.core.EmptyList(meta)
};
cljs.core.EmptyList.prototype.cljs$core$IMeta$ = true;
cljs.core.EmptyList.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1606817 = this;
  return this__1606817.meta
};
cljs.core.EmptyList.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.EmptyList.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1606818 = this;
  return coll
};
cljs.core.EmptyList;
cljs.core.List.EMPTY = new cljs.core.EmptyList(null);
cljs.core.reverse = function reverse(coll) {
  return cljs.core.reduce.call(null, cljs.core.conj, cljs.core.List.EMPTY, coll)
};
cljs.core.list = function() {
  var list__delegate = function(items) {
    return cljs.core.reduce.call(null, cljs.core.conj, cljs.core.List.EMPTY, cljs.core.reverse.call(null, items))
  };
  var list = function(var_args) {
    var items = null;
    if(goog.isDef(var_args)) {
      items = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return list__delegate.call(this, items)
  };
  list.cljs$lang$maxFixedArity = 0;
  list.cljs$lang$applyTo = function(arglist__1606819) {
    var items = cljs.core.seq(arglist__1606819);
    return list__delegate.call(this, items)
  };
  return list
}();
cljs.core.Cons = function(meta, first, rest) {
  this.meta = meta;
  this.first = first;
  this.rest = rest
};
cljs.core.Cons.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.Cons")
};
cljs.core.Cons.prototype.cljs$core$ISeqable$ = true;
cljs.core.Cons.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1606820 = this;
  return coll
};
cljs.core.Cons.prototype.cljs$core$IHash$ = true;
cljs.core.Cons.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1606821 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.Cons.prototype.cljs$core$IEquiv$ = true;
cljs.core.Cons.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1606822 = this;
  return cljs.core.equiv_sequential.call(null, coll, other)
};
cljs.core.Cons.prototype.cljs$core$ISequential$ = true;
cljs.core.Cons.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.Cons.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1606823 = this;
  return cljs.core.with_meta.call(null, cljs.core.List.EMPTY, this__1606823.meta)
};
cljs.core.Cons.prototype.cljs$core$ICollection$ = true;
cljs.core.Cons.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1606824 = this;
  return new cljs.core.Cons(null, o, coll)
};
cljs.core.Cons.prototype.cljs$core$ISeq$ = true;
cljs.core.Cons.prototype.cljs$core$ISeq$_first = function(coll) {
  var this__1606825 = this;
  return this__1606825.first
};
cljs.core.Cons.prototype.cljs$core$ISeq$_rest = function(coll) {
  var this__1606826 = this;
  if(cljs.core.truth_(this__1606826.rest === null)) {
    return cljs.core.List.EMPTY
  }else {
    return this__1606826.rest
  }
};
cljs.core.Cons.prototype.cljs$core$IMeta$ = true;
cljs.core.Cons.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1606827 = this;
  return this__1606827.meta
};
cljs.core.Cons.prototype.cljs$core$IWithMeta$ = true;
cljs.core.Cons.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1606828 = this;
  return new cljs.core.Cons(meta, this__1606828.first, this__1606828.rest)
};
cljs.core.Cons;
cljs.core.cons = function cons(x, seq) {
  return new cljs.core.Cons(null, x, seq)
};
cljs.core.IReduce["string"] = true;
cljs.core._reduce["string"] = function() {
  var G__1606829 = null;
  var G__1606829__1606830 = function(string, f) {
    return cljs.core.ci_reduce.call(null, string, f)
  };
  var G__1606829__1606831 = function(string, f, start) {
    return cljs.core.ci_reduce.call(null, string, f, start)
  };
  G__1606829 = function(string, f, start) {
    switch(arguments.length) {
      case 2:
        return G__1606829__1606830.call(this, string, f);
      case 3:
        return G__1606829__1606831.call(this, string, f, start)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606829
}();
cljs.core.ILookup["string"] = true;
cljs.core._lookup["string"] = function() {
  var G__1606833 = null;
  var G__1606833__1606834 = function(string, k) {
    return cljs.core._nth.call(null, string, k)
  };
  var G__1606833__1606835 = function(string, k, not_found) {
    return cljs.core._nth.call(null, string, k, not_found)
  };
  G__1606833 = function(string, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1606833__1606834.call(this, string, k);
      case 3:
        return G__1606833__1606835.call(this, string, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606833
}();
cljs.core.IIndexed["string"] = true;
cljs.core._nth["string"] = function() {
  var G__1606837 = null;
  var G__1606837__1606838 = function(string, n) {
    if(cljs.core.truth_(n < cljs.core._count.call(null, string))) {
      return string.charAt(n)
    }else {
      return null
    }
  };
  var G__1606837__1606839 = function(string, n, not_found) {
    if(cljs.core.truth_(n < cljs.core._count.call(null, string))) {
      return string.charAt(n)
    }else {
      return not_found
    }
  };
  G__1606837 = function(string, n, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1606837__1606838.call(this, string, n);
      case 3:
        return G__1606837__1606839.call(this, string, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606837
}();
cljs.core.ICounted["string"] = true;
cljs.core._count["string"] = function(s) {
  return s.length
};
cljs.core.ISeqable["string"] = true;
cljs.core._seq["string"] = function(string) {
  return cljs.core.prim_seq.call(null, string, 0)
};
cljs.core.IHash["string"] = true;
cljs.core._hash["string"] = function(o) {
  return goog.string.hashCode.call(null, o)
};
String.prototype.cljs$core$IFn$ = true;
String.prototype.call = function() {
  var G__1606847 = null;
  var G__1606847__1606848 = function(tsym1606841, coll) {
    var tsym1606841__1606843 = this;
    var this$__1606844 = tsym1606841__1606843;
    return cljs.core.get.call(null, coll, this$__1606844.toString())
  };
  var G__1606847__1606849 = function(tsym1606842, coll, not_found) {
    var tsym1606842__1606845 = this;
    var this$__1606846 = tsym1606842__1606845;
    return cljs.core.get.call(null, coll, this$__1606846.toString(), not_found)
  };
  G__1606847 = function(tsym1606842, coll, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1606847__1606848.call(this, tsym1606842, coll);
      case 3:
        return G__1606847__1606849.call(this, tsym1606842, coll, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1606847
}();
String["prototype"]["apply"] = function(s, args) {
  if(cljs.core.truth_(cljs.core.count.call(null, args) < 2)) {
    return cljs.core.get.call(null, args[0], s)
  }else {
    return cljs.core.get.call(null, args[0], s, args[1])
  }
};
cljs.core.lazy_seq_value = function lazy_seq_value(lazy_seq) {
  var x__1606851 = lazy_seq.x;
  if(cljs.core.truth_(lazy_seq.realized)) {
    return x__1606851
  }else {
    lazy_seq.x = x__1606851.call(null);
    lazy_seq.realized = true;
    return lazy_seq.x
  }
};
cljs.core.LazySeq = function(meta, realized, x) {
  this.meta = meta;
  this.realized = realized;
  this.x = x
};
cljs.core.LazySeq.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.LazySeq")
};
cljs.core.LazySeq.prototype.cljs$core$ISeqable$ = true;
cljs.core.LazySeq.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1606852 = this;
  return cljs.core.seq.call(null, cljs.core.lazy_seq_value.call(null, coll))
};
cljs.core.LazySeq.prototype.cljs$core$IHash$ = true;
cljs.core.LazySeq.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1606853 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.LazySeq.prototype.cljs$core$IEquiv$ = true;
cljs.core.LazySeq.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1606854 = this;
  return cljs.core.equiv_sequential.call(null, coll, other)
};
cljs.core.LazySeq.prototype.cljs$core$ISequential$ = true;
cljs.core.LazySeq.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.LazySeq.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1606855 = this;
  return cljs.core.with_meta.call(null, cljs.core.List.EMPTY, this__1606855.meta)
};
cljs.core.LazySeq.prototype.cljs$core$ICollection$ = true;
cljs.core.LazySeq.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1606856 = this;
  return cljs.core.cons.call(null, o, coll)
};
cljs.core.LazySeq.prototype.cljs$core$ISeq$ = true;
cljs.core.LazySeq.prototype.cljs$core$ISeq$_first = function(coll) {
  var this__1606857 = this;
  return cljs.core.first.call(null, cljs.core.lazy_seq_value.call(null, coll))
};
cljs.core.LazySeq.prototype.cljs$core$ISeq$_rest = function(coll) {
  var this__1606858 = this;
  return cljs.core.rest.call(null, cljs.core.lazy_seq_value.call(null, coll))
};
cljs.core.LazySeq.prototype.cljs$core$IMeta$ = true;
cljs.core.LazySeq.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1606859 = this;
  return this__1606859.meta
};
cljs.core.LazySeq.prototype.cljs$core$IWithMeta$ = true;
cljs.core.LazySeq.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1606860 = this;
  return new cljs.core.LazySeq(meta, this__1606860.realized, this__1606860.x)
};
cljs.core.LazySeq;
cljs.core.to_array = function to_array(s) {
  var ary__1606861 = [];
  var s__1606862 = s;
  while(true) {
    if(cljs.core.truth_(cljs.core.seq.call(null, s__1606862))) {
      ary__1606861.push(cljs.core.first.call(null, s__1606862));
      var G__1606863 = cljs.core.next.call(null, s__1606862);
      s__1606862 = G__1606863;
      continue
    }else {
      return ary__1606861
    }
    break
  }
};
cljs.core.bounded_count = function bounded_count(s, n) {
  var s__1606864 = s;
  var i__1606865 = n;
  var sum__1606866 = 0;
  while(true) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606867 = i__1606865 > 0;
      if(cljs.core.truth_(and__3546__auto____1606867)) {
        return cljs.core.seq.call(null, s__1606864)
      }else {
        return and__3546__auto____1606867
      }
    }())) {
      var G__1606868 = cljs.core.next.call(null, s__1606864);
      var G__1606869 = i__1606865 - 1;
      var G__1606870 = sum__1606866 + 1;
      s__1606864 = G__1606868;
      i__1606865 = G__1606869;
      sum__1606866 = G__1606870;
      continue
    }else {
      return sum__1606866
    }
    break
  }
};
cljs.core.spread = function spread(arglist) {
  if(cljs.core.truth_(arglist === null)) {
    return null
  }else {
    if(cljs.core.truth_(cljs.core.next.call(null, arglist) === null)) {
      return cljs.core.seq.call(null, cljs.core.first.call(null, arglist))
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        return cljs.core.cons.call(null, cljs.core.first.call(null, arglist), spread.call(null, cljs.core.next.call(null, arglist)))
      }else {
        return null
      }
    }
  }
};
cljs.core.concat = function() {
  var concat = null;
  var concat__1606874 = function() {
    return new cljs.core.LazySeq(null, false, function() {
      return null
    })
  };
  var concat__1606875 = function(x) {
    return new cljs.core.LazySeq(null, false, function() {
      return x
    })
  };
  var concat__1606876 = function(x, y) {
    return new cljs.core.LazySeq(null, false, function() {
      var s__1606871 = cljs.core.seq.call(null, x);
      if(cljs.core.truth_(s__1606871)) {
        return cljs.core.cons.call(null, cljs.core.first.call(null, s__1606871), concat.call(null, cljs.core.rest.call(null, s__1606871), y))
      }else {
        return y
      }
    })
  };
  var concat__1606877 = function() {
    var G__1606879__delegate = function(x, y, zs) {
      var cat__1606873 = function cat(xys, zs) {
        return new cljs.core.LazySeq(null, false, function() {
          var xys__1606872 = cljs.core.seq.call(null, xys);
          if(cljs.core.truth_(xys__1606872)) {
            return cljs.core.cons.call(null, cljs.core.first.call(null, xys__1606872), cat.call(null, cljs.core.rest.call(null, xys__1606872), zs))
          }else {
            if(cljs.core.truth_(zs)) {
              return cat.call(null, cljs.core.first.call(null, zs), cljs.core.next.call(null, zs))
            }else {
              return null
            }
          }
        })
      };
      return cat__1606873.call(null, concat.call(null, x, y), zs)
    };
    var G__1606879 = function(x, y, var_args) {
      var zs = null;
      if(goog.isDef(var_args)) {
        zs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606879__delegate.call(this, x, y, zs)
    };
    G__1606879.cljs$lang$maxFixedArity = 2;
    G__1606879.cljs$lang$applyTo = function(arglist__1606880) {
      var x = cljs.core.first(arglist__1606880);
      var y = cljs.core.first(cljs.core.next(arglist__1606880));
      var zs = cljs.core.rest(cljs.core.next(arglist__1606880));
      return G__1606879__delegate.call(this, x, y, zs)
    };
    return G__1606879
  }();
  concat = function(x, y, var_args) {
    var zs = var_args;
    switch(arguments.length) {
      case 0:
        return concat__1606874.call(this);
      case 1:
        return concat__1606875.call(this, x);
      case 2:
        return concat__1606876.call(this, x, y);
      default:
        return concat__1606877.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  concat.cljs$lang$maxFixedArity = 2;
  concat.cljs$lang$applyTo = concat__1606877.cljs$lang$applyTo;
  return concat
}();
cljs.core.list_STAR_ = function() {
  var list_STAR_ = null;
  var list_STAR___1606881 = function(args) {
    return cljs.core.seq.call(null, args)
  };
  var list_STAR___1606882 = function(a, args) {
    return cljs.core.cons.call(null, a, args)
  };
  var list_STAR___1606883 = function(a, b, args) {
    return cljs.core.cons.call(null, a, cljs.core.cons.call(null, b, args))
  };
  var list_STAR___1606884 = function(a, b, c, args) {
    return cljs.core.cons.call(null, a, cljs.core.cons.call(null, b, cljs.core.cons.call(null, c, args)))
  };
  var list_STAR___1606885 = function() {
    var G__1606887__delegate = function(a, b, c, d, more) {
      return cljs.core.cons.call(null, a, cljs.core.cons.call(null, b, cljs.core.cons.call(null, c, cljs.core.cons.call(null, d, cljs.core.spread.call(null, more)))))
    };
    var G__1606887 = function(a, b, c, d, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 4), 0)
      }
      return G__1606887__delegate.call(this, a, b, c, d, more)
    };
    G__1606887.cljs$lang$maxFixedArity = 4;
    G__1606887.cljs$lang$applyTo = function(arglist__1606888) {
      var a = cljs.core.first(arglist__1606888);
      var b = cljs.core.first(cljs.core.next(arglist__1606888));
      var c = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1606888)));
      var d = cljs.core.first(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1606888))));
      var more = cljs.core.rest(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1606888))));
      return G__1606887__delegate.call(this, a, b, c, d, more)
    };
    return G__1606887
  }();
  list_STAR_ = function(a, b, c, d, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return list_STAR___1606881.call(this, a);
      case 2:
        return list_STAR___1606882.call(this, a, b);
      case 3:
        return list_STAR___1606883.call(this, a, b, c);
      case 4:
        return list_STAR___1606884.call(this, a, b, c, d);
      default:
        return list_STAR___1606885.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  list_STAR_.cljs$lang$maxFixedArity = 4;
  list_STAR_.cljs$lang$applyTo = list_STAR___1606885.cljs$lang$applyTo;
  return list_STAR_
}();
cljs.core.apply = function() {
  var apply = null;
  var apply__1606898 = function(f, args) {
    var fixed_arity__1606889 = f.cljs$lang$maxFixedArity;
    if(cljs.core.truth_(f.cljs$lang$applyTo)) {
      if(cljs.core.truth_(cljs.core.bounded_count.call(null, args, fixed_arity__1606889 + 1) <= fixed_arity__1606889)) {
        return f.apply(f, cljs.core.to_array.call(null, args))
      }else {
        return f.cljs$lang$applyTo(args)
      }
    }else {
      return f.apply(f, cljs.core.to_array.call(null, args))
    }
  };
  var apply__1606899 = function(f, x, args) {
    var arglist__1606890 = cljs.core.list_STAR_.call(null, x, args);
    var fixed_arity__1606891 = f.cljs$lang$maxFixedArity;
    if(cljs.core.truth_(f.cljs$lang$applyTo)) {
      if(cljs.core.truth_(cljs.core.bounded_count.call(null, arglist__1606890, fixed_arity__1606891) <= fixed_arity__1606891)) {
        return f.apply(f, cljs.core.to_array.call(null, arglist__1606890))
      }else {
        return f.cljs$lang$applyTo(arglist__1606890)
      }
    }else {
      return f.apply(f, cljs.core.to_array.call(null, arglist__1606890))
    }
  };
  var apply__1606900 = function(f, x, y, args) {
    var arglist__1606892 = cljs.core.list_STAR_.call(null, x, y, args);
    var fixed_arity__1606893 = f.cljs$lang$maxFixedArity;
    if(cljs.core.truth_(f.cljs$lang$applyTo)) {
      if(cljs.core.truth_(cljs.core.bounded_count.call(null, arglist__1606892, fixed_arity__1606893) <= fixed_arity__1606893)) {
        return f.apply(f, cljs.core.to_array.call(null, arglist__1606892))
      }else {
        return f.cljs$lang$applyTo(arglist__1606892)
      }
    }else {
      return f.apply(f, cljs.core.to_array.call(null, arglist__1606892))
    }
  };
  var apply__1606901 = function(f, x, y, z, args) {
    var arglist__1606894 = cljs.core.list_STAR_.call(null, x, y, z, args);
    var fixed_arity__1606895 = f.cljs$lang$maxFixedArity;
    if(cljs.core.truth_(f.cljs$lang$applyTo)) {
      if(cljs.core.truth_(cljs.core.bounded_count.call(null, arglist__1606894, fixed_arity__1606895) <= fixed_arity__1606895)) {
        return f.apply(f, cljs.core.to_array.call(null, arglist__1606894))
      }else {
        return f.cljs$lang$applyTo(arglist__1606894)
      }
    }else {
      return f.apply(f, cljs.core.to_array.call(null, arglist__1606894))
    }
  };
  var apply__1606902 = function() {
    var G__1606904__delegate = function(f, a, b, c, d, args) {
      var arglist__1606896 = cljs.core.cons.call(null, a, cljs.core.cons.call(null, b, cljs.core.cons.call(null, c, cljs.core.cons.call(null, d, cljs.core.spread.call(null, args)))));
      var fixed_arity__1606897 = f.cljs$lang$maxFixedArity;
      if(cljs.core.truth_(f.cljs$lang$applyTo)) {
        if(cljs.core.truth_(cljs.core.bounded_count.call(null, arglist__1606896, fixed_arity__1606897) <= fixed_arity__1606897)) {
          return f.apply(f, cljs.core.to_array.call(null, arglist__1606896))
        }else {
          return f.cljs$lang$applyTo(arglist__1606896)
        }
      }else {
        return f.apply(f, cljs.core.to_array.call(null, arglist__1606896))
      }
    };
    var G__1606904 = function(f, a, b, c, d, var_args) {
      var args = null;
      if(goog.isDef(var_args)) {
        args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 5), 0)
      }
      return G__1606904__delegate.call(this, f, a, b, c, d, args)
    };
    G__1606904.cljs$lang$maxFixedArity = 5;
    G__1606904.cljs$lang$applyTo = function(arglist__1606905) {
      var f = cljs.core.first(arglist__1606905);
      var a = cljs.core.first(cljs.core.next(arglist__1606905));
      var b = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1606905)));
      var c = cljs.core.first(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1606905))));
      var d = cljs.core.first(cljs.core.next(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1606905)))));
      var args = cljs.core.rest(cljs.core.next(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1606905)))));
      return G__1606904__delegate.call(this, f, a, b, c, d, args)
    };
    return G__1606904
  }();
  apply = function(f, a, b, c, d, var_args) {
    var args = var_args;
    switch(arguments.length) {
      case 2:
        return apply__1606898.call(this, f, a);
      case 3:
        return apply__1606899.call(this, f, a, b);
      case 4:
        return apply__1606900.call(this, f, a, b, c);
      case 5:
        return apply__1606901.call(this, f, a, b, c, d);
      default:
        return apply__1606902.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  apply.cljs$lang$maxFixedArity = 5;
  apply.cljs$lang$applyTo = apply__1606902.cljs$lang$applyTo;
  return apply
}();
cljs.core.vary_meta = function() {
  var vary_meta__delegate = function(obj, f, args) {
    return cljs.core.with_meta.call(null, obj, cljs.core.apply.call(null, f, cljs.core.meta.call(null, obj), args))
  };
  var vary_meta = function(obj, f, var_args) {
    var args = null;
    if(goog.isDef(var_args)) {
      args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
    }
    return vary_meta__delegate.call(this, obj, f, args)
  };
  vary_meta.cljs$lang$maxFixedArity = 2;
  vary_meta.cljs$lang$applyTo = function(arglist__1606906) {
    var obj = cljs.core.first(arglist__1606906);
    var f = cljs.core.first(cljs.core.next(arglist__1606906));
    var args = cljs.core.rest(cljs.core.next(arglist__1606906));
    return vary_meta__delegate.call(this, obj, f, args)
  };
  return vary_meta
}();
cljs.core.not_EQ_ = function() {
  var not_EQ_ = null;
  var not_EQ___1606907 = function(x) {
    return false
  };
  var not_EQ___1606908 = function(x, y) {
    return cljs.core.not.call(null, cljs.core._EQ_.call(null, x, y))
  };
  var not_EQ___1606909 = function() {
    var G__1606911__delegate = function(x, y, more) {
      return cljs.core.not.call(null, cljs.core.apply.call(null, cljs.core._EQ_, x, y, more))
    };
    var G__1606911 = function(x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1606911__delegate.call(this, x, y, more)
    };
    G__1606911.cljs$lang$maxFixedArity = 2;
    G__1606911.cljs$lang$applyTo = function(arglist__1606912) {
      var x = cljs.core.first(arglist__1606912);
      var y = cljs.core.first(cljs.core.next(arglist__1606912));
      var more = cljs.core.rest(cljs.core.next(arglist__1606912));
      return G__1606911__delegate.call(this, x, y, more)
    };
    return G__1606911
  }();
  not_EQ_ = function(x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 1:
        return not_EQ___1606907.call(this, x);
      case 2:
        return not_EQ___1606908.call(this, x, y);
      default:
        return not_EQ___1606909.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  not_EQ_.cljs$lang$maxFixedArity = 2;
  not_EQ_.cljs$lang$applyTo = not_EQ___1606909.cljs$lang$applyTo;
  return not_EQ_
}();
cljs.core.not_empty = function not_empty(coll) {
  if(cljs.core.truth_(cljs.core.seq.call(null, coll))) {
    return coll
  }else {
    return null
  }
};
cljs.core.every_QMARK_ = function every_QMARK_(pred, coll) {
  while(true) {
    if(cljs.core.truth_(cljs.core.seq.call(null, coll) === null)) {
      return true
    }else {
      if(cljs.core.truth_(pred.call(null, cljs.core.first.call(null, coll)))) {
        var G__1606913 = pred;
        var G__1606914 = cljs.core.next.call(null, coll);
        pred = G__1606913;
        coll = G__1606914;
        continue
      }else {
        if(cljs.core.truth_("\ufdd0'else")) {
          return false
        }else {
          return null
        }
      }
    }
    break
  }
};
cljs.core.not_every_QMARK_ = function not_every_QMARK_(pred, coll) {
  return cljs.core.not.call(null, cljs.core.every_QMARK_.call(null, pred, coll))
};
cljs.core.some = function some(pred, coll) {
  while(true) {
    if(cljs.core.truth_(cljs.core.seq.call(null, coll))) {
      var or__3548__auto____1606915 = pred.call(null, cljs.core.first.call(null, coll));
      if(cljs.core.truth_(or__3548__auto____1606915)) {
        return or__3548__auto____1606915
      }else {
        var G__1606916 = pred;
        var G__1606917 = cljs.core.next.call(null, coll);
        pred = G__1606916;
        coll = G__1606917;
        continue
      }
    }else {
      return null
    }
    break
  }
};
cljs.core.not_any_QMARK_ = function not_any_QMARK_(pred, coll) {
  return cljs.core.not.call(null, cljs.core.some.call(null, pred, coll))
};
cljs.core.even_QMARK_ = function even_QMARK_(n) {
  if(cljs.core.truth_(cljs.core.integer_QMARK_.call(null, n))) {
    return(n & 1) === 0
  }else {
    throw new Error(cljs.core.str.call(null, "Argument must be an integer: ", n));
  }
};
cljs.core.odd_QMARK_ = function odd_QMARK_(n) {
  return cljs.core.not.call(null, cljs.core.even_QMARK_.call(null, n))
};
cljs.core.identity = function identity(x) {
  return x
};
cljs.core.complement = function complement(f) {
  return function() {
    var G__1606918 = null;
    var G__1606918__1606919 = function() {
      return cljs.core.not.call(null, f.call(null))
    };
    var G__1606918__1606920 = function(x) {
      return cljs.core.not.call(null, f.call(null, x))
    };
    var G__1606918__1606921 = function(x, y) {
      return cljs.core.not.call(null, f.call(null, x, y))
    };
    var G__1606918__1606922 = function() {
      var G__1606924__delegate = function(x, y, zs) {
        return cljs.core.not.call(null, cljs.core.apply.call(null, f, x, y, zs))
      };
      var G__1606924 = function(x, y, var_args) {
        var zs = null;
        if(goog.isDef(var_args)) {
          zs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
        }
        return G__1606924__delegate.call(this, x, y, zs)
      };
      G__1606924.cljs$lang$maxFixedArity = 2;
      G__1606924.cljs$lang$applyTo = function(arglist__1606925) {
        var x = cljs.core.first(arglist__1606925);
        var y = cljs.core.first(cljs.core.next(arglist__1606925));
        var zs = cljs.core.rest(cljs.core.next(arglist__1606925));
        return G__1606924__delegate.call(this, x, y, zs)
      };
      return G__1606924
    }();
    G__1606918 = function(x, y, var_args) {
      var zs = var_args;
      switch(arguments.length) {
        case 0:
          return G__1606918__1606919.call(this);
        case 1:
          return G__1606918__1606920.call(this, x);
        case 2:
          return G__1606918__1606921.call(this, x, y);
        default:
          return G__1606918__1606922.apply(this, arguments)
      }
      throw"Invalid arity: " + arguments.length;
    };
    G__1606918.cljs$lang$maxFixedArity = 2;
    G__1606918.cljs$lang$applyTo = G__1606918__1606922.cljs$lang$applyTo;
    return G__1606918
  }()
};
cljs.core.constantly = function constantly(x) {
  return function() {
    var G__1606926__delegate = function(args) {
      return x
    };
    var G__1606926 = function(var_args) {
      var args = null;
      if(goog.isDef(var_args)) {
        args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
      }
      return G__1606926__delegate.call(this, args)
    };
    G__1606926.cljs$lang$maxFixedArity = 0;
    G__1606926.cljs$lang$applyTo = function(arglist__1606927) {
      var args = cljs.core.seq(arglist__1606927);
      return G__1606926__delegate.call(this, args)
    };
    return G__1606926
  }()
};
cljs.core.comp = function() {
  var comp = null;
  var comp__1606931 = function() {
    return cljs.core.identity
  };
  var comp__1606932 = function(f) {
    return f
  };
  var comp__1606933 = function(f, g) {
    return function() {
      var G__1606937 = null;
      var G__1606937__1606938 = function() {
        return f.call(null, g.call(null))
      };
      var G__1606937__1606939 = function(x) {
        return f.call(null, g.call(null, x))
      };
      var G__1606937__1606940 = function(x, y) {
        return f.call(null, g.call(null, x, y))
      };
      var G__1606937__1606941 = function(x, y, z) {
        return f.call(null, g.call(null, x, y, z))
      };
      var G__1606937__1606942 = function() {
        var G__1606944__delegate = function(x, y, z, args) {
          return f.call(null, cljs.core.apply.call(null, g, x, y, z, args))
        };
        var G__1606944 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1606944__delegate.call(this, x, y, z, args)
        };
        G__1606944.cljs$lang$maxFixedArity = 3;
        G__1606944.cljs$lang$applyTo = function(arglist__1606945) {
          var x = cljs.core.first(arglist__1606945);
          var y = cljs.core.first(cljs.core.next(arglist__1606945));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1606945)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1606945)));
          return G__1606944__delegate.call(this, x, y, z, args)
        };
        return G__1606944
      }();
      G__1606937 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return G__1606937__1606938.call(this);
          case 1:
            return G__1606937__1606939.call(this, x);
          case 2:
            return G__1606937__1606940.call(this, x, y);
          case 3:
            return G__1606937__1606941.call(this, x, y, z);
          default:
            return G__1606937__1606942.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      G__1606937.cljs$lang$maxFixedArity = 3;
      G__1606937.cljs$lang$applyTo = G__1606937__1606942.cljs$lang$applyTo;
      return G__1606937
    }()
  };
  var comp__1606934 = function(f, g, h) {
    return function() {
      var G__1606946 = null;
      var G__1606946__1606947 = function() {
        return f.call(null, g.call(null, h.call(null)))
      };
      var G__1606946__1606948 = function(x) {
        return f.call(null, g.call(null, h.call(null, x)))
      };
      var G__1606946__1606949 = function(x, y) {
        return f.call(null, g.call(null, h.call(null, x, y)))
      };
      var G__1606946__1606950 = function(x, y, z) {
        return f.call(null, g.call(null, h.call(null, x, y, z)))
      };
      var G__1606946__1606951 = function() {
        var G__1606953__delegate = function(x, y, z, args) {
          return f.call(null, g.call(null, cljs.core.apply.call(null, h, x, y, z, args)))
        };
        var G__1606953 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1606953__delegate.call(this, x, y, z, args)
        };
        G__1606953.cljs$lang$maxFixedArity = 3;
        G__1606953.cljs$lang$applyTo = function(arglist__1606954) {
          var x = cljs.core.first(arglist__1606954);
          var y = cljs.core.first(cljs.core.next(arglist__1606954));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1606954)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1606954)));
          return G__1606953__delegate.call(this, x, y, z, args)
        };
        return G__1606953
      }();
      G__1606946 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return G__1606946__1606947.call(this);
          case 1:
            return G__1606946__1606948.call(this, x);
          case 2:
            return G__1606946__1606949.call(this, x, y);
          case 3:
            return G__1606946__1606950.call(this, x, y, z);
          default:
            return G__1606946__1606951.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      G__1606946.cljs$lang$maxFixedArity = 3;
      G__1606946.cljs$lang$applyTo = G__1606946__1606951.cljs$lang$applyTo;
      return G__1606946
    }()
  };
  var comp__1606935 = function() {
    var G__1606955__delegate = function(f1, f2, f3, fs) {
      var fs__1606928 = cljs.core.reverse.call(null, cljs.core.list_STAR_.call(null, f1, f2, f3, fs));
      return function() {
        var G__1606956__delegate = function(args) {
          var ret__1606929 = cljs.core.apply.call(null, cljs.core.first.call(null, fs__1606928), args);
          var fs__1606930 = cljs.core.next.call(null, fs__1606928);
          while(true) {
            if(cljs.core.truth_(fs__1606930)) {
              var G__1606957 = cljs.core.first.call(null, fs__1606930).call(null, ret__1606929);
              var G__1606958 = cljs.core.next.call(null, fs__1606930);
              ret__1606929 = G__1606957;
              fs__1606930 = G__1606958;
              continue
            }else {
              return ret__1606929
            }
            break
          }
        };
        var G__1606956 = function(var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
          }
          return G__1606956__delegate.call(this, args)
        };
        G__1606956.cljs$lang$maxFixedArity = 0;
        G__1606956.cljs$lang$applyTo = function(arglist__1606959) {
          var args = cljs.core.seq(arglist__1606959);
          return G__1606956__delegate.call(this, args)
        };
        return G__1606956
      }()
    };
    var G__1606955 = function(f1, f2, f3, var_args) {
      var fs = null;
      if(goog.isDef(var_args)) {
        fs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
      }
      return G__1606955__delegate.call(this, f1, f2, f3, fs)
    };
    G__1606955.cljs$lang$maxFixedArity = 3;
    G__1606955.cljs$lang$applyTo = function(arglist__1606960) {
      var f1 = cljs.core.first(arglist__1606960);
      var f2 = cljs.core.first(cljs.core.next(arglist__1606960));
      var f3 = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1606960)));
      var fs = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1606960)));
      return G__1606955__delegate.call(this, f1, f2, f3, fs)
    };
    return G__1606955
  }();
  comp = function(f1, f2, f3, var_args) {
    var fs = var_args;
    switch(arguments.length) {
      case 0:
        return comp__1606931.call(this);
      case 1:
        return comp__1606932.call(this, f1);
      case 2:
        return comp__1606933.call(this, f1, f2);
      case 3:
        return comp__1606934.call(this, f1, f2, f3);
      default:
        return comp__1606935.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  comp.cljs$lang$maxFixedArity = 3;
  comp.cljs$lang$applyTo = comp__1606935.cljs$lang$applyTo;
  return comp
}();
cljs.core.partial = function() {
  var partial = null;
  var partial__1606961 = function(f, arg1) {
    return function() {
      var G__1606966__delegate = function(args) {
        return cljs.core.apply.call(null, f, arg1, args)
      };
      var G__1606966 = function(var_args) {
        var args = null;
        if(goog.isDef(var_args)) {
          args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
        }
        return G__1606966__delegate.call(this, args)
      };
      G__1606966.cljs$lang$maxFixedArity = 0;
      G__1606966.cljs$lang$applyTo = function(arglist__1606967) {
        var args = cljs.core.seq(arglist__1606967);
        return G__1606966__delegate.call(this, args)
      };
      return G__1606966
    }()
  };
  var partial__1606962 = function(f, arg1, arg2) {
    return function() {
      var G__1606968__delegate = function(args) {
        return cljs.core.apply.call(null, f, arg1, arg2, args)
      };
      var G__1606968 = function(var_args) {
        var args = null;
        if(goog.isDef(var_args)) {
          args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
        }
        return G__1606968__delegate.call(this, args)
      };
      G__1606968.cljs$lang$maxFixedArity = 0;
      G__1606968.cljs$lang$applyTo = function(arglist__1606969) {
        var args = cljs.core.seq(arglist__1606969);
        return G__1606968__delegate.call(this, args)
      };
      return G__1606968
    }()
  };
  var partial__1606963 = function(f, arg1, arg2, arg3) {
    return function() {
      var G__1606970__delegate = function(args) {
        return cljs.core.apply.call(null, f, arg1, arg2, arg3, args)
      };
      var G__1606970 = function(var_args) {
        var args = null;
        if(goog.isDef(var_args)) {
          args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
        }
        return G__1606970__delegate.call(this, args)
      };
      G__1606970.cljs$lang$maxFixedArity = 0;
      G__1606970.cljs$lang$applyTo = function(arglist__1606971) {
        var args = cljs.core.seq(arglist__1606971);
        return G__1606970__delegate.call(this, args)
      };
      return G__1606970
    }()
  };
  var partial__1606964 = function() {
    var G__1606972__delegate = function(f, arg1, arg2, arg3, more) {
      return function() {
        var G__1606973__delegate = function(args) {
          return cljs.core.apply.call(null, f, arg1, arg2, arg3, cljs.core.concat.call(null, more, args))
        };
        var G__1606973 = function(var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
          }
          return G__1606973__delegate.call(this, args)
        };
        G__1606973.cljs$lang$maxFixedArity = 0;
        G__1606973.cljs$lang$applyTo = function(arglist__1606974) {
          var args = cljs.core.seq(arglist__1606974);
          return G__1606973__delegate.call(this, args)
        };
        return G__1606973
      }()
    };
    var G__1606972 = function(f, arg1, arg2, arg3, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 4), 0)
      }
      return G__1606972__delegate.call(this, f, arg1, arg2, arg3, more)
    };
    G__1606972.cljs$lang$maxFixedArity = 4;
    G__1606972.cljs$lang$applyTo = function(arglist__1606975) {
      var f = cljs.core.first(arglist__1606975);
      var arg1 = cljs.core.first(cljs.core.next(arglist__1606975));
      var arg2 = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1606975)));
      var arg3 = cljs.core.first(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1606975))));
      var more = cljs.core.rest(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1606975))));
      return G__1606972__delegate.call(this, f, arg1, arg2, arg3, more)
    };
    return G__1606972
  }();
  partial = function(f, arg1, arg2, arg3, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 2:
        return partial__1606961.call(this, f, arg1);
      case 3:
        return partial__1606962.call(this, f, arg1, arg2);
      case 4:
        return partial__1606963.call(this, f, arg1, arg2, arg3);
      default:
        return partial__1606964.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  partial.cljs$lang$maxFixedArity = 4;
  partial.cljs$lang$applyTo = partial__1606964.cljs$lang$applyTo;
  return partial
}();
cljs.core.fnil = function() {
  var fnil = null;
  var fnil__1606976 = function(f, x) {
    return function() {
      var G__1606980 = null;
      var G__1606980__1606981 = function(a) {
        return f.call(null, cljs.core.truth_(a === null) ? x : a)
      };
      var G__1606980__1606982 = function(a, b) {
        return f.call(null, cljs.core.truth_(a === null) ? x : a, b)
      };
      var G__1606980__1606983 = function(a, b, c) {
        return f.call(null, cljs.core.truth_(a === null) ? x : a, b, c)
      };
      var G__1606980__1606984 = function() {
        var G__1606986__delegate = function(a, b, c, ds) {
          return cljs.core.apply.call(null, f, cljs.core.truth_(a === null) ? x : a, b, c, ds)
        };
        var G__1606986 = function(a, b, c, var_args) {
          var ds = null;
          if(goog.isDef(var_args)) {
            ds = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1606986__delegate.call(this, a, b, c, ds)
        };
        G__1606986.cljs$lang$maxFixedArity = 3;
        G__1606986.cljs$lang$applyTo = function(arglist__1606987) {
          var a = cljs.core.first(arglist__1606987);
          var b = cljs.core.first(cljs.core.next(arglist__1606987));
          var c = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1606987)));
          var ds = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1606987)));
          return G__1606986__delegate.call(this, a, b, c, ds)
        };
        return G__1606986
      }();
      G__1606980 = function(a, b, c, var_args) {
        var ds = var_args;
        switch(arguments.length) {
          case 1:
            return G__1606980__1606981.call(this, a);
          case 2:
            return G__1606980__1606982.call(this, a, b);
          case 3:
            return G__1606980__1606983.call(this, a, b, c);
          default:
            return G__1606980__1606984.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      G__1606980.cljs$lang$maxFixedArity = 3;
      G__1606980.cljs$lang$applyTo = G__1606980__1606984.cljs$lang$applyTo;
      return G__1606980
    }()
  };
  var fnil__1606977 = function(f, x, y) {
    return function() {
      var G__1606988 = null;
      var G__1606988__1606989 = function(a, b) {
        return f.call(null, cljs.core.truth_(a === null) ? x : a, cljs.core.truth_(b === null) ? y : b)
      };
      var G__1606988__1606990 = function(a, b, c) {
        return f.call(null, cljs.core.truth_(a === null) ? x : a, cljs.core.truth_(b === null) ? y : b, c)
      };
      var G__1606988__1606991 = function() {
        var G__1606993__delegate = function(a, b, c, ds) {
          return cljs.core.apply.call(null, f, cljs.core.truth_(a === null) ? x : a, cljs.core.truth_(b === null) ? y : b, c, ds)
        };
        var G__1606993 = function(a, b, c, var_args) {
          var ds = null;
          if(goog.isDef(var_args)) {
            ds = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1606993__delegate.call(this, a, b, c, ds)
        };
        G__1606993.cljs$lang$maxFixedArity = 3;
        G__1606993.cljs$lang$applyTo = function(arglist__1606994) {
          var a = cljs.core.first(arglist__1606994);
          var b = cljs.core.first(cljs.core.next(arglist__1606994));
          var c = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1606994)));
          var ds = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1606994)));
          return G__1606993__delegate.call(this, a, b, c, ds)
        };
        return G__1606993
      }();
      G__1606988 = function(a, b, c, var_args) {
        var ds = var_args;
        switch(arguments.length) {
          case 2:
            return G__1606988__1606989.call(this, a, b);
          case 3:
            return G__1606988__1606990.call(this, a, b, c);
          default:
            return G__1606988__1606991.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      G__1606988.cljs$lang$maxFixedArity = 3;
      G__1606988.cljs$lang$applyTo = G__1606988__1606991.cljs$lang$applyTo;
      return G__1606988
    }()
  };
  var fnil__1606978 = function(f, x, y, z) {
    return function() {
      var G__1606995 = null;
      var G__1606995__1606996 = function(a, b) {
        return f.call(null, cljs.core.truth_(a === null) ? x : a, cljs.core.truth_(b === null) ? y : b)
      };
      var G__1606995__1606997 = function(a, b, c) {
        return f.call(null, cljs.core.truth_(a === null) ? x : a, cljs.core.truth_(b === null) ? y : b, cljs.core.truth_(c === null) ? z : c)
      };
      var G__1606995__1606998 = function() {
        var G__1607000__delegate = function(a, b, c, ds) {
          return cljs.core.apply.call(null, f, cljs.core.truth_(a === null) ? x : a, cljs.core.truth_(b === null) ? y : b, cljs.core.truth_(c === null) ? z : c, ds)
        };
        var G__1607000 = function(a, b, c, var_args) {
          var ds = null;
          if(goog.isDef(var_args)) {
            ds = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1607000__delegate.call(this, a, b, c, ds)
        };
        G__1607000.cljs$lang$maxFixedArity = 3;
        G__1607000.cljs$lang$applyTo = function(arglist__1607001) {
          var a = cljs.core.first(arglist__1607001);
          var b = cljs.core.first(cljs.core.next(arglist__1607001));
          var c = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607001)));
          var ds = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607001)));
          return G__1607000__delegate.call(this, a, b, c, ds)
        };
        return G__1607000
      }();
      G__1606995 = function(a, b, c, var_args) {
        var ds = var_args;
        switch(arguments.length) {
          case 2:
            return G__1606995__1606996.call(this, a, b);
          case 3:
            return G__1606995__1606997.call(this, a, b, c);
          default:
            return G__1606995__1606998.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      G__1606995.cljs$lang$maxFixedArity = 3;
      G__1606995.cljs$lang$applyTo = G__1606995__1606998.cljs$lang$applyTo;
      return G__1606995
    }()
  };
  fnil = function(f, x, y, z) {
    switch(arguments.length) {
      case 2:
        return fnil__1606976.call(this, f, x);
      case 3:
        return fnil__1606977.call(this, f, x, y);
      case 4:
        return fnil__1606978.call(this, f, x, y, z)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return fnil
}();
cljs.core.map_indexed = function map_indexed(f, coll) {
  var mapi__1607004 = function mpi(idx, coll) {
    return new cljs.core.LazySeq(null, false, function() {
      var temp__3698__auto____1607002 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(temp__3698__auto____1607002)) {
        var s__1607003 = temp__3698__auto____1607002;
        return cljs.core.cons.call(null, f.call(null, idx, cljs.core.first.call(null, s__1607003)), mpi.call(null, idx + 1, cljs.core.rest.call(null, s__1607003)))
      }else {
        return null
      }
    })
  };
  return mapi__1607004.call(null, 0, coll)
};
cljs.core.keep = function keep(f, coll) {
  return new cljs.core.LazySeq(null, false, function() {
    var temp__3698__auto____1607005 = cljs.core.seq.call(null, coll);
    if(cljs.core.truth_(temp__3698__auto____1607005)) {
      var s__1607006 = temp__3698__auto____1607005;
      var x__1607007 = f.call(null, cljs.core.first.call(null, s__1607006));
      if(cljs.core.truth_(x__1607007 === null)) {
        return keep.call(null, f, cljs.core.rest.call(null, s__1607006))
      }else {
        return cljs.core.cons.call(null, x__1607007, keep.call(null, f, cljs.core.rest.call(null, s__1607006)))
      }
    }else {
      return null
    }
  })
};
cljs.core.keep_indexed = function keep_indexed(f, coll) {
  var keepi__1607017 = function kpi(idx, coll) {
    return new cljs.core.LazySeq(null, false, function() {
      var temp__3698__auto____1607014 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(temp__3698__auto____1607014)) {
        var s__1607015 = temp__3698__auto____1607014;
        var x__1607016 = f.call(null, idx, cljs.core.first.call(null, s__1607015));
        if(cljs.core.truth_(x__1607016 === null)) {
          return kpi.call(null, idx + 1, cljs.core.rest.call(null, s__1607015))
        }else {
          return cljs.core.cons.call(null, x__1607016, kpi.call(null, idx + 1, cljs.core.rest.call(null, s__1607015)))
        }
      }else {
        return null
      }
    })
  };
  return keepi__1607017.call(null, 0, coll)
};
cljs.core.every_pred = function() {
  var every_pred = null;
  var every_pred__1607062 = function(p) {
    return function() {
      var ep1 = null;
      var ep1__1607067 = function() {
        return true
      };
      var ep1__1607068 = function(x) {
        return cljs.core.boolean$.call(null, p.call(null, x))
      };
      var ep1__1607069 = function(x, y) {
        return cljs.core.boolean$.call(null, function() {
          var and__3546__auto____1607024 = p.call(null, x);
          if(cljs.core.truth_(and__3546__auto____1607024)) {
            return p.call(null, y)
          }else {
            return and__3546__auto____1607024
          }
        }())
      };
      var ep1__1607070 = function(x, y, z) {
        return cljs.core.boolean$.call(null, function() {
          var and__3546__auto____1607025 = p.call(null, x);
          if(cljs.core.truth_(and__3546__auto____1607025)) {
            var and__3546__auto____1607026 = p.call(null, y);
            if(cljs.core.truth_(and__3546__auto____1607026)) {
              return p.call(null, z)
            }else {
              return and__3546__auto____1607026
            }
          }else {
            return and__3546__auto____1607025
          }
        }())
      };
      var ep1__1607071 = function() {
        var G__1607073__delegate = function(x, y, z, args) {
          return cljs.core.boolean$.call(null, function() {
            var and__3546__auto____1607027 = ep1.call(null, x, y, z);
            if(cljs.core.truth_(and__3546__auto____1607027)) {
              return cljs.core.every_QMARK_.call(null, p, args)
            }else {
              return and__3546__auto____1607027
            }
          }())
        };
        var G__1607073 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1607073__delegate.call(this, x, y, z, args)
        };
        G__1607073.cljs$lang$maxFixedArity = 3;
        G__1607073.cljs$lang$applyTo = function(arglist__1607074) {
          var x = cljs.core.first(arglist__1607074);
          var y = cljs.core.first(cljs.core.next(arglist__1607074));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607074)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607074)));
          return G__1607073__delegate.call(this, x, y, z, args)
        };
        return G__1607073
      }();
      ep1 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return ep1__1607067.call(this);
          case 1:
            return ep1__1607068.call(this, x);
          case 2:
            return ep1__1607069.call(this, x, y);
          case 3:
            return ep1__1607070.call(this, x, y, z);
          default:
            return ep1__1607071.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      ep1.cljs$lang$maxFixedArity = 3;
      ep1.cljs$lang$applyTo = ep1__1607071.cljs$lang$applyTo;
      return ep1
    }()
  };
  var every_pred__1607063 = function(p1, p2) {
    return function() {
      var ep2 = null;
      var ep2__1607075 = function() {
        return true
      };
      var ep2__1607076 = function(x) {
        return cljs.core.boolean$.call(null, function() {
          var and__3546__auto____1607028 = p1.call(null, x);
          if(cljs.core.truth_(and__3546__auto____1607028)) {
            return p2.call(null, x)
          }else {
            return and__3546__auto____1607028
          }
        }())
      };
      var ep2__1607077 = function(x, y) {
        return cljs.core.boolean$.call(null, function() {
          var and__3546__auto____1607029 = p1.call(null, x);
          if(cljs.core.truth_(and__3546__auto____1607029)) {
            var and__3546__auto____1607030 = p1.call(null, y);
            if(cljs.core.truth_(and__3546__auto____1607030)) {
              var and__3546__auto____1607031 = p2.call(null, x);
              if(cljs.core.truth_(and__3546__auto____1607031)) {
                return p2.call(null, y)
              }else {
                return and__3546__auto____1607031
              }
            }else {
              return and__3546__auto____1607030
            }
          }else {
            return and__3546__auto____1607029
          }
        }())
      };
      var ep2__1607078 = function(x, y, z) {
        return cljs.core.boolean$.call(null, function() {
          var and__3546__auto____1607032 = p1.call(null, x);
          if(cljs.core.truth_(and__3546__auto____1607032)) {
            var and__3546__auto____1607033 = p1.call(null, y);
            if(cljs.core.truth_(and__3546__auto____1607033)) {
              var and__3546__auto____1607034 = p1.call(null, z);
              if(cljs.core.truth_(and__3546__auto____1607034)) {
                var and__3546__auto____1607035 = p2.call(null, x);
                if(cljs.core.truth_(and__3546__auto____1607035)) {
                  var and__3546__auto____1607036 = p2.call(null, y);
                  if(cljs.core.truth_(and__3546__auto____1607036)) {
                    return p2.call(null, z)
                  }else {
                    return and__3546__auto____1607036
                  }
                }else {
                  return and__3546__auto____1607035
                }
              }else {
                return and__3546__auto____1607034
              }
            }else {
              return and__3546__auto____1607033
            }
          }else {
            return and__3546__auto____1607032
          }
        }())
      };
      var ep2__1607079 = function() {
        var G__1607081__delegate = function(x, y, z, args) {
          return cljs.core.boolean$.call(null, function() {
            var and__3546__auto____1607037 = ep2.call(null, x, y, z);
            if(cljs.core.truth_(and__3546__auto____1607037)) {
              return cljs.core.every_QMARK_.call(null, function(p1__1607008_SHARP_) {
                var and__3546__auto____1607038 = p1.call(null, p1__1607008_SHARP_);
                if(cljs.core.truth_(and__3546__auto____1607038)) {
                  return p2.call(null, p1__1607008_SHARP_)
                }else {
                  return and__3546__auto____1607038
                }
              }, args)
            }else {
              return and__3546__auto____1607037
            }
          }())
        };
        var G__1607081 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1607081__delegate.call(this, x, y, z, args)
        };
        G__1607081.cljs$lang$maxFixedArity = 3;
        G__1607081.cljs$lang$applyTo = function(arglist__1607082) {
          var x = cljs.core.first(arglist__1607082);
          var y = cljs.core.first(cljs.core.next(arglist__1607082));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607082)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607082)));
          return G__1607081__delegate.call(this, x, y, z, args)
        };
        return G__1607081
      }();
      ep2 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return ep2__1607075.call(this);
          case 1:
            return ep2__1607076.call(this, x);
          case 2:
            return ep2__1607077.call(this, x, y);
          case 3:
            return ep2__1607078.call(this, x, y, z);
          default:
            return ep2__1607079.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      ep2.cljs$lang$maxFixedArity = 3;
      ep2.cljs$lang$applyTo = ep2__1607079.cljs$lang$applyTo;
      return ep2
    }()
  };
  var every_pred__1607064 = function(p1, p2, p3) {
    return function() {
      var ep3 = null;
      var ep3__1607083 = function() {
        return true
      };
      var ep3__1607084 = function(x) {
        return cljs.core.boolean$.call(null, function() {
          var and__3546__auto____1607039 = p1.call(null, x);
          if(cljs.core.truth_(and__3546__auto____1607039)) {
            var and__3546__auto____1607040 = p2.call(null, x);
            if(cljs.core.truth_(and__3546__auto____1607040)) {
              return p3.call(null, x)
            }else {
              return and__3546__auto____1607040
            }
          }else {
            return and__3546__auto____1607039
          }
        }())
      };
      var ep3__1607085 = function(x, y) {
        return cljs.core.boolean$.call(null, function() {
          var and__3546__auto____1607041 = p1.call(null, x);
          if(cljs.core.truth_(and__3546__auto____1607041)) {
            var and__3546__auto____1607042 = p2.call(null, x);
            if(cljs.core.truth_(and__3546__auto____1607042)) {
              var and__3546__auto____1607043 = p3.call(null, x);
              if(cljs.core.truth_(and__3546__auto____1607043)) {
                var and__3546__auto____1607044 = p1.call(null, y);
                if(cljs.core.truth_(and__3546__auto____1607044)) {
                  var and__3546__auto____1607045 = p2.call(null, y);
                  if(cljs.core.truth_(and__3546__auto____1607045)) {
                    return p3.call(null, y)
                  }else {
                    return and__3546__auto____1607045
                  }
                }else {
                  return and__3546__auto____1607044
                }
              }else {
                return and__3546__auto____1607043
              }
            }else {
              return and__3546__auto____1607042
            }
          }else {
            return and__3546__auto____1607041
          }
        }())
      };
      var ep3__1607086 = function(x, y, z) {
        return cljs.core.boolean$.call(null, function() {
          var and__3546__auto____1607046 = p1.call(null, x);
          if(cljs.core.truth_(and__3546__auto____1607046)) {
            var and__3546__auto____1607047 = p2.call(null, x);
            if(cljs.core.truth_(and__3546__auto____1607047)) {
              var and__3546__auto____1607048 = p3.call(null, x);
              if(cljs.core.truth_(and__3546__auto____1607048)) {
                var and__3546__auto____1607049 = p1.call(null, y);
                if(cljs.core.truth_(and__3546__auto____1607049)) {
                  var and__3546__auto____1607050 = p2.call(null, y);
                  if(cljs.core.truth_(and__3546__auto____1607050)) {
                    var and__3546__auto____1607051 = p3.call(null, y);
                    if(cljs.core.truth_(and__3546__auto____1607051)) {
                      var and__3546__auto____1607052 = p1.call(null, z);
                      if(cljs.core.truth_(and__3546__auto____1607052)) {
                        var and__3546__auto____1607053 = p2.call(null, z);
                        if(cljs.core.truth_(and__3546__auto____1607053)) {
                          return p3.call(null, z)
                        }else {
                          return and__3546__auto____1607053
                        }
                      }else {
                        return and__3546__auto____1607052
                      }
                    }else {
                      return and__3546__auto____1607051
                    }
                  }else {
                    return and__3546__auto____1607050
                  }
                }else {
                  return and__3546__auto____1607049
                }
              }else {
                return and__3546__auto____1607048
              }
            }else {
              return and__3546__auto____1607047
            }
          }else {
            return and__3546__auto____1607046
          }
        }())
      };
      var ep3__1607087 = function() {
        var G__1607089__delegate = function(x, y, z, args) {
          return cljs.core.boolean$.call(null, function() {
            var and__3546__auto____1607054 = ep3.call(null, x, y, z);
            if(cljs.core.truth_(and__3546__auto____1607054)) {
              return cljs.core.every_QMARK_.call(null, function(p1__1607009_SHARP_) {
                var and__3546__auto____1607055 = p1.call(null, p1__1607009_SHARP_);
                if(cljs.core.truth_(and__3546__auto____1607055)) {
                  var and__3546__auto____1607056 = p2.call(null, p1__1607009_SHARP_);
                  if(cljs.core.truth_(and__3546__auto____1607056)) {
                    return p3.call(null, p1__1607009_SHARP_)
                  }else {
                    return and__3546__auto____1607056
                  }
                }else {
                  return and__3546__auto____1607055
                }
              }, args)
            }else {
              return and__3546__auto____1607054
            }
          }())
        };
        var G__1607089 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1607089__delegate.call(this, x, y, z, args)
        };
        G__1607089.cljs$lang$maxFixedArity = 3;
        G__1607089.cljs$lang$applyTo = function(arglist__1607090) {
          var x = cljs.core.first(arglist__1607090);
          var y = cljs.core.first(cljs.core.next(arglist__1607090));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607090)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607090)));
          return G__1607089__delegate.call(this, x, y, z, args)
        };
        return G__1607089
      }();
      ep3 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return ep3__1607083.call(this);
          case 1:
            return ep3__1607084.call(this, x);
          case 2:
            return ep3__1607085.call(this, x, y);
          case 3:
            return ep3__1607086.call(this, x, y, z);
          default:
            return ep3__1607087.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      ep3.cljs$lang$maxFixedArity = 3;
      ep3.cljs$lang$applyTo = ep3__1607087.cljs$lang$applyTo;
      return ep3
    }()
  };
  var every_pred__1607065 = function() {
    var G__1607091__delegate = function(p1, p2, p3, ps) {
      var ps__1607057 = cljs.core.list_STAR_.call(null, p1, p2, p3, ps);
      return function() {
        var epn = null;
        var epn__1607092 = function() {
          return true
        };
        var epn__1607093 = function(x) {
          return cljs.core.every_QMARK_.call(null, function(p1__1607010_SHARP_) {
            return p1__1607010_SHARP_.call(null, x)
          }, ps__1607057)
        };
        var epn__1607094 = function(x, y) {
          return cljs.core.every_QMARK_.call(null, function(p1__1607011_SHARP_) {
            var and__3546__auto____1607058 = p1__1607011_SHARP_.call(null, x);
            if(cljs.core.truth_(and__3546__auto____1607058)) {
              return p1__1607011_SHARP_.call(null, y)
            }else {
              return and__3546__auto____1607058
            }
          }, ps__1607057)
        };
        var epn__1607095 = function(x, y, z) {
          return cljs.core.every_QMARK_.call(null, function(p1__1607012_SHARP_) {
            var and__3546__auto____1607059 = p1__1607012_SHARP_.call(null, x);
            if(cljs.core.truth_(and__3546__auto____1607059)) {
              var and__3546__auto____1607060 = p1__1607012_SHARP_.call(null, y);
              if(cljs.core.truth_(and__3546__auto____1607060)) {
                return p1__1607012_SHARP_.call(null, z)
              }else {
                return and__3546__auto____1607060
              }
            }else {
              return and__3546__auto____1607059
            }
          }, ps__1607057)
        };
        var epn__1607096 = function() {
          var G__1607098__delegate = function(x, y, z, args) {
            return cljs.core.boolean$.call(null, function() {
              var and__3546__auto____1607061 = epn.call(null, x, y, z);
              if(cljs.core.truth_(and__3546__auto____1607061)) {
                return cljs.core.every_QMARK_.call(null, function(p1__1607013_SHARP_) {
                  return cljs.core.every_QMARK_.call(null, p1__1607013_SHARP_, args)
                }, ps__1607057)
              }else {
                return and__3546__auto____1607061
              }
            }())
          };
          var G__1607098 = function(x, y, z, var_args) {
            var args = null;
            if(goog.isDef(var_args)) {
              args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
            }
            return G__1607098__delegate.call(this, x, y, z, args)
          };
          G__1607098.cljs$lang$maxFixedArity = 3;
          G__1607098.cljs$lang$applyTo = function(arglist__1607099) {
            var x = cljs.core.first(arglist__1607099);
            var y = cljs.core.first(cljs.core.next(arglist__1607099));
            var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607099)));
            var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607099)));
            return G__1607098__delegate.call(this, x, y, z, args)
          };
          return G__1607098
        }();
        epn = function(x, y, z, var_args) {
          var args = var_args;
          switch(arguments.length) {
            case 0:
              return epn__1607092.call(this);
            case 1:
              return epn__1607093.call(this, x);
            case 2:
              return epn__1607094.call(this, x, y);
            case 3:
              return epn__1607095.call(this, x, y, z);
            default:
              return epn__1607096.apply(this, arguments)
          }
          throw"Invalid arity: " + arguments.length;
        };
        epn.cljs$lang$maxFixedArity = 3;
        epn.cljs$lang$applyTo = epn__1607096.cljs$lang$applyTo;
        return epn
      }()
    };
    var G__1607091 = function(p1, p2, p3, var_args) {
      var ps = null;
      if(goog.isDef(var_args)) {
        ps = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
      }
      return G__1607091__delegate.call(this, p1, p2, p3, ps)
    };
    G__1607091.cljs$lang$maxFixedArity = 3;
    G__1607091.cljs$lang$applyTo = function(arglist__1607100) {
      var p1 = cljs.core.first(arglist__1607100);
      var p2 = cljs.core.first(cljs.core.next(arglist__1607100));
      var p3 = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607100)));
      var ps = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607100)));
      return G__1607091__delegate.call(this, p1, p2, p3, ps)
    };
    return G__1607091
  }();
  every_pred = function(p1, p2, p3, var_args) {
    var ps = var_args;
    switch(arguments.length) {
      case 1:
        return every_pred__1607062.call(this, p1);
      case 2:
        return every_pred__1607063.call(this, p1, p2);
      case 3:
        return every_pred__1607064.call(this, p1, p2, p3);
      default:
        return every_pred__1607065.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  every_pred.cljs$lang$maxFixedArity = 3;
  every_pred.cljs$lang$applyTo = every_pred__1607065.cljs$lang$applyTo;
  return every_pred
}();
cljs.core.some_fn = function() {
  var some_fn = null;
  var some_fn__1607140 = function(p) {
    return function() {
      var sp1 = null;
      var sp1__1607145 = function() {
        return null
      };
      var sp1__1607146 = function(x) {
        return p.call(null, x)
      };
      var sp1__1607147 = function(x, y) {
        var or__3548__auto____1607102 = p.call(null, x);
        if(cljs.core.truth_(or__3548__auto____1607102)) {
          return or__3548__auto____1607102
        }else {
          return p.call(null, y)
        }
      };
      var sp1__1607148 = function(x, y, z) {
        var or__3548__auto____1607103 = p.call(null, x);
        if(cljs.core.truth_(or__3548__auto____1607103)) {
          return or__3548__auto____1607103
        }else {
          var or__3548__auto____1607104 = p.call(null, y);
          if(cljs.core.truth_(or__3548__auto____1607104)) {
            return or__3548__auto____1607104
          }else {
            return p.call(null, z)
          }
        }
      };
      var sp1__1607149 = function() {
        var G__1607151__delegate = function(x, y, z, args) {
          var or__3548__auto____1607105 = sp1.call(null, x, y, z);
          if(cljs.core.truth_(or__3548__auto____1607105)) {
            return or__3548__auto____1607105
          }else {
            return cljs.core.some.call(null, p, args)
          }
        };
        var G__1607151 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1607151__delegate.call(this, x, y, z, args)
        };
        G__1607151.cljs$lang$maxFixedArity = 3;
        G__1607151.cljs$lang$applyTo = function(arglist__1607152) {
          var x = cljs.core.first(arglist__1607152);
          var y = cljs.core.first(cljs.core.next(arglist__1607152));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607152)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607152)));
          return G__1607151__delegate.call(this, x, y, z, args)
        };
        return G__1607151
      }();
      sp1 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return sp1__1607145.call(this);
          case 1:
            return sp1__1607146.call(this, x);
          case 2:
            return sp1__1607147.call(this, x, y);
          case 3:
            return sp1__1607148.call(this, x, y, z);
          default:
            return sp1__1607149.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      sp1.cljs$lang$maxFixedArity = 3;
      sp1.cljs$lang$applyTo = sp1__1607149.cljs$lang$applyTo;
      return sp1
    }()
  };
  var some_fn__1607141 = function(p1, p2) {
    return function() {
      var sp2 = null;
      var sp2__1607153 = function() {
        return null
      };
      var sp2__1607154 = function(x) {
        var or__3548__auto____1607106 = p1.call(null, x);
        if(cljs.core.truth_(or__3548__auto____1607106)) {
          return or__3548__auto____1607106
        }else {
          return p2.call(null, x)
        }
      };
      var sp2__1607155 = function(x, y) {
        var or__3548__auto____1607107 = p1.call(null, x);
        if(cljs.core.truth_(or__3548__auto____1607107)) {
          return or__3548__auto____1607107
        }else {
          var or__3548__auto____1607108 = p1.call(null, y);
          if(cljs.core.truth_(or__3548__auto____1607108)) {
            return or__3548__auto____1607108
          }else {
            var or__3548__auto____1607109 = p2.call(null, x);
            if(cljs.core.truth_(or__3548__auto____1607109)) {
              return or__3548__auto____1607109
            }else {
              return p2.call(null, y)
            }
          }
        }
      };
      var sp2__1607156 = function(x, y, z) {
        var or__3548__auto____1607110 = p1.call(null, x);
        if(cljs.core.truth_(or__3548__auto____1607110)) {
          return or__3548__auto____1607110
        }else {
          var or__3548__auto____1607111 = p1.call(null, y);
          if(cljs.core.truth_(or__3548__auto____1607111)) {
            return or__3548__auto____1607111
          }else {
            var or__3548__auto____1607112 = p1.call(null, z);
            if(cljs.core.truth_(or__3548__auto____1607112)) {
              return or__3548__auto____1607112
            }else {
              var or__3548__auto____1607113 = p2.call(null, x);
              if(cljs.core.truth_(or__3548__auto____1607113)) {
                return or__3548__auto____1607113
              }else {
                var or__3548__auto____1607114 = p2.call(null, y);
                if(cljs.core.truth_(or__3548__auto____1607114)) {
                  return or__3548__auto____1607114
                }else {
                  return p2.call(null, z)
                }
              }
            }
          }
        }
      };
      var sp2__1607157 = function() {
        var G__1607159__delegate = function(x, y, z, args) {
          var or__3548__auto____1607115 = sp2.call(null, x, y, z);
          if(cljs.core.truth_(or__3548__auto____1607115)) {
            return or__3548__auto____1607115
          }else {
            return cljs.core.some.call(null, function(p1__1607018_SHARP_) {
              var or__3548__auto____1607116 = p1.call(null, p1__1607018_SHARP_);
              if(cljs.core.truth_(or__3548__auto____1607116)) {
                return or__3548__auto____1607116
              }else {
                return p2.call(null, p1__1607018_SHARP_)
              }
            }, args)
          }
        };
        var G__1607159 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1607159__delegate.call(this, x, y, z, args)
        };
        G__1607159.cljs$lang$maxFixedArity = 3;
        G__1607159.cljs$lang$applyTo = function(arglist__1607160) {
          var x = cljs.core.first(arglist__1607160);
          var y = cljs.core.first(cljs.core.next(arglist__1607160));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607160)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607160)));
          return G__1607159__delegate.call(this, x, y, z, args)
        };
        return G__1607159
      }();
      sp2 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return sp2__1607153.call(this);
          case 1:
            return sp2__1607154.call(this, x);
          case 2:
            return sp2__1607155.call(this, x, y);
          case 3:
            return sp2__1607156.call(this, x, y, z);
          default:
            return sp2__1607157.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      sp2.cljs$lang$maxFixedArity = 3;
      sp2.cljs$lang$applyTo = sp2__1607157.cljs$lang$applyTo;
      return sp2
    }()
  };
  var some_fn__1607142 = function(p1, p2, p3) {
    return function() {
      var sp3 = null;
      var sp3__1607161 = function() {
        return null
      };
      var sp3__1607162 = function(x) {
        var or__3548__auto____1607117 = p1.call(null, x);
        if(cljs.core.truth_(or__3548__auto____1607117)) {
          return or__3548__auto____1607117
        }else {
          var or__3548__auto____1607118 = p2.call(null, x);
          if(cljs.core.truth_(or__3548__auto____1607118)) {
            return or__3548__auto____1607118
          }else {
            return p3.call(null, x)
          }
        }
      };
      var sp3__1607163 = function(x, y) {
        var or__3548__auto____1607119 = p1.call(null, x);
        if(cljs.core.truth_(or__3548__auto____1607119)) {
          return or__3548__auto____1607119
        }else {
          var or__3548__auto____1607120 = p2.call(null, x);
          if(cljs.core.truth_(or__3548__auto____1607120)) {
            return or__3548__auto____1607120
          }else {
            var or__3548__auto____1607121 = p3.call(null, x);
            if(cljs.core.truth_(or__3548__auto____1607121)) {
              return or__3548__auto____1607121
            }else {
              var or__3548__auto____1607122 = p1.call(null, y);
              if(cljs.core.truth_(or__3548__auto____1607122)) {
                return or__3548__auto____1607122
              }else {
                var or__3548__auto____1607123 = p2.call(null, y);
                if(cljs.core.truth_(or__3548__auto____1607123)) {
                  return or__3548__auto____1607123
                }else {
                  return p3.call(null, y)
                }
              }
            }
          }
        }
      };
      var sp3__1607164 = function(x, y, z) {
        var or__3548__auto____1607124 = p1.call(null, x);
        if(cljs.core.truth_(or__3548__auto____1607124)) {
          return or__3548__auto____1607124
        }else {
          var or__3548__auto____1607125 = p2.call(null, x);
          if(cljs.core.truth_(or__3548__auto____1607125)) {
            return or__3548__auto____1607125
          }else {
            var or__3548__auto____1607126 = p3.call(null, x);
            if(cljs.core.truth_(or__3548__auto____1607126)) {
              return or__3548__auto____1607126
            }else {
              var or__3548__auto____1607127 = p1.call(null, y);
              if(cljs.core.truth_(or__3548__auto____1607127)) {
                return or__3548__auto____1607127
              }else {
                var or__3548__auto____1607128 = p2.call(null, y);
                if(cljs.core.truth_(or__3548__auto____1607128)) {
                  return or__3548__auto____1607128
                }else {
                  var or__3548__auto____1607129 = p3.call(null, y);
                  if(cljs.core.truth_(or__3548__auto____1607129)) {
                    return or__3548__auto____1607129
                  }else {
                    var or__3548__auto____1607130 = p1.call(null, z);
                    if(cljs.core.truth_(or__3548__auto____1607130)) {
                      return or__3548__auto____1607130
                    }else {
                      var or__3548__auto____1607131 = p2.call(null, z);
                      if(cljs.core.truth_(or__3548__auto____1607131)) {
                        return or__3548__auto____1607131
                      }else {
                        return p3.call(null, z)
                      }
                    }
                  }
                }
              }
            }
          }
        }
      };
      var sp3__1607165 = function() {
        var G__1607167__delegate = function(x, y, z, args) {
          var or__3548__auto____1607132 = sp3.call(null, x, y, z);
          if(cljs.core.truth_(or__3548__auto____1607132)) {
            return or__3548__auto____1607132
          }else {
            return cljs.core.some.call(null, function(p1__1607019_SHARP_) {
              var or__3548__auto____1607133 = p1.call(null, p1__1607019_SHARP_);
              if(cljs.core.truth_(or__3548__auto____1607133)) {
                return or__3548__auto____1607133
              }else {
                var or__3548__auto____1607134 = p2.call(null, p1__1607019_SHARP_);
                if(cljs.core.truth_(or__3548__auto____1607134)) {
                  return or__3548__auto____1607134
                }else {
                  return p3.call(null, p1__1607019_SHARP_)
                }
              }
            }, args)
          }
        };
        var G__1607167 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1607167__delegate.call(this, x, y, z, args)
        };
        G__1607167.cljs$lang$maxFixedArity = 3;
        G__1607167.cljs$lang$applyTo = function(arglist__1607168) {
          var x = cljs.core.first(arglist__1607168);
          var y = cljs.core.first(cljs.core.next(arglist__1607168));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607168)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607168)));
          return G__1607167__delegate.call(this, x, y, z, args)
        };
        return G__1607167
      }();
      sp3 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return sp3__1607161.call(this);
          case 1:
            return sp3__1607162.call(this, x);
          case 2:
            return sp3__1607163.call(this, x, y);
          case 3:
            return sp3__1607164.call(this, x, y, z);
          default:
            return sp3__1607165.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      sp3.cljs$lang$maxFixedArity = 3;
      sp3.cljs$lang$applyTo = sp3__1607165.cljs$lang$applyTo;
      return sp3
    }()
  };
  var some_fn__1607143 = function() {
    var G__1607169__delegate = function(p1, p2, p3, ps) {
      var ps__1607135 = cljs.core.list_STAR_.call(null, p1, p2, p3, ps);
      return function() {
        var spn = null;
        var spn__1607170 = function() {
          return null
        };
        var spn__1607171 = function(x) {
          return cljs.core.some.call(null, function(p1__1607020_SHARP_) {
            return p1__1607020_SHARP_.call(null, x)
          }, ps__1607135)
        };
        var spn__1607172 = function(x, y) {
          return cljs.core.some.call(null, function(p1__1607021_SHARP_) {
            var or__3548__auto____1607136 = p1__1607021_SHARP_.call(null, x);
            if(cljs.core.truth_(or__3548__auto____1607136)) {
              return or__3548__auto____1607136
            }else {
              return p1__1607021_SHARP_.call(null, y)
            }
          }, ps__1607135)
        };
        var spn__1607173 = function(x, y, z) {
          return cljs.core.some.call(null, function(p1__1607022_SHARP_) {
            var or__3548__auto____1607137 = p1__1607022_SHARP_.call(null, x);
            if(cljs.core.truth_(or__3548__auto____1607137)) {
              return or__3548__auto____1607137
            }else {
              var or__3548__auto____1607138 = p1__1607022_SHARP_.call(null, y);
              if(cljs.core.truth_(or__3548__auto____1607138)) {
                return or__3548__auto____1607138
              }else {
                return p1__1607022_SHARP_.call(null, z)
              }
            }
          }, ps__1607135)
        };
        var spn__1607174 = function() {
          var G__1607176__delegate = function(x, y, z, args) {
            var or__3548__auto____1607139 = spn.call(null, x, y, z);
            if(cljs.core.truth_(or__3548__auto____1607139)) {
              return or__3548__auto____1607139
            }else {
              return cljs.core.some.call(null, function(p1__1607023_SHARP_) {
                return cljs.core.some.call(null, p1__1607023_SHARP_, args)
              }, ps__1607135)
            }
          };
          var G__1607176 = function(x, y, z, var_args) {
            var args = null;
            if(goog.isDef(var_args)) {
              args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
            }
            return G__1607176__delegate.call(this, x, y, z, args)
          };
          G__1607176.cljs$lang$maxFixedArity = 3;
          G__1607176.cljs$lang$applyTo = function(arglist__1607177) {
            var x = cljs.core.first(arglist__1607177);
            var y = cljs.core.first(cljs.core.next(arglist__1607177));
            var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607177)));
            var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607177)));
            return G__1607176__delegate.call(this, x, y, z, args)
          };
          return G__1607176
        }();
        spn = function(x, y, z, var_args) {
          var args = var_args;
          switch(arguments.length) {
            case 0:
              return spn__1607170.call(this);
            case 1:
              return spn__1607171.call(this, x);
            case 2:
              return spn__1607172.call(this, x, y);
            case 3:
              return spn__1607173.call(this, x, y, z);
            default:
              return spn__1607174.apply(this, arguments)
          }
          throw"Invalid arity: " + arguments.length;
        };
        spn.cljs$lang$maxFixedArity = 3;
        spn.cljs$lang$applyTo = spn__1607174.cljs$lang$applyTo;
        return spn
      }()
    };
    var G__1607169 = function(p1, p2, p3, var_args) {
      var ps = null;
      if(goog.isDef(var_args)) {
        ps = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
      }
      return G__1607169__delegate.call(this, p1, p2, p3, ps)
    };
    G__1607169.cljs$lang$maxFixedArity = 3;
    G__1607169.cljs$lang$applyTo = function(arglist__1607178) {
      var p1 = cljs.core.first(arglist__1607178);
      var p2 = cljs.core.first(cljs.core.next(arglist__1607178));
      var p3 = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607178)));
      var ps = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607178)));
      return G__1607169__delegate.call(this, p1, p2, p3, ps)
    };
    return G__1607169
  }();
  some_fn = function(p1, p2, p3, var_args) {
    var ps = var_args;
    switch(arguments.length) {
      case 1:
        return some_fn__1607140.call(this, p1);
      case 2:
        return some_fn__1607141.call(this, p1, p2);
      case 3:
        return some_fn__1607142.call(this, p1, p2, p3);
      default:
        return some_fn__1607143.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  some_fn.cljs$lang$maxFixedArity = 3;
  some_fn.cljs$lang$applyTo = some_fn__1607143.cljs$lang$applyTo;
  return some_fn
}();
cljs.core.map = function() {
  var map = null;
  var map__1607191 = function(f, coll) {
    return new cljs.core.LazySeq(null, false, function() {
      var temp__3698__auto____1607179 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(temp__3698__auto____1607179)) {
        var s__1607180 = temp__3698__auto____1607179;
        return cljs.core.cons.call(null, f.call(null, cljs.core.first.call(null, s__1607180)), map.call(null, f, cljs.core.rest.call(null, s__1607180)))
      }else {
        return null
      }
    })
  };
  var map__1607192 = function(f, c1, c2) {
    return new cljs.core.LazySeq(null, false, function() {
      var s1__1607181 = cljs.core.seq.call(null, c1);
      var s2__1607182 = cljs.core.seq.call(null, c2);
      if(cljs.core.truth_(function() {
        var and__3546__auto____1607183 = s1__1607181;
        if(cljs.core.truth_(and__3546__auto____1607183)) {
          return s2__1607182
        }else {
          return and__3546__auto____1607183
        }
      }())) {
        return cljs.core.cons.call(null, f.call(null, cljs.core.first.call(null, s1__1607181), cljs.core.first.call(null, s2__1607182)), map.call(null, f, cljs.core.rest.call(null, s1__1607181), cljs.core.rest.call(null, s2__1607182)))
      }else {
        return null
      }
    })
  };
  var map__1607193 = function(f, c1, c2, c3) {
    return new cljs.core.LazySeq(null, false, function() {
      var s1__1607184 = cljs.core.seq.call(null, c1);
      var s2__1607185 = cljs.core.seq.call(null, c2);
      var s3__1607186 = cljs.core.seq.call(null, c3);
      if(cljs.core.truth_(function() {
        var and__3546__auto____1607187 = s1__1607184;
        if(cljs.core.truth_(and__3546__auto____1607187)) {
          var and__3546__auto____1607188 = s2__1607185;
          if(cljs.core.truth_(and__3546__auto____1607188)) {
            return s3__1607186
          }else {
            return and__3546__auto____1607188
          }
        }else {
          return and__3546__auto____1607187
        }
      }())) {
        return cljs.core.cons.call(null, f.call(null, cljs.core.first.call(null, s1__1607184), cljs.core.first.call(null, s2__1607185), cljs.core.first.call(null, s3__1607186)), map.call(null, f, cljs.core.rest.call(null, s1__1607184), cljs.core.rest.call(null, s2__1607185), cljs.core.rest.call(null, s3__1607186)))
      }else {
        return null
      }
    })
  };
  var map__1607194 = function() {
    var G__1607196__delegate = function(f, c1, c2, c3, colls) {
      var step__1607190 = function step(cs) {
        return new cljs.core.LazySeq(null, false, function() {
          var ss__1607189 = map.call(null, cljs.core.seq, cs);
          if(cljs.core.truth_(cljs.core.every_QMARK_.call(null, cljs.core.identity, ss__1607189))) {
            return cljs.core.cons.call(null, map.call(null, cljs.core.first, ss__1607189), step.call(null, map.call(null, cljs.core.rest, ss__1607189)))
          }else {
            return null
          }
        })
      };
      return map.call(null, function(p1__1607101_SHARP_) {
        return cljs.core.apply.call(null, f, p1__1607101_SHARP_)
      }, step__1607190.call(null, cljs.core.conj.call(null, colls, c3, c2, c1)))
    };
    var G__1607196 = function(f, c1, c2, c3, var_args) {
      var colls = null;
      if(goog.isDef(var_args)) {
        colls = cljs.core.array_seq(Array.prototype.slice.call(arguments, 4), 0)
      }
      return G__1607196__delegate.call(this, f, c1, c2, c3, colls)
    };
    G__1607196.cljs$lang$maxFixedArity = 4;
    G__1607196.cljs$lang$applyTo = function(arglist__1607197) {
      var f = cljs.core.first(arglist__1607197);
      var c1 = cljs.core.first(cljs.core.next(arglist__1607197));
      var c2 = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607197)));
      var c3 = cljs.core.first(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1607197))));
      var colls = cljs.core.rest(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1607197))));
      return G__1607196__delegate.call(this, f, c1, c2, c3, colls)
    };
    return G__1607196
  }();
  map = function(f, c1, c2, c3, var_args) {
    var colls = var_args;
    switch(arguments.length) {
      case 2:
        return map__1607191.call(this, f, c1);
      case 3:
        return map__1607192.call(this, f, c1, c2);
      case 4:
        return map__1607193.call(this, f, c1, c2, c3);
      default:
        return map__1607194.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  map.cljs$lang$maxFixedArity = 4;
  map.cljs$lang$applyTo = map__1607194.cljs$lang$applyTo;
  return map
}();
cljs.core.take = function take(n, coll) {
  return new cljs.core.LazySeq(null, false, function() {
    if(cljs.core.truth_(n > 0)) {
      var temp__3698__auto____1607198 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(temp__3698__auto____1607198)) {
        var s__1607199 = temp__3698__auto____1607198;
        return cljs.core.cons.call(null, cljs.core.first.call(null, s__1607199), take.call(null, n - 1, cljs.core.rest.call(null, s__1607199)))
      }else {
        return null
      }
    }else {
      return null
    }
  })
};
cljs.core.drop = function drop(n, coll) {
  var step__1607202 = function(n, coll) {
    while(true) {
      var s__1607200 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(function() {
        var and__3546__auto____1607201 = n > 0;
        if(cljs.core.truth_(and__3546__auto____1607201)) {
          return s__1607200
        }else {
          return and__3546__auto____1607201
        }
      }())) {
        var G__1607203 = n - 1;
        var G__1607204 = cljs.core.rest.call(null, s__1607200);
        n = G__1607203;
        coll = G__1607204;
        continue
      }else {
        return s__1607200
      }
      break
    }
  };
  return new cljs.core.LazySeq(null, false, function() {
    return step__1607202.call(null, n, coll)
  })
};
cljs.core.drop_last = function() {
  var drop_last = null;
  var drop_last__1607205 = function(s) {
    return drop_last.call(null, 1, s)
  };
  var drop_last__1607206 = function(n, s) {
    return cljs.core.map.call(null, function(x, _) {
      return x
    }, s, cljs.core.drop.call(null, n, s))
  };
  drop_last = function(n, s) {
    switch(arguments.length) {
      case 1:
        return drop_last__1607205.call(this, n);
      case 2:
        return drop_last__1607206.call(this, n, s)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return drop_last
}();
cljs.core.take_last = function take_last(n, coll) {
  var s__1607208 = cljs.core.seq.call(null, coll);
  var lead__1607209 = cljs.core.seq.call(null, cljs.core.drop.call(null, n, coll));
  while(true) {
    if(cljs.core.truth_(lead__1607209)) {
      var G__1607210 = cljs.core.next.call(null, s__1607208);
      var G__1607211 = cljs.core.next.call(null, lead__1607209);
      s__1607208 = G__1607210;
      lead__1607209 = G__1607211;
      continue
    }else {
      return s__1607208
    }
    break
  }
};
cljs.core.drop_while = function drop_while(pred, coll) {
  var step__1607214 = function(pred, coll) {
    while(true) {
      var s__1607212 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(function() {
        var and__3546__auto____1607213 = s__1607212;
        if(cljs.core.truth_(and__3546__auto____1607213)) {
          return pred.call(null, cljs.core.first.call(null, s__1607212))
        }else {
          return and__3546__auto____1607213
        }
      }())) {
        var G__1607215 = pred;
        var G__1607216 = cljs.core.rest.call(null, s__1607212);
        pred = G__1607215;
        coll = G__1607216;
        continue
      }else {
        return s__1607212
      }
      break
    }
  };
  return new cljs.core.LazySeq(null, false, function() {
    return step__1607214.call(null, pred, coll)
  })
};
cljs.core.cycle = function cycle(coll) {
  return new cljs.core.LazySeq(null, false, function() {
    var temp__3698__auto____1607217 = cljs.core.seq.call(null, coll);
    if(cljs.core.truth_(temp__3698__auto____1607217)) {
      var s__1607218 = temp__3698__auto____1607217;
      return cljs.core.concat.call(null, s__1607218, cycle.call(null, s__1607218))
    }else {
      return null
    }
  })
};
cljs.core.split_at = function split_at(n, coll) {
  return cljs.core.PersistentVector.fromArray([cljs.core.take.call(null, n, coll), cljs.core.drop.call(null, n, coll)])
};
cljs.core.repeat = function() {
  var repeat = null;
  var repeat__1607219 = function(x) {
    return new cljs.core.LazySeq(null, false, function() {
      return cljs.core.cons.call(null, x, repeat.call(null, x))
    })
  };
  var repeat__1607220 = function(n, x) {
    return cljs.core.take.call(null, n, repeat.call(null, x))
  };
  repeat = function(n, x) {
    switch(arguments.length) {
      case 1:
        return repeat__1607219.call(this, n);
      case 2:
        return repeat__1607220.call(this, n, x)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return repeat
}();
cljs.core.replicate = function replicate(n, x) {
  return cljs.core.take.call(null, n, cljs.core.repeat.call(null, x))
};
cljs.core.repeatedly = function() {
  var repeatedly = null;
  var repeatedly__1607222 = function(f) {
    return new cljs.core.LazySeq(null, false, function() {
      return cljs.core.cons.call(null, f.call(null), repeatedly.call(null, f))
    })
  };
  var repeatedly__1607223 = function(n, f) {
    return cljs.core.take.call(null, n, repeatedly.call(null, f))
  };
  repeatedly = function(n, f) {
    switch(arguments.length) {
      case 1:
        return repeatedly__1607222.call(this, n);
      case 2:
        return repeatedly__1607223.call(this, n, f)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return repeatedly
}();
cljs.core.iterate = function iterate(f, x) {
  return cljs.core.cons.call(null, x, new cljs.core.LazySeq(null, false, function() {
    return iterate.call(null, f, f.call(null, x))
  }))
};
cljs.core.interleave = function() {
  var interleave = null;
  var interleave__1607229 = function(c1, c2) {
    return new cljs.core.LazySeq(null, false, function() {
      var s1__1607225 = cljs.core.seq.call(null, c1);
      var s2__1607226 = cljs.core.seq.call(null, c2);
      if(cljs.core.truth_(function() {
        var and__3546__auto____1607227 = s1__1607225;
        if(cljs.core.truth_(and__3546__auto____1607227)) {
          return s2__1607226
        }else {
          return and__3546__auto____1607227
        }
      }())) {
        return cljs.core.cons.call(null, cljs.core.first.call(null, s1__1607225), cljs.core.cons.call(null, cljs.core.first.call(null, s2__1607226), interleave.call(null, cljs.core.rest.call(null, s1__1607225), cljs.core.rest.call(null, s2__1607226))))
      }else {
        return null
      }
    })
  };
  var interleave__1607230 = function() {
    var G__1607232__delegate = function(c1, c2, colls) {
      return new cljs.core.LazySeq(null, false, function() {
        var ss__1607228 = cljs.core.map.call(null, cljs.core.seq, cljs.core.conj.call(null, colls, c2, c1));
        if(cljs.core.truth_(cljs.core.every_QMARK_.call(null, cljs.core.identity, ss__1607228))) {
          return cljs.core.concat.call(null, cljs.core.map.call(null, cljs.core.first, ss__1607228), cljs.core.apply.call(null, interleave, cljs.core.map.call(null, cljs.core.rest, ss__1607228)))
        }else {
          return null
        }
      })
    };
    var G__1607232 = function(c1, c2, var_args) {
      var colls = null;
      if(goog.isDef(var_args)) {
        colls = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1607232__delegate.call(this, c1, c2, colls)
    };
    G__1607232.cljs$lang$maxFixedArity = 2;
    G__1607232.cljs$lang$applyTo = function(arglist__1607233) {
      var c1 = cljs.core.first(arglist__1607233);
      var c2 = cljs.core.first(cljs.core.next(arglist__1607233));
      var colls = cljs.core.rest(cljs.core.next(arglist__1607233));
      return G__1607232__delegate.call(this, c1, c2, colls)
    };
    return G__1607232
  }();
  interleave = function(c1, c2, var_args) {
    var colls = var_args;
    switch(arguments.length) {
      case 2:
        return interleave__1607229.call(this, c1, c2);
      default:
        return interleave__1607230.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  interleave.cljs$lang$maxFixedArity = 2;
  interleave.cljs$lang$applyTo = interleave__1607230.cljs$lang$applyTo;
  return interleave
}();
cljs.core.interpose = function interpose(sep, coll) {
  return cljs.core.drop.call(null, 1, cljs.core.interleave.call(null, cljs.core.repeat.call(null, sep), coll))
};
cljs.core.flatten1 = function flatten1(colls) {
  var cat__1607236 = function cat(coll, colls) {
    return new cljs.core.LazySeq(null, false, function() {
      var temp__3695__auto____1607234 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(temp__3695__auto____1607234)) {
        var coll__1607235 = temp__3695__auto____1607234;
        return cljs.core.cons.call(null, cljs.core.first.call(null, coll__1607235), cat.call(null, cljs.core.rest.call(null, coll__1607235), colls))
      }else {
        if(cljs.core.truth_(cljs.core.seq.call(null, colls))) {
          return cat.call(null, cljs.core.first.call(null, colls), cljs.core.rest.call(null, colls))
        }else {
          return null
        }
      }
    })
  };
  return cat__1607236.call(null, null, colls)
};
cljs.core.mapcat = function() {
  var mapcat = null;
  var mapcat__1607237 = function(f, coll) {
    return cljs.core.flatten1.call(null, cljs.core.map.call(null, f, coll))
  };
  var mapcat__1607238 = function() {
    var G__1607240__delegate = function(f, coll, colls) {
      return cljs.core.flatten1.call(null, cljs.core.apply.call(null, cljs.core.map, f, coll, colls))
    };
    var G__1607240 = function(f, coll, var_args) {
      var colls = null;
      if(goog.isDef(var_args)) {
        colls = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
      }
      return G__1607240__delegate.call(this, f, coll, colls)
    };
    G__1607240.cljs$lang$maxFixedArity = 2;
    G__1607240.cljs$lang$applyTo = function(arglist__1607241) {
      var f = cljs.core.first(arglist__1607241);
      var coll = cljs.core.first(cljs.core.next(arglist__1607241));
      var colls = cljs.core.rest(cljs.core.next(arglist__1607241));
      return G__1607240__delegate.call(this, f, coll, colls)
    };
    return G__1607240
  }();
  mapcat = function(f, coll, var_args) {
    var colls = var_args;
    switch(arguments.length) {
      case 2:
        return mapcat__1607237.call(this, f, coll);
      default:
        return mapcat__1607238.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  mapcat.cljs$lang$maxFixedArity = 2;
  mapcat.cljs$lang$applyTo = mapcat__1607238.cljs$lang$applyTo;
  return mapcat
}();
cljs.core.filter = function filter(pred, coll) {
  return new cljs.core.LazySeq(null, false, function() {
    var temp__3698__auto____1607242 = cljs.core.seq.call(null, coll);
    if(cljs.core.truth_(temp__3698__auto____1607242)) {
      var s__1607243 = temp__3698__auto____1607242;
      var f__1607244 = cljs.core.first.call(null, s__1607243);
      var r__1607245 = cljs.core.rest.call(null, s__1607243);
      if(cljs.core.truth_(pred.call(null, f__1607244))) {
        return cljs.core.cons.call(null, f__1607244, filter.call(null, pred, r__1607245))
      }else {
        return filter.call(null, pred, r__1607245)
      }
    }else {
      return null
    }
  })
};
cljs.core.remove = function remove(pred, coll) {
  return cljs.core.filter.call(null, cljs.core.complement.call(null, pred), coll)
};
cljs.core.tree_seq = function tree_seq(branch_QMARK_, children, root) {
  var walk__1607247 = function walk(node) {
    return new cljs.core.LazySeq(null, false, function() {
      return cljs.core.cons.call(null, node, cljs.core.truth_(branch_QMARK_.call(null, node)) ? cljs.core.mapcat.call(null, walk, children.call(null, node)) : null)
    })
  };
  return walk__1607247.call(null, root)
};
cljs.core.flatten = function flatten(x) {
  return cljs.core.filter.call(null, function(p1__1607246_SHARP_) {
    return cljs.core.not.call(null, cljs.core.sequential_QMARK_.call(null, p1__1607246_SHARP_))
  }, cljs.core.rest.call(null, cljs.core.tree_seq.call(null, cljs.core.sequential_QMARK_, cljs.core.seq, x)))
};
cljs.core.into = function into(to, from) {
  return cljs.core.reduce.call(null, cljs.core._conj, to, from)
};
cljs.core.partition = function() {
  var partition = null;
  var partition__1607254 = function(n, coll) {
    return partition.call(null, n, n, coll)
  };
  var partition__1607255 = function(n, step, coll) {
    return new cljs.core.LazySeq(null, false, function() {
      var temp__3698__auto____1607248 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(temp__3698__auto____1607248)) {
        var s__1607249 = temp__3698__auto____1607248;
        var p__1607250 = cljs.core.take.call(null, n, s__1607249);
        if(cljs.core.truth_(cljs.core._EQ_.call(null, n, cljs.core.count.call(null, p__1607250)))) {
          return cljs.core.cons.call(null, p__1607250, partition.call(null, n, step, cljs.core.drop.call(null, step, s__1607249)))
        }else {
          return null
        }
      }else {
        return null
      }
    })
  };
  var partition__1607256 = function(n, step, pad, coll) {
    return new cljs.core.LazySeq(null, false, function() {
      var temp__3698__auto____1607251 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(temp__3698__auto____1607251)) {
        var s__1607252 = temp__3698__auto____1607251;
        var p__1607253 = cljs.core.take.call(null, n, s__1607252);
        if(cljs.core.truth_(cljs.core._EQ_.call(null, n, cljs.core.count.call(null, p__1607253)))) {
          return cljs.core.cons.call(null, p__1607253, partition.call(null, n, step, pad, cljs.core.drop.call(null, step, s__1607252)))
        }else {
          return cljs.core.list.call(null, cljs.core.take.call(null, n, cljs.core.concat.call(null, p__1607253, pad)))
        }
      }else {
        return null
      }
    })
  };
  partition = function(n, step, pad, coll) {
    switch(arguments.length) {
      case 2:
        return partition__1607254.call(this, n, step);
      case 3:
        return partition__1607255.call(this, n, step, pad);
      case 4:
        return partition__1607256.call(this, n, step, pad, coll)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return partition
}();
cljs.core.get_in = function() {
  var get_in = null;
  var get_in__1607262 = function(m, ks) {
    return cljs.core.reduce.call(null, cljs.core.get, m, ks)
  };
  var get_in__1607263 = function(m, ks, not_found) {
    var sentinel__1607258 = cljs.core.lookup_sentinel;
    var m__1607259 = m;
    var ks__1607260 = cljs.core.seq.call(null, ks);
    while(true) {
      if(cljs.core.truth_(ks__1607260)) {
        var m__1607261 = cljs.core.get.call(null, m__1607259, cljs.core.first.call(null, ks__1607260), sentinel__1607258);
        if(cljs.core.truth_(sentinel__1607258 === m__1607261)) {
          return not_found
        }else {
          var G__1607265 = sentinel__1607258;
          var G__1607266 = m__1607261;
          var G__1607267 = cljs.core.next.call(null, ks__1607260);
          sentinel__1607258 = G__1607265;
          m__1607259 = G__1607266;
          ks__1607260 = G__1607267;
          continue
        }
      }else {
        return m__1607259
      }
      break
    }
  };
  get_in = function(m, ks, not_found) {
    switch(arguments.length) {
      case 2:
        return get_in__1607262.call(this, m, ks);
      case 3:
        return get_in__1607263.call(this, m, ks, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return get_in
}();
cljs.core.assoc_in = function assoc_in(m, p__1607268, v) {
  var vec__1607269__1607270 = p__1607268;
  var k__1607271 = cljs.core.nth.call(null, vec__1607269__1607270, 0, null);
  var ks__1607272 = cljs.core.nthnext.call(null, vec__1607269__1607270, 1);
  if(cljs.core.truth_(ks__1607272)) {
    return cljs.core.assoc.call(null, m, k__1607271, assoc_in.call(null, cljs.core.get.call(null, m, k__1607271), ks__1607272, v))
  }else {
    return cljs.core.assoc.call(null, m, k__1607271, v)
  }
};
cljs.core.update_in = function() {
  var update_in__delegate = function(m, p__1607273, f, args) {
    var vec__1607274__1607275 = p__1607273;
    var k__1607276 = cljs.core.nth.call(null, vec__1607274__1607275, 0, null);
    var ks__1607277 = cljs.core.nthnext.call(null, vec__1607274__1607275, 1);
    if(cljs.core.truth_(ks__1607277)) {
      return cljs.core.assoc.call(null, m, k__1607276, cljs.core.apply.call(null, update_in, cljs.core.get.call(null, m, k__1607276), ks__1607277, f, args))
    }else {
      return cljs.core.assoc.call(null, m, k__1607276, cljs.core.apply.call(null, f, cljs.core.get.call(null, m, k__1607276), args))
    }
  };
  var update_in = function(m, p__1607273, f, var_args) {
    var args = null;
    if(goog.isDef(var_args)) {
      args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
    }
    return update_in__delegate.call(this, m, p__1607273, f, args)
  };
  update_in.cljs$lang$maxFixedArity = 3;
  update_in.cljs$lang$applyTo = function(arglist__1607278) {
    var m = cljs.core.first(arglist__1607278);
    var p__1607273 = cljs.core.first(cljs.core.next(arglist__1607278));
    var f = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607278)));
    var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607278)));
    return update_in__delegate.call(this, m, p__1607273, f, args)
  };
  return update_in
}();
cljs.core.Vector = function(meta, array) {
  this.meta = meta;
  this.array = array
};
cljs.core.Vector.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.Vector")
};
cljs.core.Vector.prototype.cljs$core$IHash$ = true;
cljs.core.Vector.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1607279 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.Vector.prototype.cljs$core$ILookup$ = true;
cljs.core.Vector.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1607312 = null;
  var G__1607312__1607313 = function(coll, k) {
    var this__1607280 = this;
    return cljs.core._nth.call(null, coll, k, null)
  };
  var G__1607312__1607314 = function(coll, k, not_found) {
    var this__1607281 = this;
    return cljs.core._nth.call(null, coll, k, not_found)
  };
  G__1607312 = function(coll, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607312__1607313.call(this, coll, k);
      case 3:
        return G__1607312__1607314.call(this, coll, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607312
}();
cljs.core.Vector.prototype.cljs$core$IAssociative$ = true;
cljs.core.Vector.prototype.cljs$core$IAssociative$_assoc = function(coll, k, v) {
  var this__1607282 = this;
  var new_array__1607283 = cljs.core.aclone.call(null, this__1607282.array);
  new_array__1607283[k] = v;
  return new cljs.core.Vector(this__1607282.meta, new_array__1607283)
};
cljs.core.Vector.prototype.cljs$core$IFn$ = true;
cljs.core.Vector.prototype.call = function() {
  var G__1607316 = null;
  var G__1607316__1607317 = function(tsym1607284, k) {
    var this__1607286 = this;
    var tsym1607284__1607287 = this;
    var coll__1607288 = tsym1607284__1607287;
    return cljs.core._lookup.call(null, coll__1607288, k)
  };
  var G__1607316__1607318 = function(tsym1607285, k, not_found) {
    var this__1607289 = this;
    var tsym1607285__1607290 = this;
    var coll__1607291 = tsym1607285__1607290;
    return cljs.core._lookup.call(null, coll__1607291, k, not_found)
  };
  G__1607316 = function(tsym1607285, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607316__1607317.call(this, tsym1607285, k);
      case 3:
        return G__1607316__1607318.call(this, tsym1607285, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607316
}();
cljs.core.Vector.prototype.cljs$core$ISequential$ = true;
cljs.core.Vector.prototype.cljs$core$ICollection$ = true;
cljs.core.Vector.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1607292 = this;
  var new_array__1607293 = cljs.core.aclone.call(null, this__1607292.array);
  new_array__1607293.push(o);
  return new cljs.core.Vector(this__1607292.meta, new_array__1607293)
};
cljs.core.Vector.prototype.cljs$core$IReduce$ = true;
cljs.core.Vector.prototype.cljs$core$IReduce$_reduce = function() {
  var G__1607320 = null;
  var G__1607320__1607321 = function(v, f) {
    var this__1607294 = this;
    return cljs.core.ci_reduce.call(null, this__1607294.array, f)
  };
  var G__1607320__1607322 = function(v, f, start) {
    var this__1607295 = this;
    return cljs.core.ci_reduce.call(null, this__1607295.array, f, start)
  };
  G__1607320 = function(v, f, start) {
    switch(arguments.length) {
      case 2:
        return G__1607320__1607321.call(this, v, f);
      case 3:
        return G__1607320__1607322.call(this, v, f, start)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607320
}();
cljs.core.Vector.prototype.cljs$core$ISeqable$ = true;
cljs.core.Vector.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1607296 = this;
  if(cljs.core.truth_(this__1607296.array.length > 0)) {
    var vector_seq__1607297 = function vector_seq(i) {
      return new cljs.core.LazySeq(null, false, function() {
        if(cljs.core.truth_(i < this__1607296.array.length)) {
          return cljs.core.cons.call(null, this__1607296.array[i], vector_seq.call(null, i + 1))
        }else {
          return null
        }
      })
    };
    return vector_seq__1607297.call(null, 0)
  }else {
    return null
  }
};
cljs.core.Vector.prototype.cljs$core$ICounted$ = true;
cljs.core.Vector.prototype.cljs$core$ICounted$_count = function(coll) {
  var this__1607298 = this;
  return this__1607298.array.length
};
cljs.core.Vector.prototype.cljs$core$IStack$ = true;
cljs.core.Vector.prototype.cljs$core$IStack$_peek = function(coll) {
  var this__1607299 = this;
  var count__1607300 = this__1607299.array.length;
  if(cljs.core.truth_(count__1607300 > 0)) {
    return this__1607299.array[count__1607300 - 1]
  }else {
    return null
  }
};
cljs.core.Vector.prototype.cljs$core$IStack$_pop = function(coll) {
  var this__1607301 = this;
  if(cljs.core.truth_(this__1607301.array.length > 0)) {
    var new_array__1607302 = cljs.core.aclone.call(null, this__1607301.array);
    new_array__1607302.pop();
    return new cljs.core.Vector(this__1607301.meta, new_array__1607302)
  }else {
    throw new Error("Can't pop empty vector");
  }
};
cljs.core.Vector.prototype.cljs$core$IVector$ = true;
cljs.core.Vector.prototype.cljs$core$IVector$_assoc_n = function(coll, n, val) {
  var this__1607303 = this;
  return cljs.core._assoc.call(null, coll, n, val)
};
cljs.core.Vector.prototype.cljs$core$IEquiv$ = true;
cljs.core.Vector.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1607304 = this;
  return cljs.core.equiv_sequential.call(null, coll, other)
};
cljs.core.Vector.prototype.cljs$core$IWithMeta$ = true;
cljs.core.Vector.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1607305 = this;
  return new cljs.core.Vector(meta, this__1607305.array)
};
cljs.core.Vector.prototype.cljs$core$IMeta$ = true;
cljs.core.Vector.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1607306 = this;
  return this__1607306.meta
};
cljs.core.Vector.prototype.cljs$core$IIndexed$ = true;
cljs.core.Vector.prototype.cljs$core$IIndexed$_nth = function() {
  var G__1607324 = null;
  var G__1607324__1607325 = function(coll, n) {
    var this__1607307 = this;
    if(cljs.core.truth_(function() {
      var and__3546__auto____1607308 = 0 <= n;
      if(cljs.core.truth_(and__3546__auto____1607308)) {
        return n < this__1607307.array.length
      }else {
        return and__3546__auto____1607308
      }
    }())) {
      return this__1607307.array[n]
    }else {
      return null
    }
  };
  var G__1607324__1607326 = function(coll, n, not_found) {
    var this__1607309 = this;
    if(cljs.core.truth_(function() {
      var and__3546__auto____1607310 = 0 <= n;
      if(cljs.core.truth_(and__3546__auto____1607310)) {
        return n < this__1607309.array.length
      }else {
        return and__3546__auto____1607310
      }
    }())) {
      return this__1607309.array[n]
    }else {
      return not_found
    }
  };
  G__1607324 = function(coll, n, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607324__1607325.call(this, coll, n);
      case 3:
        return G__1607324__1607326.call(this, coll, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607324
}();
cljs.core.Vector.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.Vector.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1607311 = this;
  return cljs.core.with_meta.call(null, cljs.core.Vector.EMPTY, this__1607311.meta)
};
cljs.core.Vector;
cljs.core.Vector.EMPTY = new cljs.core.Vector(null, []);
cljs.core.Vector.fromArray = function(xs) {
  return new cljs.core.Vector(null, xs)
};
cljs.core.tail_off = function tail_off(pv) {
  var cnt__1607328 = pv.cnt;
  if(cljs.core.truth_(cnt__1607328 < 32)) {
    return 0
  }else {
    return cnt__1607328 - 1 >> 5 << 5
  }
};
cljs.core.new_path = function new_path(level, node) {
  var ll__1607329 = level;
  var ret__1607330 = node;
  while(true) {
    if(cljs.core.truth_(cljs.core._EQ_.call(null, 0, ll__1607329))) {
      return ret__1607330
    }else {
      var embed__1607331 = ret__1607330;
      var r__1607332 = cljs.core.aclone.call(null, cljs.core.PersistentVector.EMPTY_NODE);
      var ___1607333 = r__1607332[0] = embed__1607331;
      var G__1607334 = ll__1607329 - 5;
      var G__1607335 = r__1607332;
      ll__1607329 = G__1607334;
      ret__1607330 = G__1607335;
      continue
    }
    break
  }
};
cljs.core.push_tail = function push_tail(pv, level, parent, tailnode) {
  var ret__1607336 = cljs.core.aclone.call(null, parent);
  var subidx__1607337 = pv.cnt - 1 >> level & 31;
  if(cljs.core.truth_(cljs.core._EQ_.call(null, 5, level))) {
    ret__1607336[subidx__1607337] = tailnode;
    return ret__1607336
  }else {
    var temp__3695__auto____1607338 = parent[subidx__1607337];
    if(cljs.core.truth_(temp__3695__auto____1607338)) {
      var child__1607339 = temp__3695__auto____1607338;
      var node_to_insert__1607340 = push_tail.call(null, pv, level - 5, child__1607339, tailnode);
      var ___1607341 = ret__1607336[subidx__1607337] = node_to_insert__1607340;
      return ret__1607336
    }else {
      var node_to_insert__1607342 = cljs.core.new_path.call(null, level - 5, tailnode);
      var ___1607343 = ret__1607336[subidx__1607337] = node_to_insert__1607342;
      return ret__1607336
    }
  }
};
cljs.core.array_for = function array_for(pv, i) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1607344 = 0 <= i;
    if(cljs.core.truth_(and__3546__auto____1607344)) {
      return i < pv.cnt
    }else {
      return and__3546__auto____1607344
    }
  }())) {
    if(cljs.core.truth_(i >= cljs.core.tail_off.call(null, pv))) {
      return pv.tail
    }else {
      var node__1607345 = pv.root;
      var level__1607346 = pv.shift;
      while(true) {
        if(cljs.core.truth_(level__1607346 > 0)) {
          var G__1607347 = node__1607345[i >> level__1607346 & 31];
          var G__1607348 = level__1607346 - 5;
          node__1607345 = G__1607347;
          level__1607346 = G__1607348;
          continue
        }else {
          return node__1607345
        }
        break
      }
    }
  }else {
    throw new Error(cljs.core.str.call(null, "No item ", i, " in vector of length ", pv.cnt));
  }
};
cljs.core.do_assoc = function do_assoc(pv, level, node, i, val) {
  var ret__1607349 = cljs.core.aclone.call(null, node);
  if(cljs.core.truth_(level === 0)) {
    ret__1607349[i & 31] = val;
    return ret__1607349
  }else {
    var subidx__1607350 = i >> level & 31;
    var ___1607351 = ret__1607349[subidx__1607350] = do_assoc.call(null, pv, level - 5, node[subidx__1607350], i, val);
    return ret__1607349
  }
};
cljs.core.pop_tail = function pop_tail(pv, level, node) {
  var subidx__1607352 = pv.cnt - 2 >> level & 31;
  if(cljs.core.truth_(level > 5)) {
    var new_child__1607353 = pop_tail.call(null, pv, level - 5, node[subidx__1607352]);
    if(cljs.core.truth_(function() {
      var and__3546__auto____1607354 = new_child__1607353 === null;
      if(cljs.core.truth_(and__3546__auto____1607354)) {
        return subidx__1607352 === 0
      }else {
        return and__3546__auto____1607354
      }
    }())) {
      return null
    }else {
      var ret__1607355 = cljs.core.aclone.call(null, node);
      var ___1607356 = ret__1607355[subidx__1607352] = new_child__1607353;
      return ret__1607355
    }
  }else {
    if(cljs.core.truth_(subidx__1607352 === 0)) {
      return null
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        var ret__1607357 = cljs.core.aclone.call(null, node);
        var ___1607358 = ret__1607357[subidx__1607352] = null;
        return ret__1607357
      }else {
        return null
      }
    }
  }
};
cljs.core.PersistentVector = function(meta, cnt, shift, root, tail) {
  this.meta = meta;
  this.cnt = cnt;
  this.shift = shift;
  this.root = root;
  this.tail = tail
};
cljs.core.PersistentVector.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.PersistentVector")
};
cljs.core.PersistentVector.prototype.cljs$core$IHash$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1607359 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.PersistentVector.prototype.cljs$core$ILookup$ = true;
cljs.core.PersistentVector.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1607399 = null;
  var G__1607399__1607400 = function(coll, k) {
    var this__1607360 = this;
    return cljs.core._nth.call(null, coll, k, null)
  };
  var G__1607399__1607401 = function(coll, k, not_found) {
    var this__1607361 = this;
    return cljs.core._nth.call(null, coll, k, not_found)
  };
  G__1607399 = function(coll, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607399__1607400.call(this, coll, k);
      case 3:
        return G__1607399__1607401.call(this, coll, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607399
}();
cljs.core.PersistentVector.prototype.cljs$core$IAssociative$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IAssociative$_assoc = function(coll, k, v) {
  var this__1607362 = this;
  if(cljs.core.truth_(function() {
    var and__3546__auto____1607363 = 0 <= k;
    if(cljs.core.truth_(and__3546__auto____1607363)) {
      return k < this__1607362.cnt
    }else {
      return and__3546__auto____1607363
    }
  }())) {
    if(cljs.core.truth_(cljs.core.tail_off.call(null, coll) <= k)) {
      var new_tail__1607364 = cljs.core.aclone.call(null, this__1607362.tail);
      new_tail__1607364[k & 31] = v;
      return new cljs.core.PersistentVector(this__1607362.meta, this__1607362.cnt, this__1607362.shift, this__1607362.root, new_tail__1607364)
    }else {
      return new cljs.core.PersistentVector(this__1607362.meta, this__1607362.cnt, this__1607362.shift, cljs.core.do_assoc.call(null, coll, this__1607362.shift, this__1607362.root, k, v), this__1607362.tail)
    }
  }else {
    if(cljs.core.truth_(cljs.core._EQ_.call(null, k, this__1607362.cnt))) {
      return cljs.core._conj.call(null, coll, v)
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        throw new Error(cljs.core.str.call(null, "Index ", k, " out of bounds  [0,", this__1607362.cnt, "]"));
      }else {
        return null
      }
    }
  }
};
cljs.core.PersistentVector.prototype.cljs$core$IFn$ = true;
cljs.core.PersistentVector.prototype.call = function() {
  var G__1607403 = null;
  var G__1607403__1607404 = function(tsym1607365, k) {
    var this__1607367 = this;
    var tsym1607365__1607368 = this;
    var coll__1607369 = tsym1607365__1607368;
    return cljs.core._lookup.call(null, coll__1607369, k)
  };
  var G__1607403__1607405 = function(tsym1607366, k, not_found) {
    var this__1607370 = this;
    var tsym1607366__1607371 = this;
    var coll__1607372 = tsym1607366__1607371;
    return cljs.core._lookup.call(null, coll__1607372, k, not_found)
  };
  G__1607403 = function(tsym1607366, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607403__1607404.call(this, tsym1607366, k);
      case 3:
        return G__1607403__1607405.call(this, tsym1607366, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607403
}();
cljs.core.PersistentVector.prototype.cljs$core$ISequential$ = true;
cljs.core.PersistentVector.prototype.cljs$core$ICollection$ = true;
cljs.core.PersistentVector.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1607373 = this;
  if(cljs.core.truth_(this__1607373.cnt - cljs.core.tail_off.call(null, coll) < 32)) {
    var new_tail__1607374 = cljs.core.aclone.call(null, this__1607373.tail);
    new_tail__1607374.push(o);
    return new cljs.core.PersistentVector(this__1607373.meta, this__1607373.cnt + 1, this__1607373.shift, this__1607373.root, new_tail__1607374)
  }else {
    var root_overflow_QMARK___1607375 = this__1607373.cnt >> 5 > 1 << this__1607373.shift;
    var new_shift__1607376 = cljs.core.truth_(root_overflow_QMARK___1607375) ? this__1607373.shift + 5 : this__1607373.shift;
    var new_root__1607378 = cljs.core.truth_(root_overflow_QMARK___1607375) ? function() {
      var n_r__1607377 = cljs.core.aclone.call(null, cljs.core.PersistentVector.EMPTY_NODE);
      n_r__1607377[0] = this__1607373.root;
      n_r__1607377[1] = cljs.core.new_path.call(null, this__1607373.shift, this__1607373.tail);
      return n_r__1607377
    }() : cljs.core.push_tail.call(null, coll, this__1607373.shift, this__1607373.root, this__1607373.tail);
    return new cljs.core.PersistentVector(this__1607373.meta, this__1607373.cnt + 1, new_shift__1607376, new_root__1607378, [o])
  }
};
cljs.core.PersistentVector.prototype.cljs$core$IReduce$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IReduce$_reduce = function() {
  var G__1607407 = null;
  var G__1607407__1607408 = function(v, f) {
    var this__1607379 = this;
    return cljs.core.ci_reduce.call(null, v, f)
  };
  var G__1607407__1607409 = function(v, f, start) {
    var this__1607380 = this;
    return cljs.core.ci_reduce.call(null, v, f, start)
  };
  G__1607407 = function(v, f, start) {
    switch(arguments.length) {
      case 2:
        return G__1607407__1607408.call(this, v, f);
      case 3:
        return G__1607407__1607409.call(this, v, f, start)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607407
}();
cljs.core.PersistentVector.prototype.cljs$core$ISeqable$ = true;
cljs.core.PersistentVector.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1607381 = this;
  if(cljs.core.truth_(this__1607381.cnt > 0)) {
    var vector_seq__1607382 = function vector_seq(i) {
      return new cljs.core.LazySeq(null, false, function() {
        if(cljs.core.truth_(i < this__1607381.cnt)) {
          return cljs.core.cons.call(null, cljs.core._nth.call(null, coll, i), vector_seq.call(null, i + 1))
        }else {
          return null
        }
      })
    };
    return vector_seq__1607382.call(null, 0)
  }else {
    return null
  }
};
cljs.core.PersistentVector.prototype.cljs$core$ICounted$ = true;
cljs.core.PersistentVector.prototype.cljs$core$ICounted$_count = function(coll) {
  var this__1607383 = this;
  return this__1607383.cnt
};
cljs.core.PersistentVector.prototype.cljs$core$IStack$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IStack$_peek = function(coll) {
  var this__1607384 = this;
  if(cljs.core.truth_(this__1607384.cnt > 0)) {
    return cljs.core._nth.call(null, coll, this__1607384.cnt - 1)
  }else {
    return null
  }
};
cljs.core.PersistentVector.prototype.cljs$core$IStack$_pop = function(coll) {
  var this__1607385 = this;
  if(cljs.core.truth_(this__1607385.cnt === 0)) {
    throw new Error("Can't pop empty vector");
  }else {
    if(cljs.core.truth_(cljs.core._EQ_.call(null, 1, this__1607385.cnt))) {
      return cljs.core._with_meta.call(null, cljs.core.PersistentVector.EMPTY, this__1607385.meta)
    }else {
      if(cljs.core.truth_(1 < this__1607385.cnt - cljs.core.tail_off.call(null, coll))) {
        return new cljs.core.PersistentVector(this__1607385.meta, this__1607385.cnt - 1, this__1607385.shift, this__1607385.root, cljs.core.aclone.call(null, this__1607385.tail))
      }else {
        if(cljs.core.truth_("\ufdd0'else")) {
          var new_tail__1607386 = cljs.core.array_for.call(null, coll, this__1607385.cnt - 2);
          var nr__1607387 = cljs.core.pop_tail.call(null, this__1607385.shift, this__1607385.root);
          var new_root__1607388 = cljs.core.truth_(nr__1607387 === null) ? cljs.core.PersistentVector.EMPTY_NODE : nr__1607387;
          var cnt_1__1607389 = this__1607385.cnt - 1;
          if(cljs.core.truth_(function() {
            var and__3546__auto____1607390 = 5 < this__1607385.shift;
            if(cljs.core.truth_(and__3546__auto____1607390)) {
              return new_root__1607388[1] === null
            }else {
              return and__3546__auto____1607390
            }
          }())) {
            return new cljs.core.PersistentVector(this__1607385.meta, cnt_1__1607389, this__1607385.shift - 5, new_root__1607388[0], new_tail__1607386)
          }else {
            return new cljs.core.PersistentVector(this__1607385.meta, cnt_1__1607389, this__1607385.shift, new_root__1607388, new_tail__1607386)
          }
        }else {
          return null
        }
      }
    }
  }
};
cljs.core.PersistentVector.prototype.cljs$core$IVector$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IVector$_assoc_n = function(coll, n, val) {
  var this__1607391 = this;
  return cljs.core._assoc.call(null, coll, n, val)
};
cljs.core.PersistentVector.prototype.cljs$core$IEquiv$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1607392 = this;
  return cljs.core.equiv_sequential.call(null, coll, other)
};
cljs.core.PersistentVector.prototype.cljs$core$IWithMeta$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1607393 = this;
  return new cljs.core.PersistentVector(meta, this__1607393.cnt, this__1607393.shift, this__1607393.root, this__1607393.tail)
};
cljs.core.PersistentVector.prototype.cljs$core$IMeta$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1607394 = this;
  return this__1607394.meta
};
cljs.core.PersistentVector.prototype.cljs$core$IIndexed$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IIndexed$_nth = function() {
  var G__1607411 = null;
  var G__1607411__1607412 = function(coll, n) {
    var this__1607395 = this;
    return cljs.core.array_for.call(null, coll, n)[n & 31]
  };
  var G__1607411__1607413 = function(coll, n, not_found) {
    var this__1607396 = this;
    if(cljs.core.truth_(function() {
      var and__3546__auto____1607397 = 0 <= n;
      if(cljs.core.truth_(and__3546__auto____1607397)) {
        return n < this__1607396.cnt
      }else {
        return and__3546__auto____1607397
      }
    }())) {
      return cljs.core._nth.call(null, coll, n)
    }else {
      return not_found
    }
  };
  G__1607411 = function(coll, n, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607411__1607412.call(this, coll, n);
      case 3:
        return G__1607411__1607413.call(this, coll, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607411
}();
cljs.core.PersistentVector.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1607398 = this;
  return cljs.core.with_meta.call(null, cljs.core.PersistentVector.EMPTY, this__1607398.meta)
};
cljs.core.PersistentVector;
cljs.core.PersistentVector.EMPTY_NODE = new Array(32);
cljs.core.PersistentVector.EMPTY = new cljs.core.PersistentVector(null, 0, 5, cljs.core.PersistentVector.EMPTY_NODE, []);
cljs.core.PersistentVector.fromArray = function(xs) {
  return cljs.core.into.call(null, cljs.core.PersistentVector.EMPTY, xs)
};
cljs.core.vec = function vec(coll) {
  return cljs.core.reduce.call(null, cljs.core.conj, cljs.core.PersistentVector.EMPTY, coll)
};
cljs.core.vector = function() {
  var vector__delegate = function(args) {
    return cljs.core.vec.call(null, args)
  };
  var vector = function(var_args) {
    var args = null;
    if(goog.isDef(var_args)) {
      args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return vector__delegate.call(this, args)
  };
  vector.cljs$lang$maxFixedArity = 0;
  vector.cljs$lang$applyTo = function(arglist__1607415) {
    var args = cljs.core.seq(arglist__1607415);
    return vector__delegate.call(this, args)
  };
  return vector
}();
cljs.core.Subvec = function(meta, v, start, end) {
  this.meta = meta;
  this.v = v;
  this.start = start;
  this.end = end
};
cljs.core.Subvec.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.Subvec")
};
cljs.core.Subvec.prototype.cljs$core$IHash$ = true;
cljs.core.Subvec.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1607416 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.Subvec.prototype.cljs$core$ILookup$ = true;
cljs.core.Subvec.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1607444 = null;
  var G__1607444__1607445 = function(coll, k) {
    var this__1607417 = this;
    return cljs.core._nth.call(null, coll, k, null)
  };
  var G__1607444__1607446 = function(coll, k, not_found) {
    var this__1607418 = this;
    return cljs.core._nth.call(null, coll, k, not_found)
  };
  G__1607444 = function(coll, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607444__1607445.call(this, coll, k);
      case 3:
        return G__1607444__1607446.call(this, coll, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607444
}();
cljs.core.Subvec.prototype.cljs$core$IAssociative$ = true;
cljs.core.Subvec.prototype.cljs$core$IAssociative$_assoc = function(coll, key, val) {
  var this__1607419 = this;
  var v_pos__1607420 = this__1607419.start + key;
  return new cljs.core.Subvec(this__1607419.meta, cljs.core._assoc.call(null, this__1607419.v, v_pos__1607420, val), this__1607419.start, this__1607419.end > v_pos__1607420 + 1 ? this__1607419.end : v_pos__1607420 + 1)
};
cljs.core.Subvec.prototype.cljs$core$IFn$ = true;
cljs.core.Subvec.prototype.call = function() {
  var G__1607448 = null;
  var G__1607448__1607449 = function(tsym1607421, k) {
    var this__1607423 = this;
    var tsym1607421__1607424 = this;
    var coll__1607425 = tsym1607421__1607424;
    return cljs.core._lookup.call(null, coll__1607425, k)
  };
  var G__1607448__1607450 = function(tsym1607422, k, not_found) {
    var this__1607426 = this;
    var tsym1607422__1607427 = this;
    var coll__1607428 = tsym1607422__1607427;
    return cljs.core._lookup.call(null, coll__1607428, k, not_found)
  };
  G__1607448 = function(tsym1607422, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607448__1607449.call(this, tsym1607422, k);
      case 3:
        return G__1607448__1607450.call(this, tsym1607422, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607448
}();
cljs.core.Subvec.prototype.cljs$core$ISequential$ = true;
cljs.core.Subvec.prototype.cljs$core$ICollection$ = true;
cljs.core.Subvec.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1607429 = this;
  return new cljs.core.Subvec(this__1607429.meta, cljs.core._assoc_n.call(null, this__1607429.v, this__1607429.end, o), this__1607429.start, this__1607429.end + 1)
};
cljs.core.Subvec.prototype.cljs$core$IReduce$ = true;
cljs.core.Subvec.prototype.cljs$core$IReduce$_reduce = function() {
  var G__1607452 = null;
  var G__1607452__1607453 = function(coll, f) {
    var this__1607430 = this;
    return cljs.core.ci_reduce.call(null, coll, f)
  };
  var G__1607452__1607454 = function(coll, f, start) {
    var this__1607431 = this;
    return cljs.core.ci_reduce.call(null, coll, f, start)
  };
  G__1607452 = function(coll, f, start) {
    switch(arguments.length) {
      case 2:
        return G__1607452__1607453.call(this, coll, f);
      case 3:
        return G__1607452__1607454.call(this, coll, f, start)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607452
}();
cljs.core.Subvec.prototype.cljs$core$ISeqable$ = true;
cljs.core.Subvec.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1607432 = this;
  var subvec_seq__1607433 = function subvec_seq(i) {
    if(cljs.core.truth_(cljs.core._EQ_.call(null, i, this__1607432.end))) {
      return null
    }else {
      return cljs.core.cons.call(null, cljs.core._nth.call(null, this__1607432.v, i), new cljs.core.LazySeq(null, false, function() {
        return subvec_seq.call(null, i + 1)
      }))
    }
  };
  return subvec_seq__1607433.call(null, this__1607432.start)
};
cljs.core.Subvec.prototype.cljs$core$ICounted$ = true;
cljs.core.Subvec.prototype.cljs$core$ICounted$_count = function(coll) {
  var this__1607434 = this;
  return this__1607434.end - this__1607434.start
};
cljs.core.Subvec.prototype.cljs$core$IStack$ = true;
cljs.core.Subvec.prototype.cljs$core$IStack$_peek = function(coll) {
  var this__1607435 = this;
  return cljs.core._nth.call(null, this__1607435.v, this__1607435.end - 1)
};
cljs.core.Subvec.prototype.cljs$core$IStack$_pop = function(coll) {
  var this__1607436 = this;
  if(cljs.core.truth_(cljs.core._EQ_.call(null, this__1607436.start, this__1607436.end))) {
    throw new Error("Can't pop empty vector");
  }else {
    return new cljs.core.Subvec(this__1607436.meta, this__1607436.v, this__1607436.start, this__1607436.end - 1)
  }
};
cljs.core.Subvec.prototype.cljs$core$IVector$ = true;
cljs.core.Subvec.prototype.cljs$core$IVector$_assoc_n = function(coll, n, val) {
  var this__1607437 = this;
  return cljs.core._assoc.call(null, coll, n, val)
};
cljs.core.Subvec.prototype.cljs$core$IEquiv$ = true;
cljs.core.Subvec.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1607438 = this;
  return cljs.core.equiv_sequential.call(null, coll, other)
};
cljs.core.Subvec.prototype.cljs$core$IWithMeta$ = true;
cljs.core.Subvec.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1607439 = this;
  return new cljs.core.Subvec(meta, this__1607439.v, this__1607439.start, this__1607439.end)
};
cljs.core.Subvec.prototype.cljs$core$IMeta$ = true;
cljs.core.Subvec.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1607440 = this;
  return this__1607440.meta
};
cljs.core.Subvec.prototype.cljs$core$IIndexed$ = true;
cljs.core.Subvec.prototype.cljs$core$IIndexed$_nth = function() {
  var G__1607456 = null;
  var G__1607456__1607457 = function(coll, n) {
    var this__1607441 = this;
    return cljs.core._nth.call(null, this__1607441.v, this__1607441.start + n)
  };
  var G__1607456__1607458 = function(coll, n, not_found) {
    var this__1607442 = this;
    return cljs.core._nth.call(null, this__1607442.v, this__1607442.start + n, not_found)
  };
  G__1607456 = function(coll, n, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607456__1607457.call(this, coll, n);
      case 3:
        return G__1607456__1607458.call(this, coll, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607456
}();
cljs.core.Subvec.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.Subvec.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1607443 = this;
  return cljs.core.with_meta.call(null, cljs.core.Vector.EMPTY, this__1607443.meta)
};
cljs.core.Subvec;
cljs.core.subvec = function() {
  var subvec = null;
  var subvec__1607460 = function(v, start) {
    return subvec.call(null, v, start, cljs.core.count.call(null, v))
  };
  var subvec__1607461 = function(v, start, end) {
    return new cljs.core.Subvec(null, v, start, end)
  };
  subvec = function(v, start, end) {
    switch(arguments.length) {
      case 2:
        return subvec__1607460.call(this, v, start);
      case 3:
        return subvec__1607461.call(this, v, start, end)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return subvec
}();
cljs.core.PersistentQueueSeq = function(meta, front, rear) {
  this.meta = meta;
  this.front = front;
  this.rear = rear
};
cljs.core.PersistentQueueSeq.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.PersistentQueueSeq")
};
cljs.core.PersistentQueueSeq.prototype.cljs$core$ISeqable$ = true;
cljs.core.PersistentQueueSeq.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1607463 = this;
  return coll
};
cljs.core.PersistentQueueSeq.prototype.cljs$core$IHash$ = true;
cljs.core.PersistentQueueSeq.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1607464 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.PersistentQueueSeq.prototype.cljs$core$IEquiv$ = true;
cljs.core.PersistentQueueSeq.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1607465 = this;
  return cljs.core.equiv_sequential.call(null, coll, other)
};
cljs.core.PersistentQueueSeq.prototype.cljs$core$ISequential$ = true;
cljs.core.PersistentQueueSeq.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.PersistentQueueSeq.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1607466 = this;
  return cljs.core.with_meta.call(null, cljs.core.List.EMPTY, this__1607466.meta)
};
cljs.core.PersistentQueueSeq.prototype.cljs$core$ICollection$ = true;
cljs.core.PersistentQueueSeq.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1607467 = this;
  return cljs.core.cons.call(null, o, coll)
};
cljs.core.PersistentQueueSeq.prototype.cljs$core$ISeq$ = true;
cljs.core.PersistentQueueSeq.prototype.cljs$core$ISeq$_first = function(coll) {
  var this__1607468 = this;
  return cljs.core._first.call(null, this__1607468.front)
};
cljs.core.PersistentQueueSeq.prototype.cljs$core$ISeq$_rest = function(coll) {
  var this__1607469 = this;
  var temp__3695__auto____1607470 = cljs.core.next.call(null, this__1607469.front);
  if(cljs.core.truth_(temp__3695__auto____1607470)) {
    var f1__1607471 = temp__3695__auto____1607470;
    return new cljs.core.PersistentQueueSeq(this__1607469.meta, f1__1607471, this__1607469.rear)
  }else {
    if(cljs.core.truth_(this__1607469.rear === null)) {
      return cljs.core._empty.call(null, coll)
    }else {
      return new cljs.core.PersistentQueueSeq(this__1607469.meta, this__1607469.rear, null)
    }
  }
};
cljs.core.PersistentQueueSeq.prototype.cljs$core$IMeta$ = true;
cljs.core.PersistentQueueSeq.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1607472 = this;
  return this__1607472.meta
};
cljs.core.PersistentQueueSeq.prototype.cljs$core$IWithMeta$ = true;
cljs.core.PersistentQueueSeq.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1607473 = this;
  return new cljs.core.PersistentQueueSeq(meta, this__1607473.front, this__1607473.rear)
};
cljs.core.PersistentQueueSeq;
cljs.core.PersistentQueue = function(meta, count, front, rear) {
  this.meta = meta;
  this.count = count;
  this.front = front;
  this.rear = rear
};
cljs.core.PersistentQueue.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.PersistentQueue")
};
cljs.core.PersistentQueue.prototype.cljs$core$IHash$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1607474 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.PersistentQueue.prototype.cljs$core$ISequential$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$ICollection$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1607475 = this;
  if(cljs.core.truth_(this__1607475.front)) {
    return new cljs.core.PersistentQueue(this__1607475.meta, this__1607475.count + 1, this__1607475.front, cljs.core.conj.call(null, function() {
      var or__3548__auto____1607476 = this__1607475.rear;
      if(cljs.core.truth_(or__3548__auto____1607476)) {
        return or__3548__auto____1607476
      }else {
        return cljs.core.PersistentVector.fromArray([])
      }
    }(), o))
  }else {
    return new cljs.core.PersistentQueue(this__1607475.meta, this__1607475.count + 1, cljs.core.conj.call(null, this__1607475.front, o), cljs.core.PersistentVector.fromArray([]))
  }
};
cljs.core.PersistentQueue.prototype.cljs$core$ISeqable$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1607477 = this;
  var rear__1607478 = cljs.core.seq.call(null, this__1607477.rear);
  if(cljs.core.truth_(function() {
    var or__3548__auto____1607479 = this__1607477.front;
    if(cljs.core.truth_(or__3548__auto____1607479)) {
      return or__3548__auto____1607479
    }else {
      return rear__1607478
    }
  }())) {
    return new cljs.core.PersistentQueueSeq(null, this__1607477.front, cljs.core.seq.call(null, rear__1607478))
  }else {
    return cljs.core.List.EMPTY
  }
};
cljs.core.PersistentQueue.prototype.cljs$core$ICounted$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$ICounted$_count = function(coll) {
  var this__1607480 = this;
  return this__1607480.count
};
cljs.core.PersistentQueue.prototype.cljs$core$IStack$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$IStack$_peek = function(coll) {
  var this__1607481 = this;
  return cljs.core._first.call(null, this__1607481.front)
};
cljs.core.PersistentQueue.prototype.cljs$core$IStack$_pop = function(coll) {
  var this__1607482 = this;
  if(cljs.core.truth_(this__1607482.front)) {
    var temp__3695__auto____1607483 = cljs.core.next.call(null, this__1607482.front);
    if(cljs.core.truth_(temp__3695__auto____1607483)) {
      var f1__1607484 = temp__3695__auto____1607483;
      return new cljs.core.PersistentQueue(this__1607482.meta, this__1607482.count - 1, f1__1607484, this__1607482.rear)
    }else {
      return new cljs.core.PersistentQueue(this__1607482.meta, this__1607482.count - 1, cljs.core.seq.call(null, this__1607482.rear), cljs.core.PersistentVector.fromArray([]))
    }
  }else {
    return coll
  }
};
cljs.core.PersistentQueue.prototype.cljs$core$ISeq$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$ISeq$_first = function(coll) {
  var this__1607485 = this;
  return cljs.core.first.call(null, this__1607485.front)
};
cljs.core.PersistentQueue.prototype.cljs$core$ISeq$_rest = function(coll) {
  var this__1607486 = this;
  return cljs.core.rest.call(null, cljs.core.seq.call(null, coll))
};
cljs.core.PersistentQueue.prototype.cljs$core$IEquiv$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1607487 = this;
  return cljs.core.equiv_sequential.call(null, coll, other)
};
cljs.core.PersistentQueue.prototype.cljs$core$IWithMeta$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1607488 = this;
  return new cljs.core.PersistentQueue(meta, this__1607488.count, this__1607488.front, this__1607488.rear)
};
cljs.core.PersistentQueue.prototype.cljs$core$IMeta$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1607489 = this;
  return this__1607489.meta
};
cljs.core.PersistentQueue.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.PersistentQueue.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1607490 = this;
  return cljs.core.PersistentQueue.EMPTY
};
cljs.core.PersistentQueue;
cljs.core.PersistentQueue.EMPTY = new cljs.core.PersistentQueue(null, 0, null, cljs.core.PersistentVector.fromArray([]));
cljs.core.NeverEquiv = function() {
};
cljs.core.NeverEquiv.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.NeverEquiv")
};
cljs.core.NeverEquiv.prototype.cljs$core$IEquiv$ = true;
cljs.core.NeverEquiv.prototype.cljs$core$IEquiv$_equiv = function(o, other) {
  var this__1607491 = this;
  return false
};
cljs.core.NeverEquiv;
cljs.core.never_equiv = new cljs.core.NeverEquiv;
cljs.core.equiv_map = function equiv_map(x, y) {
  return cljs.core.boolean$.call(null, cljs.core.truth_(cljs.core.map_QMARK_.call(null, y)) ? cljs.core.truth_(cljs.core._EQ_.call(null, cljs.core.count.call(null, x), cljs.core.count.call(null, y))) ? cljs.core.every_QMARK_.call(null, cljs.core.identity, cljs.core.map.call(null, function(xkv) {
    return cljs.core._EQ_.call(null, cljs.core.get.call(null, y, cljs.core.first.call(null, xkv), cljs.core.never_equiv), cljs.core.second.call(null, xkv))
  }, x)) : null : null)
};
cljs.core.scan_array = function scan_array(incr, k, array) {
  var len__1607492 = array.length;
  var i__1607493 = 0;
  while(true) {
    if(cljs.core.truth_(i__1607493 < len__1607492)) {
      if(cljs.core.truth_(cljs.core._EQ_.call(null, k, array[i__1607493]))) {
        return i__1607493
      }else {
        var G__1607494 = i__1607493 + incr;
        i__1607493 = G__1607494;
        continue
      }
    }else {
      return null
    }
    break
  }
};
cljs.core.obj_map_contains_key_QMARK_ = function() {
  var obj_map_contains_key_QMARK_ = null;
  var obj_map_contains_key_QMARK___1607496 = function(k, strobj) {
    return obj_map_contains_key_QMARK_.call(null, k, strobj, true, false)
  };
  var obj_map_contains_key_QMARK___1607497 = function(k, strobj, true_val, false_val) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1607495 = goog.isString.call(null, k);
      if(cljs.core.truth_(and__3546__auto____1607495)) {
        return strobj.hasOwnProperty(k)
      }else {
        return and__3546__auto____1607495
      }
    }())) {
      return true_val
    }else {
      return false_val
    }
  };
  obj_map_contains_key_QMARK_ = function(k, strobj, true_val, false_val) {
    switch(arguments.length) {
      case 2:
        return obj_map_contains_key_QMARK___1607496.call(this, k, strobj);
      case 4:
        return obj_map_contains_key_QMARK___1607497.call(this, k, strobj, true_val, false_val)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return obj_map_contains_key_QMARK_
}();
cljs.core.obj_map_compare_keys = function obj_map_compare_keys(a, b) {
  var a__1607500 = cljs.core.hash.call(null, a);
  var b__1607501 = cljs.core.hash.call(null, b);
  if(cljs.core.truth_(a__1607500 < b__1607501)) {
    return-1
  }else {
    if(cljs.core.truth_(a__1607500 > b__1607501)) {
      return 1
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        return 0
      }else {
        return null
      }
    }
  }
};
cljs.core.ObjMap = function(meta, keys, strobj) {
  this.meta = meta;
  this.keys = keys;
  this.strobj = strobj
};
cljs.core.ObjMap.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.ObjMap")
};
cljs.core.ObjMap.prototype.cljs$core$IHash$ = true;
cljs.core.ObjMap.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1607502 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.ObjMap.prototype.cljs$core$ILookup$ = true;
cljs.core.ObjMap.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1607529 = null;
  var G__1607529__1607530 = function(coll, k) {
    var this__1607503 = this;
    return cljs.core._lookup.call(null, coll, k, null)
  };
  var G__1607529__1607531 = function(coll, k, not_found) {
    var this__1607504 = this;
    return cljs.core.obj_map_contains_key_QMARK_.call(null, k, this__1607504.strobj, this__1607504.strobj[k], not_found)
  };
  G__1607529 = function(coll, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607529__1607530.call(this, coll, k);
      case 3:
        return G__1607529__1607531.call(this, coll, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607529
}();
cljs.core.ObjMap.prototype.cljs$core$IAssociative$ = true;
cljs.core.ObjMap.prototype.cljs$core$IAssociative$_assoc = function(coll, k, v) {
  var this__1607505 = this;
  if(cljs.core.truth_(goog.isString.call(null, k))) {
    var new_strobj__1607506 = goog.object.clone.call(null, this__1607505.strobj);
    var overwrite_QMARK___1607507 = new_strobj__1607506.hasOwnProperty(k);
    new_strobj__1607506[k] = v;
    if(cljs.core.truth_(overwrite_QMARK___1607507)) {
      return new cljs.core.ObjMap(this__1607505.meta, this__1607505.keys, new_strobj__1607506)
    }else {
      var new_keys__1607508 = cljs.core.aclone.call(null, this__1607505.keys);
      new_keys__1607508.push(k);
      return new cljs.core.ObjMap(this__1607505.meta, new_keys__1607508, new_strobj__1607506)
    }
  }else {
    return cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.hash_map.call(null, k, v), cljs.core.seq.call(null, coll)), this__1607505.meta)
  }
};
cljs.core.ObjMap.prototype.cljs$core$IAssociative$_contains_key_QMARK_ = function(coll, k) {
  var this__1607509 = this;
  return cljs.core.obj_map_contains_key_QMARK_.call(null, k, this__1607509.strobj)
};
cljs.core.ObjMap.prototype.cljs$core$IFn$ = true;
cljs.core.ObjMap.prototype.call = function() {
  var G__1607533 = null;
  var G__1607533__1607534 = function(tsym1607510, k) {
    var this__1607512 = this;
    var tsym1607510__1607513 = this;
    var coll__1607514 = tsym1607510__1607513;
    return cljs.core._lookup.call(null, coll__1607514, k)
  };
  var G__1607533__1607535 = function(tsym1607511, k, not_found) {
    var this__1607515 = this;
    var tsym1607511__1607516 = this;
    var coll__1607517 = tsym1607511__1607516;
    return cljs.core._lookup.call(null, coll__1607517, k, not_found)
  };
  G__1607533 = function(tsym1607511, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607533__1607534.call(this, tsym1607511, k);
      case 3:
        return G__1607533__1607535.call(this, tsym1607511, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607533
}();
cljs.core.ObjMap.prototype.cljs$core$ICollection$ = true;
cljs.core.ObjMap.prototype.cljs$core$ICollection$_conj = function(coll, entry) {
  var this__1607518 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry))) {
    return cljs.core._assoc.call(null, coll, cljs.core._nth.call(null, entry, 0), cljs.core._nth.call(null, entry, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, coll, entry)
  }
};
cljs.core.ObjMap.prototype.cljs$core$ISeqable$ = true;
cljs.core.ObjMap.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1607519 = this;
  if(cljs.core.truth_(this__1607519.keys.length > 0)) {
    return cljs.core.map.call(null, function(p1__1607499_SHARP_) {
      return cljs.core.vector.call(null, p1__1607499_SHARP_, this__1607519.strobj[p1__1607499_SHARP_])
    }, this__1607519.keys.sort(cljs.core.obj_map_compare_keys))
  }else {
    return null
  }
};
cljs.core.ObjMap.prototype.cljs$core$ICounted$ = true;
cljs.core.ObjMap.prototype.cljs$core$ICounted$_count = function(coll) {
  var this__1607520 = this;
  return this__1607520.keys.length
};
cljs.core.ObjMap.prototype.cljs$core$IEquiv$ = true;
cljs.core.ObjMap.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1607521 = this;
  return cljs.core.equiv_map.call(null, coll, other)
};
cljs.core.ObjMap.prototype.cljs$core$IWithMeta$ = true;
cljs.core.ObjMap.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1607522 = this;
  return new cljs.core.ObjMap(meta, this__1607522.keys, this__1607522.strobj)
};
cljs.core.ObjMap.prototype.cljs$core$IMeta$ = true;
cljs.core.ObjMap.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1607523 = this;
  return this__1607523.meta
};
cljs.core.ObjMap.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.ObjMap.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1607524 = this;
  return cljs.core.with_meta.call(null, cljs.core.ObjMap.EMPTY, this__1607524.meta)
};
cljs.core.ObjMap.prototype.cljs$core$IMap$ = true;
cljs.core.ObjMap.prototype.cljs$core$IMap$_dissoc = function(coll, k) {
  var this__1607525 = this;
  if(cljs.core.truth_(function() {
    var and__3546__auto____1607526 = goog.isString.call(null, k);
    if(cljs.core.truth_(and__3546__auto____1607526)) {
      return this__1607525.strobj.hasOwnProperty(k)
    }else {
      return and__3546__auto____1607526
    }
  }())) {
    var new_keys__1607527 = cljs.core.aclone.call(null, this__1607525.keys);
    var new_strobj__1607528 = goog.object.clone.call(null, this__1607525.strobj);
    new_keys__1607527.splice(cljs.core.scan_array.call(null, 1, k, new_keys__1607527), 1);
    cljs.core.js_delete.call(null, new_strobj__1607528, k);
    return new cljs.core.ObjMap(this__1607525.meta, new_keys__1607527, new_strobj__1607528)
  }else {
    return coll
  }
};
cljs.core.ObjMap;
cljs.core.ObjMap.EMPTY = new cljs.core.ObjMap(null, [], cljs.core.js_obj.call(null));
cljs.core.ObjMap.fromObject = function(ks, obj) {
  return new cljs.core.ObjMap(null, ks, obj)
};
cljs.core.HashMap = function(meta, count, hashobj) {
  this.meta = meta;
  this.count = count;
  this.hashobj = hashobj
};
cljs.core.HashMap.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.HashMap")
};
cljs.core.HashMap.prototype.cljs$core$IHash$ = true;
cljs.core.HashMap.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1607538 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.HashMap.prototype.cljs$core$ILookup$ = true;
cljs.core.HashMap.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1607576 = null;
  var G__1607576__1607577 = function(coll, k) {
    var this__1607539 = this;
    return cljs.core._lookup.call(null, coll, k, null)
  };
  var G__1607576__1607578 = function(coll, k, not_found) {
    var this__1607540 = this;
    var bucket__1607541 = this__1607540.hashobj[cljs.core.hash.call(null, k)];
    var i__1607542 = cljs.core.truth_(bucket__1607541) ? cljs.core.scan_array.call(null, 2, k, bucket__1607541) : null;
    if(cljs.core.truth_(i__1607542)) {
      return bucket__1607541[i__1607542 + 1]
    }else {
      return not_found
    }
  };
  G__1607576 = function(coll, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607576__1607577.call(this, coll, k);
      case 3:
        return G__1607576__1607578.call(this, coll, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607576
}();
cljs.core.HashMap.prototype.cljs$core$IAssociative$ = true;
cljs.core.HashMap.prototype.cljs$core$IAssociative$_assoc = function(coll, k, v) {
  var this__1607543 = this;
  var h__1607544 = cljs.core.hash.call(null, k);
  var bucket__1607545 = this__1607543.hashobj[h__1607544];
  if(cljs.core.truth_(bucket__1607545)) {
    var new_bucket__1607546 = cljs.core.aclone.call(null, bucket__1607545);
    var new_hashobj__1607547 = goog.object.clone.call(null, this__1607543.hashobj);
    new_hashobj__1607547[h__1607544] = new_bucket__1607546;
    var temp__3695__auto____1607548 = cljs.core.scan_array.call(null, 2, k, new_bucket__1607546);
    if(cljs.core.truth_(temp__3695__auto____1607548)) {
      var i__1607549 = temp__3695__auto____1607548;
      new_bucket__1607546[i__1607549 + 1] = v;
      return new cljs.core.HashMap(this__1607543.meta, this__1607543.count, new_hashobj__1607547)
    }else {
      new_bucket__1607546.push(k, v);
      return new cljs.core.HashMap(this__1607543.meta, this__1607543.count + 1, new_hashobj__1607547)
    }
  }else {
    var new_hashobj__1607550 = goog.object.clone.call(null, this__1607543.hashobj);
    new_hashobj__1607550[h__1607544] = [k, v];
    return new cljs.core.HashMap(this__1607543.meta, this__1607543.count + 1, new_hashobj__1607550)
  }
};
cljs.core.HashMap.prototype.cljs$core$IAssociative$_contains_key_QMARK_ = function(coll, k) {
  var this__1607551 = this;
  var bucket__1607552 = this__1607551.hashobj[cljs.core.hash.call(null, k)];
  var i__1607553 = cljs.core.truth_(bucket__1607552) ? cljs.core.scan_array.call(null, 2, k, bucket__1607552) : null;
  if(cljs.core.truth_(i__1607553)) {
    return true
  }else {
    return false
  }
};
cljs.core.HashMap.prototype.cljs$core$IFn$ = true;
cljs.core.HashMap.prototype.call = function() {
  var G__1607580 = null;
  var G__1607580__1607581 = function(tsym1607554, k) {
    var this__1607556 = this;
    var tsym1607554__1607557 = this;
    var coll__1607558 = tsym1607554__1607557;
    return cljs.core._lookup.call(null, coll__1607558, k)
  };
  var G__1607580__1607582 = function(tsym1607555, k, not_found) {
    var this__1607559 = this;
    var tsym1607555__1607560 = this;
    var coll__1607561 = tsym1607555__1607560;
    return cljs.core._lookup.call(null, coll__1607561, k, not_found)
  };
  G__1607580 = function(tsym1607555, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607580__1607581.call(this, tsym1607555, k);
      case 3:
        return G__1607580__1607582.call(this, tsym1607555, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607580
}();
cljs.core.HashMap.prototype.cljs$core$ICollection$ = true;
cljs.core.HashMap.prototype.cljs$core$ICollection$_conj = function(coll, entry) {
  var this__1607562 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry))) {
    return cljs.core._assoc.call(null, coll, cljs.core._nth.call(null, entry, 0), cljs.core._nth.call(null, entry, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, coll, entry)
  }
};
cljs.core.HashMap.prototype.cljs$core$ISeqable$ = true;
cljs.core.HashMap.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1607563 = this;
  if(cljs.core.truth_(this__1607563.count > 0)) {
    var hashes__1607564 = cljs.core.js_keys.call(null, this__1607563.hashobj).sort();
    return cljs.core.mapcat.call(null, function(p1__1607537_SHARP_) {
      return cljs.core.map.call(null, cljs.core.vec, cljs.core.partition.call(null, 2, this__1607563.hashobj[p1__1607537_SHARP_]))
    }, hashes__1607564)
  }else {
    return null
  }
};
cljs.core.HashMap.prototype.cljs$core$ICounted$ = true;
cljs.core.HashMap.prototype.cljs$core$ICounted$_count = function(coll) {
  var this__1607565 = this;
  return this__1607565.count
};
cljs.core.HashMap.prototype.cljs$core$IEquiv$ = true;
cljs.core.HashMap.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1607566 = this;
  return cljs.core.equiv_map.call(null, coll, other)
};
cljs.core.HashMap.prototype.cljs$core$IWithMeta$ = true;
cljs.core.HashMap.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1607567 = this;
  return new cljs.core.HashMap(meta, this__1607567.count, this__1607567.hashobj)
};
cljs.core.HashMap.prototype.cljs$core$IMeta$ = true;
cljs.core.HashMap.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1607568 = this;
  return this__1607568.meta
};
cljs.core.HashMap.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.HashMap.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1607569 = this;
  return cljs.core.with_meta.call(null, cljs.core.HashMap.EMPTY, this__1607569.meta)
};
cljs.core.HashMap.prototype.cljs$core$IMap$ = true;
cljs.core.HashMap.prototype.cljs$core$IMap$_dissoc = function(coll, k) {
  var this__1607570 = this;
  var h__1607571 = cljs.core.hash.call(null, k);
  var bucket__1607572 = this__1607570.hashobj[h__1607571];
  var i__1607573 = cljs.core.truth_(bucket__1607572) ? cljs.core.scan_array.call(null, 2, k, bucket__1607572) : null;
  if(cljs.core.truth_(cljs.core.not.call(null, i__1607573))) {
    return coll
  }else {
    var new_hashobj__1607574 = goog.object.clone.call(null, this__1607570.hashobj);
    if(cljs.core.truth_(3 > bucket__1607572.length)) {
      cljs.core.js_delete.call(null, new_hashobj__1607574, h__1607571)
    }else {
      var new_bucket__1607575 = cljs.core.aclone.call(null, bucket__1607572);
      new_bucket__1607575.splice(i__1607573, 2);
      new_hashobj__1607574[h__1607571] = new_bucket__1607575
    }
    return new cljs.core.HashMap(this__1607570.meta, this__1607570.count - 1, new_hashobj__1607574)
  }
};
cljs.core.HashMap;
cljs.core.HashMap.EMPTY = new cljs.core.HashMap(null, 0, cljs.core.js_obj.call(null));
cljs.core.HashMap.fromArrays = function(ks, vs) {
  var len__1607584 = ks.length;
  var i__1607585 = 0;
  var out__1607586 = cljs.core.HashMap.EMPTY;
  while(true) {
    if(cljs.core.truth_(i__1607585 < len__1607584)) {
      var G__1607587 = i__1607585 + 1;
      var G__1607588 = cljs.core.assoc.call(null, out__1607586, ks[i__1607585], vs[i__1607585]);
      i__1607585 = G__1607587;
      out__1607586 = G__1607588;
      continue
    }else {
      return out__1607586
    }
    break
  }
};
cljs.core.hash_map = function() {
  var hash_map__delegate = function(keyvals) {
    var in$__1607589 = cljs.core.seq.call(null, keyvals);
    var out__1607590 = cljs.core.HashMap.EMPTY;
    while(true) {
      if(cljs.core.truth_(in$__1607589)) {
        var G__1607591 = cljs.core.nnext.call(null, in$__1607589);
        var G__1607592 = cljs.core.assoc.call(null, out__1607590, cljs.core.first.call(null, in$__1607589), cljs.core.second.call(null, in$__1607589));
        in$__1607589 = G__1607591;
        out__1607590 = G__1607592;
        continue
      }else {
        return out__1607590
      }
      break
    }
  };
  var hash_map = function(var_args) {
    var keyvals = null;
    if(goog.isDef(var_args)) {
      keyvals = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return hash_map__delegate.call(this, keyvals)
  };
  hash_map.cljs$lang$maxFixedArity = 0;
  hash_map.cljs$lang$applyTo = function(arglist__1607593) {
    var keyvals = cljs.core.seq(arglist__1607593);
    return hash_map__delegate.call(this, keyvals)
  };
  return hash_map
}();
cljs.core.keys = function keys(hash_map) {
  return cljs.core.seq.call(null, cljs.core.map.call(null, cljs.core.first, hash_map))
};
cljs.core.vals = function vals(hash_map) {
  return cljs.core.seq.call(null, cljs.core.map.call(null, cljs.core.second, hash_map))
};
cljs.core.merge = function() {
  var merge__delegate = function(maps) {
    if(cljs.core.truth_(cljs.core.some.call(null, cljs.core.identity, maps))) {
      return cljs.core.reduce.call(null, function(p1__1607594_SHARP_, p2__1607595_SHARP_) {
        return cljs.core.conj.call(null, function() {
          var or__3548__auto____1607596 = p1__1607594_SHARP_;
          if(cljs.core.truth_(or__3548__auto____1607596)) {
            return or__3548__auto____1607596
          }else {
            return cljs.core.ObjMap.fromObject([], {})
          }
        }(), p2__1607595_SHARP_)
      }, maps)
    }else {
      return null
    }
  };
  var merge = function(var_args) {
    var maps = null;
    if(goog.isDef(var_args)) {
      maps = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return merge__delegate.call(this, maps)
  };
  merge.cljs$lang$maxFixedArity = 0;
  merge.cljs$lang$applyTo = function(arglist__1607597) {
    var maps = cljs.core.seq(arglist__1607597);
    return merge__delegate.call(this, maps)
  };
  return merge
}();
cljs.core.merge_with = function() {
  var merge_with__delegate = function(f, maps) {
    if(cljs.core.truth_(cljs.core.some.call(null, cljs.core.identity, maps))) {
      var merge_entry__1607600 = function(m, e) {
        var k__1607598 = cljs.core.first.call(null, e);
        var v__1607599 = cljs.core.second.call(null, e);
        if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, m, k__1607598))) {
          return cljs.core.assoc.call(null, m, k__1607598, f.call(null, cljs.core.get.call(null, m, k__1607598), v__1607599))
        }else {
          return cljs.core.assoc.call(null, m, k__1607598, v__1607599)
        }
      };
      var merge2__1607602 = function(m1, m2) {
        return cljs.core.reduce.call(null, merge_entry__1607600, function() {
          var or__3548__auto____1607601 = m1;
          if(cljs.core.truth_(or__3548__auto____1607601)) {
            return or__3548__auto____1607601
          }else {
            return cljs.core.ObjMap.fromObject([], {})
          }
        }(), cljs.core.seq.call(null, m2))
      };
      return cljs.core.reduce.call(null, merge2__1607602, maps)
    }else {
      return null
    }
  };
  var merge_with = function(f, var_args) {
    var maps = null;
    if(goog.isDef(var_args)) {
      maps = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1), 0)
    }
    return merge_with__delegate.call(this, f, maps)
  };
  merge_with.cljs$lang$maxFixedArity = 1;
  merge_with.cljs$lang$applyTo = function(arglist__1607603) {
    var f = cljs.core.first(arglist__1607603);
    var maps = cljs.core.rest(arglist__1607603);
    return merge_with__delegate.call(this, f, maps)
  };
  return merge_with
}();
cljs.core.select_keys = function select_keys(map, keyseq) {
  var ret__1607605 = cljs.core.ObjMap.fromObject([], {});
  var keys__1607606 = cljs.core.seq.call(null, keyseq);
  while(true) {
    if(cljs.core.truth_(keys__1607606)) {
      var key__1607607 = cljs.core.first.call(null, keys__1607606);
      var entry__1607608 = cljs.core.get.call(null, map, key__1607607, "\ufdd0'user/not-found");
      var G__1607609 = cljs.core.truth_(cljs.core.not_EQ_.call(null, entry__1607608, "\ufdd0'user/not-found")) ? cljs.core.assoc.call(null, ret__1607605, key__1607607, entry__1607608) : ret__1607605;
      var G__1607610 = cljs.core.next.call(null, keys__1607606);
      ret__1607605 = G__1607609;
      keys__1607606 = G__1607610;
      continue
    }else {
      return ret__1607605
    }
    break
  }
};
cljs.core.Set = function(meta, hash_map) {
  this.meta = meta;
  this.hash_map = hash_map
};
cljs.core.Set.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.Set")
};
cljs.core.Set.prototype.cljs$core$IHash$ = true;
cljs.core.Set.prototype.cljs$core$IHash$_hash = function(coll) {
  var this__1607611 = this;
  return cljs.core.hash_coll.call(null, coll)
};
cljs.core.Set.prototype.cljs$core$ILookup$ = true;
cljs.core.Set.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1607632 = null;
  var G__1607632__1607633 = function(coll, v) {
    var this__1607612 = this;
    return cljs.core._lookup.call(null, coll, v, null)
  };
  var G__1607632__1607634 = function(coll, v, not_found) {
    var this__1607613 = this;
    if(cljs.core.truth_(cljs.core._contains_key_QMARK_.call(null, this__1607613.hash_map, v))) {
      return v
    }else {
      return not_found
    }
  };
  G__1607632 = function(coll, v, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607632__1607633.call(this, coll, v);
      case 3:
        return G__1607632__1607634.call(this, coll, v, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607632
}();
cljs.core.Set.prototype.cljs$core$IFn$ = true;
cljs.core.Set.prototype.call = function() {
  var G__1607636 = null;
  var G__1607636__1607637 = function(tsym1607614, k) {
    var this__1607616 = this;
    var tsym1607614__1607617 = this;
    var coll__1607618 = tsym1607614__1607617;
    return cljs.core._lookup.call(null, coll__1607618, k)
  };
  var G__1607636__1607638 = function(tsym1607615, k, not_found) {
    var this__1607619 = this;
    var tsym1607615__1607620 = this;
    var coll__1607621 = tsym1607615__1607620;
    return cljs.core._lookup.call(null, coll__1607621, k, not_found)
  };
  G__1607636 = function(tsym1607615, k, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607636__1607637.call(this, tsym1607615, k);
      case 3:
        return G__1607636__1607638.call(this, tsym1607615, k, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607636
}();
cljs.core.Set.prototype.cljs$core$ICollection$ = true;
cljs.core.Set.prototype.cljs$core$ICollection$_conj = function(coll, o) {
  var this__1607622 = this;
  return new cljs.core.Set(this__1607622.meta, cljs.core.assoc.call(null, this__1607622.hash_map, o, null))
};
cljs.core.Set.prototype.cljs$core$ISeqable$ = true;
cljs.core.Set.prototype.cljs$core$ISeqable$_seq = function(coll) {
  var this__1607623 = this;
  return cljs.core.keys.call(null, this__1607623.hash_map)
};
cljs.core.Set.prototype.cljs$core$ISet$ = true;
cljs.core.Set.prototype.cljs$core$ISet$_disjoin = function(coll, v) {
  var this__1607624 = this;
  return new cljs.core.Set(this__1607624.meta, cljs.core.dissoc.call(null, this__1607624.hash_map, v))
};
cljs.core.Set.prototype.cljs$core$ICounted$ = true;
cljs.core.Set.prototype.cljs$core$ICounted$_count = function(coll) {
  var this__1607625 = this;
  return cljs.core.count.call(null, cljs.core.seq.call(null, coll))
};
cljs.core.Set.prototype.cljs$core$IEquiv$ = true;
cljs.core.Set.prototype.cljs$core$IEquiv$_equiv = function(coll, other) {
  var this__1607626 = this;
  var and__3546__auto____1607627 = cljs.core.set_QMARK_.call(null, other);
  if(cljs.core.truth_(and__3546__auto____1607627)) {
    var and__3546__auto____1607628 = cljs.core._EQ_.call(null, cljs.core.count.call(null, coll), cljs.core.count.call(null, other));
    if(cljs.core.truth_(and__3546__auto____1607628)) {
      return cljs.core.every_QMARK_.call(null, function(p1__1607604_SHARP_) {
        return cljs.core.contains_QMARK_.call(null, coll, p1__1607604_SHARP_)
      }, other)
    }else {
      return and__3546__auto____1607628
    }
  }else {
    return and__3546__auto____1607627
  }
};
cljs.core.Set.prototype.cljs$core$IWithMeta$ = true;
cljs.core.Set.prototype.cljs$core$IWithMeta$_with_meta = function(coll, meta) {
  var this__1607629 = this;
  return new cljs.core.Set(meta, this__1607629.hash_map)
};
cljs.core.Set.prototype.cljs$core$IMeta$ = true;
cljs.core.Set.prototype.cljs$core$IMeta$_meta = function(coll) {
  var this__1607630 = this;
  return this__1607630.meta
};
cljs.core.Set.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.Set.prototype.cljs$core$IEmptyableCollection$_empty = function(coll) {
  var this__1607631 = this;
  return cljs.core.with_meta.call(null, cljs.core.Set.EMPTY, this__1607631.meta)
};
cljs.core.Set;
cljs.core.Set.EMPTY = new cljs.core.Set(null, cljs.core.hash_map.call(null));
cljs.core.set = function set(coll) {
  var in$__1607641 = cljs.core.seq.call(null, coll);
  var out__1607642 = cljs.core.Set.EMPTY;
  while(true) {
    if(cljs.core.truth_(cljs.core.not.call(null, cljs.core.empty_QMARK_.call(null, in$__1607641)))) {
      var G__1607643 = cljs.core.rest.call(null, in$__1607641);
      var G__1607644 = cljs.core.conj.call(null, out__1607642, cljs.core.first.call(null, in$__1607641));
      in$__1607641 = G__1607643;
      out__1607642 = G__1607644;
      continue
    }else {
      return out__1607642
    }
    break
  }
};
cljs.core.replace = function replace(smap, coll) {
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, coll))) {
    var n__1607645 = cljs.core.count.call(null, coll);
    return cljs.core.reduce.call(null, function(v, i) {
      var temp__3695__auto____1607646 = cljs.core.find.call(null, smap, cljs.core.nth.call(null, v, i));
      if(cljs.core.truth_(temp__3695__auto____1607646)) {
        var e__1607647 = temp__3695__auto____1607646;
        return cljs.core.assoc.call(null, v, i, cljs.core.second.call(null, e__1607647))
      }else {
        return v
      }
    }, coll, cljs.core.take.call(null, n__1607645, cljs.core.iterate.call(null, cljs.core.inc, 0)))
  }else {
    return cljs.core.map.call(null, function(p1__1607640_SHARP_) {
      var temp__3695__auto____1607648 = cljs.core.find.call(null, smap, p1__1607640_SHARP_);
      if(cljs.core.truth_(temp__3695__auto____1607648)) {
        var e__1607649 = temp__3695__auto____1607648;
        return cljs.core.second.call(null, e__1607649)
      }else {
        return p1__1607640_SHARP_
      }
    }, coll)
  }
};
cljs.core.distinct = function distinct(coll) {
  var step__1607657 = function step(xs, seen) {
    return new cljs.core.LazySeq(null, false, function() {
      return function(p__1607650, seen) {
        while(true) {
          var vec__1607651__1607652 = p__1607650;
          var f__1607653 = cljs.core.nth.call(null, vec__1607651__1607652, 0, null);
          var xs__1607654 = vec__1607651__1607652;
          var temp__3698__auto____1607655 = cljs.core.seq.call(null, xs__1607654);
          if(cljs.core.truth_(temp__3698__auto____1607655)) {
            var s__1607656 = temp__3698__auto____1607655;
            if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, seen, f__1607653))) {
              var G__1607658 = cljs.core.rest.call(null, s__1607656);
              var G__1607659 = seen;
              p__1607650 = G__1607658;
              seen = G__1607659;
              continue
            }else {
              return cljs.core.cons.call(null, f__1607653, step.call(null, cljs.core.rest.call(null, s__1607656), cljs.core.conj.call(null, seen, f__1607653)))
            }
          }else {
            return null
          }
          break
        }
      }.call(null, xs, seen)
    })
  };
  return step__1607657.call(null, coll, cljs.core.set([]))
};
cljs.core.butlast = function butlast(s) {
  var ret__1607660 = cljs.core.PersistentVector.fromArray([]);
  var s__1607661 = s;
  while(true) {
    if(cljs.core.truth_(cljs.core.next.call(null, s__1607661))) {
      var G__1607662 = cljs.core.conj.call(null, ret__1607660, cljs.core.first.call(null, s__1607661));
      var G__1607663 = cljs.core.next.call(null, s__1607661);
      ret__1607660 = G__1607662;
      s__1607661 = G__1607663;
      continue
    }else {
      return cljs.core.seq.call(null, ret__1607660)
    }
    break
  }
};
cljs.core.name = function name(x) {
  if(cljs.core.truth_(cljs.core.string_QMARK_.call(null, x))) {
    return x
  }else {
    if(cljs.core.truth_(function() {
      var or__3548__auto____1607664 = cljs.core.keyword_QMARK_.call(null, x);
      if(cljs.core.truth_(or__3548__auto____1607664)) {
        return or__3548__auto____1607664
      }else {
        return cljs.core.symbol_QMARK_.call(null, x)
      }
    }())) {
      var i__1607665 = x.lastIndexOf("/");
      if(cljs.core.truth_(i__1607665 < 0)) {
        return cljs.core.subs.call(null, x, 2)
      }else {
        return cljs.core.subs.call(null, x, i__1607665 + 1)
      }
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        throw new Error(cljs.core.str.call(null, "Doesn't support name: ", x));
      }else {
        return null
      }
    }
  }
};
cljs.core.namespace = function namespace(x) {
  if(cljs.core.truth_(function() {
    var or__3548__auto____1607666 = cljs.core.keyword_QMARK_.call(null, x);
    if(cljs.core.truth_(or__3548__auto____1607666)) {
      return or__3548__auto____1607666
    }else {
      return cljs.core.symbol_QMARK_.call(null, x)
    }
  }())) {
    var i__1607667 = x.lastIndexOf("/");
    if(cljs.core.truth_(i__1607667 > -1)) {
      return cljs.core.subs.call(null, x, 2, i__1607667)
    }else {
      return null
    }
  }else {
    throw new Error(cljs.core.str.call(null, "Doesn't support namespace: ", x));
  }
};
cljs.core.zipmap = function zipmap(keys, vals) {
  var map__1607670 = cljs.core.ObjMap.fromObject([], {});
  var ks__1607671 = cljs.core.seq.call(null, keys);
  var vs__1607672 = cljs.core.seq.call(null, vals);
  while(true) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1607673 = ks__1607671;
      if(cljs.core.truth_(and__3546__auto____1607673)) {
        return vs__1607672
      }else {
        return and__3546__auto____1607673
      }
    }())) {
      var G__1607674 = cljs.core.assoc.call(null, map__1607670, cljs.core.first.call(null, ks__1607671), cljs.core.first.call(null, vs__1607672));
      var G__1607675 = cljs.core.next.call(null, ks__1607671);
      var G__1607676 = cljs.core.next.call(null, vs__1607672);
      map__1607670 = G__1607674;
      ks__1607671 = G__1607675;
      vs__1607672 = G__1607676;
      continue
    }else {
      return map__1607670
    }
    break
  }
};
cljs.core.max_key = function() {
  var max_key = null;
  var max_key__1607679 = function(k, x) {
    return x
  };
  var max_key__1607680 = function(k, x, y) {
    if(cljs.core.truth_(k.call(null, x) > k.call(null, y))) {
      return x
    }else {
      return y
    }
  };
  var max_key__1607681 = function() {
    var G__1607683__delegate = function(k, x, y, more) {
      return cljs.core.reduce.call(null, function(p1__1607668_SHARP_, p2__1607669_SHARP_) {
        return max_key.call(null, k, p1__1607668_SHARP_, p2__1607669_SHARP_)
      }, max_key.call(null, k, x, y), more)
    };
    var G__1607683 = function(k, x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
      }
      return G__1607683__delegate.call(this, k, x, y, more)
    };
    G__1607683.cljs$lang$maxFixedArity = 3;
    G__1607683.cljs$lang$applyTo = function(arglist__1607684) {
      var k = cljs.core.first(arglist__1607684);
      var x = cljs.core.first(cljs.core.next(arglist__1607684));
      var y = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607684)));
      var more = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607684)));
      return G__1607683__delegate.call(this, k, x, y, more)
    };
    return G__1607683
  }();
  max_key = function(k, x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 2:
        return max_key__1607679.call(this, k, x);
      case 3:
        return max_key__1607680.call(this, k, x, y);
      default:
        return max_key__1607681.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  max_key.cljs$lang$maxFixedArity = 3;
  max_key.cljs$lang$applyTo = max_key__1607681.cljs$lang$applyTo;
  return max_key
}();
cljs.core.min_key = function() {
  var min_key = null;
  var min_key__1607685 = function(k, x) {
    return x
  };
  var min_key__1607686 = function(k, x, y) {
    if(cljs.core.truth_(k.call(null, x) < k.call(null, y))) {
      return x
    }else {
      return y
    }
  };
  var min_key__1607687 = function() {
    var G__1607689__delegate = function(k, x, y, more) {
      return cljs.core.reduce.call(null, function(p1__1607677_SHARP_, p2__1607678_SHARP_) {
        return min_key.call(null, k, p1__1607677_SHARP_, p2__1607678_SHARP_)
      }, min_key.call(null, k, x, y), more)
    };
    var G__1607689 = function(k, x, y, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
      }
      return G__1607689__delegate.call(this, k, x, y, more)
    };
    G__1607689.cljs$lang$maxFixedArity = 3;
    G__1607689.cljs$lang$applyTo = function(arglist__1607690) {
      var k = cljs.core.first(arglist__1607690);
      var x = cljs.core.first(cljs.core.next(arglist__1607690));
      var y = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607690)));
      var more = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607690)));
      return G__1607689__delegate.call(this, k, x, y, more)
    };
    return G__1607689
  }();
  min_key = function(k, x, y, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 2:
        return min_key__1607685.call(this, k, x);
      case 3:
        return min_key__1607686.call(this, k, x, y);
      default:
        return min_key__1607687.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  min_key.cljs$lang$maxFixedArity = 3;
  min_key.cljs$lang$applyTo = min_key__1607687.cljs$lang$applyTo;
  return min_key
}();
cljs.core.partition_all = function() {
  var partition_all = null;
  var partition_all__1607693 = function(n, coll) {
    return partition_all.call(null, n, n, coll)
  };
  var partition_all__1607694 = function(n, step, coll) {
    return new cljs.core.LazySeq(null, false, function() {
      var temp__3698__auto____1607691 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(temp__3698__auto____1607691)) {
        var s__1607692 = temp__3698__auto____1607691;
        return cljs.core.cons.call(null, cljs.core.take.call(null, n, s__1607692), partition_all.call(null, n, step, cljs.core.drop.call(null, step, s__1607692)))
      }else {
        return null
      }
    })
  };
  partition_all = function(n, step, coll) {
    switch(arguments.length) {
      case 2:
        return partition_all__1607693.call(this, n, step);
      case 3:
        return partition_all__1607694.call(this, n, step, coll)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return partition_all
}();
cljs.core.take_while = function take_while(pred, coll) {
  return new cljs.core.LazySeq(null, false, function() {
    var temp__3698__auto____1607696 = cljs.core.seq.call(null, coll);
    if(cljs.core.truth_(temp__3698__auto____1607696)) {
      var s__1607697 = temp__3698__auto____1607696;
      if(cljs.core.truth_(pred.call(null, cljs.core.first.call(null, s__1607697)))) {
        return cljs.core.cons.call(null, cljs.core.first.call(null, s__1607697), take_while.call(null, pred, cljs.core.rest.call(null, s__1607697)))
      }else {
        return null
      }
    }else {
      return null
    }
  })
};
cljs.core.Range = function(meta, start, end, step) {
  this.meta = meta;
  this.start = start;
  this.end = end;
  this.step = step
};
cljs.core.Range.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.Range")
};
cljs.core.Range.prototype.cljs$core$IHash$ = true;
cljs.core.Range.prototype.cljs$core$IHash$_hash = function(rng) {
  var this__1607698 = this;
  return cljs.core.hash_coll.call(null, rng)
};
cljs.core.Range.prototype.cljs$core$ISequential$ = true;
cljs.core.Range.prototype.cljs$core$ICollection$ = true;
cljs.core.Range.prototype.cljs$core$ICollection$_conj = function(rng, o) {
  var this__1607699 = this;
  return cljs.core.cons.call(null, o, rng)
};
cljs.core.Range.prototype.cljs$core$IReduce$ = true;
cljs.core.Range.prototype.cljs$core$IReduce$_reduce = function() {
  var G__1607715 = null;
  var G__1607715__1607716 = function(rng, f) {
    var this__1607700 = this;
    return cljs.core.ci_reduce.call(null, rng, f)
  };
  var G__1607715__1607717 = function(rng, f, s) {
    var this__1607701 = this;
    return cljs.core.ci_reduce.call(null, rng, f, s)
  };
  G__1607715 = function(rng, f, s) {
    switch(arguments.length) {
      case 2:
        return G__1607715__1607716.call(this, rng, f);
      case 3:
        return G__1607715__1607717.call(this, rng, f, s)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607715
}();
cljs.core.Range.prototype.cljs$core$ISeqable$ = true;
cljs.core.Range.prototype.cljs$core$ISeqable$_seq = function(rng) {
  var this__1607702 = this;
  var comp__1607703 = cljs.core.truth_(this__1607702.step > 0) ? cljs.core._LT_ : cljs.core._GT_;
  if(cljs.core.truth_(comp__1607703.call(null, this__1607702.start, this__1607702.end))) {
    return rng
  }else {
    return null
  }
};
cljs.core.Range.prototype.cljs$core$ICounted$ = true;
cljs.core.Range.prototype.cljs$core$ICounted$_count = function(rng) {
  var this__1607704 = this;
  if(cljs.core.truth_(cljs.core.not.call(null, cljs.core._seq.call(null, rng)))) {
    return 0
  }else {
    return Math["ceil"].call(null, (this__1607704.end - this__1607704.start) / this__1607704.step)
  }
};
cljs.core.Range.prototype.cljs$core$ISeq$ = true;
cljs.core.Range.prototype.cljs$core$ISeq$_first = function(rng) {
  var this__1607705 = this;
  return this__1607705.start
};
cljs.core.Range.prototype.cljs$core$ISeq$_rest = function(rng) {
  var this__1607706 = this;
  if(cljs.core.truth_(cljs.core._seq.call(null, rng))) {
    return new cljs.core.Range(this__1607706.meta, this__1607706.start + this__1607706.step, this__1607706.end, this__1607706.step)
  }else {
    return cljs.core.list.call(null)
  }
};
cljs.core.Range.prototype.cljs$core$IEquiv$ = true;
cljs.core.Range.prototype.cljs$core$IEquiv$_equiv = function(rng, other) {
  var this__1607707 = this;
  return cljs.core.equiv_sequential.call(null, rng, other)
};
cljs.core.Range.prototype.cljs$core$IWithMeta$ = true;
cljs.core.Range.prototype.cljs$core$IWithMeta$_with_meta = function(rng, meta) {
  var this__1607708 = this;
  return new cljs.core.Range(meta, this__1607708.start, this__1607708.end, this__1607708.step)
};
cljs.core.Range.prototype.cljs$core$IMeta$ = true;
cljs.core.Range.prototype.cljs$core$IMeta$_meta = function(rng) {
  var this__1607709 = this;
  return this__1607709.meta
};
cljs.core.Range.prototype.cljs$core$IIndexed$ = true;
cljs.core.Range.prototype.cljs$core$IIndexed$_nth = function() {
  var G__1607719 = null;
  var G__1607719__1607720 = function(rng, n) {
    var this__1607710 = this;
    if(cljs.core.truth_(n < cljs.core._count.call(null, rng))) {
      return this__1607710.start + n * this__1607710.step
    }else {
      if(cljs.core.truth_(function() {
        var and__3546__auto____1607711 = this__1607710.start > this__1607710.end;
        if(cljs.core.truth_(and__3546__auto____1607711)) {
          return cljs.core._EQ_.call(null, this__1607710.step, 0)
        }else {
          return and__3546__auto____1607711
        }
      }())) {
        return this__1607710.start
      }else {
        throw new Error("Index out of bounds");
      }
    }
  };
  var G__1607719__1607721 = function(rng, n, not_found) {
    var this__1607712 = this;
    if(cljs.core.truth_(n < cljs.core._count.call(null, rng))) {
      return this__1607712.start + n * this__1607712.step
    }else {
      if(cljs.core.truth_(function() {
        var and__3546__auto____1607713 = this__1607712.start > this__1607712.end;
        if(cljs.core.truth_(and__3546__auto____1607713)) {
          return cljs.core._EQ_.call(null, this__1607712.step, 0)
        }else {
          return and__3546__auto____1607713
        }
      }())) {
        return this__1607712.start
      }else {
        return not_found
      }
    }
  };
  G__1607719 = function(rng, n, not_found) {
    switch(arguments.length) {
      case 2:
        return G__1607719__1607720.call(this, rng, n);
      case 3:
        return G__1607719__1607721.call(this, rng, n, not_found)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1607719
}();
cljs.core.Range.prototype.cljs$core$IEmptyableCollection$ = true;
cljs.core.Range.prototype.cljs$core$IEmptyableCollection$_empty = function(rng) {
  var this__1607714 = this;
  return cljs.core.with_meta.call(null, cljs.core.List.EMPTY, this__1607714.meta)
};
cljs.core.Range;
cljs.core.range = function() {
  var range = null;
  var range__1607723 = function() {
    return range.call(null, 0, Number["MAX_VALUE"], 1)
  };
  var range__1607724 = function(end) {
    return range.call(null, 0, end, 1)
  };
  var range__1607725 = function(start, end) {
    return range.call(null, start, end, 1)
  };
  var range__1607726 = function(start, end, step) {
    return new cljs.core.Range(null, start, end, step)
  };
  range = function(start, end, step) {
    switch(arguments.length) {
      case 0:
        return range__1607723.call(this);
      case 1:
        return range__1607724.call(this, start);
      case 2:
        return range__1607725.call(this, start, end);
      case 3:
        return range__1607726.call(this, start, end, step)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return range
}();
cljs.core.take_nth = function take_nth(n, coll) {
  return new cljs.core.LazySeq(null, false, function() {
    var temp__3698__auto____1607728 = cljs.core.seq.call(null, coll);
    if(cljs.core.truth_(temp__3698__auto____1607728)) {
      var s__1607729 = temp__3698__auto____1607728;
      return cljs.core.cons.call(null, cljs.core.first.call(null, s__1607729), take_nth.call(null, n, cljs.core.drop.call(null, n, s__1607729)))
    }else {
      return null
    }
  })
};
cljs.core.split_with = function split_with(pred, coll) {
  return cljs.core.PersistentVector.fromArray([cljs.core.take_while.call(null, pred, coll), cljs.core.drop_while.call(null, pred, coll)])
};
cljs.core.partition_by = function partition_by(f, coll) {
  return new cljs.core.LazySeq(null, false, function() {
    var temp__3698__auto____1607731 = cljs.core.seq.call(null, coll);
    if(cljs.core.truth_(temp__3698__auto____1607731)) {
      var s__1607732 = temp__3698__auto____1607731;
      var fst__1607733 = cljs.core.first.call(null, s__1607732);
      var fv__1607734 = f.call(null, fst__1607733);
      var run__1607735 = cljs.core.cons.call(null, fst__1607733, cljs.core.take_while.call(null, function(p1__1607730_SHARP_) {
        return cljs.core._EQ_.call(null, fv__1607734, f.call(null, p1__1607730_SHARP_))
      }, cljs.core.next.call(null, s__1607732)));
      return cljs.core.cons.call(null, run__1607735, partition_by.call(null, f, cljs.core.seq.call(null, cljs.core.drop.call(null, cljs.core.count.call(null, run__1607735), s__1607732))))
    }else {
      return null
    }
  })
};
cljs.core.frequencies = function frequencies(coll) {
  return cljs.core.reduce.call(null, function(counts, x) {
    return cljs.core.assoc.call(null, counts, x, cljs.core.get.call(null, counts, x, 0) + 1)
  }, cljs.core.ObjMap.fromObject([], {}), coll)
};
cljs.core.reductions = function() {
  var reductions = null;
  var reductions__1607750 = function(f, coll) {
    return new cljs.core.LazySeq(null, false, function() {
      var temp__3695__auto____1607746 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(temp__3695__auto____1607746)) {
        var s__1607747 = temp__3695__auto____1607746;
        return reductions.call(null, f, cljs.core.first.call(null, s__1607747), cljs.core.rest.call(null, s__1607747))
      }else {
        return cljs.core.list.call(null, f.call(null))
      }
    })
  };
  var reductions__1607751 = function(f, init, coll) {
    return cljs.core.cons.call(null, init, new cljs.core.LazySeq(null, false, function() {
      var temp__3698__auto____1607748 = cljs.core.seq.call(null, coll);
      if(cljs.core.truth_(temp__3698__auto____1607748)) {
        var s__1607749 = temp__3698__auto____1607748;
        return reductions.call(null, f, f.call(null, init, cljs.core.first.call(null, s__1607749)), cljs.core.rest.call(null, s__1607749))
      }else {
        return null
      }
    }))
  };
  reductions = function(f, init, coll) {
    switch(arguments.length) {
      case 2:
        return reductions__1607750.call(this, f, init);
      case 3:
        return reductions__1607751.call(this, f, init, coll)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return reductions
}();
cljs.core.juxt = function() {
  var juxt = null;
  var juxt__1607754 = function(f) {
    return function() {
      var G__1607759 = null;
      var G__1607759__1607760 = function() {
        return cljs.core.vector.call(null, f.call(null))
      };
      var G__1607759__1607761 = function(x) {
        return cljs.core.vector.call(null, f.call(null, x))
      };
      var G__1607759__1607762 = function(x, y) {
        return cljs.core.vector.call(null, f.call(null, x, y))
      };
      var G__1607759__1607763 = function(x, y, z) {
        return cljs.core.vector.call(null, f.call(null, x, y, z))
      };
      var G__1607759__1607764 = function() {
        var G__1607766__delegate = function(x, y, z, args) {
          return cljs.core.vector.call(null, cljs.core.apply.call(null, f, x, y, z, args))
        };
        var G__1607766 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1607766__delegate.call(this, x, y, z, args)
        };
        G__1607766.cljs$lang$maxFixedArity = 3;
        G__1607766.cljs$lang$applyTo = function(arglist__1607767) {
          var x = cljs.core.first(arglist__1607767);
          var y = cljs.core.first(cljs.core.next(arglist__1607767));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607767)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607767)));
          return G__1607766__delegate.call(this, x, y, z, args)
        };
        return G__1607766
      }();
      G__1607759 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return G__1607759__1607760.call(this);
          case 1:
            return G__1607759__1607761.call(this, x);
          case 2:
            return G__1607759__1607762.call(this, x, y);
          case 3:
            return G__1607759__1607763.call(this, x, y, z);
          default:
            return G__1607759__1607764.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      G__1607759.cljs$lang$maxFixedArity = 3;
      G__1607759.cljs$lang$applyTo = G__1607759__1607764.cljs$lang$applyTo;
      return G__1607759
    }()
  };
  var juxt__1607755 = function(f, g) {
    return function() {
      var G__1607768 = null;
      var G__1607768__1607769 = function() {
        return cljs.core.vector.call(null, f.call(null), g.call(null))
      };
      var G__1607768__1607770 = function(x) {
        return cljs.core.vector.call(null, f.call(null, x), g.call(null, x))
      };
      var G__1607768__1607771 = function(x, y) {
        return cljs.core.vector.call(null, f.call(null, x, y), g.call(null, x, y))
      };
      var G__1607768__1607772 = function(x, y, z) {
        return cljs.core.vector.call(null, f.call(null, x, y, z), g.call(null, x, y, z))
      };
      var G__1607768__1607773 = function() {
        var G__1607775__delegate = function(x, y, z, args) {
          return cljs.core.vector.call(null, cljs.core.apply.call(null, f, x, y, z, args), cljs.core.apply.call(null, g, x, y, z, args))
        };
        var G__1607775 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1607775__delegate.call(this, x, y, z, args)
        };
        G__1607775.cljs$lang$maxFixedArity = 3;
        G__1607775.cljs$lang$applyTo = function(arglist__1607776) {
          var x = cljs.core.first(arglist__1607776);
          var y = cljs.core.first(cljs.core.next(arglist__1607776));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607776)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607776)));
          return G__1607775__delegate.call(this, x, y, z, args)
        };
        return G__1607775
      }();
      G__1607768 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return G__1607768__1607769.call(this);
          case 1:
            return G__1607768__1607770.call(this, x);
          case 2:
            return G__1607768__1607771.call(this, x, y);
          case 3:
            return G__1607768__1607772.call(this, x, y, z);
          default:
            return G__1607768__1607773.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      G__1607768.cljs$lang$maxFixedArity = 3;
      G__1607768.cljs$lang$applyTo = G__1607768__1607773.cljs$lang$applyTo;
      return G__1607768
    }()
  };
  var juxt__1607756 = function(f, g, h) {
    return function() {
      var G__1607777 = null;
      var G__1607777__1607778 = function() {
        return cljs.core.vector.call(null, f.call(null), g.call(null), h.call(null))
      };
      var G__1607777__1607779 = function(x) {
        return cljs.core.vector.call(null, f.call(null, x), g.call(null, x), h.call(null, x))
      };
      var G__1607777__1607780 = function(x, y) {
        return cljs.core.vector.call(null, f.call(null, x, y), g.call(null, x, y), h.call(null, x, y))
      };
      var G__1607777__1607781 = function(x, y, z) {
        return cljs.core.vector.call(null, f.call(null, x, y, z), g.call(null, x, y, z), h.call(null, x, y, z))
      };
      var G__1607777__1607782 = function() {
        var G__1607784__delegate = function(x, y, z, args) {
          return cljs.core.vector.call(null, cljs.core.apply.call(null, f, x, y, z, args), cljs.core.apply.call(null, g, x, y, z, args), cljs.core.apply.call(null, h, x, y, z, args))
        };
        var G__1607784 = function(x, y, z, var_args) {
          var args = null;
          if(goog.isDef(var_args)) {
            args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
          }
          return G__1607784__delegate.call(this, x, y, z, args)
        };
        G__1607784.cljs$lang$maxFixedArity = 3;
        G__1607784.cljs$lang$applyTo = function(arglist__1607785) {
          var x = cljs.core.first(arglist__1607785);
          var y = cljs.core.first(cljs.core.next(arglist__1607785));
          var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607785)));
          var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607785)));
          return G__1607784__delegate.call(this, x, y, z, args)
        };
        return G__1607784
      }();
      G__1607777 = function(x, y, z, var_args) {
        var args = var_args;
        switch(arguments.length) {
          case 0:
            return G__1607777__1607778.call(this);
          case 1:
            return G__1607777__1607779.call(this, x);
          case 2:
            return G__1607777__1607780.call(this, x, y);
          case 3:
            return G__1607777__1607781.call(this, x, y, z);
          default:
            return G__1607777__1607782.apply(this, arguments)
        }
        throw"Invalid arity: " + arguments.length;
      };
      G__1607777.cljs$lang$maxFixedArity = 3;
      G__1607777.cljs$lang$applyTo = G__1607777__1607782.cljs$lang$applyTo;
      return G__1607777
    }()
  };
  var juxt__1607757 = function() {
    var G__1607786__delegate = function(f, g, h, fs) {
      var fs__1607753 = cljs.core.list_STAR_.call(null, f, g, h, fs);
      return function() {
        var G__1607787 = null;
        var G__1607787__1607788 = function() {
          return cljs.core.reduce.call(null, function(p1__1607736_SHARP_, p2__1607737_SHARP_) {
            return cljs.core.conj.call(null, p1__1607736_SHARP_, p2__1607737_SHARP_.call(null))
          }, cljs.core.PersistentVector.fromArray([]), fs__1607753)
        };
        var G__1607787__1607789 = function(x) {
          return cljs.core.reduce.call(null, function(p1__1607738_SHARP_, p2__1607739_SHARP_) {
            return cljs.core.conj.call(null, p1__1607738_SHARP_, p2__1607739_SHARP_.call(null, x))
          }, cljs.core.PersistentVector.fromArray([]), fs__1607753)
        };
        var G__1607787__1607790 = function(x, y) {
          return cljs.core.reduce.call(null, function(p1__1607740_SHARP_, p2__1607741_SHARP_) {
            return cljs.core.conj.call(null, p1__1607740_SHARP_, p2__1607741_SHARP_.call(null, x, y))
          }, cljs.core.PersistentVector.fromArray([]), fs__1607753)
        };
        var G__1607787__1607791 = function(x, y, z) {
          return cljs.core.reduce.call(null, function(p1__1607742_SHARP_, p2__1607743_SHARP_) {
            return cljs.core.conj.call(null, p1__1607742_SHARP_, p2__1607743_SHARP_.call(null, x, y, z))
          }, cljs.core.PersistentVector.fromArray([]), fs__1607753)
        };
        var G__1607787__1607792 = function() {
          var G__1607794__delegate = function(x, y, z, args) {
            return cljs.core.reduce.call(null, function(p1__1607744_SHARP_, p2__1607745_SHARP_) {
              return cljs.core.conj.call(null, p1__1607744_SHARP_, cljs.core.apply.call(null, p2__1607745_SHARP_, x, y, z, args))
            }, cljs.core.PersistentVector.fromArray([]), fs__1607753)
          };
          var G__1607794 = function(x, y, z, var_args) {
            var args = null;
            if(goog.isDef(var_args)) {
              args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
            }
            return G__1607794__delegate.call(this, x, y, z, args)
          };
          G__1607794.cljs$lang$maxFixedArity = 3;
          G__1607794.cljs$lang$applyTo = function(arglist__1607795) {
            var x = cljs.core.first(arglist__1607795);
            var y = cljs.core.first(cljs.core.next(arglist__1607795));
            var z = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607795)));
            var args = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607795)));
            return G__1607794__delegate.call(this, x, y, z, args)
          };
          return G__1607794
        }();
        G__1607787 = function(x, y, z, var_args) {
          var args = var_args;
          switch(arguments.length) {
            case 0:
              return G__1607787__1607788.call(this);
            case 1:
              return G__1607787__1607789.call(this, x);
            case 2:
              return G__1607787__1607790.call(this, x, y);
            case 3:
              return G__1607787__1607791.call(this, x, y, z);
            default:
              return G__1607787__1607792.apply(this, arguments)
          }
          throw"Invalid arity: " + arguments.length;
        };
        G__1607787.cljs$lang$maxFixedArity = 3;
        G__1607787.cljs$lang$applyTo = G__1607787__1607792.cljs$lang$applyTo;
        return G__1607787
      }()
    };
    var G__1607786 = function(f, g, h, var_args) {
      var fs = null;
      if(goog.isDef(var_args)) {
        fs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3), 0)
      }
      return G__1607786__delegate.call(this, f, g, h, fs)
    };
    G__1607786.cljs$lang$maxFixedArity = 3;
    G__1607786.cljs$lang$applyTo = function(arglist__1607796) {
      var f = cljs.core.first(arglist__1607796);
      var g = cljs.core.first(cljs.core.next(arglist__1607796));
      var h = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607796)));
      var fs = cljs.core.rest(cljs.core.next(cljs.core.next(arglist__1607796)));
      return G__1607786__delegate.call(this, f, g, h, fs)
    };
    return G__1607786
  }();
  juxt = function(f, g, h, var_args) {
    var fs = var_args;
    switch(arguments.length) {
      case 1:
        return juxt__1607754.call(this, f);
      case 2:
        return juxt__1607755.call(this, f, g);
      case 3:
        return juxt__1607756.call(this, f, g, h);
      default:
        return juxt__1607757.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  juxt.cljs$lang$maxFixedArity = 3;
  juxt.cljs$lang$applyTo = juxt__1607757.cljs$lang$applyTo;
  return juxt
}();
cljs.core.dorun = function() {
  var dorun = null;
  var dorun__1607798 = function(coll) {
    while(true) {
      if(cljs.core.truth_(cljs.core.seq.call(null, coll))) {
        var G__1607801 = cljs.core.next.call(null, coll);
        coll = G__1607801;
        continue
      }else {
        return null
      }
      break
    }
  };
  var dorun__1607799 = function(n, coll) {
    while(true) {
      if(cljs.core.truth_(function() {
        var and__3546__auto____1607797 = cljs.core.seq.call(null, coll);
        if(cljs.core.truth_(and__3546__auto____1607797)) {
          return n > 0
        }else {
          return and__3546__auto____1607797
        }
      }())) {
        var G__1607802 = n - 1;
        var G__1607803 = cljs.core.next.call(null, coll);
        n = G__1607802;
        coll = G__1607803;
        continue
      }else {
        return null
      }
      break
    }
  };
  dorun = function(n, coll) {
    switch(arguments.length) {
      case 1:
        return dorun__1607798.call(this, n);
      case 2:
        return dorun__1607799.call(this, n, coll)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return dorun
}();
cljs.core.doall = function() {
  var doall = null;
  var doall__1607804 = function(coll) {
    cljs.core.dorun.call(null, coll);
    return coll
  };
  var doall__1607805 = function(n, coll) {
    cljs.core.dorun.call(null, n, coll);
    return coll
  };
  doall = function(n, coll) {
    switch(arguments.length) {
      case 1:
        return doall__1607804.call(this, n);
      case 2:
        return doall__1607805.call(this, n, coll)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return doall
}();
cljs.core.re_matches = function re_matches(re, s) {
  var matches__1607807 = re.exec(s);
  if(cljs.core.truth_(cljs.core._EQ_.call(null, cljs.core.first.call(null, matches__1607807), s))) {
    if(cljs.core.truth_(cljs.core._EQ_.call(null, cljs.core.count.call(null, matches__1607807), 1))) {
      return cljs.core.first.call(null, matches__1607807)
    }else {
      return cljs.core.vec.call(null, matches__1607807)
    }
  }else {
    return null
  }
};
cljs.core.re_find = function re_find(re, s) {
  var matches__1607808 = re.exec(s);
  if(cljs.core.truth_(matches__1607808 === null)) {
    return null
  }else {
    if(cljs.core.truth_(cljs.core._EQ_.call(null, cljs.core.count.call(null, matches__1607808), 1))) {
      return cljs.core.first.call(null, matches__1607808)
    }else {
      return cljs.core.vec.call(null, matches__1607808)
    }
  }
};
cljs.core.re_seq = function re_seq(re, s) {
  var match_data__1607809 = cljs.core.re_find.call(null, re, s);
  var match_idx__1607810 = s.search(re);
  var match_str__1607811 = cljs.core.truth_(cljs.core.coll_QMARK_.call(null, match_data__1607809)) ? cljs.core.first.call(null, match_data__1607809) : match_data__1607809;
  var post_match__1607812 = cljs.core.subs.call(null, s, match_idx__1607810 + cljs.core.count.call(null, match_str__1607811));
  if(cljs.core.truth_(match_data__1607809)) {
    return new cljs.core.LazySeq(null, false, function() {
      return cljs.core.cons.call(null, match_data__1607809, re_seq.call(null, re, post_match__1607812))
    })
  }else {
    return null
  }
};
cljs.core.re_pattern = function re_pattern(s) {
  var vec__1607814__1607815 = cljs.core.re_find.call(null, /^(?:\(\?([idmsux]*)\))?(.*)/, s);
  var ___1607816 = cljs.core.nth.call(null, vec__1607814__1607815, 0, null);
  var flags__1607817 = cljs.core.nth.call(null, vec__1607814__1607815, 1, null);
  var pattern__1607818 = cljs.core.nth.call(null, vec__1607814__1607815, 2, null);
  return new RegExp(pattern__1607818, flags__1607817)
};
cljs.core.pr_sequential = function pr_sequential(print_one, begin, sep, end, opts, coll) {
  return cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([begin]), cljs.core.flatten1.call(null, cljs.core.interpose.call(null, cljs.core.PersistentVector.fromArray([sep]), cljs.core.map.call(null, function(p1__1607813_SHARP_) {
    return print_one.call(null, p1__1607813_SHARP_, opts)
  }, coll))), cljs.core.PersistentVector.fromArray([end]))
};
cljs.core.string_print = function string_print(x) {
  cljs.core._STAR_print_fn_STAR_.call(null, x);
  return null
};
cljs.core.flush = function flush() {
  return null
};
cljs.core.pr_seq = function pr_seq(obj, opts) {
  if(cljs.core.truth_(obj === null)) {
    return cljs.core.list.call(null, "nil")
  }else {
    if(cljs.core.truth_(void 0 === obj)) {
      return cljs.core.list.call(null, "#<undefined>")
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        return cljs.core.concat.call(null, cljs.core.truth_(function() {
          var and__3546__auto____1607819 = cljs.core.get.call(null, opts, "\ufdd0'meta");
          if(cljs.core.truth_(and__3546__auto____1607819)) {
            var and__3546__auto____1607823 = function() {
              var x__451__auto____1607820 = obj;
              if(cljs.core.truth_(function() {
                var and__3546__auto____1607821 = x__451__auto____1607820;
                if(cljs.core.truth_(and__3546__auto____1607821)) {
                  var and__3546__auto____1607822 = x__451__auto____1607820.cljs$core$IMeta$;
                  if(cljs.core.truth_(and__3546__auto____1607822)) {
                    return cljs.core.not.call(null, x__451__auto____1607820.hasOwnProperty("cljs$core$IMeta$"))
                  }else {
                    return and__3546__auto____1607822
                  }
                }else {
                  return and__3546__auto____1607821
                }
              }())) {
                return true
              }else {
                return cljs.core.type_satisfies_.call(null, cljs.core.IMeta, x__451__auto____1607820)
              }
            }();
            if(cljs.core.truth_(and__3546__auto____1607823)) {
              return cljs.core.meta.call(null, obj)
            }else {
              return and__3546__auto____1607823
            }
          }else {
            return and__3546__auto____1607819
          }
        }()) ? cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray(["^"]), pr_seq.call(null, cljs.core.meta.call(null, obj), opts), cljs.core.PersistentVector.fromArray([" "])) : null, cljs.core.truth_(function() {
          var x__451__auto____1607824 = obj;
          if(cljs.core.truth_(function() {
            var and__3546__auto____1607825 = x__451__auto____1607824;
            if(cljs.core.truth_(and__3546__auto____1607825)) {
              var and__3546__auto____1607826 = x__451__auto____1607824.cljs$core$IPrintable$;
              if(cljs.core.truth_(and__3546__auto____1607826)) {
                return cljs.core.not.call(null, x__451__auto____1607824.hasOwnProperty("cljs$core$IPrintable$"))
              }else {
                return and__3546__auto____1607826
              }
            }else {
              return and__3546__auto____1607825
            }
          }())) {
            return true
          }else {
            return cljs.core.type_satisfies_.call(null, cljs.core.IPrintable, x__451__auto____1607824)
          }
        }()) ? cljs.core._pr_seq.call(null, obj, opts) : cljs.core.list.call(null, "#<", cljs.core.str.call(null, obj), ">"))
      }else {
        return null
      }
    }
  }
};
cljs.core.pr_sb = function pr_sb(objs, opts) {
  var first_obj__1607827 = cljs.core.first.call(null, objs);
  var sb__1607828 = new goog.string.StringBuffer;
  var G__1607829__1607830 = cljs.core.seq.call(null, objs);
  if(cljs.core.truth_(G__1607829__1607830)) {
    var obj__1607831 = cljs.core.first.call(null, G__1607829__1607830);
    var G__1607829__1607832 = G__1607829__1607830;
    while(true) {
      if(cljs.core.truth_(obj__1607831 === first_obj__1607827)) {
      }else {
        sb__1607828.append(" ")
      }
      var G__1607833__1607834 = cljs.core.seq.call(null, cljs.core.pr_seq.call(null, obj__1607831, opts));
      if(cljs.core.truth_(G__1607833__1607834)) {
        var string__1607835 = cljs.core.first.call(null, G__1607833__1607834);
        var G__1607833__1607836 = G__1607833__1607834;
        while(true) {
          sb__1607828.append(string__1607835);
          var temp__3698__auto____1607837 = cljs.core.next.call(null, G__1607833__1607836);
          if(cljs.core.truth_(temp__3698__auto____1607837)) {
            var G__1607833__1607838 = temp__3698__auto____1607837;
            var G__1607841 = cljs.core.first.call(null, G__1607833__1607838);
            var G__1607842 = G__1607833__1607838;
            string__1607835 = G__1607841;
            G__1607833__1607836 = G__1607842;
            continue
          }else {
          }
          break
        }
      }else {
      }
      var temp__3698__auto____1607839 = cljs.core.next.call(null, G__1607829__1607832);
      if(cljs.core.truth_(temp__3698__auto____1607839)) {
        var G__1607829__1607840 = temp__3698__auto____1607839;
        var G__1607843 = cljs.core.first.call(null, G__1607829__1607840);
        var G__1607844 = G__1607829__1607840;
        obj__1607831 = G__1607843;
        G__1607829__1607832 = G__1607844;
        continue
      }else {
      }
      break
    }
  }else {
  }
  return sb__1607828
};
cljs.core.pr_str_with_opts = function pr_str_with_opts(objs, opts) {
  return cljs.core.str.call(null, cljs.core.pr_sb.call(null, objs, opts))
};
cljs.core.prn_str_with_opts = function prn_str_with_opts(objs, opts) {
  var sb__1607845 = cljs.core.pr_sb.call(null, objs, opts);
  sb__1607845.append("\n");
  return cljs.core.str.call(null, sb__1607845)
};
cljs.core.pr_with_opts = function pr_with_opts(objs, opts) {
  var first_obj__1607846 = cljs.core.first.call(null, objs);
  var G__1607847__1607848 = cljs.core.seq.call(null, objs);
  if(cljs.core.truth_(G__1607847__1607848)) {
    var obj__1607849 = cljs.core.first.call(null, G__1607847__1607848);
    var G__1607847__1607850 = G__1607847__1607848;
    while(true) {
      if(cljs.core.truth_(obj__1607849 === first_obj__1607846)) {
      }else {
        cljs.core.string_print.call(null, " ")
      }
      var G__1607851__1607852 = cljs.core.seq.call(null, cljs.core.pr_seq.call(null, obj__1607849, opts));
      if(cljs.core.truth_(G__1607851__1607852)) {
        var string__1607853 = cljs.core.first.call(null, G__1607851__1607852);
        var G__1607851__1607854 = G__1607851__1607852;
        while(true) {
          cljs.core.string_print.call(null, string__1607853);
          var temp__3698__auto____1607855 = cljs.core.next.call(null, G__1607851__1607854);
          if(cljs.core.truth_(temp__3698__auto____1607855)) {
            var G__1607851__1607856 = temp__3698__auto____1607855;
            var G__1607859 = cljs.core.first.call(null, G__1607851__1607856);
            var G__1607860 = G__1607851__1607856;
            string__1607853 = G__1607859;
            G__1607851__1607854 = G__1607860;
            continue
          }else {
          }
          break
        }
      }else {
      }
      var temp__3698__auto____1607857 = cljs.core.next.call(null, G__1607847__1607850);
      if(cljs.core.truth_(temp__3698__auto____1607857)) {
        var G__1607847__1607858 = temp__3698__auto____1607857;
        var G__1607861 = cljs.core.first.call(null, G__1607847__1607858);
        var G__1607862 = G__1607847__1607858;
        obj__1607849 = G__1607861;
        G__1607847__1607850 = G__1607862;
        continue
      }else {
        return null
      }
      break
    }
  }else {
    return null
  }
};
cljs.core.newline = function newline(opts) {
  cljs.core.string_print.call(null, "\n");
  if(cljs.core.truth_(cljs.core.get.call(null, opts, "\ufdd0'flush-on-newline"))) {
    return cljs.core.flush.call(null)
  }else {
    return null
  }
};
cljs.core._STAR_flush_on_newline_STAR_ = true;
cljs.core._STAR_print_readably_STAR_ = true;
cljs.core._STAR_print_meta_STAR_ = false;
cljs.core._STAR_print_dup_STAR_ = false;
cljs.core.pr_opts = function pr_opts() {
  return cljs.core.ObjMap.fromObject(["\ufdd0'flush-on-newline", "\ufdd0'readably", "\ufdd0'meta", "\ufdd0'dup"], {"\ufdd0'flush-on-newline":cljs.core._STAR_flush_on_newline_STAR_, "\ufdd0'readably":cljs.core._STAR_print_readably_STAR_, "\ufdd0'meta":cljs.core._STAR_print_meta_STAR_, "\ufdd0'dup":cljs.core._STAR_print_dup_STAR_})
};
cljs.core.pr_str = function() {
  var pr_str__delegate = function(objs) {
    return cljs.core.pr_str_with_opts.call(null, objs, cljs.core.pr_opts.call(null))
  };
  var pr_str = function(var_args) {
    var objs = null;
    if(goog.isDef(var_args)) {
      objs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return pr_str__delegate.call(this, objs)
  };
  pr_str.cljs$lang$maxFixedArity = 0;
  pr_str.cljs$lang$applyTo = function(arglist__1607863) {
    var objs = cljs.core.seq(arglist__1607863);
    return pr_str__delegate.call(this, objs)
  };
  return pr_str
}();
cljs.core.prn_str = function() {
  var prn_str__delegate = function(objs) {
    return cljs.core.prn_str_with_opts.call(null, objs, cljs.core.pr_opts.call(null))
  };
  var prn_str = function(var_args) {
    var objs = null;
    if(goog.isDef(var_args)) {
      objs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return prn_str__delegate.call(this, objs)
  };
  prn_str.cljs$lang$maxFixedArity = 0;
  prn_str.cljs$lang$applyTo = function(arglist__1607864) {
    var objs = cljs.core.seq(arglist__1607864);
    return prn_str__delegate.call(this, objs)
  };
  return prn_str
}();
cljs.core.pr = function() {
  var pr__delegate = function(objs) {
    return cljs.core.pr_with_opts.call(null, objs, cljs.core.pr_opts.call(null))
  };
  var pr = function(var_args) {
    var objs = null;
    if(goog.isDef(var_args)) {
      objs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return pr__delegate.call(this, objs)
  };
  pr.cljs$lang$maxFixedArity = 0;
  pr.cljs$lang$applyTo = function(arglist__1607865) {
    var objs = cljs.core.seq(arglist__1607865);
    return pr__delegate.call(this, objs)
  };
  return pr
}();
cljs.core.print = function() {
  var cljs_core_print__delegate = function(objs) {
    return cljs.core.pr_with_opts.call(null, objs, cljs.core.assoc.call(null, cljs.core.pr_opts.call(null), "\ufdd0'readably", false))
  };
  var cljs_core_print = function(var_args) {
    var objs = null;
    if(goog.isDef(var_args)) {
      objs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return cljs_core_print__delegate.call(this, objs)
  };
  cljs_core_print.cljs$lang$maxFixedArity = 0;
  cljs_core_print.cljs$lang$applyTo = function(arglist__1607866) {
    var objs = cljs.core.seq(arglist__1607866);
    return cljs_core_print__delegate.call(this, objs)
  };
  return cljs_core_print
}();
cljs.core.print_str = function() {
  var print_str__delegate = function(objs) {
    return cljs.core.pr_str_with_opts.call(null, objs, cljs.core.assoc.call(null, cljs.core.pr_opts.call(null), "\ufdd0'readably", false))
  };
  var print_str = function(var_args) {
    var objs = null;
    if(goog.isDef(var_args)) {
      objs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return print_str__delegate.call(this, objs)
  };
  print_str.cljs$lang$maxFixedArity = 0;
  print_str.cljs$lang$applyTo = function(arglist__1607867) {
    var objs = cljs.core.seq(arglist__1607867);
    return print_str__delegate.call(this, objs)
  };
  return print_str
}();
cljs.core.println = function() {
  var println__delegate = function(objs) {
    cljs.core.pr_with_opts.call(null, objs, cljs.core.assoc.call(null, cljs.core.pr_opts.call(null), "\ufdd0'readably", false));
    return cljs.core.newline.call(null, cljs.core.pr_opts.call(null))
  };
  var println = function(var_args) {
    var objs = null;
    if(goog.isDef(var_args)) {
      objs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return println__delegate.call(this, objs)
  };
  println.cljs$lang$maxFixedArity = 0;
  println.cljs$lang$applyTo = function(arglist__1607868) {
    var objs = cljs.core.seq(arglist__1607868);
    return println__delegate.call(this, objs)
  };
  return println
}();
cljs.core.println_str = function() {
  var println_str__delegate = function(objs) {
    return cljs.core.prn_str_with_opts.call(null, objs, cljs.core.assoc.call(null, cljs.core.pr_opts.call(null), "\ufdd0'readably", false))
  };
  var println_str = function(var_args) {
    var objs = null;
    if(goog.isDef(var_args)) {
      objs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return println_str__delegate.call(this, objs)
  };
  println_str.cljs$lang$maxFixedArity = 0;
  println_str.cljs$lang$applyTo = function(arglist__1607869) {
    var objs = cljs.core.seq(arglist__1607869);
    return println_str__delegate.call(this, objs)
  };
  return println_str
}();
cljs.core.prn = function() {
  var prn__delegate = function(objs) {
    cljs.core.pr_with_opts.call(null, objs, cljs.core.pr_opts.call(null));
    return cljs.core.newline.call(null, cljs.core.pr_opts.call(null))
  };
  var prn = function(var_args) {
    var objs = null;
    if(goog.isDef(var_args)) {
      objs = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
    }
    return prn__delegate.call(this, objs)
  };
  prn.cljs$lang$maxFixedArity = 0;
  prn.cljs$lang$applyTo = function(arglist__1607870) {
    var objs = cljs.core.seq(arglist__1607870);
    return prn__delegate.call(this, objs)
  };
  return prn
}();
cljs.core.HashMap.prototype.cljs$core$IPrintable$ = true;
cljs.core.HashMap.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  var pr_pair__1607871 = function(keyval) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts, keyval)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__1607871, "{", ", ", "}", opts, coll)
};
cljs.core.IPrintable["number"] = true;
cljs.core._pr_seq["number"] = function(n, opts) {
  return cljs.core.list.call(null, cljs.core.str.call(null, n))
};
cljs.core.IndexedSeq.prototype.cljs$core$IPrintable$ = true;
cljs.core.IndexedSeq.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "(", " ", ")", opts, coll)
};
cljs.core.Subvec.prototype.cljs$core$IPrintable$ = true;
cljs.core.Subvec.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "[", " ", "]", opts, coll)
};
cljs.core.LazySeq.prototype.cljs$core$IPrintable$ = true;
cljs.core.LazySeq.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "(", " ", ")", opts, coll)
};
cljs.core.IPrintable["boolean"] = true;
cljs.core._pr_seq["boolean"] = function(bool, opts) {
  return cljs.core.list.call(null, cljs.core.str.call(null, bool))
};
cljs.core.Set.prototype.cljs$core$IPrintable$ = true;
cljs.core.Set.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "#{", " ", "}", opts, coll)
};
cljs.core.IPrintable["string"] = true;
cljs.core._pr_seq["string"] = function(obj, opts) {
  if(cljs.core.truth_(cljs.core.keyword_QMARK_.call(null, obj))) {
    return cljs.core.list.call(null, cljs.core.str.call(null, ":", function() {
      var temp__3698__auto____1607872 = cljs.core.namespace.call(null, obj);
      if(cljs.core.truth_(temp__3698__auto____1607872)) {
        var nspc__1607873 = temp__3698__auto____1607872;
        return cljs.core.str.call(null, nspc__1607873, "/")
      }else {
        return null
      }
    }(), cljs.core.name.call(null, obj)))
  }else {
    if(cljs.core.truth_(cljs.core.symbol_QMARK_.call(null, obj))) {
      return cljs.core.list.call(null, cljs.core.str.call(null, function() {
        var temp__3698__auto____1607874 = cljs.core.namespace.call(null, obj);
        if(cljs.core.truth_(temp__3698__auto____1607874)) {
          var nspc__1607875 = temp__3698__auto____1607874;
          return cljs.core.str.call(null, nspc__1607875, "/")
        }else {
          return null
        }
      }(), cljs.core.name.call(null, obj)))
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        return cljs.core.list.call(null, cljs.core.truth_("\ufdd0'readably".call(null, opts)) ? goog.string.quote.call(null, obj) : obj)
      }else {
        return null
      }
    }
  }
};
cljs.core.Vector.prototype.cljs$core$IPrintable$ = true;
cljs.core.Vector.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "[", " ", "]", opts, coll)
};
cljs.core.PersistentVector.prototype.cljs$core$IPrintable$ = true;
cljs.core.PersistentVector.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "[", " ", "]", opts, coll)
};
cljs.core.List.prototype.cljs$core$IPrintable$ = true;
cljs.core.List.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "(", " ", ")", opts, coll)
};
cljs.core.IPrintable["array"] = true;
cljs.core._pr_seq["array"] = function(a, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "#<Array [", ", ", "]>", opts, a)
};
cljs.core.PersistentQueueSeq.prototype.cljs$core$IPrintable$ = true;
cljs.core.PersistentQueueSeq.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "(", " ", ")", opts, coll)
};
cljs.core.IPrintable["function"] = true;
cljs.core._pr_seq["function"] = function(this$) {
  return cljs.core.list.call(null, "#<", cljs.core.str.call(null, this$), ">")
};
cljs.core.EmptyList.prototype.cljs$core$IPrintable$ = true;
cljs.core.EmptyList.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.list.call(null, "()")
};
cljs.core.Cons.prototype.cljs$core$IPrintable$ = true;
cljs.core.Cons.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "(", " ", ")", opts, coll)
};
cljs.core.Range.prototype.cljs$core$IPrintable$ = true;
cljs.core.Range.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "(", " ", ")", opts, coll)
};
cljs.core.ObjMap.prototype.cljs$core$IPrintable$ = true;
cljs.core.ObjMap.prototype.cljs$core$IPrintable$_pr_seq = function(coll, opts) {
  var pr_pair__1607876 = function(keyval) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts, keyval)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__1607876, "{", ", ", "}", opts, coll)
};
cljs.core.Atom = function(state, meta, validator, watches) {
  this.state = state;
  this.meta = meta;
  this.validator = validator;
  this.watches = watches
};
cljs.core.Atom.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.Atom")
};
cljs.core.Atom.prototype.cljs$core$IHash$ = true;
cljs.core.Atom.prototype.cljs$core$IHash$_hash = function(this$) {
  var this__1607877 = this;
  return goog.getUid.call(null, this$)
};
cljs.core.Atom.prototype.cljs$core$IWatchable$ = true;
cljs.core.Atom.prototype.cljs$core$IWatchable$_notify_watches = function(this$, oldval, newval) {
  var this__1607878 = this;
  var G__1607879__1607880 = cljs.core.seq.call(null, this__1607878.watches);
  if(cljs.core.truth_(G__1607879__1607880)) {
    var G__1607882__1607884 = cljs.core.first.call(null, G__1607879__1607880);
    var vec__1607883__1607885 = G__1607882__1607884;
    var key__1607886 = cljs.core.nth.call(null, vec__1607883__1607885, 0, null);
    var f__1607887 = cljs.core.nth.call(null, vec__1607883__1607885, 1, null);
    var G__1607879__1607888 = G__1607879__1607880;
    var G__1607882__1607889 = G__1607882__1607884;
    var G__1607879__1607890 = G__1607879__1607888;
    while(true) {
      var vec__1607891__1607892 = G__1607882__1607889;
      var key__1607893 = cljs.core.nth.call(null, vec__1607891__1607892, 0, null);
      var f__1607894 = cljs.core.nth.call(null, vec__1607891__1607892, 1, null);
      var G__1607879__1607895 = G__1607879__1607890;
      f__1607894.call(null, key__1607893, this$, oldval, newval);
      var temp__3698__auto____1607896 = cljs.core.next.call(null, G__1607879__1607895);
      if(cljs.core.truth_(temp__3698__auto____1607896)) {
        var G__1607879__1607897 = temp__3698__auto____1607896;
        var G__1607904 = cljs.core.first.call(null, G__1607879__1607897);
        var G__1607905 = G__1607879__1607897;
        G__1607882__1607889 = G__1607904;
        G__1607879__1607890 = G__1607905;
        continue
      }else {
        return null
      }
      break
    }
  }else {
    return null
  }
};
cljs.core.Atom.prototype.cljs$core$IWatchable$_add_watch = function(this$, key, f) {
  var this__1607898 = this;
  return this$.watches = cljs.core.assoc.call(null, this__1607898.watches, key, f)
};
cljs.core.Atom.prototype.cljs$core$IWatchable$_remove_watch = function(this$, key) {
  var this__1607899 = this;
  return this$.watches = cljs.core.dissoc.call(null, this__1607899.watches, key)
};
cljs.core.Atom.prototype.cljs$core$IPrintable$ = true;
cljs.core.Atom.prototype.cljs$core$IPrintable$_pr_seq = function(a, opts) {
  var this__1607900 = this;
  return cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray(["#<Atom: "]), cljs.core._pr_seq.call(null, this__1607900.state, opts), ">")
};
cljs.core.Atom.prototype.cljs$core$IMeta$ = true;
cljs.core.Atom.prototype.cljs$core$IMeta$_meta = function(_) {
  var this__1607901 = this;
  return this__1607901.meta
};
cljs.core.Atom.prototype.cljs$core$IDeref$ = true;
cljs.core.Atom.prototype.cljs$core$IDeref$_deref = function(_) {
  var this__1607902 = this;
  return this__1607902.state
};
cljs.core.Atom.prototype.cljs$core$IEquiv$ = true;
cljs.core.Atom.prototype.cljs$core$IEquiv$_equiv = function(o, other) {
  var this__1607903 = this;
  return o === other
};
cljs.core.Atom;
cljs.core.atom = function() {
  var atom = null;
  var atom__1607912 = function(x) {
    return new cljs.core.Atom(x, null, null, null)
  };
  var atom__1607913 = function() {
    var G__1607915__delegate = function(x, p__1607906) {
      var map__1607907__1607908 = p__1607906;
      var map__1607907__1607909 = cljs.core.truth_(cljs.core.seq_QMARK_.call(null, map__1607907__1607908)) ? cljs.core.apply.call(null, cljs.core.hash_map, map__1607907__1607908) : map__1607907__1607908;
      var validator__1607910 = cljs.core.get.call(null, map__1607907__1607909, "\ufdd0'validator");
      var meta__1607911 = cljs.core.get.call(null, map__1607907__1607909, "\ufdd0'meta");
      return new cljs.core.Atom(x, meta__1607911, validator__1607910, null)
    };
    var G__1607915 = function(x, var_args) {
      var p__1607906 = null;
      if(goog.isDef(var_args)) {
        p__1607906 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1), 0)
      }
      return G__1607915__delegate.call(this, x, p__1607906)
    };
    G__1607915.cljs$lang$maxFixedArity = 1;
    G__1607915.cljs$lang$applyTo = function(arglist__1607916) {
      var x = cljs.core.first(arglist__1607916);
      var p__1607906 = cljs.core.rest(arglist__1607916);
      return G__1607915__delegate.call(this, x, p__1607906)
    };
    return G__1607915
  }();
  atom = function(x, var_args) {
    var p__1607906 = var_args;
    switch(arguments.length) {
      case 1:
        return atom__1607912.call(this, x);
      default:
        return atom__1607913.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  atom.cljs$lang$maxFixedArity = 1;
  atom.cljs$lang$applyTo = atom__1607913.cljs$lang$applyTo;
  return atom
}();
cljs.core.reset_BANG_ = function reset_BANG_(a, new_value) {
  var temp__3698__auto____1607917 = a.validator;
  if(cljs.core.truth_(temp__3698__auto____1607917)) {
    var validate__1607918 = temp__3698__auto____1607917;
    if(cljs.core.truth_(validate__1607918.call(null, new_value))) {
    }else {
      throw new Error(cljs.core.str.call(null, "Assert failed: ", "Validator rejected reference state", "\n", cljs.core.pr_str.call(null, cljs.core.with_meta(cljs.core.list("\ufdd1'validate", "\ufdd1'new-value"), cljs.core.hash_map("\ufdd0'line", 3282)))));
    }
  }else {
  }
  var old_value__1607919 = a.state;
  a.state = new_value;
  cljs.core._notify_watches.call(null, a, old_value__1607919, new_value);
  return new_value
};
cljs.core.swap_BANG_ = function() {
  var swap_BANG_ = null;
  var swap_BANG___1607920 = function(a, f) {
    return cljs.core.reset_BANG_.call(null, a, f.call(null, a.state))
  };
  var swap_BANG___1607921 = function(a, f, x) {
    return cljs.core.reset_BANG_.call(null, a, f.call(null, a.state, x))
  };
  var swap_BANG___1607922 = function(a, f, x, y) {
    return cljs.core.reset_BANG_.call(null, a, f.call(null, a.state, x, y))
  };
  var swap_BANG___1607923 = function(a, f, x, y, z) {
    return cljs.core.reset_BANG_.call(null, a, f.call(null, a.state, x, y, z))
  };
  var swap_BANG___1607924 = function() {
    var G__1607926__delegate = function(a, f, x, y, z, more) {
      return cljs.core.reset_BANG_.call(null, a, cljs.core.apply.call(null, f, a.state, x, y, z, more))
    };
    var G__1607926 = function(a, f, x, y, z, var_args) {
      var more = null;
      if(goog.isDef(var_args)) {
        more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 5), 0)
      }
      return G__1607926__delegate.call(this, a, f, x, y, z, more)
    };
    G__1607926.cljs$lang$maxFixedArity = 5;
    G__1607926.cljs$lang$applyTo = function(arglist__1607927) {
      var a = cljs.core.first(arglist__1607927);
      var f = cljs.core.first(cljs.core.next(arglist__1607927));
      var x = cljs.core.first(cljs.core.next(cljs.core.next(arglist__1607927)));
      var y = cljs.core.first(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1607927))));
      var z = cljs.core.first(cljs.core.next(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1607927)))));
      var more = cljs.core.rest(cljs.core.next(cljs.core.next(cljs.core.next(cljs.core.next(arglist__1607927)))));
      return G__1607926__delegate.call(this, a, f, x, y, z, more)
    };
    return G__1607926
  }();
  swap_BANG_ = function(a, f, x, y, z, var_args) {
    var more = var_args;
    switch(arguments.length) {
      case 2:
        return swap_BANG___1607920.call(this, a, f);
      case 3:
        return swap_BANG___1607921.call(this, a, f, x);
      case 4:
        return swap_BANG___1607922.call(this, a, f, x, y);
      case 5:
        return swap_BANG___1607923.call(this, a, f, x, y, z);
      default:
        return swap_BANG___1607924.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  swap_BANG_.cljs$lang$maxFixedArity = 5;
  swap_BANG_.cljs$lang$applyTo = swap_BANG___1607924.cljs$lang$applyTo;
  return swap_BANG_
}();
cljs.core.compare_and_set_BANG_ = function compare_and_set_BANG_(a, oldval, newval) {
  if(cljs.core.truth_(cljs.core._EQ_.call(null, a.state, oldval))) {
    cljs.core.reset_BANG_.call(null, a, newval);
    return true
  }else {
    return false
  }
};
cljs.core.deref = function deref(o) {
  return cljs.core._deref.call(null, o)
};
cljs.core.set_validator_BANG_ = function set_validator_BANG_(iref, val) {
  return iref.validator = val
};
cljs.core.get_validator = function get_validator(iref) {
  return iref.validator
};
cljs.core.alter_meta_BANG_ = function() {
  var alter_meta_BANG___delegate = function(iref, f, args) {
    return iref.meta = cljs.core.apply.call(null, f, iref.meta, args)
  };
  var alter_meta_BANG_ = function(iref, f, var_args) {
    var args = null;
    if(goog.isDef(var_args)) {
      args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
    }
    return alter_meta_BANG___delegate.call(this, iref, f, args)
  };
  alter_meta_BANG_.cljs$lang$maxFixedArity = 2;
  alter_meta_BANG_.cljs$lang$applyTo = function(arglist__1607928) {
    var iref = cljs.core.first(arglist__1607928);
    var f = cljs.core.first(cljs.core.next(arglist__1607928));
    var args = cljs.core.rest(cljs.core.next(arglist__1607928));
    return alter_meta_BANG___delegate.call(this, iref, f, args)
  };
  return alter_meta_BANG_
}();
cljs.core.reset_meta_BANG_ = function reset_meta_BANG_(iref, m) {
  return iref.meta = m
};
cljs.core.add_watch = function add_watch(iref, key, f) {
  return cljs.core._add_watch.call(null, iref, key, f)
};
cljs.core.remove_watch = function remove_watch(iref, key) {
  return cljs.core._remove_watch.call(null, iref, key)
};
cljs.core.gensym_counter = null;
cljs.core.gensym = function() {
  var gensym = null;
  var gensym__1607929 = function() {
    return gensym.call(null, "G__")
  };
  var gensym__1607930 = function(prefix_string) {
    if(cljs.core.truth_(cljs.core.gensym_counter === null)) {
      cljs.core.gensym_counter = cljs.core.atom.call(null, 0)
    }else {
    }
    return cljs.core.symbol.call(null, cljs.core.str.call(null, prefix_string, cljs.core.swap_BANG_.call(null, cljs.core.gensym_counter, cljs.core.inc)))
  };
  gensym = function(prefix_string) {
    switch(arguments.length) {
      case 0:
        return gensym__1607929.call(this);
      case 1:
        return gensym__1607930.call(this, prefix_string)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return gensym
}();
cljs.core.fixture1 = 1;
cljs.core.fixture2 = 2;
cljs.core.Delay = function(state, f) {
  this.state = state;
  this.f = f
};
cljs.core.Delay.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.Delay")
};
cljs.core.Delay.prototype.cljs$core$IPending$ = true;
cljs.core.Delay.prototype.cljs$core$IPending$_realized_QMARK_ = function(d) {
  var this__1607932 = this;
  return"\ufdd0'done".call(null, cljs.core.deref.call(null, this__1607932.state))
};
cljs.core.Delay.prototype.cljs$core$IDeref$ = true;
cljs.core.Delay.prototype.cljs$core$IDeref$_deref = function(_) {
  var this__1607933 = this;
  return"\ufdd0'value".call(null, cljs.core.swap_BANG_.call(null, this__1607933.state, function(p__1607934) {
    var curr_state__1607935 = p__1607934;
    var curr_state__1607936 = cljs.core.truth_(cljs.core.seq_QMARK_.call(null, curr_state__1607935)) ? cljs.core.apply.call(null, cljs.core.hash_map, curr_state__1607935) : curr_state__1607935;
    var done__1607937 = cljs.core.get.call(null, curr_state__1607936, "\ufdd0'done");
    if(cljs.core.truth_(done__1607937)) {
      return curr_state__1607936
    }else {
      return cljs.core.ObjMap.fromObject(["\ufdd0'done", "\ufdd0'value"], {"\ufdd0'done":true, "\ufdd0'value":this__1607933.f.call(null)})
    }
  }))
};
cljs.core.Delay;
cljs.core.delay_QMARK_ = function delay_QMARK_(x) {
  return cljs.core.instance_QMARK_.call(null, cljs.core.Delay, x)
};
cljs.core.force = function force(x) {
  if(cljs.core.truth_(cljs.core.delay_QMARK_.call(null, x))) {
    return cljs.core.deref.call(null, x)
  }else {
    return x
  }
};
cljs.core.realized_QMARK_ = function realized_QMARK_(d) {
  return cljs.core._realized_QMARK_.call(null, d)
};
cljs.core.js__GT_clj = function() {
  var js__GT_clj__delegate = function(x, options) {
    var map__1607938__1607939 = options;
    var map__1607938__1607940 = cljs.core.truth_(cljs.core.seq_QMARK_.call(null, map__1607938__1607939)) ? cljs.core.apply.call(null, cljs.core.hash_map, map__1607938__1607939) : map__1607938__1607939;
    var keywordize_keys__1607941 = cljs.core.get.call(null, map__1607938__1607940, "\ufdd0'keywordize-keys");
    var keyfn__1607942 = cljs.core.truth_(keywordize_keys__1607941) ? cljs.core.keyword : cljs.core.str;
    var f__1607948 = function thisfn(x) {
      if(cljs.core.truth_(cljs.core.seq_QMARK_.call(null, x))) {
        return cljs.core.doall.call(null, cljs.core.map.call(null, thisfn, x))
      }else {
        if(cljs.core.truth_(cljs.core.coll_QMARK_.call(null, x))) {
          return cljs.core.into.call(null, cljs.core.empty.call(null, x), cljs.core.map.call(null, thisfn, x))
        }else {
          if(cljs.core.truth_(goog.isArray.call(null, x))) {
            return cljs.core.vec.call(null, cljs.core.map.call(null, thisfn, x))
          }else {
            if(cljs.core.truth_(goog.isObject.call(null, x))) {
              return cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), function() {
                var iter__520__auto____1607947 = function iter__1607943(s__1607944) {
                  return new cljs.core.LazySeq(null, false, function() {
                    var s__1607944__1607945 = s__1607944;
                    while(true) {
                      if(cljs.core.truth_(cljs.core.seq.call(null, s__1607944__1607945))) {
                        var k__1607946 = cljs.core.first.call(null, s__1607944__1607945);
                        return cljs.core.cons.call(null, cljs.core.PersistentVector.fromArray([keyfn__1607942.call(null, k__1607946), thisfn.call(null, x[k__1607946])]), iter__1607943.call(null, cljs.core.rest.call(null, s__1607944__1607945)))
                      }else {
                        return null
                      }
                      break
                    }
                  })
                };
                return iter__520__auto____1607947.call(null, cljs.core.js_keys.call(null, x))
              }())
            }else {
              if(cljs.core.truth_("\ufdd0'else")) {
                return x
              }else {
                return null
              }
            }
          }
        }
      }
    };
    return f__1607948.call(null, x)
  };
  var js__GT_clj = function(x, var_args) {
    var options = null;
    if(goog.isDef(var_args)) {
      options = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1), 0)
    }
    return js__GT_clj__delegate.call(this, x, options)
  };
  js__GT_clj.cljs$lang$maxFixedArity = 1;
  js__GT_clj.cljs$lang$applyTo = function(arglist__1607949) {
    var x = cljs.core.first(arglist__1607949);
    var options = cljs.core.rest(arglist__1607949);
    return js__GT_clj__delegate.call(this, x, options)
  };
  return js__GT_clj
}();
cljs.core.memoize = function memoize(f) {
  var mem__1607950 = cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {}));
  return function() {
    var G__1607954__delegate = function(args) {
      var temp__3695__auto____1607951 = cljs.core.get.call(null, cljs.core.deref.call(null, mem__1607950), args);
      if(cljs.core.truth_(temp__3695__auto____1607951)) {
        var v__1607952 = temp__3695__auto____1607951;
        return v__1607952
      }else {
        var ret__1607953 = cljs.core.apply.call(null, f, args);
        cljs.core.swap_BANG_.call(null, mem__1607950, cljs.core.assoc, args, ret__1607953);
        return ret__1607953
      }
    };
    var G__1607954 = function(var_args) {
      var args = null;
      if(goog.isDef(var_args)) {
        args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 0), 0)
      }
      return G__1607954__delegate.call(this, args)
    };
    G__1607954.cljs$lang$maxFixedArity = 0;
    G__1607954.cljs$lang$applyTo = function(arglist__1607955) {
      var args = cljs.core.seq(arglist__1607955);
      return G__1607954__delegate.call(this, args)
    };
    return G__1607954
  }()
};
cljs.core.trampoline = function() {
  var trampoline = null;
  var trampoline__1607957 = function(f) {
    while(true) {
      var ret__1607956 = f.call(null);
      if(cljs.core.truth_(cljs.core.fn_QMARK_.call(null, ret__1607956))) {
        var G__1607960 = ret__1607956;
        f = G__1607960;
        continue
      }else {
        return ret__1607956
      }
      break
    }
  };
  var trampoline__1607958 = function() {
    var G__1607961__delegate = function(f, args) {
      return trampoline.call(null, function() {
        return cljs.core.apply.call(null, f, args)
      })
    };
    var G__1607961 = function(f, var_args) {
      var args = null;
      if(goog.isDef(var_args)) {
        args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1), 0)
      }
      return G__1607961__delegate.call(this, f, args)
    };
    G__1607961.cljs$lang$maxFixedArity = 1;
    G__1607961.cljs$lang$applyTo = function(arglist__1607962) {
      var f = cljs.core.first(arglist__1607962);
      var args = cljs.core.rest(arglist__1607962);
      return G__1607961__delegate.call(this, f, args)
    };
    return G__1607961
  }();
  trampoline = function(f, var_args) {
    var args = var_args;
    switch(arguments.length) {
      case 1:
        return trampoline__1607957.call(this, f);
      default:
        return trampoline__1607958.apply(this, arguments)
    }
    throw"Invalid arity: " + arguments.length;
  };
  trampoline.cljs$lang$maxFixedArity = 1;
  trampoline.cljs$lang$applyTo = trampoline__1607958.cljs$lang$applyTo;
  return trampoline
}();
cljs.core.rand = function() {
  var rand = null;
  var rand__1607963 = function() {
    return rand.call(null, 1)
  };
  var rand__1607964 = function(n) {
    return Math.random() * n
  };
  rand = function(n) {
    switch(arguments.length) {
      case 0:
        return rand__1607963.call(this);
      case 1:
        return rand__1607964.call(this, n)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return rand
}();
cljs.core.rand_int = function rand_int(n) {
  return Math.floor(Math.random() * n)
};
cljs.core.rand_nth = function rand_nth(coll) {
  return cljs.core.nth.call(null, coll, cljs.core.rand_int.call(null, cljs.core.count.call(null, coll)))
};
cljs.core.group_by = function group_by(f, coll) {
  return cljs.core.reduce.call(null, function(ret, x) {
    var k__1607966 = f.call(null, x);
    return cljs.core.assoc.call(null, ret, k__1607966, cljs.core.conj.call(null, cljs.core.get.call(null, ret, k__1607966, cljs.core.PersistentVector.fromArray([])), x))
  }, cljs.core.ObjMap.fromObject([], {}), coll)
};
cljs.core.make_hierarchy = function make_hierarchy() {
  return cljs.core.ObjMap.fromObject(["\ufdd0'parents", "\ufdd0'descendants", "\ufdd0'ancestors"], {"\ufdd0'parents":cljs.core.ObjMap.fromObject([], {}), "\ufdd0'descendants":cljs.core.ObjMap.fromObject([], {}), "\ufdd0'ancestors":cljs.core.ObjMap.fromObject([], {})})
};
cljs.core.global_hierarchy = cljs.core.atom.call(null, cljs.core.make_hierarchy.call(null));
cljs.core.isa_QMARK_ = function() {
  var isa_QMARK_ = null;
  var isa_QMARK___1607975 = function(child, parent) {
    return isa_QMARK_.call(null, cljs.core.deref.call(null, cljs.core.global_hierarchy), child, parent)
  };
  var isa_QMARK___1607976 = function(h, child, parent) {
    var or__3548__auto____1607967 = cljs.core._EQ_.call(null, child, parent);
    if(cljs.core.truth_(or__3548__auto____1607967)) {
      return or__3548__auto____1607967
    }else {
      var or__3548__auto____1607968 = cljs.core.contains_QMARK_.call(null, "\ufdd0'ancestors".call(null, h).call(null, child), parent);
      if(cljs.core.truth_(or__3548__auto____1607968)) {
        return or__3548__auto____1607968
      }else {
        var and__3546__auto____1607969 = cljs.core.vector_QMARK_.call(null, parent);
        if(cljs.core.truth_(and__3546__auto____1607969)) {
          var and__3546__auto____1607970 = cljs.core.vector_QMARK_.call(null, child);
          if(cljs.core.truth_(and__3546__auto____1607970)) {
            var and__3546__auto____1607971 = cljs.core._EQ_.call(null, cljs.core.count.call(null, parent), cljs.core.count.call(null, child));
            if(cljs.core.truth_(and__3546__auto____1607971)) {
              var ret__1607972 = true;
              var i__1607973 = 0;
              while(true) {
                if(cljs.core.truth_(function() {
                  var or__3548__auto____1607974 = cljs.core.not.call(null, ret__1607972);
                  if(cljs.core.truth_(or__3548__auto____1607974)) {
                    return or__3548__auto____1607974
                  }else {
                    return cljs.core._EQ_.call(null, i__1607973, cljs.core.count.call(null, parent))
                  }
                }())) {
                  return ret__1607972
                }else {
                  var G__1607978 = isa_QMARK_.call(null, h, child.call(null, i__1607973), parent.call(null, i__1607973));
                  var G__1607979 = i__1607973 + 1;
                  ret__1607972 = G__1607978;
                  i__1607973 = G__1607979;
                  continue
                }
                break
              }
            }else {
              return and__3546__auto____1607971
            }
          }else {
            return and__3546__auto____1607970
          }
        }else {
          return and__3546__auto____1607969
        }
      }
    }
  };
  isa_QMARK_ = function(h, child, parent) {
    switch(arguments.length) {
      case 2:
        return isa_QMARK___1607975.call(this, h, child);
      case 3:
        return isa_QMARK___1607976.call(this, h, child, parent)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return isa_QMARK_
}();
cljs.core.parents = function() {
  var parents = null;
  var parents__1607980 = function(tag) {
    return parents.call(null, cljs.core.deref.call(null, cljs.core.global_hierarchy), tag)
  };
  var parents__1607981 = function(h, tag) {
    return cljs.core.not_empty.call(null, cljs.core.get.call(null, "\ufdd0'parents".call(null, h), tag))
  };
  parents = function(h, tag) {
    switch(arguments.length) {
      case 1:
        return parents__1607980.call(this, h);
      case 2:
        return parents__1607981.call(this, h, tag)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return parents
}();
cljs.core.ancestors = function() {
  var ancestors = null;
  var ancestors__1607983 = function(tag) {
    return ancestors.call(null, cljs.core.deref.call(null, cljs.core.global_hierarchy), tag)
  };
  var ancestors__1607984 = function(h, tag) {
    return cljs.core.not_empty.call(null, cljs.core.get.call(null, "\ufdd0'ancestors".call(null, h), tag))
  };
  ancestors = function(h, tag) {
    switch(arguments.length) {
      case 1:
        return ancestors__1607983.call(this, h);
      case 2:
        return ancestors__1607984.call(this, h, tag)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return ancestors
}();
cljs.core.descendants = function() {
  var descendants = null;
  var descendants__1607986 = function(tag) {
    return descendants.call(null, cljs.core.deref.call(null, cljs.core.global_hierarchy), tag)
  };
  var descendants__1607987 = function(h, tag) {
    return cljs.core.not_empty.call(null, cljs.core.get.call(null, "\ufdd0'descendants".call(null, h), tag))
  };
  descendants = function(h, tag) {
    switch(arguments.length) {
      case 1:
        return descendants__1607986.call(this, h);
      case 2:
        return descendants__1607987.call(this, h, tag)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return descendants
}();
cljs.core.derive = function() {
  var derive = null;
  var derive__1607997 = function(tag, parent) {
    if(cljs.core.truth_(cljs.core.namespace.call(null, parent))) {
    }else {
      throw new Error(cljs.core.str.call(null, "Assert failed: ", cljs.core.pr_str.call(null, cljs.core.with_meta(cljs.core.list("\ufdd1'namespace", "\ufdd1'parent"), cljs.core.hash_map("\ufdd0'line", 3566)))));
    }
    cljs.core.swap_BANG_.call(null, cljs.core.global_hierarchy, derive, tag, parent);
    return null
  };
  var derive__1607998 = function(h, tag, parent) {
    if(cljs.core.truth_(cljs.core.not_EQ_.call(null, tag, parent))) {
    }else {
      throw new Error(cljs.core.str.call(null, "Assert failed: ", cljs.core.pr_str.call(null, cljs.core.with_meta(cljs.core.list("\ufdd1'not=", "\ufdd1'tag", "\ufdd1'parent"), cljs.core.hash_map("\ufdd0'line", 3570)))));
    }
    var tp__1607992 = "\ufdd0'parents".call(null, h);
    var td__1607993 = "\ufdd0'descendants".call(null, h);
    var ta__1607994 = "\ufdd0'ancestors".call(null, h);
    var tf__1607995 = function(m, source, sources, target, targets) {
      return cljs.core.reduce.call(null, function(ret, k) {
        return cljs.core.assoc.call(null, ret, k, cljs.core.reduce.call(null, cljs.core.conj, cljs.core.get.call(null, targets, k, cljs.core.set([])), cljs.core.cons.call(null, target, targets.call(null, target))))
      }, m, cljs.core.cons.call(null, source, sources.call(null, source)))
    };
    var or__3548__auto____1607996 = cljs.core.truth_(cljs.core.contains_QMARK_.call(null, tp__1607992.call(null, tag), parent)) ? null : function() {
      if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, ta__1607994.call(null, tag), parent))) {
        throw new Error(cljs.core.str.call(null, tag, "already has", parent, "as ancestor"));
      }else {
      }
      if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, ta__1607994.call(null, parent), tag))) {
        throw new Error(cljs.core.str.call(null, "Cyclic derivation:", parent, "has", tag, "as ancestor"));
      }else {
      }
      return cljs.core.ObjMap.fromObject(["\ufdd0'parents", "\ufdd0'ancestors", "\ufdd0'descendants"], {"\ufdd0'parents":cljs.core.assoc.call(null, "\ufdd0'parents".call(null, h), tag, cljs.core.conj.call(null, cljs.core.get.call(null, tp__1607992, tag, cljs.core.set([])), parent)), "\ufdd0'ancestors":tf__1607995.call(null, "\ufdd0'ancestors".call(null, h), tag, td__1607993, parent, ta__1607994), "\ufdd0'descendants":tf__1607995.call(null, "\ufdd0'descendants".call(null, h), parent, ta__1607994, 
      tag, td__1607993)})
    }();
    if(cljs.core.truth_(or__3548__auto____1607996)) {
      return or__3548__auto____1607996
    }else {
      return h
    }
  };
  derive = function(h, tag, parent) {
    switch(arguments.length) {
      case 2:
        return derive__1607997.call(this, h, tag);
      case 3:
        return derive__1607998.call(this, h, tag, parent)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return derive
}();
cljs.core.underive = function() {
  var underive = null;
  var underive__1608004 = function(tag, parent) {
    cljs.core.swap_BANG_.call(null, cljs.core.global_hierarchy, underive, tag, parent);
    return null
  };
  var underive__1608005 = function(h, tag, parent) {
    var parentMap__1608000 = "\ufdd0'parents".call(null, h);
    var childsParents__1608001 = cljs.core.truth_(parentMap__1608000.call(null, tag)) ? cljs.core.disj.call(null, parentMap__1608000.call(null, tag), parent) : cljs.core.set([]);
    var newParents__1608002 = cljs.core.truth_(cljs.core.not_empty.call(null, childsParents__1608001)) ? cljs.core.assoc.call(null, parentMap__1608000, tag, childsParents__1608001) : cljs.core.dissoc.call(null, parentMap__1608000, tag);
    var deriv_seq__1608003 = cljs.core.flatten.call(null, cljs.core.map.call(null, function(p1__1607989_SHARP_) {
      return cljs.core.cons.call(null, cljs.core.first.call(null, p1__1607989_SHARP_), cljs.core.interpose.call(null, cljs.core.first.call(null, p1__1607989_SHARP_), cljs.core.second.call(null, p1__1607989_SHARP_)))
    }, cljs.core.seq.call(null, newParents__1608002)));
    if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, parentMap__1608000.call(null, tag), parent))) {
      return cljs.core.reduce.call(null, function(p1__1607990_SHARP_, p2__1607991_SHARP_) {
        return cljs.core.apply.call(null, cljs.core.derive, p1__1607990_SHARP_, p2__1607991_SHARP_)
      }, cljs.core.make_hierarchy.call(null), cljs.core.partition.call(null, 2, deriv_seq__1608003))
    }else {
      return h
    }
  };
  underive = function(h, tag, parent) {
    switch(arguments.length) {
      case 2:
        return underive__1608004.call(this, h, tag);
      case 3:
        return underive__1608005.call(this, h, tag, parent)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return underive
}();
cljs.core.reset_cache = function reset_cache(method_cache, method_table, cached_hierarchy, hierarchy) {
  cljs.core.swap_BANG_.call(null, method_cache, function(_) {
    return cljs.core.deref.call(null, method_table)
  });
  return cljs.core.swap_BANG_.call(null, cached_hierarchy, function(_) {
    return cljs.core.deref.call(null, hierarchy)
  })
};
cljs.core.prefers_STAR_ = function prefers_STAR_(x, y, prefer_table) {
  var xprefs__1608007 = cljs.core.deref.call(null, prefer_table).call(null, x);
  var or__3548__auto____1608009 = cljs.core.truth_(function() {
    var and__3546__auto____1608008 = xprefs__1608007;
    if(cljs.core.truth_(and__3546__auto____1608008)) {
      return xprefs__1608007.call(null, y)
    }else {
      return and__3546__auto____1608008
    }
  }()) ? true : null;
  if(cljs.core.truth_(or__3548__auto____1608009)) {
    return or__3548__auto____1608009
  }else {
    var or__3548__auto____1608011 = function() {
      var ps__1608010 = cljs.core.parents.call(null, y);
      while(true) {
        if(cljs.core.truth_(cljs.core.count.call(null, ps__1608010) > 0)) {
          if(cljs.core.truth_(prefers_STAR_.call(null, x, cljs.core.first.call(null, ps__1608010), prefer_table))) {
          }else {
          }
          var G__1608014 = cljs.core.rest.call(null, ps__1608010);
          ps__1608010 = G__1608014;
          continue
        }else {
          return null
        }
        break
      }
    }();
    if(cljs.core.truth_(or__3548__auto____1608011)) {
      return or__3548__auto____1608011
    }else {
      var or__3548__auto____1608013 = function() {
        var ps__1608012 = cljs.core.parents.call(null, x);
        while(true) {
          if(cljs.core.truth_(cljs.core.count.call(null, ps__1608012) > 0)) {
            if(cljs.core.truth_(prefers_STAR_.call(null, cljs.core.first.call(null, ps__1608012), y, prefer_table))) {
            }else {
            }
            var G__1608015 = cljs.core.rest.call(null, ps__1608012);
            ps__1608012 = G__1608015;
            continue
          }else {
            return null
          }
          break
        }
      }();
      if(cljs.core.truth_(or__3548__auto____1608013)) {
        return or__3548__auto____1608013
      }else {
        return false
      }
    }
  }
};
cljs.core.dominates = function dominates(x, y, prefer_table) {
  var or__3548__auto____1608016 = cljs.core.prefers_STAR_.call(null, x, y, prefer_table);
  if(cljs.core.truth_(or__3548__auto____1608016)) {
    return or__3548__auto____1608016
  }else {
    return cljs.core.isa_QMARK_.call(null, x, y)
  }
};
cljs.core.find_and_cache_best_method = function find_and_cache_best_method(name, dispatch_val, hierarchy, method_table, prefer_table, method_cache, cached_hierarchy) {
  var best_entry__1608025 = cljs.core.reduce.call(null, function(be, p__1608017) {
    var vec__1608018__1608019 = p__1608017;
    var k__1608020 = cljs.core.nth.call(null, vec__1608018__1608019, 0, null);
    var ___1608021 = cljs.core.nth.call(null, vec__1608018__1608019, 1, null);
    var e__1608022 = vec__1608018__1608019;
    if(cljs.core.truth_(cljs.core.isa_QMARK_.call(null, dispatch_val, k__1608020))) {
      var be2__1608024 = cljs.core.truth_(function() {
        var or__3548__auto____1608023 = be === null;
        if(cljs.core.truth_(or__3548__auto____1608023)) {
          return or__3548__auto____1608023
        }else {
          return cljs.core.dominates.call(null, k__1608020, cljs.core.first.call(null, be), prefer_table)
        }
      }()) ? e__1608022 : be;
      if(cljs.core.truth_(cljs.core.dominates.call(null, cljs.core.first.call(null, be2__1608024), k__1608020, prefer_table))) {
      }else {
        throw new Error(cljs.core.str.call(null, "Multiple methods in multimethod '", name, "' match dispatch value: ", dispatch_val, " -> ", k__1608020, " and ", cljs.core.first.call(null, be2__1608024), ", and neither is preferred"));
      }
      return be2__1608024
    }else {
      return be
    }
  }, null, cljs.core.deref.call(null, method_table));
  if(cljs.core.truth_(best_entry__1608025)) {
    if(cljs.core.truth_(cljs.core._EQ_.call(null, cljs.core.deref.call(null, cached_hierarchy), cljs.core.deref.call(null, hierarchy)))) {
      cljs.core.swap_BANG_.call(null, method_cache, cljs.core.assoc, dispatch_val, cljs.core.second.call(null, best_entry__1608025));
      return cljs.core.second.call(null, best_entry__1608025)
    }else {
      cljs.core.reset_cache.call(null, method_cache, method_table, cached_hierarchy, hierarchy);
      return find_and_cache_best_method.call(null, name, dispatch_val, hierarchy, method_table, prefer_table, method_cache, cached_hierarchy)
    }
  }else {
    return null
  }
};
cljs.core.IMultiFn = {};
cljs.core._reset = function _reset(mf) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1608026 = mf;
    if(cljs.core.truth_(and__3546__auto____1608026)) {
      return mf.cljs$core$IMultiFn$_reset
    }else {
      return and__3546__auto____1608026
    }
  }())) {
    return mf.cljs$core$IMultiFn$_reset(mf)
  }else {
    return function() {
      var or__3548__auto____1608027 = cljs.core._reset[goog.typeOf.call(null, mf)];
      if(cljs.core.truth_(or__3548__auto____1608027)) {
        return or__3548__auto____1608027
      }else {
        var or__3548__auto____1608028 = cljs.core._reset["_"];
        if(cljs.core.truth_(or__3548__auto____1608028)) {
          return or__3548__auto____1608028
        }else {
          throw cljs.core.missing_protocol.call(null, "IMultiFn.-reset", mf);
        }
      }
    }().call(null, mf)
  }
};
cljs.core._add_method = function _add_method(mf, dispatch_val, method) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1608029 = mf;
    if(cljs.core.truth_(and__3546__auto____1608029)) {
      return mf.cljs$core$IMultiFn$_add_method
    }else {
      return and__3546__auto____1608029
    }
  }())) {
    return mf.cljs$core$IMultiFn$_add_method(mf, dispatch_val, method)
  }else {
    return function() {
      var or__3548__auto____1608030 = cljs.core._add_method[goog.typeOf.call(null, mf)];
      if(cljs.core.truth_(or__3548__auto____1608030)) {
        return or__3548__auto____1608030
      }else {
        var or__3548__auto____1608031 = cljs.core._add_method["_"];
        if(cljs.core.truth_(or__3548__auto____1608031)) {
          return or__3548__auto____1608031
        }else {
          throw cljs.core.missing_protocol.call(null, "IMultiFn.-add-method", mf);
        }
      }
    }().call(null, mf, dispatch_val, method)
  }
};
cljs.core._remove_method = function _remove_method(mf, dispatch_val) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1608032 = mf;
    if(cljs.core.truth_(and__3546__auto____1608032)) {
      return mf.cljs$core$IMultiFn$_remove_method
    }else {
      return and__3546__auto____1608032
    }
  }())) {
    return mf.cljs$core$IMultiFn$_remove_method(mf, dispatch_val)
  }else {
    return function() {
      var or__3548__auto____1608033 = cljs.core._remove_method[goog.typeOf.call(null, mf)];
      if(cljs.core.truth_(or__3548__auto____1608033)) {
        return or__3548__auto____1608033
      }else {
        var or__3548__auto____1608034 = cljs.core._remove_method["_"];
        if(cljs.core.truth_(or__3548__auto____1608034)) {
          return or__3548__auto____1608034
        }else {
          throw cljs.core.missing_protocol.call(null, "IMultiFn.-remove-method", mf);
        }
      }
    }().call(null, mf, dispatch_val)
  }
};
cljs.core._prefer_method = function _prefer_method(mf, dispatch_val, dispatch_val_y) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1608035 = mf;
    if(cljs.core.truth_(and__3546__auto____1608035)) {
      return mf.cljs$core$IMultiFn$_prefer_method
    }else {
      return and__3546__auto____1608035
    }
  }())) {
    return mf.cljs$core$IMultiFn$_prefer_method(mf, dispatch_val, dispatch_val_y)
  }else {
    return function() {
      var or__3548__auto____1608036 = cljs.core._prefer_method[goog.typeOf.call(null, mf)];
      if(cljs.core.truth_(or__3548__auto____1608036)) {
        return or__3548__auto____1608036
      }else {
        var or__3548__auto____1608037 = cljs.core._prefer_method["_"];
        if(cljs.core.truth_(or__3548__auto____1608037)) {
          return or__3548__auto____1608037
        }else {
          throw cljs.core.missing_protocol.call(null, "IMultiFn.-prefer-method", mf);
        }
      }
    }().call(null, mf, dispatch_val, dispatch_val_y)
  }
};
cljs.core._get_method = function _get_method(mf, dispatch_val) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1608038 = mf;
    if(cljs.core.truth_(and__3546__auto____1608038)) {
      return mf.cljs$core$IMultiFn$_get_method
    }else {
      return and__3546__auto____1608038
    }
  }())) {
    return mf.cljs$core$IMultiFn$_get_method(mf, dispatch_val)
  }else {
    return function() {
      var or__3548__auto____1608039 = cljs.core._get_method[goog.typeOf.call(null, mf)];
      if(cljs.core.truth_(or__3548__auto____1608039)) {
        return or__3548__auto____1608039
      }else {
        var or__3548__auto____1608040 = cljs.core._get_method["_"];
        if(cljs.core.truth_(or__3548__auto____1608040)) {
          return or__3548__auto____1608040
        }else {
          throw cljs.core.missing_protocol.call(null, "IMultiFn.-get-method", mf);
        }
      }
    }().call(null, mf, dispatch_val)
  }
};
cljs.core._methods = function _methods(mf) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1608041 = mf;
    if(cljs.core.truth_(and__3546__auto____1608041)) {
      return mf.cljs$core$IMultiFn$_methods
    }else {
      return and__3546__auto____1608041
    }
  }())) {
    return mf.cljs$core$IMultiFn$_methods(mf)
  }else {
    return function() {
      var or__3548__auto____1608042 = cljs.core._methods[goog.typeOf.call(null, mf)];
      if(cljs.core.truth_(or__3548__auto____1608042)) {
        return or__3548__auto____1608042
      }else {
        var or__3548__auto____1608043 = cljs.core._methods["_"];
        if(cljs.core.truth_(or__3548__auto____1608043)) {
          return or__3548__auto____1608043
        }else {
          throw cljs.core.missing_protocol.call(null, "IMultiFn.-methods", mf);
        }
      }
    }().call(null, mf)
  }
};
cljs.core._prefers = function _prefers(mf) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1608044 = mf;
    if(cljs.core.truth_(and__3546__auto____1608044)) {
      return mf.cljs$core$IMultiFn$_prefers
    }else {
      return and__3546__auto____1608044
    }
  }())) {
    return mf.cljs$core$IMultiFn$_prefers(mf)
  }else {
    return function() {
      var or__3548__auto____1608045 = cljs.core._prefers[goog.typeOf.call(null, mf)];
      if(cljs.core.truth_(or__3548__auto____1608045)) {
        return or__3548__auto____1608045
      }else {
        var or__3548__auto____1608046 = cljs.core._prefers["_"];
        if(cljs.core.truth_(or__3548__auto____1608046)) {
          return or__3548__auto____1608046
        }else {
          throw cljs.core.missing_protocol.call(null, "IMultiFn.-prefers", mf);
        }
      }
    }().call(null, mf)
  }
};
cljs.core._dispatch = function _dispatch(mf, args) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1608047 = mf;
    if(cljs.core.truth_(and__3546__auto____1608047)) {
      return mf.cljs$core$IMultiFn$_dispatch
    }else {
      return and__3546__auto____1608047
    }
  }())) {
    return mf.cljs$core$IMultiFn$_dispatch(mf, args)
  }else {
    return function() {
      var or__3548__auto____1608048 = cljs.core._dispatch[goog.typeOf.call(null, mf)];
      if(cljs.core.truth_(or__3548__auto____1608048)) {
        return or__3548__auto____1608048
      }else {
        var or__3548__auto____1608049 = cljs.core._dispatch["_"];
        if(cljs.core.truth_(or__3548__auto____1608049)) {
          return or__3548__auto____1608049
        }else {
          throw cljs.core.missing_protocol.call(null, "IMultiFn.-dispatch", mf);
        }
      }
    }().call(null, mf, args)
  }
};
cljs.core.do_dispatch = function do_dispatch(mf, dispatch_fn, args) {
  var dispatch_val__1608050 = cljs.core.apply.call(null, dispatch_fn, args);
  var target_fn__1608051 = cljs.core._get_method.call(null, mf, dispatch_val__1608050);
  if(cljs.core.truth_(target_fn__1608051)) {
  }else {
    throw new Error(cljs.core.str.call(null, "No method in multimethod '", cljs.core.name, "' for dispatch value: ", dispatch_val__1608050));
  }
  return cljs.core.apply.call(null, target_fn__1608051, args)
};
cljs.core.MultiFn = function(name, dispatch_fn, default_dispatch_val, hierarchy, method_table, prefer_table, method_cache, cached_hierarchy) {
  this.name = name;
  this.dispatch_fn = dispatch_fn;
  this.default_dispatch_val = default_dispatch_val;
  this.hierarchy = hierarchy;
  this.method_table = method_table;
  this.prefer_table = prefer_table;
  this.method_cache = method_cache;
  this.cached_hierarchy = cached_hierarchy
};
cljs.core.MultiFn.cljs$core$IPrintable$_pr_seq = function(this__367__auto__) {
  return cljs.core.list.call(null, "cljs.core.MultiFn")
};
cljs.core.MultiFn.prototype.cljs$core$IHash$ = true;
cljs.core.MultiFn.prototype.cljs$core$IHash$_hash = function(this$) {
  var this__1608052 = this;
  return goog.getUid.call(null, this$)
};
cljs.core.MultiFn.prototype.cljs$core$IMultiFn$ = true;
cljs.core.MultiFn.prototype.cljs$core$IMultiFn$_reset = function(mf) {
  var this__1608053 = this;
  cljs.core.swap_BANG_.call(null, this__1608053.method_table, function(mf) {
    return cljs.core.ObjMap.fromObject([], {})
  });
  cljs.core.swap_BANG_.call(null, this__1608053.method_cache, function(mf) {
    return cljs.core.ObjMap.fromObject([], {})
  });
  cljs.core.swap_BANG_.call(null, this__1608053.prefer_table, function(mf) {
    return cljs.core.ObjMap.fromObject([], {})
  });
  cljs.core.swap_BANG_.call(null, this__1608053.cached_hierarchy, function(mf) {
    return null
  });
  return mf
};
cljs.core.MultiFn.prototype.cljs$core$IMultiFn$_add_method = function(mf, dispatch_val, method) {
  var this__1608054 = this;
  cljs.core.swap_BANG_.call(null, this__1608054.method_table, cljs.core.assoc, dispatch_val, method);
  cljs.core.reset_cache.call(null, this__1608054.method_cache, this__1608054.method_table, this__1608054.cached_hierarchy, this__1608054.hierarchy);
  return mf
};
cljs.core.MultiFn.prototype.cljs$core$IMultiFn$_remove_method = function(mf, dispatch_val) {
  var this__1608055 = this;
  cljs.core.swap_BANG_.call(null, this__1608055.method_table, cljs.core.dissoc, dispatch_val);
  cljs.core.reset_cache.call(null, this__1608055.method_cache, this__1608055.method_table, this__1608055.cached_hierarchy, this__1608055.hierarchy);
  return mf
};
cljs.core.MultiFn.prototype.cljs$core$IMultiFn$_get_method = function(mf, dispatch_val) {
  var this__1608056 = this;
  if(cljs.core.truth_(cljs.core._EQ_.call(null, cljs.core.deref.call(null, this__1608056.cached_hierarchy), cljs.core.deref.call(null, this__1608056.hierarchy)))) {
  }else {
    cljs.core.reset_cache.call(null, this__1608056.method_cache, this__1608056.method_table, this__1608056.cached_hierarchy, this__1608056.hierarchy)
  }
  var temp__3695__auto____1608057 = cljs.core.deref.call(null, this__1608056.method_cache).call(null, dispatch_val);
  if(cljs.core.truth_(temp__3695__auto____1608057)) {
    var target_fn__1608058 = temp__3695__auto____1608057;
    return target_fn__1608058
  }else {
    var temp__3695__auto____1608059 = cljs.core.find_and_cache_best_method.call(null, this__1608056.name, dispatch_val, this__1608056.hierarchy, this__1608056.method_table, this__1608056.prefer_table, this__1608056.method_cache, this__1608056.cached_hierarchy);
    if(cljs.core.truth_(temp__3695__auto____1608059)) {
      var target_fn__1608060 = temp__3695__auto____1608059;
      return target_fn__1608060
    }else {
      return cljs.core.deref.call(null, this__1608056.method_table).call(null, this__1608056.default_dispatch_val)
    }
  }
};
cljs.core.MultiFn.prototype.cljs$core$IMultiFn$_prefer_method = function(mf, dispatch_val_x, dispatch_val_y) {
  var this__1608061 = this;
  if(cljs.core.truth_(cljs.core.prefers_STAR_.call(null, dispatch_val_x, dispatch_val_y, this__1608061.prefer_table))) {
    throw new Error(cljs.core.str.call(null, "Preference conflict in multimethod '", this__1608061.name, "': ", dispatch_val_y, " is already preferred to ", dispatch_val_x));
  }else {
  }
  cljs.core.swap_BANG_.call(null, this__1608061.prefer_table, function(old) {
    return cljs.core.assoc.call(null, old, dispatch_val_x, cljs.core.conj.call(null, cljs.core.get.call(null, old, dispatch_val_x, cljs.core.set([])), dispatch_val_y))
  });
  return cljs.core.reset_cache.call(null, this__1608061.method_cache, this__1608061.method_table, this__1608061.cached_hierarchy, this__1608061.hierarchy)
};
cljs.core.MultiFn.prototype.cljs$core$IMultiFn$_methods = function(mf) {
  var this__1608062 = this;
  return cljs.core.deref.call(null, this__1608062.method_table)
};
cljs.core.MultiFn.prototype.cljs$core$IMultiFn$_prefers = function(mf) {
  var this__1608063 = this;
  return cljs.core.deref.call(null, this__1608063.prefer_table)
};
cljs.core.MultiFn.prototype.cljs$core$IMultiFn$_dispatch = function(mf, args) {
  var this__1608064 = this;
  return cljs.core.do_dispatch.call(null, mf, this__1608064.dispatch_fn, args)
};
cljs.core.MultiFn;
cljs.core.MultiFn.prototype.call = function() {
  var G__1608065__delegate = function(_, args) {
    return cljs.core._dispatch.call(null, this, args)
  };
  var G__1608065 = function(_, var_args) {
    var args = null;
    if(goog.isDef(var_args)) {
      args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1), 0)
    }
    return G__1608065__delegate.call(this, _, args)
  };
  G__1608065.cljs$lang$maxFixedArity = 1;
  G__1608065.cljs$lang$applyTo = function(arglist__1608066) {
    var _ = cljs.core.first(arglist__1608066);
    var args = cljs.core.rest(arglist__1608066);
    return G__1608065__delegate.call(this, _, args)
  };
  return G__1608065
}();
cljs.core.MultiFn.prototype.apply = function(_, args) {
  return cljs.core._dispatch.call(null, this, args)
};
cljs.core.remove_all_methods = function remove_all_methods(multifn) {
  return cljs.core._reset.call(null, multifn)
};
cljs.core.remove_method = function remove_method(multifn, dispatch_val) {
  return cljs.core._remove_method.call(null, multifn, dispatch_val)
};
cljs.core.prefer_method = function prefer_method(multifn, dispatch_val_x, dispatch_val_y) {
  return cljs.core._prefer_method.call(null, multifn, dispatch_val_x, dispatch_val_y)
};
cljs.core.methods$ = function methods$(multifn) {
  return cljs.core._methods.call(null, multifn)
};
cljs.core.get_method = function get_method(multifn, dispatch_val) {
  return cljs.core._get_method.call(null, multifn, dispatch_val)
};
cljs.core.prefers = function prefers(multifn) {
  return cljs.core._prefers.call(null, multifn)
};
goog.provide("goog.userAgent");
goog.require("goog.string");
goog.userAgent.ASSUME_IE = false;
goog.userAgent.ASSUME_GECKO = false;
goog.userAgent.ASSUME_WEBKIT = false;
goog.userAgent.ASSUME_MOBILE_WEBKIT = false;
goog.userAgent.ASSUME_OPERA = false;
goog.userAgent.BROWSER_KNOWN_ = goog.userAgent.ASSUME_IE || goog.userAgent.ASSUME_GECKO || goog.userAgent.ASSUME_MOBILE_WEBKIT || goog.userAgent.ASSUME_WEBKIT || goog.userAgent.ASSUME_OPERA;
goog.userAgent.getUserAgentString = function() {
  return goog.global["navigator"] ? goog.global["navigator"].userAgent : null
};
goog.userAgent.getNavigator = function() {
  return goog.global["navigator"]
};
goog.userAgent.init_ = function() {
  goog.userAgent.detectedOpera_ = false;
  goog.userAgent.detectedIe_ = false;
  goog.userAgent.detectedWebkit_ = false;
  goog.userAgent.detectedMobile_ = false;
  goog.userAgent.detectedGecko_ = false;
  var ua;
  if(!goog.userAgent.BROWSER_KNOWN_ && (ua = goog.userAgent.getUserAgentString())) {
    var navigator = goog.userAgent.getNavigator();
    goog.userAgent.detectedOpera_ = ua.indexOf("Opera") == 0;
    goog.userAgent.detectedIe_ = !goog.userAgent.detectedOpera_ && ua.indexOf("MSIE") != -1;
    goog.userAgent.detectedWebkit_ = !goog.userAgent.detectedOpera_ && ua.indexOf("WebKit") != -1;
    goog.userAgent.detectedMobile_ = goog.userAgent.detectedWebkit_ && ua.indexOf("Mobile") != -1;
    goog.userAgent.detectedGecko_ = !goog.userAgent.detectedOpera_ && !goog.userAgent.detectedWebkit_ && navigator.product == "Gecko"
  }
};
if(!goog.userAgent.BROWSER_KNOWN_) {
  goog.userAgent.init_()
}
goog.userAgent.OPERA = goog.userAgent.BROWSER_KNOWN_ ? goog.userAgent.ASSUME_OPERA : goog.userAgent.detectedOpera_;
goog.userAgent.IE = goog.userAgent.BROWSER_KNOWN_ ? goog.userAgent.ASSUME_IE : goog.userAgent.detectedIe_;
goog.userAgent.GECKO = goog.userAgent.BROWSER_KNOWN_ ? goog.userAgent.ASSUME_GECKO : goog.userAgent.detectedGecko_;
goog.userAgent.WEBKIT = goog.userAgent.BROWSER_KNOWN_ ? goog.userAgent.ASSUME_WEBKIT || goog.userAgent.ASSUME_MOBILE_WEBKIT : goog.userAgent.detectedWebkit_;
goog.userAgent.MOBILE = goog.userAgent.ASSUME_MOBILE_WEBKIT || goog.userAgent.detectedMobile_;
goog.userAgent.SAFARI = goog.userAgent.WEBKIT;
goog.userAgent.determinePlatform_ = function() {
  var navigator = goog.userAgent.getNavigator();
  return navigator && navigator.platform || ""
};
goog.userAgent.PLATFORM = goog.userAgent.determinePlatform_();
goog.userAgent.ASSUME_MAC = false;
goog.userAgent.ASSUME_WINDOWS = false;
goog.userAgent.ASSUME_LINUX = false;
goog.userAgent.ASSUME_X11 = false;
goog.userAgent.PLATFORM_KNOWN_ = goog.userAgent.ASSUME_MAC || goog.userAgent.ASSUME_WINDOWS || goog.userAgent.ASSUME_LINUX || goog.userAgent.ASSUME_X11;
goog.userAgent.initPlatform_ = function() {
  goog.userAgent.detectedMac_ = goog.string.contains(goog.userAgent.PLATFORM, "Mac");
  goog.userAgent.detectedWindows_ = goog.string.contains(goog.userAgent.PLATFORM, "Win");
  goog.userAgent.detectedLinux_ = goog.string.contains(goog.userAgent.PLATFORM, "Linux");
  goog.userAgent.detectedX11_ = !!goog.userAgent.getNavigator() && goog.string.contains(goog.userAgent.getNavigator()["appVersion"] || "", "X11")
};
if(!goog.userAgent.PLATFORM_KNOWN_) {
  goog.userAgent.initPlatform_()
}
goog.userAgent.MAC = goog.userAgent.PLATFORM_KNOWN_ ? goog.userAgent.ASSUME_MAC : goog.userAgent.detectedMac_;
goog.userAgent.WINDOWS = goog.userAgent.PLATFORM_KNOWN_ ? goog.userAgent.ASSUME_WINDOWS : goog.userAgent.detectedWindows_;
goog.userAgent.LINUX = goog.userAgent.PLATFORM_KNOWN_ ? goog.userAgent.ASSUME_LINUX : goog.userAgent.detectedLinux_;
goog.userAgent.X11 = goog.userAgent.PLATFORM_KNOWN_ ? goog.userAgent.ASSUME_X11 : goog.userAgent.detectedX11_;
goog.userAgent.determineVersion_ = function() {
  var version = "", re;
  if(goog.userAgent.OPERA && goog.global["opera"]) {
    var operaVersion = goog.global["opera"].version;
    version = typeof operaVersion == "function" ? operaVersion() : operaVersion
  }else {
    if(goog.userAgent.GECKO) {
      re = /rv\:([^\);]+)(\)|;)/
    }else {
      if(goog.userAgent.IE) {
        re = /MSIE\s+([^\);]+)(\)|;)/
      }else {
        if(goog.userAgent.WEBKIT) {
          re = /WebKit\/(\S+)/
        }
      }
    }
    if(re) {
      var arr = re.exec(goog.userAgent.getUserAgentString());
      version = arr ? arr[1] : ""
    }
  }
  if(goog.userAgent.IE) {
    var docMode = goog.userAgent.getDocumentMode_();
    if(docMode > parseFloat(version)) {
      return String(docMode)
    }
  }
  return version
};
goog.userAgent.getDocumentMode_ = function() {
  var doc = goog.global["document"];
  return doc ? doc["documentMode"] : undefined
};
goog.userAgent.VERSION = goog.userAgent.determineVersion_();
goog.userAgent.compare = function(v1, v2) {
  return goog.string.compareVersions(v1, v2)
};
goog.userAgent.isVersionCache_ = {};
goog.userAgent.isVersion = function(version) {
  return goog.userAgent.isVersionCache_[version] || (goog.userAgent.isVersionCache_[version] = goog.string.compareVersions(goog.userAgent.VERSION, version) >= 0)
};
goog.provide("goog.dom.BrowserFeature");
goog.require("goog.userAgent");
goog.dom.BrowserFeature = {CAN_ADD_NAME_OR_TYPE_ATTRIBUTES:!goog.userAgent.IE || goog.userAgent.isVersion("9"), CAN_USE_CHILDREN_ATTRIBUTE:!goog.userAgent.GECKO && !goog.userAgent.IE || goog.userAgent.IE && goog.userAgent.isVersion("9") || goog.userAgent.GECKO && goog.userAgent.isVersion("1.9.1"), CAN_USE_INNER_TEXT:goog.userAgent.IE && !goog.userAgent.isVersion("9"), INNER_HTML_NEEDS_SCOPED_ELEMENT:goog.userAgent.IE};
goog.provide("goog.dom.TagName");
goog.dom.TagName = {A:"A", ABBR:"ABBR", ACRONYM:"ACRONYM", ADDRESS:"ADDRESS", APPLET:"APPLET", AREA:"AREA", B:"B", BASE:"BASE", BASEFONT:"BASEFONT", BDO:"BDO", BIG:"BIG", BLOCKQUOTE:"BLOCKQUOTE", BODY:"BODY", BR:"BR", BUTTON:"BUTTON", CANVAS:"CANVAS", CAPTION:"CAPTION", CENTER:"CENTER", CITE:"CITE", CODE:"CODE", COL:"COL", COLGROUP:"COLGROUP", DD:"DD", DEL:"DEL", DFN:"DFN", DIR:"DIR", DIV:"DIV", DL:"DL", DT:"DT", EM:"EM", FIELDSET:"FIELDSET", FONT:"FONT", FORM:"FORM", FRAME:"FRAME", FRAMESET:"FRAMESET", 
H1:"H1", H2:"H2", H3:"H3", H4:"H4", H5:"H5", H6:"H6", HEAD:"HEAD", HR:"HR", HTML:"HTML", I:"I", IFRAME:"IFRAME", IMG:"IMG", INPUT:"INPUT", INS:"INS", ISINDEX:"ISINDEX", KBD:"KBD", LABEL:"LABEL", LEGEND:"LEGEND", LI:"LI", LINK:"LINK", MAP:"MAP", MENU:"MENU", META:"META", NOFRAMES:"NOFRAMES", NOSCRIPT:"NOSCRIPT", OBJECT:"OBJECT", OL:"OL", OPTGROUP:"OPTGROUP", OPTION:"OPTION", P:"P", PARAM:"PARAM", PRE:"PRE", Q:"Q", S:"S", SAMP:"SAMP", SCRIPT:"SCRIPT", SELECT:"SELECT", SMALL:"SMALL", SPAN:"SPAN", STRIKE:"STRIKE", 
STRONG:"STRONG", STYLE:"STYLE", SUB:"SUB", SUP:"SUP", TABLE:"TABLE", TBODY:"TBODY", TD:"TD", TEXTAREA:"TEXTAREA", TFOOT:"TFOOT", TH:"TH", THEAD:"THEAD", TITLE:"TITLE", TR:"TR", TT:"TT", U:"U", UL:"UL", VAR:"VAR"};
goog.provide("goog.dom.classes");
goog.require("goog.array");
goog.dom.classes.set = function(element, className) {
  element.className = className
};
goog.dom.classes.get = function(element) {
  var className = element.className;
  return className && typeof className.split == "function" ? className.split(/\s+/) : []
};
goog.dom.classes.add = function(element, var_args) {
  var classes = goog.dom.classes.get(element);
  var args = goog.array.slice(arguments, 1);
  var b = goog.dom.classes.add_(classes, args);
  element.className = classes.join(" ");
  return b
};
goog.dom.classes.remove = function(element, var_args) {
  var classes = goog.dom.classes.get(element);
  var args = goog.array.slice(arguments, 1);
  var b = goog.dom.classes.remove_(classes, args);
  element.className = classes.join(" ");
  return b
};
goog.dom.classes.add_ = function(classes, args) {
  var rv = 0;
  for(var i = 0;i < args.length;i++) {
    if(!goog.array.contains(classes, args[i])) {
      classes.push(args[i]);
      rv++
    }
  }
  return rv == args.length
};
goog.dom.classes.remove_ = function(classes, args) {
  var rv = 0;
  for(var i = 0;i < classes.length;i++) {
    if(goog.array.contains(args, classes[i])) {
      goog.array.splice(classes, i--, 1);
      rv++
    }
  }
  return rv == args.length
};
goog.dom.classes.swap = function(element, fromClass, toClass) {
  var classes = goog.dom.classes.get(element);
  var removed = false;
  for(var i = 0;i < classes.length;i++) {
    if(classes[i] == fromClass) {
      goog.array.splice(classes, i--, 1);
      removed = true
    }
  }
  if(removed) {
    classes.push(toClass);
    element.className = classes.join(" ")
  }
  return removed
};
goog.dom.classes.addRemove = function(element, classesToRemove, classesToAdd) {
  var classes = goog.dom.classes.get(element);
  if(goog.isString(classesToRemove)) {
    goog.array.remove(classes, classesToRemove)
  }else {
    if(goog.isArray(classesToRemove)) {
      goog.dom.classes.remove_(classes, classesToRemove)
    }
  }
  if(goog.isString(classesToAdd) && !goog.array.contains(classes, classesToAdd)) {
    classes.push(classesToAdd)
  }else {
    if(goog.isArray(classesToAdd)) {
      goog.dom.classes.add_(classes, classesToAdd)
    }
  }
  element.className = classes.join(" ")
};
goog.dom.classes.has = function(element, className) {
  return goog.array.contains(goog.dom.classes.get(element), className)
};
goog.dom.classes.enable = function(element, className, enabled) {
  if(enabled) {
    goog.dom.classes.add(element, className)
  }else {
    goog.dom.classes.remove(element, className)
  }
};
goog.dom.classes.toggle = function(element, className) {
  var add = !goog.dom.classes.has(element, className);
  goog.dom.classes.enable(element, className, add);
  return add
};
goog.provide("goog.math.Coordinate");
goog.math.Coordinate = function(opt_x, opt_y) {
  this.x = goog.isDef(opt_x) ? opt_x : 0;
  this.y = goog.isDef(opt_y) ? opt_y : 0
};
goog.math.Coordinate.prototype.clone = function() {
  return new goog.math.Coordinate(this.x, this.y)
};
if(goog.DEBUG) {
  goog.math.Coordinate.prototype.toString = function() {
    return"(" + this.x + ", " + this.y + ")"
  }
}
goog.math.Coordinate.equals = function(a, b) {
  if(a == b) {
    return true
  }
  if(!a || !b) {
    return false
  }
  return a.x == b.x && a.y == b.y
};
goog.math.Coordinate.distance = function(a, b) {
  var dx = a.x - b.x;
  var dy = a.y - b.y;
  return Math.sqrt(dx * dx + dy * dy)
};
goog.math.Coordinate.squaredDistance = function(a, b) {
  var dx = a.x - b.x;
  var dy = a.y - b.y;
  return dx * dx + dy * dy
};
goog.math.Coordinate.difference = function(a, b) {
  return new goog.math.Coordinate(a.x - b.x, a.y - b.y)
};
goog.math.Coordinate.sum = function(a, b) {
  return new goog.math.Coordinate(a.x + b.x, a.y + b.y)
};
goog.provide("goog.math.Size");
goog.math.Size = function(width, height) {
  this.width = width;
  this.height = height
};
goog.math.Size.equals = function(a, b) {
  if(a == b) {
    return true
  }
  if(!a || !b) {
    return false
  }
  return a.width == b.width && a.height == b.height
};
goog.math.Size.prototype.clone = function() {
  return new goog.math.Size(this.width, this.height)
};
if(goog.DEBUG) {
  goog.math.Size.prototype.toString = function() {
    return"(" + this.width + " x " + this.height + ")"
  }
}
goog.math.Size.prototype.getLongest = function() {
  return Math.max(this.width, this.height)
};
goog.math.Size.prototype.getShortest = function() {
  return Math.min(this.width, this.height)
};
goog.math.Size.prototype.area = function() {
  return this.width * this.height
};
goog.math.Size.prototype.perimeter = function() {
  return(this.width + this.height) * 2
};
goog.math.Size.prototype.aspectRatio = function() {
  return this.width / this.height
};
goog.math.Size.prototype.isEmpty = function() {
  return!this.area()
};
goog.math.Size.prototype.ceil = function() {
  this.width = Math.ceil(this.width);
  this.height = Math.ceil(this.height);
  return this
};
goog.math.Size.prototype.fitsInside = function(target) {
  return this.width <= target.width && this.height <= target.height
};
goog.math.Size.prototype.floor = function() {
  this.width = Math.floor(this.width);
  this.height = Math.floor(this.height);
  return this
};
goog.math.Size.prototype.round = function() {
  this.width = Math.round(this.width);
  this.height = Math.round(this.height);
  return this
};
goog.math.Size.prototype.scale = function(s) {
  this.width *= s;
  this.height *= s;
  return this
};
goog.math.Size.prototype.scaleToFit = function(target) {
  var s = this.aspectRatio() > target.aspectRatio() ? target.width / this.width : target.height / this.height;
  return this.scale(s)
};
goog.provide("goog.dom");
goog.provide("goog.dom.DomHelper");
goog.provide("goog.dom.NodeType");
goog.require("goog.array");
goog.require("goog.dom.BrowserFeature");
goog.require("goog.dom.TagName");
goog.require("goog.dom.classes");
goog.require("goog.math.Coordinate");
goog.require("goog.math.Size");
goog.require("goog.object");
goog.require("goog.string");
goog.require("goog.userAgent");
goog.dom.ASSUME_QUIRKS_MODE = false;
goog.dom.ASSUME_STANDARDS_MODE = false;
goog.dom.COMPAT_MODE_KNOWN_ = goog.dom.ASSUME_QUIRKS_MODE || goog.dom.ASSUME_STANDARDS_MODE;
goog.dom.NodeType = {ELEMENT:1, ATTRIBUTE:2, TEXT:3, CDATA_SECTION:4, ENTITY_REFERENCE:5, ENTITY:6, PROCESSING_INSTRUCTION:7, COMMENT:8, DOCUMENT:9, DOCUMENT_TYPE:10, DOCUMENT_FRAGMENT:11, NOTATION:12};
goog.dom.getDomHelper = function(opt_element) {
  return opt_element ? new goog.dom.DomHelper(goog.dom.getOwnerDocument(opt_element)) : goog.dom.defaultDomHelper_ || (goog.dom.defaultDomHelper_ = new goog.dom.DomHelper)
};
goog.dom.defaultDomHelper_;
goog.dom.getDocument = function() {
  return document
};
goog.dom.getElement = function(element) {
  return goog.isString(element) ? document.getElementById(element) : element
};
goog.dom.$ = goog.dom.getElement;
goog.dom.getElementsByTagNameAndClass = function(opt_tag, opt_class, opt_el) {
  return goog.dom.getElementsByTagNameAndClass_(document, opt_tag, opt_class, opt_el)
};
goog.dom.getElementsByClass = function(className, opt_el) {
  var parent = opt_el || document;
  if(goog.dom.canUseQuerySelector_(parent)) {
    return parent.querySelectorAll("." + className)
  }else {
    if(parent.getElementsByClassName) {
      return parent.getElementsByClassName(className)
    }
  }
  return goog.dom.getElementsByTagNameAndClass_(document, "*", className, opt_el)
};
goog.dom.getElementByClass = function(className, opt_el) {
  var parent = opt_el || document;
  var retVal = null;
  if(goog.dom.canUseQuerySelector_(parent)) {
    retVal = parent.querySelector("." + className)
  }else {
    retVal = goog.dom.getElementsByClass(className, opt_el)[0]
  }
  return retVal || null
};
goog.dom.canUseQuerySelector_ = function(parent) {
  return parent.querySelectorAll && parent.querySelector && (!goog.userAgent.WEBKIT || goog.dom.isCss1CompatMode_(document) || goog.userAgent.isVersion("528"))
};
goog.dom.getElementsByTagNameAndClass_ = function(doc, opt_tag, opt_class, opt_el) {
  var parent = opt_el || doc;
  var tagName = opt_tag && opt_tag != "*" ? opt_tag.toUpperCase() : "";
  if(goog.dom.canUseQuerySelector_(parent) && (tagName || opt_class)) {
    var query = tagName + (opt_class ? "." + opt_class : "");
    return parent.querySelectorAll(query)
  }
  if(opt_class && parent.getElementsByClassName) {
    var els = parent.getElementsByClassName(opt_class);
    if(tagName) {
      var arrayLike = {};
      var len = 0;
      for(var i = 0, el;el = els[i];i++) {
        if(tagName == el.nodeName) {
          arrayLike[len++] = el
        }
      }
      arrayLike.length = len;
      return arrayLike
    }else {
      return els
    }
  }
  var els = parent.getElementsByTagName(tagName || "*");
  if(opt_class) {
    var arrayLike = {};
    var len = 0;
    for(var i = 0, el;el = els[i];i++) {
      var className = el.className;
      if(typeof className.split == "function" && goog.array.contains(className.split(/\s+/), opt_class)) {
        arrayLike[len++] = el
      }
    }
    arrayLike.length = len;
    return arrayLike
  }else {
    return els
  }
};
goog.dom.$$ = goog.dom.getElementsByTagNameAndClass;
goog.dom.setProperties = function(element, properties) {
  goog.object.forEach(properties, function(val, key) {
    if(key == "style") {
      element.style.cssText = val
    }else {
      if(key == "class") {
        element.className = val
      }else {
        if(key == "for") {
          element.htmlFor = val
        }else {
          if(key in goog.dom.DIRECT_ATTRIBUTE_MAP_) {
            element.setAttribute(goog.dom.DIRECT_ATTRIBUTE_MAP_[key], val)
          }else {
            element[key] = val
          }
        }
      }
    }
  })
};
goog.dom.DIRECT_ATTRIBUTE_MAP_ = {"cellpadding":"cellPadding", "cellspacing":"cellSpacing", "colspan":"colSpan", "rowspan":"rowSpan", "valign":"vAlign", "height":"height", "width":"width", "usemap":"useMap", "frameborder":"frameBorder", "maxlength":"maxLength", "type":"type"};
goog.dom.getViewportSize = function(opt_window) {
  return goog.dom.getViewportSize_(opt_window || window)
};
goog.dom.getViewportSize_ = function(win) {
  var doc = win.document;
  if(goog.userAgent.WEBKIT && !goog.userAgent.isVersion("500") && !goog.userAgent.MOBILE) {
    if(typeof win.innerHeight == "undefined") {
      win = window
    }
    var innerHeight = win.innerHeight;
    var scrollHeight = win.document.documentElement.scrollHeight;
    if(win == win.top) {
      if(scrollHeight < innerHeight) {
        innerHeight -= 15
      }
    }
    return new goog.math.Size(win.innerWidth, innerHeight)
  }
  var el = goog.dom.isCss1CompatMode_(doc) ? doc.documentElement : doc.body;
  return new goog.math.Size(el.clientWidth, el.clientHeight)
};
goog.dom.getDocumentHeight = function() {
  return goog.dom.getDocumentHeight_(window)
};
goog.dom.getDocumentHeight_ = function(win) {
  var doc = win.document;
  var height = 0;
  if(doc) {
    var vh = goog.dom.getViewportSize_(win).height;
    var body = doc.body;
    var docEl = doc.documentElement;
    if(goog.dom.isCss1CompatMode_(doc) && docEl.scrollHeight) {
      height = docEl.scrollHeight != vh ? docEl.scrollHeight : docEl.offsetHeight
    }else {
      var sh = docEl.scrollHeight;
      var oh = docEl.offsetHeight;
      if(docEl.clientHeight != oh) {
        sh = body.scrollHeight;
        oh = body.offsetHeight
      }
      if(sh > vh) {
        height = sh > oh ? sh : oh
      }else {
        height = sh < oh ? sh : oh
      }
    }
  }
  return height
};
goog.dom.getPageScroll = function(opt_window) {
  var win = opt_window || goog.global || window;
  return goog.dom.getDomHelper(win.document).getDocumentScroll()
};
goog.dom.getDocumentScroll = function() {
  return goog.dom.getDocumentScroll_(document)
};
goog.dom.getDocumentScroll_ = function(doc) {
  var el = goog.dom.getDocumentScrollElement_(doc);
  var win = goog.dom.getWindow_(doc);
  return new goog.math.Coordinate(win.pageXOffset || el.scrollLeft, win.pageYOffset || el.scrollTop)
};
goog.dom.getDocumentScrollElement = function() {
  return goog.dom.getDocumentScrollElement_(document)
};
goog.dom.getDocumentScrollElement_ = function(doc) {
  return!goog.userAgent.WEBKIT && goog.dom.isCss1CompatMode_(doc) ? doc.documentElement : doc.body
};
goog.dom.getWindow = function(opt_doc) {
  return opt_doc ? goog.dom.getWindow_(opt_doc) : window
};
goog.dom.getWindow_ = function(doc) {
  return doc.parentWindow || doc.defaultView
};
goog.dom.createDom = function(tagName, opt_attributes, var_args) {
  return goog.dom.createDom_(document, arguments)
};
goog.dom.createDom_ = function(doc, args) {
  var tagName = args[0];
  var attributes = args[1];
  if(!goog.dom.BrowserFeature.CAN_ADD_NAME_OR_TYPE_ATTRIBUTES && attributes && (attributes.name || attributes.type)) {
    var tagNameArr = ["<", tagName];
    if(attributes.name) {
      tagNameArr.push(' name="', goog.string.htmlEscape(attributes.name), '"')
    }
    if(attributes.type) {
      tagNameArr.push(' type="', goog.string.htmlEscape(attributes.type), '"');
      var clone = {};
      goog.object.extend(clone, attributes);
      attributes = clone;
      delete attributes.type
    }
    tagNameArr.push(">");
    tagName = tagNameArr.join("")
  }
  var element = doc.createElement(tagName);
  if(attributes) {
    if(goog.isString(attributes)) {
      element.className = attributes
    }else {
      if(goog.isArray(attributes)) {
        goog.dom.classes.add.apply(null, [element].concat(attributes))
      }else {
        goog.dom.setProperties(element, attributes)
      }
    }
  }
  if(args.length > 2) {
    goog.dom.append_(doc, element, args, 2)
  }
  return element
};
goog.dom.append_ = function(doc, parent, args, startIndex) {
  function childHandler(child) {
    if(child) {
      parent.appendChild(goog.isString(child) ? doc.createTextNode(child) : child)
    }
  }
  for(var i = startIndex;i < args.length;i++) {
    var arg = args[i];
    if(goog.isArrayLike(arg) && !goog.dom.isNodeLike(arg)) {
      goog.array.forEach(goog.dom.isNodeList(arg) ? goog.array.clone(arg) : arg, childHandler)
    }else {
      childHandler(arg)
    }
  }
};
goog.dom.$dom = goog.dom.createDom;
goog.dom.createElement = function(name) {
  return document.createElement(name)
};
goog.dom.createTextNode = function(content) {
  return document.createTextNode(content)
};
goog.dom.createTable = function(rows, columns, opt_fillWithNbsp) {
  return goog.dom.createTable_(document, rows, columns, !!opt_fillWithNbsp)
};
goog.dom.createTable_ = function(doc, rows, columns, fillWithNbsp) {
  var rowHtml = ["<tr>"];
  for(var i = 0;i < columns;i++) {
    rowHtml.push(fillWithNbsp ? "<td>&nbsp;</td>" : "<td></td>")
  }
  rowHtml.push("</tr>");
  rowHtml = rowHtml.join("");
  var totalHtml = ["<table>"];
  for(i = 0;i < rows;i++) {
    totalHtml.push(rowHtml)
  }
  totalHtml.push("</table>");
  var elem = doc.createElement(goog.dom.TagName.DIV);
  elem.innerHTML = totalHtml.join("");
  return elem.removeChild(elem.firstChild)
};
goog.dom.htmlToDocumentFragment = function(htmlString) {
  return goog.dom.htmlToDocumentFragment_(document, htmlString)
};
goog.dom.htmlToDocumentFragment_ = function(doc, htmlString) {
  var tempDiv = doc.createElement("div");
  if(goog.dom.BrowserFeature.INNER_HTML_NEEDS_SCOPED_ELEMENT) {
    tempDiv.innerHTML = "<br>" + htmlString;
    tempDiv.removeChild(tempDiv.firstChild)
  }else {
    tempDiv.innerHTML = htmlString
  }
  if(tempDiv.childNodes.length == 1) {
    return tempDiv.removeChild(tempDiv.firstChild)
  }else {
    var fragment = doc.createDocumentFragment();
    while(tempDiv.firstChild) {
      fragment.appendChild(tempDiv.firstChild)
    }
    return fragment
  }
};
goog.dom.getCompatMode = function() {
  return goog.dom.isCss1CompatMode() ? "CSS1Compat" : "BackCompat"
};
goog.dom.isCss1CompatMode = function() {
  return goog.dom.isCss1CompatMode_(document)
};
goog.dom.isCss1CompatMode_ = function(doc) {
  if(goog.dom.COMPAT_MODE_KNOWN_) {
    return goog.dom.ASSUME_STANDARDS_MODE
  }
  return doc.compatMode == "CSS1Compat"
};
goog.dom.canHaveChildren = function(node) {
  if(node.nodeType != goog.dom.NodeType.ELEMENT) {
    return false
  }
  switch(node.tagName) {
    case goog.dom.TagName.APPLET:
    ;
    case goog.dom.TagName.AREA:
    ;
    case goog.dom.TagName.BASE:
    ;
    case goog.dom.TagName.BR:
    ;
    case goog.dom.TagName.COL:
    ;
    case goog.dom.TagName.FRAME:
    ;
    case goog.dom.TagName.HR:
    ;
    case goog.dom.TagName.IMG:
    ;
    case goog.dom.TagName.INPUT:
    ;
    case goog.dom.TagName.IFRAME:
    ;
    case goog.dom.TagName.ISINDEX:
    ;
    case goog.dom.TagName.LINK:
    ;
    case goog.dom.TagName.NOFRAMES:
    ;
    case goog.dom.TagName.NOSCRIPT:
    ;
    case goog.dom.TagName.META:
    ;
    case goog.dom.TagName.OBJECT:
    ;
    case goog.dom.TagName.PARAM:
    ;
    case goog.dom.TagName.SCRIPT:
    ;
    case goog.dom.TagName.STYLE:
      return false
  }
  return true
};
goog.dom.appendChild = function(parent, child) {
  parent.appendChild(child)
};
goog.dom.append = function(parent, var_args) {
  goog.dom.append_(goog.dom.getOwnerDocument(parent), parent, arguments, 1)
};
goog.dom.removeChildren = function(node) {
  var child;
  while(child = node.firstChild) {
    node.removeChild(child)
  }
};
goog.dom.insertSiblingBefore = function(newNode, refNode) {
  if(refNode.parentNode) {
    refNode.parentNode.insertBefore(newNode, refNode)
  }
};
goog.dom.insertSiblingAfter = function(newNode, refNode) {
  if(refNode.parentNode) {
    refNode.parentNode.insertBefore(newNode, refNode.nextSibling)
  }
};
goog.dom.insertChildAt = function(parent, child, index) {
  parent.insertBefore(child, parent.childNodes[index] || null)
};
goog.dom.removeNode = function(node) {
  return node && node.parentNode ? node.parentNode.removeChild(node) : null
};
goog.dom.replaceNode = function(newNode, oldNode) {
  var parent = oldNode.parentNode;
  if(parent) {
    parent.replaceChild(newNode, oldNode)
  }
};
goog.dom.flattenElement = function(element) {
  var child, parent = element.parentNode;
  if(parent && parent.nodeType != goog.dom.NodeType.DOCUMENT_FRAGMENT) {
    if(element.removeNode) {
      return element.removeNode(false)
    }else {
      while(child = element.firstChild) {
        parent.insertBefore(child, element)
      }
      return goog.dom.removeNode(element)
    }
  }
};
goog.dom.getChildren = function(element) {
  if(goog.dom.BrowserFeature.CAN_USE_CHILDREN_ATTRIBUTE && element.children != undefined) {
    return element.children
  }
  return goog.array.filter(element.childNodes, function(node) {
    return node.nodeType == goog.dom.NodeType.ELEMENT
  })
};
goog.dom.getFirstElementChild = function(node) {
  if(node.firstElementChild != undefined) {
    return node.firstElementChild
  }
  return goog.dom.getNextElementNode_(node.firstChild, true)
};
goog.dom.getLastElementChild = function(node) {
  if(node.lastElementChild != undefined) {
    return node.lastElementChild
  }
  return goog.dom.getNextElementNode_(node.lastChild, false)
};
goog.dom.getNextElementSibling = function(node) {
  if(node.nextElementSibling != undefined) {
    return node.nextElementSibling
  }
  return goog.dom.getNextElementNode_(node.nextSibling, true)
};
goog.dom.getPreviousElementSibling = function(node) {
  if(node.previousElementSibling != undefined) {
    return node.previousElementSibling
  }
  return goog.dom.getNextElementNode_(node.previousSibling, false)
};
goog.dom.getNextElementNode_ = function(node, forward) {
  while(node && node.nodeType != goog.dom.NodeType.ELEMENT) {
    node = forward ? node.nextSibling : node.previousSibling
  }
  return node
};
goog.dom.getNextNode = function(node) {
  if(!node) {
    return null
  }
  if(node.firstChild) {
    return node.firstChild
  }
  while(node && !node.nextSibling) {
    node = node.parentNode
  }
  return node ? node.nextSibling : null
};
goog.dom.getPreviousNode = function(node) {
  if(!node) {
    return null
  }
  if(!node.previousSibling) {
    return node.parentNode
  }
  node = node.previousSibling;
  while(node && node.lastChild) {
    node = node.lastChild
  }
  return node
};
goog.dom.isNodeLike = function(obj) {
  return goog.isObject(obj) && obj.nodeType > 0
};
goog.dom.isWindow = function(obj) {
  return goog.isObject(obj) && obj["window"] == obj
};
goog.dom.contains = function(parent, descendant) {
  if(parent.contains && descendant.nodeType == goog.dom.NodeType.ELEMENT) {
    return parent == descendant || parent.contains(descendant)
  }
  if(typeof parent.compareDocumentPosition != "undefined") {
    return parent == descendant || Boolean(parent.compareDocumentPosition(descendant) & 16)
  }
  while(descendant && parent != descendant) {
    descendant = descendant.parentNode
  }
  return descendant == parent
};
goog.dom.compareNodeOrder = function(node1, node2) {
  if(node1 == node2) {
    return 0
  }
  if(node1.compareDocumentPosition) {
    return node1.compareDocumentPosition(node2) & 2 ? 1 : -1
  }
  if("sourceIndex" in node1 || node1.parentNode && "sourceIndex" in node1.parentNode) {
    var isElement1 = node1.nodeType == goog.dom.NodeType.ELEMENT;
    var isElement2 = node2.nodeType == goog.dom.NodeType.ELEMENT;
    if(isElement1 && isElement2) {
      return node1.sourceIndex - node2.sourceIndex
    }else {
      var parent1 = node1.parentNode;
      var parent2 = node2.parentNode;
      if(parent1 == parent2) {
        return goog.dom.compareSiblingOrder_(node1, node2)
      }
      if(!isElement1 && goog.dom.contains(parent1, node2)) {
        return-1 * goog.dom.compareParentsDescendantNodeIe_(node1, node2)
      }
      if(!isElement2 && goog.dom.contains(parent2, node1)) {
        return goog.dom.compareParentsDescendantNodeIe_(node2, node1)
      }
      return(isElement1 ? node1.sourceIndex : parent1.sourceIndex) - (isElement2 ? node2.sourceIndex : parent2.sourceIndex)
    }
  }
  var doc = goog.dom.getOwnerDocument(node1);
  var range1, range2;
  range1 = doc.createRange();
  range1.selectNode(node1);
  range1.collapse(true);
  range2 = doc.createRange();
  range2.selectNode(node2);
  range2.collapse(true);
  return range1.compareBoundaryPoints(goog.global["Range"].START_TO_END, range2)
};
goog.dom.compareParentsDescendantNodeIe_ = function(textNode, node) {
  var parent = textNode.parentNode;
  if(parent == node) {
    return-1
  }
  var sibling = node;
  while(sibling.parentNode != parent) {
    sibling = sibling.parentNode
  }
  return goog.dom.compareSiblingOrder_(sibling, textNode)
};
goog.dom.compareSiblingOrder_ = function(node1, node2) {
  var s = node2;
  while(s = s.previousSibling) {
    if(s == node1) {
      return-1
    }
  }
  return 1
};
goog.dom.findCommonAncestor = function(var_args) {
  var i, count = arguments.length;
  if(!count) {
    return null
  }else {
    if(count == 1) {
      return arguments[0]
    }
  }
  var paths = [];
  var minLength = Infinity;
  for(i = 0;i < count;i++) {
    var ancestors = [];
    var node = arguments[i];
    while(node) {
      ancestors.unshift(node);
      node = node.parentNode
    }
    paths.push(ancestors);
    minLength = Math.min(minLength, ancestors.length)
  }
  var output = null;
  for(i = 0;i < minLength;i++) {
    var first = paths[0][i];
    for(var j = 1;j < count;j++) {
      if(first != paths[j][i]) {
        return output
      }
    }
    output = first
  }
  return output
};
goog.dom.getOwnerDocument = function(node) {
  return node.nodeType == goog.dom.NodeType.DOCUMENT ? node : node.ownerDocument || node.document
};
goog.dom.getFrameContentDocument = function(frame) {
  var doc;
  if(goog.userAgent.WEBKIT) {
    doc = frame.document || frame.contentWindow.document
  }else {
    doc = frame.contentDocument || frame.contentWindow.document
  }
  return doc
};
goog.dom.getFrameContentWindow = function(frame) {
  return frame.contentWindow || goog.dom.getWindow_(goog.dom.getFrameContentDocument(frame))
};
goog.dom.setTextContent = function(element, text) {
  if("textContent" in element) {
    element.textContent = text
  }else {
    if(element.firstChild && element.firstChild.nodeType == goog.dom.NodeType.TEXT) {
      while(element.lastChild != element.firstChild) {
        element.removeChild(element.lastChild)
      }
      element.firstChild.data = text
    }else {
      goog.dom.removeChildren(element);
      var doc = goog.dom.getOwnerDocument(element);
      element.appendChild(doc.createTextNode(text))
    }
  }
};
goog.dom.getOuterHtml = function(element) {
  if("outerHTML" in element) {
    return element.outerHTML
  }else {
    var doc = goog.dom.getOwnerDocument(element);
    var div = doc.createElement("div");
    div.appendChild(element.cloneNode(true));
    return div.innerHTML
  }
};
goog.dom.findNode = function(root, p) {
  var rv = [];
  var found = goog.dom.findNodes_(root, p, rv, true);
  return found ? rv[0] : undefined
};
goog.dom.findNodes = function(root, p) {
  var rv = [];
  goog.dom.findNodes_(root, p, rv, false);
  return rv
};
goog.dom.findNodes_ = function(root, p, rv, findOne) {
  if(root != null) {
    for(var i = 0, child;child = root.childNodes[i];i++) {
      if(p(child)) {
        rv.push(child);
        if(findOne) {
          return true
        }
      }
      if(goog.dom.findNodes_(child, p, rv, findOne)) {
        return true
      }
    }
  }
  return false
};
goog.dom.TAGS_TO_IGNORE_ = {"SCRIPT":1, "STYLE":1, "HEAD":1, "IFRAME":1, "OBJECT":1};
goog.dom.PREDEFINED_TAG_VALUES_ = {"IMG":" ", "BR":"\n"};
goog.dom.isFocusableTabIndex = function(element) {
  var attrNode = element.getAttributeNode("tabindex");
  if(attrNode && attrNode.specified) {
    var index = element.tabIndex;
    return goog.isNumber(index) && index >= 0
  }
  return false
};
goog.dom.setFocusableTabIndex = function(element, enable) {
  if(enable) {
    element.tabIndex = 0
  }else {
    element.removeAttribute("tabIndex")
  }
};
goog.dom.getTextContent = function(node) {
  var textContent;
  if(goog.dom.BrowserFeature.CAN_USE_INNER_TEXT && "innerText" in node) {
    textContent = goog.string.canonicalizeNewlines(node.innerText)
  }else {
    var buf = [];
    goog.dom.getTextContent_(node, buf, true);
    textContent = buf.join("")
  }
  textContent = textContent.replace(/ \xAD /g, " ").replace(/\xAD/g, "");
  textContent = textContent.replace(/\u200B/g, "");
  if(!goog.userAgent.IE) {
    textContent = textContent.replace(/ +/g, " ")
  }
  if(textContent != " ") {
    textContent = textContent.replace(/^\s*/, "")
  }
  return textContent
};
goog.dom.getRawTextContent = function(node) {
  var buf = [];
  goog.dom.getTextContent_(node, buf, false);
  return buf.join("")
};
goog.dom.getTextContent_ = function(node, buf, normalizeWhitespace) {
  if(node.nodeName in goog.dom.TAGS_TO_IGNORE_) {
  }else {
    if(node.nodeType == goog.dom.NodeType.TEXT) {
      if(normalizeWhitespace) {
        buf.push(String(node.nodeValue).replace(/(\r\n|\r|\n)/g, ""))
      }else {
        buf.push(node.nodeValue)
      }
    }else {
      if(node.nodeName in goog.dom.PREDEFINED_TAG_VALUES_) {
        buf.push(goog.dom.PREDEFINED_TAG_VALUES_[node.nodeName])
      }else {
        var child = node.firstChild;
        while(child) {
          goog.dom.getTextContent_(child, buf, normalizeWhitespace);
          child = child.nextSibling
        }
      }
    }
  }
};
goog.dom.getNodeTextLength = function(node) {
  return goog.dom.getTextContent(node).length
};
goog.dom.getNodeTextOffset = function(node, opt_offsetParent) {
  var root = opt_offsetParent || goog.dom.getOwnerDocument(node).body;
  var buf = [];
  while(node && node != root) {
    var cur = node;
    while(cur = cur.previousSibling) {
      buf.unshift(goog.dom.getTextContent(cur))
    }
    node = node.parentNode
  }
  return goog.string.trimLeft(buf.join("")).replace(/ +/g, " ").length
};
goog.dom.getNodeAtOffset = function(parent, offset, opt_result) {
  var stack = [parent], pos = 0, cur;
  while(stack.length > 0 && pos < offset) {
    cur = stack.pop();
    if(cur.nodeName in goog.dom.TAGS_TO_IGNORE_) {
    }else {
      if(cur.nodeType == goog.dom.NodeType.TEXT) {
        var text = cur.nodeValue.replace(/(\r\n|\r|\n)/g, "").replace(/ +/g, " ");
        pos += text.length
      }else {
        if(cur.nodeName in goog.dom.PREDEFINED_TAG_VALUES_) {
          pos += goog.dom.PREDEFINED_TAG_VALUES_[cur.nodeName].length
        }else {
          for(var i = cur.childNodes.length - 1;i >= 0;i--) {
            stack.push(cur.childNodes[i])
          }
        }
      }
    }
  }
  if(goog.isObject(opt_result)) {
    opt_result.remainder = cur ? cur.nodeValue.length + offset - pos - 1 : 0;
    opt_result.node = cur
  }
  return cur
};
goog.dom.isNodeList = function(val) {
  if(val && typeof val.length == "number") {
    if(goog.isObject(val)) {
      return typeof val.item == "function" || typeof val.item == "string"
    }else {
      if(goog.isFunction(val)) {
        return typeof val.item == "function"
      }
    }
  }
  return false
};
goog.dom.getAncestorByTagNameAndClass = function(element, opt_tag, opt_class) {
  var tagName = opt_tag ? opt_tag.toUpperCase() : null;
  return goog.dom.getAncestor(element, function(node) {
    return(!tagName || node.nodeName == tagName) && (!opt_class || goog.dom.classes.has(node, opt_class))
  }, true)
};
goog.dom.getAncestorByClass = function(element, opt_class) {
  return goog.dom.getAncestorByTagNameAndClass(element, null, opt_class)
};
goog.dom.getAncestor = function(element, matcher, opt_includeNode, opt_maxSearchSteps) {
  if(!opt_includeNode) {
    element = element.parentNode
  }
  var ignoreSearchSteps = opt_maxSearchSteps == null;
  var steps = 0;
  while(element && (ignoreSearchSteps || steps <= opt_maxSearchSteps)) {
    if(matcher(element)) {
      return element
    }
    element = element.parentNode;
    steps++
  }
  return null
};
goog.dom.DomHelper = function(opt_document) {
  this.document_ = opt_document || goog.global.document || document
};
goog.dom.DomHelper.prototype.getDomHelper = goog.dom.getDomHelper;
goog.dom.DomHelper.prototype.setDocument = function(document) {
  this.document_ = document
};
goog.dom.DomHelper.prototype.getDocument = function() {
  return this.document_
};
goog.dom.DomHelper.prototype.getElement = function(element) {
  if(goog.isString(element)) {
    return this.document_.getElementById(element)
  }else {
    return element
  }
};
goog.dom.DomHelper.prototype.$ = goog.dom.DomHelper.prototype.getElement;
goog.dom.DomHelper.prototype.getElementsByTagNameAndClass = function(opt_tag, opt_class, opt_el) {
  return goog.dom.getElementsByTagNameAndClass_(this.document_, opt_tag, opt_class, opt_el)
};
goog.dom.DomHelper.prototype.getElementsByClass = function(className, opt_el) {
  var doc = opt_el || this.document_;
  return goog.dom.getElementsByClass(className, doc)
};
goog.dom.DomHelper.prototype.getElementByClass = function(className, opt_el) {
  var doc = opt_el || this.document_;
  return goog.dom.getElementByClass(className, doc)
};
goog.dom.DomHelper.prototype.$$ = goog.dom.DomHelper.prototype.getElementsByTagNameAndClass;
goog.dom.DomHelper.prototype.setProperties = goog.dom.setProperties;
goog.dom.DomHelper.prototype.getViewportSize = function(opt_window) {
  return goog.dom.getViewportSize(opt_window || this.getWindow())
};
goog.dom.DomHelper.prototype.getDocumentHeight = function() {
  return goog.dom.getDocumentHeight_(this.getWindow())
};
goog.dom.Appendable;
goog.dom.DomHelper.prototype.createDom = function(tagName, opt_attributes, var_args) {
  return goog.dom.createDom_(this.document_, arguments)
};
goog.dom.DomHelper.prototype.$dom = goog.dom.DomHelper.prototype.createDom;
goog.dom.DomHelper.prototype.createElement = function(name) {
  return this.document_.createElement(name)
};
goog.dom.DomHelper.prototype.createTextNode = function(content) {
  return this.document_.createTextNode(content)
};
goog.dom.DomHelper.prototype.createTable = function(rows, columns, opt_fillWithNbsp) {
  return goog.dom.createTable_(this.document_, rows, columns, !!opt_fillWithNbsp)
};
goog.dom.DomHelper.prototype.htmlToDocumentFragment = function(htmlString) {
  return goog.dom.htmlToDocumentFragment_(this.document_, htmlString)
};
goog.dom.DomHelper.prototype.getCompatMode = function() {
  return this.isCss1CompatMode() ? "CSS1Compat" : "BackCompat"
};
goog.dom.DomHelper.prototype.isCss1CompatMode = function() {
  return goog.dom.isCss1CompatMode_(this.document_)
};
goog.dom.DomHelper.prototype.getWindow = function() {
  return goog.dom.getWindow_(this.document_)
};
goog.dom.DomHelper.prototype.getDocumentScrollElement = function() {
  return goog.dom.getDocumentScrollElement_(this.document_)
};
goog.dom.DomHelper.prototype.getDocumentScroll = function() {
  return goog.dom.getDocumentScroll_(this.document_)
};
goog.dom.DomHelper.prototype.appendChild = goog.dom.appendChild;
goog.dom.DomHelper.prototype.append = goog.dom.append;
goog.dom.DomHelper.prototype.removeChildren = goog.dom.removeChildren;
goog.dom.DomHelper.prototype.insertSiblingBefore = goog.dom.insertSiblingBefore;
goog.dom.DomHelper.prototype.insertSiblingAfter = goog.dom.insertSiblingAfter;
goog.dom.DomHelper.prototype.removeNode = goog.dom.removeNode;
goog.dom.DomHelper.prototype.replaceNode = goog.dom.replaceNode;
goog.dom.DomHelper.prototype.flattenElement = goog.dom.flattenElement;
goog.dom.DomHelper.prototype.getFirstElementChild = goog.dom.getFirstElementChild;
goog.dom.DomHelper.prototype.getLastElementChild = goog.dom.getLastElementChild;
goog.dom.DomHelper.prototype.getNextElementSibling = goog.dom.getNextElementSibling;
goog.dom.DomHelper.prototype.getPreviousElementSibling = goog.dom.getPreviousElementSibling;
goog.dom.DomHelper.prototype.getNextNode = goog.dom.getNextNode;
goog.dom.DomHelper.prototype.getPreviousNode = goog.dom.getPreviousNode;
goog.dom.DomHelper.prototype.isNodeLike = goog.dom.isNodeLike;
goog.dom.DomHelper.prototype.contains = goog.dom.contains;
goog.dom.DomHelper.prototype.getOwnerDocument = goog.dom.getOwnerDocument;
goog.dom.DomHelper.prototype.getFrameContentDocument = goog.dom.getFrameContentDocument;
goog.dom.DomHelper.prototype.getFrameContentWindow = goog.dom.getFrameContentWindow;
goog.dom.DomHelper.prototype.setTextContent = goog.dom.setTextContent;
goog.dom.DomHelper.prototype.findNode = goog.dom.findNode;
goog.dom.DomHelper.prototype.findNodes = goog.dom.findNodes;
goog.dom.DomHelper.prototype.getTextContent = goog.dom.getTextContent;
goog.dom.DomHelper.prototype.getNodeTextLength = goog.dom.getNodeTextLength;
goog.dom.DomHelper.prototype.getNodeTextOffset = goog.dom.getNodeTextOffset;
goog.dom.DomHelper.prototype.getAncestorByTagNameAndClass = goog.dom.getAncestorByTagNameAndClass;
goog.dom.DomHelper.prototype.getAncestor = goog.dom.getAncestor;
goog.provide("goog.string.format");
goog.require("goog.string");
goog.string.format = function(formatString, var_args) {
  var args = Array.prototype.slice.call(arguments);
  var template = args.shift();
  if(typeof template == "undefined") {
    throw Error("[goog.string.format] Template required");
  }
  var formatRe = /%([0\-\ \+]*)(\d+)?(\.(\d+))?([%sfdiu])/g;
  function replacerDemuxer(match, flags, width, dotp, precision, type, offset, wholeString) {
    if(type == "%") {
      return"%"
    }
    var value = args.shift();
    if(typeof value == "undefined") {
      throw Error("[goog.string.format] Not enough arguments");
    }
    arguments[0] = value;
    return goog.string.format.demuxes_[type].apply(null, arguments)
  }
  return template.replace(formatRe, replacerDemuxer)
};
goog.string.format.demuxes_ = {};
goog.string.format.demuxes_["s"] = function(value, flags, width, dotp, precision, type, offset, wholeString) {
  var replacement = value;
  if(isNaN(width) || replacement.length >= width) {
    return replacement
  }
  if(flags.indexOf("-", 0) > -1) {
    replacement = replacement + goog.string.repeat(" ", width - replacement.length)
  }else {
    replacement = goog.string.repeat(" ", width - replacement.length) + replacement
  }
  return replacement
};
goog.string.format.demuxes_["f"] = function(value, flags, width, dotp, precision, type, offset, wholeString) {
  var replacement = value.toString();
  if(!(isNaN(precision) || precision == "")) {
    replacement = value.toFixed(precision)
  }
  var sign;
  if(value < 0) {
    sign = "-"
  }else {
    if(flags.indexOf("+") >= 0) {
      sign = "+"
    }else {
      if(flags.indexOf(" ") >= 0) {
        sign = " "
      }else {
        sign = ""
      }
    }
  }
  if(value >= 0) {
    replacement = sign + replacement
  }
  if(isNaN(width) || replacement.length >= width) {
    return replacement
  }
  replacement = isNaN(precision) ? Math.abs(value).toString() : Math.abs(value).toFixed(precision);
  var padCount = width - replacement.length - sign.length;
  if(flags.indexOf("-", 0) >= 0) {
    replacement = sign + replacement + goog.string.repeat(" ", padCount)
  }else {
    var paddingChar = flags.indexOf("0", 0) >= 0 ? "0" : " ";
    replacement = sign + goog.string.repeat(paddingChar, padCount) + replacement
  }
  return replacement
};
goog.string.format.demuxes_["d"] = function(value, flags, width, dotp, precision, type, offset, wholeString) {
  value = parseInt(value, 10);
  precision = 0;
  return goog.string.format.demuxes_["f"](value, flags, width, dotp, precision, type, offset, wholeString)
};
goog.string.format.demuxes_["i"] = goog.string.format.demuxes_["d"];
goog.string.format.demuxes_["u"] = goog.string.format.demuxes_["d"];
goog.provide("showoff.showoff");
goog.require("cljs.core");
goog.require("goog.dom");
goog.require("goog.string");
goog.require("goog.string.format");
showoff.showoff.Tickable = {};
showoff.showoff.tick = function tick(obj) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1605589 = obj;
    if(cljs.core.truth_(and__3546__auto____1605589)) {
      return obj.showoff$showoff$Tickable$tick
    }else {
      return and__3546__auto____1605589
    }
  }())) {
    return obj.showoff$showoff$Tickable$tick(obj)
  }else {
    return function() {
      var or__3548__auto____1605590 = showoff.showoff.tick[goog.typeOf.call(null, obj)];
      if(cljs.core.truth_(or__3548__auto____1605590)) {
        return or__3548__auto____1605590
      }else {
        var or__3548__auto____1605591 = showoff.showoff.tick["_"];
        if(cljs.core.truth_(or__3548__auto____1605591)) {
          return or__3548__auto____1605591
        }else {
          throw cljs.core.missing_protocol.call(null, "Tickable.tick", obj);
        }
      }
    }().call(null, obj)
  }
};
showoff.showoff.Rectable = {};
showoff.showoff.to_rect = function to_rect(obj) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1605592 = obj;
    if(cljs.core.truth_(and__3546__auto____1605592)) {
      return obj.showoff$showoff$Rectable$to_rect
    }else {
      return and__3546__auto____1605592
    }
  }())) {
    return obj.showoff$showoff$Rectable$to_rect(obj)
  }else {
    return function() {
      var or__3548__auto____1605593 = showoff.showoff.to_rect[goog.typeOf.call(null, obj)];
      if(cljs.core.truth_(or__3548__auto____1605593)) {
        return or__3548__auto____1605593
      }else {
        var or__3548__auto____1605594 = showoff.showoff.to_rect["_"];
        if(cljs.core.truth_(or__3548__auto____1605594)) {
          return or__3548__auto____1605594
        }else {
          throw cljs.core.missing_protocol.call(null, "Rectable.to-rect", obj);
        }
      }
    }().call(null, obj)
  }
};
showoff.showoff.Drawable = {};
showoff.showoff.draw = function draw(obj, ctx) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1605595 = obj;
    if(cljs.core.truth_(and__3546__auto____1605595)) {
      return obj.showoff$showoff$Drawable$draw
    }else {
      return and__3546__auto____1605595
    }
  }())) {
    return obj.showoff$showoff$Drawable$draw(obj, ctx)
  }else {
    return function() {
      var or__3548__auto____1605596 = showoff.showoff.draw[goog.typeOf.call(null, obj)];
      if(cljs.core.truth_(or__3548__auto____1605596)) {
        return or__3548__auto____1605596
      }else {
        var or__3548__auto____1605597 = showoff.showoff.draw["_"];
        if(cljs.core.truth_(or__3548__auto____1605597)) {
          return or__3548__auto____1605597
        }else {
          throw cljs.core.missing_protocol.call(null, "Drawable.draw", obj);
        }
      }
    }().call(null, obj, ctx)
  }
};
showoff.showoff.Tickable["_"] = true;
showoff.showoff.tick["_"] = function(_) {
  return null
};
showoff.showoff.Drawable["_"] = true;
showoff.showoff.draw["_"] = function(_1605598, _) {
  return false
};
showoff.showoff._PLUS_ticks_per_ms_PLUS_ = 35 / 1E3;
showoff.showoff._PLUS_secs_per_tick_PLUS_ = 1 / (showoff.showoff._PLUS_ticks_per_ms_PLUS_ * 1E3);
showoff.showoff._STAR_display_STAR_ = null;
showoff.showoff._STAR_viewport_function_STAR_ = null;
showoff.showoff._STAR_world_dims_STAR_ = cljs.core.PersistentVector.fromArray([640, 480]);
showoff.showoff._STAR_tile_in_world_dims_STAR_ = cljs.core.PersistentVector.fromArray([640 / 16, 480 / 12]);
showoff.showoff._STAR_tile_dims_STAR_ = cljs.core.PersistentVector.fromArray([16, 16]);
showoff.showoff._STAR_default_color_STAR_ = cljs.core.PersistentVector.fromArray([255, 0, 255]);
showoff.showoff._STAR_entities_STAR_ = cljs.core.atom.call(null, cljs.core.set([]));
showoff.showoff.make_canvas = function make_canvas(p__1605599) {
  var vec__1605600__1605601 = p__1605599;
  var w__1605602 = cljs.core.nth.call(null, vec__1605600__1605601, 0, null);
  var h__1605603 = cljs.core.nth.call(null, vec__1605600__1605601, 1, null);
  var canvas__1605604 = goog.dom.createDom.call(null, "canvas");
  canvas__1605604.width = w__1605602;
  canvas__1605604.height = h__1605603;
  return canvas__1605604
};
showoff.showoff.viewport_rect = function viewport_rect() {
  return showoff.showoff._STAR_viewport_function_STAR_.call(null)
};
showoff.showoff.set_display_and_viewport = function set_display_and_viewport(display, display_size, viewport_function) {
  showoff.showoff._STAR_display_STAR_ = display;
  showoff.showoff._STAR_viewport_function_STAR_ = viewport_function;
  showoff.showoff._STAR_world_dims_STAR_ = display_size;
  var vec__1605605__1605607 = showoff.showoff.viewport_rect.call(null);
  var ___1605608 = cljs.core.nth.call(null, vec__1605605__1605607, 0, null);
  var ___1605609 = cljs.core.nth.call(null, vec__1605605__1605607, 1, null);
  var vw__1605610 = cljs.core.nth.call(null, vec__1605605__1605607, 2, null);
  var vh__1605611 = cljs.core.nth.call(null, vec__1605605__1605607, 3, null);
  var vec__1605606__1605612 = display_size;
  var sw__1605613 = cljs.core.nth.call(null, vec__1605606__1605612, 0, null);
  var sh__1605614 = cljs.core.nth.call(null, vec__1605606__1605612, 1, null);
  return showoff.showoff._STAR_tile_in_world_dims_STAR_ = cljs.core.PersistentVector.fromArray([sw__1605613 / vw__1605610, sh__1605614 / vh__1605611])
};
showoff.showoff.display = function display() {
  return showoff.showoff._STAR_display_STAR_
};
showoff.showoff.transform = function transform(p__1605615) {
  var vec__1605616__1605617 = p__1605615;
  var x__1605618 = cljs.core.nth.call(null, vec__1605616__1605617, 0, null);
  var y__1605619 = cljs.core.nth.call(null, vec__1605616__1605617, 1, null);
  var w__1605620 = cljs.core.nth.call(null, vec__1605616__1605617, 2, null);
  var h__1605621 = cljs.core.nth.call(null, vec__1605616__1605617, 3, null);
  var vec__1605622__1605625 = showoff.showoff.viewport_rect.call(null);
  var vx__1605626 = cljs.core.nth.call(null, vec__1605622__1605625, 0, null);
  var vy__1605627 = cljs.core.nth.call(null, vec__1605622__1605625, 1, null);
  var vw__1605628 = cljs.core.nth.call(null, vec__1605622__1605625, 2, null);
  var vh__1605629 = cljs.core.nth.call(null, vec__1605622__1605625, 3, null);
  var vec__1605623__1605630 = showoff.showoff._STAR_world_dims_STAR_;
  var sw__1605631 = cljs.core.nth.call(null, vec__1605623__1605630, 0, null);
  var sh__1605632 = cljs.core.nth.call(null, vec__1605623__1605630, 1, null);
  var vec__1605624__1605633 = showoff.showoff._STAR_tile_in_world_dims_STAR_;
  var twpx__1605634 = cljs.core.nth.call(null, vec__1605624__1605633, 0, null);
  var thpx__1605635 = cljs.core.nth.call(null, vec__1605624__1605633, 1, null);
  return cljs.core.PersistentVector.fromArray([Math.floor.call(null, (x__1605618 - vx__1605626) * twpx__1605634), Math.floor.call(null, (y__1605619 - vy__1605627) * thpx__1605635), Math.floor.call(null, w__1605620 * twpx__1605634), Math.floor.call(null, h__1605621 * thpx__1605635)])
};
showoff.showoff.with_transform = function with_transform(ctx, viewport, callback) {
  ctx.save();
  var vec__1605636__1605638 = viewport;
  var vx__1605639 = cljs.core.nth.call(null, vec__1605636__1605638, 0, null);
  var vy__1605640 = cljs.core.nth.call(null, vec__1605636__1605638, 1, null);
  var vec__1605637__1605641 = showoff.showoff._STAR_tile_in_world_dims_STAR_;
  var tw__1605642 = cljs.core.nth.call(null, vec__1605637__1605641, 0, null);
  var th__1605643 = cljs.core.nth.call(null, vec__1605637__1605641, 1, null);
  ctx.scale(tw__1605642, th__1605643);
  ctx.translate(-vx__1605639, -vy__1605640);
  callback.call(null);
  return ctx.restore()
};
showoff.showoff.context = function() {
  var context = null;
  var context__1605645 = function() {
    return context.call(null, showoff.showoff._STAR_display_STAR_)
  };
  var context__1605646 = function(canvas) {
    var ctx__1605644 = canvas.getContext("2d");
    ctx__1605644.imageSmoothingEnabled = false;
    return ctx__1605644
  };
  context = function(canvas) {
    switch(arguments.length) {
      case 0:
        return context__1605645.call(this);
      case 1:
        return context__1605646.call(this, canvas)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return context
}();
showoff.showoff.clear = function() {
  var clear = null;
  var clear__1605651 = function() {
    return clear.call(null, showoff.showoff._STAR_display_STAR_)
  };
  var clear__1605652 = function(canvas) {
    var w__1605648 = canvas.width;
    var h__1605649 = canvas.height;
    var ctx__1605650 = showoff.showoff.context.call(null, canvas);
    return ctx__1605650.clearRect(0, 0, w__1605648, h__1605649)
  };
  clear = function(canvas) {
    switch(arguments.length) {
      case 0:
        return clear__1605651.call(this);
      case 1:
        return clear__1605652.call(this, canvas)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return clear
}();
showoff.showoff.format = goog.string.format;
showoff.showoff.color = function() {
  var color = null;
  var color__1605666 = function(p__1605654) {
    var vec__1605656__1605657 = p__1605654;
    var r__1605658 = cljs.core.nth.call(null, vec__1605656__1605657, 0, null);
    var g__1605659 = cljs.core.nth.call(null, vec__1605656__1605657, 1, null);
    var b__1605660 = cljs.core.nth.call(null, vec__1605656__1605657, 2, null);
    return cljs.core.str.call(null, "rgb(", r__1605658, ",", g__1605659, ",", b__1605660, ")")
  };
  var color__1605667 = function(p__1605655, a) {
    var vec__1605661__1605662 = p__1605655;
    var r__1605663 = cljs.core.nth.call(null, vec__1605661__1605662, 0, null);
    var g__1605664 = cljs.core.nth.call(null, vec__1605661__1605662, 1, null);
    var b__1605665 = cljs.core.nth.call(null, vec__1605661__1605662, 2, null);
    return cljs.core.str.call(null, "rgba(", r__1605663, ",", g__1605664, ",", b__1605665, ",", a, ")")
  };
  color = function(p__1605655, a) {
    switch(arguments.length) {
      case 1:
        return color__1605666.call(this, p__1605655);
      case 2:
        return color__1605667.call(this, p__1605655, a)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return color
}();
showoff.showoff.fill_style = function fill_style(ctx, color) {
  return ctx.fillStyle = color
};
showoff.showoff.filled_rect = function filled_rect(ctx, p__1605669, p__1605670, color) {
  var vec__1605671__1605673 = p__1605669;
  var x__1605674 = cljs.core.nth.call(null, vec__1605671__1605673, 0, null);
  var y__1605675 = cljs.core.nth.call(null, vec__1605671__1605673, 1, null);
  var vec__1605672__1605676 = p__1605670;
  var w__1605677 = cljs.core.nth.call(null, vec__1605672__1605676, 0, null);
  var h__1605678 = cljs.core.nth.call(null, vec__1605672__1605676, 1, null);
  var vec__1605679__1605680 = showoff.showoff.transform.call(null, cljs.core.PersistentVector.fromArray([x__1605674, y__1605675, w__1605677, h__1605678]));
  var tx__1605681 = cljs.core.nth.call(null, vec__1605679__1605680, 0, null);
  var ty__1605682 = cljs.core.nth.call(null, vec__1605679__1605680, 1, null);
  var tw__1605683 = cljs.core.nth.call(null, vec__1605679__1605680, 2, null);
  var th__1605684 = cljs.core.nth.call(null, vec__1605679__1605680, 3, null);
  ctx.fillStyle = color;
  return ctx.fillRect(tx__1605681, ty__1605682, tw__1605683, th__1605684)
};
showoff.showoff.img_dims = function img_dims(img) {
  return cljs.core.PersistentVector.fromArray([img.width, img.height])
};
showoff.showoff.draw_sprite = function draw_sprite(ctx, img, p__1605685) {
  var vec__1605686__1605687 = p__1605685;
  var x__1605688 = cljs.core.nth.call(null, vec__1605686__1605687, 0, null);
  var y__1605689 = cljs.core.nth.call(null, vec__1605686__1605687, 1, null);
  var vec__1605690__1605692 = showoff.showoff.transform.call(null, cljs.core.PersistentVector.fromArray([x__1605688, y__1605689, 1, 1]));
  var tx__1605693 = cljs.core.nth.call(null, vec__1605690__1605692, 0, null);
  var ty__1605694 = cljs.core.nth.call(null, vec__1605690__1605692, 1, null);
  var vec__1605691__1605695 = showoff.showoff.img_dims.call(null, img);
  var sw__1605696 = cljs.core.nth.call(null, vec__1605691__1605695, 0, null);
  var sh__1605697 = cljs.core.nth.call(null, vec__1605691__1605695, 1, null);
  return ctx.drawImage(img, Math.floor.call(null, tx__1605693), Math.floor.call(null, ty__1605694))
};
showoff.showoff.get_img = function get_img(url) {
  var img__1605698 = new Image;
  img__1605698.src = url;
  return img__1605698
};
showoff.showoff.with_img = function with_img(url, callback) {
  var img__1605699 = showoff.showoff.get_img.call(null, url);
  img__1605699.onload = function() {
    return callback.call(null, img__1605699)
  };
  return img__1605699
};
showoff.showoff.img__GT_canvas = function img__GT_canvas(img) {
  var vec__1605700__1605701 = showoff.showoff.img_dims.call(null, img);
  var w__1605702 = cljs.core.nth.call(null, vec__1605700__1605701, 0, null);
  var h__1605703 = cljs.core.nth.call(null, vec__1605700__1605701, 1, null);
  var canvas__1605704 = showoff.showoff.make_canvas.call(null, cljs.core.PersistentVector.fromArray([w__1605702, h__1605703]));
  showoff.showoff.context.call(null, canvas__1605704).drawImage(img, 0, 0);
  return canvas__1605704
};
showoff.showoff.get_context_image_data = function get_context_image_data(ctx, p__1605705) {
  var vec__1605706__1605707 = p__1605705;
  var w__1605708 = cljs.core.nth.call(null, vec__1605706__1605707, 0, null);
  var h__1605709 = cljs.core.nth.call(null, vec__1605706__1605707, 1, null);
  return ctx.getImageData(0, 0, w__1605708, h__1605709)
};
showoff.showoff.get_canvas_data = function get_canvas_data(canvas) {
  return showoff.showoff.get_context_image_data.call(null, showoff.showoff.context.call(null, canvas), showoff.showoff.img_dims.call(null, canvas)).data
};
showoff.showoff.get_pixel_data = function get_pixel_data(img) {
  var canvas__1605711 = showoff.showoff.img__GT_canvas.call(null, img);
  var vec__1605710__1605712 = showoff.showoff.img_dims.call(null, img);
  var w__1605713 = cljs.core.nth.call(null, vec__1605710__1605712, 0, null);
  var h__1605714 = cljs.core.nth.call(null, vec__1605710__1605712, 1, null);
  return cljs.core.ObjMap.fromObject(["\ufdd0'data", "\ufdd0'dims"], {"\ufdd0'data":showoff.showoff.get_canvas_data.call(null, canvas__1605711), "\ufdd0'dims":cljs.core.PersistentVector.fromArray([w__1605713, h__1605714])})
};
showoff.showoff.get_pixel_idx = function get_pixel_idx(pdata, idx) {
  var data__1605715 = "\ufdd0'data".call(null, pdata);
  var r__1605716 = data__1605715[idx];
  var g__1605717 = data__1605715[idx + 1];
  var b__1605718 = data__1605715[idx + 2];
  return cljs.core.PersistentVector.fromArray([r__1605716, g__1605717, b__1605718])
};
showoff.showoff.get_pixel = function get_pixel(pdata, x, y) {
  var vec__1605719__1605720 = "\ufdd0'dims".call(null, pdata);
  var w__1605721 = cljs.core.nth.call(null, vec__1605719__1605720, 0, null);
  var h__1605722 = cljs.core.nth.call(null, vec__1605719__1605720, 1, null);
  var idx__1605723 = x * 4 + w__1605721 * y * 4;
  if(cljs.core.truth_(function() {
    var and__3546__auto____1605724 = x >= 0;
    if(cljs.core.truth_(and__3546__auto____1605724)) {
      var and__3546__auto____1605725 = y >= 0;
      if(cljs.core.truth_(and__3546__auto____1605725)) {
        var and__3546__auto____1605726 = x < w__1605721;
        if(cljs.core.truth_(and__3546__auto____1605726)) {
          return y < h__1605722
        }else {
          return and__3546__auto____1605726
        }
      }else {
        return and__3546__auto____1605725
      }
    }else {
      return and__3546__auto____1605724
    }
  }())) {
    return showoff.showoff.get_pixel_idx.call(null, pdata, idx__1605723)
  }else {
    return showoff.showoff._STAR_default_color_STAR_
  }
};
showoff.showoff.get_pixel_alpha = function get_pixel_alpha(pdata, x, y) {
  var vec__1605727__1605728 = "\ufdd0'dims".call(null, pdata);
  var w__1605729 = cljs.core.nth.call(null, vec__1605727__1605728, 0, null);
  var h__1605730 = cljs.core.nth.call(null, vec__1605727__1605728, 1, null);
  var data__1605731 = "\ufdd0'data".call(null, pdata);
  var idx__1605732 = x * 4 + w__1605729 * y * 4;
  return data__1605731[idx__1605732 + 3]
};
showoff.showoff.resize_nearest_neighbor = function() {
  var resize_nearest_neighbor = null;
  var resize_nearest_neighbor__1605767 = function(pdata, dest_dims) {
    var vec__1605733__1605734 = "\ufdd0'dims".call(null, pdata);
    var w__1605735 = cljs.core.nth.call(null, vec__1605733__1605734, 0, null);
    var h__1605736 = cljs.core.nth.call(null, vec__1605733__1605734, 1, null);
    return resize_nearest_neighbor.call(null, pdata, cljs.core.PersistentVector.fromArray([0, 0, w__1605735, h__1605736]), dest_dims)
  };
  var resize_nearest_neighbor__1605768 = function(pdata, src_rect, dest_dims) {
    var vec__1605737__1605740 = src_rect;
    var sx__1605741 = cljs.core.nth.call(null, vec__1605737__1605740, 0, null);
    var sy__1605742 = cljs.core.nth.call(null, vec__1605737__1605740, 1, null);
    var sw__1605743 = cljs.core.nth.call(null, vec__1605737__1605740, 2, null);
    var sh__1605744 = cljs.core.nth.call(null, vec__1605737__1605740, 3, null);
    var vec__1605738__1605745 = dest_dims;
    var nw__1605746 = cljs.core.nth.call(null, vec__1605738__1605745, 0, null);
    var nh__1605747 = cljs.core.nth.call(null, vec__1605738__1605745, 1, null);
    var rw__1605748 = nw__1605746 / sw__1605743;
    var rh__1605749 = nh__1605747 / sh__1605744;
    var dest_pixel_count__1605750 = nw__1605746 * nh__1605747;
    var canvas__1605751 = showoff.showoff.make_canvas.call(null, dest_dims);
    var ctx__1605752 = showoff.showoff.context.call(null, canvas__1605751);
    var src_data__1605753 = "\ufdd0'data".call(null, pdata);
    var vec__1605739__1605754 = "\ufdd0'dims".call(null, pdata);
    var sfw__1605755 = cljs.core.nth.call(null, vec__1605739__1605754, 0, null);
    var ___1605756 = cljs.core.nth.call(null, vec__1605739__1605754, 1, null);
    var dest_image_data__1605757 = showoff.showoff.get_context_image_data.call(null, ctx__1605752, dest_dims);
    var dest_data__1605758 = dest_image_data__1605757.data;
    var n__575__auto____1605759 = dest_pixel_count__1605750;
    var idx__1605760 = 0;
    while(true) {
      if(cljs.core.truth_(idx__1605760 < n__575__auto____1605759)) {
        var x__1605761 = idx__1605760 % nw__1605746;
        var y__1605762 = Math.floor.call(null, idx__1605760 / nw__1605746);
        var sxx__1605763 = sx__1605741 + Math.floor.call(null, x__1605761 / rw__1605748);
        var syy__1605764 = sy__1605742 + Math.floor.call(null, y__1605762 / rh__1605749);
        var dest_base__1605765 = idx__1605760 * 4;
        var src_base__1605766 = 4 * (sxx__1605763 + syy__1605764 * sfw__1605755);
        dest_data__1605758[dest_base__1605765] = src_data__1605753[src_base__1605766];
        dest_data__1605758[1 + dest_base__1605765] = src_data__1605753[1 + src_base__1605766];
        dest_data__1605758[2 + dest_base__1605765] = src_data__1605753[2 + src_base__1605766];
        dest_data__1605758[3 + dest_base__1605765] = src_data__1605753[3 + src_base__1605766];
        var G__1605770 = idx__1605760 + 1;
        idx__1605760 = G__1605770;
        continue
      }else {
      }
      break
    }
    ctx__1605752.putImageData(dest_image_data__1605757, 0, 0);
    return canvas__1605751
  };
  resize_nearest_neighbor = function(pdata, src_rect, dest_dims) {
    switch(arguments.length) {
      case 2:
        return resize_nearest_neighbor__1605767.call(this, pdata, src_rect);
      case 3:
        return resize_nearest_neighbor__1605768.call(this, pdata, src_rect, dest_dims)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return resize_nearest_neighbor
}();
showoff.showoff.extract_char_images = function extract_char_images(img, char_dims, num_chars, scale, color) {
  var vec__1605771__1605773 = showoff.showoff.img_dims.call(null, img);
  var iw__1605774 = cljs.core.nth.call(null, vec__1605771__1605773, 0, null);
  var ih__1605775 = cljs.core.nth.call(null, vec__1605771__1605773, 1, null);
  var vec__1605772__1605776 = char_dims;
  var cw__1605777 = cljs.core.nth.call(null, vec__1605772__1605776, 0, null);
  var ch__1605778 = cljs.core.nth.call(null, vec__1605772__1605776, 1, null);
  var pixels_per_char__1605779 = cw__1605777 * ch__1605778;
  var fw__1605780 = cw__1605777 * scale;
  var fh__1605781 = ch__1605778 * scale;
  var chars_in_row__1605782 = iw__1605774 / cw__1605777;
  var pdata__1605783 = showoff.showoff.get_pixel_data.call(null, img);
  var iter__520__auto____1605801 = function iter__1605784(s__1605785) {
    return new cljs.core.LazySeq(null, false, function() {
      var s__1605785__1605786 = s__1605785;
      while(true) {
        if(cljs.core.truth_(cljs.core.seq.call(null, s__1605785__1605786))) {
          var idx__1605787 = cljs.core.first.call(null, s__1605785__1605786);
          return cljs.core.cons.call(null, function() {
            var oy__1605788 = ch__1605778 * Math.floor.call(null, idx__1605787 / chars_in_row__1605782);
            var ox__1605789 = cw__1605777 * (idx__1605787 % chars_in_row__1605782);
            var out__1605790 = showoff.showoff.make_canvas.call(null, cljs.core.PersistentVector.fromArray([fw__1605780, fh__1605781]));
            var ctx__1605791 = showoff.showoff.context.call(null, out__1605790);
            var G__1605792__1605793 = cljs.core.seq.call(null, cljs.core.range.call(null, pixels_per_char__1605779));
            if(cljs.core.truth_(G__1605792__1605793)) {
              var pxidx__1605794 = cljs.core.first.call(null, G__1605792__1605793);
              var G__1605792__1605795 = G__1605792__1605793;
              while(true) {
                var chy__1605796 = Math.floor.call(null, pxidx__1605794 / cw__1605777);
                var chx__1605797 = pxidx__1605794 % cw__1605777;
                var pix__1605798 = showoff.showoff.get_pixel.call(null, pdata__1605783, ox__1605789 + chx__1605797, oy__1605788 + chy__1605796);
                if(cljs.core.truth_(cljs.core._EQ_.call(null, pix__1605798, cljs.core.PersistentVector.fromArray([0, 0, 0])))) {
                  ctx__1605791.fillStyle = color;
                  ctx__1605791.fillRect(chx__1605797 * scale, chy__1605796 * scale, scale, scale)
                }else {
                }
                var temp__3698__auto____1605799 = cljs.core.next.call(null, G__1605792__1605795);
                if(cljs.core.truth_(temp__3698__auto____1605799)) {
                  var G__1605792__1605800 = temp__3698__auto____1605799;
                  var G__1605802 = cljs.core.first.call(null, G__1605792__1605800);
                  var G__1605803 = G__1605792__1605800;
                  pxidx__1605794 = G__1605802;
                  G__1605792__1605795 = G__1605803;
                  continue
                }else {
                }
                break
              }
            }else {
            }
            return out__1605790
          }(), iter__1605784.call(null, cljs.core.rest.call(null, s__1605785__1605786)))
        }else {
          return null
        }
        break
      }
    })
  };
  return iter__520__auto____1605801.call(null, cljs.core.range.call(null, num_chars))
};
showoff.showoff.load_font = function load_font(img, characters, char_dims, scale, color) {
  var characters__1605805 = characters.toUpperCase();
  var vec__1605804__1605806 = char_dims;
  var cw__1605807 = cljs.core.nth.call(null, vec__1605804__1605806, 0, null);
  var ch__1605808 = cljs.core.nth.call(null, vec__1605804__1605806, 1, null);
  var images__1605809 = showoff.showoff.extract_char_images.call(null, img, char_dims, cljs.core.count.call(null, characters__1605805), scale, color);
  var font__1605810 = cljs.core.zipmap.call(null, characters__1605805, images__1605809);
  var font__1605811 = cljs.core.conj.call(null, font__1605810, cljs.core.ObjMap.fromObject(["\ufdd0'dims"], {"\ufdd0'dims":cljs.core.PersistentVector.fromArray([cw__1605807 * scale, ch__1605808 * scale])}));
  return font__1605811
};
showoff.showoff.with_loaded_font = function with_loaded_font(path, characters, char_dims, scale, color, callback) {
  return showoff.showoff.with_img.call(null, path, function(img) {
    return callback.call(null, showoff.showoff.load_font.call(null, img, characters, char_dims, scale, color))
  })
};
showoff.showoff.draw_text = function draw_text(ctx, font, chrs, pos) {
  var chrs__1605814 = chrs.toUpperCase();
  var vec__1605812__1605815 = pos;
  var ox__1605816 = cljs.core.nth.call(null, vec__1605812__1605815, 0, null);
  var oy__1605817 = cljs.core.nth.call(null, vec__1605812__1605815, 1, null);
  var vec__1605813__1605819 = function() {
    var or__3548__auto____1605818 = "\ufdd0'dims".call(null, font);
    if(cljs.core.truth_(or__3548__auto____1605818)) {
      return or__3548__auto____1605818
    }else {
      return cljs.core.PersistentVector.fromArray([16, 16])
    }
  }();
  var cw__1605820 = cljs.core.nth.call(null, vec__1605813__1605819, 0, null);
  var ch__1605821 = cljs.core.nth.call(null, vec__1605813__1605819, 1, null);
  var n__575__auto____1605822 = cljs.core.count.call(null, chrs__1605814);
  var idx__1605823 = 0;
  while(true) {
    if(cljs.core.truth_(idx__1605823 < n__575__auto____1605822)) {
      var ch__1605824 = cljs.core.nth.call(null, chrs__1605814, idx__1605823);
      var img__1605825 = font.call(null, ch__1605824);
      if(cljs.core.truth_(img__1605825)) {
        ctx.drawImage(img__1605825, ox__1605816 + cw__1605820 * idx__1605823, oy__1605817)
      }else {
        ctx.fillStyle = showoff.showoff.color.call(null, showoff.showoff._STAR_default_color_STAR_);
        ctx.fillRect(ox__1605816 + cw__1605820 * idx__1605823, oy__1605817, cw__1605820, ch__1605824)
      }
      var G__1605826 = idx__1605823 + 1;
      idx__1605823 = G__1605826;
      continue
    }else {
      return null
    }
    break
  }
};
showoff.showoff.draw_text_centered = function draw_text_centered(ctx, font, chrs, pos) {
  var vec__1605827__1605830 = function() {
    var or__3548__auto____1605829 = "\ufdd0'doms".call(null, font);
    if(cljs.core.truth_(or__3548__auto____1605829)) {
      return or__3548__auto____1605829
    }else {
      return cljs.core.PersistentVector.fromArray([16, 16])
    }
  }();
  var cw__1605831 = cljs.core.nth.call(null, vec__1605827__1605830, 0, null);
  var ch__1605832 = cljs.core.nth.call(null, vec__1605827__1605830, 1, null);
  var width__1605833 = cw__1605831 * cljs.core.count.call(null, chrs);
  var vec__1605828__1605834 = pos;
  var px__1605835 = cljs.core.nth.call(null, vec__1605828__1605834, 0, null);
  var py__1605836 = cljs.core.nth.call(null, vec__1605828__1605834, 1, null);
  var x__1605837 = px__1605835 - width__1605833 / 2;
  var y__1605838 = py__1605836 - ch__1605832 / 2;
  return showoff.showoff.draw_text.call(null, ctx, font, chrs, cljs.core.PersistentVector.fromArray([x__1605837, y__1605838]))
};
showoff.showoff._STAR_alerted_symbols_STAR_ = cljs.core.atom.call(null, cljs.core.set([]));
showoff.showoff.load_map = function load_map(img, map_symbols) {
  var vec__1605839__1605840 = showoff.showoff.img_dims.call(null, img);
  var w__1605841 = cljs.core.nth.call(null, vec__1605839__1605840, 0, null);
  var h__1605842 = cljs.core.nth.call(null, vec__1605839__1605840, 1, null);
  var dims__1605843 = cljs.core.PersistentVector.fromArray([w__1605841, h__1605842]);
  var pdata__1605844 = showoff.showoff.get_pixel_data.call(null, img);
  var data__1605852 = cljs.core.into.call(null, cljs.core.PersistentVector.fromArray([]), function() {
    var iter__520__auto____1605851 = function iter__1605845(s__1605846) {
      return new cljs.core.LazySeq(null, false, function() {
        var s__1605846__1605847 = s__1605846;
        while(true) {
          if(cljs.core.truth_(cljs.core.seq.call(null, s__1605846__1605847))) {
            var idx__1605848 = cljs.core.first.call(null, s__1605846__1605847);
            return cljs.core.cons.call(null, function() {
              var pix__1605849 = showoff.showoff.get_pixel_idx.call(null, pdata__1605844, 4 * idx__1605848);
              var sym__1605850 = map_symbols.call(null, pix__1605849);
              if(cljs.core.truth_(sym__1605850)) {
                return cljs.core.conj.call(null, sym__1605850, cljs.core.ObjMap.fromObject(["\ufdd0'objects", "\ufdd0'coords"], {"\ufdd0'objects":cljs.core.atom.call(null, cljs.core.set([])), "\ufdd0'coords":showoff.showoff.idx__GT_coords.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'dims"], {"\ufdd0'dims":dims__1605843}), idx__1605848)}))
              }else {
                if(cljs.core.truth_(cljs.core.not.call(null, cljs.core.deref.call(null, showoff.showoff._STAR_alerted_symbols_STAR_).call(null, pix__1605849)))) {
                  cljs.core.swap_BANG_.call(null, showoff.showoff._STAR_alerted_symbols_STAR_, cljs.core.conj, pix__1605849);
                  return alert.call(null, showoff.showoff.format.call(null, "couldn't find map symbol %s", cljs.core.pr_str.call(null, pix__1605849)))
                }else {
                  return null
                }
              }
            }(), iter__1605845.call(null, cljs.core.rest.call(null, s__1605846__1605847)))
          }else {
            return null
          }
          break
        }
      })
    };
    return iter__520__auto____1605851.call(null, cljs.core.range.call(null, w__1605841 * h__1605842))
  }());
  return cljs.core.ObjMap.fromObject(["\ufdd0'dims", "\ufdd0'data"], {"\ufdd0'dims":dims__1605843, "\ufdd0'data":cljs.core.apply.call(null, cljs.core.array, data__1605852)})
};
showoff.showoff.get_map_idx = function get_map_idx(map, idx) {
  var data__1605853 = "\ufdd0'data".call(null, map);
  return data__1605853[idx]
};
showoff.showoff.set_map_idx = function set_map_idx(map, idx, newvalue) {
  return"\ufdd0'data".call(null, map)[idx] = cljs.core.merge.call(null, newvalue, cljs.core.ObjMap.fromObject(["\ufdd0'objects", "\ufdd0'coords"], {"\ufdd0'objects":cljs.core.atom.call(null, cljs.core.set([])), "\ufdd0'coords":showoff.showoff.idx__GT_coords.call(null, map, idx)}))
};
showoff.showoff.idx__GT_coords = function idx__GT_coords(map, idx) {
  var vec__1605854__1605855 = "\ufdd0'dims".call(null, map);
  var mw__1605856 = cljs.core.nth.call(null, vec__1605854__1605855, 0, null);
  var ___1605857 = cljs.core.nth.call(null, vec__1605854__1605855, 1, null);
  return cljs.core.PersistentVector.fromArray([idx % mw__1605856, Math.floor.call(null, idx / mw__1605856)])
};
showoff.showoff.coords__GT_idx = function coords__GT_idx(map, p__1605858) {
  var vec__1605859__1605860 = p__1605858;
  var x__1605861 = cljs.core.nth.call(null, vec__1605859__1605860, 0, null);
  var y__1605862 = cljs.core.nth.call(null, vec__1605859__1605860, 1, null);
  var vec__1605863__1605864 = "\ufdd0'dims".call(null, map);
  var mw__1605865 = cljs.core.nth.call(null, vec__1605863__1605864, 0, null);
  var ___1605866 = cljs.core.nth.call(null, vec__1605863__1605864, 1, null);
  return Math.floor.call(null, x__1605861) + Math.floor.call(null, y__1605862) * mw__1605865
};
showoff.showoff.draw_map = function draw_map(map) {
  var vec__1605867__1605870 = "\ufdd0'dims".call(null, map);
  var mw__1605871 = cljs.core.nth.call(null, vec__1605867__1605870, 0, null);
  var mh__1605872 = cljs.core.nth.call(null, vec__1605867__1605870, 1, null);
  var ctx__1605873 = showoff.showoff.context.call(null);
  var vec__1605868__1605874 = showoff.showoff.viewport_rect.call(null);
  var ox__1605875 = cljs.core.nth.call(null, vec__1605868__1605874, 0, null);
  var oy__1605876 = cljs.core.nth.call(null, vec__1605868__1605874, 1, null);
  var ow__1605877 = cljs.core.nth.call(null, vec__1605868__1605874, 2, null);
  var oh__1605878 = cljs.core.nth.call(null, vec__1605868__1605874, 3, null);
  var vec__1605869__1605879 = showoff.showoff._STAR_tile_in_world_dims_STAR_;
  var tw__1605880 = cljs.core.nth.call(null, vec__1605869__1605879, 0, null);
  var th__1605881 = cljs.core.nth.call(null, vec__1605869__1605879, 1, null);
  var otx__1605882 = Math.floor.call(null, ox__1605875);
  var oty__1605883 = Math.floor.call(null, oy__1605876);
  var offx__1605884 = otx__1605882 - ox__1605875;
  var offy__1605885 = oty__1605883 - oy__1605876;
  var rngx__1605886 = Math.ceil.call(null, ox__1605875 + ow__1605877) - Math.floor.call(null, ox__1605875);
  var rngy__1605887 = Math.ceil.call(null, oy__1605876 + oh__1605878) - Math.floor.call(null, oy__1605876);
  var num_idxs__1605888 = rngx__1605886 * rngy__1605887;
  var map_data__1605889 = "\ufdd0'data".call(null, map);
  var n__575__auto____1605890 = num_idxs__1605888;
  var ii__1605891 = 0;
  while(true) {
    if(cljs.core.truth_(ii__1605891 < n__575__auto____1605890)) {
      var viewrow__1605892 = Math.floor.call(null, ii__1605891 / rngx__1605886);
      var viewcol__1605893 = ii__1605891 % rngx__1605886;
      var maprow__1605894 = viewrow__1605892 + oty__1605883;
      var mapcol__1605895 = viewcol__1605893 + otx__1605882;
      var tx__1605896 = viewcol__1605893 + offx__1605884;
      var ty__1605897 = viewrow__1605892 + offy__1605885;
      var drawx__1605898 = tw__1605880 * tx__1605896;
      var drawy__1605899 = th__1605881 * ty__1605897;
      var mapidx__1605900 = mapcol__1605895 + maprow__1605894 * mw__1605871;
      if(cljs.core.truth_(function() {
        var and__3546__auto____1605901 = maprow__1605894 >= 0;
        if(cljs.core.truth_(and__3546__auto____1605901)) {
          var and__3546__auto____1605902 = mapcol__1605895 >= 0;
          if(cljs.core.truth_(and__3546__auto____1605902)) {
            var and__3546__auto____1605903 = maprow__1605894 < mh__1605872;
            if(cljs.core.truth_(and__3546__auto____1605903)) {
              var and__3546__auto____1605904 = mapcol__1605895 < mw__1605871;
              if(cljs.core.truth_(and__3546__auto____1605904)) {
                return cljs.core._EQ_.call(null, map_data__1605889[mapidx__1605900].call(null, "\ufdd0'kind"), "\ufdd0'image")
              }else {
                return and__3546__auto____1605904
              }
            }else {
              return and__3546__auto____1605903
            }
          }else {
            return and__3546__auto____1605902
          }
        }else {
          return and__3546__auto____1605901
        }
      }())) {
        ctx__1605873.drawImage(map_data__1605889[mapidx__1605900].call(null, "\ufdd0'image"), Math.floor.call(null, drawx__1605898), Math.floor.call(null, drawy__1605899))
      }else {
      }
      var G__1605905 = ii__1605891 + 1;
      ii__1605891 = G__1605905;
      continue
    }else {
      return null
    }
    break
  }
};
showoff.showoff.move_object = function move_object(map, obj, src_idxs, dest_idxs) {
  var G__1605906__1605907 = cljs.core.seq.call(null, src_idxs);
  if(cljs.core.truth_(G__1605906__1605907)) {
    var idx__1605908 = cljs.core.first.call(null, G__1605906__1605907);
    var G__1605906__1605909 = G__1605906__1605907;
    while(true) {
      var rec__1605910 = showoff.showoff.get_map_idx.call(null, map, idx__1605908);
      var objects__1605911 = "\ufdd0'objects".call(null, rec__1605910);
      cljs.core.reset_BANG_.call(null, objects__1605911, cljs.core.disj.call(null, cljs.core.deref.call(null, objects__1605911), obj));
      var temp__3698__auto____1605912 = cljs.core.next.call(null, G__1605906__1605909);
      if(cljs.core.truth_(temp__3698__auto____1605912)) {
        var G__1605906__1605913 = temp__3698__auto____1605912;
        var G__1605922 = cljs.core.first.call(null, G__1605906__1605913);
        var G__1605923 = G__1605906__1605913;
        idx__1605908 = G__1605922;
        G__1605906__1605909 = G__1605923;
        continue
      }else {
      }
      break
    }
  }else {
  }
  var G__1605914__1605915 = cljs.core.seq.call(null, dest_idxs);
  if(cljs.core.truth_(G__1605914__1605915)) {
    var idx__1605916 = cljs.core.first.call(null, G__1605914__1605915);
    var G__1605914__1605917 = G__1605914__1605915;
    while(true) {
      var rec__1605918 = showoff.showoff.get_map_idx.call(null, map, idx__1605916);
      var objects__1605919 = "\ufdd0'objects".call(null, rec__1605918);
      cljs.core.reset_BANG_.call(null, objects__1605919, cljs.core.conj.call(null, cljs.core.deref.call(null, objects__1605919), obj));
      var temp__3698__auto____1605920 = cljs.core.next.call(null, G__1605914__1605917);
      if(cljs.core.truth_(temp__3698__auto____1605920)) {
        var G__1605914__1605921 = temp__3698__auto____1605920;
        var G__1605924 = cljs.core.first.call(null, G__1605914__1605921);
        var G__1605925 = G__1605914__1605921;
        idx__1605916 = G__1605924;
        G__1605914__1605917 = G__1605925;
        continue
      }else {
        return null
      }
      break
    }
  }else {
    return null
  }
};
showoff.showoff.vec_add = function vec_add(p__1605926, p__1605927) {
  var vec__1605928__1605930 = p__1605926;
  var ax__1605931 = cljs.core.nth.call(null, vec__1605928__1605930, 0, null);
  var ay__1605932 = cljs.core.nth.call(null, vec__1605928__1605930, 1, null);
  var vec__1605929__1605933 = p__1605927;
  var bx__1605934 = cljs.core.nth.call(null, vec__1605929__1605933, 0, null);
  var by__1605935 = cljs.core.nth.call(null, vec__1605929__1605933, 1, null);
  return cljs.core.PersistentVector.fromArray([ax__1605931 + bx__1605934, ay__1605932 + by__1605935])
};
showoff.showoff.vec_sub = function vec_sub(p__1605936, p__1605937) {
  var vec__1605938__1605940 = p__1605936;
  var ax__1605941 = cljs.core.nth.call(null, vec__1605938__1605940, 0, null);
  var ay__1605942 = cljs.core.nth.call(null, vec__1605938__1605940, 1, null);
  var vec__1605939__1605943 = p__1605937;
  var bx__1605944 = cljs.core.nth.call(null, vec__1605939__1605943, 0, null);
  var by__1605945 = cljs.core.nth.call(null, vec__1605939__1605943, 1, null);
  return cljs.core.PersistentVector.fromArray([ax__1605941 - bx__1605944, ay__1605942 - by__1605945])
};
showoff.showoff.vec_mag = function vec_mag(p__1605946) {
  var vec__1605947__1605948 = p__1605946;
  var ax__1605949 = cljs.core.nth.call(null, vec__1605947__1605948, 0, null);
  var ay__1605950 = cljs.core.nth.call(null, vec__1605947__1605948, 1, null);
  return Math.sqrt.call(null, ax__1605949 * ax__1605949 + ay__1605950 * ay__1605950)
};
showoff.showoff.vec_scale = function vec_scale(p__1605951, scale) {
  var vec__1605952__1605953 = p__1605951;
  var ax__1605954 = cljs.core.nth.call(null, vec__1605952__1605953, 0, null);
  var ay__1605955 = cljs.core.nth.call(null, vec__1605952__1605953, 1, null);
  return cljs.core.PersistentVector.fromArray([ax__1605954 * scale, ay__1605955 * scale])
};
showoff.showoff.vec_unit = function vec_unit(v) {
  var mag__1605956 = showoff.showoff.vec_mag.call(null, v);
  if(cljs.core.truth_(mag__1605956 > 0)) {
    return showoff.showoff.vec_scale.call(null, v, 1 / showoff.showoff.vec_mag.call(null, v))
  }else {
    return cljs.core.PersistentVector.fromArray([0, 0])
  }
};
showoff.showoff.vec_negate = function vec_negate(p__1605957) {
  var vec__1605958__1605959 = p__1605957;
  var ax__1605960 = cljs.core.nth.call(null, vec__1605958__1605959, 0, null);
  var ay__1605961 = cljs.core.nth.call(null, vec__1605958__1605959, 1, null);
  return cljs.core.PersistentVector.fromArray([-ax__1605960, -ay__1605961])
};
showoff.showoff.vec_dot = function vec_dot(p__1605962, p__1605963) {
  var vec__1605964__1605966 = p__1605962;
  var ax__1605967 = cljs.core.nth.call(null, vec__1605964__1605966, 0, null);
  var ay__1605968 = cljs.core.nth.call(null, vec__1605964__1605966, 1, null);
  var vec__1605965__1605969 = p__1605963;
  var bx__1605970 = cljs.core.nth.call(null, vec__1605965__1605969, 0, null);
  var by__1605971 = cljs.core.nth.call(null, vec__1605965__1605969, 1, null);
  return ax__1605967 * bx__1605970 + ay__1605968 * by__1605971
};
showoff.showoff.rect_center = function rect_center(rect) {
  var vec__1605972__1605973 = rect;
  var vx__1605974 = cljs.core.nth.call(null, vec__1605972__1605973, 0, null);
  var vy__1605975 = cljs.core.nth.call(null, vec__1605972__1605973, 1, null);
  var vw__1605976 = cljs.core.nth.call(null, vec__1605972__1605973, 2, null);
  var vh__1605977 = cljs.core.nth.call(null, vec__1605972__1605973, 3, null);
  return showoff.showoff.vec_add.call(null, cljs.core.PersistentVector.fromArray([vx__1605974, vy__1605975]), showoff.showoff.vec_scale.call(null, cljs.core.PersistentVector.fromArray([vw__1605976, vh__1605977]), 0.5))
};
showoff.showoff.rect_minx = function rect_minx(p__1605978) {
  var vec__1605979__1605980 = p__1605978;
  var ax__1605981 = cljs.core.nth.call(null, vec__1605979__1605980, 0, null);
  var ___1605982 = cljs.core.nth.call(null, vec__1605979__1605980, 1, null);
  var ___1605983 = cljs.core.nth.call(null, vec__1605979__1605980, 2, null);
  var ___1605984 = cljs.core.nth.call(null, vec__1605979__1605980, 3, null);
  return ax__1605981
};
showoff.showoff.rect_maxx = function rect_maxx(p__1605985) {
  var vec__1605986__1605987 = p__1605985;
  var ax__1605988 = cljs.core.nth.call(null, vec__1605986__1605987, 0, null);
  var ___1605989 = cljs.core.nth.call(null, vec__1605986__1605987, 1, null);
  var aw__1605990 = cljs.core.nth.call(null, vec__1605986__1605987, 2, null);
  var ___1605991 = cljs.core.nth.call(null, vec__1605986__1605987, 3, null);
  return ax__1605988 + aw__1605990
};
showoff.showoff.rect_miny = function rect_miny(p__1605992) {
  var vec__1605993__1605994 = p__1605992;
  var ___1605995 = cljs.core.nth.call(null, vec__1605993__1605994, 0, null);
  var ay__1605996 = cljs.core.nth.call(null, vec__1605993__1605994, 1, null);
  var ___1605997 = cljs.core.nth.call(null, vec__1605993__1605994, 2, null);
  var ___1605998 = cljs.core.nth.call(null, vec__1605993__1605994, 3, null);
  return ay__1605996
};
showoff.showoff.rect_maxy = function rect_maxy(p__1605999) {
  var vec__1606000__1606001 = p__1605999;
  var ___1606002 = cljs.core.nth.call(null, vec__1606000__1606001, 0, null);
  var ay__1606003 = cljs.core.nth.call(null, vec__1606000__1606001, 1, null);
  var ___1606004 = cljs.core.nth.call(null, vec__1606000__1606001, 2, null);
  var ah__1606005 = cljs.core.nth.call(null, vec__1606000__1606001, 3, null);
  return ay__1606003 + ah__1606005
};
showoff.showoff.rect_minmax = function rect_minmax(p__1606006) {
  var vec__1606007__1606008 = p__1606006;
  var ax__1606009 = cljs.core.nth.call(null, vec__1606007__1606008, 0, null);
  var ay__1606010 = cljs.core.nth.call(null, vec__1606007__1606008, 1, null);
  var aw__1606011 = cljs.core.nth.call(null, vec__1606007__1606008, 2, null);
  var ah__1606012 = cljs.core.nth.call(null, vec__1606007__1606008, 3, null);
  return cljs.core.PersistentVector.fromArray([ax__1606009, ay__1606010, ax__1606009 + aw__1606011, ay__1606010 + ah__1606012])
};
showoff.showoff.rect_intersect = function rect_intersect(a, b) {
  var vec__1606013__1606015 = showoff.showoff.rect_minmax.call(null, a);
  var aminx__1606016 = cljs.core.nth.call(null, vec__1606013__1606015, 0, null);
  var aminy__1606017 = cljs.core.nth.call(null, vec__1606013__1606015, 1, null);
  var amaxx__1606018 = cljs.core.nth.call(null, vec__1606013__1606015, 2, null);
  var amaxy__1606019 = cljs.core.nth.call(null, vec__1606013__1606015, 3, null);
  var vec__1606014__1606020 = showoff.showoff.rect_minmax.call(null, b);
  var bminx__1606021 = cljs.core.nth.call(null, vec__1606014__1606020, 0, null);
  var bminy__1606022 = cljs.core.nth.call(null, vec__1606014__1606020, 1, null);
  var bmaxx__1606023 = cljs.core.nth.call(null, vec__1606014__1606020, 2, null);
  var bmaxy__1606024 = cljs.core.nth.call(null, vec__1606014__1606020, 3, null);
  return cljs.core.not.call(null, function() {
    var or__3548__auto____1606025 = amaxx__1606018 < bminx__1606021;
    if(cljs.core.truth_(or__3548__auto____1606025)) {
      return or__3548__auto____1606025
    }else {
      var or__3548__auto____1606026 = aminx__1606016 > bmaxx__1606023;
      if(cljs.core.truth_(or__3548__auto____1606026)) {
        return or__3548__auto____1606026
      }else {
        var or__3548__auto____1606027 = amaxy__1606019 < bminy__1606022;
        if(cljs.core.truth_(or__3548__auto____1606027)) {
          return or__3548__auto____1606027
        }else {
          return aminy__1606017 > bmaxy__1606024
        }
      }
    }
  }())
};
showoff.showoff.rect_offset = function rect_offset(p__1606028, p__1606029) {
  var vec__1606030__1606032 = p__1606028;
  var rx__1606033 = cljs.core.nth.call(null, vec__1606030__1606032, 0, null);
  var ry__1606034 = cljs.core.nth.call(null, vec__1606030__1606032, 1, null);
  var rw__1606035 = cljs.core.nth.call(null, vec__1606030__1606032, 2, null);
  var rh__1606036 = cljs.core.nth.call(null, vec__1606030__1606032, 3, null);
  var vec__1606031__1606037 = p__1606029;
  var ox__1606038 = cljs.core.nth.call(null, vec__1606031__1606037, 0, null);
  var oy__1606039 = cljs.core.nth.call(null, vec__1606031__1606037, 1, null);
  return cljs.core.PersistentVector.fromArray([rx__1606033 + ox__1606038, ry__1606034 + oy__1606039, rw__1606035, rh__1606036])
};
showoff.showoff.rect__GT_idxs_all = function rect__GT_idxs_all(map, rect) {
  var vec__1606040__1606042 = rect;
  var rx__1606043 = cljs.core.nth.call(null, vec__1606040__1606042, 0, null);
  var ry__1606044 = cljs.core.nth.call(null, vec__1606040__1606042, 1, null);
  var rw__1606045 = cljs.core.nth.call(null, vec__1606040__1606042, 2, null);
  var rh__1606046 = cljs.core.nth.call(null, vec__1606040__1606042, 3, null);
  var vec__1606041__1606047 = "\ufdd0'dims".call(null, map);
  var mw__1606048 = cljs.core.nth.call(null, vec__1606041__1606047, 0, null);
  var mh__1606049 = cljs.core.nth.call(null, vec__1606041__1606047, 1, null);
  var rngx__1606050 = Math.ceil.call(null, rw__1606045 + rx__1606043) - Math.floor.call(null, rx__1606043);
  var rngy__1606051 = Math.ceil.call(null, rh__1606046 + ry__1606044) - Math.floor.call(null, ry__1606044);
  var ox__1606052 = Math.floor.call(null, rx__1606043);
  var oy__1606053 = Math.floor.call(null, ry__1606044);
  var iter__520__auto____1606069 = function iter__1606054(s__1606055) {
    return new cljs.core.LazySeq(null, false, function() {
      var s__1606055__1606058 = s__1606055;
      while(true) {
        if(cljs.core.truth_(cljs.core.seq.call(null, s__1606055__1606058))) {
          var ix__1606059 = cljs.core.first.call(null, s__1606055__1606058);
          var iterys__518__auto____1606067 = function(s__1606055__1606058, ix__1606059) {
            return function iter__1606056(s__1606057) {
              return new cljs.core.LazySeq(null, false, function(s__1606055__1606058, ix__1606059) {
                return function() {
                  var s__1606057__1606060 = s__1606057;
                  while(true) {
                    if(cljs.core.truth_(cljs.core.seq.call(null, s__1606057__1606060))) {
                      var iy__1606061 = cljs.core.first.call(null, s__1606057__1606060);
                      return cljs.core.cons.call(null, function() {
                        var x__1606062 = ox__1606052 + ix__1606059;
                        var y__1606063 = oy__1606053 + iy__1606061;
                        if(cljs.core.truth_(function() {
                          var and__3546__auto____1606064 = x__1606062 >= 0;
                          if(cljs.core.truth_(and__3546__auto____1606064)) {
                            var and__3546__auto____1606065 = y__1606063 >= 0;
                            if(cljs.core.truth_(and__3546__auto____1606065)) {
                              var and__3546__auto____1606066 = x__1606062 < mw__1606048;
                              if(cljs.core.truth_(and__3546__auto____1606066)) {
                                return y__1606063 < mh__1606049
                              }else {
                                return and__3546__auto____1606066
                              }
                            }else {
                              return and__3546__auto____1606065
                            }
                          }else {
                            return and__3546__auto____1606064
                          }
                        }())) {
                          return x__1606062 + y__1606063 * mw__1606048
                        }else {
                          return null
                        }
                      }(), iter__1606056.call(null, cljs.core.rest.call(null, s__1606057__1606060)))
                    }else {
                      return null
                    }
                    break
                  }
                }
              }(s__1606055__1606058, ix__1606059))
            }
          }(s__1606055__1606058, ix__1606059);
          var fs__519__auto____1606068 = cljs.core.seq.call(null, iterys__518__auto____1606067.call(null, cljs.core.range.call(null, rngy__1606051)));
          if(cljs.core.truth_(fs__519__auto____1606068)) {
            return cljs.core.concat.call(null, fs__519__auto____1606068, iter__1606054.call(null, cljs.core.rest.call(null, s__1606055__1606058)))
          }else {
            var G__1606070 = cljs.core.rest.call(null, s__1606055__1606058);
            s__1606055__1606058 = G__1606070;
            continue
          }
        }else {
          return null
        }
        break
      }
    })
  };
  return iter__520__auto____1606069.call(null, cljs.core.range.call(null, rngx__1606050))
};
showoff.showoff.rect__GT_idxs = function rect__GT_idxs(map, rect) {
  return cljs.core.filter.call(null, function(idx) {
    return cljs.core.not.call(null, idx === null)
  }, showoff.showoff.rect__GT_idxs_all.call(null, map, rect))
};
showoff.showoff.idx__GT_rect = function idx__GT_rect(map, idx) {
  var vec__1606072__1606073 = "\ufdd0'dims".call(null, map);
  var mw__1606074 = cljs.core.nth.call(null, vec__1606072__1606073, 0, null);
  var ___1606075 = cljs.core.nth.call(null, vec__1606072__1606073, 1, null);
  return cljs.core.PersistentVector.fromArray([idx % mw__1606074, Math.floor.call(null, idx / mw__1606074), 1, 1])
};
showoff.showoff.record_vs_rect = function() {
  var method_table__585__auto____1606076 = cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {}));
  var prefer_table__586__auto____1606077 = cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {}));
  var method_cache__587__auto____1606078 = cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {}));
  var cached_hierarchy__588__auto____1606079 = cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {}));
  var hierarchy__589__auto____1606080 = cljs.core.get.call(null, cljs.core.ObjMap.fromObject([], {}), "\ufdd0'hierarchy", cljs.core.global_hierarchy);
  return new cljs.core.MultiFn("record-vs-rect", function(p1__1606071_SHARP_) {
    return"\ufdd0'shape".call(null, p1__1606071_SHARP_)
  }, "\ufdd0'default", hierarchy__589__auto____1606080, method_table__585__auto____1606076, prefer_table__586__auto____1606077, method_cache__587__auto____1606078, cached_hierarchy__588__auto____1606079)
}();
showoff.showoff.map_collisions = function map_collisions(map, rect) {
  return cljs.core.filter.call(null, function(res) {
    return cljs.core.not.call(null, res === null)
  }, function() {
    var iter__520__auto____1606087 = function iter__1606081(s__1606082) {
      return new cljs.core.LazySeq(null, false, function() {
        var s__1606082__1606083 = s__1606082;
        while(true) {
          if(cljs.core.truth_(cljs.core.seq.call(null, s__1606082__1606083))) {
            var idx__1606084 = cljs.core.first.call(null, s__1606082__1606083);
            return cljs.core.cons.call(null, function() {
              var rec__1606085 = showoff.showoff.get_map_idx.call(null, map, idx__1606084);
              if(cljs.core.truth_(cljs.core.not.call(null, "\ufdd0'collidable".call(null, rec__1606085)))) {
                return null
              }else {
                if(cljs.core.truth_(function() {
                  var and__3546__auto____1606086 = "\ufdd0'collidable".call(null, rec__1606085);
                  if(cljs.core.truth_(and__3546__auto____1606086)) {
                    return cljs.core._EQ_.call(null, "\ufdd0'shape".call(null, rec__1606085), "\ufdd0'rect")
                  }else {
                    return and__3546__auto____1606086
                  }
                }())) {
                  return idx__1606084
                }else {
                  if(cljs.core.truth_(cljs.core.not.call(null, showoff.showoff.record_vs_rect.call(null, rec__1606085, rect) === null))) {
                    return idx__1606084
                  }else {
                    if(cljs.core.truth_("\ufdd0'else")) {
                      return null
                    }else {
                      return null
                    }
                  }
                }
              }
            }(), iter__1606081.call(null, cljs.core.rest.call(null, s__1606082__1606083)))
          }else {
            return null
          }
          break
        }
      })
    };
    return iter__520__auto____1606087.call(null, showoff.showoff.rect__GT_idxs.call(null, map, rect))
  }())
};
showoff.showoff.rectrect_horizontal_overlap = function rectrect_horizontal_overlap(r1, r2) {
  var vec__1606088__1606090 = r1;
  var r1x__1606091 = cljs.core.nth.call(null, vec__1606088__1606090, 0, null);
  var ___1606092 = cljs.core.nth.call(null, vec__1606088__1606090, 1, null);
  var r1w__1606093 = cljs.core.nth.call(null, vec__1606088__1606090, 2, null);
  var ___1606094 = cljs.core.nth.call(null, vec__1606088__1606090, 3, null);
  var vec__1606089__1606095 = r2;
  var r2x__1606096 = cljs.core.nth.call(null, vec__1606089__1606095, 0, null);
  var ___1606097 = cljs.core.nth.call(null, vec__1606089__1606095, 1, null);
  var r2w__1606098 = cljs.core.nth.call(null, vec__1606089__1606095, 2, null);
  var ___1606099 = cljs.core.nth.call(null, vec__1606089__1606095, 3, null);
  return(r1x__1606091 + r1w__1606093 < r2x__1606096 + r2w__1606098 ? r1x__1606091 + r1w__1606093 : r2x__1606096 + r2w__1606098) - (r1x__1606091 > r2x__1606096 ? r1x__1606091 : r2x__1606096)
};
showoff.showoff.rectrect_vertical_overlap = function rectrect_vertical_overlap(r1, r2) {
  var vec__1606100__1606102 = r1;
  var ___1606103 = cljs.core.nth.call(null, vec__1606100__1606102, 0, null);
  var r1y__1606104 = cljs.core.nth.call(null, vec__1606100__1606102, 1, null);
  var ___1606105 = cljs.core.nth.call(null, vec__1606100__1606102, 2, null);
  var r1h__1606106 = cljs.core.nth.call(null, vec__1606100__1606102, 3, null);
  var vec__1606101__1606107 = r2;
  var ___1606108 = cljs.core.nth.call(null, vec__1606101__1606107, 0, null);
  var r2y__1606109 = cljs.core.nth.call(null, vec__1606101__1606107, 1, null);
  var ___1606110 = cljs.core.nth.call(null, vec__1606101__1606107, 2, null);
  var r2h__1606111 = cljs.core.nth.call(null, vec__1606101__1606107, 3, null);
  return(r1y__1606104 + r1h__1606106 < r2y__1606109 + r2h__1606111 ? r1y__1606104 + r1h__1606106 : r2y__1606109 + r2h__1606111) - (r1y__1606104 > r2y__1606109 ? r1y__1606104 : r2y__1606109)
};
showoff.showoff.rectrect_contact = function rectrect_contact(r1, r2) {
  var ho__1606112 = showoff.showoff.rectrect_horizontal_overlap.call(null, r1, r2);
  var vo__1606113 = showoff.showoff.rectrect_vertical_overlap.call(null, r1, r2);
  if(cljs.core.truth_(vo__1606113 > ho__1606112)) {
    if(cljs.core.truth_(showoff.showoff.rect_minx.call(null, r1) < showoff.showoff.rect_minx.call(null, r2))) {
      return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":cljs.core.PersistentVector.fromArray([-1, 0]), "\ufdd0'incursion":ho__1606112})
    }else {
      return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":cljs.core.PersistentVector.fromArray([1, 0]), "\ufdd0'incursion":ho__1606112})
    }
  }else {
    if(cljs.core.truth_(ho__1606112 > vo__1606113)) {
      if(cljs.core.truth_(showoff.showoff.rect_miny.call(null, r1) < showoff.showoff.rect_miny.call(null, r2))) {
        return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":cljs.core.PersistentVector.fromArray([0, -1]), "\ufdd0'incursion":vo__1606113})
      }else {
        return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":cljs.core.PersistentVector.fromArray([0, 1]), "\ufdd0'incursion":vo__1606113})
      }
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        if(cljs.core.truth_(showoff.showoff.rect_minx.call(null, r1) < showoff.showoff.rect_minx.call(null, r2))) {
          if(cljs.core.truth_(showoff.showoff.rect_miny.call(null, r1) < showoff.showoff.rect_maxy.call(null, r2))) {
            return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":showoff.showoff.vec_unit.call(null, cljs.core.PersistentVector.fromArray([-1, -1])), "\ufdd0'incursion":showoff.showoff.vec_mag.call(null, cljs.core.PersistentVector.fromArray([ho__1606112, vo__1606113]))})
          }else {
            return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":showoff.showoff.vec_unit.call(null, cljs.core.PersistentVector.fromArray([-1, 1])), "\ufdd0'incursion":showoff.showoff.vec_mag.call(null, cljs.core.PersistentVector.fromArray([ho__1606112, vo__1606113]))})
          }
        }else {
          if(cljs.core.truth_("\ufdd0'else")) {
            if(cljs.core.truth_(showoff.showoff.rect_miny.call(null, r1) < showoff.showoff.rect_maxy.call(null, r2))) {
              return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":showoff.showoff.vec_unit.call(null, cljs.core.PersistentVector.fromArray([1, -1])), "\ufdd0'incursion":showoff.showoff.vec_mag.call(null, cljs.core.PersistentVector.fromArray([ho__1606112, vo__1606113]))})
            }else {
              return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":showoff.showoff.vec_unit.call(null, cljs.core.PersistentVector.fromArray([1, 1])), "\ufdd0'incursion":showoff.showoff.vec_mag.call(null, cljs.core.PersistentVector.fromArray([ho__1606112, vo__1606113]))})
            }
          }else {
            return null
          }
        }
      }else {
        return null
      }
    }
  }
};
cljs.core._add_method.call(null, showoff.showoff.record_vs_rect, "\ufdd0'rect", function(rec, rect) {
  var vec__1606114__1606115 = "\ufdd0'coords".call(null, rec);
  var mx__1606116 = cljs.core.nth.call(null, vec__1606114__1606115, 0, null);
  var my__1606117 = cljs.core.nth.call(null, vec__1606114__1606115, 1, null);
  var map_rect__1606118 = cljs.core.PersistentVector.fromArray([mx__1606116, my__1606117, 1, 1]);
  if(cljs.core.truth_(showoff.showoff.rect_intersect.call(null, map_rect__1606118, rect))) {
    return showoff.showoff.rectrect_contact.call(null, rect, map_rect__1606118)
  }else {
    return null
  }
});
showoff.showoff.sqrt2 = Math.sqrt.call(null, 2);
showoff.showoff._PLUS_corner_fuzz_PLUS_ = 0.1;
cljs.core._add_method.call(null, showoff.showoff.record_vs_rect, "\ufdd0'right-triangle", function(rec, rect) {
  var vec__1606119__1606122 = "\ufdd0'coords".call(null, rec);
  var mx__1606123 = cljs.core.nth.call(null, vec__1606119__1606122, 0, null);
  var my__1606124 = cljs.core.nth.call(null, vec__1606119__1606122, 1, null);
  var vec__1606120__1606125 = rect;
  var rx__1606126 = cljs.core.nth.call(null, vec__1606120__1606125, 0, null);
  var ry__1606127 = cljs.core.nth.call(null, vec__1606120__1606125, 1, null);
  var rw__1606128 = cljs.core.nth.call(null, vec__1606120__1606125, 2, null);
  var rh__1606129 = cljs.core.nth.call(null, vec__1606120__1606125, 3, null);
  var map__1606121__1606130 = rec;
  var map__1606121__1606131 = cljs.core.truth_(cljs.core.seq_QMARK_.call(null, map__1606121__1606130)) ? cljs.core.apply.call(null, cljs.core.hash_map, map__1606121__1606130) : map__1606121__1606130;
  var top_filled__1606132 = cljs.core.get.call(null, map__1606121__1606131, "\ufdd0'top-filled");
  var intercept__1606133 = cljs.core.get.call(null, map__1606121__1606131, "\ufdd0'intercept");
  var slope__1606134 = cljs.core.get.call(null, map__1606121__1606131, "\ufdd0'slope");
  var corner_test__1606143 = function(x, y) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1606135 = x > mx__1606123 - showoff.showoff._PLUS_corner_fuzz_PLUS_;
      if(cljs.core.truth_(and__3546__auto____1606135)) {
        var and__3546__auto____1606136 = x < mx__1606123 + 1 + showoff.showoff._PLUS_corner_fuzz_PLUS_;
        if(cljs.core.truth_(and__3546__auto____1606136)) {
          var and__3546__auto____1606137 = y > my__1606124 - showoff.showoff._PLUS_corner_fuzz_PLUS_;
          if(cljs.core.truth_(and__3546__auto____1606137)) {
            return y < my__1606124 + 1 + showoff.showoff._PLUS_corner_fuzz_PLUS_
          }else {
            return and__3546__auto____1606137
          }
        }else {
          return and__3546__auto____1606136
        }
      }else {
        return and__3546__auto____1606135
      }
    }())) {
      var dx__1606138 = x - mx__1606123;
      var dy__1606139 = y - my__1606124;
      var ly__1606140 = intercept__1606133 + slope__1606134 * dx__1606138;
      if(cljs.core.truth_(function() {
        var and__3546__auto____1606141 = top_filled__1606132;
        if(cljs.core.truth_(and__3546__auto____1606141)) {
          return dy__1606139 < ly__1606140
        }else {
          return and__3546__auto____1606141
        }
      }())) {
        return showoff.showoff.sqrt2 * (ly__1606140 - dy__1606139)
      }else {
        if(cljs.core.truth_(function() {
          var and__3546__auto____1606142 = cljs.core.not.call(null, top_filled__1606132);
          if(cljs.core.truth_(and__3546__auto____1606142)) {
            return dy__1606139 > ly__1606140
          }else {
            return and__3546__auto____1606142
          }
        }())) {
          return showoff.showoff.sqrt2 * (dy__1606139 - ly__1606140)
        }else {
          if(cljs.core.truth_("\ufdd0'else")) {
            return false
          }else {
            return null
          }
        }
      }
    }else {
      return null
    }
  };
  var tl__1606144 = corner_test__1606143.call(null, rx__1606126, ry__1606127);
  var tr__1606145 = corner_test__1606143.call(null, rx__1606126 + rw__1606128, ry__1606127);
  var bl__1606146 = corner_test__1606143.call(null, rx__1606126, ry__1606127 + rh__1606129);
  var br__1606147 = corner_test__1606143.call(null, rx__1606126 + rw__1606128, ry__1606127 + rh__1606129);
  if(cljs.core.truth_(tl__1606144)) {
    return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":showoff.showoff.vec_unit.call(null, cljs.core.PersistentVector.fromArray([1, 1])), "\ufdd0'incursion":tl__1606144})
  }else {
    if(cljs.core.truth_(tr__1606145)) {
      return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":showoff.showoff.vec_unit.call(null, cljs.core.PersistentVector.fromArray([-1, 1])), "\ufdd0'incursion":tr__1606145})
    }else {
      if(cljs.core.truth_(bl__1606146)) {
        return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":showoff.showoff.vec_unit.call(null, cljs.core.PersistentVector.fromArray([1, -1])), "\ufdd0'incursion":bl__1606146})
      }else {
        if(cljs.core.truth_(br__1606147)) {
          return cljs.core.ObjMap.fromObject(["\ufdd0'normal", "\ufdd0'incursion"], {"\ufdd0'normal":showoff.showoff.vec_unit.call(null, cljs.core.PersistentVector.fromArray([-1, -1])), "\ufdd0'incursion":br__1606147})
        }else {
          if(cljs.core.truth_("\ufdd0'else")) {
            return null
          }else {
            return null
          }
        }
      }
    }
  }
});
showoff.showoff.idxrect_contact = function idxrect_contact(map, idx, rect) {
  return showoff.showoff.record_vs_rect.call(null, showoff.showoff.get_map_idx.call(null, map, idx), rect)
};
showoff.showoff.supported_by_map = function supported_by_map(map, rect) {
  var vec__1606148__1606149 = rect;
  var rx__1606150 = cljs.core.nth.call(null, vec__1606148__1606149, 0, null);
  var ry__1606151 = cljs.core.nth.call(null, vec__1606148__1606149, 1, null);
  var rw__1606152 = cljs.core.nth.call(null, vec__1606148__1606149, 2, null);
  var rh__1606153 = cljs.core.nth.call(null, vec__1606148__1606149, 3, null);
  var half_width__1606154 = 0.5 * rw__1606152;
  var maxy__1606155 = ry__1606151 + rh__1606153;
  var test_rect__1606156 = cljs.core.PersistentVector.fromArray([rx__1606150 + 0.5 * half_width__1606154, maxy__1606155, half_width__1606154, 0.3]);
  return cljs.core.not.call(null, cljs.core.empty_QMARK_.call(null, showoff.showoff.map_collisions.call(null, map, test_rect__1606156)))
};
showoff.showoff.head_bumped_map = function head_bumped_map(map, rect) {
  var vec__1606157__1606158 = rect;
  var rx__1606159 = cljs.core.nth.call(null, vec__1606157__1606158, 0, null);
  var ry__1606160 = cljs.core.nth.call(null, vec__1606157__1606158, 1, null);
  var rw__1606161 = cljs.core.nth.call(null, vec__1606157__1606158, 2, null);
  var rh__1606162 = cljs.core.nth.call(null, vec__1606157__1606158, 3, null);
  var half_width__1606163 = 0.5 * rw__1606161;
  var test_rect__1606164 = cljs.core.PersistentVector.fromArray([rx__1606159 + 0.5 * half_width__1606163, ry__1606160, half_width__1606163, 0.1]);
  return cljs.core.not.call(null, cljs.core.empty_QMARK_.call(null, showoff.showoff.map_collisions.call(null, map, test_rect__1606164)))
};
showoff.showoff.drag_force_generator = function drag_force_generator(drag_coefficient) {
  return function(p) {
    var vel__1606165 = "\ufdd0'velocity".call(null, p);
    var mag_velocity__1606166 = showoff.showoff.vec_mag.call(null, vel__1606165);
    var drag_dir__1606167 = showoff.showoff.vec_negate.call(null, showoff.showoff.vec_unit.call(null, vel__1606165));
    return showoff.showoff.vec_scale.call(null, drag_dir__1606167, mag_velocity__1606166 * mag_velocity__1606166 * drag_coefficient)
  }
};
showoff.showoff.gravity_force_generator = function gravity_force_generator(g) {
  return function(p) {
    return cljs.core.PersistentVector.fromArray([0, "\ufdd0'mass".call(null, p) * g])
  }
};
showoff.showoff.spring_force = function spring_force(displacement, max_displacement, spring_constant) {
  var mag_displacement__1606168 = showoff.showoff.vec_mag.call(null, displacement);
  var diff__1606169 = mag_displacement__1606168 - max_displacement;
  if(cljs.core.truth_(mag_displacement__1606168 > max_displacement)) {
    return showoff.showoff.vec_scale.call(null, showoff.showoff.vec_unit.call(null, displacement), spring_constant * diff__1606169)
  }else {
    return cljs.core.PersistentVector.fromArray([0, 0])
  }
};
showoff.showoff.accumulate_from_generators = function accumulate_from_generators(p, generators, initial) {
  return cljs.core.reduce.call(null, function(result, func) {
    return showoff.showoff.vec_add.call(null, result, func.call(null, p))
  }, initial, generators)
};
showoff.showoff.round_to_pixel = function round_to_pixel(p__1606170) {
  var vec__1606171__1606172 = p__1606170;
  var vx__1606173 = cljs.core.nth.call(null, vec__1606171__1606172, 0, null);
  var vy__1606174 = cljs.core.nth.call(null, vec__1606171__1606172, 1, null);
  var vec__1606175__1606176 = showoff.showoff._STAR_tile_in_world_dims_STAR_;
  var tw__1606177 = cljs.core.nth.call(null, vec__1606175__1606176, 0, null);
  var th__1606178 = cljs.core.nth.call(null, vec__1606175__1606176, 1, null);
  return cljs.core.PersistentVector.fromArray([Math.round.call(null, vx__1606173 * tw__1606177 * 2) / tw__1606177 / 2, Math.round.call(null, vy__1606174 * th__1606178 * 2) / th__1606178 / 2])
};
showoff.showoff.integrate_particle = function integrate_particle(p) {
  var force__1606181 = showoff.showoff.accumulate_from_generators.call(null, p, "\ufdd0'force-generators".call(null, p), cljs.core.PersistentVector.fromArray([0, 0]));
  var base_vel__1606182 = showoff.showoff.accumulate_from_generators.call(null, p, "\ufdd0'velocity-generators".call(null, p), "\ufdd0'velocity".call(null, p));
  var base_pos__1606183 = showoff.showoff.accumulate_from_generators.call(null, p, "\ufdd0'offset-generators".call(null, p), "\ufdd0'position".call(null, p));
  var acc__1606184 = showoff.showoff.vec_scale.call(null, force__1606181, 1 / "\ufdd0'mass".call(null, p));
  var last_acc__1606186 = showoff.showoff.vec_scale.call(null, function() {
    var or__3548__auto____1606185 = "\ufdd0'last-forces".call(null, p);
    if(cljs.core.truth_(or__3548__auto____1606185)) {
      return or__3548__auto____1606185
    }else {
      return cljs.core.PersistentVector.fromArray([0, 0])
    }
  }(), 1 / "\ufdd0'mass".call(null, p));
  var pos__1606187 = showoff.showoff.vec_add.call(null, base_pos__1606183, showoff.showoff.vec_add.call(null, showoff.showoff.vec_scale.call(null, base_vel__1606182, showoff.showoff._PLUS_secs_per_tick_PLUS_), showoff.showoff.vec_scale.call(null, last_acc__1606186, 0.5 * showoff.showoff._PLUS_secs_per_tick_PLUS_ * showoff.showoff._PLUS_secs_per_tick_PLUS_)));
  var vel__1606188 = showoff.showoff.vec_add.call(null, base_vel__1606182, showoff.showoff.vec_scale.call(null, showoff.showoff.vec_add.call(null, last_acc__1606186, acc__1606184), showoff.showoff._PLUS_secs_per_tick_PLUS_ / 2));
  return cljs.core.conj.call(null, p, cljs.core.ObjMap.fromObject(["\ufdd0'position", "\ufdd0'velocity", "\ufdd0'last-forces"], {"\ufdd0'position":pos__1606187, "\ufdd0'velocity":vel__1606188, "\ufdd0'last-forces":force__1606181}))
};
showoff.showoff.max_incursion_contact = function max_incursion_contact(contacts) {
  return cljs.core.reduce.call(null, function(p1__1606179_SHARP_, p2__1606180_SHARP_) {
    if(cljs.core.truth_("\ufdd0'incursion".call(null, p1__1606179_SHARP_) > "\ufdd0'incursion".call(null, p2__1606180_SHARP_))) {
      return p1__1606179_SHARP_
    }else {
      return p2__1606180_SHARP_
    }
  }, contacts)
};
showoff.showoff.apply_particle_vs_map = function apply_particle_vs_map(p, map, rect, restitution) {
  var contacts__1606194 = function() {
    var iter__520__auto____1606193 = function iter__1606189(s__1606190) {
      return new cljs.core.LazySeq(null, false, function() {
        var s__1606190__1606191 = s__1606190;
        while(true) {
          if(cljs.core.truth_(cljs.core.seq.call(null, s__1606190__1606191))) {
            var idx__1606192 = cljs.core.first.call(null, s__1606190__1606191);
            return cljs.core.cons.call(null, showoff.showoff.idxrect_contact.call(null, map, idx__1606192, rect), iter__1606189.call(null, cljs.core.rest.call(null, s__1606190__1606191)))
          }else {
            return null
          }
          break
        }
      })
    };
    return iter__520__auto____1606193.call(null, showoff.showoff.map_collisions.call(null, map, rect))
  }();
  var temp__1606195 = cljs.core.into.call(null, cljs.core.PersistentVector.fromArray([]), contacts__1606194);
  if(cljs.core.truth_(cljs.core.empty_QMARK_.call(null, contacts__1606194))) {
    return p
  }else {
    var map__1606196__1606197 = showoff.showoff.max_incursion_contact.call(null, contacts__1606194);
    var map__1606196__1606198 = cljs.core.truth_(cljs.core.seq_QMARK_.call(null, map__1606196__1606197)) ? cljs.core.apply.call(null, cljs.core.hash_map, map__1606196__1606197) : map__1606196__1606197;
    var incursion__1606199 = cljs.core.get.call(null, map__1606196__1606198, "\ufdd0'incursion");
    var normal__1606200 = cljs.core.get.call(null, map__1606196__1606198, "\ufdd0'normal");
    var vel__1606201 = "\ufdd0'velocity".call(null, p);
    var vel_due_to_force__1606202 = showoff.showoff.vec_scale.call(null, "\ufdd0'last-forces".call(null, p), 1 / "\ufdd0'mass".call(null, p) * showoff.showoff._PLUS_secs_per_tick_PLUS_);
    var veldiff__1606203 = showoff.showoff.vec_mag.call(null, showoff.showoff.vec_sub.call(null, vel__1606201, vel_due_to_force__1606202));
    var pos__1606204 = "\ufdd0'position".call(null, p);
    var newpos__1606205 = showoff.showoff.vec_add.call(null, pos__1606204, showoff.showoff.vec_scale.call(null, normal__1606200, incursion__1606199));
    var newvel__1606206 = showoff.showoff.vec_add.call(null, vel__1606201, showoff.showoff.vec_scale.call(null, normal__1606200, (1 + restitution) * Math.abs.call(null, showoff.showoff.vec_dot.call(null, normal__1606200, vel__1606201))));
    return cljs.core.conj.call(null, p, cljs.core.ObjMap.fromObject(["\ufdd0'position", "\ufdd0'velocity"], {"\ufdd0'position":newpos__1606205, "\ufdd0'velocity":newvel__1606206}))
  }
};
showoff.showoff.tick_entities = function tick_entities() {
  var G__1606207__1606208 = cljs.core.seq.call(null, cljs.core.deref.call(null, showoff.showoff._STAR_entities_STAR_));
  if(cljs.core.truth_(G__1606207__1606208)) {
    var entity__1606209 = cljs.core.first.call(null, G__1606207__1606208);
    var G__1606207__1606210 = G__1606207__1606208;
    while(true) {
      showoff.showoff.tick.call(null, entity__1606209);
      var temp__3698__auto____1606211 = cljs.core.next.call(null, G__1606207__1606210);
      if(cljs.core.truth_(temp__3698__auto____1606211)) {
        var G__1606207__1606212 = temp__3698__auto____1606211;
        var G__1606213 = cljs.core.first.call(null, G__1606207__1606212);
        var G__1606214 = G__1606207__1606212;
        entity__1606209 = G__1606213;
        G__1606207__1606210 = G__1606214;
        continue
      }else {
        return null
      }
      break
    }
  }else {
    return null
  }
};
showoff.showoff.draw_entities = function draw_entities() {
  var ctx__1606215 = showoff.showoff.context.call(null);
  var G__1606216__1606217 = cljs.core.seq.call(null, cljs.core.deref.call(null, showoff.showoff._STAR_entities_STAR_));
  if(cljs.core.truth_(G__1606216__1606217)) {
    var entity__1606218 = cljs.core.first.call(null, G__1606216__1606217);
    var G__1606216__1606219 = G__1606216__1606217;
    while(true) {
      showoff.showoff.draw.call(null, entity__1606218, ctx__1606215);
      var temp__3698__auto____1606220 = cljs.core.next.call(null, G__1606216__1606219);
      if(cljs.core.truth_(temp__3698__auto____1606220)) {
        var G__1606216__1606221 = temp__3698__auto____1606220;
        var G__1606222 = cljs.core.first.call(null, G__1606216__1606221);
        var G__1606223 = G__1606216__1606221;
        entity__1606218 = G__1606222;
        G__1606216__1606219 = G__1606223;
        continue
      }else {
        return null
      }
      break
    }
  }else {
    return null
  }
};
showoff.showoff.add_entity = function add_entity(map, e) {
  cljs.core.swap_BANG_.call(null, showoff.showoff._STAR_entities_STAR_, cljs.core.conj, e);
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606224 = map;
    if(cljs.core.truth_(and__3546__auto____1606224)) {
      var x__451__auto____1606225 = e;
      if(cljs.core.truth_(function() {
        var and__3546__auto____1606226 = x__451__auto____1606225;
        if(cljs.core.truth_(and__3546__auto____1606226)) {
          var and__3546__auto____1606227 = x__451__auto____1606225.showoff$showoff$Rectable$;
          if(cljs.core.truth_(and__3546__auto____1606227)) {
            return cljs.core.not.call(null, x__451__auto____1606225.hasOwnProperty("showoff$showoff$Rectable$"))
          }else {
            return and__3546__auto____1606227
          }
        }else {
          return and__3546__auto____1606226
        }
      }())) {
        return true
      }else {
        return cljs.core.type_satisfies_.call(null, showoff.showoff.Rectable, x__451__auto____1606225)
      }
    }else {
      return and__3546__auto____1606224
    }
  }())) {
    return showoff.showoff.move_object.call(null, map, e, null, showoff.showoff.rect__GT_idxs.call(null, map, showoff.showoff.to_rect.call(null, e)))
  }else {
    return null
  }
};
showoff.showoff.remove_entity = function remove_entity(map, e) {
  cljs.core.swap_BANG_.call(null, showoff.showoff._STAR_entities_STAR_, cljs.core.disj, e);
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606228 = map;
    if(cljs.core.truth_(and__3546__auto____1606228)) {
      var x__451__auto____1606229 = e;
      if(cljs.core.truth_(function() {
        var and__3546__auto____1606230 = x__451__auto____1606229;
        if(cljs.core.truth_(and__3546__auto____1606230)) {
          var and__3546__auto____1606231 = x__451__auto____1606229.showoff$showoff$Rectable$;
          if(cljs.core.truth_(and__3546__auto____1606231)) {
            return cljs.core.not.call(null, x__451__auto____1606229.hasOwnProperty("showoff$showoff$Rectable$"))
          }else {
            return and__3546__auto____1606231
          }
        }else {
          return and__3546__auto____1606230
        }
      }())) {
        return true
      }else {
        return cljs.core.type_satisfies_.call(null, showoff.showoff.Rectable, x__451__auto____1606229)
      }
    }else {
      return and__3546__auto____1606228
    }
  }())) {
    return showoff.showoff.move_object.call(null, map, e, showoff.showoff.rect__GT_idxs.call(null, map, showoff.showoff.to_rect.call(null, e)), null)
  }else {
    return null
  }
};
showoff.showoff.clear_entities = function clear_entities(map) {
  var G__1606232__1606233 = cljs.core.seq.call(null, cljs.core.deref.call(null, showoff.showoff._STAR_entities_STAR_));
  if(cljs.core.truth_(G__1606232__1606233)) {
    var e__1606234 = cljs.core.first.call(null, G__1606232__1606233);
    var G__1606232__1606235 = G__1606232__1606233;
    while(true) {
      showoff.showoff.remove_entity.call(null, map, e__1606234);
      var temp__3698__auto____1606236 = cljs.core.next.call(null, G__1606232__1606235);
      if(cljs.core.truth_(temp__3698__auto____1606236)) {
        var G__1606232__1606237 = temp__3698__auto____1606236;
        var G__1606238 = cljs.core.first.call(null, G__1606232__1606237);
        var G__1606239 = G__1606232__1606237;
        e__1606234 = G__1606238;
        G__1606232__1606235 = G__1606239;
        continue
      }else {
        return null
      }
      break
    }
  }else {
    return null
  }
};
showoff.showoff._STAR_last_time_STAR_ = goog.now.call(null);
showoff.showoff._STAR_remaining_ticks_STAR_ = 0;
showoff.showoff._STAR_last_ticks_evaled_STAR_ = 0;
showoff.showoff._STAR_last_ticks_time_STAR_ = 0;
showoff.showoff._STAR_last_draw_time_STAR_ = 0;
showoff.showoff.reset_tick_clock = function reset_tick_clock() {
  return showoff.showoff._STAR_last_time_STAR_ = goog.now.call(null)
};
showoff.showoff.stats_string = function stats_string() {
  return showoff.showoff.format.call(null, "%3d ms/tick %3d ms/draw", Math.floor.call(null, showoff.showoff._STAR_last_ticks_time_STAR_ / showoff.showoff._STAR_last_ticks_evaled_STAR_), showoff.showoff._STAR_last_draw_time_STAR_)
};
showoff.showoff.cycle_once = function cycle_once(after_ticks) {
  var now__1606240 = goog.now.call(null);
  var remaining_ticks__1606241 = showoff.showoff._STAR_remaining_ticks_STAR_ + (now__1606240 - showoff.showoff._STAR_last_time_STAR_) * showoff.showoff._PLUS_ticks_per_ms_PLUS_;
  var ticks__1606242 = Math.floor.call(null, remaining_ticks__1606241);
  var remaining_ticks__1606243 = remaining_ticks__1606241 - ticks__1606242;
  showoff.showoff._STAR_last_time_STAR_ = now__1606240;
  showoff.showoff._STAR_remaining_ticks_STAR_ = remaining_ticks__1606243;
  var start__1606244 = goog.now.call(null);
  var n__575__auto____1606245 = ticks__1606242;
  var ii__1606246 = 0;
  while(true) {
    if(cljs.core.truth_(ii__1606246 < n__575__auto____1606245)) {
      showoff.showoff.tick_entities.call(null);
      var G__1606249 = ii__1606246 + 1;
      ii__1606246 = G__1606249;
      continue
    }else {
    }
    break
  }
  showoff.showoff._STAR_last_ticks_time_STAR_ = goog.now.call(null) - start__1606244;
  showoff.showoff._STAR_last_ticks_evaled_STAR_ = ticks__1606242;
  var start__1606247 = goog.now.call(null);
  var result__1606248 = after_ticks.call(null, ticks__1606242);
  showoff.showoff._STAR_last_draw_time_STAR_ = goog.now.call(null) - start__1606247;
  return result__1606248
};
goog.provide("goog.disposable.IDisposable");
goog.disposable.IDisposable = function() {
};
goog.disposable.IDisposable.prototype.dispose;
goog.disposable.IDisposable.prototype.isDisposed;
goog.provide("goog.Disposable");
goog.provide("goog.dispose");
goog.require("goog.disposable.IDisposable");
goog.Disposable = function() {
  if(goog.Disposable.ENABLE_MONITORING) {
    goog.Disposable.instances_[goog.getUid(this)] = this
  }
};
goog.Disposable.ENABLE_MONITORING = false;
goog.Disposable.instances_ = {};
goog.Disposable.getUndisposedObjects = function() {
  var ret = [];
  for(var id in goog.Disposable.instances_) {
    if(goog.Disposable.instances_.hasOwnProperty(id)) {
      ret.push(goog.Disposable.instances_[Number(id)])
    }
  }
  return ret
};
goog.Disposable.clearUndisposedObjects = function() {
  goog.Disposable.instances_ = {}
};
goog.Disposable.prototype.disposed_ = false;
goog.Disposable.prototype.isDisposed = function() {
  return this.disposed_
};
goog.Disposable.prototype.getDisposed = goog.Disposable.prototype.isDisposed;
goog.Disposable.prototype.dispose = function() {
  if(!this.disposed_) {
    this.disposed_ = true;
    this.disposeInternal();
    if(goog.Disposable.ENABLE_MONITORING) {
      var uid = goog.getUid(this);
      if(!goog.Disposable.instances_.hasOwnProperty(uid)) {
        throw Error(this + " did not call the goog.Disposable base " + "constructor or was disposed of after a clearUndisposedObjects " + "call");
      }
      delete goog.Disposable.instances_[uid]
    }
  }
};
goog.Disposable.prototype.disposeInternal = function() {
};
goog.dispose = function(obj) {
  if(obj && typeof obj.dispose == "function") {
    obj.dispose()
  }
};
goog.provide("goog.debug.EntryPointMonitor");
goog.provide("goog.debug.entryPointRegistry");
goog.debug.EntryPointMonitor = function() {
};
goog.debug.EntryPointMonitor.prototype.wrap;
goog.debug.EntryPointMonitor.prototype.unwrap;
goog.debug.entryPointRegistry.refList_ = [];
goog.debug.entryPointRegistry.register = function(callback) {
  goog.debug.entryPointRegistry.refList_[goog.debug.entryPointRegistry.refList_.length] = callback
};
goog.debug.entryPointRegistry.monitorAll = function(monitor) {
  var transformer = goog.bind(monitor.wrap, monitor);
  for(var i = 0;i < goog.debug.entryPointRegistry.refList_.length;i++) {
    goog.debug.entryPointRegistry.refList_[i](transformer)
  }
};
goog.debug.entryPointRegistry.unmonitorAllIfPossible = function(monitor) {
  var transformer = goog.bind(monitor.unwrap, monitor);
  for(var i = 0;i < goog.debug.entryPointRegistry.refList_.length;i++) {
    goog.debug.entryPointRegistry.refList_[i](transformer)
  }
};
goog.provide("goog.debug.errorHandlerWeakDep");
goog.debug.errorHandlerWeakDep = {protectEntryPoint:function(fn, opt_tracers) {
  return fn
}};
goog.provide("goog.events.BrowserFeature");
goog.require("goog.userAgent");
goog.events.BrowserFeature = {HAS_W3C_BUTTON:!goog.userAgent.IE || goog.userAgent.isVersion("9"), SET_KEY_CODE_TO_PREVENT_DEFAULT:goog.userAgent.IE && !goog.userAgent.isVersion("8")};
goog.provide("goog.events.Event");
goog.require("goog.Disposable");
goog.events.Event = function(type, opt_target) {
  goog.Disposable.call(this);
  this.type = type;
  this.target = opt_target;
  this.currentTarget = this.target
};
goog.inherits(goog.events.Event, goog.Disposable);
goog.events.Event.prototype.disposeInternal = function() {
  delete this.type;
  delete this.target;
  delete this.currentTarget
};
goog.events.Event.prototype.propagationStopped_ = false;
goog.events.Event.prototype.returnValue_ = true;
goog.events.Event.prototype.stopPropagation = function() {
  this.propagationStopped_ = true
};
goog.events.Event.prototype.preventDefault = function() {
  this.returnValue_ = false
};
goog.events.Event.stopPropagation = function(e) {
  e.stopPropagation()
};
goog.events.Event.preventDefault = function(e) {
  e.preventDefault()
};
goog.provide("goog.events.EventType");
goog.require("goog.userAgent");
goog.events.EventType = {CLICK:"click", DBLCLICK:"dblclick", MOUSEDOWN:"mousedown", MOUSEUP:"mouseup", MOUSEOVER:"mouseover", MOUSEOUT:"mouseout", MOUSEMOVE:"mousemove", SELECTSTART:"selectstart", KEYPRESS:"keypress", KEYDOWN:"keydown", KEYUP:"keyup", BLUR:"blur", FOCUS:"focus", DEACTIVATE:"deactivate", FOCUSIN:goog.userAgent.IE ? "focusin" : "DOMFocusIn", FOCUSOUT:goog.userAgent.IE ? "focusout" : "DOMFocusOut", CHANGE:"change", SELECT:"select", SUBMIT:"submit", INPUT:"input", PROPERTYCHANGE:"propertychange", 
DRAGSTART:"dragstart", DRAGENTER:"dragenter", DRAGOVER:"dragover", DRAGLEAVE:"dragleave", DROP:"drop", TOUCHSTART:"touchstart", TOUCHMOVE:"touchmove", TOUCHEND:"touchend", TOUCHCANCEL:"touchcancel", CONTEXTMENU:"contextmenu", ERROR:"error", HELP:"help", LOAD:"load", LOSECAPTURE:"losecapture", READYSTATECHANGE:"readystatechange", RESIZE:"resize", SCROLL:"scroll", UNLOAD:"unload", HASHCHANGE:"hashchange", PAGEHIDE:"pagehide", PAGESHOW:"pageshow", POPSTATE:"popstate", COPY:"copy", PASTE:"paste", CUT:"cut", 
MESSAGE:"message", CONNECT:"connect"};
goog.provide("goog.reflect");
goog.reflect.object = function(type, object) {
  return object
};
goog.reflect.sinkValue = new Function("a", "return a");
goog.provide("goog.events.BrowserEvent");
goog.provide("goog.events.BrowserEvent.MouseButton");
goog.require("goog.events.BrowserFeature");
goog.require("goog.events.Event");
goog.require("goog.events.EventType");
goog.require("goog.reflect");
goog.require("goog.userAgent");
goog.events.BrowserEvent = function(opt_e, opt_currentTarget) {
  if(opt_e) {
    this.init(opt_e, opt_currentTarget)
  }
};
goog.inherits(goog.events.BrowserEvent, goog.events.Event);
goog.events.BrowserEvent.MouseButton = {LEFT:0, MIDDLE:1, RIGHT:2};
goog.events.BrowserEvent.IEButtonMap = [1, 4, 2];
goog.events.BrowserEvent.prototype.target = null;
goog.events.BrowserEvent.prototype.currentTarget;
goog.events.BrowserEvent.prototype.relatedTarget = null;
goog.events.BrowserEvent.prototype.offsetX = 0;
goog.events.BrowserEvent.prototype.offsetY = 0;
goog.events.BrowserEvent.prototype.clientX = 0;
goog.events.BrowserEvent.prototype.clientY = 0;
goog.events.BrowserEvent.prototype.screenX = 0;
goog.events.BrowserEvent.prototype.screenY = 0;
goog.events.BrowserEvent.prototype.button = 0;
goog.events.BrowserEvent.prototype.keyCode = 0;
goog.events.BrowserEvent.prototype.charCode = 0;
goog.events.BrowserEvent.prototype.ctrlKey = false;
goog.events.BrowserEvent.prototype.altKey = false;
goog.events.BrowserEvent.prototype.shiftKey = false;
goog.events.BrowserEvent.prototype.metaKey = false;
goog.events.BrowserEvent.prototype.state;
goog.events.BrowserEvent.prototype.platformModifierKey = false;
goog.events.BrowserEvent.prototype.event_ = null;
goog.events.BrowserEvent.prototype.init = function(e, opt_currentTarget) {
  var type = this.type = e.type;
  goog.events.Event.call(this, type);
  this.target = e.target || e.srcElement;
  this.currentTarget = opt_currentTarget;
  var relatedTarget = e.relatedTarget;
  if(relatedTarget) {
    if(goog.userAgent.GECKO) {
      try {
        goog.reflect.sinkValue(relatedTarget.nodeName)
      }catch(err) {
        relatedTarget = null
      }
    }
  }else {
    if(type == goog.events.EventType.MOUSEOVER) {
      relatedTarget = e.fromElement
    }else {
      if(type == goog.events.EventType.MOUSEOUT) {
        relatedTarget = e.toElement
      }
    }
  }
  this.relatedTarget = relatedTarget;
  this.offsetX = e.offsetX !== undefined ? e.offsetX : e.layerX;
  this.offsetY = e.offsetY !== undefined ? e.offsetY : e.layerY;
  this.clientX = e.clientX !== undefined ? e.clientX : e.pageX;
  this.clientY = e.clientY !== undefined ? e.clientY : e.pageY;
  this.screenX = e.screenX || 0;
  this.screenY = e.screenY || 0;
  this.button = e.button;
  this.keyCode = e.keyCode || 0;
  this.charCode = e.charCode || (type == "keypress" ? e.keyCode : 0);
  this.ctrlKey = e.ctrlKey;
  this.altKey = e.altKey;
  this.shiftKey = e.shiftKey;
  this.metaKey = e.metaKey;
  this.platformModifierKey = goog.userAgent.MAC ? e.metaKey : e.ctrlKey;
  this.state = e.state;
  this.event_ = e;
  delete this.returnValue_;
  delete this.propagationStopped_
};
goog.events.BrowserEvent.prototype.isButton = function(button) {
  if(!goog.events.BrowserFeature.HAS_W3C_BUTTON) {
    if(this.type == "click") {
      return button == goog.events.BrowserEvent.MouseButton.LEFT
    }else {
      return!!(this.event_.button & goog.events.BrowserEvent.IEButtonMap[button])
    }
  }else {
    return this.event_.button == button
  }
};
goog.events.BrowserEvent.prototype.isMouseActionButton = function() {
  return this.isButton(goog.events.BrowserEvent.MouseButton.LEFT) && !(goog.userAgent.WEBKIT && goog.userAgent.MAC && this.ctrlKey)
};
goog.events.BrowserEvent.prototype.stopPropagation = function() {
  goog.events.BrowserEvent.superClass_.stopPropagation.call(this);
  if(this.event_.stopPropagation) {
    this.event_.stopPropagation()
  }else {
    this.event_.cancelBubble = true
  }
};
goog.events.BrowserEvent.prototype.preventDefault = function() {
  goog.events.BrowserEvent.superClass_.preventDefault.call(this);
  var be = this.event_;
  if(!be.preventDefault) {
    be.returnValue = false;
    if(goog.events.BrowserFeature.SET_KEY_CODE_TO_PREVENT_DEFAULT) {
      try {
        var VK_F1 = 112;
        var VK_F12 = 123;
        if(be.ctrlKey || be.keyCode >= VK_F1 && be.keyCode <= VK_F12) {
          be.keyCode = -1
        }
      }catch(ex) {
      }
    }
  }else {
    be.preventDefault()
  }
};
goog.events.BrowserEvent.prototype.getBrowserEvent = function() {
  return this.event_
};
goog.events.BrowserEvent.prototype.disposeInternal = function() {
  goog.events.BrowserEvent.superClass_.disposeInternal.call(this);
  this.event_ = null;
  this.target = null;
  this.currentTarget = null;
  this.relatedTarget = null
};
goog.provide("goog.events.EventWrapper");
goog.events.EventWrapper = function() {
};
goog.events.EventWrapper.prototype.listen = function(src, listener, opt_capt, opt_scope, opt_eventHandler) {
};
goog.events.EventWrapper.prototype.unlisten = function(src, listener, opt_capt, opt_scope, opt_eventHandler) {
};
goog.provide("goog.events.Listener");
goog.events.Listener = function() {
};
goog.events.Listener.counter_ = 0;
goog.events.Listener.prototype.isFunctionListener_;
goog.events.Listener.prototype.listener;
goog.events.Listener.prototype.proxy;
goog.events.Listener.prototype.src;
goog.events.Listener.prototype.type;
goog.events.Listener.prototype.capture;
goog.events.Listener.prototype.handler;
goog.events.Listener.prototype.key = 0;
goog.events.Listener.prototype.removed = false;
goog.events.Listener.prototype.callOnce = false;
goog.events.Listener.prototype.init = function(listener, proxy, src, type, capture, opt_handler) {
  if(goog.isFunction(listener)) {
    this.isFunctionListener_ = true
  }else {
    if(listener && listener.handleEvent && goog.isFunction(listener.handleEvent)) {
      this.isFunctionListener_ = false
    }else {
      throw Error("Invalid listener argument");
    }
  }
  this.listener = listener;
  this.proxy = proxy;
  this.src = src;
  this.type = type;
  this.capture = !!capture;
  this.handler = opt_handler;
  this.callOnce = false;
  this.key = ++goog.events.Listener.counter_;
  this.removed = false
};
goog.events.Listener.prototype.handleEvent = function(eventObject) {
  if(this.isFunctionListener_) {
    return this.listener.call(this.handler || this.src, eventObject)
  }
  return this.listener.handleEvent.call(this.listener, eventObject)
};
goog.provide("goog.structs.SimplePool");
goog.require("goog.Disposable");
goog.structs.SimplePool = function(initialCount, maxCount) {
  goog.Disposable.call(this);
  this.maxCount_ = maxCount;
  this.freeQueue_ = [];
  this.createInitial_(initialCount)
};
goog.inherits(goog.structs.SimplePool, goog.Disposable);
goog.structs.SimplePool.prototype.createObjectFn_ = null;
goog.structs.SimplePool.prototype.disposeObjectFn_ = null;
goog.structs.SimplePool.prototype.setCreateObjectFn = function(createObjectFn) {
  this.createObjectFn_ = createObjectFn
};
goog.structs.SimplePool.prototype.setDisposeObjectFn = function(disposeObjectFn) {
  this.disposeObjectFn_ = disposeObjectFn
};
goog.structs.SimplePool.prototype.getObject = function() {
  if(this.freeQueue_.length) {
    return this.freeQueue_.pop()
  }
  return this.createObject()
};
goog.structs.SimplePool.prototype.releaseObject = function(obj) {
  if(this.freeQueue_.length < this.maxCount_) {
    this.freeQueue_.push(obj)
  }else {
    this.disposeObject(obj)
  }
};
goog.structs.SimplePool.prototype.createInitial_ = function(initialCount) {
  if(initialCount > this.maxCount_) {
    throw Error("[goog.structs.SimplePool] Initial cannot be greater than max");
  }
  for(var i = 0;i < initialCount;i++) {
    this.freeQueue_.push(this.createObject())
  }
};
goog.structs.SimplePool.prototype.createObject = function() {
  if(this.createObjectFn_) {
    return this.createObjectFn_()
  }else {
    return{}
  }
};
goog.structs.SimplePool.prototype.disposeObject = function(obj) {
  if(this.disposeObjectFn_) {
    this.disposeObjectFn_(obj)
  }else {
    if(goog.isObject(obj)) {
      if(goog.isFunction(obj.dispose)) {
        obj.dispose()
      }else {
        for(var i in obj) {
          delete obj[i]
        }
      }
    }
  }
};
goog.structs.SimplePool.prototype.disposeInternal = function() {
  goog.structs.SimplePool.superClass_.disposeInternal.call(this);
  var freeQueue = this.freeQueue_;
  while(freeQueue.length) {
    this.disposeObject(freeQueue.pop())
  }
  delete this.freeQueue_
};
goog.provide("goog.events.pools");
goog.require("goog.events.BrowserEvent");
goog.require("goog.events.Listener");
goog.require("goog.structs.SimplePool");
goog.require("goog.userAgent.jscript");
goog.events.ASSUME_GOOD_GC = false;
goog.events.pools.getObject;
goog.events.pools.releaseObject;
goog.events.pools.getArray;
goog.events.pools.releaseArray;
goog.events.pools.getProxy;
goog.events.pools.setProxyCallbackFunction;
goog.events.pools.releaseProxy;
goog.events.pools.getListener;
goog.events.pools.releaseListener;
goog.events.pools.getEvent;
goog.events.pools.releaseEvent;
(function() {
  var BAD_GC = !goog.events.ASSUME_GOOD_GC && goog.userAgent.jscript.HAS_JSCRIPT && !goog.userAgent.jscript.isVersion("5.7");
  function getObject() {
    return{count_:0, remaining_:0}
  }
  function getArray() {
    return[]
  }
  var proxyCallbackFunction;
  goog.events.pools.setProxyCallbackFunction = function(cb) {
    proxyCallbackFunction = cb
  };
  function getProxy() {
    var f = function(eventObject) {
      return proxyCallbackFunction.call(f.src, f.key, eventObject)
    };
    return f
  }
  function getListener() {
    return new goog.events.Listener
  }
  function getEvent() {
    return new goog.events.BrowserEvent
  }
  if(!BAD_GC) {
    goog.events.pools.getObject = getObject;
    goog.events.pools.releaseObject = goog.nullFunction;
    goog.events.pools.getArray = getArray;
    goog.events.pools.releaseArray = goog.nullFunction;
    goog.events.pools.getProxy = getProxy;
    goog.events.pools.releaseProxy = goog.nullFunction;
    goog.events.pools.getListener = getListener;
    goog.events.pools.releaseListener = goog.nullFunction;
    goog.events.pools.getEvent = getEvent;
    goog.events.pools.releaseEvent = goog.nullFunction
  }else {
    goog.events.pools.getObject = function() {
      return objectPool.getObject()
    };
    goog.events.pools.releaseObject = function(obj) {
      objectPool.releaseObject(obj)
    };
    goog.events.pools.getArray = function() {
      return arrayPool.getObject()
    };
    goog.events.pools.releaseArray = function(obj) {
      arrayPool.releaseObject(obj)
    };
    goog.events.pools.getProxy = function() {
      return proxyPool.getObject()
    };
    goog.events.pools.releaseProxy = function(obj) {
      proxyPool.releaseObject(getProxy())
    };
    goog.events.pools.getListener = function() {
      return listenerPool.getObject()
    };
    goog.events.pools.releaseListener = function(obj) {
      listenerPool.releaseObject(obj)
    };
    goog.events.pools.getEvent = function() {
      return eventPool.getObject()
    };
    goog.events.pools.releaseEvent = function(obj) {
      eventPool.releaseObject(obj)
    };
    var OBJECT_POOL_INITIAL_COUNT = 0;
    var OBJECT_POOL_MAX_COUNT = 600;
    var objectPool = new goog.structs.SimplePool(OBJECT_POOL_INITIAL_COUNT, OBJECT_POOL_MAX_COUNT);
    objectPool.setCreateObjectFn(getObject);
    var ARRAY_POOL_INITIAL_COUNT = 0;
    var ARRAY_POOL_MAX_COUNT = 600;
    var arrayPool = new goog.structs.SimplePool(ARRAY_POOL_INITIAL_COUNT, ARRAY_POOL_MAX_COUNT);
    arrayPool.setCreateObjectFn(getArray);
    var HANDLE_EVENT_PROXY_POOL_INITIAL_COUNT = 0;
    var HANDLE_EVENT_PROXY_POOL_MAX_COUNT = 600;
    var proxyPool = new goog.structs.SimplePool(HANDLE_EVENT_PROXY_POOL_INITIAL_COUNT, HANDLE_EVENT_PROXY_POOL_MAX_COUNT);
    proxyPool.setCreateObjectFn(getProxy);
    var LISTENER_POOL_INITIAL_COUNT = 0;
    var LISTENER_POOL_MAX_COUNT = 600;
    var listenerPool = new goog.structs.SimplePool(LISTENER_POOL_INITIAL_COUNT, LISTENER_POOL_MAX_COUNT);
    listenerPool.setCreateObjectFn(getListener);
    var EVENT_POOL_INITIAL_COUNT = 0;
    var EVENT_POOL_MAX_COUNT = 600;
    var eventPool = new goog.structs.SimplePool(EVENT_POOL_INITIAL_COUNT, EVENT_POOL_MAX_COUNT);
    eventPool.setCreateObjectFn(getEvent)
  }
})();
goog.provide("goog.events");
goog.require("goog.array");
goog.require("goog.debug.entryPointRegistry");
goog.require("goog.debug.errorHandlerWeakDep");
goog.require("goog.events.BrowserEvent");
goog.require("goog.events.Event");
goog.require("goog.events.EventWrapper");
goog.require("goog.events.pools");
goog.require("goog.object");
goog.require("goog.userAgent");
goog.events.listeners_ = {};
goog.events.listenerTree_ = {};
goog.events.sources_ = {};
goog.events.onString_ = "on";
goog.events.onStringMap_ = {};
goog.events.keySeparator_ = "_";
goog.events.requiresSyntheticEventPropagation_;
goog.events.listen = function(src, type, listener, opt_capt, opt_handler) {
  if(!type) {
    throw Error("Invalid event type");
  }else {
    if(goog.isArray(type)) {
      for(var i = 0;i < type.length;i++) {
        goog.events.listen(src, type[i], listener, opt_capt, opt_handler)
      }
      return null
    }else {
      var capture = !!opt_capt;
      var map = goog.events.listenerTree_;
      if(!(type in map)) {
        map[type] = goog.events.pools.getObject()
      }
      map = map[type];
      if(!(capture in map)) {
        map[capture] = goog.events.pools.getObject();
        map.count_++
      }
      map = map[capture];
      var srcUid = goog.getUid(src);
      var listenerArray, listenerObj;
      map.remaining_++;
      if(!map[srcUid]) {
        listenerArray = map[srcUid] = goog.events.pools.getArray();
        map.count_++
      }else {
        listenerArray = map[srcUid];
        for(var i = 0;i < listenerArray.length;i++) {
          listenerObj = listenerArray[i];
          if(listenerObj.listener == listener && listenerObj.handler == opt_handler) {
            if(listenerObj.removed) {
              break
            }
            return listenerArray[i].key
          }
        }
      }
      var proxy = goog.events.pools.getProxy();
      proxy.src = src;
      listenerObj = goog.events.pools.getListener();
      listenerObj.init(listener, proxy, src, type, capture, opt_handler);
      var key = listenerObj.key;
      proxy.key = key;
      listenerArray.push(listenerObj);
      goog.events.listeners_[key] = listenerObj;
      if(!goog.events.sources_[srcUid]) {
        goog.events.sources_[srcUid] = goog.events.pools.getArray()
      }
      goog.events.sources_[srcUid].push(listenerObj);
      if(src.addEventListener) {
        if(src == goog.global || !src.customEvent_) {
          src.addEventListener(type, proxy, capture)
        }
      }else {
        src.attachEvent(goog.events.getOnString_(type), proxy)
      }
      return key
    }
  }
};
goog.events.listenOnce = function(src, type, listener, opt_capt, opt_handler) {
  if(goog.isArray(type)) {
    for(var i = 0;i < type.length;i++) {
      goog.events.listenOnce(src, type[i], listener, opt_capt, opt_handler)
    }
    return null
  }
  var key = goog.events.listen(src, type, listener, opt_capt, opt_handler);
  var listenerObj = goog.events.listeners_[key];
  listenerObj.callOnce = true;
  return key
};
goog.events.listenWithWrapper = function(src, wrapper, listener, opt_capt, opt_handler) {
  wrapper.listen(src, listener, opt_capt, opt_handler)
};
goog.events.unlisten = function(src, type, listener, opt_capt, opt_handler) {
  if(goog.isArray(type)) {
    for(var i = 0;i < type.length;i++) {
      goog.events.unlisten(src, type[i], listener, opt_capt, opt_handler)
    }
    return null
  }
  var capture = !!opt_capt;
  var listenerArray = goog.events.getListeners_(src, type, capture);
  if(!listenerArray) {
    return false
  }
  for(var i = 0;i < listenerArray.length;i++) {
    if(listenerArray[i].listener == listener && listenerArray[i].capture == capture && listenerArray[i].handler == opt_handler) {
      return goog.events.unlistenByKey(listenerArray[i].key)
    }
  }
  return false
};
goog.events.unlistenByKey = function(key) {
  if(!goog.events.listeners_[key]) {
    return false
  }
  var listener = goog.events.listeners_[key];
  if(listener.removed) {
    return false
  }
  var src = listener.src;
  var type = listener.type;
  var proxy = listener.proxy;
  var capture = listener.capture;
  if(src.removeEventListener) {
    if(src == goog.global || !src.customEvent_) {
      src.removeEventListener(type, proxy, capture)
    }
  }else {
    if(src.detachEvent) {
      src.detachEvent(goog.events.getOnString_(type), proxy)
    }
  }
  var srcUid = goog.getUid(src);
  var listenerArray = goog.events.listenerTree_[type][capture][srcUid];
  if(goog.events.sources_[srcUid]) {
    var sourcesArray = goog.events.sources_[srcUid];
    goog.array.remove(sourcesArray, listener);
    if(sourcesArray.length == 0) {
      delete goog.events.sources_[srcUid]
    }
  }
  listener.removed = true;
  listenerArray.needsCleanup_ = true;
  goog.events.cleanUp_(type, capture, srcUid, listenerArray);
  delete goog.events.listeners_[key];
  return true
};
goog.events.unlistenWithWrapper = function(src, wrapper, listener, opt_capt, opt_handler) {
  wrapper.unlisten(src, listener, opt_capt, opt_handler)
};
goog.events.cleanUp_ = function(type, capture, srcUid, listenerArray) {
  if(!listenerArray.locked_) {
    if(listenerArray.needsCleanup_) {
      for(var oldIndex = 0, newIndex = 0;oldIndex < listenerArray.length;oldIndex++) {
        if(listenerArray[oldIndex].removed) {
          var proxy = listenerArray[oldIndex].proxy;
          proxy.src = null;
          goog.events.pools.releaseProxy(proxy);
          goog.events.pools.releaseListener(listenerArray[oldIndex]);
          continue
        }
        if(oldIndex != newIndex) {
          listenerArray[newIndex] = listenerArray[oldIndex]
        }
        newIndex++
      }
      listenerArray.length = newIndex;
      listenerArray.needsCleanup_ = false;
      if(newIndex == 0) {
        goog.events.pools.releaseArray(listenerArray);
        delete goog.events.listenerTree_[type][capture][srcUid];
        goog.events.listenerTree_[type][capture].count_--;
        if(goog.events.listenerTree_[type][capture].count_ == 0) {
          goog.events.pools.releaseObject(goog.events.listenerTree_[type][capture]);
          delete goog.events.listenerTree_[type][capture];
          goog.events.listenerTree_[type].count_--
        }
        if(goog.events.listenerTree_[type].count_ == 0) {
          goog.events.pools.releaseObject(goog.events.listenerTree_[type]);
          delete goog.events.listenerTree_[type]
        }
      }
    }
  }
};
goog.events.removeAll = function(opt_obj, opt_type, opt_capt) {
  var count = 0;
  var noObj = opt_obj == null;
  var noType = opt_type == null;
  var noCapt = opt_capt == null;
  opt_capt = !!opt_capt;
  if(!noObj) {
    var srcUid = goog.getUid(opt_obj);
    if(goog.events.sources_[srcUid]) {
      var sourcesArray = goog.events.sources_[srcUid];
      for(var i = sourcesArray.length - 1;i >= 0;i--) {
        var listener = sourcesArray[i];
        if((noType || opt_type == listener.type) && (noCapt || opt_capt == listener.capture)) {
          goog.events.unlistenByKey(listener.key);
          count++
        }
      }
    }
  }else {
    goog.object.forEach(goog.events.sources_, function(listeners) {
      for(var i = listeners.length - 1;i >= 0;i--) {
        var listener = listeners[i];
        if((noType || opt_type == listener.type) && (noCapt || opt_capt == listener.capture)) {
          goog.events.unlistenByKey(listener.key);
          count++
        }
      }
    })
  }
  return count
};
goog.events.getListeners = function(obj, type, capture) {
  return goog.events.getListeners_(obj, type, capture) || []
};
goog.events.getListeners_ = function(obj, type, capture) {
  var map = goog.events.listenerTree_;
  if(type in map) {
    map = map[type];
    if(capture in map) {
      map = map[capture];
      var objUid = goog.getUid(obj);
      if(map[objUid]) {
        return map[objUid]
      }
    }
  }
  return null
};
goog.events.getListener = function(src, type, listener, opt_capt, opt_handler) {
  var capture = !!opt_capt;
  var listenerArray = goog.events.getListeners_(src, type, capture);
  if(listenerArray) {
    for(var i = 0;i < listenerArray.length;i++) {
      if(listenerArray[i].listener == listener && listenerArray[i].capture == capture && listenerArray[i].handler == opt_handler) {
        return listenerArray[i]
      }
    }
  }
  return null
};
goog.events.hasListener = function(obj, opt_type, opt_capture) {
  var objUid = goog.getUid(obj);
  var listeners = goog.events.sources_[objUid];
  if(listeners) {
    var hasType = goog.isDef(opt_type);
    var hasCapture = goog.isDef(opt_capture);
    if(hasType && hasCapture) {
      var map = goog.events.listenerTree_[opt_type];
      return!!map && !!map[opt_capture] && objUid in map[opt_capture]
    }else {
      if(!(hasType || hasCapture)) {
        return true
      }else {
        return goog.array.some(listeners, function(listener) {
          return hasType && listener.type == opt_type || hasCapture && listener.capture == opt_capture
        })
      }
    }
  }
  return false
};
goog.events.expose = function(e) {
  var str = [];
  for(var key in e) {
    if(e[key] && e[key].id) {
      str.push(key + " = " + e[key] + " (" + e[key].id + ")")
    }else {
      str.push(key + " = " + e[key])
    }
  }
  return str.join("\n")
};
goog.events.getOnString_ = function(type) {
  if(type in goog.events.onStringMap_) {
    return goog.events.onStringMap_[type]
  }
  return goog.events.onStringMap_[type] = goog.events.onString_ + type
};
goog.events.fireListeners = function(obj, type, capture, eventObject) {
  var map = goog.events.listenerTree_;
  if(type in map) {
    map = map[type];
    if(capture in map) {
      return goog.events.fireListeners_(map[capture], obj, type, capture, eventObject)
    }
  }
  return true
};
goog.events.fireListeners_ = function(map, obj, type, capture, eventObject) {
  var retval = 1;
  var objUid = goog.getUid(obj);
  if(map[objUid]) {
    map.remaining_--;
    var listenerArray = map[objUid];
    if(!listenerArray.locked_) {
      listenerArray.locked_ = 1
    }else {
      listenerArray.locked_++
    }
    try {
      var length = listenerArray.length;
      for(var i = 0;i < length;i++) {
        var listener = listenerArray[i];
        if(listener && !listener.removed) {
          retval &= goog.events.fireListener(listener, eventObject) !== false
        }
      }
    }finally {
      listenerArray.locked_--;
      goog.events.cleanUp_(type, capture, objUid, listenerArray)
    }
  }
  return Boolean(retval)
};
goog.events.fireListener = function(listener, eventObject) {
  var rv = listener.handleEvent(eventObject);
  if(listener.callOnce) {
    goog.events.unlistenByKey(listener.key)
  }
  return rv
};
goog.events.getTotalListenerCount = function() {
  return goog.object.getCount(goog.events.listeners_)
};
goog.events.dispatchEvent = function(src, e) {
  var type = e.type || e;
  var map = goog.events.listenerTree_;
  if(!(type in map)) {
    return true
  }
  if(goog.isString(e)) {
    e = new goog.events.Event(e, src)
  }else {
    if(!(e instanceof goog.events.Event)) {
      var oldEvent = e;
      e = new goog.events.Event(type, src);
      goog.object.extend(e, oldEvent)
    }else {
      e.target = e.target || src
    }
  }
  var rv = 1, ancestors;
  map = map[type];
  var hasCapture = true in map;
  var targetsMap;
  if(hasCapture) {
    ancestors = [];
    for(var parent = src;parent;parent = parent.getParentEventTarget()) {
      ancestors.push(parent)
    }
    targetsMap = map[true];
    targetsMap.remaining_ = targetsMap.count_;
    for(var i = ancestors.length - 1;!e.propagationStopped_ && i >= 0 && targetsMap.remaining_;i--) {
      e.currentTarget = ancestors[i];
      rv &= goog.events.fireListeners_(targetsMap, ancestors[i], e.type, true, e) && e.returnValue_ != false
    }
  }
  var hasBubble = false in map;
  if(hasBubble) {
    targetsMap = map[false];
    targetsMap.remaining_ = targetsMap.count_;
    if(hasCapture) {
      for(var i = 0;!e.propagationStopped_ && i < ancestors.length && targetsMap.remaining_;i++) {
        e.currentTarget = ancestors[i];
        rv &= goog.events.fireListeners_(targetsMap, ancestors[i], e.type, false, e) && e.returnValue_ != false
      }
    }else {
      for(var current = src;!e.propagationStopped_ && current && targetsMap.remaining_;current = current.getParentEventTarget()) {
        e.currentTarget = current;
        rv &= goog.events.fireListeners_(targetsMap, current, e.type, false, e) && e.returnValue_ != false
      }
    }
  }
  return Boolean(rv)
};
goog.events.protectBrowserEventEntryPoint = function(errorHandler) {
  goog.events.handleBrowserEvent_ = errorHandler.protectEntryPoint(goog.events.handleBrowserEvent_);
  goog.events.pools.setProxyCallbackFunction(goog.events.handleBrowserEvent_)
};
goog.events.handleBrowserEvent_ = function(key, opt_evt) {
  if(!goog.events.listeners_[key]) {
    return true
  }
  var listener = goog.events.listeners_[key];
  var type = listener.type;
  var map = goog.events.listenerTree_;
  if(!(type in map)) {
    return true
  }
  map = map[type];
  var retval, targetsMap;
  if(goog.events.synthesizeEventPropagation_()) {
    var ieEvent = opt_evt || goog.getObjectByName("window.event");
    var hasCapture = true in map;
    var hasBubble = false in map;
    if(hasCapture) {
      if(goog.events.isMarkedIeEvent_(ieEvent)) {
        return true
      }
      goog.events.markIeEvent_(ieEvent)
    }
    var evt = goog.events.pools.getEvent();
    evt.init(ieEvent, this);
    retval = true;
    try {
      if(hasCapture) {
        var ancestors = goog.events.pools.getArray();
        for(var parent = evt.currentTarget;parent;parent = parent.parentNode) {
          ancestors.push(parent)
        }
        targetsMap = map[true];
        targetsMap.remaining_ = targetsMap.count_;
        for(var i = ancestors.length - 1;!evt.propagationStopped_ && i >= 0 && targetsMap.remaining_;i--) {
          evt.currentTarget = ancestors[i];
          retval &= goog.events.fireListeners_(targetsMap, ancestors[i], type, true, evt)
        }
        if(hasBubble) {
          targetsMap = map[false];
          targetsMap.remaining_ = targetsMap.count_;
          for(var i = 0;!evt.propagationStopped_ && i < ancestors.length && targetsMap.remaining_;i++) {
            evt.currentTarget = ancestors[i];
            retval &= goog.events.fireListeners_(targetsMap, ancestors[i], type, false, evt)
          }
        }
      }else {
        retval = goog.events.fireListener(listener, evt)
      }
    }finally {
      if(ancestors) {
        ancestors.length = 0;
        goog.events.pools.releaseArray(ancestors)
      }
      evt.dispose();
      goog.events.pools.releaseEvent(evt)
    }
    return retval
  }
  var be = new goog.events.BrowserEvent(opt_evt, this);
  try {
    retval = goog.events.fireListener(listener, be)
  }finally {
    be.dispose()
  }
  return retval
};
goog.events.pools.setProxyCallbackFunction(goog.events.handleBrowserEvent_);
goog.events.markIeEvent_ = function(e) {
  var useReturnValue = false;
  if(e.keyCode == 0) {
    try {
      e.keyCode = -1;
      return
    }catch(ex) {
      useReturnValue = true
    }
  }
  if(useReturnValue || e.returnValue == undefined) {
    e.returnValue = true
  }
};
goog.events.isMarkedIeEvent_ = function(e) {
  return e.keyCode < 0 || e.returnValue != undefined
};
goog.events.uniqueIdCounter_ = 0;
goog.events.getUniqueId = function(identifier) {
  return identifier + "_" + goog.events.uniqueIdCounter_++
};
goog.events.synthesizeEventPropagation_ = function() {
  if(goog.events.requiresSyntheticEventPropagation_ === undefined) {
    goog.events.requiresSyntheticEventPropagation_ = goog.userAgent.IE && !goog.global["addEventListener"]
  }
  return goog.events.requiresSyntheticEventPropagation_
};
goog.debug.entryPointRegistry.register(function(transformer) {
  goog.events.handleBrowserEvent_ = transformer(goog.events.handleBrowserEvent_);
  goog.events.pools.setProxyCallbackFunction(goog.events.handleBrowserEvent_)
});
goog.provide("goog.events.EventTarget");
goog.require("goog.Disposable");
goog.require("goog.events");
goog.events.EventTarget = function() {
  goog.Disposable.call(this)
};
goog.inherits(goog.events.EventTarget, goog.Disposable);
goog.events.EventTarget.prototype.customEvent_ = true;
goog.events.EventTarget.prototype.parentEventTarget_ = null;
goog.events.EventTarget.prototype.getParentEventTarget = function() {
  return this.parentEventTarget_
};
goog.events.EventTarget.prototype.setParentEventTarget = function(parent) {
  this.parentEventTarget_ = parent
};
goog.events.EventTarget.prototype.addEventListener = function(type, handler, opt_capture, opt_handlerScope) {
  goog.events.listen(this, type, handler, opt_capture, opt_handlerScope)
};
goog.events.EventTarget.prototype.removeEventListener = function(type, handler, opt_capture, opt_handlerScope) {
  goog.events.unlisten(this, type, handler, opt_capture, opt_handlerScope)
};
goog.events.EventTarget.prototype.dispatchEvent = function(e) {
  return goog.events.dispatchEvent(this, e)
};
goog.events.EventTarget.prototype.disposeInternal = function() {
  goog.events.EventTarget.superClass_.disposeInternal.call(this);
  goog.events.removeAll(this);
  this.parentEventTarget_ = null
};
goog.provide("goog.Timer");
goog.require("goog.events.EventTarget");
goog.Timer = function(opt_interval, opt_timerObject) {
  goog.events.EventTarget.call(this);
  this.interval_ = opt_interval || 1;
  this.timerObject_ = opt_timerObject || goog.Timer.defaultTimerObject;
  this.boundTick_ = goog.bind(this.tick_, this);
  this.last_ = goog.now()
};
goog.inherits(goog.Timer, goog.events.EventTarget);
goog.Timer.MAX_TIMEOUT_ = 2147483647;
goog.Timer.prototype.enabled = false;
goog.Timer.defaultTimerObject = goog.global["window"];
goog.Timer.intervalScale = 0.8;
goog.Timer.prototype.timer_ = null;
goog.Timer.prototype.getInterval = function() {
  return this.interval_
};
goog.Timer.prototype.setInterval = function(interval) {
  this.interval_ = interval;
  if(this.timer_ && this.enabled) {
    this.stop();
    this.start()
  }else {
    if(this.timer_) {
      this.stop()
    }
  }
};
goog.Timer.prototype.tick_ = function() {
  if(this.enabled) {
    var elapsed = goog.now() - this.last_;
    if(elapsed > 0 && elapsed < this.interval_ * goog.Timer.intervalScale) {
      this.timer_ = this.timerObject_.setTimeout(this.boundTick_, this.interval_ - elapsed);
      return
    }
    this.dispatchTick();
    if(this.enabled) {
      this.timer_ = this.timerObject_.setTimeout(this.boundTick_, this.interval_);
      this.last_ = goog.now()
    }
  }
};
goog.Timer.prototype.dispatchTick = function() {
  this.dispatchEvent(goog.Timer.TICK)
};
goog.Timer.prototype.start = function() {
  this.enabled = true;
  if(!this.timer_) {
    this.timer_ = this.timerObject_.setTimeout(this.boundTick_, this.interval_);
    this.last_ = goog.now()
  }
};
goog.Timer.prototype.stop = function() {
  this.enabled = false;
  if(this.timer_) {
    this.timerObject_.clearTimeout(this.timer_);
    this.timer_ = null
  }
};
goog.Timer.prototype.disposeInternal = function() {
  goog.Timer.superClass_.disposeInternal.call(this);
  this.stop();
  delete this.timerObject_
};
goog.Timer.TICK = "tick";
goog.Timer.callOnce = function(listener, opt_delay, opt_handler) {
  if(goog.isFunction(listener)) {
    if(opt_handler) {
      listener = goog.bind(listener, opt_handler)
    }
  }else {
    if(listener && typeof listener.handleEvent == "function") {
      listener = goog.bind(listener.handleEvent, listener)
    }else {
      throw Error("Invalid listener argument");
    }
  }
  if(opt_delay > goog.Timer.MAX_TIMEOUT_) {
    return-1
  }else {
    return goog.Timer.defaultTimerObject.setTimeout(listener, opt_delay || 0)
  }
};
goog.Timer.clear = function(timerId) {
  goog.Timer.defaultTimerObject.clearTimeout(timerId)
};
goog.provide("goog.structs");
goog.require("goog.array");
goog.require("goog.object");
goog.structs.getCount = function(col) {
  if(typeof col.getCount == "function") {
    return col.getCount()
  }
  if(goog.isArrayLike(col) || goog.isString(col)) {
    return col.length
  }
  return goog.object.getCount(col)
};
goog.structs.getValues = function(col) {
  if(typeof col.getValues == "function") {
    return col.getValues()
  }
  if(goog.isString(col)) {
    return col.split("")
  }
  if(goog.isArrayLike(col)) {
    var rv = [];
    var l = col.length;
    for(var i = 0;i < l;i++) {
      rv.push(col[i])
    }
    return rv
  }
  return goog.object.getValues(col)
};
goog.structs.getKeys = function(col) {
  if(typeof col.getKeys == "function") {
    return col.getKeys()
  }
  if(typeof col.getValues == "function") {
    return undefined
  }
  if(goog.isArrayLike(col) || goog.isString(col)) {
    var rv = [];
    var l = col.length;
    for(var i = 0;i < l;i++) {
      rv.push(i)
    }
    return rv
  }
  return goog.object.getKeys(col)
};
goog.structs.contains = function(col, val) {
  if(typeof col.contains == "function") {
    return col.contains(val)
  }
  if(typeof col.containsValue == "function") {
    return col.containsValue(val)
  }
  if(goog.isArrayLike(col) || goog.isString(col)) {
    return goog.array.contains(col, val)
  }
  return goog.object.containsValue(col, val)
};
goog.structs.isEmpty = function(col) {
  if(typeof col.isEmpty == "function") {
    return col.isEmpty()
  }
  if(goog.isArrayLike(col) || goog.isString(col)) {
    return goog.array.isEmpty(col)
  }
  return goog.object.isEmpty(col)
};
goog.structs.clear = function(col) {
  if(typeof col.clear == "function") {
    col.clear()
  }else {
    if(goog.isArrayLike(col)) {
      goog.array.clear(col)
    }else {
      goog.object.clear(col)
    }
  }
};
goog.structs.forEach = function(col, f, opt_obj) {
  if(typeof col.forEach == "function") {
    col.forEach(f, opt_obj)
  }else {
    if(goog.isArrayLike(col) || goog.isString(col)) {
      goog.array.forEach(col, f, opt_obj)
    }else {
      var keys = goog.structs.getKeys(col);
      var values = goog.structs.getValues(col);
      var l = values.length;
      for(var i = 0;i < l;i++) {
        f.call(opt_obj, values[i], keys && keys[i], col)
      }
    }
  }
};
goog.structs.filter = function(col, f, opt_obj) {
  if(typeof col.filter == "function") {
    return col.filter(f, opt_obj)
  }
  if(goog.isArrayLike(col) || goog.isString(col)) {
    return goog.array.filter(col, f, opt_obj)
  }
  var rv;
  var keys = goog.structs.getKeys(col);
  var values = goog.structs.getValues(col);
  var l = values.length;
  if(keys) {
    rv = {};
    for(var i = 0;i < l;i++) {
      if(f.call(opt_obj, values[i], keys[i], col)) {
        rv[keys[i]] = values[i]
      }
    }
  }else {
    rv = [];
    for(var i = 0;i < l;i++) {
      if(f.call(opt_obj, values[i], undefined, col)) {
        rv.push(values[i])
      }
    }
  }
  return rv
};
goog.structs.map = function(col, f, opt_obj) {
  if(typeof col.map == "function") {
    return col.map(f, opt_obj)
  }
  if(goog.isArrayLike(col) || goog.isString(col)) {
    return goog.array.map(col, f, opt_obj)
  }
  var rv;
  var keys = goog.structs.getKeys(col);
  var values = goog.structs.getValues(col);
  var l = values.length;
  if(keys) {
    rv = {};
    for(var i = 0;i < l;i++) {
      rv[keys[i]] = f.call(opt_obj, values[i], keys[i], col)
    }
  }else {
    rv = [];
    for(var i = 0;i < l;i++) {
      rv[i] = f.call(opt_obj, values[i], undefined, col)
    }
  }
  return rv
};
goog.structs.some = function(col, f, opt_obj) {
  if(typeof col.some == "function") {
    return col.some(f, opt_obj)
  }
  if(goog.isArrayLike(col) || goog.isString(col)) {
    return goog.array.some(col, f, opt_obj)
  }
  var keys = goog.structs.getKeys(col);
  var values = goog.structs.getValues(col);
  var l = values.length;
  for(var i = 0;i < l;i++) {
    if(f.call(opt_obj, values[i], keys && keys[i], col)) {
      return true
    }
  }
  return false
};
goog.structs.every = function(col, f, opt_obj) {
  if(typeof col.every == "function") {
    return col.every(f, opt_obj)
  }
  if(goog.isArrayLike(col) || goog.isString(col)) {
    return goog.array.every(col, f, opt_obj)
  }
  var keys = goog.structs.getKeys(col);
  var values = goog.structs.getValues(col);
  var l = values.length;
  for(var i = 0;i < l;i++) {
    if(!f.call(opt_obj, values[i], keys && keys[i], col)) {
      return false
    }
  }
  return true
};
goog.provide("goog.iter");
goog.provide("goog.iter.Iterator");
goog.provide("goog.iter.StopIteration");
goog.require("goog.array");
goog.require("goog.asserts");
goog.iter.Iterable;
if("StopIteration" in goog.global) {
  goog.iter.StopIteration = goog.global["StopIteration"]
}else {
  goog.iter.StopIteration = Error("StopIteration")
}
goog.iter.Iterator = function() {
};
goog.iter.Iterator.prototype.next = function() {
  throw goog.iter.StopIteration;
};
goog.iter.Iterator.prototype.__iterator__ = function(opt_keys) {
  return this
};
goog.iter.toIterator = function(iterable) {
  if(iterable instanceof goog.iter.Iterator) {
    return iterable
  }
  if(typeof iterable.__iterator__ == "function") {
    return iterable.__iterator__(false)
  }
  if(goog.isArrayLike(iterable)) {
    var i = 0;
    var newIter = new goog.iter.Iterator;
    newIter.next = function() {
      while(true) {
        if(i >= iterable.length) {
          throw goog.iter.StopIteration;
        }
        if(!(i in iterable)) {
          i++;
          continue
        }
        return iterable[i++]
      }
    };
    return newIter
  }
  throw Error("Not implemented");
};
goog.iter.forEach = function(iterable, f, opt_obj) {
  if(goog.isArrayLike(iterable)) {
    try {
      goog.array.forEach(iterable, f, opt_obj)
    }catch(ex) {
      if(ex !== goog.iter.StopIteration) {
        throw ex;
      }
    }
  }else {
    iterable = goog.iter.toIterator(iterable);
    try {
      while(true) {
        f.call(opt_obj, iterable.next(), undefined, iterable)
      }
    }catch(ex) {
      if(ex !== goog.iter.StopIteration) {
        throw ex;
      }
    }
  }
};
goog.iter.filter = function(iterable, f, opt_obj) {
  iterable = goog.iter.toIterator(iterable);
  var newIter = new goog.iter.Iterator;
  newIter.next = function() {
    while(true) {
      var val = iterable.next();
      if(f.call(opt_obj, val, undefined, iterable)) {
        return val
      }
    }
  };
  return newIter
};
goog.iter.range = function(startOrStop, opt_stop, opt_step) {
  var start = 0;
  var stop = startOrStop;
  var step = opt_step || 1;
  if(arguments.length > 1) {
    start = startOrStop;
    stop = opt_stop
  }
  if(step == 0) {
    throw Error("Range step argument must not be zero");
  }
  var newIter = new goog.iter.Iterator;
  newIter.next = function() {
    if(step > 0 && start >= stop || step < 0 && start <= stop) {
      throw goog.iter.StopIteration;
    }
    var rv = start;
    start += step;
    return rv
  };
  return newIter
};
goog.iter.join = function(iterable, deliminator) {
  return goog.iter.toArray(iterable).join(deliminator)
};
goog.iter.map = function(iterable, f, opt_obj) {
  iterable = goog.iter.toIterator(iterable);
  var newIter = new goog.iter.Iterator;
  newIter.next = function() {
    while(true) {
      var val = iterable.next();
      return f.call(opt_obj, val, undefined, iterable)
    }
  };
  return newIter
};
goog.iter.reduce = function(iterable, f, val, opt_obj) {
  var rval = val;
  goog.iter.forEach(iterable, function(val) {
    rval = f.call(opt_obj, rval, val)
  });
  return rval
};
goog.iter.some = function(iterable, f, opt_obj) {
  iterable = goog.iter.toIterator(iterable);
  try {
    while(true) {
      if(f.call(opt_obj, iterable.next(), undefined, iterable)) {
        return true
      }
    }
  }catch(ex) {
    if(ex !== goog.iter.StopIteration) {
      throw ex;
    }
  }
  return false
};
goog.iter.every = function(iterable, f, opt_obj) {
  iterable = goog.iter.toIterator(iterable);
  try {
    while(true) {
      if(!f.call(opt_obj, iterable.next(), undefined, iterable)) {
        return false
      }
    }
  }catch(ex) {
    if(ex !== goog.iter.StopIteration) {
      throw ex;
    }
  }
  return true
};
goog.iter.chain = function(var_args) {
  var args = arguments;
  var length = args.length;
  var i = 0;
  var newIter = new goog.iter.Iterator;
  newIter.next = function() {
    try {
      if(i >= length) {
        throw goog.iter.StopIteration;
      }
      var current = goog.iter.toIterator(args[i]);
      return current.next()
    }catch(ex) {
      if(ex !== goog.iter.StopIteration || i >= length) {
        throw ex;
      }else {
        i++;
        return this.next()
      }
    }
  };
  return newIter
};
goog.iter.dropWhile = function(iterable, f, opt_obj) {
  iterable = goog.iter.toIterator(iterable);
  var newIter = new goog.iter.Iterator;
  var dropping = true;
  newIter.next = function() {
    while(true) {
      var val = iterable.next();
      if(dropping && f.call(opt_obj, val, undefined, iterable)) {
        continue
      }else {
        dropping = false
      }
      return val
    }
  };
  return newIter
};
goog.iter.takeWhile = function(iterable, f, opt_obj) {
  iterable = goog.iter.toIterator(iterable);
  var newIter = new goog.iter.Iterator;
  var taking = true;
  newIter.next = function() {
    while(true) {
      if(taking) {
        var val = iterable.next();
        if(f.call(opt_obj, val, undefined, iterable)) {
          return val
        }else {
          taking = false
        }
      }else {
        throw goog.iter.StopIteration;
      }
    }
  };
  return newIter
};
goog.iter.toArray = function(iterable) {
  if(goog.isArrayLike(iterable)) {
    return goog.array.toArray(iterable)
  }
  iterable = goog.iter.toIterator(iterable);
  var array = [];
  goog.iter.forEach(iterable, function(val) {
    array.push(val)
  });
  return array
};
goog.iter.equals = function(iterable1, iterable2) {
  iterable1 = goog.iter.toIterator(iterable1);
  iterable2 = goog.iter.toIterator(iterable2);
  var b1, b2;
  try {
    while(true) {
      b1 = b2 = false;
      var val1 = iterable1.next();
      b1 = true;
      var val2 = iterable2.next();
      b2 = true;
      if(val1 != val2) {
        return false
      }
    }
  }catch(ex) {
    if(ex !== goog.iter.StopIteration) {
      throw ex;
    }else {
      if(b1 && !b2) {
        return false
      }
      if(!b2) {
        try {
          val2 = iterable2.next();
          return false
        }catch(ex1) {
          if(ex1 !== goog.iter.StopIteration) {
            throw ex1;
          }
          return true
        }
      }
    }
  }
  return false
};
goog.iter.nextOrValue = function(iterable, defaultValue) {
  try {
    return goog.iter.toIterator(iterable).next()
  }catch(e) {
    if(e != goog.iter.StopIteration) {
      throw e;
    }
    return defaultValue
  }
};
goog.iter.product = function(var_args) {
  var someArrayEmpty = goog.array.some(arguments, function(arr) {
    return!arr.length
  });
  if(someArrayEmpty || !arguments.length) {
    return new goog.iter.Iterator
  }
  var iter = new goog.iter.Iterator;
  var arrays = arguments;
  var indicies = goog.array.repeat(0, arrays.length);
  iter.next = function() {
    if(indicies) {
      var retVal = goog.array.map(indicies, function(valueIndex, arrayIndex) {
        return arrays[arrayIndex][valueIndex]
      });
      for(var i = indicies.length - 1;i >= 0;i--) {
        goog.asserts.assert(indicies);
        if(indicies[i] < arrays[i].length - 1) {
          indicies[i]++;
          break
        }
        if(i == 0) {
          indicies = null;
          break
        }
        indicies[i] = 0
      }
      return retVal
    }
    throw goog.iter.StopIteration;
  };
  return iter
};
goog.provide("goog.structs.Map");
goog.require("goog.iter.Iterator");
goog.require("goog.iter.StopIteration");
goog.require("goog.object");
goog.require("goog.structs");
goog.structs.Map = function(opt_map, var_args) {
  this.map_ = {};
  this.keys_ = [];
  var argLength = arguments.length;
  if(argLength > 1) {
    if(argLength % 2) {
      throw Error("Uneven number of arguments");
    }
    for(var i = 0;i < argLength;i += 2) {
      this.set(arguments[i], arguments[i + 1])
    }
  }else {
    if(opt_map) {
      this.addAll(opt_map)
    }
  }
};
goog.structs.Map.prototype.count_ = 0;
goog.structs.Map.prototype.version_ = 0;
goog.structs.Map.prototype.getCount = function() {
  return this.count_
};
goog.structs.Map.prototype.getValues = function() {
  this.cleanupKeysArray_();
  var rv = [];
  for(var i = 0;i < this.keys_.length;i++) {
    var key = this.keys_[i];
    rv.push(this.map_[key])
  }
  return rv
};
goog.structs.Map.prototype.getKeys = function() {
  this.cleanupKeysArray_();
  return this.keys_.concat()
};
goog.structs.Map.prototype.containsKey = function(key) {
  return goog.structs.Map.hasKey_(this.map_, key)
};
goog.structs.Map.prototype.containsValue = function(val) {
  for(var i = 0;i < this.keys_.length;i++) {
    var key = this.keys_[i];
    if(goog.structs.Map.hasKey_(this.map_, key) && this.map_[key] == val) {
      return true
    }
  }
  return false
};
goog.structs.Map.prototype.equals = function(otherMap, opt_equalityFn) {
  if(this === otherMap) {
    return true
  }
  if(this.count_ != otherMap.getCount()) {
    return false
  }
  var equalityFn = opt_equalityFn || goog.structs.Map.defaultEquals;
  this.cleanupKeysArray_();
  for(var key, i = 0;key = this.keys_[i];i++) {
    if(!equalityFn(this.get(key), otherMap.get(key))) {
      return false
    }
  }
  return true
};
goog.structs.Map.defaultEquals = function(a, b) {
  return a === b
};
goog.structs.Map.prototype.isEmpty = function() {
  return this.count_ == 0
};
goog.structs.Map.prototype.clear = function() {
  this.map_ = {};
  this.keys_.length = 0;
  this.count_ = 0;
  this.version_ = 0
};
goog.structs.Map.prototype.remove = function(key) {
  if(goog.structs.Map.hasKey_(this.map_, key)) {
    delete this.map_[key];
    this.count_--;
    this.version_++;
    if(this.keys_.length > 2 * this.count_) {
      this.cleanupKeysArray_()
    }
    return true
  }
  return false
};
goog.structs.Map.prototype.cleanupKeysArray_ = function() {
  if(this.count_ != this.keys_.length) {
    var srcIndex = 0;
    var destIndex = 0;
    while(srcIndex < this.keys_.length) {
      var key = this.keys_[srcIndex];
      if(goog.structs.Map.hasKey_(this.map_, key)) {
        this.keys_[destIndex++] = key
      }
      srcIndex++
    }
    this.keys_.length = destIndex
  }
  if(this.count_ != this.keys_.length) {
    var seen = {};
    var srcIndex = 0;
    var destIndex = 0;
    while(srcIndex < this.keys_.length) {
      var key = this.keys_[srcIndex];
      if(!goog.structs.Map.hasKey_(seen, key)) {
        this.keys_[destIndex++] = key;
        seen[key] = 1
      }
      srcIndex++
    }
    this.keys_.length = destIndex
  }
};
goog.structs.Map.prototype.get = function(key, opt_val) {
  if(goog.structs.Map.hasKey_(this.map_, key)) {
    return this.map_[key]
  }
  return opt_val
};
goog.structs.Map.prototype.set = function(key, value) {
  if(!goog.structs.Map.hasKey_(this.map_, key)) {
    this.count_++;
    this.keys_.push(key);
    this.version_++
  }
  this.map_[key] = value
};
goog.structs.Map.prototype.addAll = function(map) {
  var keys, values;
  if(map instanceof goog.structs.Map) {
    keys = map.getKeys();
    values = map.getValues()
  }else {
    keys = goog.object.getKeys(map);
    values = goog.object.getValues(map)
  }
  for(var i = 0;i < keys.length;i++) {
    this.set(keys[i], values[i])
  }
};
goog.structs.Map.prototype.clone = function() {
  return new goog.structs.Map(this)
};
goog.structs.Map.prototype.transpose = function() {
  var transposed = new goog.structs.Map;
  for(var i = 0;i < this.keys_.length;i++) {
    var key = this.keys_[i];
    var value = this.map_[key];
    transposed.set(value, key)
  }
  return transposed
};
goog.structs.Map.prototype.toObject = function() {
  this.cleanupKeysArray_();
  var obj = {};
  for(var i = 0;i < this.keys_.length;i++) {
    var key = this.keys_[i];
    obj[key] = this.map_[key]
  }
  return obj
};
goog.structs.Map.prototype.getKeyIterator = function() {
  return this.__iterator__(true)
};
goog.structs.Map.prototype.getValueIterator = function() {
  return this.__iterator__(false)
};
goog.structs.Map.prototype.__iterator__ = function(opt_keys) {
  this.cleanupKeysArray_();
  var i = 0;
  var keys = this.keys_;
  var map = this.map_;
  var version = this.version_;
  var selfObj = this;
  var newIter = new goog.iter.Iterator;
  newIter.next = function() {
    while(true) {
      if(version != selfObj.version_) {
        throw Error("The map has changed since the iterator was created");
      }
      if(i >= keys.length) {
        throw goog.iter.StopIteration;
      }
      var key = keys[i++];
      return opt_keys ? key : map[key]
    }
  };
  return newIter
};
goog.structs.Map.hasKey_ = function(obj, key) {
  return Object.prototype.hasOwnProperty.call(obj, key)
};
goog.provide("goog.structs.Set");
goog.require("goog.structs");
goog.require("goog.structs.Map");
goog.structs.Set = function(opt_values) {
  this.map_ = new goog.structs.Map;
  if(opt_values) {
    this.addAll(opt_values)
  }
};
goog.structs.Set.getKey_ = function(val) {
  var type = typeof val;
  if(type == "object" && val || type == "function") {
    return"o" + goog.getUid(val)
  }else {
    return type.substr(0, 1) + val
  }
};
goog.structs.Set.prototype.getCount = function() {
  return this.map_.getCount()
};
goog.structs.Set.prototype.add = function(element) {
  this.map_.set(goog.structs.Set.getKey_(element), element)
};
goog.structs.Set.prototype.addAll = function(col) {
  var values = goog.structs.getValues(col);
  var l = values.length;
  for(var i = 0;i < l;i++) {
    this.add(values[i])
  }
};
goog.structs.Set.prototype.removeAll = function(col) {
  var values = goog.structs.getValues(col);
  var l = values.length;
  for(var i = 0;i < l;i++) {
    this.remove(values[i])
  }
};
goog.structs.Set.prototype.remove = function(element) {
  return this.map_.remove(goog.structs.Set.getKey_(element))
};
goog.structs.Set.prototype.clear = function() {
  this.map_.clear()
};
goog.structs.Set.prototype.isEmpty = function() {
  return this.map_.isEmpty()
};
goog.structs.Set.prototype.contains = function(element) {
  return this.map_.containsKey(goog.structs.Set.getKey_(element))
};
goog.structs.Set.prototype.containsAll = function(col) {
  return goog.structs.every(col, this.contains, this)
};
goog.structs.Set.prototype.intersection = function(col) {
  var result = new goog.structs.Set;
  var values = goog.structs.getValues(col);
  for(var i = 0;i < values.length;i++) {
    var value = values[i];
    if(this.contains(value)) {
      result.add(value)
    }
  }
  return result
};
goog.structs.Set.prototype.getValues = function() {
  return this.map_.getValues()
};
goog.structs.Set.prototype.clone = function() {
  return new goog.structs.Set(this)
};
goog.structs.Set.prototype.equals = function(col) {
  return this.getCount() == goog.structs.getCount(col) && this.isSubsetOf(col)
};
goog.structs.Set.prototype.isSubsetOf = function(col) {
  var colCount = goog.structs.getCount(col);
  if(this.getCount() > colCount) {
    return false
  }
  if(!(col instanceof goog.structs.Set) && colCount > 5) {
    col = new goog.structs.Set(col)
  }
  return goog.structs.every(this, function(value) {
    return goog.structs.contains(col, value)
  })
};
goog.structs.Set.prototype.__iterator__ = function(opt_keys) {
  return this.map_.__iterator__(false)
};
goog.provide("goog.debug");
goog.require("goog.array");
goog.require("goog.string");
goog.require("goog.structs.Set");
goog.debug.catchErrors = function(logFunc, opt_cancel, opt_target) {
  var target = opt_target || goog.global;
  var oldErrorHandler = target.onerror;
  target.onerror = function(message, url, line) {
    if(oldErrorHandler) {
      oldErrorHandler(message, url, line)
    }
    logFunc({message:message, fileName:url, line:line});
    return Boolean(opt_cancel)
  }
};
goog.debug.expose = function(obj, opt_showFn) {
  if(typeof obj == "undefined") {
    return"undefined"
  }
  if(obj == null) {
    return"NULL"
  }
  var str = [];
  for(var x in obj) {
    if(!opt_showFn && goog.isFunction(obj[x])) {
      continue
    }
    var s = x + " = ";
    try {
      s += obj[x]
    }catch(e) {
      s += "*** " + e + " ***"
    }
    str.push(s)
  }
  return str.join("\n")
};
goog.debug.deepExpose = function(obj, opt_showFn) {
  var previous = new goog.structs.Set;
  var str = [];
  var helper = function(obj, space) {
    var nestspace = space + "  ";
    var indentMultiline = function(str) {
      return str.replace(/\n/g, "\n" + space)
    };
    try {
      if(!goog.isDef(obj)) {
        str.push("undefined")
      }else {
        if(goog.isNull(obj)) {
          str.push("NULL")
        }else {
          if(goog.isString(obj)) {
            str.push('"' + indentMultiline(obj) + '"')
          }else {
            if(goog.isFunction(obj)) {
              str.push(indentMultiline(String(obj)))
            }else {
              if(goog.isObject(obj)) {
                if(previous.contains(obj)) {
                  str.push("*** reference loop detected ***")
                }else {
                  previous.add(obj);
                  str.push("{");
                  for(var x in obj) {
                    if(!opt_showFn && goog.isFunction(obj[x])) {
                      continue
                    }
                    str.push("\n");
                    str.push(nestspace);
                    str.push(x + " = ");
                    helper(obj[x], nestspace)
                  }
                  str.push("\n" + space + "}")
                }
              }else {
                str.push(obj)
              }
            }
          }
        }
      }
    }catch(e) {
      str.push("*** " + e + " ***")
    }
  };
  helper(obj, "");
  return str.join("")
};
goog.debug.exposeArray = function(arr) {
  var str = [];
  for(var i = 0;i < arr.length;i++) {
    if(goog.isArray(arr[i])) {
      str.push(goog.debug.exposeArray(arr[i]))
    }else {
      str.push(arr[i])
    }
  }
  return"[ " + str.join(", ") + " ]"
};
goog.debug.exposeException = function(err, opt_fn) {
  try {
    var e = goog.debug.normalizeErrorObject(err);
    var error = "Message: " + goog.string.htmlEscape(e.message) + '\nUrl: <a href="view-source:' + e.fileName + '" target="_new">' + e.fileName + "</a>\nLine: " + e.lineNumber + "\n\nBrowser stack:\n" + goog.string.htmlEscape(e.stack + "-> ") + "[end]\n\nJS stack traversal:\n" + goog.string.htmlEscape(goog.debug.getStacktrace(opt_fn) + "-> ");
    return error
  }catch(e2) {
    return"Exception trying to expose exception! You win, we lose. " + e2
  }
};
goog.debug.normalizeErrorObject = function(err) {
  var href = goog.getObjectByName("window.location.href");
  if(goog.isString(err)) {
    return{"message":err, "name":"Unknown error", "lineNumber":"Not available", "fileName":href, "stack":"Not available"}
  }
  var lineNumber, fileName;
  var threwError = false;
  try {
    lineNumber = err.lineNumber || err.line || "Not available"
  }catch(e) {
    lineNumber = "Not available";
    threwError = true
  }
  try {
    fileName = err.fileName || err.filename || err.sourceURL || href
  }catch(e) {
    fileName = "Not available";
    threwError = true
  }
  if(threwError || !err.lineNumber || !err.fileName || !err.stack) {
    return{"message":err.message, "name":err.name, "lineNumber":lineNumber, "fileName":fileName, "stack":err.stack || "Not available"}
  }
  return err
};
goog.debug.enhanceError = function(err, opt_message) {
  var error = typeof err == "string" ? Error(err) : err;
  if(!error.stack) {
    error.stack = goog.debug.getStacktrace(arguments.callee.caller)
  }
  if(opt_message) {
    var x = 0;
    while(error["message" + x]) {
      ++x
    }
    error["message" + x] = String(opt_message)
  }
  return error
};
goog.debug.getStacktraceSimple = function(opt_depth) {
  var sb = [];
  var fn = arguments.callee.caller;
  var depth = 0;
  while(fn && (!opt_depth || depth < opt_depth)) {
    sb.push(goog.debug.getFunctionName(fn));
    sb.push("()\n");
    try {
      fn = fn.caller
    }catch(e) {
      sb.push("[exception trying to get caller]\n");
      break
    }
    depth++;
    if(depth >= goog.debug.MAX_STACK_DEPTH) {
      sb.push("[...long stack...]");
      break
    }
  }
  if(opt_depth && depth >= opt_depth) {
    sb.push("[...reached max depth limit...]")
  }else {
    sb.push("[end]")
  }
  return sb.join("")
};
goog.debug.MAX_STACK_DEPTH = 50;
goog.debug.getStacktrace = function(opt_fn) {
  return goog.debug.getStacktraceHelper_(opt_fn || arguments.callee.caller, [])
};
goog.debug.getStacktraceHelper_ = function(fn, visited) {
  var sb = [];
  if(goog.array.contains(visited, fn)) {
    sb.push("[...circular reference...]")
  }else {
    if(fn && visited.length < goog.debug.MAX_STACK_DEPTH) {
      sb.push(goog.debug.getFunctionName(fn) + "(");
      var args = fn.arguments;
      for(var i = 0;i < args.length;i++) {
        if(i > 0) {
          sb.push(", ")
        }
        var argDesc;
        var arg = args[i];
        switch(typeof arg) {
          case "object":
            argDesc = arg ? "object" : "null";
            break;
          case "string":
            argDesc = arg;
            break;
          case "number":
            argDesc = String(arg);
            break;
          case "boolean":
            argDesc = arg ? "true" : "false";
            break;
          case "function":
            argDesc = goog.debug.getFunctionName(arg);
            argDesc = argDesc ? argDesc : "[fn]";
            break;
          case "undefined":
          ;
          default:
            argDesc = typeof arg;
            break
        }
        if(argDesc.length > 40) {
          argDesc = argDesc.substr(0, 40) + "..."
        }
        sb.push(argDesc)
      }
      visited.push(fn);
      sb.push(")\n");
      try {
        sb.push(goog.debug.getStacktraceHelper_(fn.caller, visited))
      }catch(e) {
        sb.push("[exception trying to get caller]\n")
      }
    }else {
      if(fn) {
        sb.push("[...long stack...]")
      }else {
        sb.push("[end]")
      }
    }
  }
  return sb.join("")
};
goog.debug.getFunctionName = function(fn) {
  var functionSource = String(fn);
  if(!goog.debug.fnNameCache_[functionSource]) {
    var matches = /function ([^\(]+)/.exec(functionSource);
    if(matches) {
      var method = matches[1];
      goog.debug.fnNameCache_[functionSource] = method
    }else {
      goog.debug.fnNameCache_[functionSource] = "[Anonymous]"
    }
  }
  return goog.debug.fnNameCache_[functionSource]
};
goog.debug.makeWhitespaceVisible = function(string) {
  return string.replace(/ /g, "[_]").replace(/\f/g, "[f]").replace(/\n/g, "[n]\n").replace(/\r/g, "[r]").replace(/\t/g, "[t]")
};
goog.debug.fnNameCache_ = {};
goog.provide("goog.debug.LogRecord");
goog.debug.LogRecord = function(level, msg, loggerName, opt_time, opt_sequenceNumber) {
  this.reset(level, msg, loggerName, opt_time, opt_sequenceNumber)
};
goog.debug.LogRecord.prototype.time_;
goog.debug.LogRecord.prototype.level_;
goog.debug.LogRecord.prototype.msg_;
goog.debug.LogRecord.prototype.loggerName_;
goog.debug.LogRecord.prototype.sequenceNumber_ = 0;
goog.debug.LogRecord.prototype.exception_ = null;
goog.debug.LogRecord.prototype.exceptionText_ = null;
goog.debug.LogRecord.ENABLE_SEQUENCE_NUMBERS = true;
goog.debug.LogRecord.nextSequenceNumber_ = 0;
goog.debug.LogRecord.prototype.reset = function(level, msg, loggerName, opt_time, opt_sequenceNumber) {
  if(goog.debug.LogRecord.ENABLE_SEQUENCE_NUMBERS) {
    this.sequenceNumber_ = typeof opt_sequenceNumber == "number" ? opt_sequenceNumber : goog.debug.LogRecord.nextSequenceNumber_++
  }
  this.time_ = opt_time || goog.now();
  this.level_ = level;
  this.msg_ = msg;
  this.loggerName_ = loggerName;
  delete this.exception_;
  delete this.exceptionText_
};
goog.debug.LogRecord.prototype.getLoggerName = function() {
  return this.loggerName_
};
goog.debug.LogRecord.prototype.getException = function() {
  return this.exception_
};
goog.debug.LogRecord.prototype.setException = function(exception) {
  this.exception_ = exception
};
goog.debug.LogRecord.prototype.getExceptionText = function() {
  return this.exceptionText_
};
goog.debug.LogRecord.prototype.setExceptionText = function(text) {
  this.exceptionText_ = text
};
goog.debug.LogRecord.prototype.setLoggerName = function(loggerName) {
  this.loggerName_ = loggerName
};
goog.debug.LogRecord.prototype.getLevel = function() {
  return this.level_
};
goog.debug.LogRecord.prototype.setLevel = function(level) {
  this.level_ = level
};
goog.debug.LogRecord.prototype.getMessage = function() {
  return this.msg_
};
goog.debug.LogRecord.prototype.setMessage = function(msg) {
  this.msg_ = msg
};
goog.debug.LogRecord.prototype.getMillis = function() {
  return this.time_
};
goog.debug.LogRecord.prototype.setMillis = function(time) {
  this.time_ = time
};
goog.debug.LogRecord.prototype.getSequenceNumber = function() {
  return this.sequenceNumber_
};
goog.provide("goog.debug.LogBuffer");
goog.require("goog.asserts");
goog.require("goog.debug.LogRecord");
goog.debug.LogBuffer = function() {
  goog.asserts.assert(goog.debug.LogBuffer.isBufferingEnabled(), "Cannot use goog.debug.LogBuffer without defining " + "goog.debug.LogBuffer.CAPACITY.");
  this.clear()
};
goog.debug.LogBuffer.getInstance = function() {
  if(!goog.debug.LogBuffer.instance_) {
    goog.debug.LogBuffer.instance_ = new goog.debug.LogBuffer
  }
  return goog.debug.LogBuffer.instance_
};
goog.debug.LogBuffer.CAPACITY = 0;
goog.debug.LogBuffer.prototype.buffer_;
goog.debug.LogBuffer.prototype.curIndex_;
goog.debug.LogBuffer.prototype.isFull_;
goog.debug.LogBuffer.prototype.addRecord = function(level, msg, loggerName) {
  var curIndex = (this.curIndex_ + 1) % goog.debug.LogBuffer.CAPACITY;
  this.curIndex_ = curIndex;
  if(this.isFull_) {
    var ret = this.buffer_[curIndex];
    ret.reset(level, msg, loggerName);
    return ret
  }
  this.isFull_ = curIndex == goog.debug.LogBuffer.CAPACITY - 1;
  return this.buffer_[curIndex] = new goog.debug.LogRecord(level, msg, loggerName)
};
goog.debug.LogBuffer.isBufferingEnabled = function() {
  return goog.debug.LogBuffer.CAPACITY > 0
};
goog.debug.LogBuffer.prototype.clear = function() {
  this.buffer_ = new Array(goog.debug.LogBuffer.CAPACITY);
  this.curIndex_ = -1;
  this.isFull_ = false
};
goog.debug.LogBuffer.prototype.forEachRecord = function(func) {
  var buffer = this.buffer_;
  if(!buffer[0]) {
    return
  }
  var curIndex = this.curIndex_;
  var i = this.isFull_ ? curIndex : -1;
  do {
    i = (i + 1) % goog.debug.LogBuffer.CAPACITY;
    func(buffer[i])
  }while(i != curIndex)
};
goog.provide("goog.debug.LogManager");
goog.provide("goog.debug.Logger");
goog.provide("goog.debug.Logger.Level");
goog.require("goog.array");
goog.require("goog.asserts");
goog.require("goog.debug");
goog.require("goog.debug.LogBuffer");
goog.require("goog.debug.LogRecord");
goog.debug.Logger = function(name) {
  this.name_ = name
};
goog.debug.Logger.prototype.parent_ = null;
goog.debug.Logger.prototype.level_ = null;
goog.debug.Logger.prototype.children_ = null;
goog.debug.Logger.prototype.handlers_ = null;
goog.debug.Logger.ENABLE_HIERARCHY = true;
if(!goog.debug.Logger.ENABLE_HIERARCHY) {
  goog.debug.Logger.rootHandlers_ = [];
  goog.debug.Logger.rootLevel_
}
goog.debug.Logger.Level = function(name, value) {
  this.name = name;
  this.value = value
};
goog.debug.Logger.Level.prototype.toString = function() {
  return this.name
};
goog.debug.Logger.Level.OFF = new goog.debug.Logger.Level("OFF", Infinity);
goog.debug.Logger.Level.SHOUT = new goog.debug.Logger.Level("SHOUT", 1200);
goog.debug.Logger.Level.SEVERE = new goog.debug.Logger.Level("SEVERE", 1E3);
goog.debug.Logger.Level.WARNING = new goog.debug.Logger.Level("WARNING", 900);
goog.debug.Logger.Level.INFO = new goog.debug.Logger.Level("INFO", 800);
goog.debug.Logger.Level.CONFIG = new goog.debug.Logger.Level("CONFIG", 700);
goog.debug.Logger.Level.FINE = new goog.debug.Logger.Level("FINE", 500);
goog.debug.Logger.Level.FINER = new goog.debug.Logger.Level("FINER", 400);
goog.debug.Logger.Level.FINEST = new goog.debug.Logger.Level("FINEST", 300);
goog.debug.Logger.Level.ALL = new goog.debug.Logger.Level("ALL", 0);
goog.debug.Logger.Level.PREDEFINED_LEVELS = [goog.debug.Logger.Level.OFF, goog.debug.Logger.Level.SHOUT, goog.debug.Logger.Level.SEVERE, goog.debug.Logger.Level.WARNING, goog.debug.Logger.Level.INFO, goog.debug.Logger.Level.CONFIG, goog.debug.Logger.Level.FINE, goog.debug.Logger.Level.FINER, goog.debug.Logger.Level.FINEST, goog.debug.Logger.Level.ALL];
goog.debug.Logger.Level.predefinedLevelsCache_ = null;
goog.debug.Logger.Level.createPredefinedLevelsCache_ = function() {
  goog.debug.Logger.Level.predefinedLevelsCache_ = {};
  for(var i = 0, level;level = goog.debug.Logger.Level.PREDEFINED_LEVELS[i];i++) {
    goog.debug.Logger.Level.predefinedLevelsCache_[level.value] = level;
    goog.debug.Logger.Level.predefinedLevelsCache_[level.name] = level
  }
};
goog.debug.Logger.Level.getPredefinedLevel = function(name) {
  if(!goog.debug.Logger.Level.predefinedLevelsCache_) {
    goog.debug.Logger.Level.createPredefinedLevelsCache_()
  }
  return goog.debug.Logger.Level.predefinedLevelsCache_[name] || null
};
goog.debug.Logger.Level.getPredefinedLevelByValue = function(value) {
  if(!goog.debug.Logger.Level.predefinedLevelsCache_) {
    goog.debug.Logger.Level.createPredefinedLevelsCache_()
  }
  if(value in goog.debug.Logger.Level.predefinedLevelsCache_) {
    return goog.debug.Logger.Level.predefinedLevelsCache_[value]
  }
  for(var i = 0;i < goog.debug.Logger.Level.PREDEFINED_LEVELS.length;++i) {
    var level = goog.debug.Logger.Level.PREDEFINED_LEVELS[i];
    if(level.value <= value) {
      return level
    }
  }
  return null
};
goog.debug.Logger.getLogger = function(name) {
  return goog.debug.LogManager.getLogger(name)
};
goog.debug.Logger.prototype.getName = function() {
  return this.name_
};
goog.debug.Logger.prototype.addHandler = function(handler) {
  if(goog.debug.Logger.ENABLE_HIERARCHY) {
    if(!this.handlers_) {
      this.handlers_ = []
    }
    this.handlers_.push(handler)
  }else {
    goog.asserts.assert(!this.name_, "Cannot call addHandler on a non-root logger when " + "goog.debug.Logger.ENABLE_HIERARCHY is false.");
    goog.debug.Logger.rootHandlers_.push(handler)
  }
};
goog.debug.Logger.prototype.removeHandler = function(handler) {
  var handlers = goog.debug.Logger.ENABLE_HIERARCHY ? this.handlers_ : goog.debug.Logger.rootHandlers_;
  return!!handlers && goog.array.remove(handlers, handler)
};
goog.debug.Logger.prototype.getParent = function() {
  return this.parent_
};
goog.debug.Logger.prototype.getChildren = function() {
  if(!this.children_) {
    this.children_ = {}
  }
  return this.children_
};
goog.debug.Logger.prototype.setLevel = function(level) {
  if(goog.debug.Logger.ENABLE_HIERARCHY) {
    this.level_ = level
  }else {
    goog.asserts.assert(!this.name_, "Cannot call setLevel() on a non-root logger when " + "goog.debug.Logger.ENABLE_HIERARCHY is false.");
    goog.debug.Logger.rootLevel_ = level
  }
};
goog.debug.Logger.prototype.getLevel = function() {
  return this.level_
};
goog.debug.Logger.prototype.getEffectiveLevel = function() {
  if(!goog.debug.Logger.ENABLE_HIERARCHY) {
    return goog.debug.Logger.rootLevel_
  }
  if(this.level_) {
    return this.level_
  }
  if(this.parent_) {
    return this.parent_.getEffectiveLevel()
  }
  goog.asserts.fail("Root logger has no level set.");
  return null
};
goog.debug.Logger.prototype.isLoggable = function(level) {
  return level.value >= this.getEffectiveLevel().value
};
goog.debug.Logger.prototype.log = function(level, msg, opt_exception) {
  if(this.isLoggable(level)) {
    this.doLogRecord_(this.getLogRecord(level, msg, opt_exception))
  }
};
goog.debug.Logger.prototype.getLogRecord = function(level, msg, opt_exception) {
  if(goog.debug.LogBuffer.isBufferingEnabled()) {
    var logRecord = goog.debug.LogBuffer.getInstance().addRecord(level, msg, this.name_)
  }else {
    logRecord = new goog.debug.LogRecord(level, String(msg), this.name_)
  }
  if(opt_exception) {
    logRecord.setException(opt_exception);
    logRecord.setExceptionText(goog.debug.exposeException(opt_exception, arguments.callee.caller))
  }
  return logRecord
};
goog.debug.Logger.prototype.shout = function(msg, opt_exception) {
  this.log(goog.debug.Logger.Level.SHOUT, msg, opt_exception)
};
goog.debug.Logger.prototype.severe = function(msg, opt_exception) {
  this.log(goog.debug.Logger.Level.SEVERE, msg, opt_exception)
};
goog.debug.Logger.prototype.warning = function(msg, opt_exception) {
  this.log(goog.debug.Logger.Level.WARNING, msg, opt_exception)
};
goog.debug.Logger.prototype.info = function(msg, opt_exception) {
  this.log(goog.debug.Logger.Level.INFO, msg, opt_exception)
};
goog.debug.Logger.prototype.config = function(msg, opt_exception) {
  this.log(goog.debug.Logger.Level.CONFIG, msg, opt_exception)
};
goog.debug.Logger.prototype.fine = function(msg, opt_exception) {
  this.log(goog.debug.Logger.Level.FINE, msg, opt_exception)
};
goog.debug.Logger.prototype.finer = function(msg, opt_exception) {
  this.log(goog.debug.Logger.Level.FINER, msg, opt_exception)
};
goog.debug.Logger.prototype.finest = function(msg, opt_exception) {
  this.log(goog.debug.Logger.Level.FINEST, msg, opt_exception)
};
goog.debug.Logger.prototype.logRecord = function(logRecord) {
  if(this.isLoggable(logRecord.getLevel())) {
    this.doLogRecord_(logRecord)
  }
};
goog.debug.Logger.prototype.logToSpeedTracer_ = function(msg) {
  if(goog.global["console"] && goog.global["console"]["markTimeline"]) {
    goog.global["console"]["markTimeline"](msg)
  }
};
goog.debug.Logger.prototype.doLogRecord_ = function(logRecord) {
  this.logToSpeedTracer_("log:" + logRecord.getMessage());
  if(goog.debug.Logger.ENABLE_HIERARCHY) {
    var target = this;
    while(target) {
      target.callPublish_(logRecord);
      target = target.getParent()
    }
  }else {
    for(var i = 0, handler;handler = goog.debug.Logger.rootHandlers_[i++];) {
      handler(logRecord)
    }
  }
};
goog.debug.Logger.prototype.callPublish_ = function(logRecord) {
  if(this.handlers_) {
    for(var i = 0, handler;handler = this.handlers_[i];i++) {
      handler(logRecord)
    }
  }
};
goog.debug.Logger.prototype.setParent_ = function(parent) {
  this.parent_ = parent
};
goog.debug.Logger.prototype.addChild_ = function(name, logger) {
  this.getChildren()[name] = logger
};
goog.debug.LogManager = {};
goog.debug.LogManager.loggers_ = {};
goog.debug.LogManager.rootLogger_ = null;
goog.debug.LogManager.initialize = function() {
  if(!goog.debug.LogManager.rootLogger_) {
    goog.debug.LogManager.rootLogger_ = new goog.debug.Logger("");
    goog.debug.LogManager.loggers_[""] = goog.debug.LogManager.rootLogger_;
    goog.debug.LogManager.rootLogger_.setLevel(goog.debug.Logger.Level.CONFIG)
  }
};
goog.debug.LogManager.getLoggers = function() {
  return goog.debug.LogManager.loggers_
};
goog.debug.LogManager.getRoot = function() {
  goog.debug.LogManager.initialize();
  return goog.debug.LogManager.rootLogger_
};
goog.debug.LogManager.getLogger = function(name) {
  goog.debug.LogManager.initialize();
  var ret = goog.debug.LogManager.loggers_[name];
  return ret || goog.debug.LogManager.createLogger_(name)
};
goog.debug.LogManager.createFunctionForCatchErrors = function(opt_logger) {
  return function(info) {
    var logger = opt_logger || goog.debug.LogManager.getRoot();
    logger.severe("Error: " + info.message + " (" + info.fileName + " @ Line: " + info.line + ")")
  }
};
goog.debug.LogManager.createLogger_ = function(name) {
  var logger = new goog.debug.Logger(name);
  if(goog.debug.Logger.ENABLE_HIERARCHY) {
    var lastDotIndex = name.lastIndexOf(".");
    var parentName = name.substr(0, lastDotIndex);
    var leafName = name.substr(lastDotIndex + 1);
    var parentLogger = goog.debug.LogManager.getLogger(parentName);
    parentLogger.addChild_(leafName, logger);
    logger.setParent_(parentLogger)
  }
  goog.debug.LogManager.loggers_[name] = logger;
  return logger
};
goog.provide("goog.json");
goog.provide("goog.json.Serializer");
goog.json.isValid_ = function(s) {
  if(/^\s*$/.test(s)) {
    return false
  }
  var backslashesRe = /\\["\\\/bfnrtu]/g;
  var simpleValuesRe = /"[^"\\\n\r\u2028\u2029\x00-\x08\x10-\x1f\x80-\x9f]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g;
  var openBracketsRe = /(?:^|:|,)(?:[\s\u2028\u2029]*\[)+/g;
  var remainderRe = /^[\],:{}\s\u2028\u2029]*$/;
  return remainderRe.test(s.replace(backslashesRe, "@").replace(simpleValuesRe, "]").replace(openBracketsRe, ""))
};
goog.json.parse = function(s) {
  var o = String(s);
  if(goog.json.isValid_(o)) {
    try {
      return eval("(" + o + ")")
    }catch(ex) {
    }
  }
  throw Error("Invalid JSON string: " + o);
};
goog.json.unsafeParse = function(s) {
  return eval("(" + s + ")")
};
goog.json.serialize = function(object) {
  return(new goog.json.Serializer).serialize(object)
};
goog.json.Serializer = function() {
};
goog.json.Serializer.prototype.serialize = function(object) {
  var sb = [];
  this.serialize_(object, sb);
  return sb.join("")
};
goog.json.Serializer.prototype.serialize_ = function(object, sb) {
  switch(typeof object) {
    case "string":
      this.serializeString_(object, sb);
      break;
    case "number":
      this.serializeNumber_(object, sb);
      break;
    case "boolean":
      sb.push(object);
      break;
    case "undefined":
      sb.push("null");
      break;
    case "object":
      if(object == null) {
        sb.push("null");
        break
      }
      if(goog.isArray(object)) {
        this.serializeArray_(object, sb);
        break
      }
      this.serializeObject_(object, sb);
      break;
    case "function":
      break;
    default:
      throw Error("Unknown type: " + typeof object);
  }
};
goog.json.Serializer.charToJsonCharCache_ = {'"':'\\"', "\\":"\\\\", "/":"\\/", "\u0008":"\\b", "\u000c":"\\f", "\n":"\\n", "\r":"\\r", "\t":"\\t", "\u000b":"\\u000b"};
goog.json.Serializer.charsToReplace_ = /\uffff/.test("\uffff") ? /[\\\"\x00-\x1f\x7f-\uffff]/g : /[\\\"\x00-\x1f\x7f-\xff]/g;
goog.json.Serializer.prototype.serializeString_ = function(s, sb) {
  sb.push('"', s.replace(goog.json.Serializer.charsToReplace_, function(c) {
    if(c in goog.json.Serializer.charToJsonCharCache_) {
      return goog.json.Serializer.charToJsonCharCache_[c]
    }
    var cc = c.charCodeAt(0);
    var rv = "\\u";
    if(cc < 16) {
      rv += "000"
    }else {
      if(cc < 256) {
        rv += "00"
      }else {
        if(cc < 4096) {
          rv += "0"
        }
      }
    }
    return goog.json.Serializer.charToJsonCharCache_[c] = rv + cc.toString(16)
  }), '"')
};
goog.json.Serializer.prototype.serializeNumber_ = function(n, sb) {
  sb.push(isFinite(n) && !isNaN(n) ? n : "null")
};
goog.json.Serializer.prototype.serializeArray_ = function(arr, sb) {
  var l = arr.length;
  sb.push("[");
  var sep = "";
  for(var i = 0;i < l;i++) {
    sb.push(sep);
    this.serialize_(arr[i], sb);
    sep = ","
  }
  sb.push("]")
};
goog.json.Serializer.prototype.serializeObject_ = function(obj, sb) {
  sb.push("{");
  var sep = "";
  for(var key in obj) {
    if(Object.prototype.hasOwnProperty.call(obj, key)) {
      var value = obj[key];
      if(typeof value != "function") {
        sb.push(sep);
        this.serializeString_(key, sb);
        sb.push(":");
        this.serialize_(value, sb);
        sep = ","
      }
    }
  }
  sb.push("}")
};
goog.provide("goog.net.ErrorCode");
goog.net.ErrorCode = {NO_ERROR:0, ACCESS_DENIED:1, FILE_NOT_FOUND:2, FF_SILENT_ERROR:3, CUSTOM_ERROR:4, EXCEPTION:5, HTTP_ERROR:6, ABORT:7, TIMEOUT:8, OFFLINE:9};
goog.net.ErrorCode.getDebugMessage = function(errorCode) {
  switch(errorCode) {
    case goog.net.ErrorCode.NO_ERROR:
      return"No Error";
    case goog.net.ErrorCode.ACCESS_DENIED:
      return"Access denied to content document";
    case goog.net.ErrorCode.FILE_NOT_FOUND:
      return"File not found";
    case goog.net.ErrorCode.FF_SILENT_ERROR:
      return"Firefox silently errored";
    case goog.net.ErrorCode.CUSTOM_ERROR:
      return"Application custom error";
    case goog.net.ErrorCode.EXCEPTION:
      return"An exception occurred";
    case goog.net.ErrorCode.HTTP_ERROR:
      return"Http response at 400 or 500 level";
    case goog.net.ErrorCode.ABORT:
      return"Request was aborted";
    case goog.net.ErrorCode.TIMEOUT:
      return"Request timed out";
    case goog.net.ErrorCode.OFFLINE:
      return"The resource is not available offline";
    default:
      return"Unrecognized error code"
  }
};
goog.provide("goog.net.EventType");
goog.net.EventType = {COMPLETE:"complete", SUCCESS:"success", ERROR:"error", ABORT:"abort", READY:"ready", READY_STATE_CHANGE:"readystatechange", TIMEOUT:"timeout", INCREMENTAL_DATA:"incrementaldata", PROGRESS:"progress"};
goog.provide("goog.net.HttpStatus");
goog.net.HttpStatus = {CONTINUE:100, SWITCHING_PROTOCOLS:101, OK:200, CREATED:201, ACCEPTED:202, NON_AUTHORITATIVE_INFORMATION:203, NO_CONTENT:204, RESET_CONTENT:205, PARTIAL_CONTENT:206, MULTIPLE_CHOICES:300, MOVED_PERMANENTLY:301, FOUND:302, SEE_OTHER:303, NOT_MODIFIED:304, USE_PROXY:305, TEMPORARY_REDIRECT:307, BAD_REQUEST:400, UNAUTHORIZED:401, PAYMENT_REQUIRED:402, FORBIDDEN:403, NOT_FOUND:404, METHOD_NOT_ALLOWED:405, NOT_ACCEPTABLE:406, PROXY_AUTHENTICATION_REQUIRED:407, REQUEST_TIMEOUT:408, 
CONFLICT:409, GONE:410, LENGTH_REQUIRED:411, PRECONDITION_FAILED:412, REQUEST_ENTITY_TOO_LARGE:413, REQUEST_URI_TOO_LONG:414, UNSUPPORTED_MEDIA_TYPE:415, REQUEST_RANGE_NOT_SATISFIABLE:416, EXPECTATION_FAILED:417, INTERNAL_SERVER_ERROR:500, NOT_IMPLEMENTED:501, BAD_GATEWAY:502, SERVICE_UNAVAILABLE:503, GATEWAY_TIMEOUT:504, HTTP_VERSION_NOT_SUPPORTED:505};
goog.provide("goog.net.XmlHttpFactory");
goog.net.XmlHttpFactory = function() {
};
goog.net.XmlHttpFactory.prototype.cachedOptions_ = null;
goog.net.XmlHttpFactory.prototype.createInstance = goog.abstractMethod;
goog.net.XmlHttpFactory.prototype.getOptions = function() {
  return this.cachedOptions_ || (this.cachedOptions_ = this.internalGetOptions())
};
goog.net.XmlHttpFactory.prototype.internalGetOptions = goog.abstractMethod;
goog.provide("goog.net.WrapperXmlHttpFactory");
goog.require("goog.net.XmlHttpFactory");
goog.net.WrapperXmlHttpFactory = function(xhrFactory, optionsFactory) {
  goog.net.XmlHttpFactory.call(this);
  this.xhrFactory_ = xhrFactory;
  this.optionsFactory_ = optionsFactory
};
goog.inherits(goog.net.WrapperXmlHttpFactory, goog.net.XmlHttpFactory);
goog.net.WrapperXmlHttpFactory.prototype.createInstance = function() {
  return this.xhrFactory_()
};
goog.net.WrapperXmlHttpFactory.prototype.getOptions = function() {
  return this.optionsFactory_()
};
goog.provide("goog.net.DefaultXmlHttpFactory");
goog.provide("goog.net.XmlHttp");
goog.provide("goog.net.XmlHttp.OptionType");
goog.provide("goog.net.XmlHttp.ReadyState");
goog.require("goog.net.WrapperXmlHttpFactory");
goog.require("goog.net.XmlHttpFactory");
goog.net.XmlHttp = function() {
  return goog.net.XmlHttp.factory_.createInstance()
};
goog.net.XmlHttp.getOptions = function() {
  return goog.net.XmlHttp.factory_.getOptions()
};
goog.net.XmlHttp.OptionType = {USE_NULL_FUNCTION:0, LOCAL_REQUEST_ERROR:1};
goog.net.XmlHttp.ReadyState = {UNINITIALIZED:0, LOADING:1, LOADED:2, INTERACTIVE:3, COMPLETE:4};
goog.net.XmlHttp.factory_;
goog.net.XmlHttp.setFactory = function(factory, optionsFactory) {
  goog.net.XmlHttp.setGlobalFactory(new goog.net.WrapperXmlHttpFactory(factory, optionsFactory))
};
goog.net.XmlHttp.setGlobalFactory = function(factory) {
  goog.net.XmlHttp.factory_ = factory
};
goog.net.DefaultXmlHttpFactory = function() {
  goog.net.XmlHttpFactory.call(this)
};
goog.inherits(goog.net.DefaultXmlHttpFactory, goog.net.XmlHttpFactory);
goog.net.DefaultXmlHttpFactory.prototype.createInstance = function() {
  var progId = this.getProgId_();
  if(progId) {
    return new ActiveXObject(progId)
  }else {
    return new XMLHttpRequest
  }
};
goog.net.DefaultXmlHttpFactory.prototype.internalGetOptions = function() {
  var progId = this.getProgId_();
  var options = {};
  if(progId) {
    options[goog.net.XmlHttp.OptionType.USE_NULL_FUNCTION] = true;
    options[goog.net.XmlHttp.OptionType.LOCAL_REQUEST_ERROR] = true
  }
  return options
};
goog.net.DefaultXmlHttpFactory.prototype.ieProgId_ = null;
goog.net.DefaultXmlHttpFactory.prototype.getProgId_ = function() {
  if(!this.ieProgId_ && typeof XMLHttpRequest == "undefined" && typeof ActiveXObject != "undefined") {
    var ACTIVE_X_IDENTS = ["MSXML2.XMLHTTP.6.0", "MSXML2.XMLHTTP.3.0", "MSXML2.XMLHTTP", "Microsoft.XMLHTTP"];
    for(var i = 0;i < ACTIVE_X_IDENTS.length;i++) {
      var candidate = ACTIVE_X_IDENTS[i];
      try {
        new ActiveXObject(candidate);
        this.ieProgId_ = candidate;
        return candidate
      }catch(e) {
      }
    }
    throw Error("Could not create ActiveXObject. ActiveX might be disabled," + " or MSXML might not be installed");
  }
  return this.ieProgId_
};
goog.net.XmlHttp.setGlobalFactory(new goog.net.DefaultXmlHttpFactory);
goog.provide("goog.net.xhrMonitor");
goog.require("goog.array");
goog.require("goog.debug.Logger");
goog.require("goog.userAgent");
goog.net.XhrMonitor_ = function() {
  if(!goog.userAgent.GECKO) {
    return
  }
  this.contextsToXhr_ = {};
  this.xhrToContexts_ = {};
  this.stack_ = []
};
goog.net.XhrMonitor_.getKey = function(obj) {
  return goog.isString(obj) ? obj : goog.isObject(obj) ? goog.getUid(obj) : ""
};
goog.net.XhrMonitor_.prototype.logger_ = goog.debug.Logger.getLogger("goog.net.xhrMonitor");
goog.net.XhrMonitor_.prototype.enabled_ = goog.userAgent.GECKO;
goog.net.XhrMonitor_.prototype.setEnabled = function(val) {
  this.enabled_ = goog.userAgent.GECKO && val
};
goog.net.XhrMonitor_.prototype.pushContext = function(context) {
  if(!this.enabled_) {
    return
  }
  var key = goog.net.XhrMonitor_.getKey(context);
  this.logger_.finest("Pushing context: " + context + " (" + key + ")");
  this.stack_.push(key)
};
goog.net.XhrMonitor_.prototype.popContext = function() {
  if(!this.enabled_) {
    return
  }
  var context = this.stack_.pop();
  this.logger_.finest("Popping context: " + context);
  this.updateDependentContexts_(context)
};
goog.net.XhrMonitor_.prototype.isContextSafe = function(context) {
  if(!this.enabled_) {
    return true
  }
  var deps = this.contextsToXhr_[goog.net.XhrMonitor_.getKey(context)];
  this.logger_.fine("Context is safe : " + context + " - " + deps);
  return!deps
};
goog.net.XhrMonitor_.prototype.markXhrOpen = function(xhr) {
  if(!this.enabled_) {
    return
  }
  var uid = goog.getUid(xhr);
  this.logger_.fine("Opening XHR : " + uid);
  for(var i = 0;i < this.stack_.length;i++) {
    var context = this.stack_[i];
    this.addToMap_(this.contextsToXhr_, context, uid);
    this.addToMap_(this.xhrToContexts_, uid, context)
  }
};
goog.net.XhrMonitor_.prototype.markXhrClosed = function(xhr) {
  if(!this.enabled_) {
    return
  }
  var uid = goog.getUid(xhr);
  this.logger_.fine("Closing XHR : " + uid);
  delete this.xhrToContexts_[uid];
  for(var context in this.contextsToXhr_) {
    goog.array.remove(this.contextsToXhr_[context], uid);
    if(this.contextsToXhr_[context].length == 0) {
      delete this.contextsToXhr_[context]
    }
  }
};
goog.net.XhrMonitor_.prototype.updateDependentContexts_ = function(xhrUid) {
  var contexts = this.xhrToContexts_[xhrUid];
  var xhrs = this.contextsToXhr_[xhrUid];
  if(contexts && xhrs) {
    this.logger_.finest("Updating dependent contexts");
    goog.array.forEach(contexts, function(context) {
      goog.array.forEach(xhrs, function(xhr) {
        this.addToMap_(this.contextsToXhr_, context, xhr);
        this.addToMap_(this.xhrToContexts_, xhr, context)
      }, this)
    }, this)
  }
};
goog.net.XhrMonitor_.prototype.addToMap_ = function(map, key, value) {
  if(!map[key]) {
    map[key] = []
  }
  if(!goog.array.contains(map[key], value)) {
    map[key].push(value)
  }
};
goog.net.xhrMonitor = new goog.net.XhrMonitor_;
goog.provide("goog.uri.utils");
goog.provide("goog.uri.utils.ComponentIndex");
goog.require("goog.asserts");
goog.require("goog.string");
goog.uri.utils.CharCode_ = {AMPERSAND:38, EQUAL:61, HASH:35, QUESTION:63};
goog.uri.utils.buildFromEncodedParts = function(opt_scheme, opt_userInfo, opt_domain, opt_port, opt_path, opt_queryData, opt_fragment) {
  var out = [];
  if(opt_scheme) {
    out.push(opt_scheme, ":")
  }
  if(opt_domain) {
    out.push("//");
    if(opt_userInfo) {
      out.push(opt_userInfo, "@")
    }
    out.push(opt_domain);
    if(opt_port) {
      out.push(":", opt_port)
    }
  }
  if(opt_path) {
    out.push(opt_path)
  }
  if(opt_queryData) {
    out.push("?", opt_queryData)
  }
  if(opt_fragment) {
    out.push("#", opt_fragment)
  }
  return out.join("")
};
goog.uri.utils.splitRe_ = new RegExp("^" + "(?:" + "([^:/?#.]+)" + ":)?" + "(?://" + "(?:([^/?#]*)@)?" + "([\\w\\d\\-\\u0100-\\uffff.%]*)" + "(?::([0-9]+))?" + ")?" + "([^?#]+)?" + "(?:\\?([^#]*))?" + "(?:#(.*))?" + "$");
goog.uri.utils.ComponentIndex = {SCHEME:1, USER_INFO:2, DOMAIN:3, PORT:4, PATH:5, QUERY_DATA:6, FRAGMENT:7};
goog.uri.utils.split = function(uri) {
  return uri.match(goog.uri.utils.splitRe_)
};
goog.uri.utils.decodeIfPossible_ = function(uri) {
  return uri && decodeURIComponent(uri)
};
goog.uri.utils.getComponentByIndex_ = function(componentIndex, uri) {
  return goog.uri.utils.split(uri)[componentIndex] || null
};
goog.uri.utils.getScheme = function(uri) {
  return goog.uri.utils.getComponentByIndex_(goog.uri.utils.ComponentIndex.SCHEME, uri)
};
goog.uri.utils.getUserInfoEncoded = function(uri) {
  return goog.uri.utils.getComponentByIndex_(goog.uri.utils.ComponentIndex.USER_INFO, uri)
};
goog.uri.utils.getUserInfo = function(uri) {
  return goog.uri.utils.decodeIfPossible_(goog.uri.utils.getUserInfoEncoded(uri))
};
goog.uri.utils.getDomainEncoded = function(uri) {
  return goog.uri.utils.getComponentByIndex_(goog.uri.utils.ComponentIndex.DOMAIN, uri)
};
goog.uri.utils.getDomain = function(uri) {
  return goog.uri.utils.decodeIfPossible_(goog.uri.utils.getDomainEncoded(uri))
};
goog.uri.utils.getPort = function(uri) {
  return Number(goog.uri.utils.getComponentByIndex_(goog.uri.utils.ComponentIndex.PORT, uri)) || null
};
goog.uri.utils.getPathEncoded = function(uri) {
  return goog.uri.utils.getComponentByIndex_(goog.uri.utils.ComponentIndex.PATH, uri)
};
goog.uri.utils.getPath = function(uri) {
  return goog.uri.utils.decodeIfPossible_(goog.uri.utils.getPathEncoded(uri))
};
goog.uri.utils.getQueryData = function(uri) {
  return goog.uri.utils.getComponentByIndex_(goog.uri.utils.ComponentIndex.QUERY_DATA, uri)
};
goog.uri.utils.getFragmentEncoded = function(uri) {
  var hashIndex = uri.indexOf("#");
  return hashIndex < 0 ? null : uri.substr(hashIndex + 1)
};
goog.uri.utils.setFragmentEncoded = function(uri, fragment) {
  return goog.uri.utils.removeFragment(uri) + (fragment ? "#" + fragment : "")
};
goog.uri.utils.getFragment = function(uri) {
  return goog.uri.utils.decodeIfPossible_(goog.uri.utils.getFragmentEncoded(uri))
};
goog.uri.utils.getHost = function(uri) {
  var pieces = goog.uri.utils.split(uri);
  return goog.uri.utils.buildFromEncodedParts(pieces[goog.uri.utils.ComponentIndex.SCHEME], pieces[goog.uri.utils.ComponentIndex.USER_INFO], pieces[goog.uri.utils.ComponentIndex.DOMAIN], pieces[goog.uri.utils.ComponentIndex.PORT])
};
goog.uri.utils.getPathAndAfter = function(uri) {
  var pieces = goog.uri.utils.split(uri);
  return goog.uri.utils.buildFromEncodedParts(null, null, null, null, pieces[goog.uri.utils.ComponentIndex.PATH], pieces[goog.uri.utils.ComponentIndex.QUERY_DATA], pieces[goog.uri.utils.ComponentIndex.FRAGMENT])
};
goog.uri.utils.removeFragment = function(uri) {
  var hashIndex = uri.indexOf("#");
  return hashIndex < 0 ? uri : uri.substr(0, hashIndex)
};
goog.uri.utils.haveSameDomain = function(uri1, uri2) {
  var pieces1 = goog.uri.utils.split(uri1);
  var pieces2 = goog.uri.utils.split(uri2);
  return pieces1[goog.uri.utils.ComponentIndex.DOMAIN] == pieces2[goog.uri.utils.ComponentIndex.DOMAIN] && pieces1[goog.uri.utils.ComponentIndex.SCHEME] == pieces2[goog.uri.utils.ComponentIndex.SCHEME] && pieces1[goog.uri.utils.ComponentIndex.PORT] == pieces2[goog.uri.utils.ComponentIndex.PORT]
};
goog.uri.utils.assertNoFragmentsOrQueries_ = function(uri) {
  if(goog.DEBUG && (uri.indexOf("#") >= 0 || uri.indexOf("?") >= 0)) {
    throw Error("goog.uri.utils: Fragment or query identifiers are not " + "supported: [" + uri + "]");
  }
};
goog.uri.utils.QueryValue;
goog.uri.utils.QueryArray;
goog.uri.utils.appendQueryData_ = function(buffer) {
  if(buffer[1]) {
    var baseUri = buffer[0];
    var hashIndex = baseUri.indexOf("#");
    if(hashIndex >= 0) {
      buffer.push(baseUri.substr(hashIndex));
      buffer[0] = baseUri = baseUri.substr(0, hashIndex)
    }
    var questionIndex = baseUri.indexOf("?");
    if(questionIndex < 0) {
      buffer[1] = "?"
    }else {
      if(questionIndex == baseUri.length - 1) {
        buffer[1] = undefined
      }
    }
  }
  return buffer.join("")
};
goog.uri.utils.appendKeyValuePairs_ = function(key, value, pairs) {
  if(goog.isArray(value)) {
    value = value;
    for(var j = 0;j < value.length;j++) {
      pairs.push("&", key);
      if(value[j] !== "") {
        pairs.push("=", goog.string.urlEncode(value[j]))
      }
    }
  }else {
    if(value != null) {
      pairs.push("&", key);
      if(value !== "") {
        pairs.push("=", goog.string.urlEncode(value))
      }
    }
  }
};
goog.uri.utils.buildQueryDataBuffer_ = function(buffer, keysAndValues, opt_startIndex) {
  goog.asserts.assert(Math.max(keysAndValues.length - (opt_startIndex || 0), 0) % 2 == 0, "goog.uri.utils: Key/value lists must be even in length.");
  for(var i = opt_startIndex || 0;i < keysAndValues.length;i += 2) {
    goog.uri.utils.appendKeyValuePairs_(keysAndValues[i], keysAndValues[i + 1], buffer)
  }
  return buffer
};
goog.uri.utils.buildQueryData = function(keysAndValues, opt_startIndex) {
  var buffer = goog.uri.utils.buildQueryDataBuffer_([], keysAndValues, opt_startIndex);
  buffer[0] = "";
  return buffer.join("")
};
goog.uri.utils.buildQueryDataBufferFromMap_ = function(buffer, map) {
  for(var key in map) {
    goog.uri.utils.appendKeyValuePairs_(key, map[key], buffer)
  }
  return buffer
};
goog.uri.utils.buildQueryDataFromMap = function(map) {
  var buffer = goog.uri.utils.buildQueryDataBufferFromMap_([], map);
  buffer[0] = "";
  return buffer.join("")
};
goog.uri.utils.appendParams = function(uri, var_args) {
  return goog.uri.utils.appendQueryData_(arguments.length == 2 ? goog.uri.utils.buildQueryDataBuffer_([uri], arguments[1], 0) : goog.uri.utils.buildQueryDataBuffer_([uri], arguments, 1))
};
goog.uri.utils.appendParamsFromMap = function(uri, map) {
  return goog.uri.utils.appendQueryData_(goog.uri.utils.buildQueryDataBufferFromMap_([uri], map))
};
goog.uri.utils.appendParam = function(uri, key, value) {
  return goog.uri.utils.appendQueryData_([uri, "&", key, "=", goog.string.urlEncode(value)])
};
goog.uri.utils.findParam_ = function(uri, startIndex, keyEncoded, hashOrEndIndex) {
  var index = startIndex;
  var keyLength = keyEncoded.length;
  while((index = uri.indexOf(keyEncoded, index)) >= 0 && index < hashOrEndIndex) {
    var precedingChar = uri.charCodeAt(index - 1);
    if(precedingChar == goog.uri.utils.CharCode_.AMPERSAND || precedingChar == goog.uri.utils.CharCode_.QUESTION) {
      var followingChar = uri.charCodeAt(index + keyLength);
      if(!followingChar || followingChar == goog.uri.utils.CharCode_.EQUAL || followingChar == goog.uri.utils.CharCode_.AMPERSAND || followingChar == goog.uri.utils.CharCode_.HASH) {
        return index
      }
    }
    index += keyLength + 1
  }
  return-1
};
goog.uri.utils.hashOrEndRe_ = /#|$/;
goog.uri.utils.hasParam = function(uri, keyEncoded) {
  return goog.uri.utils.findParam_(uri, 0, keyEncoded, uri.search(goog.uri.utils.hashOrEndRe_)) >= 0
};
goog.uri.utils.getParamValue = function(uri, keyEncoded) {
  var hashOrEndIndex = uri.search(goog.uri.utils.hashOrEndRe_);
  var foundIndex = goog.uri.utils.findParam_(uri, 0, keyEncoded, hashOrEndIndex);
  if(foundIndex < 0) {
    return null
  }else {
    var endPosition = uri.indexOf("&", foundIndex);
    if(endPosition < 0 || endPosition > hashOrEndIndex) {
      endPosition = hashOrEndIndex
    }
    foundIndex += keyEncoded.length + 1;
    return goog.string.urlDecode(uri.substr(foundIndex, endPosition - foundIndex))
  }
};
goog.uri.utils.getParamValues = function(uri, keyEncoded) {
  var hashOrEndIndex = uri.search(goog.uri.utils.hashOrEndRe_);
  var position = 0;
  var foundIndex;
  var result = [];
  while((foundIndex = goog.uri.utils.findParam_(uri, position, keyEncoded, hashOrEndIndex)) >= 0) {
    position = uri.indexOf("&", foundIndex);
    if(position < 0 || position > hashOrEndIndex) {
      position = hashOrEndIndex
    }
    foundIndex += keyEncoded.length + 1;
    result.push(goog.string.urlDecode(uri.substr(foundIndex, position - foundIndex)))
  }
  return result
};
goog.uri.utils.trailingQueryPunctuationRe_ = /[?&]($|#)/;
goog.uri.utils.removeParam = function(uri, keyEncoded) {
  var hashOrEndIndex = uri.search(goog.uri.utils.hashOrEndRe_);
  var position = 0;
  var foundIndex;
  var buffer = [];
  while((foundIndex = goog.uri.utils.findParam_(uri, position, keyEncoded, hashOrEndIndex)) >= 0) {
    buffer.push(uri.substring(position, foundIndex));
    position = Math.min(uri.indexOf("&", foundIndex) + 1 || hashOrEndIndex, hashOrEndIndex)
  }
  buffer.push(uri.substr(position));
  return buffer.join("").replace(goog.uri.utils.trailingQueryPunctuationRe_, "$1")
};
goog.uri.utils.setParam = function(uri, keyEncoded, value) {
  return goog.uri.utils.appendParam(goog.uri.utils.removeParam(uri, keyEncoded), keyEncoded, value)
};
goog.uri.utils.appendPath = function(baseUri, path) {
  goog.uri.utils.assertNoFragmentsOrQueries_(baseUri);
  if(goog.string.endsWith(baseUri, "/")) {
    baseUri = baseUri.substr(0, baseUri.length - 1)
  }
  if(goog.string.startsWith(path, "/")) {
    path = path.substr(1)
  }
  return goog.string.buildString(baseUri, "/", path)
};
goog.uri.utils.StandardQueryParam = {RANDOM:"zx"};
goog.uri.utils.makeUnique = function(uri) {
  return goog.uri.utils.setParam(uri, goog.uri.utils.StandardQueryParam.RANDOM, goog.string.getRandomString())
};
goog.provide("goog.net.XhrIo");
goog.provide("goog.net.XhrIo.ResponseType");
goog.require("goog.Timer");
goog.require("goog.debug.Logger");
goog.require("goog.debug.entryPointRegistry");
goog.require("goog.debug.errorHandlerWeakDep");
goog.require("goog.events.EventTarget");
goog.require("goog.json");
goog.require("goog.net.ErrorCode");
goog.require("goog.net.EventType");
goog.require("goog.net.HttpStatus");
goog.require("goog.net.XmlHttp");
goog.require("goog.net.xhrMonitor");
goog.require("goog.object");
goog.require("goog.structs");
goog.require("goog.structs.Map");
goog.require("goog.uri.utils");
goog.net.XhrIo = function(opt_xmlHttpFactory) {
  goog.events.EventTarget.call(this);
  this.headers = new goog.structs.Map;
  this.xmlHttpFactory_ = opt_xmlHttpFactory || null
};
goog.inherits(goog.net.XhrIo, goog.events.EventTarget);
goog.net.XhrIo.ResponseType = {DEFAULT:"", TEXT:"text", DOCUMENT:"document", BLOB:"blob", ARRAY_BUFFER:"arraybuffer"};
goog.net.XhrIo.prototype.logger_ = goog.debug.Logger.getLogger("goog.net.XhrIo");
goog.net.XhrIo.CONTENT_TYPE_HEADER = "Content-Type";
goog.net.XhrIo.HTTP_SCHEME_PATTERN = /^https?:?$/i;
goog.net.XhrIo.FORM_CONTENT_TYPE = "application/x-www-form-urlencoded;charset=utf-8";
goog.net.XhrIo.sendInstances_ = [];
goog.net.XhrIo.send = function(url, opt_callback, opt_method, opt_content, opt_headers, opt_timeoutInterval) {
  var x = new goog.net.XhrIo;
  goog.net.XhrIo.sendInstances_.push(x);
  if(opt_callback) {
    goog.events.listen(x, goog.net.EventType.COMPLETE, opt_callback)
  }
  goog.events.listen(x, goog.net.EventType.READY, goog.partial(goog.net.XhrIo.cleanupSend_, x));
  if(opt_timeoutInterval) {
    x.setTimeoutInterval(opt_timeoutInterval)
  }
  x.send(url, opt_method, opt_content, opt_headers)
};
goog.net.XhrIo.cleanup = function() {
  var instances = goog.net.XhrIo.sendInstances_;
  while(instances.length) {
    instances.pop().dispose()
  }
};
goog.net.XhrIo.protectEntryPoints = function(errorHandler) {
  goog.net.XhrIo.prototype.onReadyStateChangeEntryPoint_ = errorHandler.protectEntryPoint(goog.net.XhrIo.prototype.onReadyStateChangeEntryPoint_)
};
goog.net.XhrIo.cleanupSend_ = function(XhrIo) {
  XhrIo.dispose();
  goog.array.remove(goog.net.XhrIo.sendInstances_, XhrIo)
};
goog.net.XhrIo.prototype.active_ = false;
goog.net.XhrIo.prototype.xhr_ = null;
goog.net.XhrIo.prototype.xhrOptions_ = null;
goog.net.XhrIo.prototype.lastUri_ = "";
goog.net.XhrIo.prototype.lastMethod_ = "";
goog.net.XhrIo.prototype.lastErrorCode_ = goog.net.ErrorCode.NO_ERROR;
goog.net.XhrIo.prototype.lastError_ = "";
goog.net.XhrIo.prototype.errorDispatched_ = false;
goog.net.XhrIo.prototype.inSend_ = false;
goog.net.XhrIo.prototype.inOpen_ = false;
goog.net.XhrIo.prototype.inAbort_ = false;
goog.net.XhrIo.prototype.timeoutInterval_ = 0;
goog.net.XhrIo.prototype.timeoutId_ = null;
goog.net.XhrIo.prototype.responseType_ = goog.net.XhrIo.ResponseType.DEFAULT;
goog.net.XhrIo.prototype.withCredentials_ = false;
goog.net.XhrIo.prototype.getTimeoutInterval = function() {
  return this.timeoutInterval_
};
goog.net.XhrIo.prototype.setTimeoutInterval = function(ms) {
  this.timeoutInterval_ = Math.max(0, ms)
};
goog.net.XhrIo.prototype.setResponseType = function(type) {
  this.responseType_ = type
};
goog.net.XhrIo.prototype.getResponseType = function() {
  return this.responseType_
};
goog.net.XhrIo.prototype.setWithCredentials = function(withCredentials) {
  this.withCredentials_ = withCredentials
};
goog.net.XhrIo.prototype.getWithCredentials = function() {
  return this.withCredentials_
};
goog.net.XhrIo.prototype.send = function(url, opt_method, opt_content, opt_headers) {
  if(this.xhr_) {
    throw Error("[goog.net.XhrIo] Object is active with another request");
  }
  var method = opt_method || "GET";
  this.lastUri_ = url;
  this.lastError_ = "";
  this.lastErrorCode_ = goog.net.ErrorCode.NO_ERROR;
  this.lastMethod_ = method;
  this.errorDispatched_ = false;
  this.active_ = true;
  this.xhr_ = this.createXhr();
  this.xhrOptions_ = this.xmlHttpFactory_ ? this.xmlHttpFactory_.getOptions() : goog.net.XmlHttp.getOptions();
  goog.net.xhrMonitor.markXhrOpen(this.xhr_);
  this.xhr_.onreadystatechange = goog.bind(this.onReadyStateChange_, this);
  try {
    this.logger_.fine(this.formatMsg_("Opening Xhr"));
    this.inOpen_ = true;
    this.xhr_.open(method, url, true);
    this.inOpen_ = false
  }catch(err) {
    this.logger_.fine(this.formatMsg_("Error opening Xhr: " + err.message));
    this.error_(goog.net.ErrorCode.EXCEPTION, err);
    return
  }
  var content = opt_content || "";
  var headers = this.headers.clone();
  if(opt_headers) {
    goog.structs.forEach(opt_headers, function(value, key) {
      headers.set(key, value)
    })
  }
  if(method == "POST" && !headers.containsKey(goog.net.XhrIo.CONTENT_TYPE_HEADER)) {
    headers.set(goog.net.XhrIo.CONTENT_TYPE_HEADER, goog.net.XhrIo.FORM_CONTENT_TYPE)
  }
  goog.structs.forEach(headers, function(value, key) {
    this.xhr_.setRequestHeader(key, value)
  }, this);
  if(this.responseType_) {
    this.xhr_.responseType = this.responseType_
  }
  if(goog.object.containsKey(this.xhr_, "withCredentials")) {
    this.xhr_.withCredentials = this.withCredentials_
  }
  try {
    if(this.timeoutId_) {
      goog.Timer.defaultTimerObject.clearTimeout(this.timeoutId_);
      this.timeoutId_ = null
    }
    if(this.timeoutInterval_ > 0) {
      this.logger_.fine(this.formatMsg_("Will abort after " + this.timeoutInterval_ + "ms if incomplete"));
      this.timeoutId_ = goog.Timer.defaultTimerObject.setTimeout(goog.bind(this.timeout_, this), this.timeoutInterval_)
    }
    this.logger_.fine(this.formatMsg_("Sending request"));
    this.inSend_ = true;
    this.xhr_.send(content);
    this.inSend_ = false
  }catch(err) {
    this.logger_.fine(this.formatMsg_("Send error: " + err.message));
    this.error_(goog.net.ErrorCode.EXCEPTION, err)
  }
};
goog.net.XhrIo.prototype.createXhr = function() {
  return this.xmlHttpFactory_ ? this.xmlHttpFactory_.createInstance() : new goog.net.XmlHttp
};
goog.net.XhrIo.prototype.dispatchEvent = function(e) {
  if(this.xhr_) {
    goog.net.xhrMonitor.pushContext(this.xhr_);
    try {
      return goog.net.XhrIo.superClass_.dispatchEvent.call(this, e)
    }finally {
      goog.net.xhrMonitor.popContext()
    }
  }else {
    return goog.net.XhrIo.superClass_.dispatchEvent.call(this, e)
  }
};
goog.net.XhrIo.prototype.timeout_ = function() {
  if(typeof goog == "undefined") {
  }else {
    if(this.xhr_) {
      this.lastError_ = "Timed out after " + this.timeoutInterval_ + "ms, aborting";
      this.lastErrorCode_ = goog.net.ErrorCode.TIMEOUT;
      this.logger_.fine(this.formatMsg_(this.lastError_));
      this.dispatchEvent(goog.net.EventType.TIMEOUT);
      this.abort(goog.net.ErrorCode.TIMEOUT)
    }
  }
};
goog.net.XhrIo.prototype.error_ = function(errorCode, err) {
  this.active_ = false;
  if(this.xhr_) {
    this.inAbort_ = true;
    this.xhr_.abort();
    this.inAbort_ = false
  }
  this.lastError_ = err;
  this.lastErrorCode_ = errorCode;
  this.dispatchErrors_();
  this.cleanUpXhr_()
};
goog.net.XhrIo.prototype.dispatchErrors_ = function() {
  if(!this.errorDispatched_) {
    this.errorDispatched_ = true;
    this.dispatchEvent(goog.net.EventType.COMPLETE);
    this.dispatchEvent(goog.net.EventType.ERROR)
  }
};
goog.net.XhrIo.prototype.abort = function(opt_failureCode) {
  if(this.xhr_ && this.active_) {
    this.logger_.fine(this.formatMsg_("Aborting"));
    this.active_ = false;
    this.inAbort_ = true;
    this.xhr_.abort();
    this.inAbort_ = false;
    this.lastErrorCode_ = opt_failureCode || goog.net.ErrorCode.ABORT;
    this.dispatchEvent(goog.net.EventType.COMPLETE);
    this.dispatchEvent(goog.net.EventType.ABORT);
    this.cleanUpXhr_()
  }
};
goog.net.XhrIo.prototype.disposeInternal = function() {
  if(this.xhr_) {
    if(this.active_) {
      this.active_ = false;
      this.inAbort_ = true;
      this.xhr_.abort();
      this.inAbort_ = false
    }
    this.cleanUpXhr_(true)
  }
  goog.net.XhrIo.superClass_.disposeInternal.call(this)
};
goog.net.XhrIo.prototype.onReadyStateChange_ = function() {
  if(!this.inOpen_ && !this.inSend_ && !this.inAbort_) {
    this.onReadyStateChangeEntryPoint_()
  }else {
    this.onReadyStateChangeHelper_()
  }
};
goog.net.XhrIo.prototype.onReadyStateChangeEntryPoint_ = function() {
  this.onReadyStateChangeHelper_()
};
goog.net.XhrIo.prototype.onReadyStateChangeHelper_ = function() {
  if(!this.active_) {
    return
  }
  if(typeof goog == "undefined") {
  }else {
    if(this.xhrOptions_[goog.net.XmlHttp.OptionType.LOCAL_REQUEST_ERROR] && this.getReadyState() == goog.net.XmlHttp.ReadyState.COMPLETE && this.getStatus() == 2) {
      this.logger_.fine(this.formatMsg_("Local request error detected and ignored"))
    }else {
      if(this.inSend_ && this.getReadyState() == goog.net.XmlHttp.ReadyState.COMPLETE) {
        goog.Timer.defaultTimerObject.setTimeout(goog.bind(this.onReadyStateChange_, this), 0);
        return
      }
      this.dispatchEvent(goog.net.EventType.READY_STATE_CHANGE);
      if(this.isComplete()) {
        this.logger_.fine(this.formatMsg_("Request complete"));
        this.active_ = false;
        if(this.isSuccess()) {
          this.dispatchEvent(goog.net.EventType.COMPLETE);
          this.dispatchEvent(goog.net.EventType.SUCCESS)
        }else {
          this.lastErrorCode_ = goog.net.ErrorCode.HTTP_ERROR;
          this.lastError_ = this.getStatusText() + " [" + this.getStatus() + "]";
          this.dispatchErrors_()
        }
        this.cleanUpXhr_()
      }
    }
  }
};
goog.net.XhrIo.prototype.cleanUpXhr_ = function(opt_fromDispose) {
  if(this.xhr_) {
    var xhr = this.xhr_;
    var clearedOnReadyStateChange = this.xhrOptions_[goog.net.XmlHttp.OptionType.USE_NULL_FUNCTION] ? goog.nullFunction : null;
    this.xhr_ = null;
    this.xhrOptions_ = null;
    if(this.timeoutId_) {
      goog.Timer.defaultTimerObject.clearTimeout(this.timeoutId_);
      this.timeoutId_ = null
    }
    if(!opt_fromDispose) {
      goog.net.xhrMonitor.pushContext(xhr);
      this.dispatchEvent(goog.net.EventType.READY);
      goog.net.xhrMonitor.popContext()
    }
    goog.net.xhrMonitor.markXhrClosed(xhr);
    try {
      xhr.onreadystatechange = clearedOnReadyStateChange
    }catch(e) {
      this.logger_.severe("Problem encountered resetting onreadystatechange: " + e.message)
    }
  }
};
goog.net.XhrIo.prototype.isActive = function() {
  return!!this.xhr_
};
goog.net.XhrIo.prototype.isComplete = function() {
  return this.getReadyState() == goog.net.XmlHttp.ReadyState.COMPLETE
};
goog.net.XhrIo.prototype.isSuccess = function() {
  switch(this.getStatus()) {
    case 0:
      return!this.isLastUriEffectiveSchemeHttp_();
    case goog.net.HttpStatus.OK:
    ;
    case goog.net.HttpStatus.NO_CONTENT:
    ;
    case goog.net.HttpStatus.NOT_MODIFIED:
      return true;
    default:
      return false
  }
};
goog.net.XhrIo.prototype.isLastUriEffectiveSchemeHttp_ = function() {
  var lastUriScheme = goog.isString(this.lastUri_) ? goog.uri.utils.getScheme(this.lastUri_) : this.lastUri_.getScheme();
  if(lastUriScheme) {
    return goog.net.XhrIo.HTTP_SCHEME_PATTERN.test(lastUriScheme)
  }
  if(self.location) {
    return goog.net.XhrIo.HTTP_SCHEME_PATTERN.test(self.location.protocol)
  }else {
    return true
  }
};
goog.net.XhrIo.prototype.getReadyState = function() {
  return this.xhr_ ? this.xhr_.readyState : goog.net.XmlHttp.ReadyState.UNINITIALIZED
};
goog.net.XhrIo.prototype.getStatus = function() {
  try {
    return this.getReadyState() > goog.net.XmlHttp.ReadyState.LOADED ? this.xhr_.status : -1
  }catch(e) {
    this.logger_.warning("Can not get status: " + e.message);
    return-1
  }
};
goog.net.XhrIo.prototype.getStatusText = function() {
  try {
    return this.getReadyState() > goog.net.XmlHttp.ReadyState.LOADED ? this.xhr_.statusText : ""
  }catch(e) {
    this.logger_.fine("Can not get status: " + e.message);
    return""
  }
};
goog.net.XhrIo.prototype.getLastUri = function() {
  return String(this.lastUri_)
};
goog.net.XhrIo.prototype.getResponseText = function() {
  try {
    return this.xhr_ ? this.xhr_.responseText : ""
  }catch(e) {
    this.logger_.fine("Can not get responseText: " + e.message);
    return""
  }
};
goog.net.XhrIo.prototype.getResponseXml = function() {
  try {
    return this.xhr_ ? this.xhr_.responseXML : null
  }catch(e) {
    this.logger_.fine("Can not get responseXML: " + e.message);
    return null
  }
};
goog.net.XhrIo.prototype.getResponseJson = function(opt_xssiPrefix) {
  if(!this.xhr_) {
    return undefined
  }
  var responseText = this.xhr_.responseText;
  if(opt_xssiPrefix && responseText.indexOf(opt_xssiPrefix) == 0) {
    responseText = responseText.substring(opt_xssiPrefix.length)
  }
  return goog.json.parse(responseText)
};
goog.net.XhrIo.prototype.getResponse = function() {
  try {
    return this.xhr_ && this.xhr_.response
  }catch(e) {
    this.logger_.fine("Can not get response: " + e.message);
    return null
  }
};
goog.net.XhrIo.prototype.getResponseHeader = function(key) {
  return this.xhr_ && this.isComplete() ? this.xhr_.getResponseHeader(key) : undefined
};
goog.net.XhrIo.prototype.getAllResponseHeaders = function() {
  return this.xhr_ && this.isComplete() ? this.xhr_.getAllResponseHeaders() : ""
};
goog.net.XhrIo.prototype.getLastErrorCode = function() {
  return this.lastErrorCode_
};
goog.net.XhrIo.prototype.getLastError = function() {
  return goog.isString(this.lastError_) ? this.lastError_ : String(this.lastError_)
};
goog.net.XhrIo.prototype.formatMsg_ = function(msg) {
  return msg + " [" + this.lastMethod_ + " " + this.lastUri_ + " " + this.getStatus() + "]"
};
goog.debug.entryPointRegistry.register(function(transformer) {
  goog.net.XhrIo.prototype.onReadyStateChangeEntryPoint_ = transformer(goog.net.XhrIo.prototype.onReadyStateChangeEntryPoint_)
});
goog.provide("goog.net.xpc");
goog.provide("goog.net.xpc.CfgFields");
goog.provide("goog.net.xpc.ChannelStates");
goog.provide("goog.net.xpc.TransportNames");
goog.provide("goog.net.xpc.TransportTypes");
goog.provide("goog.net.xpc.UriCfgFields");
goog.require("goog.debug.Logger");
goog.net.xpc.TransportTypes = {NATIVE_MESSAGING:1, FRAME_ELEMENT_METHOD:2, IFRAME_RELAY:3, IFRAME_POLLING:4, FLASH:5, NIX:6};
goog.net.xpc.TransportNames = {1:"NativeMessagingTransport", 2:"FrameElementMethodTransport", 3:"IframeRelayTransport", 4:"IframePollingTransport", 5:"FlashTransport", 6:"NixTransport"};
goog.net.xpc.CfgFields = {CHANNEL_NAME:"cn", AUTH_TOKEN:"at", REMOTE_AUTH_TOKEN:"rat", PEER_URI:"pu", IFRAME_ID:"ifrid", TRANSPORT:"tp", LOCAL_RELAY_URI:"lru", PEER_RELAY_URI:"pru", LOCAL_POLL_URI:"lpu", PEER_POLL_URI:"ppu", PEER_HOSTNAME:"ph"};
goog.net.xpc.UriCfgFields = [goog.net.xpc.CfgFields.PEER_URI, goog.net.xpc.CfgFields.LOCAL_RELAY_URI, goog.net.xpc.CfgFields.PEER_RELAY_URI, goog.net.xpc.CfgFields.LOCAL_POLL_URI, goog.net.xpc.CfgFields.PEER_POLL_URI];
goog.net.xpc.ChannelStates = {NOT_CONNECTED:1, CONNECTED:2, CLOSED:3};
goog.net.xpc.TRANSPORT_SERVICE_ = "tp";
goog.net.xpc.SETUP = "SETUP";
goog.net.xpc.SETUP_ACK_ = "SETUP_ACK";
goog.net.xpc.channels_ = {};
goog.net.xpc.getRandomString = function(length, opt_characters) {
  var chars = opt_characters || goog.net.xpc.randomStringCharacters_;
  var charsLength = chars.length;
  var s = "";
  while(length-- > 0) {
    s += chars.charAt(Math.floor(Math.random() * charsLength))
  }
  return s
};
goog.net.xpc.randomStringCharacters_ = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
goog.net.xpc.logger = goog.debug.Logger.getLogger("goog.net.xpc");
goog.provide("goog.Uri");
goog.provide("goog.Uri.QueryData");
goog.require("goog.array");
goog.require("goog.string");
goog.require("goog.structs");
goog.require("goog.structs.Map");
goog.require("goog.uri.utils");
goog.require("goog.uri.utils.ComponentIndex");
goog.Uri = function(opt_uri, opt_ignoreCase) {
  var m;
  if(opt_uri instanceof goog.Uri) {
    this.setIgnoreCase(opt_ignoreCase == null ? opt_uri.getIgnoreCase() : opt_ignoreCase);
    this.setScheme(opt_uri.getScheme());
    this.setUserInfo(opt_uri.getUserInfo());
    this.setDomain(opt_uri.getDomain());
    this.setPort(opt_uri.getPort());
    this.setPath(opt_uri.getPath());
    this.setQueryData(opt_uri.getQueryData().clone());
    this.setFragment(opt_uri.getFragment())
  }else {
    if(opt_uri && (m = goog.uri.utils.split(String(opt_uri)))) {
      this.setIgnoreCase(!!opt_ignoreCase);
      this.setScheme(m[goog.uri.utils.ComponentIndex.SCHEME] || "", true);
      this.setUserInfo(m[goog.uri.utils.ComponentIndex.USER_INFO] || "", true);
      this.setDomain(m[goog.uri.utils.ComponentIndex.DOMAIN] || "", true);
      this.setPort(m[goog.uri.utils.ComponentIndex.PORT]);
      this.setPath(m[goog.uri.utils.ComponentIndex.PATH] || "", true);
      this.setQuery(m[goog.uri.utils.ComponentIndex.QUERY_DATA] || "", true);
      this.setFragment(m[goog.uri.utils.ComponentIndex.FRAGMENT] || "", true)
    }else {
      this.setIgnoreCase(!!opt_ignoreCase);
      this.queryData_ = new goog.Uri.QueryData(null, this, this.ignoreCase_)
    }
  }
};
goog.Uri.RANDOM_PARAM = goog.uri.utils.StandardQueryParam.RANDOM;
goog.Uri.prototype.scheme_ = "";
goog.Uri.prototype.userInfo_ = "";
goog.Uri.prototype.domain_ = "";
goog.Uri.prototype.port_ = null;
goog.Uri.prototype.path_ = "";
goog.Uri.prototype.queryData_;
goog.Uri.prototype.fragment_ = "";
goog.Uri.prototype.isReadOnly_ = false;
goog.Uri.prototype.ignoreCase_ = false;
goog.Uri.prototype.toString = function() {
  if(this.cachedToString_) {
    return this.cachedToString_
  }
  var out = [];
  if(this.scheme_) {
    out.push(goog.Uri.encodeSpecialChars_(this.scheme_, goog.Uri.reDisallowedInSchemeOrUserInfo_), ":")
  }
  if(this.domain_) {
    out.push("//");
    if(this.userInfo_) {
      out.push(goog.Uri.encodeSpecialChars_(this.userInfo_, goog.Uri.reDisallowedInSchemeOrUserInfo_), "@")
    }
    out.push(goog.Uri.encodeString_(this.domain_));
    if(this.port_ != null) {
      out.push(":", String(this.getPort()))
    }
  }
  if(this.path_) {
    if(this.hasDomain() && this.path_.charAt(0) != "/") {
      out.push("/")
    }
    out.push(goog.Uri.encodeSpecialChars_(this.path_, goog.Uri.reDisallowedInPath_))
  }
  var query = String(this.queryData_);
  if(query) {
    out.push("?", query)
  }
  if(this.fragment_) {
    out.push("#", goog.Uri.encodeSpecialChars_(this.fragment_, goog.Uri.reDisallowedInFragment_))
  }
  return this.cachedToString_ = out.join("")
};
goog.Uri.prototype.resolve = function(relativeUri) {
  var absoluteUri = this.clone();
  var overridden = relativeUri.hasScheme();
  if(overridden) {
    absoluteUri.setScheme(relativeUri.getScheme())
  }else {
    overridden = relativeUri.hasUserInfo()
  }
  if(overridden) {
    absoluteUri.setUserInfo(relativeUri.getUserInfo())
  }else {
    overridden = relativeUri.hasDomain()
  }
  if(overridden) {
    absoluteUri.setDomain(relativeUri.getDomain())
  }else {
    overridden = relativeUri.hasPort()
  }
  var path = relativeUri.getPath();
  if(overridden) {
    absoluteUri.setPort(relativeUri.getPort())
  }else {
    overridden = relativeUri.hasPath();
    if(overridden) {
      if(path.charAt(0) != "/") {
        if(this.hasDomain() && !this.hasPath()) {
          path = "/" + path
        }else {
          var lastSlashIndex = absoluteUri.getPath().lastIndexOf("/");
          if(lastSlashIndex != -1) {
            path = absoluteUri.getPath().substr(0, lastSlashIndex + 1) + path
          }
        }
      }
      path = goog.Uri.removeDotSegments(path)
    }
  }
  if(overridden) {
    absoluteUri.setPath(path)
  }else {
    overridden = relativeUri.hasQuery()
  }
  if(overridden) {
    absoluteUri.setQuery(relativeUri.getDecodedQuery())
  }else {
    overridden = relativeUri.hasFragment()
  }
  if(overridden) {
    absoluteUri.setFragment(relativeUri.getFragment())
  }
  return absoluteUri
};
goog.Uri.prototype.clone = function() {
  return goog.Uri.create(this.scheme_, this.userInfo_, this.domain_, this.port_, this.path_, this.queryData_.clone(), this.fragment_, this.ignoreCase_)
};
goog.Uri.prototype.getScheme = function() {
  return this.scheme_
};
goog.Uri.prototype.setScheme = function(newScheme, opt_decode) {
  this.enforceReadOnly();
  delete this.cachedToString_;
  this.scheme_ = opt_decode ? goog.Uri.decodeOrEmpty_(newScheme) : newScheme;
  if(this.scheme_) {
    this.scheme_ = this.scheme_.replace(/:$/, "")
  }
  return this
};
goog.Uri.prototype.hasScheme = function() {
  return!!this.scheme_
};
goog.Uri.prototype.getUserInfo = function() {
  return this.userInfo_
};
goog.Uri.prototype.setUserInfo = function(newUserInfo, opt_decode) {
  this.enforceReadOnly();
  delete this.cachedToString_;
  this.userInfo_ = opt_decode ? goog.Uri.decodeOrEmpty_(newUserInfo) : newUserInfo;
  return this
};
goog.Uri.prototype.hasUserInfo = function() {
  return!!this.userInfo_
};
goog.Uri.prototype.getDomain = function() {
  return this.domain_
};
goog.Uri.prototype.setDomain = function(newDomain, opt_decode) {
  this.enforceReadOnly();
  delete this.cachedToString_;
  this.domain_ = opt_decode ? goog.Uri.decodeOrEmpty_(newDomain) : newDomain;
  return this
};
goog.Uri.prototype.hasDomain = function() {
  return!!this.domain_
};
goog.Uri.prototype.getPort = function() {
  return this.port_
};
goog.Uri.prototype.setPort = function(newPort) {
  this.enforceReadOnly();
  delete this.cachedToString_;
  if(newPort) {
    newPort = Number(newPort);
    if(isNaN(newPort) || newPort < 0) {
      throw Error("Bad port number " + newPort);
    }
    this.port_ = newPort
  }else {
    this.port_ = null
  }
  return this
};
goog.Uri.prototype.hasPort = function() {
  return this.port_ != null
};
goog.Uri.prototype.getPath = function() {
  return this.path_
};
goog.Uri.prototype.setPath = function(newPath, opt_decode) {
  this.enforceReadOnly();
  delete this.cachedToString_;
  this.path_ = opt_decode ? goog.Uri.decodeOrEmpty_(newPath) : newPath;
  return this
};
goog.Uri.prototype.hasPath = function() {
  return!!this.path_
};
goog.Uri.prototype.hasQuery = function() {
  return this.queryData_.toString() !== ""
};
goog.Uri.prototype.setQueryData = function(queryData, opt_decode) {
  this.enforceReadOnly();
  delete this.cachedToString_;
  if(queryData instanceof goog.Uri.QueryData) {
    this.queryData_ = queryData;
    this.queryData_.uri_ = this;
    this.queryData_.setIgnoreCase(this.ignoreCase_)
  }else {
    if(!opt_decode) {
      queryData = goog.Uri.encodeSpecialChars_(queryData, goog.Uri.reDisallowedInQuery_)
    }
    this.queryData_ = new goog.Uri.QueryData(queryData, this, this.ignoreCase_)
  }
  return this
};
goog.Uri.prototype.setQuery = function(newQuery, opt_decode) {
  return this.setQueryData(newQuery, opt_decode)
};
goog.Uri.prototype.getEncodedQuery = function() {
  return this.queryData_.toString()
};
goog.Uri.prototype.getDecodedQuery = function() {
  return this.queryData_.toDecodedString()
};
goog.Uri.prototype.getQueryData = function() {
  return this.queryData_
};
goog.Uri.prototype.getQuery = function() {
  return this.getEncodedQuery()
};
goog.Uri.prototype.setParameterValue = function(key, value) {
  this.enforceReadOnly();
  delete this.cachedToString_;
  this.queryData_.set(key, value);
  return this
};
goog.Uri.prototype.setParameterValues = function(key, values) {
  this.enforceReadOnly();
  delete this.cachedToString_;
  if(!goog.isArray(values)) {
    values = [String(values)]
  }
  this.queryData_.setValues(key, values);
  return this
};
goog.Uri.prototype.getParameterValues = function(name) {
  return this.queryData_.getValues(name)
};
goog.Uri.prototype.getParameterValue = function(paramName) {
  return this.queryData_.get(paramName)
};
goog.Uri.prototype.getFragment = function() {
  return this.fragment_
};
goog.Uri.prototype.setFragment = function(newFragment, opt_decode) {
  this.enforceReadOnly();
  delete this.cachedToString_;
  this.fragment_ = opt_decode ? goog.Uri.decodeOrEmpty_(newFragment) : newFragment;
  return this
};
goog.Uri.prototype.hasFragment = function() {
  return!!this.fragment_
};
goog.Uri.prototype.hasSameDomainAs = function(uri2) {
  return(!this.hasDomain() && !uri2.hasDomain() || this.getDomain() == uri2.getDomain()) && (!this.hasPort() && !uri2.hasPort() || this.getPort() == uri2.getPort())
};
goog.Uri.prototype.makeUnique = function() {
  this.enforceReadOnly();
  this.setParameterValue(goog.Uri.RANDOM_PARAM, goog.string.getRandomString());
  return this
};
goog.Uri.prototype.removeParameter = function(key) {
  this.enforceReadOnly();
  this.queryData_.remove(key);
  return this
};
goog.Uri.prototype.setReadOnly = function(isReadOnly) {
  this.isReadOnly_ = isReadOnly;
  return this
};
goog.Uri.prototype.isReadOnly = function() {
  return this.isReadOnly_
};
goog.Uri.prototype.enforceReadOnly = function() {
  if(this.isReadOnly_) {
    throw Error("Tried to modify a read-only Uri");
  }
};
goog.Uri.prototype.setIgnoreCase = function(ignoreCase) {
  this.ignoreCase_ = ignoreCase;
  if(this.queryData_) {
    this.queryData_.setIgnoreCase(ignoreCase)
  }
  return this
};
goog.Uri.prototype.getIgnoreCase = function() {
  return this.ignoreCase_
};
goog.Uri.parse = function(uri, opt_ignoreCase) {
  return uri instanceof goog.Uri ? uri.clone() : new goog.Uri(uri, opt_ignoreCase)
};
goog.Uri.create = function(opt_scheme, opt_userInfo, opt_domain, opt_port, opt_path, opt_query, opt_fragment, opt_ignoreCase) {
  var uri = new goog.Uri(null, opt_ignoreCase);
  opt_scheme && uri.setScheme(opt_scheme);
  opt_userInfo && uri.setUserInfo(opt_userInfo);
  opt_domain && uri.setDomain(opt_domain);
  opt_port && uri.setPort(opt_port);
  opt_path && uri.setPath(opt_path);
  opt_query && uri.setQueryData(opt_query);
  opt_fragment && uri.setFragment(opt_fragment);
  return uri
};
goog.Uri.resolve = function(base, rel) {
  if(!(base instanceof goog.Uri)) {
    base = goog.Uri.parse(base)
  }
  if(!(rel instanceof goog.Uri)) {
    rel = goog.Uri.parse(rel)
  }
  return base.resolve(rel)
};
goog.Uri.removeDotSegments = function(path) {
  if(path == ".." || path == ".") {
    return""
  }else {
    if(!goog.string.contains(path, "./") && !goog.string.contains(path, "/.")) {
      return path
    }else {
      var leadingSlash = goog.string.startsWith(path, "/");
      var segments = path.split("/");
      var out = [];
      for(var pos = 0;pos < segments.length;) {
        var segment = segments[pos++];
        if(segment == ".") {
          if(leadingSlash && pos == segments.length) {
            out.push("")
          }
        }else {
          if(segment == "..") {
            if(out.length > 1 || out.length == 1 && out[0] != "") {
              out.pop()
            }
            if(leadingSlash && pos == segments.length) {
              out.push("")
            }
          }else {
            out.push(segment);
            leadingSlash = true
          }
        }
      }
      return out.join("/")
    }
  }
};
goog.Uri.decodeOrEmpty_ = function(val) {
  return val ? decodeURIComponent(val) : ""
};
goog.Uri.encodeString_ = function(unescapedPart) {
  if(goog.isString(unescapedPart)) {
    return encodeURIComponent(unescapedPart)
  }
  return null
};
goog.Uri.encodeSpecialRegExp_ = /^[a-zA-Z0-9\-_.!~*'():\/;?]*$/;
goog.Uri.encodeSpecialChars_ = function(unescapedPart, extra) {
  var ret = null;
  if(goog.isString(unescapedPart)) {
    ret = unescapedPart;
    if(!goog.Uri.encodeSpecialRegExp_.test(ret)) {
      ret = encodeURI(unescapedPart)
    }
    if(ret.search(extra) >= 0) {
      ret = ret.replace(extra, goog.Uri.encodeChar_)
    }
  }
  return ret
};
goog.Uri.encodeChar_ = function(ch) {
  var n = ch.charCodeAt(0);
  return"%" + (n >> 4 & 15).toString(16) + (n & 15).toString(16)
};
goog.Uri.reDisallowedInSchemeOrUserInfo_ = /[#\/\?@]/g;
goog.Uri.reDisallowedInPath_ = /[\#\?]/g;
goog.Uri.reDisallowedInQuery_ = /[\#\?@]/g;
goog.Uri.reDisallowedInFragment_ = /#/g;
goog.Uri.haveSameDomain = function(uri1String, uri2String) {
  var pieces1 = goog.uri.utils.split(uri1String);
  var pieces2 = goog.uri.utils.split(uri2String);
  return pieces1[goog.uri.utils.ComponentIndex.DOMAIN] == pieces2[goog.uri.utils.ComponentIndex.DOMAIN] && pieces1[goog.uri.utils.ComponentIndex.PORT] == pieces2[goog.uri.utils.ComponentIndex.PORT]
};
goog.Uri.QueryData = function(opt_query, opt_uri, opt_ignoreCase) {
  this.encodedQuery_ = opt_query || null;
  this.uri_ = opt_uri || null;
  this.ignoreCase_ = !!opt_ignoreCase
};
goog.Uri.QueryData.prototype.ensureKeyMapInitialized_ = function() {
  if(!this.keyMap_) {
    this.keyMap_ = new goog.structs.Map;
    if(this.encodedQuery_) {
      var pairs = this.encodedQuery_.split("&");
      for(var i = 0;i < pairs.length;i++) {
        var indexOfEquals = pairs[i].indexOf("=");
        var name = null;
        var value = null;
        if(indexOfEquals >= 0) {
          name = pairs[i].substring(0, indexOfEquals);
          value = pairs[i].substring(indexOfEquals + 1)
        }else {
          name = pairs[i]
        }
        name = goog.string.urlDecode(name);
        name = this.getKeyName_(name);
        this.add(name, value ? goog.string.urlDecode(value) : "")
      }
    }
  }
};
goog.Uri.QueryData.createFromMap = function(map, opt_uri, opt_ignoreCase) {
  var keys = goog.structs.getKeys(map);
  if(typeof keys == "undefined") {
    throw Error("Keys are undefined");
  }
  return goog.Uri.QueryData.createFromKeysValues(keys, goog.structs.getValues(map), opt_uri, opt_ignoreCase)
};
goog.Uri.QueryData.createFromKeysValues = function(keys, values, opt_uri, opt_ignoreCase) {
  if(keys.length != values.length) {
    throw Error("Mismatched lengths for keys/values");
  }
  var queryData = new goog.Uri.QueryData(null, opt_uri, opt_ignoreCase);
  for(var i = 0;i < keys.length;i++) {
    queryData.add(keys[i], values[i])
  }
  return queryData
};
goog.Uri.QueryData.prototype.keyMap_ = null;
goog.Uri.QueryData.prototype.count_ = null;
goog.Uri.QueryData.decodedQuery_ = null;
goog.Uri.QueryData.prototype.getCount = function() {
  this.ensureKeyMapInitialized_();
  return this.count_
};
goog.Uri.QueryData.prototype.add = function(key, value) {
  this.ensureKeyMapInitialized_();
  this.invalidateCache_();
  key = this.getKeyName_(key);
  if(!this.containsKey(key)) {
    this.keyMap_.set(key, value)
  }else {
    var current = this.keyMap_.get(key);
    if(goog.isArray(current)) {
      current.push(value)
    }else {
      this.keyMap_.set(key, [current, value])
    }
  }
  this.count_++;
  return this
};
goog.Uri.QueryData.prototype.remove = function(key) {
  this.ensureKeyMapInitialized_();
  key = this.getKeyName_(key);
  if(this.keyMap_.containsKey(key)) {
    this.invalidateCache_();
    var old = this.keyMap_.get(key);
    if(goog.isArray(old)) {
      this.count_ -= old.length
    }else {
      this.count_--
    }
    return this.keyMap_.remove(key)
  }
  return false
};
goog.Uri.QueryData.prototype.clear = function() {
  this.invalidateCache_();
  if(this.keyMap_) {
    this.keyMap_.clear()
  }
  this.count_ = 0
};
goog.Uri.QueryData.prototype.isEmpty = function() {
  this.ensureKeyMapInitialized_();
  return this.count_ == 0
};
goog.Uri.QueryData.prototype.containsKey = function(key) {
  this.ensureKeyMapInitialized_();
  key = this.getKeyName_(key);
  return this.keyMap_.containsKey(key)
};
goog.Uri.QueryData.prototype.containsValue = function(value) {
  var vals = this.getValues();
  return goog.array.contains(vals, value)
};
goog.Uri.QueryData.prototype.getKeys = function() {
  this.ensureKeyMapInitialized_();
  var vals = this.keyMap_.getValues();
  var keys = this.keyMap_.getKeys();
  var rv = [];
  for(var i = 0;i < keys.length;i++) {
    var val = vals[i];
    if(goog.isArray(val)) {
      for(var j = 0;j < val.length;j++) {
        rv.push(keys[i])
      }
    }else {
      rv.push(keys[i])
    }
  }
  return rv
};
goog.Uri.QueryData.prototype.getValues = function(opt_key) {
  this.ensureKeyMapInitialized_();
  var rv;
  if(opt_key) {
    var key = this.getKeyName_(opt_key);
    if(this.containsKey(key)) {
      var value = this.keyMap_.get(key);
      if(goog.isArray(value)) {
        return value
      }else {
        rv = [];
        rv.push(value)
      }
    }else {
      rv = []
    }
  }else {
    var vals = this.keyMap_.getValues();
    rv = [];
    for(var i = 0;i < vals.length;i++) {
      var val = vals[i];
      if(goog.isArray(val)) {
        goog.array.extend(rv, val)
      }else {
        rv.push(val)
      }
    }
  }
  return rv
};
goog.Uri.QueryData.prototype.set = function(key, value) {
  this.ensureKeyMapInitialized_();
  this.invalidateCache_();
  key = this.getKeyName_(key);
  if(this.containsKey(key)) {
    var old = this.keyMap_.get(key);
    if(goog.isArray(old)) {
      this.count_ -= old.length
    }else {
      this.count_--
    }
  }
  this.keyMap_.set(key, value);
  this.count_++;
  return this
};
goog.Uri.QueryData.prototype.get = function(key, opt_default) {
  this.ensureKeyMapInitialized_();
  key = this.getKeyName_(key);
  if(this.containsKey(key)) {
    var val = this.keyMap_.get(key);
    if(goog.isArray(val)) {
      return val[0]
    }else {
      return val
    }
  }else {
    return opt_default
  }
};
goog.Uri.QueryData.prototype.setValues = function(key, values) {
  this.ensureKeyMapInitialized_();
  this.invalidateCache_();
  key = this.getKeyName_(key);
  if(this.containsKey(key)) {
    var old = this.keyMap_.get(key);
    if(goog.isArray(old)) {
      this.count_ -= old.length
    }else {
      this.count_--
    }
  }
  if(values.length > 0) {
    this.keyMap_.set(key, values);
    this.count_ += values.length
  }
};
goog.Uri.QueryData.prototype.toString = function() {
  if(this.encodedQuery_) {
    return this.encodedQuery_
  }
  if(!this.keyMap_) {
    return""
  }
  var sb = [];
  var count = 0;
  var keys = this.keyMap_.getKeys();
  for(var i = 0;i < keys.length;i++) {
    var key = keys[i];
    var encodedKey = goog.string.urlEncode(key);
    var val = this.keyMap_.get(key);
    if(goog.isArray(val)) {
      for(var j = 0;j < val.length;j++) {
        if(count > 0) {
          sb.push("&")
        }
        sb.push(encodedKey);
        if(val[j] !== "") {
          sb.push("=", goog.string.urlEncode(val[j]))
        }
        count++
      }
    }else {
      if(count > 0) {
        sb.push("&")
      }
      sb.push(encodedKey);
      if(val !== "") {
        sb.push("=", goog.string.urlEncode(val))
      }
      count++
    }
  }
  return this.encodedQuery_ = sb.join("")
};
goog.Uri.QueryData.prototype.toDecodedString = function() {
  if(!this.decodedQuery_) {
    this.decodedQuery_ = goog.Uri.decodeOrEmpty_(this.toString())
  }
  return this.decodedQuery_
};
goog.Uri.QueryData.prototype.invalidateCache_ = function() {
  delete this.decodedQuery_;
  delete this.encodedQuery_;
  if(this.uri_) {
    delete this.uri_.cachedToString_
  }
};
goog.Uri.QueryData.prototype.filterKeys = function(keys) {
  this.ensureKeyMapInitialized_();
  goog.structs.forEach(this.keyMap_, function(value, key, map) {
    if(!goog.array.contains(keys, key)) {
      this.remove(key)
    }
  }, this);
  return this
};
goog.Uri.QueryData.prototype.clone = function() {
  var rv = new goog.Uri.QueryData;
  if(this.decodedQuery_) {
    rv.decodedQuery_ = this.decodedQuery_
  }
  if(this.encodedQuery_) {
    rv.encodedQuery_ = this.encodedQuery_
  }
  if(this.keyMap_) {
    rv.keyMap_ = this.keyMap_.clone()
  }
  return rv
};
goog.Uri.QueryData.prototype.getKeyName_ = function(arg) {
  var keyName = String(arg);
  if(this.ignoreCase_) {
    keyName = keyName.toLowerCase()
  }
  return keyName
};
goog.Uri.QueryData.prototype.setIgnoreCase = function(ignoreCase) {
  var resetKeys = ignoreCase && !this.ignoreCase_;
  if(resetKeys) {
    this.ensureKeyMapInitialized_();
    this.invalidateCache_();
    goog.structs.forEach(this.keyMap_, function(value, key, map) {
      var lowerCase = key.toLowerCase();
      if(key != lowerCase) {
        this.remove(key);
        this.add(lowerCase, value)
      }
    }, this)
  }
  this.ignoreCase_ = ignoreCase
};
goog.Uri.QueryData.prototype.extend = function(var_args) {
  for(var i = 0;i < arguments.length;i++) {
    var data = arguments[i];
    goog.structs.forEach(data, function(value, key) {
      this.add(key, value)
    }, this)
  }
};
goog.provide("goog.events.KeyCodes");
goog.require("goog.userAgent");
goog.events.KeyCodes = {MAC_ENTER:3, BACKSPACE:8, TAB:9, NUM_CENTER:12, ENTER:13, SHIFT:16, CTRL:17, ALT:18, PAUSE:19, CAPS_LOCK:20, ESC:27, SPACE:32, PAGE_UP:33, PAGE_DOWN:34, END:35, HOME:36, LEFT:37, UP:38, RIGHT:39, DOWN:40, PRINT_SCREEN:44, INSERT:45, DELETE:46, ZERO:48, ONE:49, TWO:50, THREE:51, FOUR:52, FIVE:53, SIX:54, SEVEN:55, EIGHT:56, NINE:57, QUESTION_MARK:63, A:65, B:66, C:67, D:68, E:69, F:70, G:71, H:72, I:73, J:74, K:75, L:76, M:77, N:78, O:79, P:80, Q:81, R:82, S:83, T:84, U:85, 
V:86, W:87, X:88, Y:89, Z:90, META:91, CONTEXT_MENU:93, NUM_ZERO:96, NUM_ONE:97, NUM_TWO:98, NUM_THREE:99, NUM_FOUR:100, NUM_FIVE:101, NUM_SIX:102, NUM_SEVEN:103, NUM_EIGHT:104, NUM_NINE:105, NUM_MULTIPLY:106, NUM_PLUS:107, NUM_MINUS:109, NUM_PERIOD:110, NUM_DIVISION:111, F1:112, F2:113, F3:114, F4:115, F5:116, F6:117, F7:118, F8:119, F9:120, F10:121, F11:122, F12:123, NUMLOCK:144, SEMICOLON:186, DASH:189, EQUALS:187, COMMA:188, PERIOD:190, SLASH:191, APOSTROPHE:192, SINGLE_QUOTE:222, OPEN_SQUARE_BRACKET:219, 
BACKSLASH:220, CLOSE_SQUARE_BRACKET:221, WIN_KEY:224, MAC_FF_META:224, WIN_IME:229, PHANTOM:255};
goog.events.KeyCodes.isTextModifyingKeyEvent = function(e) {
  if(e.altKey && !e.ctrlKey || e.metaKey || e.keyCode >= goog.events.KeyCodes.F1 && e.keyCode <= goog.events.KeyCodes.F12) {
    return false
  }
  switch(e.keyCode) {
    case goog.events.KeyCodes.ALT:
    ;
    case goog.events.KeyCodes.CAPS_LOCK:
    ;
    case goog.events.KeyCodes.CONTEXT_MENU:
    ;
    case goog.events.KeyCodes.CTRL:
    ;
    case goog.events.KeyCodes.DOWN:
    ;
    case goog.events.KeyCodes.END:
    ;
    case goog.events.KeyCodes.ESC:
    ;
    case goog.events.KeyCodes.HOME:
    ;
    case goog.events.KeyCodes.INSERT:
    ;
    case goog.events.KeyCodes.LEFT:
    ;
    case goog.events.KeyCodes.MAC_FF_META:
    ;
    case goog.events.KeyCodes.META:
    ;
    case goog.events.KeyCodes.NUMLOCK:
    ;
    case goog.events.KeyCodes.NUM_CENTER:
    ;
    case goog.events.KeyCodes.PAGE_DOWN:
    ;
    case goog.events.KeyCodes.PAGE_UP:
    ;
    case goog.events.KeyCodes.PAUSE:
    ;
    case goog.events.KeyCodes.PHANTOM:
    ;
    case goog.events.KeyCodes.PRINT_SCREEN:
    ;
    case goog.events.KeyCodes.RIGHT:
    ;
    case goog.events.KeyCodes.SHIFT:
    ;
    case goog.events.KeyCodes.UP:
    ;
    case goog.events.KeyCodes.WIN_KEY:
      return false;
    default:
      return true
  }
};
goog.events.KeyCodes.firesKeyPressEvent = function(keyCode, opt_heldKeyCode, opt_shiftKey, opt_ctrlKey, opt_altKey) {
  if(!goog.userAgent.IE && !(goog.userAgent.WEBKIT && goog.userAgent.isVersion("525"))) {
    return true
  }
  if(goog.userAgent.MAC && opt_altKey) {
    return goog.events.KeyCodes.isCharacterKey(keyCode)
  }
  if(opt_altKey && !opt_ctrlKey) {
    return false
  }
  if(!opt_shiftKey && (opt_heldKeyCode == goog.events.KeyCodes.CTRL || opt_heldKeyCode == goog.events.KeyCodes.ALT)) {
    return false
  }
  if(goog.userAgent.IE && opt_ctrlKey && opt_heldKeyCode == keyCode) {
    return false
  }
  switch(keyCode) {
    case goog.events.KeyCodes.ENTER:
      return true;
    case goog.events.KeyCodes.ESC:
      return!goog.userAgent.WEBKIT
  }
  return goog.events.KeyCodes.isCharacterKey(keyCode)
};
goog.events.KeyCodes.isCharacterKey = function(keyCode) {
  if(keyCode >= goog.events.KeyCodes.ZERO && keyCode <= goog.events.KeyCodes.NINE) {
    return true
  }
  if(keyCode >= goog.events.KeyCodes.NUM_ZERO && keyCode <= goog.events.KeyCodes.NUM_MULTIPLY) {
    return true
  }
  if(keyCode >= goog.events.KeyCodes.A && keyCode <= goog.events.KeyCodes.Z) {
    return true
  }
  if(goog.userAgent.WEBKIT && keyCode == 0) {
    return true
  }
  switch(keyCode) {
    case goog.events.KeyCodes.SPACE:
    ;
    case goog.events.KeyCodes.QUESTION_MARK:
    ;
    case goog.events.KeyCodes.NUM_PLUS:
    ;
    case goog.events.KeyCodes.NUM_MINUS:
    ;
    case goog.events.KeyCodes.NUM_PERIOD:
    ;
    case goog.events.KeyCodes.NUM_DIVISION:
    ;
    case goog.events.KeyCodes.SEMICOLON:
    ;
    case goog.events.KeyCodes.DASH:
    ;
    case goog.events.KeyCodes.EQUALS:
    ;
    case goog.events.KeyCodes.COMMA:
    ;
    case goog.events.KeyCodes.PERIOD:
    ;
    case goog.events.KeyCodes.SLASH:
    ;
    case goog.events.KeyCodes.APOSTROPHE:
    ;
    case goog.events.KeyCodes.SINGLE_QUOTE:
    ;
    case goog.events.KeyCodes.OPEN_SQUARE_BRACKET:
    ;
    case goog.events.KeyCodes.BACKSLASH:
    ;
    case goog.events.KeyCodes.CLOSE_SQUARE_BRACKET:
      return true;
    default:
      return false
  }
};
goog.provide("goog.events.KeyEvent");
goog.provide("goog.events.KeyHandler");
goog.provide("goog.events.KeyHandler.EventType");
goog.require("goog.events");
goog.require("goog.events.BrowserEvent");
goog.require("goog.events.EventTarget");
goog.require("goog.events.EventType");
goog.require("goog.events.KeyCodes");
goog.require("goog.userAgent");
goog.events.KeyHandler = function(opt_element, opt_capture) {
  goog.events.EventTarget.call(this);
  if(opt_element) {
    this.attach(opt_element, opt_capture)
  }
};
goog.inherits(goog.events.KeyHandler, goog.events.EventTarget);
goog.events.KeyHandler.prototype.element_ = null;
goog.events.KeyHandler.prototype.keyPressKey_ = null;
goog.events.KeyHandler.prototype.keyDownKey_ = null;
goog.events.KeyHandler.prototype.keyUpKey_ = null;
goog.events.KeyHandler.prototype.lastKey_ = -1;
goog.events.KeyHandler.prototype.keyCode_ = -1;
goog.events.KeyHandler.EventType = {KEY:"key"};
goog.events.KeyHandler.safariKey_ = {3:goog.events.KeyCodes.ENTER, 12:goog.events.KeyCodes.NUMLOCK, 63232:goog.events.KeyCodes.UP, 63233:goog.events.KeyCodes.DOWN, 63234:goog.events.KeyCodes.LEFT, 63235:goog.events.KeyCodes.RIGHT, 63236:goog.events.KeyCodes.F1, 63237:goog.events.KeyCodes.F2, 63238:goog.events.KeyCodes.F3, 63239:goog.events.KeyCodes.F4, 63240:goog.events.KeyCodes.F5, 63241:goog.events.KeyCodes.F6, 63242:goog.events.KeyCodes.F7, 63243:goog.events.KeyCodes.F8, 63244:goog.events.KeyCodes.F9, 
63245:goog.events.KeyCodes.F10, 63246:goog.events.KeyCodes.F11, 63247:goog.events.KeyCodes.F12, 63248:goog.events.KeyCodes.PRINT_SCREEN, 63272:goog.events.KeyCodes.DELETE, 63273:goog.events.KeyCodes.HOME, 63275:goog.events.KeyCodes.END, 63276:goog.events.KeyCodes.PAGE_UP, 63277:goog.events.KeyCodes.PAGE_DOWN, 63289:goog.events.KeyCodes.NUMLOCK, 63302:goog.events.KeyCodes.INSERT};
goog.events.KeyHandler.keyIdentifier_ = {"Up":goog.events.KeyCodes.UP, "Down":goog.events.KeyCodes.DOWN, "Left":goog.events.KeyCodes.LEFT, "Right":goog.events.KeyCodes.RIGHT, "Enter":goog.events.KeyCodes.ENTER, "F1":goog.events.KeyCodes.F1, "F2":goog.events.KeyCodes.F2, "F3":goog.events.KeyCodes.F3, "F4":goog.events.KeyCodes.F4, "F5":goog.events.KeyCodes.F5, "F6":goog.events.KeyCodes.F6, "F7":goog.events.KeyCodes.F7, "F8":goog.events.KeyCodes.F8, "F9":goog.events.KeyCodes.F9, "F10":goog.events.KeyCodes.F10, 
"F11":goog.events.KeyCodes.F11, "F12":goog.events.KeyCodes.F12, "U+007F":goog.events.KeyCodes.DELETE, "Home":goog.events.KeyCodes.HOME, "End":goog.events.KeyCodes.END, "PageUp":goog.events.KeyCodes.PAGE_UP, "PageDown":goog.events.KeyCodes.PAGE_DOWN, "Insert":goog.events.KeyCodes.INSERT};
goog.events.KeyHandler.mozKeyCodeToKeyCodeMap_ = {61:187, 59:186};
goog.events.KeyHandler.USES_KEYDOWN_ = goog.userAgent.IE || goog.userAgent.WEBKIT && goog.userAgent.isVersion("525");
goog.events.KeyHandler.prototype.handleKeyDown_ = function(e) {
  if(goog.userAgent.WEBKIT && (this.lastKey_ == goog.events.KeyCodes.CTRL && !e.ctrlKey || this.lastKey_ == goog.events.KeyCodes.ALT && !e.altKey)) {
    this.lastKey_ = -1;
    this.keyCode_ = -1
  }
  if(goog.events.KeyHandler.USES_KEYDOWN_ && !goog.events.KeyCodes.firesKeyPressEvent(e.keyCode, this.lastKey_, e.shiftKey, e.ctrlKey, e.altKey)) {
    this.handleEvent(e)
  }else {
    if(goog.userAgent.GECKO && e.keyCode in goog.events.KeyHandler.mozKeyCodeToKeyCodeMap_) {
      this.keyCode_ = goog.events.KeyHandler.mozKeyCodeToKeyCodeMap_[e.keyCode]
    }else {
      this.keyCode_ = e.keyCode
    }
  }
};
goog.events.KeyHandler.prototype.handleKeyup_ = function(e) {
  this.lastKey_ = -1;
  this.keyCode_ = -1
};
goog.events.KeyHandler.prototype.handleEvent = function(e) {
  var be = e.getBrowserEvent();
  var keyCode, charCode;
  if(goog.userAgent.IE && e.type == goog.events.EventType.KEYPRESS) {
    keyCode = this.keyCode_;
    charCode = keyCode != goog.events.KeyCodes.ENTER && keyCode != goog.events.KeyCodes.ESC ? be.keyCode : 0
  }else {
    if(goog.userAgent.WEBKIT && e.type == goog.events.EventType.KEYPRESS) {
      keyCode = this.keyCode_;
      charCode = be.charCode >= 0 && be.charCode < 63232 && goog.events.KeyCodes.isCharacterKey(keyCode) ? be.charCode : 0
    }else {
      if(goog.userAgent.OPERA) {
        keyCode = this.keyCode_;
        charCode = goog.events.KeyCodes.isCharacterKey(keyCode) ? be.keyCode : 0
      }else {
        keyCode = be.keyCode || this.keyCode_;
        charCode = be.charCode || 0;
        if(goog.userAgent.MAC && charCode == goog.events.KeyCodes.QUESTION_MARK && !keyCode) {
          keyCode = goog.events.KeyCodes.SLASH
        }
      }
    }
  }
  var key = keyCode;
  var keyIdentifier = be.keyIdentifier;
  if(keyCode) {
    if(keyCode >= 63232 && keyCode in goog.events.KeyHandler.safariKey_) {
      key = goog.events.KeyHandler.safariKey_[keyCode]
    }else {
      if(keyCode == 25 && e.shiftKey) {
        key = 9
      }
    }
  }else {
    if(keyIdentifier && keyIdentifier in goog.events.KeyHandler.keyIdentifier_) {
      key = goog.events.KeyHandler.keyIdentifier_[keyIdentifier]
    }
  }
  var repeat = key == this.lastKey_;
  this.lastKey_ = key;
  var event = new goog.events.KeyEvent(key, charCode, repeat, be);
  try {
    this.dispatchEvent(event)
  }finally {
    event.dispose()
  }
};
goog.events.KeyHandler.prototype.getElement = function() {
  return this.element_
};
goog.events.KeyHandler.prototype.attach = function(element, opt_capture) {
  if(this.keyUpKey_) {
    this.detach()
  }
  this.element_ = element;
  this.keyPressKey_ = goog.events.listen(this.element_, goog.events.EventType.KEYPRESS, this, opt_capture);
  this.keyDownKey_ = goog.events.listen(this.element_, goog.events.EventType.KEYDOWN, this.handleKeyDown_, opt_capture, this);
  this.keyUpKey_ = goog.events.listen(this.element_, goog.events.EventType.KEYUP, this.handleKeyup_, opt_capture, this)
};
goog.events.KeyHandler.prototype.detach = function() {
  if(this.keyPressKey_) {
    goog.events.unlistenByKey(this.keyPressKey_);
    goog.events.unlistenByKey(this.keyDownKey_);
    goog.events.unlistenByKey(this.keyUpKey_);
    this.keyPressKey_ = null;
    this.keyDownKey_ = null;
    this.keyUpKey_ = null
  }
  this.element_ = null;
  this.lastKey_ = -1;
  this.keyCode_ = -1
};
goog.events.KeyHandler.prototype.disposeInternal = function() {
  goog.events.KeyHandler.superClass_.disposeInternal.call(this);
  this.detach()
};
goog.events.KeyEvent = function(keyCode, charCode, repeat, browserEvent) {
  goog.events.BrowserEvent.call(this, browserEvent);
  this.type = goog.events.KeyHandler.EventType.KEY;
  this.keyCode = keyCode;
  this.charCode = charCode;
  this.repeat = repeat
};
goog.inherits(goog.events.KeyEvent, goog.events.BrowserEvent);
goog.provide("goog.net.xpc.Transport");
goog.require("goog.Disposable");
goog.require("goog.net.xpc");
goog.net.xpc.Transport = function(opt_domHelper) {
  goog.Disposable.call(this);
  this.domHelper_ = opt_domHelper || goog.dom.getDomHelper()
};
goog.inherits(goog.net.xpc.Transport, goog.Disposable);
goog.net.xpc.Transport.prototype.transportType = 0;
goog.net.xpc.Transport.prototype.getType = function() {
  return this.transportType
};
goog.net.xpc.Transport.prototype.getWindow = function() {
  return this.domHelper_.getWindow()
};
goog.net.xpc.Transport.prototype.getName = function() {
  return goog.net.xpc.TransportNames[this.transportType] || ""
};
goog.net.xpc.Transport.prototype.transportServiceHandler = goog.abstractMethod;
goog.net.xpc.Transport.prototype.connect = goog.abstractMethod;
goog.net.xpc.Transport.prototype.send = goog.abstractMethod;
goog.provide("goog.messaging.MessageChannel");
goog.messaging.MessageChannel = function() {
};
goog.messaging.MessageChannel.prototype.connect = function(opt_connectCb) {
};
goog.messaging.MessageChannel.prototype.isConnected = function() {
};
goog.messaging.MessageChannel.prototype.registerService = function(serviceName, callback, opt_objectPayload) {
};
goog.messaging.MessageChannel.prototype.registerDefaultService = function(callback) {
};
goog.messaging.MessageChannel.prototype.send = function(serviceName, payload) {
};
goog.provide("goog.messaging.AbstractChannel");
goog.require("goog.Disposable");
goog.require("goog.debug");
goog.require("goog.debug.Logger");
goog.require("goog.json");
goog.require("goog.messaging.MessageChannel");
goog.messaging.AbstractChannel = function() {
  goog.base(this);
  this.services_ = {}
};
goog.inherits(goog.messaging.AbstractChannel, goog.Disposable);
goog.messaging.AbstractChannel.prototype.defaultService_;
goog.messaging.AbstractChannel.prototype.logger = goog.debug.Logger.getLogger("goog.messaging.AbstractChannel");
goog.messaging.AbstractChannel.prototype.connect = function(opt_connectCb) {
  if(opt_connectCb) {
    opt_connectCb()
  }
};
goog.messaging.AbstractChannel.prototype.isConnected = function() {
  return true
};
goog.messaging.AbstractChannel.prototype.registerService = function(serviceName, callback, opt_objectPayload) {
  this.services_[serviceName] = {callback:callback, objectPayload:!!opt_objectPayload}
};
goog.messaging.AbstractChannel.prototype.registerDefaultService = function(callback) {
  this.defaultService_ = callback
};
goog.messaging.AbstractChannel.prototype.send = goog.abstractMethod;
goog.messaging.AbstractChannel.prototype.deliver = function(serviceName, payload) {
  var service = this.getService(serviceName, payload);
  if(!service) {
    return
  }
  payload = this.decodePayload(serviceName, payload, service.objectPayload);
  if(goog.isDefAndNotNull(payload)) {
    service.callback(payload)
  }
};
goog.messaging.AbstractChannel.prototype.getService = function(serviceName, payload) {
  var service = this.services_[serviceName];
  if(service) {
    return service
  }else {
    if(this.defaultService_) {
      var callback = goog.partial(this.defaultService_, serviceName);
      var objectPayload = goog.isObject(payload);
      return{callback:callback, objectPayload:objectPayload}
    }
  }
  this.logger.warning('Unknown service name "' + serviceName + '"');
  return null
};
goog.messaging.AbstractChannel.prototype.decodePayload = function(serviceName, payload, objectPayload) {
  if(objectPayload && goog.isString(payload)) {
    try {
      return goog.json.parse(payload)
    }catch(err) {
      this.logger.warning("Expected JSON payload for " + serviceName + ', was "' + payload + '"');
      return null
    }
  }else {
    if(!objectPayload && !goog.isString(payload)) {
      return goog.json.serialize(payload)
    }
  }
  return payload
};
goog.messaging.AbstractChannel.prototype.disposeInternal = function() {
  goog.base(this, "disposeInternal");
  goog.dispose(this.logger);
  delete this.logger;
  delete this.services_;
  delete this.defaultService_
};
goog.provide("clojure.browser.event");
goog.require("cljs.core");
goog.require("goog.events");
goog.require("goog.events.EventTarget");
goog.require("goog.events.EventType");
clojure.browser.event.EventType = {};
clojure.browser.event.event_types = function event_types(this$) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1606250 = this$;
    if(cljs.core.truth_(and__3546__auto____1606250)) {
      return this$.clojure$browser$event$EventType$event_types
    }else {
      return and__3546__auto____1606250
    }
  }())) {
    return this$.clojure$browser$event$EventType$event_types(this$)
  }else {
    return function() {
      var or__3548__auto____1606251 = clojure.browser.event.event_types[goog.typeOf.call(null, this$)];
      if(cljs.core.truth_(or__3548__auto____1606251)) {
        return or__3548__auto____1606251
      }else {
        var or__3548__auto____1606252 = clojure.browser.event.event_types["_"];
        if(cljs.core.truth_(or__3548__auto____1606252)) {
          return or__3548__auto____1606252
        }else {
          throw cljs.core.missing_protocol.call(null, "EventType.event-types", this$);
        }
      }
    }().call(null, this$)
  }
};
Element.prototype.clojure$browser$event$EventType$ = true;
Element.prototype.clojure$browser$event$EventType$event_types = function(this$) {
  return cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), cljs.core.map.call(null, function(p__1606253) {
    var vec__1606254__1606255 = p__1606253;
    var k__1606256 = cljs.core.nth.call(null, vec__1606254__1606255, 0, null);
    var v__1606257 = cljs.core.nth.call(null, vec__1606254__1606255, 1, null);
    return cljs.core.PersistentVector.fromArray([cljs.core.keyword.call(null, k__1606256.toLowerCase()), v__1606257])
  }, cljs.core.merge.call(null, cljs.core.js__GT_clj.call(null, goog.events.EventType))))
};
goog.events.EventTarget.prototype.clojure$browser$event$EventType$ = true;
goog.events.EventTarget.prototype.clojure$browser$event$EventType$event_types = function(this$) {
  return cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), cljs.core.map.call(null, function(p__1606258) {
    var vec__1606259__1606260 = p__1606258;
    var k__1606261 = cljs.core.nth.call(null, vec__1606259__1606260, 0, null);
    var v__1606262 = cljs.core.nth.call(null, vec__1606259__1606260, 1, null);
    return cljs.core.PersistentVector.fromArray([cljs.core.keyword.call(null, k__1606261.toLowerCase()), v__1606262])
  }, cljs.core.merge.call(null, cljs.core.js__GT_clj.call(null, goog.events.EventType))))
};
clojure.browser.event.listen = function() {
  var listen = null;
  var listen__1606263 = function(src, type, fn) {
    return listen.call(null, src, type, fn, false)
  };
  var listen__1606264 = function(src, type, fn, capture_QMARK_) {
    return goog.events.listen.call(null, src, cljs.core.get.call(null, clojure.browser.event.event_types.call(null, src), type, type), fn, capture_QMARK_)
  };
  listen = function(src, type, fn, capture_QMARK_) {
    switch(arguments.length) {
      case 3:
        return listen__1606263.call(this, src, type, fn);
      case 4:
        return listen__1606264.call(this, src, type, fn, capture_QMARK_)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return listen
}();
clojure.browser.event.listen_once = function() {
  var listen_once = null;
  var listen_once__1606266 = function(src, type, fn) {
    return listen_once.call(null, src, type, fn, false)
  };
  var listen_once__1606267 = function(src, type, fn, capture_QMARK_) {
    return goog.events.listenOnce.call(null, src, cljs.core.get.call(null, clojure.browser.event.event_types.call(null, src), type, type), fn, capture_QMARK_)
  };
  listen_once = function(src, type, fn, capture_QMARK_) {
    switch(arguments.length) {
      case 3:
        return listen_once__1606266.call(this, src, type, fn);
      case 4:
        return listen_once__1606267.call(this, src, type, fn, capture_QMARK_)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return listen_once
}();
clojure.browser.event.unlisten = function() {
  var unlisten = null;
  var unlisten__1606269 = function(src, type, fn) {
    return unlisten.call(null, src, type, fn, false)
  };
  var unlisten__1606270 = function(src, type, fn, capture_QMARK_) {
    return goog.events.unlisten.call(null, src, cljs.core.get.call(null, clojure.browser.event.event_types.call(null, src), type, type), fn, capture_QMARK_)
  };
  unlisten = function(src, type, fn, capture_QMARK_) {
    switch(arguments.length) {
      case 3:
        return unlisten__1606269.call(this, src, type, fn);
      case 4:
        return unlisten__1606270.call(this, src, type, fn, capture_QMARK_)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return unlisten
}();
clojure.browser.event.unlisten_by_key = function unlisten_by_key(key) {
  return goog.events.unlistenByKey.call(null, key)
};
clojure.browser.event.dispatch_event = function dispatch_event(src, event) {
  return goog.events.dispatchEvent.call(null, src, event)
};
clojure.browser.event.expose = function expose(e) {
  return goog.events.expose.call(null, e)
};
clojure.browser.event.fire_listeners = function fire_listeners(obj, type, capture, event) {
  return null
};
clojure.browser.event.total_listener_count = function total_listener_count() {
  return goog.events.getTotalListenerCount.call(null)
};
clojure.browser.event.get_listener = function get_listener(src, type, listener, opt_capt, opt_handler) {
  return null
};
clojure.browser.event.all_listeners = function all_listeners(obj, type, capture) {
  return null
};
clojure.browser.event.unique_event_id = function unique_event_id(event_type) {
  return null
};
clojure.browser.event.has_listener = function has_listener(obj, opt_type, opt_capture) {
  return null
};
clojure.browser.event.remove_all = function remove_all(opt_obj, opt_type, opt_capt) {
  return null
};
goog.provide("goog.net.xpc.IframePollingTransport");
goog.provide("goog.net.xpc.IframePollingTransport.Receiver");
goog.provide("goog.net.xpc.IframePollingTransport.Sender");
goog.require("goog.array");
goog.require("goog.dom");
goog.require("goog.net.xpc");
goog.require("goog.net.xpc.Transport");
goog.require("goog.userAgent");
goog.net.xpc.IframePollingTransport = function(channel, opt_domHelper) {
  goog.base(this, opt_domHelper);
  this.channel_ = channel;
  this.sendUri_ = this.channel_.cfg_[goog.net.xpc.CfgFields.PEER_POLL_URI];
  this.rcvUri_ = this.channel_.cfg_[goog.net.xpc.CfgFields.LOCAL_POLL_URI];
  this.sendQueue_ = []
};
goog.inherits(goog.net.xpc.IframePollingTransport, goog.net.xpc.Transport);
goog.net.xpc.IframePollingTransport.prototype.transportType = goog.net.xpc.TransportTypes.IFRAME_POLLING;
goog.net.xpc.IframePollingTransport.prototype.sequence_ = 0;
goog.net.xpc.IframePollingTransport.prototype.waitForAck_ = false;
goog.net.xpc.IframePollingTransport.prototype.initialized_ = false;
goog.net.xpc.IframePollingTransport.IFRAME_PREFIX = "googlexpc";
goog.net.xpc.IframePollingTransport.prototype.getMsgFrameName_ = function() {
  return goog.net.xpc.IframePollingTransport.IFRAME_PREFIX + "_" + this.channel_.name + "_msg"
};
goog.net.xpc.IframePollingTransport.prototype.getAckFrameName_ = function() {
  return goog.net.xpc.IframePollingTransport.IFRAME_PREFIX + "_" + this.channel_.name + "_ack"
};
goog.net.xpc.IframePollingTransport.prototype.connect = function() {
  goog.net.xpc.logger.fine("transport connect called");
  if(!this.initialized_) {
    goog.net.xpc.logger.fine("initializing...");
    this.constructSenderFrames_();
    this.initialized_ = true
  }
  this.checkForeignFramesReady_()
};
goog.net.xpc.IframePollingTransport.prototype.constructSenderFrames_ = function() {
  var name = this.getMsgFrameName_();
  this.msgIframeElm_ = this.constructSenderFrame_(name);
  this.msgWinObj_ = this.getWindow().frames[name];
  name = this.getAckFrameName_();
  this.ackIframeElm_ = this.constructSenderFrame_(name);
  this.ackWinObj_ = this.getWindow().frames[name]
};
goog.net.xpc.IframePollingTransport.prototype.constructSenderFrame_ = function(id) {
  goog.net.xpc.logger.finest("constructing sender frame: " + id);
  var ifr = goog.dom.createElement("iframe");
  var s = ifr.style;
  s.position = "absolute";
  s.top = "-10px";
  s.left = "10px";
  s.width = "1px";
  s.height = "1px";
  ifr.id = ifr.name = id;
  ifr.src = this.sendUri_ + "#INITIAL";
  this.getWindow().document.body.appendChild(ifr);
  return ifr
};
goog.net.xpc.IframePollingTransport.prototype.innerPeerReconnect_ = function() {
  goog.net.xpc.logger.finest("innerPeerReconnect called");
  this.channel_.name = goog.net.xpc.getRandomString(10);
  goog.net.xpc.logger.finest("switching channels: " + this.channel_.name);
  this.deconstructSenderFrames_();
  this.initialized_ = false;
  this.reconnectFrame_ = this.constructSenderFrame_(goog.net.xpc.IframePollingTransport.IFRAME_PREFIX + "_reconnect_" + this.channel_.name)
};
goog.net.xpc.IframePollingTransport.prototype.outerPeerReconnect_ = function() {
  goog.net.xpc.logger.finest("outerPeerReconnect called");
  var frames = this.channel_.peerWindowObject_.frames;
  var length = frames.length;
  for(var i = 0;i < length;i++) {
    var frameName;
    try {
      if(frames[i] && frames[i].name) {
        frameName = frames[i].name
      }
    }catch(e) {
    }
    if(!frameName) {
      continue
    }
    var message = frameName.split("_");
    if(message.length == 3 && message[0] == goog.net.xpc.IframePollingTransport.IFRAME_PREFIX && message[1] == "reconnect") {
      this.channel_.name = message[2];
      this.deconstructSenderFrames_();
      this.initialized_ = false;
      break
    }
  }
};
goog.net.xpc.IframePollingTransport.prototype.deconstructSenderFrames_ = function() {
  goog.net.xpc.logger.finest("deconstructSenderFrames called");
  if(this.msgIframeElm_) {
    this.msgIframeElm_.parentNode.removeChild(this.msgIframeElm_);
    this.msgIframeElm_ = null;
    this.msgWinObj_ = null
  }
  if(this.ackIframeElm_) {
    this.ackIframeElm_.parentNode.removeChild(this.ackIframeElm_);
    this.ackIframeElm_ = null;
    this.ackWinObj_ = null
  }
};
goog.net.xpc.IframePollingTransport.prototype.checkForeignFramesReady_ = function() {
  if(!(this.isRcvFrameReady_(this.getMsgFrameName_()) && this.isRcvFrameReady_(this.getAckFrameName_()))) {
    goog.net.xpc.logger.finest("foreign frames not (yet) present");
    if(this.channel_.getRole() == goog.net.xpc.CrossPageChannel.Role.INNER && !this.reconnectFrame_) {
      this.innerPeerReconnect_()
    }else {
      if(this.channel_.getRole() == goog.net.xpc.CrossPageChannel.Role.OUTER) {
        this.outerPeerReconnect_()
      }
    }
    this.getWindow().setTimeout(goog.bind(this.connect, this), 100)
  }else {
    goog.net.xpc.logger.fine("foreign frames present");
    this.msgReceiver_ = new goog.net.xpc.IframePollingTransport.Receiver(this, this.channel_.peerWindowObject_.frames[this.getMsgFrameName_()], goog.bind(this.processIncomingMsg, this));
    this.ackReceiver_ = new goog.net.xpc.IframePollingTransport.Receiver(this, this.channel_.peerWindowObject_.frames[this.getAckFrameName_()], goog.bind(this.processIncomingAck, this));
    this.checkLocalFramesPresent_()
  }
};
goog.net.xpc.IframePollingTransport.prototype.isRcvFrameReady_ = function(frameName) {
  goog.net.xpc.logger.finest("checking for receive frame: " + frameName);
  try {
    var winObj = this.channel_.peerWindowObject_.frames[frameName];
    if(!winObj || winObj.location.href.indexOf(this.rcvUri_) != 0) {
      return false
    }
  }catch(e) {
    return false
  }
  return true
};
goog.net.xpc.IframePollingTransport.prototype.checkLocalFramesPresent_ = function() {
  var frames = this.channel_.peerWindowObject_.frames;
  if(!(frames[this.getAckFrameName_()] && frames[this.getMsgFrameName_()])) {
    if(!this.checkLocalFramesPresentCb_) {
      this.checkLocalFramesPresentCb_ = goog.bind(this.checkLocalFramesPresent_, this)
    }
    this.getWindow().setTimeout(this.checkLocalFramesPresentCb_, 100);
    goog.net.xpc.logger.fine("local frames not (yet) present")
  }else {
    this.msgSender_ = new goog.net.xpc.IframePollingTransport.Sender(this.sendUri_, this.msgWinObj_);
    this.ackSender_ = new goog.net.xpc.IframePollingTransport.Sender(this.sendUri_, this.ackWinObj_);
    goog.net.xpc.logger.fine("local frames ready");
    this.getWindow().setTimeout(goog.bind(function() {
      this.msgSender_.send(goog.net.xpc.SETUP);
      this.sentConnectionSetup_ = true;
      this.waitForAck_ = true;
      goog.net.xpc.logger.fine("SETUP sent")
    }, this), 100)
  }
};
goog.net.xpc.IframePollingTransport.prototype.checkIfConnected_ = function() {
  if(this.sentConnectionSetupAck_ && this.rcvdConnectionSetupAck_) {
    this.channel_.notifyConnected_();
    if(this.deliveryQueue_) {
      goog.net.xpc.logger.fine("delivering queued messages " + "(" + this.deliveryQueue_.length + ")");
      for(var i = 0, m;i < this.deliveryQueue_.length;i++) {
        m = this.deliveryQueue_[i];
        this.channel_.deliver_(m.service, m.payload)
      }
      delete this.deliveryQueue_
    }
  }else {
    goog.net.xpc.logger.finest("checking if connected: " + "ack sent:" + this.sentConnectionSetupAck_ + ", ack rcvd: " + this.rcvdConnectionSetupAck_)
  }
};
goog.net.xpc.IframePollingTransport.prototype.processIncomingMsg = function(raw) {
  goog.net.xpc.logger.finest("msg received: " + raw);
  if(raw == goog.net.xpc.SETUP) {
    if(!this.ackSender_) {
      return
    }
    this.ackSender_.send(goog.net.xpc.SETUP_ACK_);
    goog.net.xpc.logger.finest("SETUP_ACK sent");
    this.sentConnectionSetupAck_ = true;
    this.checkIfConnected_()
  }else {
    if(this.channel_.isConnected() || this.sentConnectionSetupAck_) {
      var pos = raw.indexOf("|");
      var head = raw.substring(0, pos);
      var frame = raw.substring(pos + 1);
      pos = head.indexOf(",");
      if(pos == -1) {
        var seq = head;
        this.ackSender_.send("ACK:" + seq);
        this.deliverPayload_(frame)
      }else {
        var seq = head.substring(0, pos);
        this.ackSender_.send("ACK:" + seq);
        var partInfo = head.substring(pos + 1).split("/");
        var part0 = parseInt(partInfo[0], 10);
        var part1 = parseInt(partInfo[1], 10);
        if(part0 == 1) {
          this.parts_ = []
        }
        this.parts_.push(frame);
        if(part0 == part1) {
          this.deliverPayload_(this.parts_.join(""));
          delete this.parts_
        }
      }
    }else {
      goog.net.xpc.logger.warning("received msg, but channel is not connected")
    }
  }
};
goog.net.xpc.IframePollingTransport.prototype.processIncomingAck = function(msgStr) {
  goog.net.xpc.logger.finest("ack received: " + msgStr);
  if(msgStr == goog.net.xpc.SETUP_ACK_) {
    this.waitForAck_ = false;
    this.rcvdConnectionSetupAck_ = true;
    this.checkIfConnected_()
  }else {
    if(this.channel_.isConnected()) {
      if(!this.waitForAck_) {
        goog.net.xpc.logger.warning("got unexpected ack");
        return
      }
      var seq = parseInt(msgStr.split(":")[1], 10);
      if(seq == this.sequence_) {
        this.waitForAck_ = false;
        this.sendNextFrame_()
      }else {
        goog.net.xpc.logger.warning("got ack with wrong sequence")
      }
    }else {
      goog.net.xpc.logger.warning("received ack, but channel not connected")
    }
  }
};
goog.net.xpc.IframePollingTransport.prototype.sendNextFrame_ = function() {
  if(this.waitForAck_ || !this.sendQueue_.length) {
    return
  }
  var s = this.sendQueue_.shift();
  ++this.sequence_;
  this.msgSender_.send(this.sequence_ + s);
  goog.net.xpc.logger.finest("msg sent: " + this.sequence_ + s);
  this.waitForAck_ = true
};
goog.net.xpc.IframePollingTransport.prototype.deliverPayload_ = function(s) {
  var pos = s.indexOf(":");
  var service = s.substr(0, pos);
  var payload = s.substring(pos + 1);
  if(!this.channel_.isConnected()) {
    (this.deliveryQueue_ || (this.deliveryQueue_ = [])).push({service:service, payload:payload});
    goog.net.xpc.logger.finest("queued delivery")
  }else {
    this.channel_.deliver_(service, payload)
  }
};
goog.net.xpc.IframePollingTransport.prototype.MAX_FRAME_LENGTH_ = 3800;
goog.net.xpc.IframePollingTransport.prototype.send = function(service, payload) {
  var frame = service + ":" + payload;
  if(!goog.userAgent.IE || payload.length <= this.MAX_FRAME_LENGTH_) {
    this.sendQueue_.push("|" + frame)
  }else {
    var l = payload.length;
    var num = Math.ceil(l / this.MAX_FRAME_LENGTH_);
    var pos = 0;
    var i = 1;
    while(pos < l) {
      this.sendQueue_.push("," + i + "/" + num + "|" + frame.substr(pos, this.MAX_FRAME_LENGTH_));
      i++;
      pos += this.MAX_FRAME_LENGTH_
    }
  }
  this.sendNextFrame_()
};
goog.net.xpc.IframePollingTransport.prototype.disposeInternal = function() {
  goog.base(this, "disposeInternal");
  var receivers = goog.net.xpc.IframePollingTransport.receivers_;
  goog.array.remove(receivers, this.msgReceiver_);
  goog.array.remove(receivers, this.ackReceiver_);
  this.msgReceiver_ = this.ackReceiver_ = null;
  goog.dom.removeNode(this.msgIframeElm_);
  goog.dom.removeNode(this.ackIframeElm_);
  this.msgIframeElm_ = this.ackIframeElm_ = null;
  this.msgWinObj_ = this.ackWinObj_ = null
};
goog.net.xpc.IframePollingTransport.receivers_ = [];
goog.net.xpc.IframePollingTransport.TIME_POLL_SHORT_ = 10;
goog.net.xpc.IframePollingTransport.TIME_POLL_LONG_ = 100;
goog.net.xpc.IframePollingTransport.TIME_SHORT_POLL_AFTER_ACTIVITY_ = 1E3;
goog.net.xpc.IframePollingTransport.receive_ = function() {
  var rcvd = false;
  try {
    for(var i = 0, l = goog.net.xpc.IframePollingTransport.receivers_.length;i < l;i++) {
      rcvd = rcvd || goog.net.xpc.IframePollingTransport.receivers_[i].receive()
    }
  }catch(e) {
    goog.net.xpc.logger.info("receive_() failed: " + e);
    goog.net.xpc.IframePollingTransport.receivers_[i].transport_.channel_.notifyTransportError_();
    if(!goog.net.xpc.IframePollingTransport.receivers_.length) {
      return
    }
  }
  var now = goog.now();
  if(rcvd) {
    goog.net.xpc.IframePollingTransport.lastActivity_ = now
  }
  var t = now - goog.net.xpc.IframePollingTransport.lastActivity_ < goog.net.xpc.IframePollingTransport.TIME_SHORT_POLL_AFTER_ACTIVITY_ ? goog.net.xpc.IframePollingTransport.TIME_POLL_SHORT_ : goog.net.xpc.IframePollingTransport.TIME_POLL_LONG_;
  goog.net.xpc.IframePollingTransport.rcvTimer_ = window.setTimeout(goog.net.xpc.IframePollingTransport.receiveCb_, t)
};
goog.net.xpc.IframePollingTransport.receiveCb_ = goog.bind(goog.net.xpc.IframePollingTransport.receive_, goog.net.xpc.IframePollingTransport);
goog.net.xpc.IframePollingTransport.startRcvTimer_ = function() {
  goog.net.xpc.logger.fine("starting receive-timer");
  goog.net.xpc.IframePollingTransport.lastActivity_ = goog.now();
  if(goog.net.xpc.IframePollingTransport.rcvTimer_) {
    window.clearTimeout(goog.net.xpc.IframePollingTransport.rcvTimer_)
  }
  goog.net.xpc.IframePollingTransport.rcvTimer_ = window.setTimeout(goog.net.xpc.IframePollingTransport.receiveCb_, goog.net.xpc.IframePollingTransport.TIME_POLL_SHORT_)
};
goog.net.xpc.IframePollingTransport.Sender = function(url, windowObj) {
  this.sendUri_ = url;
  this.sendFrame_ = windowObj;
  this.cycle_ = 0
};
goog.net.xpc.IframePollingTransport.Sender.prototype.send = function(payload) {
  this.cycle_ = ++this.cycle_ % 2;
  var url = this.sendUri_ + "#" + this.cycle_ + encodeURIComponent(payload);
  try {
    if(goog.userAgent.WEBKIT) {
      this.sendFrame_.location.href = url
    }else {
      this.sendFrame_.location.replace(url)
    }
  }catch(e) {
    goog.net.xpc.logger.severe("sending failed", e)
  }
  goog.net.xpc.IframePollingTransport.startRcvTimer_()
};
goog.net.xpc.IframePollingTransport.Receiver = function(transport, windowObj, callback) {
  this.transport_ = transport;
  this.rcvFrame_ = windowObj;
  this.cb_ = callback;
  this.currentLoc_ = this.rcvFrame_.location.href.split("#")[0] + "#INITIAL";
  goog.net.xpc.IframePollingTransport.receivers_.push(this);
  goog.net.xpc.IframePollingTransport.startRcvTimer_()
};
goog.net.xpc.IframePollingTransport.Receiver.prototype.receive = function() {
  var loc = this.rcvFrame_.location.href;
  if(loc != this.currentLoc_) {
    this.currentLoc_ = loc;
    var payload = loc.split("#")[1];
    if(payload) {
      payload = payload.substr(1);
      this.cb_(decodeURIComponent(payload))
    }
    return true
  }else {
    return false
  }
};
goog.provide("goog.net.xpc.FrameElementMethodTransport");
goog.require("goog.net.xpc");
goog.require("goog.net.xpc.Transport");
goog.net.xpc.FrameElementMethodTransport = function(channel, opt_domHelper) {
  goog.base(this, opt_domHelper);
  this.channel_ = channel;
  this.queue_ = [];
  this.deliverQueuedCb_ = goog.bind(this.deliverQueued_, this)
};
goog.inherits(goog.net.xpc.FrameElementMethodTransport, goog.net.xpc.Transport);
goog.net.xpc.FrameElementMethodTransport.prototype.transportType = goog.net.xpc.TransportTypes.FRAME_ELEMENT_METHOD;
goog.net.xpc.FrameElementMethodTransport.prototype.recursive_ = false;
goog.net.xpc.FrameElementMethodTransport.prototype.timer_ = 0;
goog.net.xpc.FrameElementMethodTransport.outgoing_ = null;
goog.net.xpc.FrameElementMethodTransport.prototype.connect = function() {
  if(this.channel_.getRole() == goog.net.xpc.CrossPageChannel.Role.OUTER) {
    this.iframeElm_ = this.channel_.iframeElement_;
    this.iframeElm_["XPC_toOuter"] = goog.bind(this.incoming_, this)
  }else {
    this.attemptSetup_()
  }
};
goog.net.xpc.FrameElementMethodTransport.prototype.attemptSetup_ = function() {
  var retry = true;
  try {
    if(!this.iframeElm_) {
      this.iframeElm_ = this.getWindow().frameElement
    }
    if(this.iframeElm_ && this.iframeElm_["XPC_toOuter"]) {
      this.outgoing_ = this.iframeElm_["XPC_toOuter"];
      this.iframeElm_["XPC_toOuter"]["XPC_toInner"] = goog.bind(this.incoming_, this);
      retry = false;
      this.send(goog.net.xpc.TRANSPORT_SERVICE_, goog.net.xpc.SETUP_ACK_);
      this.channel_.notifyConnected_()
    }
  }catch(e) {
    goog.net.xpc.logger.severe("exception caught while attempting setup: " + e)
  }
  if(retry) {
    if(!this.attemptSetupCb_) {
      this.attemptSetupCb_ = goog.bind(this.attemptSetup_, this)
    }
    this.getWindow().setTimeout(this.attemptSetupCb_, 100)
  }
};
goog.net.xpc.FrameElementMethodTransport.prototype.transportServiceHandler = function(payload) {
  if(this.channel_.getRole() == goog.net.xpc.CrossPageChannel.Role.OUTER && !this.channel_.isConnected() && payload == goog.net.xpc.SETUP_ACK_) {
    this.outgoing_ = this.iframeElm_["XPC_toOuter"]["XPC_toInner"];
    this.channel_.notifyConnected_()
  }else {
    throw Error("Got unexpected transport message.");
  }
};
goog.net.xpc.FrameElementMethodTransport.prototype.incoming_ = function(serviceName, payload) {
  if(!this.recursive_ && this.queue_.length == 0) {
    this.channel_.deliver_(serviceName, payload)
  }else {
    this.queue_.push({serviceName:serviceName, payload:payload});
    if(this.queue_.length == 1) {
      this.timer_ = this.getWindow().setTimeout(this.deliverQueuedCb_, 1)
    }
  }
};
goog.net.xpc.FrameElementMethodTransport.prototype.deliverQueued_ = function() {
  while(this.queue_.length) {
    var msg = this.queue_.shift();
    this.channel_.deliver_(msg.serviceName, msg.payload)
  }
};
goog.net.xpc.FrameElementMethodTransport.prototype.send = function(service, payload) {
  this.recursive_ = true;
  this.outgoing_(service, payload);
  this.recursive_ = false
};
goog.net.xpc.FrameElementMethodTransport.prototype.disposeInternal = function() {
  goog.net.xpc.FrameElementMethodTransport.superClass_.disposeInternal.call(this);
  this.outgoing_ = null;
  this.iframeElm_ = null
};
goog.provide("goog.net.xpc.IframeRelayTransport");
goog.require("goog.dom");
goog.require("goog.events");
goog.require("goog.net.xpc");
goog.require("goog.net.xpc.Transport");
goog.require("goog.userAgent");
goog.net.xpc.IframeRelayTransport = function(channel, opt_domHelper) {
  goog.base(this, opt_domHelper);
  this.channel_ = channel;
  this.peerRelayUri_ = this.channel_.cfg_[goog.net.xpc.CfgFields.PEER_RELAY_URI];
  this.peerIframeId_ = this.channel_.cfg_[goog.net.xpc.CfgFields.IFRAME_ID];
  if(goog.userAgent.WEBKIT) {
    goog.net.xpc.IframeRelayTransport.startCleanupTimer_()
  }
};
goog.inherits(goog.net.xpc.IframeRelayTransport, goog.net.xpc.Transport);
if(goog.userAgent.WEBKIT) {
  goog.net.xpc.IframeRelayTransport.iframeRefs_ = [];
  goog.net.xpc.IframeRelayTransport.CLEANUP_INTERVAL_ = 1E3;
  goog.net.xpc.IframeRelayTransport.IFRAME_MAX_AGE_ = 3E3;
  goog.net.xpc.IframeRelayTransport.cleanupTimer_ = 0;
  goog.net.xpc.IframeRelayTransport.startCleanupTimer_ = function() {
    if(!goog.net.xpc.IframeRelayTransport.cleanupTimer_) {
      goog.net.xpc.IframeRelayTransport.cleanupTimer_ = window.setTimeout(function() {
        goog.net.xpc.IframeRelayTransport.cleanup_()
      }, goog.net.xpc.IframeRelayTransport.CLEANUP_INTERVAL_)
    }
  };
  goog.net.xpc.IframeRelayTransport.cleanup_ = function(opt_maxAge) {
    var now = goog.now();
    var maxAge = opt_maxAge || goog.net.xpc.IframeRelayTransport.IFRAME_MAX_AGE_;
    while(goog.net.xpc.IframeRelayTransport.iframeRefs_.length && now - goog.net.xpc.IframeRelayTransport.iframeRefs_[0].timestamp >= maxAge) {
      var ifr = goog.net.xpc.IframeRelayTransport.iframeRefs_.shift().iframeElement;
      goog.dom.removeNode(ifr);
      goog.net.xpc.logger.finest("iframe removed")
    }
    goog.net.xpc.IframeRelayTransport.cleanupTimer_ = window.setTimeout(goog.net.xpc.IframeRelayTransport.cleanupCb_, goog.net.xpc.IframeRelayTransport.CLEANUP_INTERVAL_)
  };
  goog.net.xpc.IframeRelayTransport.cleanupCb_ = function() {
    goog.net.xpc.IframeRelayTransport.cleanup_()
  }
}
goog.net.xpc.IframeRelayTransport.IE_PAYLOAD_MAX_SIZE_ = 1800;
goog.net.xpc.IframeRelayTransport.FragmentInfo;
goog.net.xpc.IframeRelayTransport.fragmentMap_ = {};
goog.net.xpc.IframeRelayTransport.prototype.transportType = goog.net.xpc.TransportTypes.IFRAME_RELAY;
goog.net.xpc.IframeRelayTransport.prototype.connect = function() {
  if(!this.getWindow()["xpcRelay"]) {
    this.getWindow()["xpcRelay"] = goog.net.xpc.IframeRelayTransport.receiveMessage_
  }
  this.send(goog.net.xpc.TRANSPORT_SERVICE_, goog.net.xpc.SETUP)
};
goog.net.xpc.IframeRelayTransport.receiveMessage_ = function(channelName, frame) {
  var pos = frame.indexOf(":");
  var header = frame.substr(0, pos);
  var payload = frame.substr(pos + 1);
  if(!goog.userAgent.IE || (pos = header.indexOf("|")) == -1) {
    var service = header
  }else {
    var service = header.substr(0, pos);
    var fragmentIdStr = header.substr(pos + 1);
    pos = fragmentIdStr.indexOf("+");
    var messageIdStr = fragmentIdStr.substr(0, pos);
    var fragmentNum = parseInt(fragmentIdStr.substr(pos + 1), 10);
    var fragmentInfo = goog.net.xpc.IframeRelayTransport.fragmentMap_[messageIdStr];
    if(!fragmentInfo) {
      fragmentInfo = goog.net.xpc.IframeRelayTransport.fragmentMap_[messageIdStr] = {fragments:[], received:0, expected:0}
    }
    if(goog.string.contains(fragmentIdStr, "++")) {
      fragmentInfo.expected = fragmentNum + 1
    }
    fragmentInfo.fragments[fragmentNum] = payload;
    fragmentInfo.received++;
    if(fragmentInfo.received != fragmentInfo.expected) {
      return
    }
    payload = fragmentInfo.fragments.join("");
    delete goog.net.xpc.IframeRelayTransport.fragmentMap_[messageIdStr]
  }
  goog.net.xpc.channels_[channelName].deliver_(service, decodeURIComponent(payload))
};
goog.net.xpc.IframeRelayTransport.prototype.transportServiceHandler = function(payload) {
  if(payload == goog.net.xpc.SETUP) {
    this.send(goog.net.xpc.TRANSPORT_SERVICE_, goog.net.xpc.SETUP_ACK_);
    this.channel_.notifyConnected_()
  }else {
    if(payload == goog.net.xpc.SETUP_ACK_) {
      this.channel_.notifyConnected_()
    }
  }
};
goog.net.xpc.IframeRelayTransport.prototype.send = function(service, payload) {
  var encodedPayload = encodeURIComponent(payload);
  var encodedLen = encodedPayload.length;
  var maxSize = goog.net.xpc.IframeRelayTransport.IE_PAYLOAD_MAX_SIZE_;
  if(goog.userAgent.IE && encodedLen > maxSize) {
    var messageIdStr = goog.string.getRandomString();
    for(var startIndex = 0, fragmentNum = 0;startIndex < encodedLen;fragmentNum++) {
      var payloadFragment = encodedPayload.substr(startIndex, maxSize);
      startIndex += maxSize;
      var fragmentIdStr = messageIdStr + (startIndex >= encodedLen ? "++" : "+") + fragmentNum;
      this.send_(service, payloadFragment, fragmentIdStr)
    }
  }else {
    this.send_(service, encodedPayload)
  }
};
goog.net.xpc.IframeRelayTransport.prototype.send_ = function(service, encodedPayload, opt_fragmentIdStr) {
  if(goog.userAgent.IE) {
    var div = this.getWindow().document.createElement("div");
    div.innerHTML = '<iframe onload="this.xpcOnload()"></iframe>';
    var ifr = div.childNodes[0];
    div = null;
    ifr["xpcOnload"] = goog.net.xpc.IframeRelayTransport.iframeLoadHandler_
  }else {
    var ifr = this.getWindow().document.createElement("iframe");
    if(goog.userAgent.WEBKIT) {
      goog.net.xpc.IframeRelayTransport.iframeRefs_.push({timestamp:goog.now(), iframeElement:ifr})
    }else {
      goog.events.listen(ifr, "load", goog.net.xpc.IframeRelayTransport.iframeLoadHandler_)
    }
  }
  var style = ifr.style;
  style.visibility = "hidden";
  style.width = ifr.style.height = "0px";
  style.position = "absolute";
  var url = this.peerRelayUri_;
  url += "#" + this.channel_.name;
  if(this.peerIframeId_) {
    url += "," + this.peerIframeId_
  }
  url += "|" + service;
  if(opt_fragmentIdStr) {
    url += "|" + opt_fragmentIdStr
  }
  url += ":" + encodedPayload;
  ifr.src = url;
  this.getWindow().document.body.appendChild(ifr);
  goog.net.xpc.logger.finest("msg sent: " + url)
};
goog.net.xpc.IframeRelayTransport.iframeLoadHandler_ = function() {
  goog.net.xpc.logger.finest("iframe-load");
  goog.dom.removeNode(this);
  this.xpcOnload = null
};
goog.net.xpc.IframeRelayTransport.prototype.disposeInternal = function() {
  goog.base(this, "disposeInternal");
  if(goog.userAgent.WEBKIT) {
    goog.net.xpc.IframeRelayTransport.cleanup_(0)
  }
};
goog.provide("goog.net.xpc.NativeMessagingTransport");
goog.require("goog.events");
goog.require("goog.net.xpc");
goog.require("goog.net.xpc.Transport");
goog.net.xpc.NativeMessagingTransport = function(channel, peerHostname, opt_domHelper) {
  goog.base(this, opt_domHelper);
  this.channel_ = channel;
  this.peerHostname_ = peerHostname || "*"
};
goog.inherits(goog.net.xpc.NativeMessagingTransport, goog.net.xpc.Transport);
goog.net.xpc.NativeMessagingTransport.prototype.initialized_ = false;
goog.net.xpc.NativeMessagingTransport.prototype.transportType = goog.net.xpc.TransportTypes.NATIVE_MESSAGING;
goog.net.xpc.NativeMessagingTransport.activeCount_ = {};
goog.net.xpc.NativeMessagingTransport.initialize_ = function(listenWindow) {
  var uid = goog.getUid(listenWindow);
  var value = goog.net.xpc.NativeMessagingTransport.activeCount_[uid];
  if(!goog.isNumber(value)) {
    value = 0
  }
  if(value == 0) {
    goog.events.listen(listenWindow.postMessage ? listenWindow : listenWindow.document, "message", goog.net.xpc.NativeMessagingTransport.messageReceived_, false, goog.net.xpc.NativeMessagingTransport)
  }
  goog.net.xpc.NativeMessagingTransport.activeCount_[uid] = value + 1
};
goog.net.xpc.NativeMessagingTransport.messageReceived_ = function(msgEvt) {
  var data = msgEvt.getBrowserEvent().data;
  var headDelim = data.indexOf("|");
  var serviceDelim = data.indexOf(":");
  if(headDelim == -1 || serviceDelim == -1) {
    return false
  }
  var channelName = data.substring(0, headDelim);
  var service = data.substring(headDelim + 1, serviceDelim);
  var payload = data.substring(serviceDelim + 1);
  goog.net.xpc.logger.fine("messageReceived: channel=" + channelName + ", service=" + service + ", payload=" + payload);
  var channel = goog.net.xpc.channels_[channelName];
  if(channel) {
    channel.deliver_(service, payload, msgEvt.getBrowserEvent().origin);
    return true
  }
  for(var staleChannelName in goog.net.xpc.channels_) {
    var staleChannel = goog.net.xpc.channels_[staleChannelName];
    if(staleChannel.getRole() == goog.net.xpc.CrossPageChannel.Role.INNER && !staleChannel.isConnected() && service == goog.net.xpc.TRANSPORT_SERVICE_ && payload == goog.net.xpc.SETUP) {
      goog.net.xpc.logger.fine("changing channel name to " + channelName);
      staleChannel.name = channelName;
      delete goog.net.xpc.channels_[staleChannelName];
      goog.net.xpc.channels_[channelName] = staleChannel;
      staleChannel.deliver_(service, payload);
      return true
    }
  }
  goog.net.xpc.logger.info('channel name mismatch; message ignored"');
  return false
};
goog.net.xpc.NativeMessagingTransport.prototype.transportServiceHandler = function(payload) {
  switch(payload) {
    case goog.net.xpc.SETUP:
      this.send(goog.net.xpc.TRANSPORT_SERVICE_, goog.net.xpc.SETUP_ACK_);
      break;
    case goog.net.xpc.SETUP_ACK_:
      this.channel_.notifyConnected_();
      break
  }
};
goog.net.xpc.NativeMessagingTransport.prototype.connect = function() {
  goog.net.xpc.NativeMessagingTransport.initialize_(this.getWindow());
  this.initialized_ = true;
  this.connectWithRetries_()
};
goog.net.xpc.NativeMessagingTransport.prototype.connectWithRetries_ = function() {
  if(this.channel_.isConnected() || this.isDisposed()) {
    return
  }
  this.send(goog.net.xpc.TRANSPORT_SERVICE_, goog.net.xpc.SETUP);
  this.getWindow().setTimeout(goog.bind(this.connectWithRetries_, this), 100)
};
goog.net.xpc.NativeMessagingTransport.prototype.send = function(service, payload) {
  var win = this.channel_.peerWindowObject_;
  if(!win) {
    goog.net.xpc.logger.fine("send(): window not ready");
    return
  }
  var obj = win.postMessage ? win : win.document;
  this.send = function(service, payload) {
    goog.net.xpc.logger.fine("send(): payload=" + payload + " to hostname=" + this.peerHostname_);
    obj.postMessage(this.channel_.name + "|" + service + ":" + payload, this.peerHostname_)
  };
  this.send(service, payload)
};
goog.net.xpc.NativeMessagingTransport.prototype.disposeInternal = function() {
  goog.base(this, "disposeInternal");
  if(this.initialized_) {
    var listenWindow = this.getWindow();
    var uid = goog.getUid(listenWindow);
    var value = goog.net.xpc.NativeMessagingTransport.activeCount_[uid];
    goog.net.xpc.NativeMessagingTransport.activeCount_[uid] = value - 1;
    if(value == 1) {
      goog.events.unlisten(listenWindow.postMessage ? listenWindow : listenWindow.document, "message", goog.net.xpc.NativeMessagingTransport.messageReceived_, false, goog.net.xpc.NativeMessagingTransport)
    }
  }
};
goog.provide("goog.net.xpc.NixTransport");
goog.require("goog.net.xpc");
goog.require("goog.net.xpc.Transport");
goog.net.xpc.NixTransport = function(channel, opt_domHelper) {
  goog.base(this, opt_domHelper);
  this.channel_ = channel;
  this.authToken_ = channel[goog.net.xpc.CfgFields.AUTH_TOKEN] || "";
  this.remoteAuthToken_ = channel[goog.net.xpc.CfgFields.REMOTE_AUTH_TOKEN] || "";
  goog.net.xpc.NixTransport.conductGlobalSetup_(this.getWindow());
  this[goog.net.xpc.NixTransport.NIX_HANDLE_MESSAGE] = this.handleMessage_;
  this[goog.net.xpc.NixTransport.NIX_CREATE_CHANNEL] = this.createChannel_
};
goog.inherits(goog.net.xpc.NixTransport, goog.net.xpc.Transport);
goog.net.xpc.NixTransport.NIX_WRAPPER = "GCXPC____NIXVBS_wrapper";
goog.net.xpc.NixTransport.NIX_GET_WRAPPER = "GCXPC____NIXVBS_get_wrapper";
goog.net.xpc.NixTransport.NIX_HANDLE_MESSAGE = "GCXPC____NIXJS_handle_message";
goog.net.xpc.NixTransport.NIX_CREATE_CHANNEL = "GCXPC____NIXJS_create_channel";
goog.net.xpc.NixTransport.NIX_ID_FIELD = "GCXPC____NIXVBS_container";
goog.net.xpc.NixTransport.conductGlobalSetup_ = function(listenWindow) {
  if(listenWindow["nix_setup_complete"]) {
    return
  }
  var vbscript = "Class " + goog.net.xpc.NixTransport.NIX_WRAPPER + "\n " + "Private m_Transport\n" + "Private m_Auth\n" + "Public Sub SetTransport(transport)\n" + "If isEmpty(m_Transport) Then\n" + "Set m_Transport = transport\n" + "End If\n" + "End Sub\n" + "Public Sub SetAuth(auth)\n" + "If isEmpty(m_Auth) Then\n" + "m_Auth = auth\n" + "End If\n" + "End Sub\n" + "Public Function GetAuthToken()\n " + "GetAuthToken = m_Auth\n" + "End Function\n" + "Public Sub SendMessage(service, payload)\n " + 
  "Call m_Transport." + goog.net.xpc.NixTransport.NIX_HANDLE_MESSAGE + "(service, payload)\n" + "End Sub\n" + "Public Sub CreateChannel(channel)\n " + "Call m_Transport." + goog.net.xpc.NixTransport.NIX_CREATE_CHANNEL + "(channel)\n" + "End Sub\n" + "Public Sub " + goog.net.xpc.NixTransport.NIX_ID_FIELD + "()\n " + "End Sub\n" + "End Class\n " + "Function " + goog.net.xpc.NixTransport.NIX_GET_WRAPPER + "(transport, auth)\n" + "Dim wrap\n" + "Set wrap = New " + goog.net.xpc.NixTransport.NIX_WRAPPER + 
  "\n" + "wrap.SetTransport transport\n" + "wrap.SetAuth auth\n" + "Set " + goog.net.xpc.NixTransport.NIX_GET_WRAPPER + " = wrap\n" + "End Function";
  try {
    listenWindow.execScript(vbscript, "vbscript");
    listenWindow["nix_setup_complete"] = true
  }catch(e) {
    goog.net.xpc.logger.severe("exception caught while attempting global setup: " + e)
  }
};
goog.net.xpc.NixTransport.prototype.transportType = goog.net.xpc.TransportTypes.NIX;
goog.net.xpc.NixTransport.prototype.localSetupCompleted_ = false;
goog.net.xpc.NixTransport.prototype.nixChannel_ = null;
goog.net.xpc.NixTransport.prototype.connect = function() {
  if(this.channel_.getRole() == goog.net.xpc.CrossPageChannel.Role.OUTER) {
    this.attemptOuterSetup_()
  }else {
    this.attemptInnerSetup_()
  }
};
goog.net.xpc.NixTransport.prototype.attemptOuterSetup_ = function() {
  if(this.localSetupCompleted_) {
    return
  }
  var innerFrame = this.channel_.iframeElement_;
  try {
    innerFrame.contentWindow.opener = this.getWindow()[goog.net.xpc.NixTransport.NIX_GET_WRAPPER](this, this.authToken_);
    this.localSetupCompleted_ = true
  }catch(e) {
    goog.net.xpc.logger.severe("exception caught while attempting setup: " + e)
  }
  if(!this.localSetupCompleted_) {
    this.getWindow().setTimeout(goog.bind(this.attemptOuterSetup_, this), 100)
  }
};
goog.net.xpc.NixTransport.prototype.attemptInnerSetup_ = function() {
  if(this.localSetupCompleted_) {
    return
  }
  try {
    var opener = this.getWindow().opener;
    if(opener && goog.net.xpc.NixTransport.NIX_ID_FIELD in opener) {
      this.nixChannel_ = opener;
      var remoteAuthToken = this.nixChannel_["GetAuthToken"]();
      if(remoteAuthToken != this.remoteAuthToken_) {
        goog.net.xpc.logger.severe("Invalid auth token from other party");
        return
      }
      this.nixChannel_["CreateChannel"](this.getWindow()[goog.net.xpc.NixTransport.NIX_GET_WRAPPER](this, this.authToken_));
      this.localSetupCompleted_ = true;
      this.channel_.notifyConnected_()
    }
  }catch(e) {
    goog.net.xpc.logger.severe("exception caught while attempting setup: " + e);
    return
  }
  if(!this.localSetupCompleted_) {
    this.getWindow().setTimeout(goog.bind(this.attemptInnerSetup_, this), 100)
  }
};
goog.net.xpc.NixTransport.prototype.createChannel_ = function(channel) {
  if(typeof channel != "unknown" || !(goog.net.xpc.NixTransport.NIX_ID_FIELD in channel)) {
    goog.net.xpc.logger.severe("Invalid NIX channel given to createChannel_")
  }
  this.nixChannel_ = channel;
  var remoteAuthToken = this.nixChannel_["GetAuthToken"]();
  if(remoteAuthToken != this.remoteAuthToken_) {
    goog.net.xpc.logger.severe("Invalid auth token from other party");
    return
  }
  this.channel_.notifyConnected_()
};
goog.net.xpc.NixTransport.prototype.handleMessage_ = function(serviceName, payload) {
  function deliveryHandler() {
    this.channel_.deliver_(serviceName, payload)
  }
  this.getWindow().setTimeout(goog.bind(deliveryHandler, this), 1)
};
goog.net.xpc.NixTransport.prototype.send = function(service, payload) {
  if(typeof this.nixChannel_ !== "unknown") {
    goog.net.xpc.logger.severe("NIX channel not connected")
  }
  this.nixChannel_["SendMessage"](service, payload)
};
goog.net.xpc.NixTransport.prototype.disposeInternal = function() {
  goog.base(this, "disposeInternal");
  this.nixChannel_ = null
};
goog.provide("goog.net.xpc.CrossPageChannel");
goog.provide("goog.net.xpc.CrossPageChannel.Role");
goog.require("goog.Disposable");
goog.require("goog.Uri");
goog.require("goog.dom");
goog.require("goog.events");
goog.require("goog.json");
goog.require("goog.messaging.AbstractChannel");
goog.require("goog.net.xpc");
goog.require("goog.net.xpc.FrameElementMethodTransport");
goog.require("goog.net.xpc.IframePollingTransport");
goog.require("goog.net.xpc.IframeRelayTransport");
goog.require("goog.net.xpc.NativeMessagingTransport");
goog.require("goog.net.xpc.NixTransport");
goog.require("goog.net.xpc.Transport");
goog.require("goog.userAgent");
goog.net.xpc.CrossPageChannel = function(cfg, opt_domHelper) {
  goog.base(this);
  for(var i = 0, uriField;uriField = goog.net.xpc.UriCfgFields[i];i++) {
    if(uriField in cfg && !/^https?:\/\//.test(cfg[uriField])) {
      throw Error("URI " + cfg[uriField] + " is invalid for field " + uriField);
    }
  }
  this.cfg_ = cfg;
  this.name = this.cfg_[goog.net.xpc.CfgFields.CHANNEL_NAME] || goog.net.xpc.getRandomString(10);
  this.domHelper_ = opt_domHelper || goog.dom.getDomHelper();
  goog.net.xpc.channels_[this.name] = this;
  goog.events.listen(window, "unload", goog.net.xpc.CrossPageChannel.disposeAll_);
  goog.net.xpc.logger.info("CrossPageChannel created: " + this.name)
};
goog.inherits(goog.net.xpc.CrossPageChannel, goog.messaging.AbstractChannel);
goog.net.xpc.CrossPageChannel.TRANSPORT_SERVICE_ESCAPE_RE_ = new RegExp("^%*" + goog.net.xpc.TRANSPORT_SERVICE_ + "$");
goog.net.xpc.CrossPageChannel.TRANSPORT_SERVICE_UNESCAPE_RE_ = new RegExp("^%+" + goog.net.xpc.TRANSPORT_SERVICE_ + "$");
goog.net.xpc.CrossPageChannel.prototype.transport_ = null;
goog.net.xpc.CrossPageChannel.prototype.state_ = goog.net.xpc.ChannelStates.NOT_CONNECTED;
goog.net.xpc.CrossPageChannel.prototype.isConnected = function() {
  return this.state_ == goog.net.xpc.ChannelStates.CONNECTED
};
goog.net.xpc.CrossPageChannel.prototype.peerWindowObject_ = null;
goog.net.xpc.CrossPageChannel.prototype.iframeElement_ = null;
goog.net.xpc.CrossPageChannel.prototype.setPeerWindowObject = function(peerWindowObject) {
  this.peerWindowObject_ = peerWindowObject
};
goog.net.xpc.CrossPageChannel.prototype.determineTransportType_ = function() {
  var transportType;
  if(goog.isFunction(document.postMessage) || goog.isFunction(window.postMessage) || goog.userAgent.IE && window.postMessage) {
    transportType = goog.net.xpc.TransportTypes.NATIVE_MESSAGING
  }else {
    if(goog.userAgent.GECKO) {
      transportType = goog.net.xpc.TransportTypes.FRAME_ELEMENT_METHOD
    }else {
      if(goog.userAgent.IE && this.cfg_[goog.net.xpc.CfgFields.PEER_RELAY_URI]) {
        transportType = goog.net.xpc.TransportTypes.IFRAME_RELAY
      }else {
        if(goog.userAgent.IE) {
          transportType = goog.net.xpc.TransportTypes.NIX
        }else {
          if(this.cfg_[goog.net.xpc.CfgFields.LOCAL_POLL_URI] && this.cfg_[goog.net.xpc.CfgFields.PEER_POLL_URI]) {
            transportType = goog.net.xpc.TransportTypes.IFRAME_POLLING
          }
        }
      }
    }
  }
  return transportType
};
goog.net.xpc.CrossPageChannel.prototype.createTransport_ = function() {
  if(this.transport_) {
    return
  }
  if(!this.cfg_[goog.net.xpc.CfgFields.TRANSPORT]) {
    this.cfg_[goog.net.xpc.CfgFields.TRANSPORT] = this.determineTransportType_()
  }
  switch(this.cfg_[goog.net.xpc.CfgFields.TRANSPORT]) {
    case goog.net.xpc.TransportTypes.NATIVE_MESSAGING:
      this.transport_ = new goog.net.xpc.NativeMessagingTransport(this, this.cfg_[goog.net.xpc.CfgFields.PEER_HOSTNAME], this.domHelper_);
      break;
    case goog.net.xpc.TransportTypes.NIX:
      this.transport_ = new goog.net.xpc.NixTransport(this, this.domHelper_);
      break;
    case goog.net.xpc.TransportTypes.FRAME_ELEMENT_METHOD:
      this.transport_ = new goog.net.xpc.FrameElementMethodTransport(this, this.domHelper_);
      break;
    case goog.net.xpc.TransportTypes.IFRAME_RELAY:
      this.transport_ = new goog.net.xpc.IframeRelayTransport(this, this.domHelper_);
      break;
    case goog.net.xpc.TransportTypes.IFRAME_POLLING:
      this.transport_ = new goog.net.xpc.IframePollingTransport(this, this.domHelper_);
      break
  }
  if(this.transport_) {
    goog.net.xpc.logger.info("Transport created: " + this.transport_.getName())
  }else {
    throw Error("CrossPageChannel: No suitable transport found!");
  }
};
goog.net.xpc.CrossPageChannel.prototype.getTransportType = function() {
  return this.transport_.getType()
};
goog.net.xpc.CrossPageChannel.prototype.getTransportName = function() {
  return this.transport_.getName()
};
goog.net.xpc.CrossPageChannel.prototype.getPeerConfiguration = function() {
  var peerCfg = {};
  peerCfg[goog.net.xpc.CfgFields.CHANNEL_NAME] = this.name;
  peerCfg[goog.net.xpc.CfgFields.TRANSPORT] = this.cfg_[goog.net.xpc.CfgFields.TRANSPORT];
  if(this.cfg_[goog.net.xpc.CfgFields.LOCAL_RELAY_URI]) {
    peerCfg[goog.net.xpc.CfgFields.PEER_RELAY_URI] = this.cfg_[goog.net.xpc.CfgFields.LOCAL_RELAY_URI]
  }
  if(this.cfg_[goog.net.xpc.CfgFields.LOCAL_POLL_URI]) {
    peerCfg[goog.net.xpc.CfgFields.PEER_POLL_URI] = this.cfg_[goog.net.xpc.CfgFields.LOCAL_POLL_URI]
  }
  if(this.cfg_[goog.net.xpc.CfgFields.PEER_POLL_URI]) {
    peerCfg[goog.net.xpc.CfgFields.LOCAL_POLL_URI] = this.cfg_[goog.net.xpc.CfgFields.PEER_POLL_URI]
  }
  return peerCfg
};
goog.net.xpc.CrossPageChannel.prototype.createPeerIframe = function(parentElm, opt_configureIframeCb, opt_addCfgParam) {
  var iframeId = this.cfg_[goog.net.xpc.CfgFields.IFRAME_ID];
  if(!iframeId) {
    iframeId = this.cfg_[goog.net.xpc.CfgFields.IFRAME_ID] = "xpcpeer" + goog.net.xpc.getRandomString(4)
  }
  var iframeElm = goog.dom.createElement("IFRAME");
  iframeElm.id = iframeElm.name = iframeId;
  if(opt_configureIframeCb) {
    opt_configureIframeCb(iframeElm)
  }else {
    iframeElm.style.width = iframeElm.style.height = "100%"
  }
  var peerUri = this.cfg_[goog.net.xpc.CfgFields.PEER_URI];
  if(goog.isString(peerUri)) {
    peerUri = this.cfg_[goog.net.xpc.CfgFields.PEER_URI] = new goog.Uri(peerUri)
  }
  if(opt_addCfgParam !== false) {
    peerUri.setParameterValue("xpc", goog.json.serialize(this.getPeerConfiguration()))
  }
  if(goog.userAgent.GECKO || goog.userAgent.WEBKIT) {
    this.deferConnect_ = true;
    window.setTimeout(goog.bind(function() {
      this.deferConnect_ = false;
      parentElm.appendChild(iframeElm);
      iframeElm.src = peerUri.toString();
      goog.net.xpc.logger.info("peer iframe created (" + iframeId + ")");
      if(this.connectDeferred_) {
        this.connect(this.connectCb_)
      }
    }, this), 1)
  }else {
    iframeElm.src = peerUri.toString();
    parentElm.appendChild(iframeElm);
    goog.net.xpc.logger.info("peer iframe created (" + iframeId + ")")
  }
  return iframeElm
};
goog.net.xpc.CrossPageChannel.prototype.deferConnect_ = false;
goog.net.xpc.CrossPageChannel.prototype.connectDeferred_ = false;
goog.net.xpc.CrossPageChannel.prototype.connect = function(opt_connectCb) {
  this.connectCb_ = opt_connectCb || goog.nullFunction;
  if(this.deferConnect_) {
    goog.net.xpc.logger.info("connect() deferred");
    this.connectDeferred_ = true;
    return
  }
  goog.net.xpc.logger.info("connect()");
  if(this.cfg_[goog.net.xpc.CfgFields.IFRAME_ID]) {
    this.iframeElement_ = this.domHelper_.getElement(this.cfg_[goog.net.xpc.CfgFields.IFRAME_ID])
  }
  if(this.iframeElement_) {
    var winObj = this.iframeElement_.contentWindow;
    if(!winObj) {
      winObj = window.frames[this.cfg_[goog.net.xpc.CfgFields.IFRAME_ID]]
    }
    this.setPeerWindowObject(winObj)
  }
  if(!this.peerWindowObject_) {
    if(window == top) {
      throw Error("CrossPageChannel: Can't connect, peer window-object not set.");
    }else {
      this.setPeerWindowObject(window.parent)
    }
  }
  this.createTransport_();
  this.transport_.connect()
};
goog.net.xpc.CrossPageChannel.prototype.close = function() {
  if(!this.isConnected()) {
    return
  }
  this.state_ = goog.net.xpc.ChannelStates.CLOSED;
  this.transport_.dispose();
  this.transport_ = null;
  goog.net.xpc.logger.info('Channel "' + this.name + '" closed')
};
goog.net.xpc.CrossPageChannel.prototype.notifyConnected_ = function() {
  if(this.isConnected()) {
    return
  }
  this.state_ = goog.net.xpc.ChannelStates.CONNECTED;
  goog.net.xpc.logger.info('Channel "' + this.name + '" connected');
  this.connectCb_()
};
goog.net.xpc.CrossPageChannel.prototype.notifyTransportError_ = function() {
  goog.net.xpc.logger.info("Transport Error");
  this.close()
};
goog.net.xpc.CrossPageChannel.prototype.send = function(serviceName, payload) {
  if(!this.isConnected()) {
    goog.net.xpc.logger.severe("Can't send. Channel not connected.");
    return
  }
  if(this.peerWindowObject_.closed) {
    goog.net.xpc.logger.severe("Peer has disappeared.");
    this.close();
    return
  }
  if(goog.isObject(payload)) {
    payload = goog.json.serialize(payload)
  }
  this.transport_.send(this.escapeServiceName_(serviceName), payload)
};
goog.net.xpc.CrossPageChannel.prototype.deliver_ = function(serviceName, payload, opt_origin) {
  if(!this.isMessageOriginAcceptable_(opt_origin)) {
    goog.net.xpc.logger.warning('Message received from unapproved origin "' + opt_origin + '" - rejected.');
    return
  }
  if(this.isDisposed()) {
    goog.net.xpc.logger.warning("CrossPageChannel::deliver_(): Disposed.")
  }else {
    if(!serviceName || serviceName == goog.net.xpc.TRANSPORT_SERVICE_) {
      this.transport_.transportServiceHandler(payload)
    }else {
      if(this.isConnected()) {
        this.deliver(this.unescapeServiceName_(serviceName), payload)
      }else {
        goog.net.xpc.logger.info("CrossPageChannel::deliver_(): Not connected.")
      }
    }
  }
};
goog.net.xpc.CrossPageChannel.prototype.escapeServiceName_ = function(name) {
  if(goog.net.xpc.CrossPageChannel.TRANSPORT_SERVICE_ESCAPE_RE_.test(name)) {
    name = "%" + name
  }
  return name.replace(/[%:|]/g, encodeURIComponent)
};
goog.net.xpc.CrossPageChannel.prototype.unescapeServiceName_ = function(name) {
  name = name.replace(/%[0-9a-f]{2}/gi, decodeURIComponent);
  if(goog.net.xpc.CrossPageChannel.TRANSPORT_SERVICE_UNESCAPE_RE_.test(name)) {
    return name.substring(1)
  }else {
    return name
  }
};
goog.net.xpc.CrossPageChannel.Role = {OUTER:0, INNER:1};
goog.net.xpc.CrossPageChannel.prototype.getRole = function() {
  return window.parent == this.peerWindowObject_ ? goog.net.xpc.CrossPageChannel.Role.INNER : goog.net.xpc.CrossPageChannel.Role.OUTER
};
goog.net.xpc.CrossPageChannel.prototype.isMessageOriginAcceptable_ = function(opt_origin) {
  var peerHostname = this.cfg_[goog.net.xpc.CfgFields.PEER_HOSTNAME];
  return goog.string.isEmptySafe(opt_origin) || goog.string.isEmptySafe(peerHostname) || opt_origin == this.cfg_[goog.net.xpc.CfgFields.PEER_HOSTNAME]
};
goog.net.xpc.CrossPageChannel.prototype.disposeInternal = function() {
  goog.base(this, "disposeInternal");
  this.close();
  this.peerWindowObject_ = null;
  this.iframeElement_ = null;
  delete goog.net.xpc.channels_[this.name]
};
goog.net.xpc.CrossPageChannel.disposeAll_ = function() {
  for(var name in goog.net.xpc.channels_) {
    var ch = goog.net.xpc.channels_[name];
    if(ch) {
      ch.dispose()
    }
  }
};
goog.provide("clojure.browser.net");
goog.require("cljs.core");
goog.require("clojure.browser.event");
goog.require("goog.net.XhrIo");
goog.require("goog.net.EventType");
goog.require("goog.net.xpc.CfgFields");
goog.require("goog.net.xpc.CrossPageChannel");
goog.require("goog.json");
clojure.browser.net._STAR_timeout_STAR_ = 1E4;
clojure.browser.net.event_types = cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), cljs.core.map.call(null, function(p__1608080) {
  var vec__1608081__1608082 = p__1608080;
  var k__1608083 = cljs.core.nth.call(null, vec__1608081__1608082, 0, null);
  var v__1608084 = cljs.core.nth.call(null, vec__1608081__1608082, 1, null);
  return cljs.core.PersistentVector.fromArray([cljs.core.keyword.call(null, k__1608083.toLowerCase()), v__1608084])
}, cljs.core.merge.call(null, cljs.core.js__GT_clj.call(null, goog.net.EventType))));
clojure.browser.net.IConnection = {};
clojure.browser.net.connect = function() {
  var connect = null;
  var connect__1608115 = function(this$) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608085 = this$;
      if(cljs.core.truth_(and__3546__auto____1608085)) {
        return this$.clojure$browser$net$IConnection$connect
      }else {
        return and__3546__auto____1608085
      }
    }())) {
      return this$.clojure$browser$net$IConnection$connect(this$)
    }else {
      return function() {
        var or__3548__auto____1608086 = clojure.browser.net.connect[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608086)) {
          return or__3548__auto____1608086
        }else {
          var or__3548__auto____1608087 = clojure.browser.net.connect["_"];
          if(cljs.core.truth_(or__3548__auto____1608087)) {
            return or__3548__auto____1608087
          }else {
            throw cljs.core.missing_protocol.call(null, "IConnection.connect", this$);
          }
        }
      }().call(null, this$)
    }
  };
  var connect__1608116 = function(this$, opt1) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608088 = this$;
      if(cljs.core.truth_(and__3546__auto____1608088)) {
        return this$.clojure$browser$net$IConnection$connect
      }else {
        return and__3546__auto____1608088
      }
    }())) {
      return this$.clojure$browser$net$IConnection$connect(this$, opt1)
    }else {
      return function() {
        var or__3548__auto____1608089 = clojure.browser.net.connect[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608089)) {
          return or__3548__auto____1608089
        }else {
          var or__3548__auto____1608090 = clojure.browser.net.connect["_"];
          if(cljs.core.truth_(or__3548__auto____1608090)) {
            return or__3548__auto____1608090
          }else {
            throw cljs.core.missing_protocol.call(null, "IConnection.connect", this$);
          }
        }
      }().call(null, this$, opt1)
    }
  };
  var connect__1608117 = function(this$, opt1, opt2) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608091 = this$;
      if(cljs.core.truth_(and__3546__auto____1608091)) {
        return this$.clojure$browser$net$IConnection$connect
      }else {
        return and__3546__auto____1608091
      }
    }())) {
      return this$.clojure$browser$net$IConnection$connect(this$, opt1, opt2)
    }else {
      return function() {
        var or__3548__auto____1608092 = clojure.browser.net.connect[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608092)) {
          return or__3548__auto____1608092
        }else {
          var or__3548__auto____1608093 = clojure.browser.net.connect["_"];
          if(cljs.core.truth_(or__3548__auto____1608093)) {
            return or__3548__auto____1608093
          }else {
            throw cljs.core.missing_protocol.call(null, "IConnection.connect", this$);
          }
        }
      }().call(null, this$, opt1, opt2)
    }
  };
  var connect__1608118 = function(this$, opt1, opt2, opt3) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608094 = this$;
      if(cljs.core.truth_(and__3546__auto____1608094)) {
        return this$.clojure$browser$net$IConnection$connect
      }else {
        return and__3546__auto____1608094
      }
    }())) {
      return this$.clojure$browser$net$IConnection$connect(this$, opt1, opt2, opt3)
    }else {
      return function() {
        var or__3548__auto____1608095 = clojure.browser.net.connect[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608095)) {
          return or__3548__auto____1608095
        }else {
          var or__3548__auto____1608096 = clojure.browser.net.connect["_"];
          if(cljs.core.truth_(or__3548__auto____1608096)) {
            return or__3548__auto____1608096
          }else {
            throw cljs.core.missing_protocol.call(null, "IConnection.connect", this$);
          }
        }
      }().call(null, this$, opt1, opt2, opt3)
    }
  };
  connect = function(this$, opt1, opt2, opt3) {
    switch(arguments.length) {
      case 1:
        return connect__1608115.call(this, this$);
      case 2:
        return connect__1608116.call(this, this$, opt1);
      case 3:
        return connect__1608117.call(this, this$, opt1, opt2);
      case 4:
        return connect__1608118.call(this, this$, opt1, opt2, opt3)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return connect
}();
clojure.browser.net.transmit = function() {
  var transmit = null;
  var transmit__1608120 = function(this$, opt) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608097 = this$;
      if(cljs.core.truth_(and__3546__auto____1608097)) {
        return this$.clojure$browser$net$IConnection$transmit
      }else {
        return and__3546__auto____1608097
      }
    }())) {
      return this$.clojure$browser$net$IConnection$transmit(this$, opt)
    }else {
      return function() {
        var or__3548__auto____1608098 = clojure.browser.net.transmit[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608098)) {
          return or__3548__auto____1608098
        }else {
          var or__3548__auto____1608099 = clojure.browser.net.transmit["_"];
          if(cljs.core.truth_(or__3548__auto____1608099)) {
            return or__3548__auto____1608099
          }else {
            throw cljs.core.missing_protocol.call(null, "IConnection.transmit", this$);
          }
        }
      }().call(null, this$, opt)
    }
  };
  var transmit__1608121 = function(this$, opt, opt2) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608100 = this$;
      if(cljs.core.truth_(and__3546__auto____1608100)) {
        return this$.clojure$browser$net$IConnection$transmit
      }else {
        return and__3546__auto____1608100
      }
    }())) {
      return this$.clojure$browser$net$IConnection$transmit(this$, opt, opt2)
    }else {
      return function() {
        var or__3548__auto____1608101 = clojure.browser.net.transmit[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608101)) {
          return or__3548__auto____1608101
        }else {
          var or__3548__auto____1608102 = clojure.browser.net.transmit["_"];
          if(cljs.core.truth_(or__3548__auto____1608102)) {
            return or__3548__auto____1608102
          }else {
            throw cljs.core.missing_protocol.call(null, "IConnection.transmit", this$);
          }
        }
      }().call(null, this$, opt, opt2)
    }
  };
  var transmit__1608122 = function(this$, opt, opt2, opt3) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608103 = this$;
      if(cljs.core.truth_(and__3546__auto____1608103)) {
        return this$.clojure$browser$net$IConnection$transmit
      }else {
        return and__3546__auto____1608103
      }
    }())) {
      return this$.clojure$browser$net$IConnection$transmit(this$, opt, opt2, opt3)
    }else {
      return function() {
        var or__3548__auto____1608104 = clojure.browser.net.transmit[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608104)) {
          return or__3548__auto____1608104
        }else {
          var or__3548__auto____1608105 = clojure.browser.net.transmit["_"];
          if(cljs.core.truth_(or__3548__auto____1608105)) {
            return or__3548__auto____1608105
          }else {
            throw cljs.core.missing_protocol.call(null, "IConnection.transmit", this$);
          }
        }
      }().call(null, this$, opt, opt2, opt3)
    }
  };
  var transmit__1608123 = function(this$, opt, opt2, opt3, opt4) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608106 = this$;
      if(cljs.core.truth_(and__3546__auto____1608106)) {
        return this$.clojure$browser$net$IConnection$transmit
      }else {
        return and__3546__auto____1608106
      }
    }())) {
      return this$.clojure$browser$net$IConnection$transmit(this$, opt, opt2, opt3, opt4)
    }else {
      return function() {
        var or__3548__auto____1608107 = clojure.browser.net.transmit[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608107)) {
          return or__3548__auto____1608107
        }else {
          var or__3548__auto____1608108 = clojure.browser.net.transmit["_"];
          if(cljs.core.truth_(or__3548__auto____1608108)) {
            return or__3548__auto____1608108
          }else {
            throw cljs.core.missing_protocol.call(null, "IConnection.transmit", this$);
          }
        }
      }().call(null, this$, opt, opt2, opt3, opt4)
    }
  };
  var transmit__1608124 = function(this$, opt, opt2, opt3, opt4, opt5) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608109 = this$;
      if(cljs.core.truth_(and__3546__auto____1608109)) {
        return this$.clojure$browser$net$IConnection$transmit
      }else {
        return and__3546__auto____1608109
      }
    }())) {
      return this$.clojure$browser$net$IConnection$transmit(this$, opt, opt2, opt3, opt4, opt5)
    }else {
      return function() {
        var or__3548__auto____1608110 = clojure.browser.net.transmit[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608110)) {
          return or__3548__auto____1608110
        }else {
          var or__3548__auto____1608111 = clojure.browser.net.transmit["_"];
          if(cljs.core.truth_(or__3548__auto____1608111)) {
            return or__3548__auto____1608111
          }else {
            throw cljs.core.missing_protocol.call(null, "IConnection.transmit", this$);
          }
        }
      }().call(null, this$, opt, opt2, opt3, opt4, opt5)
    }
  };
  transmit = function(this$, opt, opt2, opt3, opt4, opt5) {
    switch(arguments.length) {
      case 2:
        return transmit__1608120.call(this, this$, opt);
      case 3:
        return transmit__1608121.call(this, this$, opt, opt2);
      case 4:
        return transmit__1608122.call(this, this$, opt, opt2, opt3);
      case 5:
        return transmit__1608123.call(this, this$, opt, opt2, opt3, opt4);
      case 6:
        return transmit__1608124.call(this, this$, opt, opt2, opt3, opt4, opt5)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return transmit
}();
clojure.browser.net.close = function close(this$) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1608112 = this$;
    if(cljs.core.truth_(and__3546__auto____1608112)) {
      return this$.clojure$browser$net$IConnection$close
    }else {
      return and__3546__auto____1608112
    }
  }())) {
    return this$.clojure$browser$net$IConnection$close(this$)
  }else {
    return function() {
      var or__3548__auto____1608113 = clojure.browser.net.close[goog.typeOf.call(null, this$)];
      if(cljs.core.truth_(or__3548__auto____1608113)) {
        return or__3548__auto____1608113
      }else {
        var or__3548__auto____1608114 = clojure.browser.net.close["_"];
        if(cljs.core.truth_(or__3548__auto____1608114)) {
          return or__3548__auto____1608114
        }else {
          throw cljs.core.missing_protocol.call(null, "IConnection.close", this$);
        }
      }
    }().call(null, this$)
  }
};
goog.net.XhrIo.prototype.clojure$browser$event$EventType$ = true;
goog.net.XhrIo.prototype.clojure$browser$event$EventType$event_types = function(this$) {
  return cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), cljs.core.map.call(null, function(p__1608126) {
    var vec__1608127__1608128 = p__1608126;
    var k__1608129 = cljs.core.nth.call(null, vec__1608127__1608128, 0, null);
    var v__1608130 = cljs.core.nth.call(null, vec__1608127__1608128, 1, null);
    return cljs.core.PersistentVector.fromArray([cljs.core.keyword.call(null, k__1608129.toLowerCase()), v__1608130])
  }, cljs.core.merge.call(null, cljs.core.js__GT_clj.call(null, goog.net.EventType))))
};
goog.net.XhrIo.prototype.clojure$browser$net$IConnection$ = true;
goog.net.XhrIo.prototype.clojure$browser$net$IConnection$transmit = function() {
  var G__1608131 = null;
  var G__1608131__1608132 = function(this$, uri) {
    return clojure.browser.net.transmit.call(null, this$, uri, "GET", null, null, clojure.browser.net._STAR_timeout_STAR_)
  };
  var G__1608131__1608133 = function(this$, uri, method) {
    return clojure.browser.net.transmit.call(null, this$, uri, method, null, null, clojure.browser.net._STAR_timeout_STAR_)
  };
  var G__1608131__1608134 = function(this$, uri, method, content) {
    return clojure.browser.net.transmit.call(null, this$, uri, method, content, null, clojure.browser.net._STAR_timeout_STAR_)
  };
  var G__1608131__1608135 = function(this$, uri, method, content, headers) {
    return clojure.browser.net.transmit.call(null, this$, uri, method, content, headers, clojure.browser.net._STAR_timeout_STAR_)
  };
  var G__1608131__1608136 = function(this$, uri, method, content, headers, timeout) {
    this$.setTimeoutInterval(timeout);
    return this$.send(uri, method, content, headers)
  };
  G__1608131 = function(this$, uri, method, content, headers, timeout) {
    switch(arguments.length) {
      case 2:
        return G__1608131__1608132.call(this, this$, uri);
      case 3:
        return G__1608131__1608133.call(this, this$, uri, method);
      case 4:
        return G__1608131__1608134.call(this, this$, uri, method, content);
      case 5:
        return G__1608131__1608135.call(this, this$, uri, method, content, headers);
      case 6:
        return G__1608131__1608136.call(this, this$, uri, method, content, headers, timeout)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1608131
}();
clojure.browser.net.xpc_config_fields = cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), cljs.core.map.call(null, function(p__1608138) {
  var vec__1608139__1608140 = p__1608138;
  var k__1608141 = cljs.core.nth.call(null, vec__1608139__1608140, 0, null);
  var v__1608142 = cljs.core.nth.call(null, vec__1608139__1608140, 1, null);
  return cljs.core.PersistentVector.fromArray([cljs.core.keyword.call(null, k__1608141.toLowerCase()), v__1608142])
}, cljs.core.js__GT_clj.call(null, goog.net.xpc.CfgFields)));
clojure.browser.net.xhr_connection = function xhr_connection() {
  return new goog.net.XhrIo
};
clojure.browser.net.ICrossPageChannel = {};
clojure.browser.net.register_service = function() {
  var register_service = null;
  var register_service__1608149 = function(this$, service_name, fn) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608143 = this$;
      if(cljs.core.truth_(and__3546__auto____1608143)) {
        return this$.clojure$browser$net$ICrossPageChannel$register_service
      }else {
        return and__3546__auto____1608143
      }
    }())) {
      return this$.clojure$browser$net$ICrossPageChannel$register_service(this$, service_name, fn)
    }else {
      return function() {
        var or__3548__auto____1608144 = clojure.browser.net.register_service[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608144)) {
          return or__3548__auto____1608144
        }else {
          var or__3548__auto____1608145 = clojure.browser.net.register_service["_"];
          if(cljs.core.truth_(or__3548__auto____1608145)) {
            return or__3548__auto____1608145
          }else {
            throw cljs.core.missing_protocol.call(null, "ICrossPageChannel.register-service", this$);
          }
        }
      }().call(null, this$, service_name, fn)
    }
  };
  var register_service__1608150 = function(this$, service_name, fn, encode_json_QMARK_) {
    if(cljs.core.truth_(function() {
      var and__3546__auto____1608146 = this$;
      if(cljs.core.truth_(and__3546__auto____1608146)) {
        return this$.clojure$browser$net$ICrossPageChannel$register_service
      }else {
        return and__3546__auto____1608146
      }
    }())) {
      return this$.clojure$browser$net$ICrossPageChannel$register_service(this$, service_name, fn, encode_json_QMARK_)
    }else {
      return function() {
        var or__3548__auto____1608147 = clojure.browser.net.register_service[goog.typeOf.call(null, this$)];
        if(cljs.core.truth_(or__3548__auto____1608147)) {
          return or__3548__auto____1608147
        }else {
          var or__3548__auto____1608148 = clojure.browser.net.register_service["_"];
          if(cljs.core.truth_(or__3548__auto____1608148)) {
            return or__3548__auto____1608148
          }else {
            throw cljs.core.missing_protocol.call(null, "ICrossPageChannel.register-service", this$);
          }
        }
      }().call(null, this$, service_name, fn, encode_json_QMARK_)
    }
  };
  register_service = function(this$, service_name, fn, encode_json_QMARK_) {
    switch(arguments.length) {
      case 3:
        return register_service__1608149.call(this, this$, service_name, fn);
      case 4:
        return register_service__1608150.call(this, this$, service_name, fn, encode_json_QMARK_)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return register_service
}();
goog.net.xpc.CrossPageChannel.prototype.clojure$browser$net$IConnection$ = true;
goog.net.xpc.CrossPageChannel.prototype.clojure$browser$net$IConnection$connect = function() {
  var G__1608152 = null;
  var G__1608152__1608153 = function(this$) {
    return clojure.browser.net.connect.call(null, this$, null)
  };
  var G__1608152__1608154 = function(this$, on_connect_fn) {
    return this$.connect(on_connect_fn)
  };
  var G__1608152__1608155 = function(this$, on_connect_fn, config_iframe_fn) {
    return clojure.browser.net.connect.call(null, this$, on_connect_fn, config_iframe_fn, document.body)
  };
  var G__1608152__1608156 = function(this$, on_connect_fn, config_iframe_fn, iframe_parent) {
    this$.createPeerIframe(iframe_parent, config_iframe_fn);
    return this$.connect(on_connect_fn)
  };
  G__1608152 = function(this$, on_connect_fn, config_iframe_fn, iframe_parent) {
    switch(arguments.length) {
      case 1:
        return G__1608152__1608153.call(this, this$);
      case 2:
        return G__1608152__1608154.call(this, this$, on_connect_fn);
      case 3:
        return G__1608152__1608155.call(this, this$, on_connect_fn, config_iframe_fn);
      case 4:
        return G__1608152__1608156.call(this, this$, on_connect_fn, config_iframe_fn, iframe_parent)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1608152
}();
goog.net.xpc.CrossPageChannel.prototype.clojure$browser$net$IConnection$transmit = function(this$, service_name, payload) {
  return this$.send(cljs.core.name.call(null, service_name), payload)
};
goog.net.xpc.CrossPageChannel.prototype.clojure$browser$net$IConnection$close = function(this$) {
  return this$.close(cljs.core.List.EMPTY)
};
goog.net.xpc.CrossPageChannel.prototype.clojure$browser$net$ICrossPageChannel$ = true;
goog.net.xpc.CrossPageChannel.prototype.clojure$browser$net$ICrossPageChannel$register_service = function() {
  var G__1608158 = null;
  var G__1608158__1608159 = function(this$, service_name, fn) {
    return clojure.browser.net.register_service.call(null, this$, service_name, fn, false)
  };
  var G__1608158__1608160 = function(this$, service_name, fn, encode_json_QMARK_) {
    return this$.registerService(cljs.core.name.call(null, service_name), fn, encode_json_QMARK_)
  };
  G__1608158 = function(this$, service_name, fn, encode_json_QMARK_) {
    switch(arguments.length) {
      case 3:
        return G__1608158__1608159.call(this, this$, service_name, fn);
      case 4:
        return G__1608158__1608160.call(this, this$, service_name, fn, encode_json_QMARK_)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1608158
}();
clojure.browser.net.xpc_connection = function() {
  var xpc_connection = null;
  var xpc_connection__1608171 = function() {
    var temp__3698__auto____1608162 = (new goog.Uri(window.location.href)).getParameterValue("xpc");
    if(cljs.core.truth_(temp__3698__auto____1608162)) {
      var config__1608163 = temp__3698__auto____1608162;
      return new goog.net.xpc.CrossPageChannel(goog.json.parse.call(null, config__1608163))
    }else {
      return null
    }
  };
  var xpc_connection__1608172 = function(config) {
    return new goog.net.xpc.CrossPageChannel(cljs.core.reduce.call(null, function(sum, p__1608164) {
      var vec__1608165__1608166 = p__1608164;
      var k__1608167 = cljs.core.nth.call(null, vec__1608165__1608166, 0, null);
      var v__1608168 = cljs.core.nth.call(null, vec__1608165__1608166, 1, null);
      var temp__3695__auto____1608169 = cljs.core.get.call(null, clojure.browser.net.xpc_config_fields, k__1608167);
      if(cljs.core.truth_(temp__3695__auto____1608169)) {
        var field__1608170 = temp__3695__auto____1608169;
        return cljs.core.assoc.call(null, sum, field__1608170, v__1608168)
      }else {
        return sum
      }
    }, cljs.core.ObjMap.fromObject([], {}), config).strobj)
  };
  xpc_connection = function(config) {
    switch(arguments.length) {
      case 0:
        return xpc_connection__1608171.call(this);
      case 1:
        return xpc_connection__1608172.call(this, config)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return xpc_connection
}();
goog.provide("clojure.browser.repl");
goog.require("cljs.core");
goog.require("clojure.browser.net");
goog.require("clojure.browser.event");
clojure.browser.repl.xpc_connection = cljs.core.atom.call(null, null);
clojure.browser.repl.repl_print = function repl_print(data) {
  var temp__3695__auto____1608067 = cljs.core.deref.call(null, clojure.browser.repl.xpc_connection);
  if(cljs.core.truth_(temp__3695__auto____1608067)) {
    var conn__1608068 = temp__3695__auto____1608067;
    return clojure.browser.net.transmit.call(null, conn__1608068, "\ufdd0'print", cljs.core.pr_str.call(null, data))
  }else {
    return null
  }
};
clojure.browser.repl.evaluate_javascript = function evaluate_javascript(conn, block) {
  var result__1608071 = function() {
    try {
      return cljs.core.ObjMap.fromObject(["\ufdd0'status", "\ufdd0'value"], {"\ufdd0'status":"\ufdd0'success", "\ufdd0'value":cljs.core.str.call(null, eval(block))})
    }catch(e1608069) {
      if(cljs.core.truth_(cljs.core.instance_QMARK_.call(null, Error, e1608069))) {
        var e__1608070 = e1608069;
        return cljs.core.ObjMap.fromObject(["\ufdd0'status", "\ufdd0'value", "\ufdd0'stacktrace"], {"\ufdd0'status":"\ufdd0'exception", "\ufdd0'value":cljs.core.pr_str.call(null, e__1608070), "\ufdd0'stacktrace":cljs.core.truth_(e__1608070.hasOwnProperty("stack")) ? e__1608070.stack : "No stacktrace available."})
      }else {
        if(cljs.core.truth_("\ufdd0'else")) {
          throw e1608069;
        }else {
          return null
        }
      }
    }
  }();
  return cljs.core.pr_str.call(null, result__1608071)
};
clojure.browser.repl.send_result = function send_result(connection, url, data) {
  return clojure.browser.net.transmit.call(null, connection, url, "POST", data, null, 0)
};
clojure.browser.repl.send_print = function() {
  var send_print = null;
  var send_print__1608073 = function(url, data) {
    return send_print.call(null, url, data, 0)
  };
  var send_print__1608074 = function(url, data, n) {
    var conn__1608072 = clojure.browser.net.xhr_connection.call(null);
    clojure.browser.event.listen.call(null, conn__1608072, "\ufdd0'error", function(_) {
      if(cljs.core.truth_(n < 10)) {
        return send_print.call(null, url, data, n + 1)
      }else {
        return console.log(cljs.core.str.call(null, "Could not send ", data, " after ", n, " attempts."))
      }
    });
    return clojure.browser.net.transmit.call(null, conn__1608072, url, "POST", data, null, 0)
  };
  send_print = function(url, data, n) {
    switch(arguments.length) {
      case 2:
        return send_print__1608073.call(this, url, data);
      case 3:
        return send_print__1608074.call(this, url, data, n)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return send_print
}();
clojure.browser.repl.order = cljs.core.atom.call(null, 0);
clojure.browser.repl.wrap_message = function wrap_message(t, data) {
  return cljs.core.pr_str.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'type", "\ufdd0'content", "\ufdd0'order"], {"\ufdd0'type":t, "\ufdd0'content":data, "\ufdd0'order":cljs.core.swap_BANG_.call(null, clojure.browser.repl.order, cljs.core.inc)}))
};
clojure.browser.repl.start_evaluator = function start_evaluator(url) {
  var temp__3695__auto____1608076 = clojure.browser.net.xpc_connection.call(null);
  if(cljs.core.truth_(temp__3695__auto____1608076)) {
    var repl_connection__1608077 = temp__3695__auto____1608076;
    var connection__1608078 = clojure.browser.net.xhr_connection.call(null);
    clojure.browser.event.listen.call(null, connection__1608078, "\ufdd0'success", function(e) {
      return clojure.browser.net.transmit.call(null, repl_connection__1608077, "\ufdd0'evaluate-javascript", e.currentTarget.getResponseText(cljs.core.List.EMPTY))
    });
    clojure.browser.net.register_service.call(null, repl_connection__1608077, "\ufdd0'send-result", function(data) {
      return clojure.browser.repl.send_result.call(null, connection__1608078, url, clojure.browser.repl.wrap_message.call(null, "\ufdd0'result", data))
    });
    clojure.browser.net.register_service.call(null, repl_connection__1608077, "\ufdd0'print", function(data) {
      return clojure.browser.repl.send_print.call(null, url, clojure.browser.repl.wrap_message.call(null, "\ufdd0'print", data))
    });
    clojure.browser.net.connect.call(null, repl_connection__1608077, cljs.core.constantly.call(null, null));
    return setTimeout.call(null, function() {
      return clojure.browser.repl.send_result.call(null, connection__1608078, url, clojure.browser.repl.wrap_message.call(null, "\ufdd0'ready", "ready"))
    }, 50)
  }else {
    return alert.call(null, "No 'xpc' param provided to child iframe.")
  }
};
clojure.browser.repl.connect = function connect(repl_server_url) {
  var repl_connection__1608079 = clojure.browser.net.xpc_connection.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'peer_uri"], {"\ufdd0'peer_uri":repl_server_url}));
  cljs.core.swap_BANG_.call(null, clojure.browser.repl.xpc_connection, cljs.core.constantly.call(null, repl_connection__1608079));
  clojure.browser.net.register_service.call(null, repl_connection__1608079, "\ufdd0'evaluate-javascript", function(js) {
    return clojure.browser.net.transmit.call(null, repl_connection__1608079, "\ufdd0'send-result", clojure.browser.repl.evaluate_javascript.call(null, repl_connection__1608079, js))
  });
  return clojure.browser.net.connect.call(null, repl_connection__1608079, cljs.core.constantly.call(null, null), function(iframe) {
    return iframe.style.display = "none"
  })
};
goog.provide("showoff.core");
goog.require("cljs.core");
goog.require("showoff.showoff");
goog.require("goog.dom");
goog.require("goog.string");
goog.require("goog.string.format");
goog.require("goog.events");
goog.require("goog.Timer");
goog.require("goog.events.KeyHandler");
goog.require("clojure.browser.event");
goog.require("clojure.browser.repl");
showoff.core.by_id = function by_id(id) {
  return goog.dom.getElement.call(null, id)
};
showoff.core.content = function content() {
  return showoff.core.by_id.call(null, "content")
};
showoff.core._STAR_command_state_map_STAR_ = cljs.core.set([]);
showoff.core._STAR_media_player_STAR_ = null;
showoff.core._STAR_current_map_STAR_ = null;
showoff.core.map__GT_js = function map__GT_js(m) {
  var out__1605382 = cljs.core.js_obj.call(null);
  var G__1605383__1605384 = cljs.core.seq.call(null, m);
  if(cljs.core.truth_(G__1605383__1605384)) {
    var G__1605386__1605388 = cljs.core.first.call(null, G__1605383__1605384);
    var vec__1605387__1605389 = G__1605386__1605388;
    var k__1605390 = cljs.core.nth.call(null, vec__1605387__1605389, 0, null);
    var v__1605391 = cljs.core.nth.call(null, vec__1605387__1605389, 1, null);
    var G__1605383__1605392 = G__1605383__1605384;
    var G__1605386__1605393 = G__1605386__1605388;
    var G__1605383__1605394 = G__1605383__1605392;
    while(true) {
      var vec__1605395__1605396 = G__1605386__1605393;
      var k__1605397 = cljs.core.nth.call(null, vec__1605395__1605396, 0, null);
      var v__1605398 = cljs.core.nth.call(null, vec__1605395__1605396, 1, null);
      var G__1605383__1605399 = G__1605383__1605394;
      out__1605382[cljs.core.name.call(null, k__1605397)] = v__1605398;
      var temp__3698__auto____1605400 = cljs.core.next.call(null, G__1605383__1605399);
      if(cljs.core.truth_(temp__3698__auto____1605400)) {
        var G__1605383__1605401 = temp__3698__auto____1605400;
        var G__1605402 = cljs.core.first.call(null, G__1605383__1605401);
        var G__1605403 = G__1605383__1605401;
        G__1605386__1605393 = G__1605402;
        G__1605383__1605394 = G__1605403;
        continue
      }else {
      }
      break
    }
  }else {
  }
  return out__1605382
};
showoff.core.clj__GT_js = function clj__GT_js(x) {
  if(cljs.core.truth_(cljs.core.string_QMARK_.call(null, x))) {
    return x
  }else {
    if(cljs.core.truth_(cljs.core.keyword_QMARK_.call(null, x))) {
      return cljs.core.name.call(null, x)
    }else {
      if(cljs.core.truth_(cljs.core.map_QMARK_.call(null, x))) {
        return cljs.core.reduce.call(null, function(m, p__1605404) {
          var vec__1605405__1605406 = p__1605404;
          var k__1605407 = cljs.core.nth.call(null, vec__1605405__1605406, 0, null);
          var v__1605408 = cljs.core.nth.call(null, vec__1605405__1605406, 1, null);
          return cljs.core.assoc.call(null, m, clj__GT_js.call(null, k__1605407), clj__GT_js.call(null, v__1605408))
        }, cljs.core.ObjMap.fromObject([], {}), x).strobj
      }else {
        if(cljs.core.truth_(cljs.core.coll_QMARK_.call(null, x))) {
          return cljs.core.apply.call(null, cljs.core.array, cljs.core.map.call(null, clj__GT_js, x))
        }else {
          if(cljs.core.truth_("\ufdd0'else")) {
            return x
          }else {
            return null
          }
        }
      }
    }
  }
};
showoff.core.prepare_sound = function prepare_sound() {
  var spec__1605409 = cljs.core.ObjMap.fromObject(["\ufdd0'resources", "\ufdd0'autoplay", "\ufdd0'spritemap"], {"\ufdd0'resources":cljs.core.PersistentVector.fromArray(["music/epica.ogg", "music/epica.mp3"]), "\ufdd0'autoplay":"bg-music", "\ufdd0'spritemap":cljs.core.ObjMap.fromObject(["\ufdd0'bg-music"], {"\ufdd0'bg-music":cljs.core.ObjMap.fromObject(["\ufdd0'start", "\ufdd0'end", "\ufdd0'loop"], {"\ufdd0'start":0, "\ufdd0'end":122, "\ufdd0'loop":true})})});
  return showoff.core._STAR_media_player_STAR_ = new jukebox.Player(showoff.core.clj__GT_js.call(null, spec__1605409))
};
showoff.core._PLUS_map_symbols_PLUS_ = null;
showoff.core.keydown = function keydown(e) {
  return showoff.core._STAR_command_state_map_STAR_ = cljs.core.conj.call(null, showoff.core._STAR_command_state_map_STAR_, e.keyCode)
};
showoff.core.keyup = function keyup(e) {
  return showoff.core._STAR_command_state_map_STAR_ = cljs.core.disj.call(null, showoff.core._STAR_command_state_map_STAR_, e.keyCode)
};
showoff.core.prepare_input = function prepare_input() {
  var doc__1605410 = document;
  goog.events.listen.call(null, doc__1605410, goog.events.EventType.KEYDOWN, showoff.core.keydown);
  return goog.events.listen.call(null, doc__1605410, goog.events.EventType.KEYUP, showoff.core.keyup)
};
showoff.core._STAR_guy_sprites_STAR_ = null;
showoff.core._STAR_hud_sprite_STAR_ = null;
showoff.core.keyboard_velocity_generator = function keyboard_velocity_generator(keycode, value) {
  return function(p) {
    if(cljs.core.truth_(showoff.core._STAR_command_state_map_STAR_.call(null, keycode))) {
      return value
    }else {
      return cljs.core.PersistentVector.fromArray([0, 0])
    }
  }
};
showoff.core.jump_velocity_generator = function jump_velocity_generator(map, rect_gen, up_vel, jump_fuel) {
  var state__1605411 = cljs.core.atom.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'jump-fuel", "\ufdd0'jumping"], {"\ufdd0'jump-fuel":jump_fuel, "\ufdd0'jumping":false}));
  return function(p) {
    var supported__1605412 = showoff.showoff.supported_by_map.call(null, cljs.core.deref.call(null, map), rect_gen.call(null));
    if(cljs.core.truth_(cljs.core.not.call(null, showoff.core._STAR_command_state_map_STAR_.call(null, goog.events.KeyCodes.UP)))) {
      if(cljs.core.truth_(supported__1605412)) {
        cljs.core.swap_BANG_.call(null, state__1605411, cljs.core.assoc, "\ufdd0'jump-fuel", jump_fuel)
      }else {
      }
      cljs.core.swap_BANG_.call(null, state__1605411, cljs.core.assoc, "\ufdd0'jumping", false);
      return cljs.core.PersistentVector.fromArray([0, 0])
    }else {
      if(cljs.core.truth_(function() {
        var and__3546__auto____1605413 = supported__1605412;
        if(cljs.core.truth_(and__3546__auto____1605413)) {
          return cljs.core.not.call(null, "\ufdd0'jumping".call(null, cljs.core.deref.call(null, state__1605411)))
        }else {
          return and__3546__auto____1605413
        }
      }())) {
        cljs.core.swap_BANG_.call(null, state__1605411, cljs.core.assoc, "\ufdd0'jumping", true);
        return cljs.core.PersistentVector.fromArray([0, -up_vel])
      }else {
        if(cljs.core.truth_(showoff.showoff.head_bumped_map.call(null, cljs.core.deref.call(null, map), rect_gen.call(null)))) {
          cljs.core.swap_BANG_.call(null, state__1605411, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'jump-fuel"], {"\ufdd0'jump-fuel":0}));
          return cljs.core.PersistentVector.fromArray([0, 0])
        }else {
          if(cljs.core.truth_("\ufdd0'jumping".call(null, cljs.core.deref.call(null, state__1605411)))) {
            var fuel__1605414 = "\ufdd0'jump-fuel".call(null, cljs.core.deref.call(null, state__1605411));
            cljs.core.swap_BANG_.call(null, state__1605411, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'jump-fuel"], {"\ufdd0'jump-fuel":fuel__1605414 - showoff.showoff._PLUS_secs_per_tick_PLUS_}));
            if(cljs.core.truth_(fuel__1605414 > 0)) {
              var fuel_factor__1605415 = fuel__1605414 / jump_fuel;
              return cljs.core.PersistentVector.fromArray([0, -(fuel_factor__1605415 * fuel_factor__1605415 * up_vel)])
            }else {
              return cljs.core.PersistentVector.fromArray([0, 0])
            }
          }else {
            if(cljs.core.truth_("\ufdd0'else")) {
              return cljs.core.PersistentVector.fromArray([0, 0])
            }else {
              return null
            }
          }
        }
      }
    }
  }
};
showoff.core.ground_friction_generator = function ground_friction_generator(map, rect_gen, coefficient) {
  return function(p) {
    if(cljs.core.truth_(cljs.core.not.call(null, showoff.showoff.supported_by_map.call(null, cljs.core.deref.call(null, map), rect_gen.call(null))))) {
      return cljs.core.PersistentVector.fromArray([0, 0])
    }else {
      if(cljs.core.truth_(function() {
        var or__3548__auto____1605416 = showoff.core._STAR_command_state_map_STAR_.call(null, goog.events.KeyCodes.LEFT);
        if(cljs.core.truth_(or__3548__auto____1605416)) {
          return or__3548__auto____1605416
        }else {
          return showoff.core._STAR_command_state_map_STAR_.call(null, goog.events.KeyCodes.RIGHT)
        }
      }())) {
        return cljs.core.PersistentVector.fromArray([0, 0])
      }else {
        if(cljs.core.truth_("\ufdd0'else")) {
          var xvel__1605417 = showoff.showoff.vec_dot.call(null, cljs.core.PersistentVector.fromArray([1, 0]), "\ufdd0'velocity".call(null, p));
          return showoff.showoff.vec_scale.call(null, cljs.core.PersistentVector.fromArray([1, 0]), -1 * coefficient * xvel__1605417)
        }else {
          return null
        }
      }
    }
  }
};
showoff.core.Bullet = function(particle, maxticks, __meta, __extmap) {
  this.particle = particle;
  this.maxticks = maxticks;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 2) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
showoff.core.Bullet.prototype.showoff$showoff$Drawable$ = true;
showoff.core.Bullet.prototype.showoff$showoff$Drawable$draw = function(bullet, ctx) {
  var this__1605421 = this;
  var vec__1605422__1605423 = showoff.showoff.to_rect.call(null, bullet);
  var x__1605424 = cljs.core.nth.call(null, vec__1605422__1605423, 0, null);
  var y__1605425 = cljs.core.nth.call(null, vec__1605422__1605423, 1, null);
  var w__1605426 = cljs.core.nth.call(null, vec__1605422__1605423, 2, null);
  var h__1605427 = cljs.core.nth.call(null, vec__1605422__1605423, 3, null);
  return showoff.showoff.filled_rect.call(null, ctx, cljs.core.PersistentVector.fromArray([x__1605424, y__1605425]), cljs.core.PersistentVector.fromArray([w__1605426, h__1605427]), showoff.showoff.color.call(null, cljs.core.PersistentVector.fromArray([128, 128, 128])))
};
showoff.core.Bullet.prototype.cljs$core$IHash$ = true;
showoff.core.Bullet.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1605428 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
showoff.core.Bullet.prototype.cljs$core$ILookup$ = true;
showoff.core.Bullet.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605455 = null;
  var G__1605455__1605456 = function(this__388__auto__, k__389__auto__) {
    var this__1605429 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605455__1605457 = function(this__390__auto__, k1605419, else__391__auto__) {
    var this__1605430 = this;
    if(cljs.core.truth_(k1605419 === "\ufdd0'particle")) {
      return this__1605430.particle
    }else {
      if(cljs.core.truth_(k1605419 === "\ufdd0'maxticks")) {
        return this__1605430.maxticks
      }else {
        if(cljs.core.truth_("\ufdd0'else")) {
          return cljs.core.get.call(null, this__1605430.__extmap, k1605419, else__391__auto__)
        }else {
          return null
        }
      }
    }
  };
  G__1605455 = function(this__390__auto__, k1605419, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605455__1605456.call(this, this__390__auto__, k1605419);
      case 3:
        return G__1605455__1605457.call(this, this__390__auto__, k1605419, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605455
}();
showoff.core.Bullet.prototype.cljs$core$IAssociative$ = true;
showoff.core.Bullet.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1605418) {
  var this__1605431 = this;
  var pred__1605432__1605435 = cljs.core.identical_QMARK_;
  var expr__1605433__1605436 = k__396__auto__;
  if(cljs.core.truth_(pred__1605432__1605435.call(null, "\ufdd0'particle", expr__1605433__1605436))) {
    return new showoff.core.Bullet(G__1605418, this__1605431.maxticks, this__1605431.__meta, this__1605431.__extmap)
  }else {
    if(cljs.core.truth_(pred__1605432__1605435.call(null, "\ufdd0'maxticks", expr__1605433__1605436))) {
      return new showoff.core.Bullet(this__1605431.particle, G__1605418, this__1605431.__meta, this__1605431.__extmap)
    }else {
      return new showoff.core.Bullet(this__1605431.particle, this__1605431.maxticks, this__1605431.__meta, cljs.core.assoc.call(null, this__1605431.__extmap, k__396__auto__, G__1605418))
    }
  }
};
showoff.core.Bullet.prototype.showoff$showoff$Tickable$ = true;
showoff.core.Bullet.prototype.showoff$showoff$Tickable$tick = function(bullet) {
  var this__1605437 = this;
  var ticks__1605439 = 1 + function() {
    var or__3548__auto____1605438 = "\ufdd0'ticks".call(null, cljs.core.deref.call(null, this__1605437.particle));
    if(cljs.core.truth_(or__3548__auto____1605438)) {
      return or__3548__auto____1605438
    }else {
      return 0
    }
  }();
  if(cljs.core.truth_(ticks__1605439 > this__1605437.maxticks)) {
    return showoff.showoff.remove_entity.call(null, showoff.core._STAR_current_map_STAR_, bullet)
  }else {
    if(cljs.core.truth_(cljs.core.not.call(null, cljs.core.empty_QMARK_.call(null, showoff.showoff.map_collisions.call(null, showoff.core._STAR_current_map_STAR_, showoff.showoff.to_rect.call(null, bullet)))))) {
      return showoff.showoff.remove_entity.call(null, showoff.core._STAR_current_map_STAR_, bullet)
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        return cljs.core.reset_BANG_.call(null, this__1605437.particle, cljs.core.conj.call(null, showoff.showoff.integrate_particle.call(null, cljs.core.deref.call(null, this__1605437.particle)), cljs.core.ObjMap.fromObject(["\ufdd0'ticks"], {"\ufdd0'ticks":ticks__1605439})))
      }else {
        return null
      }
    }
  }
};
showoff.core.Bullet.prototype.showoff$showoff$Rectable$ = true;
showoff.core.Bullet.prototype.showoff$showoff$Rectable$to_rect = function(bullet) {
  var this__1605440 = this;
  var vec__1605441__1605442 = "\ufdd0'position".call(null, cljs.core.deref.call(null, this__1605440.particle));
  var x__1605443 = cljs.core.nth.call(null, vec__1605441__1605442, 0, null);
  var y__1605444 = cljs.core.nth.call(null, vec__1605441__1605442, 1, null);
  return cljs.core.PersistentVector.fromArray([x__1605443, y__1605444, 0.2, 0.2])
};
showoff.core.Bullet.prototype.cljs$core$IRecord$ = true;
showoff.core.Bullet.prototype.cljs$core$ICollection$ = true;
showoff.core.Bullet.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1605445 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
showoff.core.Bullet.prototype.cljs$core$ISeqable$ = true;
showoff.core.Bullet.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605446 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'particle", this__1605446.particle), cljs.core.vector.call(null, "\ufdd0'maxticks", this__1605446.maxticks)]), this__1605446.__extmap))
};
showoff.core.Bullet.prototype.cljs$core$IPrintable$ = true;
showoff.core.Bullet.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605447 = this;
  var pr_pair__404__auto____1605448 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605448, cljs.core.str.call(null, "#", "showoff.core.Bullet", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'particle", this__1605447.particle), cljs.core.vector.call(null, "\ufdd0'maxticks", this__1605447.maxticks)]), this__1605447.__extmap))
};
showoff.core.Bullet.prototype.cljs$core$ICounted$ = true;
showoff.core.Bullet.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605449 = this;
  return 2 + cljs.core.count.call(null, this__1605449.__extmap)
};
showoff.core.Bullet.prototype.cljs$core$IEquiv$ = true;
showoff.core.Bullet.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605450 = this;
  var and__3546__auto____1605451 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605451)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605451
  }
};
showoff.core.Bullet.prototype.cljs$core$IWithMeta$ = true;
showoff.core.Bullet.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1605418) {
  var this__1605452 = this;
  return new showoff.core.Bullet(this__1605452.particle, this__1605452.maxticks, G__1605418, this__1605452.__extmap)
};
showoff.core.Bullet.prototype.cljs$core$IMeta$ = true;
showoff.core.Bullet.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605453 = this;
  return this__1605453.__meta
};
showoff.core.Bullet.prototype.cljs$core$IMap$ = true;
showoff.core.Bullet.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605454 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'maxticks", "\ufdd0'particle"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605454.__meta), k__398__auto__)
  }else {
    return new showoff.core.Bullet(this__1605454.particle, this__1605454.maxticks, this__1605454.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605454.__extmap, k__398__auto__)))
  }
};
showoff.core.Bullet.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "showoff.core.Bullet")
};
showoff.core.__GT_Bullet = function __GT_Bullet(particle, maxticks) {
  return new showoff.core.Bullet(particle, maxticks)
};
showoff.core.map__GT_Bullet = function map__GT_Bullet(G__1605420) {
  return new showoff.core.Bullet("\ufdd0'particle".call(null, G__1605420), "\ufdd0'maxticks".call(null, G__1605420), null, cljs.core.dissoc.call(null, G__1605420, "\ufdd0'particle", "\ufdd0'maxticks"))
};
showoff.core.Bullet;
showoff.core._STAR_guy_extra_forces_STAR_ = cljs.core.atom.call(null, cljs.core.PersistentVector.fromArray([]));
showoff.core.guy_extra_forces = function guy_extra_forces(p) {
  var force__1605459 = cljs.core.reduce.call(null, showoff.showoff.vec_add, cljs.core.PersistentVector.fromArray([0, 0]), cljs.core.deref.call(null, showoff.core._STAR_guy_extra_forces_STAR_));
  cljs.core.reset_BANG_.call(null, showoff.core._STAR_guy_extra_forces_STAR_, cljs.core.PersistentVector.fromArray([]));
  return force__1605459
};
showoff.core._PLUS_firing_cooldown_PLUS_ = 10;
showoff.core.Guy = function(particle, __meta, __extmap) {
  this.particle = particle;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 1) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
showoff.core.Guy.prototype.showoff$showoff$Drawable$ = true;
showoff.core.Guy.prototype.showoff$showoff$Drawable$draw = function(guy, ctx) {
  var this__1605463 = this;
  var vec__1605464__1605465 = "\ufdd0'velocity".call(null, cljs.core.deref.call(null, this__1605463.particle));
  var vx__1605466 = cljs.core.nth.call(null, vec__1605464__1605465, 0, null);
  var ___1605467 = cljs.core.nth.call(null, vec__1605464__1605465, 1, null);
  var sprite__1605468 = cljs.core.truth_(vx__1605466 > 0) ? cljs.core.nth.call(null, showoff.core._STAR_guy_sprites_STAR_, 0) : cljs.core.nth.call(null, showoff.core._STAR_guy_sprites_STAR_, 1);
  return showoff.showoff.draw_sprite.call(null, ctx, sprite__1605468, "\ufdd0'position".call(null, cljs.core.deref.call(null, this__1605463.particle)))
};
showoff.core.Guy.prototype.cljs$core$IHash$ = true;
showoff.core.Guy.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1605469 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
showoff.core.Guy.prototype.cljs$core$ILookup$ = true;
showoff.core.Guy.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605502 = null;
  var G__1605502__1605503 = function(this__388__auto__, k__389__auto__) {
    var this__1605470 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605502__1605504 = function(this__390__auto__, k1605461, else__391__auto__) {
    var this__1605471 = this;
    if(cljs.core.truth_(k1605461 === "\ufdd0'particle")) {
      return this__1605471.particle
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        return cljs.core.get.call(null, this__1605471.__extmap, k1605461, else__391__auto__)
      }else {
        return null
      }
    }
  };
  G__1605502 = function(this__390__auto__, k1605461, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605502__1605503.call(this, this__390__auto__, k1605461);
      case 3:
        return G__1605502__1605504.call(this, this__390__auto__, k1605461, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605502
}();
showoff.core.Guy.prototype.cljs$core$IAssociative$ = true;
showoff.core.Guy.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1605460) {
  var this__1605472 = this;
  var pred__1605473__1605476 = cljs.core.identical_QMARK_;
  var expr__1605474__1605477 = k__396__auto__;
  if(cljs.core.truth_(pred__1605473__1605476.call(null, "\ufdd0'particle", expr__1605474__1605477))) {
    return new showoff.core.Guy(G__1605460, this__1605472.__meta, this__1605472.__extmap)
  }else {
    return new showoff.core.Guy(this__1605472.particle, this__1605472.__meta, cljs.core.assoc.call(null, this__1605472.__extmap, k__396__auto__, G__1605460))
  }
};
showoff.core.Guy.prototype.showoff$showoff$Tickable$ = true;
showoff.core.Guy.prototype.showoff$showoff$Tickable$tick = function(guy) {
  var this__1605478 = this;
  if(cljs.core.truth_(showoff.core._STAR_command_state_map_STAR_.call(null, 32))) {
    var cooldown__1605481 = function() {
      var or__3548__auto____1605480 = "\ufdd0'firing-cooldown".call(null, cljs.core.deref.call(null, this__1605478.particle));
      if(cljs.core.truth_(or__3548__auto____1605480)) {
        return or__3548__auto____1605480
      }else {
        return 0
      }
    }();
    var vec__1605479__1605482 = "\ufdd0'velocity".call(null, cljs.core.deref.call(null, this__1605478.particle));
    var vx__1605483 = cljs.core.nth.call(null, vec__1605479__1605482, 0, null);
    var ___1605484 = cljs.core.nth.call(null, vec__1605479__1605482, 1, null);
    var bullet_direction__1605485 = cljs.core.truth_(vx__1605483 > 0) ? 1 : -1;
    var bullet__1605486 = cljs.core.ObjMap.fromObject(["\ufdd0'mass", "\ufdd0'position", "\ufdd0'velocity"], {"\ufdd0'mass":1, "\ufdd0'position":showoff.showoff.vec_add.call(null, cljs.core.PersistentVector.fromArray([cljs.core.truth_(vx__1605483 > 0) ? 1 : 0, 0.5]), "\ufdd0'position".call(null, cljs.core.deref.call(null, this__1605478.particle))), "\ufdd0'velocity":cljs.core.PersistentVector.fromArray([bullet_direction__1605485 * 6, 0])});
    if(cljs.core.truth_(cooldown__1605481 > 0)) {
      cljs.core.swap_BANG_.call(null, this__1605478.particle, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'firing-cooldown"], {"\ufdd0'firing-cooldown":cooldown__1605481 - 1}))
    }else {
      showoff.showoff.add_entity.call(null, showoff.core._STAR_current_map_STAR_, new showoff.core.Bullet(cljs.core.atom.call(null, bullet__1605486), 40));
      cljs.core.swap_BANG_.call(null, showoff.core._STAR_guy_extra_forces_STAR_, cljs.core.conj, cljs.core.PersistentVector.fromArray([-3 * bullet_direction__1605485, 0]));
      cljs.core.swap_BANG_.call(null, this__1605478.particle, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'firing-cooldown"], {"\ufdd0'firing-cooldown":showoff.core._PLUS_firing_cooldown_PLUS_}))
    }
  }else {
    cljs.core.swap_BANG_.call(null, this__1605478.particle, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'firing-cooldown"], {"\ufdd0'firing-cooldown":0}))
  }
  return cljs.core.reset_BANG_.call(null, this__1605478.particle, showoff.showoff.apply_particle_vs_map.call(null, showoff.showoff.integrate_particle.call(null, cljs.core.deref.call(null, this__1605478.particle)), showoff.core._STAR_current_map_STAR_, showoff.showoff.to_rect.call(null, guy), 0))
};
showoff.core.Guy.prototype.showoff$showoff$Rectable$ = true;
showoff.core.Guy.prototype.showoff$showoff$Rectable$to_rect = function(guy) {
  var this__1605487 = this;
  var vec__1605488__1605489 = "\ufdd0'position".call(null, cljs.core.deref.call(null, this__1605487.particle));
  var x__1605490 = cljs.core.nth.call(null, vec__1605488__1605489, 0, null);
  var y__1605491 = cljs.core.nth.call(null, vec__1605488__1605489, 1, null);
  return cljs.core.PersistentVector.fromArray([x__1605490 + 0.2, y__1605491 + 0.1, 0.6, 0.9])
};
showoff.core.Guy.prototype.cljs$core$IRecord$ = true;
showoff.core.Guy.prototype.cljs$core$ICollection$ = true;
showoff.core.Guy.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1605492 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
showoff.core.Guy.prototype.cljs$core$ISeqable$ = true;
showoff.core.Guy.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605493 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'particle", this__1605493.particle)]), this__1605493.__extmap))
};
showoff.core.Guy.prototype.cljs$core$IPrintable$ = true;
showoff.core.Guy.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605494 = this;
  var pr_pair__404__auto____1605495 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605495, cljs.core.str.call(null, "#", "showoff.core.Guy", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'particle", this__1605494.particle)]), this__1605494.__extmap))
};
showoff.core.Guy.prototype.cljs$core$ICounted$ = true;
showoff.core.Guy.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605496 = this;
  return 1 + cljs.core.count.call(null, this__1605496.__extmap)
};
showoff.core.Guy.prototype.cljs$core$IEquiv$ = true;
showoff.core.Guy.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605497 = this;
  var and__3546__auto____1605498 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605498)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605498
  }
};
showoff.core.Guy.prototype.cljs$core$IWithMeta$ = true;
showoff.core.Guy.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1605460) {
  var this__1605499 = this;
  return new showoff.core.Guy(this__1605499.particle, G__1605460, this__1605499.__extmap)
};
showoff.core.Guy.prototype.cljs$core$IMeta$ = true;
showoff.core.Guy.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605500 = this;
  return this__1605500.__meta
};
showoff.core.Guy.prototype.cljs$core$IMap$ = true;
showoff.core.Guy.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605501 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'particle"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605501.__meta), k__398__auto__)
  }else {
    return new showoff.core.Guy(this__1605501.particle, this__1605501.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605501.__extmap, k__398__auto__)))
  }
};
showoff.core.Guy.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "showoff.core.Guy")
};
showoff.core.__GT_Guy = function __GT_Guy(particle) {
  return new showoff.core.Guy(particle)
};
showoff.core.map__GT_Guy = function map__GT_Guy(G__1605462) {
  return new showoff.core.Guy("\ufdd0'particle".call(null, G__1605462), null, cljs.core.dissoc.call(null, G__1605462, "\ufdd0'particle"))
};
showoff.core.Guy;
showoff.core._PLUS_guy_speed_PLUS_ = 40;
showoff.core._STAR_guy_STAR_ = new showoff.core.Guy(cljs.core.atom.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'mass", "\ufdd0'position", "\ufdd0'velocity", "\ufdd0'force-generators"], {"\ufdd0'mass":5, "\ufdd0'position":cljs.core.PersistentVector.fromArray([2, 2]), "\ufdd0'velocity":cljs.core.PersistentVector.fromArray([0, 0]), "\ufdd0'force-generators":cljs.core.PersistentVector.fromArray([showoff.showoff.drag_force_generator.call(null, 2), showoff.core.ground_friction_generator.call(null, showoff.core._STAR_current_map_STAR_, 
function() {
  return showoff.showoff.to_rect.call(null, showoff.core._STAR_guy_STAR_)
}, 30), showoff.showoff.gravity_force_generator.call(null, 16), showoff.core.guy_extra_forces, showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.LEFT, cljs.core.PersistentVector.fromArray([-showoff.core._PLUS_guy_speed_PLUS_, 0])), showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.RIGHT, cljs.core.PersistentVector.fromArray([showoff.core._PLUS_guy_speed_PLUS_, 0])), showoff.core.jump_velocity_generator.call(null, showoff.core._STAR_current_map_STAR_, 
function() {
  return showoff.showoff.to_rect.call(null, showoff.core._STAR_guy_STAR_)
}, 400, 0.5)])})));
showoff.core.guy_particle = function guy_particle() {
  return cljs.core.deref.call(null, "\ufdd0'particle".call(null, showoff.core._STAR_guy_STAR_))
};
showoff.core._PLUS_viewport_spring_constant_PLUS_ = 50;
showoff.core._PLUS_viewport_drag_coefficient_PLUS_ = 3;
showoff.core._PLUS_viewport_max_displacement_PLUS_ = 2;
showoff.core.Viewport = function(dims, particle, __meta, __extmap) {
  this.dims = dims;
  this.particle = particle;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 2) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
showoff.core.Viewport.prototype.cljs$core$IHash$ = true;
showoff.core.Viewport.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1605509 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
showoff.core.Viewport.prototype.cljs$core$ILookup$ = true;
showoff.core.Viewport.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605538 = null;
  var G__1605538__1605539 = function(this__388__auto__, k__389__auto__) {
    var this__1605510 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605538__1605540 = function(this__390__auto__, k1605507, else__391__auto__) {
    var this__1605511 = this;
    if(cljs.core.truth_(k1605507 === "\ufdd0'dims")) {
      return this__1605511.dims
    }else {
      if(cljs.core.truth_(k1605507 === "\ufdd0'particle")) {
        return this__1605511.particle
      }else {
        if(cljs.core.truth_("\ufdd0'else")) {
          return cljs.core.get.call(null, this__1605511.__extmap, k1605507, else__391__auto__)
        }else {
          return null
        }
      }
    }
  };
  G__1605538 = function(this__390__auto__, k1605507, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605538__1605539.call(this, this__390__auto__, k1605507);
      case 3:
        return G__1605538__1605540.call(this, this__390__auto__, k1605507, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605538
}();
showoff.core.Viewport.prototype.cljs$core$IAssociative$ = true;
showoff.core.Viewport.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1605506) {
  var this__1605512 = this;
  var pred__1605513__1605516 = cljs.core.identical_QMARK_;
  var expr__1605514__1605517 = k__396__auto__;
  if(cljs.core.truth_(pred__1605513__1605516.call(null, "\ufdd0'dims", expr__1605514__1605517))) {
    return new showoff.core.Viewport(G__1605506, this__1605512.particle, this__1605512.__meta, this__1605512.__extmap)
  }else {
    if(cljs.core.truth_(pred__1605513__1605516.call(null, "\ufdd0'particle", expr__1605514__1605517))) {
      return new showoff.core.Viewport(this__1605512.dims, G__1605506, this__1605512.__meta, this__1605512.__extmap)
    }else {
      return new showoff.core.Viewport(this__1605512.dims, this__1605512.particle, this__1605512.__meta, cljs.core.assoc.call(null, this__1605512.__extmap, k__396__auto__, G__1605506))
    }
  }
};
showoff.core.Viewport.prototype.showoff$showoff$Tickable$ = true;
showoff.core.Viewport.prototype.showoff$showoff$Tickable$tick = function(vp) {
  var this__1605518 = this;
  return cljs.core.reset_BANG_.call(null, this__1605518.particle, showoff.showoff.integrate_particle.call(null, cljs.core.deref.call(null, this__1605518.particle)))
};
showoff.core.Viewport.prototype.showoff$showoff$Rectable$ = true;
showoff.core.Viewport.prototype.showoff$showoff$Rectable$to_rect = function(vp) {
  var this__1605519 = this;
  var vec__1605520__1605522 = this__1605519.dims;
  var w__1605523 = cljs.core.nth.call(null, vec__1605520__1605522, 0, null);
  var h__1605524 = cljs.core.nth.call(null, vec__1605520__1605522, 1, null);
  var vec__1605521__1605525 = "\ufdd0'position".call(null, cljs.core.deref.call(null, this__1605519.particle));
  var x__1605526 = cljs.core.nth.call(null, vec__1605521__1605525, 0, null);
  var y__1605527 = cljs.core.nth.call(null, vec__1605521__1605525, 1, null);
  return cljs.core.PersistentVector.fromArray([x__1605526, y__1605527, w__1605523, h__1605524])
};
showoff.core.Viewport.prototype.cljs$core$IRecord$ = true;
showoff.core.Viewport.prototype.cljs$core$ICollection$ = true;
showoff.core.Viewport.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1605528 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
showoff.core.Viewport.prototype.cljs$core$ISeqable$ = true;
showoff.core.Viewport.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605529 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'dims", this__1605529.dims), cljs.core.vector.call(null, "\ufdd0'particle", this__1605529.particle)]), this__1605529.__extmap))
};
showoff.core.Viewport.prototype.cljs$core$IPrintable$ = true;
showoff.core.Viewport.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605530 = this;
  var pr_pair__404__auto____1605531 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605531, cljs.core.str.call(null, "#", "showoff.core.Viewport", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'dims", this__1605530.dims), cljs.core.vector.call(null, "\ufdd0'particle", this__1605530.particle)]), this__1605530.__extmap))
};
showoff.core.Viewport.prototype.cljs$core$ICounted$ = true;
showoff.core.Viewport.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605532 = this;
  return 2 + cljs.core.count.call(null, this__1605532.__extmap)
};
showoff.core.Viewport.prototype.cljs$core$IEquiv$ = true;
showoff.core.Viewport.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605533 = this;
  var and__3546__auto____1605534 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605534)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605534
  }
};
showoff.core.Viewport.prototype.cljs$core$IWithMeta$ = true;
showoff.core.Viewport.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1605506) {
  var this__1605535 = this;
  return new showoff.core.Viewport(this__1605535.dims, this__1605535.particle, G__1605506, this__1605535.__extmap)
};
showoff.core.Viewport.prototype.cljs$core$IMeta$ = true;
showoff.core.Viewport.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605536 = this;
  return this__1605536.__meta
};
showoff.core.Viewport.prototype.cljs$core$IMap$ = true;
showoff.core.Viewport.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605537 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'dims", "\ufdd0'particle"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605537.__meta), k__398__auto__)
  }else {
    return new showoff.core.Viewport(this__1605537.dims, this__1605537.particle, this__1605537.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605537.__extmap, k__398__auto__)))
  }
};
showoff.core.Viewport.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "showoff.core.Viewport")
};
showoff.core.__GT_Viewport = function __GT_Viewport(dims, particle) {
  return new showoff.core.Viewport(dims, particle)
};
showoff.core.map__GT_Viewport = function map__GT_Viewport(G__1605508) {
  return new showoff.core.Viewport("\ufdd0'dims".call(null, G__1605508), "\ufdd0'particle".call(null, G__1605508), null, cljs.core.dissoc.call(null, G__1605508, "\ufdd0'dims", "\ufdd0'particle"))
};
showoff.core.Viewport;
showoff.core._STAR_viewport_STAR_ = new showoff.core.Viewport(cljs.core.PersistentVector.fromArray([16, 10]), cljs.core.atom.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'mass", "\ufdd0'position", "\ufdd0'velocity", "\ufdd0'force-generators"], {"\ufdd0'mass":1, "\ufdd0'position":cljs.core.PersistentVector.fromArray([0, 0]), "\ufdd0'velocity":cljs.core.PersistentVector.fromArray([0, 0]), "\ufdd0'force-generators":cljs.core.PersistentVector.fromArray([function(p) {
  return showoff.showoff.spring_force.call(null, showoff.showoff.vec_sub.call(null, "\ufdd0'position".call(null, showoff.core.guy_particle.call(null)), showoff.showoff.vec_sub.call(null, showoff.showoff.rect_center.call(null, showoff.showoff.viewport_rect.call(null)), cljs.core.PersistentVector.fromArray([0, 1]))), showoff.core._PLUS_viewport_max_displacement_PLUS_, showoff.core._PLUS_viewport_spring_constant_PLUS_)
}, showoff.showoff.drag_force_generator.call(null, showoff.core._PLUS_viewport_drag_coefficient_PLUS_)])})));
showoff.core._STAR_font_chars_STAR_ = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"?!./';
showoff.core._STAR_default_font_STAR_ = null;
showoff.core.with_prepared_assets = function() {
  var with_prepared_assets__delegate = function(callback, p__1605542) {
    var map__1605543__1605544 = p__1605542;
    var map__1605543__1605545 = cljs.core.truth_(cljs.core.seq_QMARK_.call(null, map__1605543__1605544)) ? cljs.core.apply.call(null, cljs.core.hash_map, map__1605543__1605544) : map__1605543__1605544;
    var force_nocache__1605546 = cljs.core.get.call(null, map__1605543__1605545, "\ufdd0'force-nocache");
    showoff.showoff.with_img.call(null, "hud/hud.png", function(hud) {
      return showoff.core._STAR_hud_sprite_STAR_ = showoff.showoff.resize_nearest_neighbor.call(null, hud, showoff.showoff._STAR_world_dims_STAR_)
    });
    showoff.showoff.with_loaded_font.call(null, "sprites/basic-font.gif", showoff.core._STAR_font_chars_STAR_, cljs.core.PersistentVector.fromArray([8, 8]), 2, showoff.showoff.color.call(null, cljs.core.PersistentVector.fromArray([196, 106, 59])), function(font) {
      return showoff.core._STAR_default_font_STAR_ = font
    });
    return showoff.showoff.with_img.call(null, cljs.core.truth_(force_nocache__1605546) ? cljs.core.str.call(null, "sprites/sheet.png?", Math.random.call(null)) : "sprites/sheet.png", function(sheet) {
      var dest_dims__1605547 = showoff.showoff._STAR_tile_in_world_dims_STAR_;
      showoff.core._STAR_guy_sprites_STAR_ = cljs.core.PersistentVector.fromArray([showoff.showoff.resize_nearest_neighbor.call(null, sheet, cljs.core.PersistentVector.fromArray([16, 0, 16, 16]), dest_dims__1605547), showoff.showoff.resize_nearest_neighbor.call(null, sheet, cljs.core.PersistentVector.fromArray([32, 0, 16, 16]), dest_dims__1605547)]);
      showoff.core._PLUS_map_symbols_PLUS_ = cljs.core.HashMap.fromArrays([cljs.core.PersistentVector.fromArray([255, 255, 255]), cljs.core.PersistentVector.fromArray([255, 0, 0]), cljs.core.PersistentVector.fromArray([255, 255, 0]), cljs.core.PersistentVector.fromArray([153, 153, 0]), cljs.core.PersistentVector.fromArray([0, 255, 0]), cljs.core.PersistentVector.fromArray([0, 102, 51]), cljs.core.PersistentVector.fromArray([153, 0, 0]), cljs.core.PersistentVector.fromArray([0, 0, 255])], [cljs.core.ObjMap.fromObject(["\ufdd0'kind"], 
      {"\ufdd0'kind":"\ufdd0'skip"}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable", "\ufdd0'shape"], {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, sheet, cljs.core.PersistentVector.fromArray([0, 16, 16, 16]), dest_dims__1605547), "\ufdd0'collidable":true, "\ufdd0'shape":"\ufdd0'rect"}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable", "\ufdd0'shape", "\ufdd0'slope", "\ufdd0'intercept", 
      "\ufdd0'top-filled"], {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, sheet, cljs.core.PersistentVector.fromArray([16, 16, 16, 16]), dest_dims__1605547), "\ufdd0'collidable":true, "\ufdd0'shape":"\ufdd0'right-triangle", "\ufdd0'slope":1, "\ufdd0'intercept":0, "\ufdd0'top-filled":false}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable", "\ufdd0'shape", "\ufdd0'slope", "\ufdd0'intercept", "\ufdd0'top-filled"], {"\ufdd0'kind":"\ufdd0'image", 
      "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, sheet, cljs.core.PersistentVector.fromArray([16, 32, 16, 16]), dest_dims__1605547), "\ufdd0'collidable":true, "\ufdd0'shape":"\ufdd0'right-triangle", "\ufdd0'slope":1, "\ufdd0'intercept":0, "\ufdd0'top-filled":false}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable", "\ufdd0'shape", "\ufdd0'slope", "\ufdd0'intercept", "\ufdd0'top-filled"], {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, 
      sheet, cljs.core.PersistentVector.fromArray([32, 16, 16, 16]), dest_dims__1605547), "\ufdd0'collidable":true, "\ufdd0'shape":"\ufdd0'right-triangle", "\ufdd0'slope":-1, "\ufdd0'intercept":1, "\ufdd0'top-filled":false}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable", "\ufdd0'shape", "\ufdd0'slope", "\ufdd0'intercept", "\ufdd0'top-filled"], {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, sheet, cljs.core.PersistentVector.fromArray([32, 
      32, 16, 16]), dest_dims__1605547), "\ufdd0'collidable":true, "\ufdd0'shape":"\ufdd0'right-triangle", "\ufdd0'slope":-1, "\ufdd0'intercept":1, "\ufdd0'top-filled":false}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable", "\ufdd0'shape"], {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, sheet, cljs.core.PersistentVector.fromArray([0, 32, 16, 16]), dest_dims__1605547), "\ufdd0'collidable":true, "\ufdd0'shape":"\ufdd0'rect"}), 
      cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'color"], {"\ufdd0'kind":"\ufdd0'rect", "\ufdd0'color":cljs.core.PersistentVector.fromArray([0, 0, 255])})]);
      return callback.call(null)
    })
  };
  var with_prepared_assets = function(callback, var_args) {
    var p__1605542 = null;
    if(goog.isDef(var_args)) {
      p__1605542 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1), 0)
    }
    return with_prepared_assets__delegate.call(this, callback, p__1605542)
  };
  with_prepared_assets.cljs$lang$maxFixedArity = 1;
  with_prepared_assets.cljs$lang$applyTo = function(arglist__1605548) {
    var callback = cljs.core.first(arglist__1605548);
    var p__1605542 = cljs.core.rest(arglist__1605548);
    return with_prepared_assets__delegate.call(this, callback, p__1605542)
  };
  return with_prepared_assets
}();
showoff.core.draw_hud = function draw_hud() {
  var vec__1605549__1605551 = showoff.showoff.img_dims.call(null, showoff.core._STAR_hud_sprite_STAR_);
  var w__1605552 = cljs.core.nth.call(null, vec__1605549__1605551, 0, null);
  var h__1605553 = cljs.core.nth.call(null, vec__1605549__1605551, 1, null);
  var vec__1605550__1605554 = showoff.showoff._STAR_world_dims_STAR_;
  var sw__1605555 = cljs.core.nth.call(null, vec__1605550__1605554, 0, null);
  var sh__1605556 = cljs.core.nth.call(null, vec__1605550__1605554, 1, null);
  return showoff.showoff.context.call(null).drawImage(showoff.core._STAR_hud_sprite_STAR_, 0, 0, w__1605552, h__1605553, 0, 0, sw__1605555, sh__1605556)
};
showoff.core.draw_guy_tile_test = function draw_guy_tile_test() {
  var ctx__1605557 = showoff.showoff.context.call(null);
  var G__1605558__1605559 = cljs.core.seq.call(null, showoff.showoff.rect__GT_idxs.call(null, showoff.core._STAR_current_map_STAR_, showoff.showoff.to_rect.call(null, showoff.core._STAR_guy_STAR_)));
  if(cljs.core.truth_(G__1605558__1605559)) {
    var idx__1605560 = cljs.core.first.call(null, G__1605558__1605559);
    var G__1605558__1605561 = G__1605558__1605559;
    while(true) {
      var xy__1605562 = showoff.showoff.idx__GT_coords.call(null, showoff.core._STAR_current_map_STAR_, idx__1605560);
      showoff.showoff.filled_rect.call(null, ctx__1605557, xy__1605562, cljs.core.PersistentVector.fromArray([1, 1]), showoff.showoff.color.call(null, cljs.core.PersistentVector.fromArray([255, 0, 255])));
      var temp__3698__auto____1605563 = cljs.core.next.call(null, G__1605558__1605561);
      if(cljs.core.truth_(temp__3698__auto____1605563)) {
        var G__1605558__1605564 = temp__3698__auto____1605563;
        var G__1605565 = cljs.core.first.call(null, G__1605558__1605564);
        var G__1605566 = G__1605558__1605564;
        idx__1605560 = G__1605565;
        G__1605558__1605561 = G__1605566;
        continue
      }else {
        return null
      }
      break
    }
  }else {
    return null
  }
};
showoff.core.draw_guy_collision_test = function draw_guy_collision_test() {
  var G__1605567__1605568 = cljs.core.seq.call(null, showoff.showoff.map_collisions.call(null, showoff.core._STAR_current_map_STAR_, showoff.showoff.to_rect.call(null, showoff.core._STAR_guy_STAR_)));
  if(cljs.core.truth_(G__1605567__1605568)) {
    var idx__1605569 = cljs.core.first.call(null, G__1605567__1605568);
    var G__1605567__1605570 = G__1605567__1605568;
    while(true) {
      showoff.showoff.filled_rect.call(null, showoff.showoff.context.call(null), showoff.showoff.idx__GT_coords.call(null, showoff.core._STAR_current_map_STAR_, idx__1605569), cljs.core.PersistentVector.fromArray([1, 1]), showoff.showoff.color.call(null, cljs.core.PersistentVector.fromArray([255, 0, 255])));
      var temp__3698__auto____1605571 = cljs.core.next.call(null, G__1605567__1605570);
      if(cljs.core.truth_(temp__3698__auto____1605571)) {
        var G__1605567__1605572 = temp__3698__auto____1605571;
        var G__1605573 = cljs.core.first.call(null, G__1605567__1605572);
        var G__1605574 = G__1605567__1605572;
        idx__1605569 = G__1605573;
        G__1605567__1605570 = G__1605574;
        continue
      }else {
        return null
      }
      break
    }
  }else {
    return null
  }
};
showoff.core.draw_world = function draw_world() {
  showoff.showoff.clear.call(null);
  showoff.showoff.draw_map.call(null, showoff.core._STAR_current_map_STAR_);
  showoff.showoff.draw_entities.call(null);
  showoff.core.draw_hud.call(null);
  return showoff.showoff.draw_text_centered.call(null, showoff.showoff.context.call(null), showoff.core._STAR_default_font_STAR_, showoff.showoff.stats_string.call(null), cljs.core.PersistentVector.fromArray([372, 438]))
};
showoff.core.request_animation = function() {
  var or__3548__auto____1605576 = window.requestAnimationFrame;
  if(cljs.core.truth_(or__3548__auto____1605576)) {
    return or__3548__auto____1605576
  }else {
    var or__3548__auto____1605577 = window.webkitRequestAnimationFrame;
    if(cljs.core.truth_(or__3548__auto____1605577)) {
      return or__3548__auto____1605577
    }else {
      var or__3548__auto____1605578 = window.mozRequestAnimationFrame;
      if(cljs.core.truth_(or__3548__auto____1605578)) {
        return or__3548__auto____1605578
      }else {
        var or__3548__auto____1605579 = window.oRequestAnimationFrame;
        if(cljs.core.truth_(or__3548__auto____1605579)) {
          return or__3548__auto____1605579
        }else {
          var or__3548__auto____1605580 = window.msRequestAnimationFrame;
          if(cljs.core.truth_(or__3548__auto____1605580)) {
            return or__3548__auto____1605580
          }else {
            return function(p1__1605575_SHARP_) {
              return window.setTimeout.call(null, p1__1605575_SHARP_, 1E3 / 60)
            }
          }
        }
      }
    }
  }
}();
showoff.core.until_false = function until_false(callback, timeout) {
  var step__1605581 = function() {
    if(cljs.core.truth_(callback.call(null))) {
      return until_false.call(null, callback, timeout)
    }else {
      return null
    }
  };
  if(cljs.core.truth_(timeout <= 0)) {
    return showoff.core.request_animation.call(null, step__1605581, showoff.showoff.display.call(null))
  }else {
    return goog.Timer.callOnce.call(null, step__1605581, timeout)
  }
};
showoff.core.main = function main() {
  goog.dom.setTextContent.call(null, showoff.core.content.call(null), "");
  var screen_dims__1605582 = cljs.core.PersistentVector.fromArray([640, 480]);
  var canvas__1605583 = showoff.showoff.make_canvas.call(null, screen_dims__1605582);
  var viewport_fn__1605584 = function() {
    return showoff.showoff.to_rect.call(null, showoff.core._STAR_viewport_STAR_)
  };
  showoff.showoff.set_display_and_viewport.call(null, canvas__1605583, screen_dims__1605582, viewport_fn__1605584);
  goog.dom.appendChild.call(null, showoff.core.content.call(null), canvas__1605583);
  showoff.core.prepare_input.call(null);
  return showoff.core.with_prepared_assets.call(null, function() {
    return showoff.showoff.with_img.call(null, "maps/test.gif", function(img) {
      showoff.core._STAR_current_map_STAR_ = showoff.showoff.load_map.call(null, img, showoff.core._PLUS_map_symbols_PLUS_);
      showoff.showoff.add_entity.call(null, showoff.core._STAR_current_map_STAR_, showoff.core._STAR_guy_STAR_);
      showoff.showoff.add_entity.call(null, showoff.core._STAR_current_map_STAR_, showoff.core._STAR_viewport_STAR_);
      return showoff.core.until_false.call(null, function() {
        return showoff.showoff.cycle_once.call(null, showoff.core.draw_world)
      }, 0)
    })
  })
};
goog.exportSymbol("showoff.core.main", showoff.core.main);
showoff.core.map_viewer = function map_viewer() {
  var screen_dims__1605585 = cljs.core.PersistentVector.fromArray([1024, 768]);
  var canvas__1605586 = showoff.showoff.make_canvas.call(null, screen_dims__1605585);
  var viewport_speed__1605587 = 0.5;
  var viewport__1605588 = new showoff.core.Viewport(cljs.core.PersistentVector.fromArray([64, 48]), cljs.core.atom.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'mass", "\ufdd0'position", "\ufdd0'velocity", "\ufdd0'offset-generators"], {"\ufdd0'mass":1, "\ufdd0'position":cljs.core.PersistentVector.fromArray([0, 0]), "\ufdd0'velocity":cljs.core.PersistentVector.fromArray([0, 0]), "\ufdd0'offset-generators":cljs.core.PersistentVector.fromArray([showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.LEFT, 
  cljs.core.PersistentVector.fromArray([-viewport_speed__1605587, 0])), showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.RIGHT, cljs.core.PersistentVector.fromArray([viewport_speed__1605587, 0])), showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.UP, cljs.core.PersistentVector.fromArray([0, -viewport_speed__1605587])), showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.DOWN, cljs.core.PersistentVector.fromArray([0, viewport_speed__1605587]))])})));
  goog.dom.appendChild.call(null, showoff.core.content.call(null), canvas__1605586);
  showoff.showoff.set_display_and_viewport.call(null, canvas__1605586, screen_dims__1605585, function() {
    return showoff.showoff.to_rect.call(null, viewport__1605588)
  });
  showoff.core.prepare_input.call(null);
  showoff.core.with_prepared_assets.call(null, function() {
    return showoff.showoff.with_img.call(null, "maps/test.gif", function(img) {
      showoff.core._STAR_current_map_STAR_ = showoff.showoff.load_map.call(null, img, showoff.core._PLUS_map_symbols_PLUS_);
      showoff.showoff.add_entity.call(null, showoff.core._STAR_current_map_STAR_, viewport__1605588);
      return showoff.core.until_false.call(null, function() {
        return showoff.showoff.cycle_once.call(null, function() {
          showoff.showoff.clear.call(null);
          return showoff.showoff.draw_map.call(null, showoff.core._STAR_current_map_STAR_)
        })
      }, 300)
    })
  });
  return goog.events.listen.call(null, showoff.core.by_id.call(null, "reload"), "click", function() {
    return showoff.core.with_prepared_assets.call(null, function() {
      return showoff.showoff.with_img.call(null, cljs.core.str.call(null, "maps/test.gif?", Math.random.call(null)), function(img) {
        return showoff.core._STAR_current_map_STAR_ = showoff.showoff.load_map.call(null, img, showoff.core._PLUS_map_symbols_PLUS_)
      })
    }, "\ufdd0'force-nocache", true)
  })
};
goog.exportSymbol("showoff.core.map_viewer", showoff.core.map_viewer);
goog.provide("ld23.core");
goog.require("cljs.core");
goog.require("showoff.core");
goog.require("showoff.showoff");
goog.require("goog.dom");
goog.require("goog.string");
goog.require("goog.events");
goog.require("goog.Timer");
goog.require("goog.events.KeyHandler");
goog.require("clojure.browser.event");
goog.require("clojure.browser.repl");
ld23.core._STAR_canvas_STAR_ = null;
ld23.core._STAR_current_map_STAR_ = cljs.core.atom.call(null, null);
ld23.core._STAR_symbols_STAR_ = null;
ld23.core._STAR_hud_font_STAR_ = null;
ld23.core._STAR_font_chars_STAR_ = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"?!./:$';
ld23.core._STAR_backdrop_STAR_ = showoff.showoff.get_img.call(null, cljs.core.str.call(null, "graphics/backdrop.png"));
ld23.core._STAR_player_sprite_STAR_ = null;
ld23.core._STAR_money_icon_STAR_ = null;
ld23.core._STAR_hud_STAR_ = null;
ld23.core._STAR_collectables_STAR_ = null;
ld23.core._STAR_bag_STAR_ = cljs.core.atom.call(null, cljs.core.PersistentVector.fromArray([]));
ld23.core._STAR_media_player_STAR_ = null;
ld23.core._STAR_keys_collected_STAR_ = cljs.core.atom.call(null, 0);
ld23.core._STAR_total_keys_STAR_ = cljs.core.atom.call(null, 0);
ld23.core._STAR_bricks_destroyed_STAR_ = cljs.core.atom.call(null, 0);
ld23.core.play_sound = function play_sound(key) {
  return ld23.core._STAR_media_player_STAR_.play(cljs.core.name.call(null, key))
};
ld23.core.Collectable = {};
ld23.core.collect = function collect(c) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1604927 = c;
    if(cljs.core.truth_(and__3546__auto____1604927)) {
      return c.ld23$core$Collectable$collect
    }else {
      return and__3546__auto____1604927
    }
  }())) {
    return c.ld23$core$Collectable$collect(c)
  }else {
    return function() {
      var or__3548__auto____1604928 = ld23.core.collect[goog.typeOf.call(null, c)];
      if(cljs.core.truth_(or__3548__auto____1604928)) {
        return or__3548__auto____1604928
      }else {
        var or__3548__auto____1604929 = ld23.core.collect["_"];
        if(cljs.core.truth_(or__3548__auto____1604929)) {
          return or__3548__auto____1604929
        }else {
          throw cljs.core.missing_protocol.call(null, "Collectable.collect", c);
        }
      }
    }().call(null, c)
  }
};
ld23.core.Useable = {};
ld23.core.use_thing = function use_thing(obj, user) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1604930 = obj;
    if(cljs.core.truth_(and__3546__auto____1604930)) {
      return obj.ld23$core$Useable$use_thing
    }else {
      return and__3546__auto____1604930
    }
  }())) {
    return obj.ld23$core$Useable$use_thing(obj, user)
  }else {
    return function() {
      var or__3548__auto____1604931 = ld23.core.use_thing[goog.typeOf.call(null, obj)];
      if(cljs.core.truth_(or__3548__auto____1604931)) {
        return or__3548__auto____1604931
      }else {
        var or__3548__auto____1604932 = ld23.core.use_thing["_"];
        if(cljs.core.truth_(or__3548__auto____1604932)) {
          return or__3548__auto____1604932
        }else {
          throw cljs.core.missing_protocol.call(null, "Useable.use-thing", obj);
        }
      }
    }().call(null, obj, user)
  }
};
ld23.core.Iconic = {};
ld23.core.icon = function icon(obj) {
  if(cljs.core.truth_(function() {
    var and__3546__auto____1604933 = obj;
    if(cljs.core.truth_(and__3546__auto____1604933)) {
      return obj.ld23$core$Iconic$icon
    }else {
      return and__3546__auto____1604933
    }
  }())) {
    return obj.ld23$core$Iconic$icon(obj)
  }else {
    return function() {
      var or__3548__auto____1604934 = ld23.core.icon[goog.typeOf.call(null, obj)];
      if(cljs.core.truth_(or__3548__auto____1604934)) {
        return or__3548__auto____1604934
      }else {
        var or__3548__auto____1604935 = ld23.core.icon["_"];
        if(cljs.core.truth_(or__3548__auto____1604935)) {
          return or__3548__auto____1604935
        }else {
          throw cljs.core.missing_protocol.call(null, "Iconic.icon", obj);
        }
      }
    }().call(null, obj)
  }
};
ld23.core.posrec__GT_rect = function posrec__GT_rect(position, rec) {
  var vec__1604936__1604938 = position;
  var px__1604939 = cljs.core.nth.call(null, vec__1604936__1604938, 0, null);
  var py__1604940 = cljs.core.nth.call(null, vec__1604936__1604938, 1, null);
  var vec__1604937__1604941 = "\ufdd0'dims".call(null, rec);
  var w__1604942 = cljs.core.nth.call(null, vec__1604937__1604941, 0, null);
  var h__1604943 = cljs.core.nth.call(null, vec__1604937__1604941, 1, null);
  return cljs.core.PersistentVector.fromArray([px__1604939, py__1604940, w__1604942, h__1604943])
};
ld23.core.cooldown_tick = function cooldown_tick(obj) {
  var cooldown__1604945 = function() {
    var or__3548__auto____1604944 = "\ufdd0'cooldown".call(null, cljs.core.deref.call(null, obj));
    if(cljs.core.truth_(or__3548__auto____1604944)) {
      return or__3548__auto____1604944
    }else {
      return 0
    }
  }();
  return cljs.core.swap_BANG_.call(null, obj, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'cooldown"], {"\ufdd0'cooldown":cooldown__1604945 - showoff.showoff._PLUS_secs_per_tick_PLUS_}))
};
ld23.core.is_cool_QMARK_ = function is_cool_QMARK_(obj) {
  return function() {
    var or__3548__auto____1604946 = "\ufdd0'cooldown".call(null, cljs.core.deref.call(null, obj));
    if(cljs.core.truth_(or__3548__auto____1604946)) {
      return or__3548__auto____1604946
    }else {
      return 0
    }
  }() <= 0
};
ld23.core.cooldown_start = function cooldown_start(obj, max_cooldown) {
  return cljs.core.swap_BANG_.call(null, obj, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'cooldown"], {"\ufdd0'cooldown":max_cooldown}))
};
ld23.core.StaticCollectable = function(position, rec, __meta, __extmap) {
  this.position = position;
  this.rec = rec;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 2) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
ld23.core.StaticCollectable.prototype.showoff$showoff$Drawable$ = true;
ld23.core.StaticCollectable.prototype.showoff$showoff$Drawable$draw = function(c, ctx) {
  var this__1604950 = this;
  return showoff.showoff.draw_sprite.call(null, ctx, "\ufdd0'image".call(null, this__1604950.rec), this__1604950.position)
};
ld23.core.StaticCollectable.prototype.cljs$core$IHash$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1604951 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
ld23.core.StaticCollectable.prototype.cljs$core$ILookup$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1604972 = null;
  var G__1604972__1604973 = function(this__388__auto__, k__389__auto__) {
    var this__1604952 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1604972__1604974 = function(this__390__auto__, k1604948, else__391__auto__) {
    var this__1604953 = this;
    if(cljs.core.truth_(k1604948 === "\ufdd0'position")) {
      return this__1604953.position
    }else {
      if(cljs.core.truth_(k1604948 === "\ufdd0'rec")) {
        return this__1604953.rec
      }else {
        if(cljs.core.truth_("\ufdd0'else")) {
          return cljs.core.get.call(null, this__1604953.__extmap, k1604948, else__391__auto__)
        }else {
          return null
        }
      }
    }
  };
  G__1604972 = function(this__390__auto__, k1604948, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1604972__1604973.call(this, this__390__auto__, k1604948);
      case 3:
        return G__1604972__1604974.call(this, this__390__auto__, k1604948, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1604972
}();
ld23.core.StaticCollectable.prototype.cljs$core$IAssociative$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1604947) {
  var this__1604954 = this;
  var pred__1604955__1604958 = cljs.core.identical_QMARK_;
  var expr__1604956__1604959 = k__396__auto__;
  if(cljs.core.truth_(pred__1604955__1604958.call(null, "\ufdd0'position", expr__1604956__1604959))) {
    return new ld23.core.StaticCollectable(G__1604947, this__1604954.rec, this__1604954.__meta, this__1604954.__extmap)
  }else {
    if(cljs.core.truth_(pred__1604955__1604958.call(null, "\ufdd0'rec", expr__1604956__1604959))) {
      return new ld23.core.StaticCollectable(this__1604954.position, G__1604947, this__1604954.__meta, this__1604954.__extmap)
    }else {
      return new ld23.core.StaticCollectable(this__1604954.position, this__1604954.rec, this__1604954.__meta, cljs.core.assoc.call(null, this__1604954.__extmap, k__396__auto__, G__1604947))
    }
  }
};
ld23.core.StaticCollectable.prototype.showoff$showoff$Rectable$ = true;
ld23.core.StaticCollectable.prototype.showoff$showoff$Rectable$to_rect = function(c) {
  var this__1604960 = this;
  return ld23.core.posrec__GT_rect.call(null, this__1604960.position, this__1604960.rec)
};
ld23.core.StaticCollectable.prototype.cljs$core$IRecord$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$ICollection$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1604961 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
ld23.core.StaticCollectable.prototype.cljs$core$ISeqable$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1604962 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'position", this__1604962.position), cljs.core.vector.call(null, "\ufdd0'rec", this__1604962.rec)]), this__1604962.__extmap))
};
ld23.core.StaticCollectable.prototype.ld23$core$Collectable$ = true;
ld23.core.StaticCollectable.prototype.ld23$core$Collectable$collect = function(c) {
  var this__1604963 = this;
  cljs.core.swap_BANG_.call(null, ld23.core._STAR_keys_collected_STAR_, cljs.core.inc);
  return showoff.showoff.remove_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), c)
};
ld23.core.StaticCollectable.prototype.cljs$core$IPrintable$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1604964 = this;
  var pr_pair__404__auto____1604965 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1604965, cljs.core.str.call(null, "#", "ld23.core.StaticCollectable", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'position", this__1604964.position), cljs.core.vector.call(null, "\ufdd0'rec", this__1604964.rec)]), this__1604964.__extmap))
};
ld23.core.StaticCollectable.prototype.cljs$core$ICounted$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1604966 = this;
  return 2 + cljs.core.count.call(null, this__1604966.__extmap)
};
ld23.core.StaticCollectable.prototype.cljs$core$IEquiv$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1604967 = this;
  var and__3546__auto____1604968 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1604968)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1604968
  }
};
ld23.core.StaticCollectable.prototype.cljs$core$IWithMeta$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1604947) {
  var this__1604969 = this;
  return new ld23.core.StaticCollectable(this__1604969.position, this__1604969.rec, G__1604947, this__1604969.__extmap)
};
ld23.core.StaticCollectable.prototype.cljs$core$IMeta$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1604970 = this;
  return this__1604970.__meta
};
ld23.core.StaticCollectable.prototype.cljs$core$IMap$ = true;
ld23.core.StaticCollectable.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1604971 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'position", "\ufdd0'rec"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1604971.__meta), k__398__auto__)
  }else {
    return new ld23.core.StaticCollectable(this__1604971.position, this__1604971.rec, this__1604971.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1604971.__extmap, k__398__auto__)))
  }
};
ld23.core.StaticCollectable.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "ld23.core.StaticCollectable")
};
ld23.core.__GT_StaticCollectable = function __GT_StaticCollectable(position, rec) {
  return new ld23.core.StaticCollectable(position, rec)
};
ld23.core.map__GT_StaticCollectable = function map__GT_StaticCollectable(G__1604949) {
  return new ld23.core.StaticCollectable("\ufdd0'position".call(null, G__1604949), "\ufdd0'rec".call(null, G__1604949), null, cljs.core.dissoc.call(null, G__1604949, "\ufdd0'position", "\ufdd0'rec"))
};
ld23.core.StaticCollectable;
ld23.core.dir_offset = cljs.core.ObjMap.fromObject(["\ufdd0'left", "\ufdd0'right", "\ufdd0'above", "\ufdd0'below"], {"\ufdd0'left":cljs.core.PersistentVector.fromArray([-1, 0]), "\ufdd0'right":cljs.core.PersistentVector.fromArray([1, 0]), "\ufdd0'above":cljs.core.PersistentVector.fromArray([0, -1]), "\ufdd0'below":cljs.core.PersistentVector.fromArray([0, 1])});
ld23.core.kind_towards_QMARK_ = function kind_towards_QMARK_(rect, dir, kind) {
  var center__1604976 = showoff.showoff.rect_center.call(null, rect);
  var test_point__1604977 = showoff.showoff.vec_add.call(null, center__1604976, ld23.core.dir_offset.call(null, dir));
  var idx__1604978 = showoff.showoff.coords__GT_idx.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), test_point__1604977);
  var rec__1604979 = showoff.showoff.get_map_idx.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), idx__1604978);
  if(cljs.core.truth_(kind.call(null, rec__1604979))) {
    return idx__1604978
  }else {
    return null
  }
};
ld23.core.breakable_underneath_QMARK_ = function breakable_underneath_QMARK_(rect) {
  return ld23.core.kind_towards_QMARK_.call(null, rect, "\ufdd0'below", "\ufdd0'breakable")
};
ld23.core.Bag = function(contents, __meta, __extmap) {
  this.contents = contents;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 1) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
ld23.core.Bag.prototype.cljs$core$IHash$ = true;
ld23.core.Bag.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1604983 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
ld23.core.Bag.prototype.cljs$core$ILookup$ = true;
ld23.core.Bag.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605009 = null;
  var G__1605009__1605010 = function(this__388__auto__, k__389__auto__) {
    var this__1604984 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605009__1605011 = function(this__390__auto__, k1604981, else__391__auto__) {
    var this__1604985 = this;
    if(cljs.core.truth_(k1604981 === "\ufdd0'contents")) {
      return this__1604985.contents
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        return cljs.core.get.call(null, this__1604985.__extmap, k1604981, else__391__auto__)
      }else {
        return null
      }
    }
  };
  G__1605009 = function(this__390__auto__, k1604981, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605009__1605010.call(this, this__390__auto__, k1604981);
      case 3:
        return G__1605009__1605011.call(this, this__390__auto__, k1604981, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605009
}();
ld23.core.Bag.prototype.cljs$core$IAssociative$ = true;
ld23.core.Bag.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1604980) {
  var this__1604986 = this;
  var pred__1604987__1604990 = cljs.core.identical_QMARK_;
  var expr__1604988__1604991 = k__396__auto__;
  if(cljs.core.truth_(pred__1604987__1604990.call(null, "\ufdd0'contents", expr__1604988__1604991))) {
    return new ld23.core.Bag(G__1604980, this__1604986.__meta, this__1604986.__extmap)
  }else {
    return new ld23.core.Bag(this__1604986.contents, this__1604986.__meta, cljs.core.assoc.call(null, this__1604986.__extmap, k__396__auto__, G__1604980))
  }
};
ld23.core.Bag.prototype.showoff$showoff$Tickable$ = true;
ld23.core.Bag.prototype.showoff$showoff$Tickable$tick = function(b) {
  var this__1604992 = this;
  var G__1604993__1604994 = cljs.core.seq.call(null, cljs.core.deref.call(null, this__1604992.contents));
  if(cljs.core.truth_(G__1604993__1604994)) {
    var item__1604995 = cljs.core.first.call(null, G__1604993__1604994);
    var G__1604993__1604996 = G__1604993__1604994;
    while(true) {
      showoff.showoff.tick.call(null, item__1604995);
      var temp__3698__auto____1604997 = cljs.core.next.call(null, G__1604993__1604996);
      if(cljs.core.truth_(temp__3698__auto____1604997)) {
        var G__1604993__1604998 = temp__3698__auto____1604997;
        var G__1605013 = cljs.core.first.call(null, G__1604993__1604998);
        var G__1605014 = G__1604993__1604998;
        item__1604995 = G__1605013;
        G__1604993__1604996 = G__1605014;
        continue
      }else {
        return null
      }
      break
    }
  }else {
    return null
  }
};
ld23.core.Bag.prototype.cljs$core$IRecord$ = true;
ld23.core.Bag.prototype.cljs$core$ICollection$ = true;
ld23.core.Bag.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1604999 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
ld23.core.Bag.prototype.cljs$core$ISeqable$ = true;
ld23.core.Bag.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605000 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'contents", this__1605000.contents)]), this__1605000.__extmap))
};
ld23.core.Bag.prototype.cljs$core$IPrintable$ = true;
ld23.core.Bag.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605001 = this;
  var pr_pair__404__auto____1605002 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605002, cljs.core.str.call(null, "#", "ld23.core.Bag", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'contents", this__1605001.contents)]), this__1605001.__extmap))
};
ld23.core.Bag.prototype.cljs$core$ICounted$ = true;
ld23.core.Bag.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605003 = this;
  return 1 + cljs.core.count.call(null, this__1605003.__extmap)
};
ld23.core.Bag.prototype.cljs$core$IEquiv$ = true;
ld23.core.Bag.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605004 = this;
  var and__3546__auto____1605005 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605005)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605005
  }
};
ld23.core.Bag.prototype.cljs$core$IWithMeta$ = true;
ld23.core.Bag.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1604980) {
  var this__1605006 = this;
  return new ld23.core.Bag(this__1605006.contents, G__1604980, this__1605006.__extmap)
};
ld23.core.Bag.prototype.cljs$core$IMeta$ = true;
ld23.core.Bag.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605007 = this;
  return this__1605007.__meta
};
ld23.core.Bag.prototype.cljs$core$IMap$ = true;
ld23.core.Bag.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605008 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'contents"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605008.__meta), k__398__auto__)
  }else {
    return new ld23.core.Bag(this__1605008.contents, this__1605008.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605008.__extmap, k__398__auto__)))
  }
};
ld23.core.Bag.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "ld23.core.Bag")
};
ld23.core.__GT_Bag = function __GT_Bag(contents) {
  return new ld23.core.Bag(contents)
};
ld23.core.map__GT_Bag = function map__GT_Bag(G__1604982) {
  return new ld23.core.Bag("\ufdd0'contents".call(null, G__1604982), null, cljs.core.dissoc.call(null, G__1604982, "\ufdd0'contents"))
};
ld23.core.Bag;
ld23.core.add_to_bag = function add_to_bag(item) {
  return cljs.core.swap_BANG_.call(null, ld23.core._STAR_bag_STAR_, cljs.core.conj, item)
};
ld23.core.remove_from_bag = function remove_from_bag(item) {
  return cljs.core.reset_BANG_.call(null, ld23.core._STAR_bag_STAR_, cljs.core.into.call(null, cljs.core.PersistentVector.fromArray([]), cljs.core.filter.call(null, function(p1__1605015_SHARP_) {
    return cljs.core.not.call(null, cljs.core._EQ_.call(null, item, p1__1605015_SHARP_))
  }, cljs.core.deref.call(null, ld23.core._STAR_bag_STAR_))))
};
ld23.core.empty_bag = function empty_bag() {
  return cljs.core.reset_BANG_.call(null, ld23.core._STAR_bag_STAR_, cljs.core.PersistentVector.fromArray([]))
};
ld23.core.take_brick = function take_brick(idx) {
  var rec__1605016 = showoff.showoff.get_map_idx.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), idx);
  showoff.showoff.set_map_idx.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), idx, cljs.core.ObjMap.fromObject(["\ufdd0'kind"], {"\ufdd0'kind":"\ufdd0'skip"}));
  if(cljs.core.truth_(cljs.core.not.call(null, "\ufdd0'used".call(null, rec__1605016)))) {
    cljs.core.swap_BANG_.call(null, ld23.core._STAR_bricks_destroyed_STAR_, cljs.core.inc)
  }else {
  }
  return rec__1605016
};
ld23.core.Jackhammer = function(position, rec, max_cooldown, state, __meta, __extmap) {
  this.position = position;
  this.rec = rec;
  this.max_cooldown = max_cooldown;
  this.state = state;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 4) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
ld23.core.Jackhammer.prototype.showoff$showoff$Drawable$ = true;
ld23.core.Jackhammer.prototype.showoff$showoff$Drawable$draw = function(c, ctx) {
  var this__1605020 = this;
  return showoff.showoff.draw_sprite.call(null, ctx, "\ufdd0'image".call(null, this__1605020.rec), this__1605020.position)
};
ld23.core.Jackhammer.prototype.cljs$core$IHash$ = true;
ld23.core.Jackhammer.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1605021 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
ld23.core.Jackhammer.prototype.cljs$core$ILookup$ = true;
ld23.core.Jackhammer.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605047 = null;
  var G__1605047__1605048 = function(this__388__auto__, k__389__auto__) {
    var this__1605022 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605047__1605049 = function(this__390__auto__, k1605018, else__391__auto__) {
    var this__1605023 = this;
    if(cljs.core.truth_(k1605018 === "\ufdd0'position")) {
      return this__1605023.position
    }else {
      if(cljs.core.truth_(k1605018 === "\ufdd0'rec")) {
        return this__1605023.rec
      }else {
        if(cljs.core.truth_(k1605018 === "\ufdd0'max-cooldown")) {
          return this__1605023.max_cooldown
        }else {
          if(cljs.core.truth_(k1605018 === "\ufdd0'state")) {
            return this__1605023.state
          }else {
            if(cljs.core.truth_("\ufdd0'else")) {
              return cljs.core.get.call(null, this__1605023.__extmap, k1605018, else__391__auto__)
            }else {
              return null
            }
          }
        }
      }
    }
  };
  G__1605047 = function(this__390__auto__, k1605018, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605047__1605048.call(this, this__390__auto__, k1605018);
      case 3:
        return G__1605047__1605049.call(this, this__390__auto__, k1605018, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605047
}();
ld23.core.Jackhammer.prototype.cljs$core$IAssociative$ = true;
ld23.core.Jackhammer.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1605017) {
  var this__1605024 = this;
  var pred__1605025__1605028 = cljs.core.identical_QMARK_;
  var expr__1605026__1605029 = k__396__auto__;
  if(cljs.core.truth_(pred__1605025__1605028.call(null, "\ufdd0'position", expr__1605026__1605029))) {
    return new ld23.core.Jackhammer(G__1605017, this__1605024.rec, this__1605024.max_cooldown, this__1605024.state, this__1605024.__meta, this__1605024.__extmap)
  }else {
    if(cljs.core.truth_(pred__1605025__1605028.call(null, "\ufdd0'rec", expr__1605026__1605029))) {
      return new ld23.core.Jackhammer(this__1605024.position, G__1605017, this__1605024.max_cooldown, this__1605024.state, this__1605024.__meta, this__1605024.__extmap)
    }else {
      if(cljs.core.truth_(pred__1605025__1605028.call(null, "\ufdd0'max-cooldown", expr__1605026__1605029))) {
        return new ld23.core.Jackhammer(this__1605024.position, this__1605024.rec, G__1605017, this__1605024.state, this__1605024.__meta, this__1605024.__extmap)
      }else {
        if(cljs.core.truth_(pred__1605025__1605028.call(null, "\ufdd0'state", expr__1605026__1605029))) {
          return new ld23.core.Jackhammer(this__1605024.position, this__1605024.rec, this__1605024.max_cooldown, G__1605017, this__1605024.__meta, this__1605024.__extmap)
        }else {
          return new ld23.core.Jackhammer(this__1605024.position, this__1605024.rec, this__1605024.max_cooldown, this__1605024.state, this__1605024.__meta, cljs.core.assoc.call(null, this__1605024.__extmap, k__396__auto__, G__1605017))
        }
      }
    }
  }
};
ld23.core.Jackhammer.prototype.showoff$showoff$Tickable$ = true;
ld23.core.Jackhammer.prototype.showoff$showoff$Tickable$tick = function(c) {
  var this__1605030 = this;
  return ld23.core.cooldown_tick.call(null, this__1605030.state)
};
ld23.core.Jackhammer.prototype.ld23$core$Iconic$ = true;
ld23.core.Jackhammer.prototype.ld23$core$Iconic$icon = function(c) {
  var this__1605031 = this;
  return"\ufdd0'image".call(null, this__1605031.rec)
};
ld23.core.Jackhammer.prototype.ld23$core$Useable$ = true;
ld23.core.Jackhammer.prototype.ld23$core$Useable$use_thing = function(c, user) {
  var this__1605032 = this;
  if(cljs.core.truth_(ld23.core.is_cool_QMARK_.call(null, this__1605032.state))) {
    var temp__3695__auto____1605033 = ld23.core.breakable_underneath_QMARK_.call(null, showoff.showoff.to_rect.call(null, user));
    if(cljs.core.truth_(temp__3695__auto____1605033)) {
      var idx__1605034 = temp__3695__auto____1605033;
      return showoff.showoff.add_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), ld23.core.add_collectable.call(null, "\ufdd0'rubble", showoff.showoff.idx__GT_coords.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), idx__1605034), ld23.core.take_brick.call(null, idx__1605034)))
    }else {
      return ld23.core.cooldown_start.call(null, this__1605032.state, this__1605032.max_cooldown)
    }
  }else {
    return null
  }
};
ld23.core.Jackhammer.prototype.showoff$showoff$Rectable$ = true;
ld23.core.Jackhammer.prototype.showoff$showoff$Rectable$to_rect = function(c) {
  var this__1605035 = this;
  return ld23.core.posrec__GT_rect.call(null, this__1605035.position, this__1605035.rec)
};
ld23.core.Jackhammer.prototype.cljs$core$IRecord$ = true;
ld23.core.Jackhammer.prototype.cljs$core$ICollection$ = true;
ld23.core.Jackhammer.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1605036 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
ld23.core.Jackhammer.prototype.cljs$core$ISeqable$ = true;
ld23.core.Jackhammer.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605037 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'position", this__1605037.position), cljs.core.vector.call(null, "\ufdd0'rec", this__1605037.rec), cljs.core.vector.call(null, "\ufdd0'max-cooldown", this__1605037.max_cooldown), cljs.core.vector.call(null, "\ufdd0'state", this__1605037.state)]), this__1605037.__extmap))
};
ld23.core.Jackhammer.prototype.ld23$core$Collectable$ = true;
ld23.core.Jackhammer.prototype.ld23$core$Collectable$collect = function(c) {
  var this__1605038 = this;
  showoff.showoff.remove_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), c);
  return ld23.core.add_to_bag.call(null, c)
};
ld23.core.Jackhammer.prototype.cljs$core$IPrintable$ = true;
ld23.core.Jackhammer.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605039 = this;
  var pr_pair__404__auto____1605040 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605040, cljs.core.str.call(null, "#", "ld23.core.Jackhammer", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'position", this__1605039.position), cljs.core.vector.call(null, "\ufdd0'rec", this__1605039.rec), cljs.core.vector.call(null, "\ufdd0'max-cooldown", this__1605039.max_cooldown), cljs.core.vector.call(null, "\ufdd0'state", this__1605039.state)]), 
  this__1605039.__extmap))
};
ld23.core.Jackhammer.prototype.cljs$core$ICounted$ = true;
ld23.core.Jackhammer.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605041 = this;
  return 4 + cljs.core.count.call(null, this__1605041.__extmap)
};
ld23.core.Jackhammer.prototype.cljs$core$IEquiv$ = true;
ld23.core.Jackhammer.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605042 = this;
  var and__3546__auto____1605043 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605043)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605043
  }
};
ld23.core.Jackhammer.prototype.cljs$core$IWithMeta$ = true;
ld23.core.Jackhammer.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1605017) {
  var this__1605044 = this;
  return new ld23.core.Jackhammer(this__1605044.position, this__1605044.rec, this__1605044.max_cooldown, this__1605044.state, G__1605017, this__1605044.__extmap)
};
ld23.core.Jackhammer.prototype.cljs$core$IMeta$ = true;
ld23.core.Jackhammer.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605046 = this;
  return this__1605046.__meta
};
ld23.core.Jackhammer.prototype.cljs$core$IMap$ = true;
ld23.core.Jackhammer.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605045 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'position", "\ufdd0'state", "\ufdd0'rec", "\ufdd0'max-cooldown"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605045.__meta), k__398__auto__)
  }else {
    return new ld23.core.Jackhammer(this__1605045.position, this__1605045.rec, this__1605045.max_cooldown, this__1605045.state, this__1605045.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605045.__extmap, k__398__auto__)))
  }
};
ld23.core.Jackhammer.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "ld23.core.Jackhammer")
};
ld23.core.__GT_Jackhammer = function __GT_Jackhammer(position, rec, max_cooldown, state) {
  return new ld23.core.Jackhammer(position, rec, max_cooldown, state)
};
ld23.core.map__GT_Jackhammer = function map__GT_Jackhammer(G__1605019) {
  return new ld23.core.Jackhammer("\ufdd0'position".call(null, G__1605019), "\ufdd0'rec".call(null, G__1605019), "\ufdd0'max-cooldown".call(null, G__1605019), "\ufdd0'state".call(null, G__1605019), null, cljs.core.dissoc.call(null, G__1605019, "\ufdd0'position", "\ufdd0'rec", "\ufdd0'max-cooldown", "\ufdd0'state"))
};
ld23.core.Jackhammer;
ld23.core.Blowtorch = function(position, rec, max_cooldown, state, __meta, __extmap) {
  this.position = position;
  this.rec = rec;
  this.max_cooldown = max_cooldown;
  this.state = state;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 4) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
ld23.core.Blowtorch.prototype.showoff$showoff$Drawable$ = true;
ld23.core.Blowtorch.prototype.showoff$showoff$Drawable$draw = function(c, ctx) {
  var this__1605054 = this;
  return showoff.showoff.draw_sprite.call(null, ctx, "\ufdd0'image".call(null, this__1605054.rec), this__1605054.position)
};
ld23.core.Blowtorch.prototype.cljs$core$IHash$ = true;
ld23.core.Blowtorch.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1605055 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
ld23.core.Blowtorch.prototype.cljs$core$ILookup$ = true;
ld23.core.Blowtorch.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605081 = null;
  var G__1605081__1605082 = function(this__388__auto__, k__389__auto__) {
    var this__1605056 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605081__1605083 = function(this__390__auto__, k1605052, else__391__auto__) {
    var this__1605057 = this;
    if(cljs.core.truth_(k1605052 === "\ufdd0'position")) {
      return this__1605057.position
    }else {
      if(cljs.core.truth_(k1605052 === "\ufdd0'rec")) {
        return this__1605057.rec
      }else {
        if(cljs.core.truth_(k1605052 === "\ufdd0'max-cooldown")) {
          return this__1605057.max_cooldown
        }else {
          if(cljs.core.truth_(k1605052 === "\ufdd0'state")) {
            return this__1605057.state
          }else {
            if(cljs.core.truth_("\ufdd0'else")) {
              return cljs.core.get.call(null, this__1605057.__extmap, k1605052, else__391__auto__)
            }else {
              return null
            }
          }
        }
      }
    }
  };
  G__1605081 = function(this__390__auto__, k1605052, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605081__1605082.call(this, this__390__auto__, k1605052);
      case 3:
        return G__1605081__1605083.call(this, this__390__auto__, k1605052, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605081
}();
ld23.core.Blowtorch.prototype.cljs$core$IAssociative$ = true;
ld23.core.Blowtorch.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1605051) {
  var this__1605058 = this;
  var pred__1605059__1605062 = cljs.core.identical_QMARK_;
  var expr__1605060__1605063 = k__396__auto__;
  if(cljs.core.truth_(pred__1605059__1605062.call(null, "\ufdd0'position", expr__1605060__1605063))) {
    return new ld23.core.Blowtorch(G__1605051, this__1605058.rec, this__1605058.max_cooldown, this__1605058.state, this__1605058.__meta, this__1605058.__extmap)
  }else {
    if(cljs.core.truth_(pred__1605059__1605062.call(null, "\ufdd0'rec", expr__1605060__1605063))) {
      return new ld23.core.Blowtorch(this__1605058.position, G__1605051, this__1605058.max_cooldown, this__1605058.state, this__1605058.__meta, this__1605058.__extmap)
    }else {
      if(cljs.core.truth_(pred__1605059__1605062.call(null, "\ufdd0'max-cooldown", expr__1605060__1605063))) {
        return new ld23.core.Blowtorch(this__1605058.position, this__1605058.rec, G__1605051, this__1605058.state, this__1605058.__meta, this__1605058.__extmap)
      }else {
        if(cljs.core.truth_(pred__1605059__1605062.call(null, "\ufdd0'state", expr__1605060__1605063))) {
          return new ld23.core.Blowtorch(this__1605058.position, this__1605058.rec, this__1605058.max_cooldown, G__1605051, this__1605058.__meta, this__1605058.__extmap)
        }else {
          return new ld23.core.Blowtorch(this__1605058.position, this__1605058.rec, this__1605058.max_cooldown, this__1605058.state, this__1605058.__meta, cljs.core.assoc.call(null, this__1605058.__extmap, k__396__auto__, G__1605051))
        }
      }
    }
  }
};
ld23.core.Blowtorch.prototype.showoff$showoff$Tickable$ = true;
ld23.core.Blowtorch.prototype.showoff$showoff$Tickable$tick = function(c) {
  var this__1605064 = this;
  return ld23.core.cooldown_tick.call(null, this__1605064.state)
};
ld23.core.Blowtorch.prototype.ld23$core$Iconic$ = true;
ld23.core.Blowtorch.prototype.ld23$core$Iconic$icon = function(c) {
  var this__1605065 = this;
  return"\ufdd0'image".call(null, this__1605065.rec)
};
ld23.core.Blowtorch.prototype.ld23$core$Useable$ = true;
ld23.core.Blowtorch.prototype.ld23$core$Useable$use_thing = function(c, user) {
  var this__1605066 = this;
  if(cljs.core.truth_(ld23.core.is_cool_QMARK_.call(null, this__1605066.state))) {
    var temp__3695__auto____1605067 = ld23.core.kind_towards_QMARK_.call(null, showoff.showoff.to_rect.call(null, user), "\ufdd0'direction".call(null, cljs.core.deref.call(null, "\ufdd0'particle".call(null, user))), "\ufdd0'breakable");
    if(cljs.core.truth_(temp__3695__auto____1605067)) {
      var idx__1605068 = temp__3695__auto____1605067;
      return showoff.showoff.add_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), ld23.core.add_collectable.call(null, "\ufdd0'rubble", showoff.showoff.idx__GT_coords.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), idx__1605068), ld23.core.take_brick.call(null, idx__1605068)))
    }else {
      return ld23.core.cooldown_start.call(null, this__1605066.state, this__1605066.max_cooldown)
    }
  }else {
    return null
  }
};
ld23.core.Blowtorch.prototype.showoff$showoff$Rectable$ = true;
ld23.core.Blowtorch.prototype.showoff$showoff$Rectable$to_rect = function(c) {
  var this__1605069 = this;
  return ld23.core.posrec__GT_rect.call(null, this__1605069.position, this__1605069.rec)
};
ld23.core.Blowtorch.prototype.cljs$core$IRecord$ = true;
ld23.core.Blowtorch.prototype.cljs$core$ICollection$ = true;
ld23.core.Blowtorch.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1605070 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
ld23.core.Blowtorch.prototype.cljs$core$ISeqable$ = true;
ld23.core.Blowtorch.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605071 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'position", this__1605071.position), cljs.core.vector.call(null, "\ufdd0'rec", this__1605071.rec), cljs.core.vector.call(null, "\ufdd0'max-cooldown", this__1605071.max_cooldown), cljs.core.vector.call(null, "\ufdd0'state", this__1605071.state)]), this__1605071.__extmap))
};
ld23.core.Blowtorch.prototype.ld23$core$Collectable$ = true;
ld23.core.Blowtorch.prototype.ld23$core$Collectable$collect = function(c) {
  var this__1605072 = this;
  showoff.showoff.remove_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), c);
  return ld23.core.add_to_bag.call(null, c)
};
ld23.core.Blowtorch.prototype.cljs$core$IPrintable$ = true;
ld23.core.Blowtorch.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605073 = this;
  var pr_pair__404__auto____1605074 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605074, cljs.core.str.call(null, "#", "ld23.core.Blowtorch", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'position", this__1605073.position), cljs.core.vector.call(null, "\ufdd0'rec", this__1605073.rec), cljs.core.vector.call(null, "\ufdd0'max-cooldown", this__1605073.max_cooldown), cljs.core.vector.call(null, "\ufdd0'state", this__1605073.state)]), 
  this__1605073.__extmap))
};
ld23.core.Blowtorch.prototype.cljs$core$ICounted$ = true;
ld23.core.Blowtorch.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605075 = this;
  return 4 + cljs.core.count.call(null, this__1605075.__extmap)
};
ld23.core.Blowtorch.prototype.cljs$core$IEquiv$ = true;
ld23.core.Blowtorch.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605076 = this;
  var and__3546__auto____1605077 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605077)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605077
  }
};
ld23.core.Blowtorch.prototype.cljs$core$IWithMeta$ = true;
ld23.core.Blowtorch.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1605051) {
  var this__1605078 = this;
  return new ld23.core.Blowtorch(this__1605078.position, this__1605078.rec, this__1605078.max_cooldown, this__1605078.state, G__1605051, this__1605078.__extmap)
};
ld23.core.Blowtorch.prototype.cljs$core$IMeta$ = true;
ld23.core.Blowtorch.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605080 = this;
  return this__1605080.__meta
};
ld23.core.Blowtorch.prototype.cljs$core$IMap$ = true;
ld23.core.Blowtorch.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605079 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'position", "\ufdd0'state", "\ufdd0'rec", "\ufdd0'max-cooldown"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605079.__meta), k__398__auto__)
  }else {
    return new ld23.core.Blowtorch(this__1605079.position, this__1605079.rec, this__1605079.max_cooldown, this__1605079.state, this__1605079.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605079.__extmap, k__398__auto__)))
  }
};
ld23.core.Blowtorch.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "ld23.core.Blowtorch")
};
ld23.core.__GT_Blowtorch = function __GT_Blowtorch(position, rec, max_cooldown, state) {
  return new ld23.core.Blowtorch(position, rec, max_cooldown, state)
};
ld23.core.map__GT_Blowtorch = function map__GT_Blowtorch(G__1605053) {
  return new ld23.core.Blowtorch("\ufdd0'position".call(null, G__1605053), "\ufdd0'rec".call(null, G__1605053), "\ufdd0'max-cooldown".call(null, G__1605053), "\ufdd0'state".call(null, G__1605053), null, cljs.core.dissoc.call(null, G__1605053, "\ufdd0'position", "\ufdd0'rec", "\ufdd0'max-cooldown", "\ufdd0'state"))
};
ld23.core.Blowtorch;
ld23.core.fillable_QMARK_ = function fillable_QMARK_(rec) {
  var player_idx__1605085 = showoff.showoff.coords__GT_idx.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), showoff.showoff.rect_center.call(null, showoff.showoff.to_rect.call(null, ld23.core._STAR_player_STAR_)));
  var rec_idx__1605086 = showoff.showoff.coords__GT_idx.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), "\ufdd0'coords".call(null, rec));
  var and__3546__auto____1605087 = cljs.core._EQ_.call(null, "\ufdd0'kind".call(null, rec), "\ufdd0'skip");
  if(cljs.core.truth_(and__3546__auto____1605087)) {
    return cljs.core.not.call(null, cljs.core._EQ_.call(null, player_idx__1605085, rec_idx__1605086))
  }else {
    return and__3546__auto____1605087
  }
};
ld23.core.ConsumableStack = function(kind, rec, contents, __meta, __extmap) {
  this.kind = kind;
  this.rec = rec;
  this.contents = contents;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 3) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
ld23.core.ConsumableStack.prototype.cljs$core$IHash$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1605092 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
ld23.core.ConsumableStack.prototype.cljs$core$ILookup$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605114 = null;
  var G__1605114__1605115 = function(this__388__auto__, k__389__auto__) {
    var this__1605093 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605114__1605116 = function(this__390__auto__, k1605090, else__391__auto__) {
    var this__1605094 = this;
    if(cljs.core.truth_(k1605090 === "\ufdd0'kind")) {
      return this__1605094.kind
    }else {
      if(cljs.core.truth_(k1605090 === "\ufdd0'rec")) {
        return this__1605094.rec
      }else {
        if(cljs.core.truth_(k1605090 === "\ufdd0'contents")) {
          return this__1605094.contents
        }else {
          if(cljs.core.truth_("\ufdd0'else")) {
            return cljs.core.get.call(null, this__1605094.__extmap, k1605090, else__391__auto__)
          }else {
            return null
          }
        }
      }
    }
  };
  G__1605114 = function(this__390__auto__, k1605090, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605114__1605115.call(this, this__390__auto__, k1605090);
      case 3:
        return G__1605114__1605116.call(this, this__390__auto__, k1605090, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605114
}();
ld23.core.ConsumableStack.prototype.cljs$core$IAssociative$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1605089) {
  var this__1605095 = this;
  var pred__1605096__1605099 = cljs.core.identical_QMARK_;
  var expr__1605097__1605100 = k__396__auto__;
  if(cljs.core.truth_(pred__1605096__1605099.call(null, "\ufdd0'kind", expr__1605097__1605100))) {
    return new ld23.core.ConsumableStack(G__1605089, this__1605095.rec, this__1605095.contents, this__1605095.__meta, this__1605095.__extmap)
  }else {
    if(cljs.core.truth_(pred__1605096__1605099.call(null, "\ufdd0'rec", expr__1605097__1605100))) {
      return new ld23.core.ConsumableStack(this__1605095.kind, G__1605089, this__1605095.contents, this__1605095.__meta, this__1605095.__extmap)
    }else {
      if(cljs.core.truth_(pred__1605096__1605099.call(null, "\ufdd0'contents", expr__1605097__1605100))) {
        return new ld23.core.ConsumableStack(this__1605095.kind, this__1605095.rec, G__1605089, this__1605095.__meta, this__1605095.__extmap)
      }else {
        return new ld23.core.ConsumableStack(this__1605095.kind, this__1605095.rec, this__1605095.contents, this__1605095.__meta, cljs.core.assoc.call(null, this__1605095.__extmap, k__396__auto__, G__1605089))
      }
    }
  }
};
ld23.core.ConsumableStack.prototype.ld23$core$Iconic$ = true;
ld23.core.ConsumableStack.prototype.ld23$core$Iconic$icon = function(c) {
  var this__1605101 = this;
  return"\ufdd0'image".call(null, this__1605101.rec)
};
ld23.core.ConsumableStack.prototype.ld23$core$Useable$ = true;
ld23.core.ConsumableStack.prototype.ld23$core$Useable$use_thing = function(c, user) {
  var this__1605102 = this;
  var item__1605103 = cljs.core.first.call(null, cljs.core.deref.call(null, this__1605102.contents));
  if(cljs.core.truth_(ld23.core.use_thing.call(null, item__1605103, user))) {
    cljs.core.swap_BANG_.call(null, this__1605102.contents, cljs.core.rest)
  }else {
  }
  if(cljs.core.truth_(cljs.core.empty_QMARK_.call(null, cljs.core.deref.call(null, this__1605102.contents)))) {
    return ld23.core.remove_from_bag.call(null, c)
  }else {
    return null
  }
};
ld23.core.ConsumableStack.prototype.cljs$core$IRecord$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$ICollection$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1605104 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
ld23.core.ConsumableStack.prototype.cljs$core$ISeqable$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605105 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'kind", this__1605105.kind), cljs.core.vector.call(null, "\ufdd0'rec", this__1605105.rec), cljs.core.vector.call(null, "\ufdd0'contents", this__1605105.contents)]), this__1605105.__extmap))
};
ld23.core.ConsumableStack.prototype.cljs$core$IPrintable$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605106 = this;
  var pr_pair__404__auto____1605107 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605107, cljs.core.str.call(null, "#", "ld23.core.ConsumableStack", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'kind", this__1605106.kind), cljs.core.vector.call(null, "\ufdd0'rec", this__1605106.rec), cljs.core.vector.call(null, "\ufdd0'contents", this__1605106.contents)]), this__1605106.__extmap))
};
ld23.core.ConsumableStack.prototype.cljs$core$ICounted$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605108 = this;
  return 3 + cljs.core.count.call(null, this__1605108.__extmap)
};
ld23.core.ConsumableStack.prototype.cljs$core$IEquiv$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605109 = this;
  var and__3546__auto____1605110 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605110)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605110
  }
};
ld23.core.ConsumableStack.prototype.cljs$core$IWithMeta$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1605089) {
  var this__1605111 = this;
  return new ld23.core.ConsumableStack(this__1605111.kind, this__1605111.rec, this__1605111.contents, G__1605089, this__1605111.__extmap)
};
ld23.core.ConsumableStack.prototype.cljs$core$IMeta$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605112 = this;
  return this__1605112.__meta
};
ld23.core.ConsumableStack.prototype.cljs$core$IMap$ = true;
ld23.core.ConsumableStack.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605113 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'kind", "\ufdd0'rec", "\ufdd0'contents"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605113.__meta), k__398__auto__)
  }else {
    return new ld23.core.ConsumableStack(this__1605113.kind, this__1605113.rec, this__1605113.contents, this__1605113.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605113.__extmap, k__398__auto__)))
  }
};
ld23.core.ConsumableStack.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "ld23.core.ConsumableStack")
};
ld23.core.__GT_ConsumableStack = function __GT_ConsumableStack(kind, rec, contents) {
  return new ld23.core.ConsumableStack(kind, rec, contents)
};
ld23.core.map__GT_ConsumableStack = function map__GT_ConsumableStack(G__1605091) {
  return new ld23.core.ConsumableStack("\ufdd0'kind".call(null, G__1605091), "\ufdd0'rec".call(null, G__1605091), "\ufdd0'contents".call(null, G__1605091), null, cljs.core.dissoc.call(null, G__1605091, "\ufdd0'kind", "\ufdd0'rec", "\ufdd0'contents"))
};
ld23.core.ConsumableStack;
ld23.core.add_with_stacking = function add_with_stacking(item, kind, rec) {
  var temp__3695__auto____1605118 = cljs.core.first.call(null, cljs.core.filter.call(null, function(p1__1605088_SHARP_) {
    return cljs.core._EQ_.call(null, "\ufdd0'kind".call(null, p1__1605088_SHARP_), kind)
  }, cljs.core.deref.call(null, ld23.core._STAR_bag_STAR_)));
  if(cljs.core.truth_(temp__3695__auto____1605118)) {
    var stack__1605119 = temp__3695__auto____1605118;
    return cljs.core.swap_BANG_.call(null, "\ufdd0'contents".call(null, stack__1605119), cljs.core.conj, item)
  }else {
    return cljs.core.swap_BANG_.call(null, ld23.core._STAR_bag_STAR_, cljs.core.conj, new ld23.core.ConsumableStack(kind, rec, cljs.core.atom.call(null, cljs.core.PersistentVector.fromArray([item]))))
  }
};
ld23.core.Rubble = function(position, rec, map_rec, state, __meta, __extmap) {
  this.position = position;
  this.rec = rec;
  this.map_rec = map_rec;
  this.state = state;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 4) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
ld23.core.Rubble.prototype.showoff$showoff$Drawable$ = true;
ld23.core.Rubble.prototype.showoff$showoff$Drawable$draw = function(c, ctx) {
  var this__1605123 = this;
  return showoff.showoff.draw_sprite.call(null, ctx, "\ufdd0'image".call(null, this__1605123.rec), this__1605123.position)
};
ld23.core.Rubble.prototype.cljs$core$IHash$ = true;
ld23.core.Rubble.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1605124 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
ld23.core.Rubble.prototype.cljs$core$ILookup$ = true;
ld23.core.Rubble.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605152 = null;
  var G__1605152__1605153 = function(this__388__auto__, k__389__auto__) {
    var this__1605125 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605152__1605154 = function(this__390__auto__, k1605121, else__391__auto__) {
    var this__1605126 = this;
    if(cljs.core.truth_(k1605121 === "\ufdd0'position")) {
      return this__1605126.position
    }else {
      if(cljs.core.truth_(k1605121 === "\ufdd0'rec")) {
        return this__1605126.rec
      }else {
        if(cljs.core.truth_(k1605121 === "\ufdd0'map-rec")) {
          return this__1605126.map_rec
        }else {
          if(cljs.core.truth_(k1605121 === "\ufdd0'state")) {
            return this__1605126.state
          }else {
            if(cljs.core.truth_("\ufdd0'else")) {
              return cljs.core.get.call(null, this__1605126.__extmap, k1605121, else__391__auto__)
            }else {
              return null
            }
          }
        }
      }
    }
  };
  G__1605152 = function(this__390__auto__, k1605121, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605152__1605153.call(this, this__390__auto__, k1605121);
      case 3:
        return G__1605152__1605154.call(this, this__390__auto__, k1605121, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605152
}();
ld23.core.Rubble.prototype.cljs$core$IAssociative$ = true;
ld23.core.Rubble.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1605120) {
  var this__1605127 = this;
  var pred__1605128__1605131 = cljs.core.identical_QMARK_;
  var expr__1605129__1605132 = k__396__auto__;
  if(cljs.core.truth_(pred__1605128__1605131.call(null, "\ufdd0'position", expr__1605129__1605132))) {
    return new ld23.core.Rubble(G__1605120, this__1605127.rec, this__1605127.map_rec, this__1605127.state, this__1605127.__meta, this__1605127.__extmap)
  }else {
    if(cljs.core.truth_(pred__1605128__1605131.call(null, "\ufdd0'rec", expr__1605129__1605132))) {
      return new ld23.core.Rubble(this__1605127.position, G__1605120, this__1605127.map_rec, this__1605127.state, this__1605127.__meta, this__1605127.__extmap)
    }else {
      if(cljs.core.truth_(pred__1605128__1605131.call(null, "\ufdd0'map-rec", expr__1605129__1605132))) {
        return new ld23.core.Rubble(this__1605127.position, this__1605127.rec, G__1605120, this__1605127.state, this__1605127.__meta, this__1605127.__extmap)
      }else {
        if(cljs.core.truth_(pred__1605128__1605131.call(null, "\ufdd0'state", expr__1605129__1605132))) {
          return new ld23.core.Rubble(this__1605127.position, this__1605127.rec, this__1605127.map_rec, G__1605120, this__1605127.__meta, this__1605127.__extmap)
        }else {
          return new ld23.core.Rubble(this__1605127.position, this__1605127.rec, this__1605127.map_rec, this__1605127.state, this__1605127.__meta, cljs.core.assoc.call(null, this__1605127.__extmap, k__396__auto__, G__1605120))
        }
      }
    }
  }
};
ld23.core.Rubble.prototype.showoff$showoff$Tickable$ = true;
ld23.core.Rubble.prototype.showoff$showoff$Tickable$tick = function(c) {
  var this__1605133 = this;
  return ld23.core.cooldown_tick.call(null, this__1605133.state)
};
ld23.core.Rubble.prototype.ld23$core$Iconic$ = true;
ld23.core.Rubble.prototype.ld23$core$Iconic$icon = function(c) {
  var this__1605134 = this;
  return"\ufdd0'image".call(null, this__1605134.rec)
};
ld23.core.Rubble.prototype.ld23$core$Useable$ = true;
ld23.core.Rubble.prototype.ld23$core$Useable$use_thing = function(c, user) {
  var this__1605135 = this;
  var temp__3695__auto____1605136 = ld23.core.kind_towards_QMARK_.call(null, showoff.showoff.to_rect.call(null, user), "\ufdd0'below", ld23.core.fillable_QMARK_);
  if(cljs.core.truth_(temp__3695__auto____1605136)) {
    var below_fillable_idx__1605137 = temp__3695__auto____1605136;
    return showoff.showoff.set_map_idx.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), below_fillable_idx__1605137, cljs.core.conj.call(null, this__1605135.map_rec, cljs.core.ObjMap.fromObject(["\ufdd0'used"], {"\ufdd0'used":true})))
  }else {
    var temp__3698__auto____1605138 = ld23.core.kind_towards_QMARK_.call(null, showoff.showoff.to_rect.call(null, user), "\ufdd0'direction".call(null, cljs.core.deref.call(null, "\ufdd0'particle".call(null, user))), ld23.core.fillable_QMARK_);
    if(cljs.core.truth_(temp__3698__auto____1605138)) {
      var idx__1605139 = temp__3698__auto____1605138;
      return showoff.showoff.set_map_idx.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), idx__1605139, cljs.core.conj.call(null, this__1605135.map_rec, cljs.core.ObjMap.fromObject(["\ufdd0'used"], {"\ufdd0'used":true})))
    }else {
      return null
    }
  }
};
ld23.core.Rubble.prototype.showoff$showoff$Rectable$ = true;
ld23.core.Rubble.prototype.showoff$showoff$Rectable$to_rect = function(c) {
  var this__1605140 = this;
  return ld23.core.posrec__GT_rect.call(null, this__1605140.position, this__1605140.rec)
};
ld23.core.Rubble.prototype.cljs$core$IRecord$ = true;
ld23.core.Rubble.prototype.cljs$core$ICollection$ = true;
ld23.core.Rubble.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1605141 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
ld23.core.Rubble.prototype.cljs$core$ISeqable$ = true;
ld23.core.Rubble.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605142 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'position", this__1605142.position), cljs.core.vector.call(null, "\ufdd0'rec", this__1605142.rec), cljs.core.vector.call(null, "\ufdd0'map-rec", this__1605142.map_rec), cljs.core.vector.call(null, "\ufdd0'state", this__1605142.state)]), this__1605142.__extmap))
};
ld23.core.Rubble.prototype.ld23$core$Collectable$ = true;
ld23.core.Rubble.prototype.ld23$core$Collectable$collect = function(c) {
  var this__1605143 = this;
  if(cljs.core.truth_(ld23.core.is_cool_QMARK_.call(null, this__1605143.state))) {
    showoff.showoff.remove_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), c);
    return ld23.core.add_with_stacking.call(null, c, "\ufdd0'rubble", this__1605143.rec)
  }else {
    return null
  }
};
ld23.core.Rubble.prototype.cljs$core$IPrintable$ = true;
ld23.core.Rubble.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605144 = this;
  var pr_pair__404__auto____1605145 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605145, cljs.core.str.call(null, "#", "ld23.core.Rubble", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'position", this__1605144.position), cljs.core.vector.call(null, "\ufdd0'rec", this__1605144.rec), cljs.core.vector.call(null, "\ufdd0'map-rec", this__1605144.map_rec), cljs.core.vector.call(null, "\ufdd0'state", this__1605144.state)]), this__1605144.__extmap))
};
ld23.core.Rubble.prototype.cljs$core$ICounted$ = true;
ld23.core.Rubble.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605146 = this;
  return 4 + cljs.core.count.call(null, this__1605146.__extmap)
};
ld23.core.Rubble.prototype.cljs$core$IEquiv$ = true;
ld23.core.Rubble.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605147 = this;
  var and__3546__auto____1605148 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605148)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605148
  }
};
ld23.core.Rubble.prototype.cljs$core$IWithMeta$ = true;
ld23.core.Rubble.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1605120) {
  var this__1605149 = this;
  return new ld23.core.Rubble(this__1605149.position, this__1605149.rec, this__1605149.map_rec, this__1605149.state, G__1605120, this__1605149.__extmap)
};
ld23.core.Rubble.prototype.cljs$core$IMeta$ = true;
ld23.core.Rubble.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605151 = this;
  return this__1605151.__meta
};
ld23.core.Rubble.prototype.cljs$core$IMap$ = true;
ld23.core.Rubble.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605150 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'position", "\ufdd0'state", "\ufdd0'rec", "\ufdd0'map-rec"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605150.__meta), k__398__auto__)
  }else {
    return new ld23.core.Rubble(this__1605150.position, this__1605150.rec, this__1605150.map_rec, this__1605150.state, this__1605150.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605150.__extmap, k__398__auto__)))
  }
};
ld23.core.Rubble.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "ld23.core.Rubble")
};
ld23.core.__GT_Rubble = function __GT_Rubble(position, rec, map_rec, state) {
  return new ld23.core.Rubble(position, rec, map_rec, state)
};
ld23.core.map__GT_Rubble = function map__GT_Rubble(G__1605122) {
  return new ld23.core.Rubble("\ufdd0'position".call(null, G__1605122), "\ufdd0'rec".call(null, G__1605122), "\ufdd0'map-rec".call(null, G__1605122), "\ufdd0'state".call(null, G__1605122), null, cljs.core.dissoc.call(null, G__1605122, "\ufdd0'position", "\ufdd0'rec", "\ufdd0'map-rec", "\ufdd0'state"))
};
ld23.core.Rubble;
ld23.core.Fist = function(rec, state, __meta, __extmap) {
  this.rec = rec;
  this.state = state;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 2) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
ld23.core.Fist.prototype.cljs$core$IHash$ = true;
ld23.core.Fist.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1605159 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
ld23.core.Fist.prototype.cljs$core$ILookup$ = true;
ld23.core.Fist.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605180 = null;
  var G__1605180__1605181 = function(this__388__auto__, k__389__auto__) {
    var this__1605160 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605180__1605182 = function(this__390__auto__, k1605157, else__391__auto__) {
    var this__1605161 = this;
    if(cljs.core.truth_(k1605157 === "\ufdd0'rec")) {
      return this__1605161.rec
    }else {
      if(cljs.core.truth_(k1605157 === "\ufdd0'state")) {
        return this__1605161.state
      }else {
        if(cljs.core.truth_("\ufdd0'else")) {
          return cljs.core.get.call(null, this__1605161.__extmap, k1605157, else__391__auto__)
        }else {
          return null
        }
      }
    }
  };
  G__1605180 = function(this__390__auto__, k1605157, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605180__1605181.call(this, this__390__auto__, k1605157);
      case 3:
        return G__1605180__1605182.call(this, this__390__auto__, k1605157, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605180
}();
ld23.core.Fist.prototype.cljs$core$IAssociative$ = true;
ld23.core.Fist.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1605156) {
  var this__1605162 = this;
  var pred__1605163__1605166 = cljs.core.identical_QMARK_;
  var expr__1605164__1605167 = k__396__auto__;
  if(cljs.core.truth_(pred__1605163__1605166.call(null, "\ufdd0'rec", expr__1605164__1605167))) {
    return new ld23.core.Fist(G__1605156, this__1605162.state, this__1605162.__meta, this__1605162.__extmap)
  }else {
    if(cljs.core.truth_(pred__1605163__1605166.call(null, "\ufdd0'state", expr__1605164__1605167))) {
      return new ld23.core.Fist(this__1605162.rec, G__1605156, this__1605162.__meta, this__1605162.__extmap)
    }else {
      return new ld23.core.Fist(this__1605162.rec, this__1605162.state, this__1605162.__meta, cljs.core.assoc.call(null, this__1605162.__extmap, k__396__auto__, G__1605156))
    }
  }
};
ld23.core.Fist.prototype.ld23$core$Iconic$ = true;
ld23.core.Fist.prototype.ld23$core$Iconic$icon = function(c) {
  var this__1605168 = this;
  return"\ufdd0'image".call(null, this__1605168.rec)
};
ld23.core.Fist.prototype.ld23$core$Useable$ = true;
ld23.core.Fist.prototype.ld23$core$Useable$use_thing = function(c) {
  var this__1605169 = this;
  return null
};
ld23.core.Fist.prototype.cljs$core$IRecord$ = true;
ld23.core.Fist.prototype.cljs$core$ICollection$ = true;
ld23.core.Fist.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1605170 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
ld23.core.Fist.prototype.cljs$core$ISeqable$ = true;
ld23.core.Fist.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605171 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'rec", this__1605171.rec), cljs.core.vector.call(null, "\ufdd0'state", this__1605171.state)]), this__1605171.__extmap))
};
ld23.core.Fist.prototype.cljs$core$IPrintable$ = true;
ld23.core.Fist.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605172 = this;
  var pr_pair__404__auto____1605173 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605173, cljs.core.str.call(null, "#", "ld23.core.Fist", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'rec", this__1605172.rec), cljs.core.vector.call(null, "\ufdd0'state", this__1605172.state)]), this__1605172.__extmap))
};
ld23.core.Fist.prototype.cljs$core$ICounted$ = true;
ld23.core.Fist.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605174 = this;
  return 2 + cljs.core.count.call(null, this__1605174.__extmap)
};
ld23.core.Fist.prototype.cljs$core$IEquiv$ = true;
ld23.core.Fist.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605175 = this;
  var and__3546__auto____1605176 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605176)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605176
  }
};
ld23.core.Fist.prototype.cljs$core$IWithMeta$ = true;
ld23.core.Fist.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1605156) {
  var this__1605177 = this;
  return new ld23.core.Fist(this__1605177.rec, this__1605177.state, G__1605156, this__1605177.__extmap)
};
ld23.core.Fist.prototype.cljs$core$IMeta$ = true;
ld23.core.Fist.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605178 = this;
  return this__1605178.__meta
};
ld23.core.Fist.prototype.cljs$core$IMap$ = true;
ld23.core.Fist.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605179 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'state", "\ufdd0'rec"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605179.__meta), k__398__auto__)
  }else {
    return new ld23.core.Fist(this__1605179.rec, this__1605179.state, this__1605179.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605179.__extmap, k__398__auto__)))
  }
};
ld23.core.Fist.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "ld23.core.Fist")
};
ld23.core.__GT_Fist = function __GT_Fist(rec, state) {
  return new ld23.core.Fist(rec, state)
};
ld23.core.map__GT_Fist = function map__GT_Fist(G__1605158) {
  return new ld23.core.Fist("\ufdd0'rec".call(null, G__1605158), "\ufdd0'state".call(null, G__1605158), null, cljs.core.dissoc.call(null, G__1605158, "\ufdd0'rec", "\ufdd0'state"))
};
ld23.core.Fist;
ld23.core.timer_time = function timer_time(timer) {
  var or__3548__auto____1605184 = "\ufdd0'time".call(null, cljs.core.deref.call(null, "\ufdd0'state".call(null, timer)));
  if(cljs.core.truth_(or__3548__auto____1605184)) {
    return or__3548__auto____1605184
  }else {
    return"\ufdd0'start".call(null, timer)
  }
};
ld23.core.Timer = function(start, state, __meta, __extmap) {
  this.start = start;
  this.state = state;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 2) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
ld23.core.Timer.prototype.cljs$core$IHash$ = true;
ld23.core.Timer.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1605188 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
ld23.core.Timer.prototype.cljs$core$ILookup$ = true;
ld23.core.Timer.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605209 = null;
  var G__1605209__1605210 = function(this__388__auto__, k__389__auto__) {
    var this__1605189 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605209__1605211 = function(this__390__auto__, k1605186, else__391__auto__) {
    var this__1605190 = this;
    if(cljs.core.truth_(k1605186 === "\ufdd0'start")) {
      return this__1605190.start
    }else {
      if(cljs.core.truth_(k1605186 === "\ufdd0'state")) {
        return this__1605190.state
      }else {
        if(cljs.core.truth_("\ufdd0'else")) {
          return cljs.core.get.call(null, this__1605190.__extmap, k1605186, else__391__auto__)
        }else {
          return null
        }
      }
    }
  };
  G__1605209 = function(this__390__auto__, k1605186, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605209__1605210.call(this, this__390__auto__, k1605186);
      case 3:
        return G__1605209__1605211.call(this, this__390__auto__, k1605186, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605209
}();
ld23.core.Timer.prototype.cljs$core$IAssociative$ = true;
ld23.core.Timer.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1605185) {
  var this__1605191 = this;
  var pred__1605192__1605195 = cljs.core.identical_QMARK_;
  var expr__1605193__1605196 = k__396__auto__;
  if(cljs.core.truth_(pred__1605192__1605195.call(null, "\ufdd0'start", expr__1605193__1605196))) {
    return new ld23.core.Timer(G__1605185, this__1605191.state, this__1605191.__meta, this__1605191.__extmap)
  }else {
    if(cljs.core.truth_(pred__1605192__1605195.call(null, "\ufdd0'state", expr__1605193__1605196))) {
      return new ld23.core.Timer(this__1605191.start, G__1605185, this__1605191.__meta, this__1605191.__extmap)
    }else {
      return new ld23.core.Timer(this__1605191.start, this__1605191.state, this__1605191.__meta, cljs.core.assoc.call(null, this__1605191.__extmap, k__396__auto__, G__1605185))
    }
  }
};
ld23.core.Timer.prototype.showoff$showoff$Tickable$ = true;
ld23.core.Timer.prototype.showoff$showoff$Tickable$tick = function(c) {
  var this__1605197 = this;
  var last_time__1605198 = ld23.core.timer_time.call(null, c);
  cljs.core.swap_BANG_.call(null, this__1605197.state, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'time"], {"\ufdd0'time":last_time__1605198 - showoff.showoff._PLUS_secs_per_tick_PLUS_}));
  if(cljs.core.truth_(last_time__1605198 <= 0)) {
    return cljs.core.swap_BANG_.call(null, this__1605197.state, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'time"], {"\ufdd0'time":0}))
  }else {
    return null
  }
};
ld23.core.Timer.prototype.cljs$core$IRecord$ = true;
ld23.core.Timer.prototype.cljs$core$ICollection$ = true;
ld23.core.Timer.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1605199 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
ld23.core.Timer.prototype.cljs$core$ISeqable$ = true;
ld23.core.Timer.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605200 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'start", this__1605200.start), cljs.core.vector.call(null, "\ufdd0'state", this__1605200.state)]), this__1605200.__extmap))
};
ld23.core.Timer.prototype.cljs$core$IPrintable$ = true;
ld23.core.Timer.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605201 = this;
  var pr_pair__404__auto____1605202 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605202, cljs.core.str.call(null, "#", "ld23.core.Timer", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'start", this__1605201.start), cljs.core.vector.call(null, "\ufdd0'state", this__1605201.state)]), this__1605201.__extmap))
};
ld23.core.Timer.prototype.cljs$core$ICounted$ = true;
ld23.core.Timer.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605203 = this;
  return 2 + cljs.core.count.call(null, this__1605203.__extmap)
};
ld23.core.Timer.prototype.cljs$core$IEquiv$ = true;
ld23.core.Timer.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605204 = this;
  var and__3546__auto____1605205 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605205)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605205
  }
};
ld23.core.Timer.prototype.cljs$core$IWithMeta$ = true;
ld23.core.Timer.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1605185) {
  var this__1605206 = this;
  return new ld23.core.Timer(this__1605206.start, this__1605206.state, G__1605185, this__1605206.__extmap)
};
ld23.core.Timer.prototype.cljs$core$IMeta$ = true;
ld23.core.Timer.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605207 = this;
  return this__1605207.__meta
};
ld23.core.Timer.prototype.cljs$core$IMap$ = true;
ld23.core.Timer.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605208 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'state", "\ufdd0'start"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605208.__meta), k__398__auto__)
  }else {
    return new ld23.core.Timer(this__1605208.start, this__1605208.state, this__1605208.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605208.__extmap, k__398__auto__)))
  }
};
ld23.core.Timer.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "ld23.core.Timer")
};
ld23.core.__GT_Timer = function __GT_Timer(start, state) {
  return new ld23.core.Timer(start, state)
};
ld23.core.map__GT_Timer = function map__GT_Timer(G__1605187) {
  return new ld23.core.Timer("\ufdd0'start".call(null, G__1605187), "\ufdd0'state".call(null, G__1605187), null, cljs.core.dissoc.call(null, G__1605187, "\ufdd0'start", "\ufdd0'state"))
};
ld23.core.Timer;
ld23.core._STAR_game_timer_STAR_ = null;
ld23.core.draw_timer = function draw_timer(ctx, timer) {
  var time__1605213 = Math.ceil.call(null, "\ufdd0'time".call(null, cljs.core.deref.call(null, "\ufdd0'state".call(null, timer))));
  var minutes__1605214 = Math.floor.call(null, time__1605213 / 60);
  var seconds__1605215 = time__1605213 % 60;
  return showoff.showoff.draw_text_centered.call(null, ctx, ld23.core._STAR_hud_font_STAR_, showoff.showoff.format.call(null, "%2d:%02d", minutes__1605214, seconds__1605215), cljs.core.PersistentVector.fromArray([55, 452]))
};
ld23.core.fill_template = function fill_template(pdata, p__1605216, sym) {
  var vec__1605217__1605218 = p__1605216;
  var px__1605219 = cljs.core.nth.call(null, vec__1605217__1605218, 0, null);
  var py__1605220 = cljs.core.nth.call(null, vec__1605217__1605218, 1, null);
  var vec__1605221__1605224 = showoff.showoff._STAR_tile_in_world_dims_STAR_;
  var dw__1605225 = cljs.core.nth.call(null, vec__1605221__1605224, 0, null);
  var dh__1605226 = cljs.core.nth.call(null, vec__1605221__1605224, 1, null);
  var vec__1605222__1605227 = "\ufdd0'dims".call(null, pdata);
  var sw__1605228 = cljs.core.nth.call(null, vec__1605222__1605227, 0, null);
  var sh__1605229 = cljs.core.nth.call(null, vec__1605222__1605227, 1, null);
  var pw__1605230 = dw__1605225 / 16;
  var ph__1605231 = dh__1605226 / 16;
  var num_pixels__1605232 = 16 * 16;
  var canvas__1605233 = showoff.showoff.make_canvas.call(null, cljs.core.PersistentVector.fromArray([dw__1605225, dh__1605226]));
  var ctx__1605234 = showoff.showoff.context.call(null, canvas__1605233);
  var vec__1605223__1605235 = sym;
  var br__1605236 = cljs.core.nth.call(null, vec__1605223__1605235, 0, null);
  var bg__1605237 = cljs.core.nth.call(null, vec__1605223__1605235, 1, null);
  var bb__1605238 = cljs.core.nth.call(null, vec__1605223__1605235, 2, null);
  var n__575__auto____1605239 = num_pixels__1605232;
  var ii__1605240 = 0;
  while(true) {
    if(cljs.core.truth_(ii__1605240 < n__575__auto____1605239)) {
      var x__1605242 = ii__1605240 % 16;
      var y__1605243 = Math.floor.call(null, ii__1605240 / 16);
      var src_x__1605244 = px__1605219 + x__1605242;
      var src_y__1605245 = py__1605220 + y__1605243;
      var vec__1605241__1605246 = showoff.showoff.get_pixel.call(null, pdata, src_x__1605244, src_y__1605245);
      var scale__1605247 = cljs.core.nth.call(null, vec__1605241__1605246, 0, null);
      var ___1605248 = cljs.core.nth.call(null, vec__1605241__1605246, 1, null);
      var ___1605249 = cljs.core.nth.call(null, vec__1605241__1605246, 2, null);
      var scale__1605250 = scale__1605247 / 255;
      ctx__1605234.fillStyle = showoff.showoff.color.call(null, cljs.core.PersistentVector.fromArray([Math.round.call(null, scale__1605250 * br__1605236), Math.round.call(null, scale__1605250 * bg__1605237), Math.round.call(null, scale__1605250 * bb__1605238)]));
      ctx__1605234.fillRect(Math.floor.call(null, x__1605242 * pw__1605230), Math.floor.call(null, y__1605243 * ph__1605231), Math.ceil.call(null, pw__1605230), Math.ceil.call(null, ph__1605231));
      var G__1605251 = ii__1605240 + 1;
      ii__1605240 = G__1605251;
      continue
    }else {
    }
    break
  }
  return cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable", "\ufdd0'shape", "\ufdd0'breakable"], {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":canvas__1605233, "\ufdd0'collidable":true, "\ufdd0'shape":"\ufdd0'rect", "\ufdd0'breakable":true})
};
ld23.core.make_symbol_generator = function make_symbol_generator(base_symbols, pdata, templates, p__1605252) {
  var vec__1605253__1605254 = p__1605252;
  var startx__1605255 = cljs.core.nth.call(null, vec__1605253__1605254, 0, null);
  var starty__1605256 = cljs.core.nth.call(null, vec__1605253__1605254, 1, null);
  var cache__1605257 = cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {}));
  return function(sym) {
    var temp__3695__auto____1605258 = base_symbols.call(null, sym);
    if(cljs.core.truth_(temp__3695__auto____1605258)) {
      var result__1605259 = temp__3695__auto____1605258;
      return result__1605259
    }else {
      var template__1605260 = Math.floor.call(null, templates * Math.random.call(null));
      var cache_key__1605261 = cljs.core.PersistentVector.fromArray([sym, template__1605260]);
      var temp__3695__auto____1605262 = cljs.core.deref.call(null, cache__1605257).call(null, cache_key__1605261);
      if(cljs.core.truth_(temp__3695__auto____1605262)) {
        var result__1605263 = temp__3695__auto____1605262;
        return result__1605263
      }else {
        var filled_template__1605264 = ld23.core.fill_template.call(null, pdata, cljs.core.PersistentVector.fromArray([startx__1605255 + template__1605260 * 16, starty__1605256]), sym);
        cljs.core.swap_BANG_.call(null, cache__1605257, cljs.core.conj, cljs.core.HashMap.fromArrays([cache_key__1605261], [filled_template__1605264]));
        return filled_template__1605264
      }
    }
  }
};
ld23.core.setup_symbols = function setup_symbols(sprites) {
  var dims__1605265 = showoff.showoff._STAR_tile_in_world_dims_STAR_;
  var pdata__1605266 = showoff.showoff.get_pixel_data.call(null, sprites);
  var base_symbols__1605267 = cljs.core.HashMap.fromArrays([cljs.core.PersistentVector.fromArray([255, 255, 255]), cljs.core.PersistentVector.fromArray([0, 0, 0]), cljs.core.PersistentVector.fromArray([0, 255, 0]), cljs.core.PersistentVector.fromArray([102, 102, 102]), cljs.core.PersistentVector.fromArray([204, 204, 204]), cljs.core.PersistentVector.fromArray([0, 0, 255])], [cljs.core.ObjMap.fromObject(["\ufdd0'kind"], {"\ufdd0'kind":"\ufdd0'skip"}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", 
  "\ufdd0'collidable", "\ufdd0'shape"], {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([0, 16, 16, 16]), dims__1605265), "\ufdd0'collidable":true, "\ufdd0'shape":"\ufdd0'rect"}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable", "\ufdd0'breakable", "\ufdd0'shape"], {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, 
  cljs.core.PersistentVector.fromArray([0, 32, 16, 16]), dims__1605265), "\ufdd0'collidable":true, "\ufdd0'breakable":true, "\ufdd0'shape":"\ufdd0'rect"}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable", "\ufdd0'breakable", "\ufdd0'shape"], {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([16, 32, 16, 16]), dims__1605265), "\ufdd0'collidable":true, "\ufdd0'breakable":true, 
  "\ufdd0'shape":"\ufdd0'rect"}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable", "\ufdd0'breakable", "\ufdd0'shape"], {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([16, 16, 16, 16]), dims__1605265), "\ufdd0'collidable":true, "\ufdd0'breakable":true, "\ufdd0'shape":"\ufdd0'rect"}), cljs.core.ObjMap.fromObject(["\ufdd0'kind", "\ufdd0'image", "\ufdd0'collidable"], 
  {"\ufdd0'kind":"\ufdd0'image", "\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([32, 32, 16, 16]), dims__1605265), "\ufdd0'collidable":false})]);
  ld23.core._STAR_symbols_STAR_ = ld23.core.make_symbol_generator.call(null, base_symbols__1605267, pdata__1605266, 3, cljs.core.PersistentVector.fromArray([0, 48]));
  ld23.core._STAR_player_sprite_STAR_ = cljs.core.ObjMap.fromObject(["\ufdd0'left", "\ufdd0'right"], {"\ufdd0'left":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([0, 0, 16, 16]), dims__1605265), "\ufdd0'right":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([16, 0, 16, 16]), dims__1605265)});
  ld23.core._STAR_money_icon_STAR_ = showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([64, 0, 16, 16]), dims__1605265);
  return ld23.core._STAR_collectables_STAR_ = cljs.core.ObjMap.fromObject(["\ufdd0'key", "\ufdd0'jackhammer", "\ufdd0'blowtorch", "\ufdd0'rubble", "\ufdd0'fist"], {"\ufdd0'key":cljs.core.ObjMap.fromObject(["\ufdd0'image", "\ufdd0'dims", "\ufdd0'spawn"], {"\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([32, 0, 16, 16]), dims__1605265), "\ufdd0'dims":cljs.core.PersistentVector.fromArray([1, 1]), "\ufdd0'spawn":function(pos, rec) {
    return new ld23.core.StaticCollectable(pos, rec)
  }}), "\ufdd0'jackhammer":cljs.core.ObjMap.fromObject(["\ufdd0'image", "\ufdd0'dims", "\ufdd0'spawn"], {"\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([48, 0, 16, 16]), dims__1605265), "\ufdd0'dims":cljs.core.PersistentVector.fromArray([1, 1]), "\ufdd0'spawn":function(pos, rec, cooldown) {
    return new ld23.core.Jackhammer(pos, rec, cooldown, cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {})))
  }}), "\ufdd0'blowtorch":cljs.core.ObjMap.fromObject(["\ufdd0'image", "\ufdd0'dims", "\ufdd0'spawn"], {"\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([48, 48, 16, 16]), dims__1605265), "\ufdd0'dims":cljs.core.PersistentVector.fromArray([1, 1]), "\ufdd0'spawn":function(pos, rec, cooldown) {
    return new ld23.core.Blowtorch(pos, rec, cooldown, cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {})))
  }}), "\ufdd0'rubble":cljs.core.ObjMap.fromObject(["\ufdd0'image", "\ufdd0'dims", "\ufdd0'spawn"], {"\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([48, 32, 16, 16]), dims__1605265), "\ufdd0'dims":cljs.core.PersistentVector.fromArray([1, 1]), "\ufdd0'spawn":function(pos, rec, map_rec) {
    return new ld23.core.Rubble(pos, rec, map_rec, cljs.core.atom.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'cooldown"], {"\ufdd0'cooldown":0.2})))
  }}), "\ufdd0'fist":cljs.core.ObjMap.fromObject(["\ufdd0'image", "\ufdd0'dims"], {"\ufdd0'image":showoff.showoff.resize_nearest_neighbor.call(null, pdata__1605266, cljs.core.PersistentVector.fromArray([48, 16, 16, 16]), dims__1605265), "\ufdd0'dims":cljs.core.PersistentVector.fromArray([1, 1])})})
};
ld23.core.with_prepared_assets = function with_prepared_assets(callback) {
  showoff.showoff.with_loaded_font.call(null, "graphics/basic-font.gif", ld23.core._STAR_font_chars_STAR_, cljs.core.PersistentVector.fromArray([8, 8]), 2, showoff.showoff.color.call(null, cljs.core.PersistentVector.fromArray([128, 0, 0])), function(font) {
    return ld23.core._STAR_hud_font_STAR_ = font
  });
  return showoff.showoff.with_img.call(null, cljs.core.str.call(null, "graphics/hud.png"), function(hud) {
    ld23.core._STAR_hud_STAR_ = showoff.showoff.resize_nearest_neighbor.call(null, showoff.showoff.get_pixel_data.call(null, hud), cljs.core.PersistentVector.fromArray([640, 480]));
    return showoff.showoff.with_img.call(null, cljs.core.str.call(null, "graphics/sprites.png"), function(sprites) {
      ld23.core.setup_symbols.call(null, sprites);
      return callback.call(null)
    })
  })
};
ld23.core.with_loaded_map = function with_loaded_map(callback) {
  return showoff.showoff.with_img.call(null, cljs.core.str.call(null, "graphics/world2.gif"), function(map_img) {
    cljs.core.reset_BANG_.call(null, ld23.core._STAR_current_map_STAR_, showoff.showoff.load_map.call(null, map_img, ld23.core._STAR_symbols_STAR_));
    return callback.call(null)
  })
};
ld23.core._STAR_command_state_override_STAR_ = null;
ld23.core.input_state = function input_state() {
  if(cljs.core.truth_(ld23.core._STAR_command_state_override_STAR_)) {
    return ld23.core._STAR_command_state_override_STAR_
  }else {
    return showoff.core._STAR_command_state_map_STAR_
  }
};
HTMLCanvasElement.prototype.cljs$core$IHash$ = true;
HTMLCanvasElement.prototype.cljs$core$IHash$_hash = function(c) {
  return goog.getUid.call(null, c)
};
ld23.core.collectable_QMARK_ = function collectable_QMARK_(o) {
  var x__451__auto____1605268 = o;
  if(cljs.core.truth_(function() {
    var and__3546__auto____1605269 = x__451__auto____1605268;
    if(cljs.core.truth_(and__3546__auto____1605269)) {
      var and__3546__auto____1605270 = x__451__auto____1605268.ld23$core$Collectable$;
      if(cljs.core.truth_(and__3546__auto____1605270)) {
        return cljs.core.not.call(null, x__451__auto____1605268.hasOwnProperty("ld23$core$Collectable$"))
      }else {
        return and__3546__auto____1605270
      }
    }else {
      return and__3546__auto____1605269
    }
  }())) {
    return true
  }else {
    return cljs.core.type_satisfies_.call(null, ld23.core.Collectable, x__451__auto____1605268)
  }
};
ld23.core.Player = function(particle, __meta, __extmap) {
  this.particle = particle;
  this.__meta = __meta;
  this.__extmap = __extmap;
  if(arguments.length > 1) {
    this.__meta = __meta;
    this.__extmap = __extmap
  }else {
    this.__meta = null;
    this.__extmap = null
  }
};
ld23.core.Player.prototype.cljs$core$IHash$ = true;
ld23.core.Player.prototype.cljs$core$IHash$_hash = function(this__383__auto__) {
  var this__1605274 = this;
  return cljs.core.hash_coll.call(null, this__383__auto__)
};
ld23.core.Player.prototype.cljs$core$ILookup$ = true;
ld23.core.Player.prototype.cljs$core$ILookup$_lookup = function() {
  var G__1605317 = null;
  var G__1605317__1605318 = function(this__388__auto__, k__389__auto__) {
    var this__1605275 = this;
    return cljs.core._lookup.call(null, this__388__auto__, k__389__auto__, null)
  };
  var G__1605317__1605319 = function(this__390__auto__, k1605272, else__391__auto__) {
    var this__1605276 = this;
    if(cljs.core.truth_(k1605272 === "\ufdd0'particle")) {
      return this__1605276.particle
    }else {
      if(cljs.core.truth_("\ufdd0'else")) {
        return cljs.core.get.call(null, this__1605276.__extmap, k1605272, else__391__auto__)
      }else {
        return null
      }
    }
  };
  G__1605317 = function(this__390__auto__, k1605272, else__391__auto__) {
    switch(arguments.length) {
      case 2:
        return G__1605317__1605318.call(this, this__390__auto__, k1605272);
      case 3:
        return G__1605317__1605319.call(this, this__390__auto__, k1605272, else__391__auto__)
    }
    throw"Invalid arity: " + arguments.length;
  };
  return G__1605317
}();
ld23.core.Player.prototype.cljs$core$IAssociative$ = true;
ld23.core.Player.prototype.cljs$core$IAssociative$_assoc = function(this__395__auto__, k__396__auto__, G__1605271) {
  var this__1605277 = this;
  var pred__1605278__1605281 = cljs.core.identical_QMARK_;
  var expr__1605279__1605282 = k__396__auto__;
  if(cljs.core.truth_(pred__1605278__1605281.call(null, "\ufdd0'particle", expr__1605279__1605282))) {
    return new ld23.core.Player(G__1605271, this__1605277.__meta, this__1605277.__extmap)
  }else {
    return new ld23.core.Player(this__1605277.particle, this__1605277.__meta, cljs.core.assoc.call(null, this__1605277.__extmap, k__396__auto__, G__1605271))
  }
};
ld23.core.Player.prototype.showoff$showoff$Tickable$ = true;
ld23.core.Player.prototype.showoff$showoff$Tickable$tick = function(player) {
  var this__1605283 = this;
  ld23.core.cooldown_tick.call(null, this__1605283.particle);
  if(cljs.core.truth_(ld23.core.input_state.call(null).call(null, goog.events.KeyCodes.LEFT))) {
    cljs.core.swap_BANG_.call(null, this__1605283.particle, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'direction"], {"\ufdd0'direction":"\ufdd0'left"}))
  }else {
    if(cljs.core.truth_(ld23.core.input_state.call(null).call(null, goog.events.KeyCodes.RIGHT))) {
      cljs.core.swap_BANG_.call(null, this__1605283.particle, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'direction"], {"\ufdd0'direction":"\ufdd0'right"}))
    }else {
    }
  }
  if(cljs.core.truth_(cljs.core.not.call(null, function() {
    var or__3548__auto____1605284 = ld23.core.input_state.call(null).call(null, goog.events.KeyCodes.DOWN);
    if(cljs.core.truth_(or__3548__auto____1605284)) {
      return or__3548__auto____1605284
    }else {
      return ld23.core.input_state.call(null).call(null, 32)
    }
  }()))) {
    cljs.core.swap_BANG_.call(null, this__1605283.particle, cljs.core.conj, cljs.core.ObjMap.fromObject(["\ufdd0'cooldown"], {"\ufdd0'cooldown":0}))
  }else {
  }
  if(cljs.core.truth_(function() {
    var and__3546__auto____1605285 = ld23.core.is_cool_QMARK_.call(null, this__1605283.particle);
    if(cljs.core.truth_(and__3546__auto____1605285)) {
      return ld23.core.input_state.call(null).call(null, 32)
    }else {
      return and__3546__auto____1605285
    }
  }())) {
    ld23.core.use_thing.call(null, cljs.core.first.call(null, cljs.core.deref.call(null, ld23.core._STAR_bag_STAR_)), player);
    ld23.core.cooldown_start.call(null, this__1605283.particle, 0.3)
  }else {
  }
  if(cljs.core.truth_(function() {
    var and__3546__auto____1605286 = ld23.core.is_cool_QMARK_.call(null, this__1605283.particle);
    if(cljs.core.truth_(and__3546__auto____1605286)) {
      return ld23.core.input_state.call(null).call(null, goog.events.KeyCodes.DOWN)
    }else {
      return and__3546__auto____1605286
    }
  }())) {
    cljs.core.reset_BANG_.call(null, ld23.core._STAR_bag_STAR_, cljs.core.conj.call(null, cljs.core.into.call(null, cljs.core.PersistentVector.fromArray([]), cljs.core.rest.call(null, cljs.core.deref.call(null, ld23.core._STAR_bag_STAR_))), cljs.core.first.call(null, cljs.core.deref.call(null, ld23.core._STAR_bag_STAR_))));
    ld23.core.cooldown_start.call(null, this__1605283.particle, 0.3)
  }else {
  }
  var G__1605287__1605288 = cljs.core.seq.call(null, showoff.showoff.rect__GT_idxs.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), showoff.showoff.to_rect.call(null, player)));
  if(cljs.core.truth_(G__1605287__1605288)) {
    var idx__1605289 = cljs.core.first.call(null, G__1605287__1605288);
    var G__1605287__1605290 = G__1605287__1605288;
    while(true) {
      var rec__1605291 = showoff.showoff.get_map_idx.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), idx__1605289);
      var objects__1605292 = "\ufdd0'objects".call(null, rec__1605291);
      var collectables__1605293 = cljs.core.filter.call(null, ld23.core.collectable_QMARK_, cljs.core.deref.call(null, objects__1605292));
      var G__1605294__1605295 = cljs.core.seq.call(null, collectables__1605293);
      if(cljs.core.truth_(G__1605294__1605295)) {
        var collectable__1605296 = cljs.core.first.call(null, G__1605294__1605295);
        var G__1605294__1605297 = G__1605294__1605295;
        while(true) {
          if(cljs.core.truth_(showoff.showoff.rect_intersect.call(null, showoff.showoff.to_rect.call(null, collectable__1605296), showoff.showoff.to_rect.call(null, player)))) {
            ld23.core.collect.call(null, collectable__1605296)
          }else {
          }
          var temp__3698__auto____1605298 = cljs.core.next.call(null, G__1605294__1605297);
          if(cljs.core.truth_(temp__3698__auto____1605298)) {
            var G__1605294__1605299 = temp__3698__auto____1605298;
            var G__1605321 = cljs.core.first.call(null, G__1605294__1605299);
            var G__1605322 = G__1605294__1605299;
            collectable__1605296 = G__1605321;
            G__1605294__1605297 = G__1605322;
            continue
          }else {
          }
          break
        }
      }else {
      }
      var temp__3698__auto____1605300 = cljs.core.next.call(null, G__1605287__1605290);
      if(cljs.core.truth_(temp__3698__auto____1605300)) {
        var G__1605287__1605301 = temp__3698__auto____1605300;
        var G__1605323 = cljs.core.first.call(null, G__1605287__1605301);
        var G__1605324 = G__1605287__1605301;
        idx__1605289 = G__1605323;
        G__1605287__1605290 = G__1605324;
        continue
      }else {
      }
      break
    }
  }else {
  }
  return cljs.core.reset_BANG_.call(null, this__1605283.particle, showoff.showoff.apply_particle_vs_map.call(null, showoff.showoff.integrate_particle.call(null, cljs.core.deref.call(null, this__1605283.particle)), cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), showoff.showoff.to_rect.call(null, player), 0))
};
ld23.core.Player.prototype.showoff$showoff$Rectable$ = true;
ld23.core.Player.prototype.showoff$showoff$Rectable$to_rect = function(player) {
  var this__1605302 = this;
  var vec__1605303__1605304 = "\ufdd0'position".call(null, cljs.core.deref.call(null, this__1605302.particle));
  var x__1605305 = cljs.core.nth.call(null, vec__1605303__1605304, 0, null);
  var y__1605306 = cljs.core.nth.call(null, vec__1605303__1605304, 1, null);
  return cljs.core.PersistentVector.fromArray([x__1605305 + 0.1, y__1605306 + 0.1, 0.8, 0.9])
};
ld23.core.Player.prototype.cljs$core$IRecord$ = true;
ld23.core.Player.prototype.cljs$core$ICollection$ = true;
ld23.core.Player.prototype.cljs$core$ICollection$_conj = function(this__393__auto__, entry__394__auto__) {
  var this__1605307 = this;
  if(cljs.core.truth_(cljs.core.vector_QMARK_.call(null, entry__394__auto__))) {
    return cljs.core._assoc.call(null, this__393__auto__, cljs.core._nth.call(null, entry__394__auto__, 0), cljs.core._nth.call(null, entry__394__auto__, 1))
  }else {
    return cljs.core.reduce.call(null, cljs.core._conj, this__393__auto__, entry__394__auto__)
  }
};
ld23.core.Player.prototype.cljs$core$ISeqable$ = true;
ld23.core.Player.prototype.cljs$core$ISeqable$_seq = function(this__400__auto__) {
  var this__1605308 = this;
  return cljs.core.seq.call(null, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'particle", this__1605308.particle)]), this__1605308.__extmap))
};
ld23.core.Player.prototype.cljs$core$IPrintable$ = true;
ld23.core.Player.prototype.cljs$core$IPrintable$_pr_seq = function(this__402__auto__, opts__403__auto__) {
  var this__1605309 = this;
  var pr_pair__404__auto____1605310 = function(keyval__405__auto__) {
    return cljs.core.pr_sequential.call(null, cljs.core.pr_seq, "", " ", "", opts__403__auto__, keyval__405__auto__)
  };
  return cljs.core.pr_sequential.call(null, pr_pair__404__auto____1605310, cljs.core.str.call(null, "#", "ld23.core.Player", "{"), ", ", "}", opts__403__auto__, cljs.core.concat.call(null, cljs.core.PersistentVector.fromArray([cljs.core.vector.call(null, "\ufdd0'particle", this__1605309.particle)]), this__1605309.__extmap))
};
ld23.core.Player.prototype.cljs$core$ICounted$ = true;
ld23.core.Player.prototype.cljs$core$ICounted$_count = function(this__392__auto__) {
  var this__1605311 = this;
  return 1 + cljs.core.count.call(null, this__1605311.__extmap)
};
ld23.core.Player.prototype.cljs$core$IEquiv$ = true;
ld23.core.Player.prototype.cljs$core$IEquiv$_equiv = function(this__384__auto__, other__385__auto__) {
  var this__1605312 = this;
  var and__3546__auto____1605313 = this__384__auto__.constructor === other__385__auto__.constructor;
  if(cljs.core.truth_(and__3546__auto____1605313)) {
    return cljs.core.equiv_map.call(null, this__384__auto__, other__385__auto__)
  }else {
    return and__3546__auto____1605313
  }
};
ld23.core.Player.prototype.cljs$core$IWithMeta$ = true;
ld23.core.Player.prototype.cljs$core$IWithMeta$_with_meta = function(this__387__auto__, G__1605271) {
  var this__1605314 = this;
  return new ld23.core.Player(this__1605314.particle, G__1605271, this__1605314.__extmap)
};
ld23.core.Player.prototype.cljs$core$IMeta$ = true;
ld23.core.Player.prototype.cljs$core$IMeta$_meta = function(this__386__auto__) {
  var this__1605315 = this;
  return this__1605315.__meta
};
ld23.core.Player.prototype.cljs$core$IMap$ = true;
ld23.core.Player.prototype.cljs$core$IMap$_dissoc = function(this__397__auto__, k__398__auto__) {
  var this__1605316 = this;
  if(cljs.core.truth_(cljs.core.contains_QMARK_.call(null, cljs.core.set(["\ufdd0'particle"]), k__398__auto__))) {
    return cljs.core.dissoc.call(null, cljs.core.with_meta.call(null, cljs.core.into.call(null, cljs.core.ObjMap.fromObject([], {}), this__397__auto__), this__1605316.__meta), k__398__auto__)
  }else {
    return new ld23.core.Player(this__1605316.particle, this__1605316.__meta, cljs.core.not_empty.call(null, cljs.core.dissoc.call(null, this__1605316.__extmap, k__398__auto__)))
  }
};
ld23.core.Player.cljs$core$IPrintable$_pr_seq = function(this__429__auto__) {
  return cljs.core.list.call(null, "ld23.core.Player")
};
ld23.core.__GT_Player = function __GT_Player(particle) {
  return new ld23.core.Player(particle)
};
ld23.core.map__GT_Player = function map__GT_Player(G__1605273) {
  return new ld23.core.Player("\ufdd0'particle".call(null, G__1605273), null, cljs.core.dissoc.call(null, G__1605273, "\ufdd0'particle"))
};
ld23.core.Player;
ld23.core.draw_player = function draw_player(ctx, position, direction) {
  var sprite__1605325 = direction.call(null, ld23.core._STAR_player_sprite_STAR_);
  return showoff.showoff.draw_sprite.call(null, ctx, sprite__1605325, position)
};
ld23.core.draw_player_entity = function draw_player_entity(ctx, p) {
  var particle__1605326 = cljs.core.deref.call(null, "\ufdd0'particle".call(null, p));
  var direction__1605328 = function() {
    var or__3548__auto____1605327 = "\ufdd0'direction".call(null, particle__1605326);
    if(cljs.core.truth_(or__3548__auto____1605327)) {
      return or__3548__auto____1605327
    }else {
      return"\ufdd0'right"
    }
  }();
  return ld23.core.draw_player.call(null, ctx, "\ufdd0'position".call(null, particle__1605326), direction__1605328)
};
ld23.core._STAR_player_speed_STAR_ = 40;
ld23.core._STAR_player_STAR_ = null;
ld23.core.add_collectable = function() {
  var add_collectable__delegate = function(key, pos, more) {
    var rec__1605329 = ld23.core._STAR_collectables_STAR_.call(null, key);
    var coll__1605330 = cljs.core.apply.call(null, "\ufdd0'spawn".call(null, rec__1605329), pos, rec__1605329, more);
    return showoff.showoff.add_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), coll__1605330)
  };
  var add_collectable = function(key, pos, var_args) {
    var more = null;
    if(goog.isDef(var_args)) {
      more = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2), 0)
    }
    return add_collectable__delegate.call(this, key, pos, more)
  };
  add_collectable.cljs$lang$maxFixedArity = 2;
  add_collectable.cljs$lang$applyTo = function(arglist__1605331) {
    var key = cljs.core.first(arglist__1605331);
    var pos = cljs.core.first(cljs.core.next(arglist__1605331));
    var more = cljs.core.rest(cljs.core.next(arglist__1605331));
    return add_collectable__delegate.call(this, key, pos, more)
  };
  return add_collectable
}();
ld23.core._PLUS_viewport_spring_constant_PLUS_ = 60;
ld23.core._PLUS_viewport_drag_coefficient_PLUS_ = 2;
ld23.core._PLUS_viewport_max_displacement_PLUS_ = 2;
ld23.core._STAR_viewport_STAR_ = null;
ld23.core.add_keys = function add_keys(locations) {
  var G__1605332__1605333 = cljs.core.seq.call(null, locations);
  if(cljs.core.truth_(G__1605332__1605333)) {
    var loc__1605334 = cljs.core.first.call(null, G__1605332__1605333);
    var G__1605332__1605335 = G__1605332__1605333;
    while(true) {
      ld23.core.add_collectable.call(null, "\ufdd0'key", loc__1605334);
      var temp__3698__auto____1605336 = cljs.core.next.call(null, G__1605332__1605335);
      if(cljs.core.truth_(temp__3698__auto____1605336)) {
        var G__1605332__1605337 = temp__3698__auto____1605336;
        var G__1605338 = cljs.core.first.call(null, G__1605332__1605337);
        var G__1605339 = G__1605332__1605337;
        loc__1605334 = G__1605338;
        G__1605332__1605335 = G__1605339;
        continue
      }else {
      }
      break
    }
  }else {
  }
  return cljs.core.reset_BANG_.call(null, ld23.core._STAR_total_keys_STAR_, cljs.core.count.call(null, locations))
};
ld23.core.setup_world = function setup_world(callback) {
  ld23.core.empty_bag.call(null);
  showoff.showoff.clear_entities.call(null);
  cljs.core.reset_BANG_.call(null, ld23.core._STAR_keys_collected_STAR_, 0);
  cljs.core.reset_BANG_.call(null, ld23.core._STAR_bricks_destroyed_STAR_, 0);
  cljs.core.swap_BANG_.call(null, ld23.core._STAR_bag_STAR_, cljs.core.conj, new ld23.core.Fist("\ufdd0'fist".call(null, ld23.core._STAR_collectables_STAR_), cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {}))));
  ld23.core._STAR_player_STAR_ = new ld23.core.Player(cljs.core.atom.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'mass", "\ufdd0'position", "\ufdd0'velocity", "\ufdd0'force-generators"], {"\ufdd0'mass":5, "\ufdd0'position":cljs.core.PersistentVector.fromArray([5, 5]), "\ufdd0'velocity":cljs.core.PersistentVector.fromArray([0, 0]), "\ufdd0'force-generators":cljs.core.PersistentVector.fromArray([showoff.showoff.drag_force_generator.call(null, 1), showoff.core.ground_friction_generator.call(null, 
  ld23.core._STAR_current_map_STAR_, function() {
    return showoff.showoff.to_rect.call(null, ld23.core._STAR_player_STAR_)
  }, 30), showoff.showoff.gravity_force_generator.call(null, 20), showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.LEFT, cljs.core.PersistentVector.fromArray([-ld23.core._STAR_player_speed_STAR_, 0])), showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.RIGHT, cljs.core.PersistentVector.fromArray([ld23.core._STAR_player_speed_STAR_, 0])), showoff.core.jump_velocity_generator.call(null, ld23.core._STAR_current_map_STAR_, function() {
    return showoff.showoff.to_rect.call(null, ld23.core._STAR_player_STAR_)
  }, 300, 0.5)])})));
  ld23.core._STAR_viewport_STAR_ = new showoff.core.Viewport(cljs.core.PersistentVector.fromArray([20, 15]), cljs.core.atom.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'mass", "\ufdd0'position", "\ufdd0'velocity", "\ufdd0'force-generators"], {"\ufdd0'mass":1, "\ufdd0'position":cljs.core.PersistentVector.fromArray([5, 5]), "\ufdd0'velocity":cljs.core.PersistentVector.fromArray([0, 0]), "\ufdd0'force-generators":cljs.core.PersistentVector.fromArray([function(p) {
    return showoff.showoff.spring_force.call(null, showoff.showoff.vec_sub.call(null, "\ufdd0'position".call(null, cljs.core.deref.call(null, "\ufdd0'particle".call(null, ld23.core._STAR_player_STAR_))), showoff.showoff.vec_sub.call(null, showoff.showoff.rect_center.call(null, showoff.showoff.viewport_rect.call(null)), cljs.core.PersistentVector.fromArray([0, 2]))), ld23.core._PLUS_viewport_max_displacement_PLUS_, ld23.core._PLUS_viewport_spring_constant_PLUS_)
  }, showoff.showoff.drag_force_generator.call(null, ld23.core._PLUS_viewport_drag_coefficient_PLUS_), function(p) {
    var spd__1605340 = showoff.showoff.vec_mag.call(null, "\ufdd0'velocity".call(null, p));
    var drag_dir__1605341 = showoff.showoff.vec_negate.call(null, showoff.showoff.vec_unit.call(null, "\ufdd0'velocity".call(null, p)));
    return showoff.showoff.vec_scale.call(null, drag_dir__1605341, spd__1605340 * 0.3)
  }])})));
  showoff.showoff.set_display_and_viewport.call(null, ld23.core._STAR_canvas_STAR_, cljs.core.PersistentVector.fromArray([640, 480]), function() {
    return showoff.showoff.to_rect.call(null, ld23.core._STAR_viewport_STAR_)
  });
  ld23.core.add_collectable.call(null, "\ufdd0'jackhammer", cljs.core.PersistentVector.fromArray([9, 5]), 0.3);
  ld23.core.add_collectable.call(null, "\ufdd0'blowtorch", cljs.core.PersistentVector.fromArray([5, 22]), 0.3);
  ld23.core.add_keys.call(null, cljs.core.PersistentVector.fromArray([cljs.core.PersistentVector.fromArray([21, 24]), cljs.core.PersistentVector.fromArray([30, 22]), cljs.core.PersistentVector.fromArray([31, 22]), cljs.core.PersistentVector.fromArray([32, 22]), cljs.core.PersistentVector.fromArray([33, 22]), cljs.core.PersistentVector.fromArray([54, 16]), cljs.core.PersistentVector.fromArray([59, 39]), cljs.core.PersistentVector.fromArray([6, 49]), cljs.core.PersistentVector.fromArray([7, 49]), cljs.core.PersistentVector.fromArray([8, 
  49]), cljs.core.PersistentVector.fromArray([9, 49]), cljs.core.PersistentVector.fromArray([22, 29])]));
  showoff.showoff.add_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), ld23.core._STAR_viewport_STAR_);
  showoff.showoff.add_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), ld23.core._STAR_player_STAR_);
  showoff.showoff.add_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), new ld23.core.Bag(ld23.core._STAR_bag_STAR_));
  ld23.core._STAR_game_timer_STAR_ = new ld23.core.Timer(4 * 60, cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {})));
  showoff.showoff.add_entity.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_), ld23.core._STAR_game_timer_STAR_);
  showoff.showoff.reset_tick_clock.call(null);
  return callback.call(null)
};
ld23.core.prepare_sound = function prepare_sound() {
  var sounds__1605342 = cljs.core.ObjMap.fromObject(["\ufdd0'resources", "\ufdd0'autoplay", "\ufdd0'spritemap"], {"\ufdd0'resources":cljs.core.PersistentVector.fromArray(["sounds/music2.ogg", "sounds/music2.mp3"]), "\ufdd0'autoplay":"bg-music", "\ufdd0'spritemap":cljs.core.ObjMap.fromObject(["\ufdd0'bg-music", "\ufdd0'powerup"], {"\ufdd0'bg-music":cljs.core.ObjMap.fromObject(["\ufdd0'start", "\ufdd0'end", "\ufdd0'loop"], {"\ufdd0'start":0, "\ufdd0'end":135, "\ufdd0'loop":true}), "\ufdd0'powerup":cljs.core.ObjMap.fromObject(["\ufdd0'start", 
  "\ufdd0'end"], {"\ufdd0'start":136, "\ufdd0'end":137})})});
  var mgrconfig__1605343 = cljs.core.ObjMap.fromObject(["useGameLoop"], {"useGameLoop":true});
  jukebox.Manager = new jukebox.Manager(showoff.core.clj__GT_js.call(null, mgrconfig__1605343));
  return ld23.core._STAR_media_player_STAR_ = new jukebox.Player(showoff.core.clj__GT_js.call(null, sounds__1605342))
};
ld23.core.draw_world = function draw_world(ticks) {
  if(cljs.core.truth_(ticks > 0)) {
    showoff.showoff.clear.call(null);
    var ctx__1605345 = showoff.showoff.context.call(null);
    var vec__1605344__1605346 = showoff.showoff.viewport_rect.call(null);
    var vx__1605347 = cljs.core.nth.call(null, vec__1605344__1605346, 0, null);
    var vy__1605348 = cljs.core.nth.call(null, vec__1605344__1605346, 1, null);
    var ___1605349 = cljs.core.nth.call(null, vec__1605344__1605346, 2, null);
    var ___1605350 = cljs.core.nth.call(null, vec__1605344__1605346, 3, null);
    ctx__1605345.drawImage(ld23.core._STAR_backdrop_STAR_, 0 - 50 - 13 * vx__1605347, 0 - 10 - 13 * vy__1605348);
    showoff.showoff.draw_map.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_map_STAR_));
    showoff.showoff.draw_entities.call(null);
    ld23.core.draw_player_entity.call(null, ctx__1605345, ld23.core._STAR_player_STAR_);
    var vec__1605351__1605352 = showoff.showoff.img_dims.call(null, ld23.core._STAR_hud_STAR_);
    var w__1605353 = cljs.core.nth.call(null, vec__1605351__1605352, 0, null);
    var h__1605354 = cljs.core.nth.call(null, vec__1605351__1605352, 1, null);
    var key_img__1605355 = "\ufdd0'image".call(null, "\ufdd0'key".call(null, ld23.core._STAR_collectables_STAR_));
    ctx__1605345.drawImage(ld23.core._STAR_hud_STAR_, 0, 0, w__1605353, h__1605354, 0, 0, 640, 480);
    ctx__1605345.drawImage(key_img__1605355, 2 * 73, 2 * 218);
    showoff.showoff.draw_text.call(null, ctx__1605345, ld23.core._STAR_hud_font_STAR_, cljs.core.str.call(null, cljs.core.deref.call(null, ld23.core._STAR_keys_collected_STAR_)), cljs.core.PersistentVector.fromArray([180, 444]));
    ctx__1605345.drawImage(ld23.core._STAR_money_icon_STAR_, 2 * 114, 2 * 218);
    showoff.showoff.draw_text.call(null, ctx__1605345, ld23.core._STAR_hud_font_STAR_, cljs.core.str.call(null, "$", 1E3 * cljs.core.deref.call(null, ld23.core._STAR_bricks_destroyed_STAR_)), cljs.core.PersistentVector.fromArray([268, 444]));
    var item__1605356 = cljs.core.first.call(null, cljs.core.deref.call(null, ld23.core._STAR_bag_STAR_));
    ctx__1605345.drawImage(ld23.core.icon.call(null, item__1605356), 592, 436);
    ld23.core.draw_timer.call(null, ctx__1605345, ld23.core._STAR_game_timer_STAR_)
  }else {
  }
  if(cljs.core.truth_(cljs.core._EQ_.call(null, ld23.core.timer_time.call(null, ld23.core._STAR_game_timer_STAR_), 0))) {
    return"\ufdd0'show-score"
  }else {
    return"\ufdd0'game"
  }
};
ld23.core._STAR_base_dialog_STAR_ = null;
ld23.core._STAR_instructions_STAR_ = null;
ld23.core.with_dialog_assets = function with_dialog_assets(callback) {
  return showoff.showoff.with_img.call(null, "graphics/dialog.png", function(dialog) {
    ld23.core._STAR_base_dialog_STAR_ = showoff.showoff.resize_nearest_neighbor.call(null, showoff.showoff.get_pixel_data.call(null, dialog), cljs.core.PersistentVector.fromArray([640, 480]));
    return showoff.showoff.with_img.call(null, "graphics/instructions.png", function(instr) {
      ld23.core._STAR_instructions_STAR_ = showoff.showoff.resize_nearest_neighbor.call(null, showoff.showoff.get_pixel_data.call(null, instr), cljs.core.PersistentVector.fromArray([648, 480]));
      return callback.call(null)
    })
  })
};
ld23.core._STAR_instruction_time_STAR_ = cljs.core.atom.call(null, null);
ld23.core.once_only_setup = function once_only_setup(callback) {
  return ld23.core.with_prepared_assets.call(null, function() {
    return ld23.core.with_dialog_assets.call(null, function() {
      return callback.call(null)
    })
  })
};
ld23.core._PLUS_total_instruction_time_PLUS_ = 30;
ld23.core.prepare_instructions = function prepare_instructions(callback) {
  cljs.core.reset_BANG_.call(null, ld23.core._STAR_instruction_time_STAR_, ld23.core._PLUS_total_instruction_time_PLUS_);
  showoff.showoff.set_display_and_viewport.call(null, ld23.core._STAR_canvas_STAR_, cljs.core.PersistentVector.fromArray([640, 480]), function() {
    return cljs.core.vector.call(null, 0, 0, 20, 15)
  });
  showoff.showoff.reset_tick_clock.call(null);
  return callback.call(null)
};
ld23.core.any_keys_pressed_QMARK_ = function any_keys_pressed_QMARK_() {
  return cljs.core.not.call(null, cljs.core.empty_QMARK_.call(null, ld23.core.input_state.call(null)))
};
ld23.core.instructions_screen = function instructions_screen(ticks) {
  var ctx__1605357 = showoff.showoff.context.call(null);
  var factor__1605358 = cljs.core.deref.call(null, ld23.core._STAR_instruction_time_STAR_) / ld23.core._PLUS_total_instruction_time_PLUS_;
  var v__1605359 = 2 * Math.PI * 3 * factor__1605358;
  var xoff__1605360 = Math.sin.call(null, v__1605359);
  var hopv__1605361 = factor__1605358 % 0.03 / 0.03 - 0.5;
  var yoff__1605362 = -(hopv__1605361 * hopv__1605361 * 2);
  var dir__1605363 = cljs.core.truth_(Math.cos.call(null, v__1605359) < 0) ? "\ufdd0'right" : "\ufdd0'left";
  ctx__1605357.drawImage(ld23.core._STAR_backdrop_STAR_, -(factor__1605358 * 600), 0);
  ctx__1605357.drawImage(ld23.core._STAR_base_dialog_STAR_, 0, 0);
  ctx__1605357.drawImage(ld23.core._STAR_instructions_STAR_, 0, 0);
  ld23.core.draw_player.call(null, ctx__1605357, cljs.core.PersistentVector.fromArray([9 + xoff__1605360, 1.5]), dir__1605363);
  ld23.core.draw_player.call(null, ctx__1605357, cljs.core.PersistentVector.fromArray([15, 1.1 - yoff__1605362]), "\ufdd0'right");
  var item_number__1605364 = Math.floor.call(null, factor__1605358 % 0.1 / 0.1 * 3);
  var item_key__1605365 = cljs.core.PersistentVector.fromArray(["\ufdd0'jackhammer", "\ufdd0'blowtorch", "\ufdd0'rubble"]).call(null, item_number__1605364);
  var item_img__1605366 = "\ufdd0'image".call(null, ld23.core._STAR_collectables_STAR_.call(null, item_key__1605365));
  ctx__1605357.drawImage(item_img__1605366, 2 * 99, 2 * 79);
  ctx__1605357.drawImage(item_img__1605366, 2 * 238, 2 * 80);
  ld23.core.draw_player.call(null, ctx__1605357, cljs.core.PersistentVector.fromArray([16, 5]), "\ufdd0'left");
  cljs.core.reset_BANG_.call(null, ld23.core._STAR_instruction_time_STAR_, cljs.core.deref.call(null, ld23.core._STAR_instruction_time_STAR_) - ticks * showoff.showoff._PLUS_secs_per_tick_PLUS_);
  if(cljs.core.truth_(function() {
    var or__3548__auto____1605367 = cljs.core.deref.call(null, ld23.core._STAR_instruction_time_STAR_) <= 0;
    if(cljs.core.truth_(or__3548__auto____1605367)) {
      return or__3548__auto____1605367
    }else {
      return ld23.core.any_keys_pressed_QMARK_.call(null)
    }
  }())) {
    return"\ufdd0'setup-map"
  }else {
    return"\ufdd0'instructions"
  }
};
ld23.core._STAR_scorescreen_cooldown_STAR_ = cljs.core.atom.call(null, cljs.core.ObjMap.fromObject([], {}));
ld23.core.prepare_scorescreen = function prepare_scorescreen(callback) {
  ld23.core.cooldown_start.call(null, ld23.core._STAR_scorescreen_cooldown_STAR_, 1);
  return callback.call(null)
};
ld23.core.scorescreen = function scorescreen(ticks) {
  var ctx__1605368 = showoff.showoff.context.call(null);
  var key_img__1605369 = "\ufdd0'image".call(null, "\ufdd0'key".call(null, ld23.core._STAR_collectables_STAR_));
  ctx__1605368.drawImage(ld23.core._STAR_base_dialog_STAR_, 0, 0);
  showoff.showoff.draw_text_centered.call(null, ctx__1605368, ld23.core._STAR_hud_font_STAR_, "Time is Up!", cljs.core.PersistentVector.fromArray([320, 100]));
  ctx__1605368.drawImage(key_img__1605369, 216, 150);
  showoff.showoff.draw_text.call(null, ctx__1605368, ld23.core._STAR_hud_font_STAR_, showoff.showoff.format.call(null, "%d of %d", cljs.core.deref.call(null, ld23.core._STAR_keys_collected_STAR_), cljs.core.deref.call(null, ld23.core._STAR_total_keys_STAR_)), cljs.core.PersistentVector.fromArray([264, 158]));
  ctx__1605368.drawImage(ld23.core._STAR_money_icon_STAR_, 216, 182);
  showoff.showoff.draw_text.call(null, ctx__1605368, ld23.core._STAR_hud_font_STAR_, showoff.showoff.format.call(null, "$%d", 1E3 * cljs.core.deref.call(null, ld23.core._STAR_bricks_destroyed_STAR_)), cljs.core.PersistentVector.fromArray([264, 190]));
  showoff.showoff.draw_text.call(null, ctx__1605368, ld23.core._STAR_hud_font_STAR_, "of damage done", cljs.core.PersistentVector.fromArray([264, 222]));
  showoff.showoff.draw_text.call(null, ctx__1605368, ld23.core._STAR_hud_font_STAR_, "Press a Key", cljs.core.PersistentVector.fromArray([264, 286]));
  if(cljs.core.truth_(function() {
    var and__3546__auto____1605370 = ld23.core.is_cool_QMARK_.call(null, ld23.core._STAR_scorescreen_cooldown_STAR_);
    if(cljs.core.truth_(and__3546__auto____1605370)) {
      return ld23.core.any_keys_pressed_QMARK_.call(null)
    }else {
      return and__3546__auto____1605370
    }
  }())) {
    return"\ufdd0'setup-map"
  }else {
    return"\ufdd0'show-score"
  }
};
ld23.core._STAR_game_states_STAR_ = cljs.core.ObjMap.fromObject(["\ufdd0'start", "\ufdd0'instructions", "\ufdd0'setup-map", "\ufdd0'game", "\ufdd0'show-score"], {"\ufdd0'start":cljs.core.ObjMap.fromObject(["\ufdd0'setup", "\ufdd0'after-ticks"], {"\ufdd0'setup":ld23.core.once_only_setup, "\ufdd0'after-ticks":function _STAR_game_states_STAR_() {
  return"\ufdd0'instructions"
}}), "\ufdd0'instructions":cljs.core.ObjMap.fromObject(["\ufdd0'setup", "\ufdd0'after-ticks"], {"\ufdd0'setup":ld23.core.prepare_instructions, "\ufdd0'after-ticks":ld23.core.instructions_screen}), "\ufdd0'setup-map":cljs.core.ObjMap.fromObject(["\ufdd0'setup", "\ufdd0'after-ticks"], {"\ufdd0'setup":ld23.core.with_loaded_map, "\ufdd0'after-ticks":function _STAR_game_states_STAR_() {
  return"\ufdd0'game"
}}), "\ufdd0'game":cljs.core.ObjMap.fromObject(["\ufdd0'setup", "\ufdd0'after-ticks"], {"\ufdd0'setup":ld23.core.setup_world, "\ufdd0'after-ticks":ld23.core.draw_world}), "\ufdd0'show-score":cljs.core.ObjMap.fromObject(["\ufdd0'setup", "\ufdd0'after-ticks"], {"\ufdd0'setup":ld23.core.prepare_scorescreen, "\ufdd0'after-ticks":ld23.core.scorescreen})});
ld23.core._STAR_current_game_state_STAR_ = cljs.core.atom.call(null, null);
ld23.core.perform_after_ticks = function perform_after_ticks(ticks) {
  var after_ticks__1605371 = "\ufdd0'after-ticks".call(null, cljs.core.deref.call(null, ld23.core._STAR_current_game_state_STAR_).call(null, ld23.core._STAR_game_states_STAR_));
  return after_ticks__1605371.call(null, ticks)
};
ld23.core.with_changed_game_state = function with_changed_game_state(new_state, callback) {
  var change_complete__1605372 = function() {
    cljs.core.reset_BANG_.call(null, ld23.core._STAR_current_game_state_STAR_, new_state);
    return callback.call(null)
  };
  if(cljs.core.truth_(cljs.core.not.call(null, cljs.core._EQ_.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_game_state_STAR_), new_state)))) {
    var temp__3695__auto____1605373 = "\ufdd0'setup".call(null, new_state.call(null, ld23.core._STAR_game_states_STAR_));
    if(cljs.core.truth_(temp__3695__auto____1605373)) {
      var setup__1605374 = temp__3695__auto____1605373;
      return setup__1605374.call(null, change_complete__1605372)
    }else {
      return change_complete__1605372.call(null)
    }
  }else {
    return change_complete__1605372.call(null)
  }
};
ld23.core.game_loop = function game_loop() {
  jukebox.Manager.loop();
  if(cljs.core.truth_(cljs.core._EQ_.call(null, cljs.core.deref.call(null, ld23.core._STAR_current_game_state_STAR_), null))) {
    return ld23.core.with_changed_game_state.call(null, "\ufdd0'start", function() {
      ld23.core.perform_after_ticks.call(null, 0);
      return showoff.core.request_animation.call(null, game_loop, showoff.showoff.display.call(null))
    })
  }else {
    var next_state__1605375 = showoff.showoff.cycle_once.call(null, ld23.core.perform_after_ticks);
    return ld23.core.with_changed_game_state.call(null, next_state__1605375, function() {
      return showoff.core.request_animation.call(null, game_loop, showoff.showoff.display.call(null))
    })
  }
};
ld23.core.game = function game() {
  var screen_size__1605376 = cljs.core.PersistentVector.fromArray([640, 480]);
  var canvas__1605377 = showoff.showoff.make_canvas.call(null, screen_size__1605376);
  goog.dom.appendChild.call(null, showoff.core.content.call(null), canvas__1605377);
  ld23.core._STAR_canvas_STAR_ = canvas__1605377;
  showoff.showoff.set_display_and_viewport.call(null, ld23.core._STAR_canvas_STAR_, cljs.core.PersistentVector.fromArray([640, 480]), function() {
    return cljs.core.vector.call(null, 0, 0, 20, 15)
  });
  showoff.core.prepare_input.call(null);
  ld23.core.prepare_sound.call(null);
  return ld23.core.game_loop.call(null)
};
goog.exportSymbol("ld23.core.game", ld23.core.game);
ld23.core.map_viewer = function map_viewer() {
  goog.dom.setTextContent.call(null, showoff.core.content.call(null), "");
  var screen_size__1605378 = cljs.core.PersistentVector.fromArray([640, 480]);
  var canvas__1605379 = showoff.showoff.make_canvas.call(null, screen_size__1605378);
  var viewport_speed__1605380 = 30 * showoff.showoff._PLUS_secs_per_tick_PLUS_;
  var viewport__1605381 = new showoff.core.Viewport(cljs.core.PersistentVector.fromArray([16, 10]), cljs.core.atom.call(null, cljs.core.ObjMap.fromObject(["\ufdd0'mass", "\ufdd0'position", "\ufdd0'velocity", "\ufdd0'offset-generators"], {"\ufdd0'mass":1, "\ufdd0'position":cljs.core.PersistentVector.fromArray([0, 0]), "\ufdd0'velocity":cljs.core.PersistentVector.fromArray([0, 0]), "\ufdd0'offset-generators":cljs.core.PersistentVector.fromArray([showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.LEFT, 
  cljs.core.PersistentVector.fromArray([-viewport_speed__1605380, 0])), showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.RIGHT, cljs.core.PersistentVector.fromArray([viewport_speed__1605380, 0])), showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.UP, cljs.core.PersistentVector.fromArray([0, -viewport_speed__1605380])), showoff.core.keyboard_velocity_generator.call(null, goog.events.KeyCodes.DOWN, cljs.core.PersistentVector.fromArray([0, viewport_speed__1605380]))])})));
  goog.dom.appendChild.call(null, showoff.core.content.call(null), canvas__1605379);
  showoff.showoff.set_display_and_viewport.call(null, canvas__1605379, screen_size__1605378, function() {
    return showoff.showoff.to_rect.call(null, viewport__1605381)
  });
  showoff.core.prepare_input.call(null);
  showoff.showoff.add_entity.call(null, cljs.core.ObjMap.fromObject([], {}), viewport__1605381);
  return ld23.core.with_prepared_assets.call(null, function() {
    ld23.core.setup_world.call(null);
    return showoff.core.until_false.call(null, ld23.core.game_loop)
  })
};
goog.exportSymbol("ld23.core.map_viewer", ld23.core.map_viewer);
